diff -pruN 4.3.2-2/acinclude.m4 4.3.3-1/acinclude.m4
--- 4.3.2-2/acinclude.m4	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/acinclude.m4	2020-09-07 10:12:14.000000000 +0000
@@ -691,7 +691,7 @@ int main (int, char **)
             return t;
         }
         ])],
-        [AC_MSG_RESULT(yes) ; libzmq_cv_has_atomic_instrisics="yes" ; $1],
+        [AC_MSG_RESULT(yes) ; libzmq_cv_has_atomic_instrisics="yes" PKGCFG_LIBS_PRIVATE="$PKGCFG_LIBS_PRIVATE -latomic" ; $1],
         [AC_MSG_RESULT(no) ; libzmq_cv_has_atomic_instrisics="no" LIBS=$save_LIBS ; $2])
     fi
 }])
diff -pruN 4.3.2-2/appveyor.yml 4.3.3-1/appveyor.yml
--- 4.3.2-2/appveyor.yml	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/appveyor.yml	2020-09-07 10:12:14.000000000 +0000
@@ -10,6 +10,15 @@ environment:
   MSVCYEAR: "vs2013"
   ENABLE_DRAFTS: ON
   matrix:
+    - platform: x64
+      configuration: Release
+      WITH_LIBSODIUM: ON
+      ENABLE_CURVE: ON
+      APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2019
+      CMAKE_GENERATOR: "Visual Studio 16 2019"
+      MSVCVERSION: "v142"
+      MSVCYEAR: "vs2019"
+      ARTIFACT_NAME: v142-x64
     - platform: Win32
       configuration: Release
       WITH_LIBSODIUM: OFF # unavailable build files for VS2008
@@ -110,6 +119,30 @@ environment:
       ENABLE_CURVE: ON
       CMAKE_GENERATOR: "MSYS Makefiles"
       ARTIFACT_NAME: mingw64
+    - platform: Win32-uwp
+      configuration: Debug
+      WITH_LIBSODIUM: OFF
+      ENABLE_CURVE: OFF
+      APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2017
+      CMAKE_GENERATOR: "Visual Studio 15 2017"
+      MSVCVERSION: "v141"
+      MSVCYEAR: "vs2017"
+      ARTIFACT_NAME: v141-gd-uwp
+      CMAKE_SYSTEM_NAME: WindowsStore
+      CMAKE_SYSTEM_VERSION: 10.0.18362
+      EXTRA_FLAGS: -DCMAKE_SYSTEM_NAME=%CMAKE_SYSTEM_NAME% -DCMAKE_SYSTEM_VERSION=%CMAKE_SYSTEM_VERSION% -DBUILD_TESTS=OFF
+    - platform: Win32-uwp
+      configuration: Release
+      WITH_LIBSODIUM: OFF
+      ENABLE_CURVE: OFF
+      APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2017
+      CMAKE_GENERATOR: "Visual Studio 15 2017"
+      MSVCVERSION: "v141"
+      MSVCYEAR: "vs2017"
+      ARTIFACT_NAME: v141-uwp
+      CMAKE_SYSTEM_NAME: WindowsStore
+      CMAKE_SYSTEM_VERSION: 10.0.18362
+      EXTRA_FLAGS: -DCMAKE_SYSTEM_NAME=%CMAKE_SYSTEM_NAME% -DCMAKE_SYSTEM_VERSION=%CMAKE_SYSTEM_VERSION% -DBUILD_TESTS=OFF
 
 matrix:
   fast_finish: false
@@ -138,7 +171,7 @@ install:
   - cmd: if "%Platform%"=="cygwin64" set PATH=C:\cygwin64\bin;%PATH%
   - cmd: if "%Platform%"=="mingw64" C:\msys64\usr\bin\bash -lc "pacman -Qg"
   - cmd: if "%Platform%"=="mingw64" set PATH=C:\msys64\usr\bin;%PATH%
-  - cmd: if "%Platform%"=="x64" set "CMAKE_GENERATOR=%CMAKE_GENERATOR% Win64"
+  - cmd: if "%Platform%"=="x64" (if not "%MSVCVERSION%"=="v142" set "CMAKE_GENERATOR=%CMAKE_GENERATOR% Win64")
   - cmd: echo "Generator='%CMAKE_GENERATOR%'"
   - cmd: echo "Platform='%Platform%'"
   - cmd: if "%WITH_LIBSODIUM%"=="ON" set LIBSODIUMDIR=C:\projects\libsodium
@@ -180,7 +213,7 @@ build_script:
   - cmd: if "%MSVCYEAR%"=="vs2008" set verbosity=Normal
   - cmd: if "%MSVCYEAR%"=="vs2008" set path=C:\Windows\Microsoft.NET\Framework\v3.5;%path% 
   - cmd: cd "%LIBZMQ_BUILDDIR%"
-  - cmd: if "%PLATFORM%" == "Win32" (
+  - cmd: if "%PLATFORM:~0,5%" == "Win32" (
             if "%MSVCYEAR%"=="vs2008" (
                 cmake --build %LIBZMQ_BUILDDIR% --config %configuration% --target install
             ) else (
@@ -216,10 +249,12 @@ after_build:
             # -Dsonar.cxx.compiler.reportPath=build.log 
             # -Dsonar.cxx.compiler.charset=UTF-8 
             # -Dsonar.cxx.compiler.regex=^(?<filename>.*)\\((?<line>[0-9]+)\\):\\x20warning\\x20(?<id>C\\d\\d\\d\\d):(?<message>.*)$
+# TODO this should be done differently, using the INSTALL cmake target, the current handling depends on the details of the CMakeLists.txt
   - cmd: cd %LIBZMQ_BUILDDIR%\bin\%Configuration%"
   - cmd: if "%WITH_LIBSODIUM%"=="ON" copy "%SODIUM_LIBRARY_DIR%\libsodium.dll" .
   - cmd: copy "%LIBZMQ_SRCDIR%\include\zmq.h" .
-  - cmd: 7z a -y -bd -mx=9 libzmq.zip *.exe *.dll *.pdb *.h
+  - cmd: copy ..\..\lib\%Configuration%\libzmq*.lib . & exit 0
+  - cmd: 7z a -y -bd -mx=9 libzmq.zip *.exe *.dll *.pdb *.h *.lib
   - ps: Push-AppveyorArtifact "libzmq.zip" -Filename "libzmq-${env:ARTIFACT_NAME}-${env:ZMQ_VERSION_MAJOR}_${env:ZMQ_VERSION_MINOR}_${env:ZMQ_VERSION_PATCH}.zip"
 
 test_script:
@@ -240,7 +275,7 @@ deploy:
   - provider: BinTray
     username: somdoron
     api_key:
-      secure: GTpnqv6RB1urgspx4kTsUDksN2Vaow/x4kFJKmUX4zFjMDUlBsRUCrpFBiedYb33
+      secure: B4TC4GvUMbwX13Skh2Kvyc6SnqLkjNS9W0gtN2yxUC2Y4oQSCK2F4eRgtpMpCasg
     subject: zeromq
     repo: generic
     package: libzmq
diff -pruN 4.3.2-2/builds/abi-compliance-checker/ci_build.sh 4.3.3-1/builds/abi-compliance-checker/ci_build.sh
--- 4.3.2-2/builds/abi-compliance-checker/ci_build.sh	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/abi-compliance-checker/ci_build.sh	2020-09-07 10:12:14.000000000 +0000
@@ -1,6 +1,7 @@
 #!/usr/bin/env bash
 
 set -x
+set -e
 
 cd ../../
 
@@ -24,14 +25,17 @@ function print_abi_api_breakages() {
    exit 1
 }
 
+git fetch --unshallow
+git fetch --all --tags
+LATEST_VERSION=$(git describe --abbrev=0 --tags)
+
 ./autogen.sh
 ./configure "${CONFIG_OPTS[@]}"
 make VERBOSE=1 -j5
 abi-dumper src/.libs/libzmq.so -o ${BUILD_PREFIX}/libzmq.head.dump -lver HEAD
 
-git clone --depth 1 -b latest_release https://github.com/zeromq/libzmq.git latest_release
+git clone --depth 1 -b ${LATEST_VERSION} https://github.com/zeromq/libzmq.git latest_release
 cd latest_release
-LATEST_VERSION=$(git describe --abbrev=0 --tags)
 ./autogen.sh
 ./configure "${CONFIG_OPTS[@]}"
 make VERBOSe=1 -j5
diff -pruN 4.3.2-2/builds/android/android_build_helper.sh 4.3.3-1/builds/android/android_build_helper.sh
--- 4.3.2-2/builds/android/android_build_helper.sh	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/android/android_build_helper.sh	2020-09-07 10:12:14.000000000 +0000
@@ -2,21 +2,21 @@
 #
 # Copyright (c) 2014, Joe Eli McIlvain
 # All rights reserved.
-# 
+#
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
-# 
+#
 # 1. Redistributions of source code must retain the above copyright notice,
 #    this list of conditions and the following disclaimer.
-# 
+#
 # 2. Redistributions in binary form must reproduce the above copyright notice,
 #    this list of conditions and the following disclaimer in the documentation
 #    and/or other materials provided with the distribution.
-# 
+#
 # 3. Neither the name of the copyright holder nor the names of its
 #    contributors may be used to endorse or promote products derived from
 #    this software without specific prior written permission.
-# 
+#
 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 # AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
@@ -60,7 +60,7 @@ ANDROID_BUILD_FAIL=()
 
 function android_build_check_fail {
     if [ ! ${#ANDROID_BUILD_FAIL[@]} -eq 0 ]; then
-        echo "Android build failed for the following reasons:"
+        echo "Android (${TOOLCHAIN_ARCH}) build failed for the following reasons:"
         for reason in "${ANDROID_BUILD_FAIL[@]}"; do
             local formatted_reason="  ${reason}"
             echo "${formatted_reason}"
@@ -69,205 +69,186 @@ function android_build_check_fail {
     fi
 }
 
+function android_build_set_env {
+    BUILD_ARCH=$1
+
+    export TOOLCHAIN_PATH="${ANDROID_NDK_ROOT}/toolchains/llvm/prebuilt/${HOST_PLATFORM}/bin"
+
+    # Set variables for each architecture
+    if [ $BUILD_ARCH == "arm" ]; then
+        export TOOLCHAIN_HOST="arm-linux-androideabi"
+        export TOOLCHAIN_COMP="armv7a-linux-androideabi${MIN_SDK_VERSION}"
+        export TOOLCHAIN_ABI="armeabi-v7a"
+        export TOOLCHAIN_ARCH="arm"
+    elif [ $BUILD_ARCH == "x86" ]; then
+        export TOOLCHAIN_HOST="i686-linux-android"
+        export TOOLCHAIN_COMP="i686-linux-android${MIN_SDK_VERSION}"
+        export TOOLCHAIN_ABI="x86"
+        export TOOLCHAIN_ARCH="x86"
+    elif [ $BUILD_ARCH == "arm64" ]; then
+        export TOOLCHAIN_HOST="aarch64-linux-android"
+        export TOOLCHAIN_COMP="aarch64-linux-android${MIN_SDK_VERSION}"
+        export TOOLCHAIN_ABI="arm64-v8a"
+        export TOOLCHAIN_ARCH="arm64"
+    elif [ $BUILD_ARCH == "x86_64" ]; then
+        export TOOLCHAIN_HOST="x86_64-linux-android"
+        export TOOLCHAIN_COMP="x86_64-linux-android${MIN_SDK_VERSION}"
+        export TOOLCHAIN_ABI="x86_64"
+        export TOOLCHAIN_ARCH="x86_64"
+    fi
+
+    export ANDROID_BUILD_SYSROOT="${ANDROID_NDK_ROOT}/platforms/android-${MIN_SDK_VERSION}/arch-${TOOLCHAIN_ARCH}"
+    export ANDROID_BUILD_PREFIX="${ANDROID_BUILD_DIR}/prefix/${TOOLCHAIN_ARCH}"
+}
+
 function android_build_env {
     ##
     # Check that necessary environment variables are set
-    
+
     if [ -z "$ANDROID_NDK_ROOT" ]; then
         ANDROID_BUILD_FAIL+=("Please set the ANDROID_NDK_ROOT environment variable")
-        ANDROID_BUILD_FAIL+=("  (eg. \"/home/user/android/android-ndk-r11c\")")
+        ANDROID_BUILD_FAIL+=("  (eg. \"/home/user/android/android-ndk-r20\")")
     fi
-    
+
     if [ -z "$TOOLCHAIN_PATH" ]; then
         ANDROID_BUILD_FAIL+=("Please set the TOOLCHAIN_PATH environment variable")
-        ANDROID_BUILD_FAIL+=("  (eg. \"/home/user/android/android-ndk-r11c/toolchains/arm-linux-androideabi-4.9/prebuilt/linux-x86_64/bin\")")
-    fi
-    
-    if [ -z "$TOOLCHAIN_NAME" ]; then
-        ANDROID_BUILD_FAIL+=("Please set the TOOLCHAIN_NAME environment variable")
-        ANDROID_BUILD_FAIL+=("  (eg. \"arm-linux-androideabi-4.9\")")
+        ANDROID_BUILD_FAIL+=("  (eg. \"/home/user/android/android-ndk-r20/toolchains/arm-linux-androideabi-4.9/prebuilt/linux-x86_64/bin\")")
     fi
-    
+
     if [ -z "$TOOLCHAIN_HOST" ]; then
         ANDROID_BUILD_FAIL+=("Please set the TOOLCHAIN_HOST environment variable")
         ANDROID_BUILD_FAIL+=("  (eg. \"arm-linux-androideabi\")")
     fi
-    
+
+    if [ -z "$TOOLCHAIN_COMP" ]; then
+        ANDROID_BUILD_FAIL+=("Please set the TOOLCHAIN_COMP environment variable")
+        ANDROID_BUILD_FAIL+=("  (eg. \"armv7a-linux-androideabi\")")
+    fi
+
+    if [ -z "$TOOLCHAIN_ABI" ]; then
+        ANDROID_BUILD_FAIL+=("Please set the TOOLCHAIN_ABI environment variable")
+        ANDROID_BUILD_FAIL+=("  (eg. \"armeabi-v7a\")")
+    fi
+
     if [ -z "$TOOLCHAIN_ARCH" ]; then
         ANDROID_BUILD_FAIL+=("Please set the TOOLCHAIN_ARCH environment variable")
         ANDROID_BUILD_FAIL+=("  (eg. \"arm\")")
     fi
-    
+
     android_build_check_fail
-    
+
     ##
     # Check that directories given by environment variables exist
-    
+
     if [ ! -d "$ANDROID_NDK_ROOT" ]; then
         ANDROID_BUILD_FAIL+=("The ANDROID_NDK_ROOT directory does not exist")
         ANDROID_BUILD_FAIL+=("  ${ANDROID_NDK_ROOT}")
     fi
-    
+
     if [ ! -d "$TOOLCHAIN_PATH" ]; then
         ANDROID_BUILD_FAIL+=("The TOOLCHAIN_PATH directory does not exist")
         ANDROID_BUILD_FAIL+=("  ${TOOLCHAIN_PATH}")
     fi
-    
+
     ##
     # Set up some local variables and check them
-    
-    ANDROID_BUILD_SYSROOT="${ANDROID_NDK_ROOT}/platforms/android-14/arch-${TOOLCHAIN_ARCH}"
-    
+
     if [ ! -d "$ANDROID_BUILD_SYSROOT" ]; then
         ANDROID_BUILD_FAIL+=("The ANDROID_BUILD_SYSROOT directory does not exist")
         ANDROID_BUILD_FAIL+=("  ${ANDROID_BUILD_SYSROOT}")
     fi
-    
-    ANDROID_BUILD_PREFIX="${ANDROID_BUILD_DIR}/prefix/${TOOLCHAIN_NAME}"
-    
+
     mkdir -p "$ANDROID_BUILD_PREFIX" || {
         ANDROID_BUILD_FAIL+=("Failed to make ANDROID_BUILD_PREFIX directory")
         ANDROID_BUILD_FAIL+=("  ${ANDROID_BUILD_PREFIX}")
     }
-    
+
     android_build_check_fail
 }
 
 function _android_build_opts_process_binaries {
-    local CPP="${TOOLCHAIN_PATH}/${TOOLCHAIN_HOST}-cpp"
-    local CC="${TOOLCHAIN_PATH}/${TOOLCHAIN_HOST}-gcc"
-    local CXX="${TOOLCHAIN_PATH}/${TOOLCHAIN_HOST}-g++"
+    local TOOLCHAIN="${ANDROID_NDK_ROOT}/toolchains/llvm/prebuilt/${HOST_PLATFORM}"
+    local CC="${TOOLCHAIN_PATH}/${TOOLCHAIN_COMP}-clang"
+    local CXX="${TOOLCHAIN_PATH}/${TOOLCHAIN_COMP}-clang++"
     local LD="${TOOLCHAIN_PATH}/${TOOLCHAIN_HOST}-ld"
     local AS="${TOOLCHAIN_PATH}/${TOOLCHAIN_HOST}-as"
     local AR="${TOOLCHAIN_PATH}/${TOOLCHAIN_HOST}-ar"
     local RANLIB="${TOOLCHAIN_PATH}/${TOOLCHAIN_HOST}-ranlib"
-    
-    if [ ! -x "${CPP}" ]; then
-        ANDROID_BUILD_FAIL+=("The CPP binary does not exist or is not executable")
-        ANDROID_BUILD_FAIL+=("  ${CPP}")
-    fi
-    
+    local STRIP="${TOOLCHAIN_PATH}/${TOOLCHAIN_HOST}-strip"
+
     if [ ! -x "${CC}" ]; then
         ANDROID_BUILD_FAIL+=("The CC binary does not exist or is not executable")
         ANDROID_BUILD_FAIL+=("  ${CC}")
     fi
-    
+
     if [ ! -x "${CXX}" ]; then
         ANDROID_BUILD_FAIL+=("The CXX binary does not exist or is not executable")
         ANDROID_BUILD_FAIL+=("  ${CXX}")
     fi
-    
+
     if [ ! -x "${LD}" ]; then
         ANDROID_BUILD_FAIL+=("The LD binary does not exist or is not executable")
         ANDROID_BUILD_FAIL+=("  ${LD}")
     fi
-    
+
     if [ ! -x "${AS}" ]; then
         ANDROID_BUILD_FAIL+=("The AS binary does not exist or is not executable")
         ANDROID_BUILD_FAIL+=("  ${AS}")
     fi
-    
+
     if [ ! -x "${AR}" ]; then
         ANDROID_BUILD_FAIL+=("The AR binary does not exist or is not executable")
         ANDROID_BUILD_FAIL+=("  ${AR}")
     fi
-    
+
     if [ ! -x "${RANLIB}" ]; then
         ANDROID_BUILD_FAIL+=("The RANLIB binary does not exist or is not executable")
         ANDROID_BUILD_FAIL+=("  ${RANLIB}")
     fi
-    
-    ANDROID_BUILD_OPTS+=("CPP=${CPP}")
+
+    if [ ! -x "${STRIP}" ]; then
+        ANDROID_BUILD_FAIL+=("The STRIP binary does not exist or is not executable")
+        ANDROID_BUILD_FAIL+=("  ${STRIP}")
+    fi
+
+    ANDROID_BUILD_OPTS+=("TOOLCHAIN=${TOOLCHAIN}")
     ANDROID_BUILD_OPTS+=("CC=${CC}")
     ANDROID_BUILD_OPTS+=("CXX=${CXX}")
     ANDROID_BUILD_OPTS+=("LD=${LD}")
     ANDROID_BUILD_OPTS+=("AS=${AS}")
     ANDROID_BUILD_OPTS+=("AR=${AR}")
     ANDROID_BUILD_OPTS+=("RANLIB=${RANLIB}")
-    
-    android_build_check_fail
-}
+    ANDROID_BUILD_OPTS+=("STRIP=${STRIP}")
 
-function _android_build_opts_process_cxx_stl {
-    case "${ANDROID_BUILD_CXXSTL}" in
-    stlport_static)
-        LIBS+=" -lstlport_static"
-        CPPFLAGS+=" -I${ANDROID_NDK_ROOT}/sources/cxx-stl/stlport/stlport"
-        case "${TOOLCHAIN_ARCH}" in
-        arm)
-            LDFLAGS+=" -L${ANDROID_NDK_ROOT}/sources/cxx-stl/stlport/libs/armeabi"
-        ;;
-        x86)
-            LDFLAGS+=" -L${ANDROID_NDK_ROOT}/sources/cxx-stl/stlport/libs/x86"
-        ;;
-        mips)
-            LDFLAGS+=" -L${ANDROID_NDK_ROOT}/sources/cxx-stl/stlport/libs/mips"
-        ;;
-        *)
-            ANDROID_BUILD_FAIL+=("Unknown combination for ANDROID_BUILD_CXXSTL and TOOLCHAIN_ARCH")
-            ANDROID_BUILD_FAIL+=("  ${ANDROID_BUILD_CXXSTL}")
-            ANDROID_BUILD_FAIL+=("  ${TOOLCHAIN_ARCH}")
-        ;;
-        esac
-    ;;
-    gnustl_shared_49)
-        LIBS+=" -lgnustl_shared"
-        CPPFLAGS+=" -I${ANDROID_NDK_ROOT}/sources/cxx-stl/gnu-libstdc++/4.9/include"
-        case "${TOOLCHAIN_ARCH}" in
-        arm)
-            LDFLAGS+=" -L${ANDROID_NDK_ROOT}/sources/cxx-stl/gnu-libstdc++/4.9/libs/armeabi"
-            CPPFLAGS+=" -I${ANDROID_NDK_ROOT}/sources/cxx-stl/gnu-libstdc++/4.9/libs/armeabi/include"
-        ;;
-        x86)
-            LDFLAGS+=" -L${ANDROID_NDK_ROOT}/sources/cxx-stl/gnu-libstdc++/4.9/libs/x86"
-            CPPFLAGS+=" -I${ANDROID_NDK_ROOT}/sources/cxx-stl/gnu-libstdc++/4.9/libs/x86/include"
-        ;;
-        mips)
-            LDFLAGS+=" -L${ANDROID_NDK_ROOT}/sources/cxx-stl/gnu-libstdc++/4.9/libs/mips"
-            CPPFLAGS+=" -I${ANDROID_NDK_ROOT}/sources/cxx-stl/gnu-libstdc++/4.9/libs/mips/include"
-        ;;
-        *)
-            ANDROID_BUILD_FAIL+=("Unknown combination for ANDROID_BUILD_CXXSTL and TOOLCHAIN_ARCH")
-            ANDROID_BUILD_FAIL+=("  ${ANDROID_BUILD_CXXSTL}")
-            ANDROID_BUILD_FAIL+=("  ${TOOLCHAIN_ARCH}")
-        ;;
-        esac
-    ;;
-    '');;
-    *)
-        ANDROID_BUILD_FAIL+=("Unknown value for ANDROID_BUILD_CXXSTL")
-        ANDROID_BUILD_FAIL+=("  ${ANDROID_BUILD_CXXSTL}")
-    ;;
-    esac
+    android_build_check_fail
 }
 
 # Set the ANDROID_BUILD_OPTS variable to a bash array of configure options
 function android_build_opts {
     ANDROID_BUILD_OPTS=()
-    
-    local CFLAGS="--sysroot=${ANDROID_BUILD_SYSROOT} -I${ANDROID_BUILD_PREFIX}/include"
-    local CPPFLAGS="--sysroot=${ANDROID_BUILD_SYSROOT} -I${ANDROID_BUILD_PREFIX}/include"
-    local CXXFLAGS="--sysroot=${ANDROID_BUILD_SYSROOT} -I${ANDROID_BUILD_PREFIX}/include"
-    local LDFLAGS="-L${ANDROID_BUILD_PREFIX}/lib"
-    local LIBS="-lc -lgcc -ldl"
-    
+
     _android_build_opts_process_binaries
-    _android_build_opts_process_cxx_stl
-    
+
+    local LIBS="-lc -lgcc -ldl -lm -llog -lc++_shared"
+    local LDFLAGS="-L${ANDROID_BUILD_PREFIX}/lib"
+    LDFLAGS+=" -L${ANDROID_NDK_ROOT}/sources/cxx-stl/llvm-libc++/libs/${TOOLCHAIN_ABI}"
+    CFLAGS+=" -D_GNU_SOURCE -D_REENTRANT -D_THREAD_SAFE"
+    CPPFLAGS+=" -I${ANDROID_BUILD_PREFIX}/include"
+
     ANDROID_BUILD_OPTS+=("CFLAGS=${CFLAGS} ${ANDROID_BUILD_EXTRA_CFLAGS}")
     ANDROID_BUILD_OPTS+=("CPPFLAGS=${CPPFLAGS} ${ANDROID_BUILD_EXTRA_CPPFLAGS}")
     ANDROID_BUILD_OPTS+=("CXXFLAGS=${CXXFLAGS} ${ANDROID_BUILD_EXTRA_CXXFLAGS}")
     ANDROID_BUILD_OPTS+=("LDFLAGS=${LDFLAGS} ${ANDROID_BUILD_EXTRA_LDFLAGS}")
     ANDROID_BUILD_OPTS+=("LIBS=${LIBS} ${ANDROID_BUILD_EXTRA_LIBS}")
-    
-    ANDROID_BUILD_OPTS+=("PKG_CONFIG_LIBDIR=${ANDROID_NDK_ROOT}/prebuilt/linux-x86_64/lib/pkgconfig")
+
+    ANDROID_BUILD_OPTS+=("PKG_CONFIG_LIBDIR=${ANDROID_NDK_ROOT}/prebuilt/${HOST_PLATFORM}/lib/pkgconfig")
     ANDROID_BUILD_OPTS+=("PKG_CONFIG_PATH=${ANDROID_BUILD_PREFIX}/lib/pkgconfig")
     ANDROID_BUILD_OPTS+=("PKG_CONFIG_SYSROOT_DIR=${ANDROID_BUILD_SYSROOT}")
     ANDROID_BUILD_OPTS+=("PKG_CONFIG_DIR=")
     ANDROID_BUILD_OPTS+=("--with-sysroot=${ANDROID_BUILD_SYSROOT}")
     ANDROID_BUILD_OPTS+=("--host=${TOOLCHAIN_HOST}")
     ANDROID_BUILD_OPTS+=("--prefix=${ANDROID_BUILD_PREFIX}")
-    
+
     android_build_check_fail
 }
 
@@ -278,14 +259,14 @@ function android_build_opts {
 function android_build_verify_so {
     local soname="$1"
     shift # Get rid of first argument - the rest represent dependencies
-    
+
     local sofile="${ANDROID_BUILD_PREFIX}/lib/${soname}"
     if [ ! -f "${sofile}" ]; then
         ANDROID_BUILD_FAIL+=("Found no library named ${soname}")
         ANDROID_BUILD_FAIL+=("  ${sofile}")
     fi
     android_build_check_fail
-    
+
     if command -v readelf >/dev/null 2>&1 ; then
         local readelf_bin="readelf"
     elif command -v greadelf >/dev/null 2>&1 ; then
@@ -295,8 +276,8 @@ function android_build_verify_so {
     fi
     android_build_check_fail
 
-    local elfoutput=$($readelf_bin -d ${sofile})
-    
+    local elfoutput=$(LC_ALL=C $readelf_bin -d ${sofile})
+
     local soname_regexp='soname: \[([[:alnum:]\.]+)\]'
     if [[ $elfoutput =~ $soname_regexp ]]; then
         local parsed_soname="${BASH_REMATCH[1]}"
@@ -308,13 +289,13 @@ function android_build_verify_so {
         ANDROID_BUILD_FAIL+=("Failed to meaningfully parse readelf output for library ${soname}:")
         ANDROID_BUILD_FAIL+=("  ${elfoutput}")
     fi
-    
+
     for dep_soname do
         if [[ $elfoutput != *"library: [${dep_soname}]"* ]]; then
             ANDROID_BUILD_FAIL+=("Library ${soname} was expected to be linked to library with soname:")
             ANDROID_BUILD_FAIL+=("  ${dep_soname}")
         fi
     done
-    
+
     android_build_check_fail
 }
diff -pruN 4.3.2-2/builds/android/build.sh 4.3.3-1/builds/android/build.sh
--- 4.3.2-2/builds/android/build.sh	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/android/build.sh	2020-09-07 10:12:14.000000000 +0000
@@ -1,21 +1,52 @@
 #!/usr/bin/env bash
 
+function usage {
+    echo "Usage ./build.sh [ arm | arm64 | x86 | x86_64 ]"
+}
+
 # Use directory of current script as the build directory and working directory
 cd "$( dirname "${BASH_SOURCE[0]}" )"
-ANDROID_BUILD_DIR="$(pwd)"
+ANDROID_BUILD_DIR="${ANDROID_BUILD_DIR:-`pwd`}"
 
 # Get access to android_build functions and variables
-source ${ANDROID_BUILD_DIR}/android_build_helper.sh
+source ./android_build_helper.sh
 
 # Choose a C++ standard library implementation from the ndk
 ANDROID_BUILD_CXXSTL="gnustl_shared_49"
 
+BUILD_ARCH=$1
+if [ -z $BUILD_ARCH ]; then
+    usage
+    exit 1
+fi
+
+case $(uname | tr '[:upper:]' '[:lower:]') in
+  linux*)
+    export HOST_PLATFORM=linux-x86_64
+    ;;
+  darwin*)
+    export HOST_PLATFORM=darwin-x86_64
+    ;;
+  *)
+    echo "Unsupported platform"
+    exit 1
+    ;;
+esac
+
+# Set default values used in ci builds
+
+export NDK_VERSION=${NDK_VERSION:-android-ndk-r21d}
+# With NDK r21d, the minimum SDK version range is [16, 29].
+# SDK version 21 is the minimum version for 64-bit builds.
+export MIN_SDK_VERSION=${MIN_SDK_VERSION:-21}
+
 # Set up android build environment and set ANDROID_BUILD_OPTS array
+android_build_set_env $BUILD_ARCH
 android_build_env
 android_build_opts
 
 # Use a temporary build directory
-cache="/tmp/android_build/${TOOLCHAIN_NAME}"
+cache="/tmp/android_build/${TOOLCHAIN_ARCH}"
 rm -rf "${cache}"
 mkdir -p "${cache}"
 
@@ -56,7 +87,7 @@ LIBTOOL_EXTRA_LDFLAGS='-avoid-version'
 (android_build_verify_so ${VERIFY} &> /dev/null) || {
     rm -rf "${cache}/libzmq"
     (cp -r ../.. "${cache}/libzmq" && cd "${cache}/libzmq" && make clean)
-    
+
     (cd "${cache}/libzmq" && ./autogen.sh \
         && ./configure --quiet "${ANDROID_BUILD_OPTS[@]}" ${CURVE} --without-docs \
         && make -j 4 \
diff -pruN 4.3.2-2/builds/android/ci_build.sh 4.3.3-1/builds/android/ci_build.sh
--- 4.3.2-2/builds/android/ci_build.sh	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/android/ci_build.sh	2020-09-07 10:12:14.000000000 +0000
@@ -1,30 +1,31 @@
 #!/usr/bin/env bash
 
-NDK_VER=android-ndk-r11c
-NDK_ABI_VER=4.9
+export NDK_VERSION=android-ndk-r21d
+export ANDROID_NDK_ROOT="/tmp/${NDK_VERSION}"
 
-if [ $TRAVIS_OS_NAME == "linux" ]
-then
-    NDK_PLATFORM=linux-x86_64
-elif [ $TRAVIS_OS_NAME == "osx" ]
-then
-    NDK_PLATFORM=darwin-x86_64
-else
-    echo "Unsupported platform $TRAVIS_OS_NAME"
+case $(uname | tr '[:upper:]' '[:lower:]') in
+  linux*)
+    HOST_PLATFORM=linux-x86_64
+    ;;
+  darwin*)
+    HOST_PLATFORM=darwin-x86_64
+    ;;
+  *)
+    echo "Unsupported platform"
     exit 1
-fi
-
-export FILENAME=$NDK_VER-$NDK_PLATFORM.zip
+    ;;
+esac
 
-(cd '/tmp' \
-    && wget http://dl.google.com/android/repository/$FILENAME \
-    && unzip $FILENAME &> /dev/null ) || exit 1
-unset FILENAME
+if [ ! -d "${ANDROID_NDK_ROOT}" ]; then
+    export FILENAME=$NDK_VERSION-$HOST_PLATFORM.zip
 
-export ANDROID_NDK_ROOT="/tmp/$NDK_VER"
-export TOOLCHAIN_PATH="$ANDROID_NDK_ROOT/toolchains/arm-linux-androideabi-$NDK_ABI_VER/prebuilt/$NDK_PLATFORM/bin"
-export TOOLCHAIN_NAME="arm-linux-androideabi-$NDK_ABI_VER"
-export TOOLCHAIN_HOST="arm-linux-androideabi"
-export TOOLCHAIN_ARCH="arm"
+    (cd '/tmp' \
+        && wget http://dl.google.com/android/repository/$FILENAME -O $FILENAME &> /dev/null \
+        && unzip -q $FILENAME) || exit 1
+    unset FILENAME
+fi
 
-source ./build.sh
+./build.sh "arm"
+./build.sh "arm64"
+./build.sh "x86"
+./build.sh "x86_64"
diff -pruN 4.3.2-2/builds/android/README.md 4.3.3-1/builds/android/README.md
--- 4.3.2-2/builds/android/README.md	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/android/README.md	2020-09-07 10:12:14.000000000 +0000
@@ -1,83 +1,33 @@
-LIBZMQ ANDROID COMPILATION STEPS
-================================
-To launch the docker build:
-
-    $ docker build .
-
-To launch the android build, you have to first install the android-ndk first in your HOME directory:
-
-    $ cd ~
-    $ export ANDROID_NDK_VERSION="r10e"
-    $ wget -q https://dl.google.com/android/ndk/android-ndk-${ANDROID_NDK_VERSION}-linux-x86_64.bin -O android-ndk-${ANDROID_NDK_VERSION}-linux-x86_64.bin
-    $ #check the hashes before executing this binary
-    $ md5sum android-ndk-r10e-linux-x86_64.bin
-    # 19af543b068bdb7f27787c2bc69aba7f  android-ndk-r10e-linux-x86_64.bin
-    $ sha256sum android-ndk-r10e-linux-x86_64.bin
-    # 102d6723f67ff1384330d12c45854315d6452d6510286f4e5891e00a5a8f1d5a  android-ndk-r10e-linux-x86_64.bin
-    $ chmod +x android-ndk-${ANDROID_NDK_VERSION}-linux-x86_64.bin
-    $ ./android-ndk-r10e-linux-x86_64.bin
-    $ export ANDROID_NDK_ROOT=${HOME}/android-ndk-r10e
-    $ export TOOLCHAIN_NAME=arm-linux-androideabi-4.9
-    $ export TOOLCHAIN_HOST=arm-linux-androideabi
-    $ export TOOLCHAIN_PATH=${ANDROID_NDK_ROOT}/toolchains/${TOOLCHAIN_NAME}/prebuilt/linux-x86_64/bin
-    $ export TOOLCHAIN_ARCH=arm
-
-Then you can launch the build:
-
-    $ cd ~/libzmq/builds/android
-    $ ./build.sh 
-    Cloning into 'libsodium'...
-    remote: Counting objects: 15246, done.
-    remote: Compressing objects: 100% (182/182), done.
-    Receiving objects:  16% (2440/15246)   
-    [...]
-
-A successful build should finish with the following message and give you back your shell prompt:
-
-    [...]
-    make[2]: Leaving directory '/tmp/android_build/arm-linux-androideabi-4.9/libzmq'
-    make[1]: Leaving directory '/tmp/android_build/arm-linux-androideabi-4.9/libzmq'
-    libzmq android build succeeded
-    $ 
-
-You will then be able to see libzmq.so compiled in the prefix/ directory:
-
-    $ cd ~/libzmq/builds/android/prefix/arm-linux-androideabi-4.9/lib
-    $ ls
-    libsodium.a  libsodium.la  libsodium.so  libzmq.a  libzmq.la  libzmq.so  pkgconfig
-
-You can then triple check that they are ARM libs:
-
-    $ cd ~/libzmq/builds/android/prefix/arm-linux-androideabi-4.9/lib
-    $ file libzmq.so
-    libzmq.so: ELF 32-bit LSB shared object, ARM, EABI5 version 1 (SYSV), dynamically linked, interpreter /system/bin/linker, not stripped
-
-
-COMPILE WITH DOCKERFILE
-=======================
-
-To launch the docker build with a tagged image as a result:
-
-    $ cd ~/libzmq/builds/android
-    $ docker build -t libzmq-android:`date +"%y%m%d-%H%M%S"` .
-    $ docker build -t libzmq-android:latest .
-
-If it is successful, it will end by "libzmq android build succeeded" followed by the ContainerID "e53db616aff4":
-
-    [...]
-    make[2]: Leaving directory `/tmp/android_build/arm-linux-androideabi-4.9/libzmq'
-    make[1]: Leaving directory `/tmp/android_build/arm-linux-androideabi-4.9/libzmq'
-    libzmq android build succeeded
-    ---> e53db616aff4
-    Removing intermediate container 8a5f3e34f3da
-    Successfully built e53db616aff4
-    $
-
-    $ docker images
-    REPOSITORY          TAG                 IMAGE ID            CREATED             VIRTUAL SIZE
-    libzmq-android      151218-101411       e53db616aff4        18 hours ago        5.495 GB
-
-If you want to collect the artifacts on the build, you can specify a directory in your HOME directory, such as "$HOME/libzmq-android-bins" for example:
-    
-    $ mkdir -pv $HOME/libzmq-android-bins
-    $ docker run -v $HOME/libzmq-android-bins:/data libzmq-android:latest "cp -v /home/zmq/libzmq/builds/android/prefix/arm-linux-androideabi-4.9/lib/* /data"
+# Android Build
+
+## Prerequisites
+
+You need the Android Native Development Kit (NDK) installed. See
+[here](https://developer.android.com/ndk) to download it.
+
+This project is tested against Android NDK version r21d.
+
+If you installed version r21d all you have to do is to expose the NDK root
+directory as environment variable, e.g:
+
+    export ANDROID_NDK_ROOT=$HOME/android-ndk-r21d
+
+If you installed another version you have to expose the NDK root directory as
+well as the NDK version, e.g:
+
+    export ANDROID_NDK_ROOT=$HOME/android-ndk-r17c
+    export NDK_VERSION=android-ndk-r17c
+
+To specify the minimum sdk version set the environment variable below:
+
+    export MIN_SDK_VERSION=21   # Default value if unset
+
+To specify the prefix directory set the environment variable below:
+
+    export ANDROID_BUILD_DIR=./builds/android/prefix/<android_arch> # Default value if unset
+
+## Build
+
+In the android directory, run:
+
+    ./build.sh [ arm | arm64 | x86 | x86_64 ]
diff -pruN 4.3.2-2/builds/cmake/ci_build.sh 4.3.3-1/builds/cmake/ci_build.sh
--- 4.3.2-2/builds/cmake/ci_build.sh	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/cmake/ci_build.sh	2020-09-07 10:12:14.000000000 +0000
@@ -30,6 +30,7 @@ CMAKE_OPTS+=("-DCMAKE_INSTALL_PREFIX:PAT
 CMAKE_OPTS+=("-DCMAKE_PREFIX_PATH:PATH=${BUILD_PREFIX}")
 CMAKE_OPTS+=("-DCMAKE_LIBRARY_PATH:PATH=${BUILD_PREFIX}/lib")
 CMAKE_OPTS+=("-DCMAKE_INCLUDE_PATH:PATH=${BUILD_PREFIX}/include")
+CMAKE_OPTS+=("-DENABLE_CAPSH=ON")
 
 if [ "$CLANG_FORMAT" != "" ] ; then
     CMAKE_OPTS+=("-DCLANG_FORMAT=${CLANG_FORMAT}")
@@ -59,8 +60,8 @@ if [ -n "$CLANG_TIDY" ] ; then
         MAKE_PREFIXES+=("${TRAVIS_BUILD_DIR}/bw-output")
         
     fi
-    CMAKE_PREFIXES+=("scan-build-6.0")
-    MAKE_PREFIXES+=("scan-build-6.0")
+    CMAKE_PREFIXES+=("scan-build-10")
+    MAKE_PREFIXES+=("scan-build-10")
     MAKE_PREFIXES+=("-plist-html")
     SCAN_BUILD_OUTPUT="$(pwd)/scan-build-report"
     MAKE_PREFIXES+=("-o ${SCAN_BUILD_OUTPUT}")
diff -pruN 4.3.2-2/builds/cmake/Modules/FindNSS3.cmake 4.3.3-1/builds/cmake/Modules/FindNSS3.cmake
--- 4.3.2-2/builds/cmake/Modules/FindNSS3.cmake	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/builds/cmake/Modules/FindNSS3.cmake	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,8 @@
+include(FindPackageHandleStandardArgs)
+
+if (NOT MSVC)
+    find_package(PkgConfig REQUIRED)
+    pkg_check_modules(NSS3 "nss>=3.19")
+    find_package_handle_standard_args(NSS3 DEFAULT_MSG NSS3_LIBRARIES NSS3_CFLAGS)
+endif()
+
diff -pruN 4.3.2-2/builds/cmake/Modules/FindSodium.cmake 4.3.3-1/builds/cmake/Modules/FindSodium.cmake
--- 4.3.2-2/builds/cmake/Modules/FindSodium.cmake	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/cmake/Modules/FindSodium.cmake	2020-09-07 10:12:14.000000000 +0000
@@ -4,7 +4,7 @@
 ################################################################################
 
 if (NOT MSVC)
-include(FindPkgConfig)
+find_package(PkgConfig REQUIRED) 
 pkg_check_modules(PC_SODIUM "libsodium")
 if (PC_SODIUM_FOUND)
   set(pkg_config_names_private "${pkg_config_names_private} libsodium")
@@ -39,7 +39,7 @@ find_library(
 )
 
 include(FindPackageHandleStandardArgs)
-find_package_handle_standard_args(SODIUM DEFAULT_MSG SODIUM_LIBRARIES SODIUM_INCLUDE_DIRS)
+find_package_handle_standard_args(sodium DEFAULT_MSG SODIUM_LIBRARIES SODIUM_INCLUDE_DIRS)
 mark_as_advanced(SODIUM_FOUND SODIUM_LIBRARIES SODIUM_INCLUDE_DIRS)
 
 ################################################################################
diff -pruN 4.3.2-2/builds/cmake/Modules/ZMQSourceRunChecks.cmake 4.3.3-1/builds/cmake/Modules/ZMQSourceRunChecks.cmake
--- 4.3.2-2/builds/cmake/Modules/ZMQSourceRunChecks.cmake	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/cmake/Modules/ZMQSourceRunChecks.cmake	2020-09-07 10:12:14.000000000 +0000
@@ -273,7 +273,7 @@ int main(int argc, char *argv [])
     return 0;
 }
 "
-    ZMQ_HAVE_PTHREAD_SETAFFINITY)
+    ZMQ_HAVE_PTHREAD_SET_AFFINITY)
   set(CMAKE_REQUIRED_FLAGS ${SAVE_CMAKE_REQUIRED_FLAGS})
 endmacro()
 
diff -pruN 4.3.2-2/builds/cmake/platform.hpp.in 4.3.3-1/builds/cmake/platform.hpp.in
--- 4.3.2-2/builds/cmake/platform.hpp.in	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/cmake/platform.hpp.in	2020-09-07 10:12:14.000000000 +0000
@@ -48,16 +48,31 @@
 #cmakedefine ZMQ_HAVE_PTHREAD_SETNAME_2
 #cmakedefine ZMQ_HAVE_PTHREAD_SETNAME_3
 #cmakedefine ZMQ_HAVE_PTHREAD_SET_NAME
+#cmakedefine ZMQ_HAVE_PTHREAD_SET_AFFINITY
 #cmakedefine HAVE_ACCEPT4
 #cmakedefine HAVE_STRNLEN
+#cmakedefine ZMQ_HAVE_STRLCPY
+#cmakedefine ZMQ_HAVE_LIBBSD
+
+#cmakedefine ZMQ_HAVE_IPC
+
+#cmakedefine ZMQ_USE_BUILTIN_SHA1
+#cmakedefine ZMQ_USE_NSS
+#cmakedefine ZMQ_HAVE_WS
+#cmakedefine ZMQ_HAVE_WSS
+#cmakedefine ZMQ_HAVE_TIPC
 
 #cmakedefine ZMQ_HAVE_OPENPGM
+#cmakedefine ZMQ_HAVE_NORM
 #cmakedefine ZMQ_MAKE_VALGRIND_HAPPY
 
+#cmakedefine ZMQ_BUILD_DRAFT_API
 #cmakedefine ZMQ_HAVE_CURVE
 #cmakedefine ZMQ_USE_TWEETNACL
 #cmakedefine ZMQ_USE_LIBSODIUM
 #cmakedefine SODIUM_STATIC
+#cmakedefine ZMQ_USE_GNUTLS
+#cmakedefine ZMQ_USE_RADIX_TREE
 
 #ifdef _AIX
   #define ZMQ_HAVE_AIX
@@ -75,8 +90,13 @@
   #define ZMQ_HAVE_MINGW32
 #endif
 
-#if defined(__FreeBSD__) || defined(__DragonFly__) || defined(__FreeBSD_kernel__)
+#if defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
+  #define ZMQ_HAVE_FREEBSD
+#endif
+
+#if defined(__DragonFly__)
   #define ZMQ_HAVE_FREEBSD
+  #define ZMQ_HAVE_DRAGONFLY
 #endif
 
 #if defined __hpux
@@ -95,8 +115,10 @@
   #define ZMQ_HAVE_OPENBSD
 #endif
 
+// TODO better move OS-specific defines to the automake files, and check for availability of IPC with an explicit test there
 #if defined __VMS
   #define ZMQ_HAVE_OPENVMS
+  #undef ZMQ_HAVE_IPC
 #endif
 
 #if defined __APPLE__
diff -pruN 4.3.2-2/builds/cmake/ZeroMQConfig.cmake.in 4.3.3-1/builds/cmake/ZeroMQConfig.cmake.in
--- 4.3.2-2/builds/cmake/ZeroMQConfig.cmake.in	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/cmake/ZeroMQConfig.cmake.in	2020-09-07 10:12:14.000000000 +0000
@@ -21,6 +21,11 @@ if(NOT TARGET libzmq AND NOT TARGET libz
 
   if (TARGET libzmq)
     get_target_property(@PROJECT_NAME@_INCLUDE_DIR libzmq INTERFACE_INCLUDE_DIRECTORIES)
+  else ()
+    get_target_property(@PROJECT_NAME@_INCLUDE_DIR libzmq-static INTERFACE_INCLUDE_DIRECTORIES)
+  endif()
+
+  if (TARGET libzmq)
     get_target_property(@PROJECT_NAME@_LIBRARY libzmq LOCATION)
   endif()
   if (TARGET libzmq-static)
diff -pruN 4.3.2-2/builds/coverage/ci_build.sh 4.3.3-1/builds/coverage/ci_build.sh
--- 4.3.2-2/builds/coverage/ci_build.sh	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/coverage/ci_build.sh	2020-09-07 10:12:14.000000000 +0000
@@ -5,28 +5,12 @@ set -x
 mkdir tmp
 BUILD_PREFIX=$PWD/tmp
 
-CONFIG_OPTS=()
-CONFIG_OPTS+=("CFLAGS=-I${BUILD_PREFIX}/include")
-CONFIG_OPTS+=("CPPFLAGS=-I${BUILD_PREFIX}/include")
-CONFIG_OPTS+=("CXXFLAGS=-I${BUILD_PREFIX}/include")
-CONFIG_OPTS+=("LDFLAGS=-L${BUILD_PREFIX}/lib")
-CONFIG_OPTS+=("PKG_CONFIG_PATH=${BUILD_PREFIX}/lib/pkgconfig")
-CONFIG_OPTS+=("--prefix=${BUILD_PREFIX}")
-CONFIG_OPTS+=("--enable-code-coverage")
-
-if [ -z $CURVE ]; then
-    CMAKE_OPTS+=("-DENABLE_CURVE=OFF")
-elif [ $CURVE == "libsodium" ]; then
-    CMAKE_OPTS+=("-DWITH_LIBSODIUM=ON")
+source ../../config.sh
+set_config_opts
 
-    if ! ((command -v dpkg-query >/dev/null 2>&1 && dpkg-query --list libsodium-dev >/dev/null 2>&1) || \
-            (command -v brew >/dev/null 2>&1 && brew ls --versions libsodium >/dev/null 2>&1)); then
-        git clone --depth 1 -b stable git://github.com/jedisct1/libsodium.git
-        ( cd libsodium; ./autogen.sh; ./configure --prefix=$BUILD_PREFIX; make install)
-    fi
-fi
+CONFIG_OPTS+=("--enable-code-coverage")
 
 pip install --user cpp-coveralls
 
 # Build, check, and install from local source
-( cd ../..; ./autogen.sh && ./configure "${CONFIG_OPTS[@]}" && make VERBOSE=1 -j5 check && coveralls --exclude tests --exclude src/tweetnacl.c --exclude src/tweetnacl.h --build-root . --gcov-options '\-lp') || exit 1
+( cd ../..; ./autogen.sh && ./configure "${CONFIG_OPTS[@]}" && make VERBOSE=1 -j5 check && coveralls --include src --exclude src/tweetnacl.c --exclude src/tweetnacl.h --build-root . --gcov-options '\-lp') || exit 1
diff -pruN 4.3.2-2/builds/fuzz/ci_build.sh 4.3.3-1/builds/fuzz/ci_build.sh
--- 4.3.2-2/builds/fuzz/ci_build.sh	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/builds/fuzz/ci_build.sh	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,25 @@
+#!/usr/bin/env bash
+# used by oss-fuzz https://github.com/google/oss-fuzz/tree/master/projects/libzmq
+
+set -e
+set -x
+
+cd "${SRC}/libsodium"
+DO_NOT_UPDATE_CONFIG_SCRIPTS=1 ./autogen.sh
+./configure --disable-shared --prefix=/install_prefix --disable-asm
+make -j$(nproc) V=1 install DESTDIR=/tmp/zmq_install_dir
+
+cd "${SRC}/libzmq"
+./autogen.sh
+export LDFLAGS+=" $(PKG_CONFIG_PATH=/tmp/zmq_install_dir/install_prefix/lib/pkgconfig pkg-config --static --libs --define-prefix libsodium)"
+export CXXFLAGS+=" $(PKG_CONFIG_PATH=/tmp/zmq_install_dir/install_prefix/lib/pkgconfig pkg-config --static --cflags --define-prefix libsodium)"
+./configure --disable-shared --prefix=/install_prefix --disable-perf --disable-curve-keygen PKG_CONFIG_PATH=/tmp/zmq_install_dir/install_prefix/lib/pkgconfig --with-libsodium=yes --with-fuzzing-installdir=fuzzers --with-fuzzing-engine=$LIB_FUZZING_ENGINE
+make -j$(nproc) V=1 install DESTDIR=/tmp/zmq_install_dir
+
+cd "${SRC}/libzmq-fuzz-corpora"
+cp dictionaries/* /tmp/zmq_install_dir/install_prefix/fuzzers/
+for t in test_*_seed_corpus; do
+  zip -j --quiet /tmp/zmq_install_dir/install_prefix/fuzzers/${t}.zip ${t}/*
+done
+
+cp /tmp/zmq_install_dir/install_prefix/fuzzers/* "${OUT}"
diff -pruN 4.3.2-2/builds/gyp/project.gyp 4.3.3-1/builds/gyp/project.gyp
--- 4.3.2-2/builds/gyp/project.gyp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/gyp/project.gyp	2020-09-07 10:12:14.000000000 +0000
@@ -74,6 +74,7 @@
         '../../src/clock.cpp',
         '../../src/clock.hpp',
         '../../src/command.hpp',
+        '../../src/compat.hpp',
         '../../src/condition_variable.hpp',
         '../../src/config.hpp',
         '../../src/ctx.cpp',
diff -pruN 4.3.2-2/builds/gyp/project-tests.gypi 4.3.3-1/builds/gyp/project-tests.gypi
--- 4.3.2-2/builds/gyp/project-tests.gypi	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/gyp/project-tests.gypi	2020-09-07 10:12:14.000000000 +0000
@@ -133,6 +133,17 @@
       ],
     },
     {
+      'target_name': 'test_msg_init',
+      'type': 'executable',
+      'sources': [
+        '../../tests/test_msg_init.cpp',
+        '../../tests/testutil.hpp'
+      ],
+      'dependencies': [
+        'libzmq'
+      ],
+    },
+    {
       'target_name': 'test_connect_resolve',
       'type': 'executable',
       'sources': [
diff -pruN 4.3.2-2/builds/gyp/project-tests.xml 4.3.3-1/builds/gyp/project-tests.xml
--- 4.3.2-2/builds/gyp/project-tests.xml	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/gyp/project-tests.xml	2020-09-07 10:12:14.000000000 +0000
@@ -11,6 +11,7 @@
     <test name = "test_invalid_rep" />
     <test name = "test_msg_flags" />
     <test name = "test_msg_ffn" />
+    <test name = "test_msg_init" />
     <test name = "test_connect_resolve" />
     <test name = "test_immediate" />
     <test name = "test_last_endpoint" />
diff -pruN 4.3.2-2/builds/ios/build_ios.sh 4.3.3-1/builds/ios/build_ios.sh
--- 4.3.2-2/builds/ios/build_ios.sh	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/builds/ios/build_ios.sh	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,110 @@
+#!/bin/sh
+# This is a first attempt to create a script to libzmq for iOS >= 13.5, including arm64
+# inspired on https://raw.githubusercontent.com/drewcrawford/libzmq-ios/master/libzmq.sh
+
+set -e
+LIBNAME="libzmq.a"
+ARCHS=${ARCHS:-"armv7 armv7s arm64 x86_64"}
+DEVELOPER=$(xcode-select -print-path)
+LIPO=$(xcrun -sdk iphoneos -find lipo)
+SCRIPTDIR=$( (cd -P $(dirname $0) && pwd) )
+DISTLIBDIR="${SCRIPTDIR}/lib"
+DSTDIR=${SCRIPTDIR}
+BUILDDIR="${DSTDIR}/libzmq_build"
+DISTDIR="${DSTDIR}/libzmq_dist"
+LIBDIR=$(dirname $(dirname ${SCRIPTDIR}))
+SDK=$(xcodebuild -showsdks \
+    | grep iphoneos | sort | tail -n 1 | awk '{print substr($NF, 9)}'
+    )
+IOS_VERSION_MIN=8.0
+OTHER_LDFLAGS=""
+OTHER_CFLAGS="-Os -Qunused-arguments"
+# Enable Bitcode
+OTHER_CPPFLAGS="-Os -fembed-bitcode"
+OTHER_CXXFLAGS="-Os"
+
+${LIBDIR}/autogen.sh
+for ARCH in $ARCHS
+do
+    BUILDARCHDIR="$BUILDDIR/$ARCH"
+    mkdir -p ${BUILDARCHDIR}
+
+    case ${ARCH} in
+        armv7)
+	    PLATFORM="iPhoneOS"
+	    HOST="${ARCH}-apple-darwin"
+	    export BASEDIR="${DEVELOPER}/Platforms/${PLATFORM}.platform/Developer"
+	    export ISDKROOT="${BASEDIR}/SDKs/${PLATFORM}${SDK}.sdk"
+	    export CXXFLAGS="${OTHER_CXXFLAGS}"
+	    export CPPFLAGS="-arch ${ARCH} -isysroot ${ISDKROOT} -mios-version-min=${IOS_VERSION_MIN} ${OTHER_CPPFLAGS}"
+	    export LDFLAGS="-arch ${ARCH} -isysroot ${ISDKROOT} ${OTHER_LDFLAGS}"
+            ;;
+
+        armv7s)
+	    PLATFORM="iPhoneOS"
+	    HOST="${ARCH}-apple-darwin"
+	    export BASEDIR="${DEVELOPER}/Platforms/${PLATFORM}.platform/Developer"
+	    export ISDKROOT="${BASEDIR}/SDKs/${PLATFORM}${SDK}.sdk"
+	    export CXXFLAGS="${OTHER_CXXFLAGS}"
+	    export CPPFLAGS="-arch ${ARCH} -isysroot ${ISDKROOT} -mios-version-min=${IOS_VERSION_MIN} ${OTHER_CPPFLAGS}"
+	    export LDFLAGS="-arch ${ARCH} -isysroot ${ISDKROOT} ${OTHER_LDFLAGS}"
+            ;;
+
+        arm64)
+	    PLATFORM="iPhoneOS"
+	    HOST="arm-apple-darwin"
+	    export BASEDIR="${DEVELOPER}/Platforms/${PLATFORM}.platform/Developer"
+	    export ISDKROOT="${BASEDIR}/SDKs/${PLATFORM}${SDK}.sdk"
+	    export CXXFLAGS="${OTHER_CXXFLAGS}"
+	    export CPPFLAGS="-arch ${ARCH} -isysroot ${ISDKROOT} -mios-version-min=${IOS_VERSION_MIN} ${OTHER_CPPFLAGS}"
+	    export LDFLAGS="-arch ${ARCH} -isysroot ${ISDKROOT} ${OTHER_LDFLAGS}"
+            ;;
+
+        x86_64)
+	    PLATFORM="iPhoneSimulator"
+	    HOST="${ARCH}-apple-darwin"
+	    export BASEDIR="${DEVELOPER}/Platforms/${PLATFORM}.platform/Developer"
+	    export ISDKROOT="${BASEDIR}/SDKs/${PLATFORM}${SDK}.sdk"
+	    export CXXFLAGS="${OTHER_CXXFLAGS}"
+	    export CPPFLAGS="-arch ${ARCH} -isysroot ${ISDKROOT} -mios-version-min=${IOS_VERSION_MIN} ${OTHER_CPPFLAGS}"
+	    export LDFLAGS="-arch ${ARCH} ${OTHER_LDFLAGS}"
+	    echo "LDFLAGS $LDFLAGS"
+            ;;
+        *)
+	    echo "Unsupported architecture ${ARCH}"
+	    exit 1
+            ;;
+    esac
+
+    echo "Configuring for ${ARCH}..."
+    set +e
+    cd ${LIBDIR} 
+    set -e
+    ${LIBDIR}/configure \
+	--prefix=${BUILDARCHDIR} \
+	--disable-shared \
+	--enable-static \
+	--host=${HOST}
+
+    echo "Building ${LIBNAME} for ${ARCH}..."
+    cd ${LIBDIR}
+    
+    make -j8 
+    make install
+	make clean
+
+done
+
+mkdir -p ${DISTLIBDIR}
+for ARCH in $ARCHS
+do
+	LIBPATH="$BUILDDIR/$ARCH/lib/${LIBNAME}"
+	LIBLIST+=" -arch ${ARCH} ${LIBPATH}"
+done
+
+set +e
+
+${LIPO} -create ${LIBLIST} -output ${DISTLIBDIR}/${LIBNAME}
+
+echo "Done !"
+
diff -pruN 4.3.2-2/builds/valgrind/ci_build.sh 4.3.3-1/builds/valgrind/ci_build.sh
--- 4.3.2-2/builds/valgrind/ci_build.sh	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/builds/valgrind/ci_build.sh	2020-09-07 10:12:14.000000000 +0000
@@ -14,6 +14,10 @@ CONFIG_OPTS+=("PKG_CONFIG_PATH=${BUILD_P
 CONFIG_OPTS+=("--prefix=${BUILD_PREFIX}")
 CONFIG_OPTS+=("--enable-valgrind")
 
+if [ -n "$TLS" ] && [ "$TLS" == "enabled" ]; then
+    CONFIG_OPTS+=("--with-tls=yes")
+fi
+
 if [ -z $CURVE ]; then
     CONFIG_OPTS+=("--disable-curve")
 elif [ $CURVE == "libsodium" ]; then
diff -pruN 4.3.2-2/ci_build.sh 4.3.3-1/ci_build.sh
--- 4.3.2-2/ci_build.sh	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/ci_build.sh	2020-09-07 10:12:14.000000000 +0000
@@ -3,75 +3,19 @@
 set -x
 set -e
 
-if [ $BUILD_TYPE == "default" ]; then
+if [ $BUILD_TYPE = "default" ]; then
     mkdir tmp
     BUILD_PREFIX=$PWD/tmp
 
-    CONFIG_OPTS=()
-    CONFIG_OPTS+=("CFLAGS=-g")
-    CONFIG_OPTS+=("CPPFLAGS=-I${BUILD_PREFIX}/include")
-    CONFIG_OPTS+=("CXXFLAGS=-g")
-    CONFIG_OPTS+=("LDFLAGS=-L${BUILD_PREFIX}/lib")
-    CONFIG_OPTS+=("PKG_CONFIG_PATH=${BUILD_PREFIX}/lib/pkgconfig")
-    CONFIG_OPTS+=("--prefix=${BUILD_PREFIX}")
-
-    if [ -n "$ADDRESS_SANITIZER" ] && [ "$ADDRESS_SANITIZER" == "enabled" ]; then
-        CONFIG_OPTS+=("--enable-address-sanitizer=yes")
-        CONFIG_OPTS+=("CXX=g++-6")
-        CONFIG_OPTS+=("CC=gcc-6")
-        # workaround for linker problem with ASAN options in GCC
-        # http://stackoverflow.com/questions/37603238/fsanitize-not-using-gold-linker-in-gcc-6-1
-        CONFIG_OPTS+=("LDFLAGS=-fuse-ld=gold")
-    fi
-
-    if [ -z $CURVE ]; then
-        CONFIG_OPTS+=("--disable-curve")
-    elif [ $CURVE == "libsodium" ]; then
-        CONFIG_OPTS+=("--with-libsodium=yes")
-
-        if ! ((command -v dpkg-query >/dev/null 2>&1 && dpkg-query --list libsodium-dev >/dev/null 2>&1) || \
-                (command -v brew >/dev/null 2>&1 && brew ls --versions libsodium >/dev/null 2>&1)); then
-            git clone --depth 1 -b stable git://github.com/jedisct1/libsodium.git
-            ( cd libsodium; ./autogen.sh; ./configure --prefix=$BUILD_PREFIX; make install)
-        fi
-    fi
-
-    if [ -n "$GSSAPI" ] && [ "$GSSAPI" == "enabled" ]; then
-        CONFIG_OPTS+=("--with-libgssapi_krb5=yes")
-    fi
-
-    if [ -n "$PGM" ] && [ "$PGM" == "enabled" ]; then
-        CONFIG_OPTS+=("--with-pgm=yes")
-    fi
-
-    if [ -n "$NORM" ] && [ "$NORM" == "enabled" ]; then
-        CONFIG_OPTS+=("--with-norm=yes")
-    fi
-
-    if [ -n "$TIPC" ] && [ "$TIPC" == "enabled" ]; then
-        sudo modprobe tipc
-    fi
-
-    if [ -n "$POLLER" ]; then
-        CONFIG_OPTS+=("--with-poller=${POLLER}")
-    fi
-
-    if [ -z $DRAFT ] || [ $DRAFT == "disabled" ]; then
-        CONFIG_OPTS+=("--enable-drafts=no")
-    elif [ $DRAFT == "enabled" ]; then
-        CONFIG_OPTS+=("--enable-drafts=yes")
-    fi
-
-    if [ -n "$FORCE_98" ] && [ "$FORCE_98" == "enabled" ]; then
-        CONFIG_OPTS+=("--enable-force-CXX98-compat=yes")
-    fi
+    source config.sh
+    set_config_opts
 
     # Build and check this project
     (
         ./autogen.sh &&
         ./configure "${CONFIG_OPTS[@]}" &&
         export DISTCHECK_CONFIGURE_FLAGS="${CONFIG_OPTS[@]}" &&
-        make VERBOSE=1 -j5 distcheck
+        make VERBOSE=1 -j5 ${CHECK}
     ) || exit 1
 else
     cd ./builds/${BUILD_TYPE} && ./ci_build.sh
diff -pruN 4.3.2-2/ci_deploy.sh 4.3.3-1/ci_deploy.sh
--- 4.3.2-2/ci_deploy.sh	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/ci_deploy.sh	2020-09-07 10:12:14.000000000 +0000
@@ -16,16 +16,11 @@ if [[ $BUILD_TYPE == "default" && $CURVE
     sha1sum *.zip *.tar.gz > SHA1SUMS
     cd -
 
-    # Trigger source run on new tag on OBS.
-    # We have to keep a release branch on the lastest tag, as it is
-    # not possible to edit files on OBS with secure tokens, and it is not
-    # possible to dynamically fetch the latest git tag either.
-    if [ -n "${GH_TOKEN}" -a -n "${OBS_STABLE_TOKEN}" -a -n "${OBS_DRAFT_TOKEN}" ]; then
-        TAG_SHA=$(curl -s -H "Authorization: token ${GH_TOKEN}" -X GET https://api.github.com/repos/zeromq/libzmq/git/refs/tags/${TRAVIS_TAG} | grep -o -P '(?<=sha":\s).*(?=,)')
-        curl -H "Authorization: token ${GH_TOKEN}" -X DELETE https://api.github.com/repos/zeromq/libzmq/git/refs/heads/latest_release
-        curl -H "Authorization: token ${GH_TOKEN}" -X POST --data "{\"ref\":\"refs/heads/latest_release\",\"sha\":${TAG_SHA}}" https://api.github.com/repos/zeromq/libzmq/git/refs
-        sleep 2 # try to avoid races if Github is slow
+    # Trigger source run on new tag on OBS. The latest tag will be fetched.
+    if [ -n "${OBS_STABLE_TOKEN}" ]; then
         curl -H "Authorization: Token ${OBS_STABLE_TOKEN}" -X POST https://api.opensuse.org/trigger/runservice
+    fi
+    if [ -n "${OBS_DRAFT_TOKEN}" ]; then
         curl -H "Authorization: Token ${OBS_DRAFT_TOKEN}" -X POST https://api.opensuse.org/trigger/runservice
     fi
 else
diff -pruN 4.3.2-2/.clang-format 4.3.3-1/.clang-format
--- 4.3.2-2/.clang-format	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/.clang-format	2020-09-07 10:12:14.000000000 +0000
@@ -38,7 +38,7 @@ SpaceInEmptyParentheses: false
 SpacesInAngles: false
 SpacesInParentheses: false
 SpacesInSquareBrackets: false
-Standard: Cpp11
+Standard: Cpp03
 
 SortIncludes: false
 
diff -pruN 4.3.2-2/.clang-tidy 4.3.3-1/.clang-tidy
--- 4.3.2-2/.clang-tidy	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/.clang-tidy	2020-09-07 10:12:14.000000000 +0000
@@ -9,21 +9,28 @@ Checks:        "*,\
 -fuchsia-default-arguments,\
 -google-readability-todo,\
 -google-runtime-int,\
+-cppcoreguidelines-avoid-goto,\
 -cppcoreguidelines-pro-type-member-init,\
 -cppcoreguidelines-pro-type-static-cast-downcast,\
 # not applicable\
+-fuchsia-default-argument-calls,\
 -fuchsia-overloaded-operator,\
+-fuchsia-statically-constructed-objects,\
 # not currently a coding convention, C++11-specific, but conceivable,\
 -modernize-use-nullptr,\
 -modernize-use-equals-default,\
 -modernize-deprecated-headers,\
 # not currently a coding convention, C++11-specific and hard to implement,\
 -hicpp-no-malloc,\
+-hicpp-avoid-c-arrays,\
+-modernize-avoid-c-arrays,\
 -modernize-pass-by-value,\
 -modernize-loop-convert,\
 -modernize-use-auto,\
+-modernize-use-trailing-return-type,\
 -modernize-use-using,\
 -modernize-return-braced-init-list,\
+-cppcoreguidelines-avoid-c-arrays,\
 -cppcoreguidelines-no-malloc,\
 -cppcoreguidelines-owning-memory,\
 -cppcoreguidelines-pro-type-union-access,\
@@ -37,6 +44,7 @@ Checks:        "*,\
 # duplicates,\
 -google-readability-braces-around-statements,\
 -cppcoreguidelines-pro-type-cstyle-cast,\
+-cppcoreguidelines-avoid-magic-numbers,\
 -hicpp-braces-around-statements,\
 -hicpp-use-equals-default,\
 -hicpp-deprecated-headers,\
@@ -412,3 +420,7 @@ CheckOptions:
     # value:           '0'
   # - key:             readability-simplify-boolean-expr.ChainedConditionalReturn
     # value:           '0'
+   - key:             modernize-use-override.OverrideSpelling
+     value:           'ZMQ_OVERRIDE'
+   - key:             modernize-use-override.FinalSpelling
+     value:           'ZMQ_FINAL'
diff -pruN 4.3.2-2/CMakeLists.txt 4.3.3-1/CMakeLists.txt
--- 4.3.2-2/CMakeLists.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/CMakeLists.txt	2020-09-07 10:12:14.000000000 +0000
@@ -29,20 +29,70 @@ include(TestZMQVersion)
 include(ZMQSourceRunChecks)
 include(ZMQSupportMacros)
 
+find_package(PkgConfig)
+
+# Set lists to empty beforehand as to not accidentally take values from parent
+set(sources)
+set(cxx-sources)
+set(html-docs)
+set(target_outputs)
+
 option(ENABLE_ASAN "Build with address sanitizer" OFF)
 if(ENABLE_ASAN)
   message(STATUS "Instrumenting with Address Sanitizer")
+  set(CMAKE_BUILD_TYPE "RelWithDebInfo")
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope -fno-omit-frame-pointer")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope -fno-omit-frame-pointer")
+  set(CMAKE_CXX_FLAGS
+      "${CMAKE_CXX_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope -fno-omit-frame-pointer")
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope")
   set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope")
 endif()
 
-option (ENABLE_INTRINSICS "Build using compiler intrinsics for atomic ops" OFF)
-if (ENABLE_INTRINSICS)
-   message(STATUS "Using compiler intrinsics for atomic ops")
-   add_definitions(-DZMQ_HAVE_ATOMIC_INTRINSICS)
-endif()
+# NOTE: Running libzmq under TSAN doesn't make much sense -- synchronization in libzmq is to some extent
+# handled by the code "knowing" what threads are allowed to do, rather than by enforcing those
+# restrictions, so TSAN generates a lot of (presumably) false positives from libzmq.
+# The settings below are intended to enable libzmq to be built with minimal support for TSAN
+# such that it can be used along with other code that is also built with TSAN.
+option(ENABLE_TSAN "Build with thread sanitizer" OFF)
+if(ENABLE_TSAN)
+  message(STATUS "Instrumenting with Thread Sanitizer")
+  set(CMAKE_BUILD_TYPE "RelWithDebInfo")
+  set(TSAN_FLAGS "-fno-omit-frame-pointer -fsanitize=thread")
+  set(TSAN_CCFLAGS "${TSAN_CCFLAGS} -mllvm -tsan-instrument-memory-accesses=0")
+  set(TSAN_CCFLAGS "${TSAN_CCFLAGS} -mllvm -tsan-instrument-atomics=0")
+  set(TSAN_CCFLAGS "${TSAN_CCFLAGS} -mllvm -tsan-instrument-func-entry-exit=1")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${TSAN_FLAGS} ${TSAN_CCFLAGS} -fPIE")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${TSAN_FLAGS} ${TSAN_CCFLAGS} -fPIE")
+  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${TSAN_FLAGS} -pie -Qunused-arguments")
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${TSAN_FLAGS} -pie -Qunused-arguments")
+endif()
+
+option(ENABLE_UBSAN "Build with undefined behavior sanitizer" OFF)
+if(ENABLE_UBSAN)
+  message(STATUS "Instrumenting with Undefined Behavior Sanitizer")
+  set(CMAKE_BUILD_TYPE "RelWithDebInfo")
+  set(UBSAN_FLAGS "${UBSAN_FLAGS} -fno-omit-frame-pointer")
+  set(UBSAN_FLAGS "${UBSAN_FLAGS} -fsanitize=undefined")
+  set(UBSAN_FLAGS "${UBSAN_FLAGS} -fsanitize=implicit-conversion")
+  set(UBSAN_FLAGS "${UBSAN_FLAGS} -fsanitize=implicit-integer-truncation")
+  set(UBSAN_FLAGS "${UBSAN_FLAGS} -fsanitize=integer")
+  set(UBSAN_FLAGS "${UBSAN_FLAGS} -fsanitize=nullability")
+  set(UBSAN_FLAGS "${UBSAN_FLAGS} -fsanitize=vptr")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${UBSAN_FLAGS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${UBSAN_FLAGS}")
+  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${UBSAN_FLAGS}")
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${UBSAN_FLAGS}")
+endif()
+
+option(ENABLE_INTRINSICS "Build using compiler intrinsics for atomic ops" OFF)
+if(ENABLE_INTRINSICS)
+  message(STATUS "Using compiler intrinsics for atomic ops")
+  add_definitions(-DZMQ_HAVE_ATOMIC_INTRINSICS)
+endif()
+
+set(ZMQ_OUTPUT_BASENAME
+    "zmq"
+    CACHE STRING "Output zmq library base name")
 
 if(${CMAKE_SYSTEM_NAME} STREQUAL Darwin)
   # Find more information: https://cmake.org/Wiki/CMake_RPATH_handling
@@ -60,16 +110,23 @@ if(${CMAKE_SYSTEM_NAME} STREQUAL Darwin)
   set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
 endif()
 
-check_cxx_compiler_flag("-std=gnu++11" COMPILER_SUPPORTS_CXX11)
-if(COMPILER_SUPPORTS_CXX11)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
-endif()
-check_c_compiler_flag("-std=gnu11" COMPILER_SUPPORTS_C11)
-if(COMPILER_SUPPORTS_C11)
-  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
-endif()
+if (NOT MSVC)
+  if(NOT CMAKE_CXX_FLAGS MATCHES "-std=")
+    # use C++11 by default if supported
+    check_cxx_compiler_flag("-std=gnu++11" COMPILER_SUPPORTS_CXX11)
+    if(COMPILER_SUPPORTS_CXX11)
+      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
+    endif()
+  endif()
+  if(NOT CMAKE_C_FLAGS MATCHES "-std=")
+    check_c_compiler_flag("-std=gnu11" COMPILER_SUPPORTS_C11)
+    if(COMPILER_SUPPORTS_C11)
+      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
+    else()
+      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
+    endif()
+  endif()
 
-if(NOT MSVC)
   # clang 6 has a warning that does not make sense on multi-platform code
   check_cxx_compiler_flag("-Wno-tautological-constant-compare" CXX_HAS_TAUT_WARNING)
   if(CXX_HAS_TAUT_WARNING)
@@ -86,71 +143,242 @@ set(pkg_config_libs_private "")
 set(pkg_config_names_private "")
 
 option(WITH_OPENPGM "Build with support for OpenPGM" OFF)
+option(WITH_NORM "Build with support for NORM" OFF)
 option(WITH_VMCI "Build with support for VMware VMCI socket" OFF)
 
 if(APPLE)
   option(ZMQ_BUILD_FRAMEWORK "Build as OS X framework" OFF)
 endif()
 
-# Select curve encryption library, defaults to tweetnacl
-# To use libsodium instead, use --with-libsodium(must be installed)
-# To disable curve, use --disable-curve
+if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
+  message(STATUS "Build and install draft classes and methods")
+  option(ENABLE_DRAFTS "Build and install draft classes and methods" ON)
+else()
+  message(STATUS "Not building draft classes and methods")
+  option(ENABLE_DRAFTS "Build and install draft classes and methods" OFF)
+endif()
 
-option(WITH_LIBSODIUM "Use libsodium instead of built-in tweetnacl" OFF)
-option(ENABLE_CURVE "Enable CURVE security" ON)
+# Enable WebSocket transport and RadixTree
+if(ENABLE_DRAFTS)
+  set(ZMQ_BUILD_DRAFT_API 1)
+  option(ENABLE_WS "Enable WebSocket transport" ON)
+  option(ENABLE_RADIX_TREE "Use radix tree implementation to manage subscriptions" ON)
+else()
+  option(ENABLE_WS "Enable WebSocket transport" OFF)
+  option(ENABLE_RADIX_TREE "Use radix tree implementation to manage subscriptions" OFF)
+endif()
 
-if(NOT ENABLE_CURVE)
-  message(STATUS "CURVE security is disabled")
-elseif(WITH_LIBSODIUM)
-  find_package(Sodium)
-  if(SODIUM_FOUND)
-    message(STATUS "Using libsodium for CURVE security")
-    include_directories(${SODIUM_INCLUDE_DIRS})
-    set(ZMQ_USE_LIBSODIUM 1)
-    set(ZMQ_HAVE_CURVE 1)
-  else()
-    message(FATAL_ERROR
-      "libsodium is not installed. Install it, then run CMake again")
+if(ENABLE_RADIX_TREE)
+  message(STATUS "Using radix tree implementation to manage subscriptions")
+  set(ZMQ_USE_RADIX_TREE 1)
+endif()
+
+if(ENABLE_WS)
+  list(
+    APPEND
+    sources
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_address.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_connecter.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_decoder.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_encoder.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_engine.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_listener.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_address.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_connecter.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_decoder.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_encoder.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_engine.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_listener.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_protocol.hpp)
+  set(ZMQ_HAVE_WS 1)
+
+  message(STATUS "Enable WebSocket transport")
+
+  option(WITH_TLS "Use TLS for WSS support" ON)
+  option(WITH_NSS "Use NSS instead of builtin sha1" OFF)
+
+  if(WITH_TLS)
+    find_package("GnuTLS" 3.6.7)
+    if(GNUTLS_FOUND)
+      set(pkg_config_names_private "${pkg_config_names_private} gnutls")
+      list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/src/wss_address.hpp
+           ${CMAKE_CURRENT_SOURCE_DIR}/src/wss_address.cpp ${CMAKE_CURRENT_SOURCE_DIR}/src/wss_engine.hpp
+           ${CMAKE_CURRENT_SOURCE_DIR}/src/wss_engine.cpp)
+
+      message(STATUS "Enable WSS transport")
+      set(ZMQ_USE_GNUTLS 1)
+      set(ZMQ_HAVE_WSS 1)
+    else()
+      message(WARNING "No WSS support, you may want to install GnuTLS and run cmake again")
+    endif()
   endif()
-else()
-  message(STATUS "Using tweetnacl for CURVE security")
-  list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/src/tweetnacl.c)
-  set(ZMQ_USE_TWEETNACL 1)
-  set(ZMQ_HAVE_CURVE 1)
 endif()
 
-set(SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
+if(NOT ZMQ_USE_GNUTLS)
+  if(WITH_NSS)
+    pkg_check_modules(NSS3 "nss")
+    if(NSS3_FOUND)
+      set(pkg_config_names_private "${pkg_config_names_private} nss")
+      message(STATUS "Using NSS")
+      set(ZMQ_USE_NSS 1)
+    else()
+      find_package("NSS3")
+      if(NSS3_FOUND)
+        set(pkg_config_libs_private "${pkg_config_libs_private} -lnss3")
+        message(STATUS "Using NSS")
+        set(ZMQ_USE_NSS 1)
+      else()
+        message(WARNING "No nss installed, if you don't want builtin SHA1, install NSS or GnuTLS")
+      endif()
+    endif()
+  endif()
+  if(NOT ZMQ_USE_NSS)
+    list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/external/sha1/sha1.c
+         ${CMAKE_CURRENT_SOURCE_DIR}/external/sha1/sha1.h)
+    message(STATUS "Using builtin sha1")
+    set(ZMQ_USE_BUILTIN_SHA1 1)
+  endif()
+endif()
 
-if(EXISTS "${SOURCE_DIR}/.git")
-  option(ENABLE_DRAFTS "Build and install draft classes and methods" ON)
-else()
-  option(ENABLE_DRAFTS "Build and install draft classes and methods" OFF)
+if(NOT MSVC)
+  option(WITH_LIBBSD "Use libbsd instead of builtin strlcpy" ON)
+  if(WITH_LIBBSD)
+    pkg_check_modules(LIBBSD "libbsd")
+    if(LIBBSD_FOUND)
+      message(STATUS "Using libbsd")
+      set(pkg_config_names_private "${pkg_config_names_private} libbsd")
+      set(ZMQ_HAVE_LIBBSD 1)
+    endif()
+  endif()
+  if(NOT WITH_LIBBSD OR NOT LIBBSD_FOUND)
+    check_cxx_symbol_exists(strlcpy string.h ZMQ_HAVE_STRLCPY)
+  endif()
 endif()
-if(ENABLE_DRAFTS)
-  option (ENABLE_RADIX_TREE "Use radix tree implementation to manage subscriptions" ON)
-  add_definitions(-DZMQ_BUILD_DRAFT_API)
-  set(pkg_config_defines "-DZMQ_BUILD_DRAFT_API=1")
+
+# Select curve encryption library, defaults to tweetnacl To use libsodium instead, use --with-libsodium(must be
+# installed) To disable curve, use --disable-curve
+
+option(WITH_LIBSODIUM "Use libsodium instead of built-in tweetnacl" ON)
+option(WITH_LIBSODIUM_STATIC "Use static libsodium library" OFF)
+option(ENABLE_CURVE "Enable CURVE security" ON)
+
+if(ENABLE_CURVE)
+  if(WITH_LIBSODIUM)
+    find_package("Sodium")
+    if(SODIUM_FOUND)
+      message(STATUS "Using libsodium for CURVE security")
+      include_directories(${SODIUM_INCLUDE_DIRS})
+      if(WITH_LIBSODIUM_STATIC)
+        add_compile_definitions(SODIUM_STATIC)
+      endif()
+      set(ZMQ_USE_LIBSODIUM 1)
+      set(ZMQ_HAVE_CURVE 1)
+    else()
+      message(
+        WARNING
+          "libsodium not installed, instead using builtin tweetnacl, you may want to install libsodium and run cmake again"
+      )
+    endif()
+  endif()
+  if(NOT ZMQ_HAVE_CURVE)
+    message(STATUS "Using tweetnacl for CURVE security")
+    list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/src/tweetnacl.c)
+    set(ZMQ_USE_TWEETNACL 1)
+    set(ZMQ_HAVE_CURVE 1)
+  endif()
 else()
-  option (ENABLE_RADIX_TREE "Use radix tree implementation to manage subscriptions" OFF)
-  set(pkg_config_defines "")
+  message(STATUS "CURVE security is disabled")
 endif()
 
-if (ENABLE_RADIX_TREE)
-   message(STATUS "Using radix tree implementation to manage subscriptions")
-   add_definitions(-DZMQ_USE_RADIX_TREE)
-endif()
+set(SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
 
 option(WITH_MILITANT "Enable militant assertions" OFF)
 if(WITH_MILITANT)
   add_definitions(-DZMQ_ACT_MILITANT)
 endif()
 
-set(API_POLLER "" CACHE STRING "Choose polling system for zmq_poll(er)_*. valid values are
+set(API_POLLER
+    ""
+    CACHE STRING "Choose polling system for zmq_poll(er)_*. valid values are
   poll or select [default=poll unless POLLER=select]")
 
-set(POLLER "" CACHE STRING "Choose polling system for I/O threads. valid values are
+set(POLLER
+    ""
+    CACHE STRING "Choose polling system for I/O threads. valid values are
   kqueue, epoll, devpoll, pollset, poll or select [default=autodetect]")
 
+if(WIN32)
+  if(CMAKE_SYSTEM_NAME STREQUAL "WindowsStore" AND CMAKE_SYSTEM_VERSION MATCHES "^10.0")
+    set(ZMQ_HAVE_WINDOWS_UWP ON)
+    set(ZMQ_HAVE_IPC OFF)
+    # to remove compile warninging "D9002 ignoring unknown option"
+    string(REPLACE "/Zi" "" CMAKE_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
+    set(CMAKE_CXX_FLAGS_DEBUG
+        ${CMAKE_CXX_FLAGS_DEBUG}
+        CACHE STRING "" FORCE)
+    string(REPLACE "/Zi" "" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
+    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO
+        ${CMAKE_CXX_FLAGS_RELWITHDEBINFO}
+        CACHE STRING "" FORCE)
+    string(REPLACE "/Zi" "" CMAKE_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
+  endif()
+  # from https://stackoverflow.com/a/40217291/2019765
+  macro(get_WIN32_WINNT version)
+    if(CMAKE_SYSTEM_VERSION)
+      set(ver ${CMAKE_SYSTEM_VERSION})
+      string(REGEX MATCH "^([0-9]+).([0-9])" ver ${ver})
+      string(REGEX MATCH "^([0-9]+)" verMajor ${ver})
+      # Check for Windows 10, b/c we'll need to convert to hex 'A'.
+      if("${verMajor}" MATCHES "10")
+        set(verMajor "A")
+        string(REGEX REPLACE "^([0-9]+)" ${verMajor} ver ${ver})
+      endif("${verMajor}" MATCHES "10")
+      # Remove all remaining '.' characters.
+      string(REPLACE "." "" ver ${ver})
+      # Prepend each digit with a zero.
+      string(REGEX REPLACE "([0-9A-Z])" "0\\1" ver ${ver})
+      set(${version} "0x${ver}")
+    endif(CMAKE_SYSTEM_VERSION)
+  endmacro(get_WIN32_WINNT)
+
+  get_win32_winnt(ZMQ_WIN32_WINNT_DEFAULT)
+  message(STATUS "Detected _WIN32_WINNT from CMAKE_SYSTEM_VERSION: ${ZMQ_WIN32_WINNT_DEFAULT}")
+
+  # TODO limit _WIN32_WINNT to the actual Windows SDK version, which might be different from the default version
+  # installed with Visual Studio
+  if(MSVC_VERSION STREQUAL "1500" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.0")
+    set(ZMQ_WIN32_WINNT_LIMIT "0x0600")
+  elseif(MSVC_VERSION STREQUAL "1600" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.1")
+    set(ZMQ_WIN32_WINNT_LIMIT "0x0601")
+  elseif(MSVC_VERSION STREQUAL "1700" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.1")
+    set(ZMQ_WIN32_WINNT_LIMIT "0x0601")
+  elseif(MSVC_VERSION STREQUAL "1800" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.2")
+    set(ZMQ_WIN32_WINNT_LIMIT "0x0602")
+  endif()
+  if(ZMQ_WIN32_WINNT_LIMIT)
+    message(
+      STATUS
+        "Mismatch of Visual Studio Version (${MSVC_VERSION}) and CMAKE_SYSTEM_VERSION (${CMAKE_SYSTEM_VERSION}), limiting _WIN32_WINNT to ${ZMQ_WIN32_WINNT_LIMIT}, you may override this by setting ZMQ_WIN32_WINNT"
+    )
+    set(ZMQ_WIN32_WINNT_DEFAULT "${ZMQ_WIN32_WINNT_LIMIT}")
+  endif()
+
+  set(ZMQ_WIN32_WINNT
+      "${ZMQ_WIN32_WINNT_DEFAULT}"
+      CACHE STRING "Value to set _WIN32_WINNT to for building [default=autodetect from build environment]")
+
+  # On Windows Vista or greater, with MSVC 2013 or greater, default to epoll (which is required on Win 10 for ipc
+  # support)
+  if(ZMQ_WIN32_WINNT GREATER "0x05FF"
+     AND MSVC_VERSION GREATER 1799
+     AND POLLER STREQUAL ""
+     AND NOT ZMQ_HAVE_WINDOWS_UWP)
+    set(POLLER "epoll")
+  endif()
+
+  add_definitions(-D_WIN32_WINNT=${ZMQ_WIN32_WINNT})
+endif(WIN32)
+
 if(NOT MSVC)
   if(POLLER STREQUAL "")
     check_cxx_symbol_exists(kqueue sys/event.h HAVE_KQUEUE)
@@ -203,17 +431,16 @@ if(POLLER STREQUAL "")
   if(HAVE_SELECT)
     set(POLLER "select")
   else()
-    message(FATAL_ERROR
-      "Could not autodetect polling method")
+    message(FATAL_ERROR "Could not autodetect polling method")
   endif()
 endif()
 
 if(POLLER STREQUAL "kqueue"
-  OR POLLER STREQUAL "epoll"
-  OR POLLER STREQUAL "devpoll"
-  OR POLLER STREQUAL "pollset"
-  OR POLLER STREQUAL "poll"
-  OR POLLER STREQUAL "select")
+   OR POLLER STREQUAL "epoll"
+   OR POLLER STREQUAL "devpoll"
+   OR POLLER STREQUAL "pollset"
+   OR POLLER STREQUAL "poll"
+   OR POLLER STREQUAL "select")
   message(STATUS "Using polling method in I/O threads: ${POLLER}")
   string(TOUPPER ${POLLER} UPPER_POLLER)
   set(ZMQ_IOTHREAD_POLLER_USE_${UPPER_POLLER} 1)
@@ -223,7 +450,8 @@ endif()
 
 if(POLLER STREQUAL "epoll" AND WIN32)
   message(STATUS "Including wepoll")
-  list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/external/wepoll/wepoll.c ${CMAKE_CURRENT_SOURCE_DIR}/external/wepoll/wepoll.h)
+  list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/external/wepoll/wepoll.c
+       ${CMAKE_CURRENT_SOURCE_DIR}/external/wepoll/wepoll.h)
 endif()
 
 if(API_POLLER STREQUAL "")
@@ -238,8 +466,13 @@ message(STATUS "Using polling method in
 string(TOUPPER ${API_POLLER} UPPER_API_POLLER)
 set(ZMQ_POLL_BASED_ON_${UPPER_API_POLLER} 1)
 
-execute_process(COMMAND getconf LEVEL1_DCACHE_LINESIZE OUTPUT_VARIABLE CACHELINE_SIZE ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
-if(CACHELINE_SIZE STREQUAL "" OR CACHELINE_SIZE EQUAL 0 OR CACHELINE_SIZE EQUAL -1)
+execute_process(
+  COMMAND getconf LEVEL1_DCACHE_LINESIZE
+  OUTPUT_VARIABLE CACHELINE_SIZE
+  ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
+if(CACHELINE_SIZE STREQUAL ""
+   OR CACHELINE_SIZE EQUAL 0
+   OR CACHELINE_SIZE EQUAL -1)
   set(ZMQ_CACHELINE_SIZE 64)
 else()
   set(ZMQ_CACHELINE_SIZE ${CACHELINE_SIZE})
@@ -251,89 +484,51 @@ if(NOT CYGWIN)
   check_include_files(windows.h ZMQ_HAVE_WINDOWS)
 endif()
 
-if (WIN32)
-    # from https://stackoverflow.com/a/40217291/2019765
-    macro(get_WIN32_WINNT version)
-        if (CMAKE_SYSTEM_VERSION)
-            set(ver ${CMAKE_SYSTEM_VERSION})
-            string(REGEX MATCH "^([0-9]+).([0-9])" ver ${ver})
-            string(REGEX MATCH "^([0-9]+)" verMajor ${ver})
-            # Check for Windows 10, b/c we'll need to convert to hex 'A'.
-            if ("${verMajor}" MATCHES "10")
-                set(verMajor "A")
-                string(REGEX REPLACE "^([0-9]+)" ${verMajor} ver ${ver})
-            endif ("${verMajor}" MATCHES "10")
-            # Remove all remaining '.' characters.
-            string(REPLACE "." "" ver ${ver})
-            # Prepend each digit with a zero.
-            string(REGEX REPLACE "([0-9A-Z])" "0\\1" ver ${ver})
-            set(${version} "0x${ver}")
-        endif(CMAKE_SYSTEM_VERSION)
-    endmacro(get_WIN32_WINNT)
-
-    get_WIN32_WINNT(ZMQ_WIN32_WINNT_DEFAULT)
-    message(STATUS "Detected _WIN32_WINNT from CMAKE_SYSTEM_VERSION: ${ZMQ_WIN32_WINNT_DEFAULT}")
-
-    # TODO limit _WIN32_WINNT to the actual Windows SDK version, which might be different from the default version installed with Visual Studio
-    if(MSVC_VERSION STREQUAL "1500" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.0")
-        set(ZMQ_WIN32_WINNT_LIMIT "0x0600")
-    elseif(MSVC_VERSION STREQUAL "1600" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.1")
-        set(ZMQ_WIN32_WINNT_LIMIT "0x0601")
-    elseif(MSVC_VERSION STREQUAL "1700" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.1")
-        set(ZMQ_WIN32_WINNT_LIMIT "0x0601")
-    elseif(MSVC_VERSION STREQUAL "1800" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.2")
-        set(ZMQ_WIN32_WINNT_LIMIT "0x0602")
-    endif()
-    if(ZMQ_WIN32_WINNT_LIMIT)
-        message(STATUS "Mismatch of Visual Studio Version (${MSVC_VERSION}) and CMAKE_SYSTEM_VERSION (${CMAKE_SYSTEM_VERSION}), limiting _WIN32_WINNT to ${ZMQ_WIN32_WINNT_LIMIT}, you may override this by setting ZMQ_WIN32_WINNT")
-        set(ZMQ_WIN32_WINNT_DEFAULT "${ZMQ_WIN32_WINNT_LIMIT}")
-    endif()
-
-    set(ZMQ_WIN32_WINNT "${ZMQ_WIN32_WINNT_DEFAULT}" CACHE STRING "Value to set _WIN32_WINNT to for building [default=autodetect from build environment]")
-
-    add_definitions(-D_WIN32_WINNT=${ZMQ_WIN32_WINNT})
-endif(WIN32)
+if(NOT WIN32)
+  set(ZMQ_HAVE_IPC 1)
+else()
+  check_include_files("winsock2.h;afunix.h" ZMQ_HAVE_IPC)
+endif()
 
-###################### BEGIN condition_variable_t selection
+# ##################### BEGIN condition_variable_t selection
 if(NOT ZMQ_CV_IMPL)
-    # prefer C++11 STL std::condition_variable implementation, if available
-    check_include_files(condition_variable ZMQ_HAVE_STL_CONDITION_VARIABLE LANGUAGE CXX)
+  # prefer C++11 STL std::condition_variable implementation, if available
+  check_include_files(condition_variable ZMQ_HAVE_STL_CONDITION_VARIABLE LANGUAGE CXX)
 
-    if (ZMQ_HAVE_STL_CONDITION_VARIABLE)
-        set(ZMQ_CV_IMPL_DEFAULT "stl11")
+  if(ZMQ_HAVE_STL_CONDITION_VARIABLE)
+    set(ZMQ_CV_IMPL_DEFAULT "stl11")
+  else()
+    if(WIN32 AND NOT CMAKE_SYSTEM_VERSION VERSION_LESS "6.0")
+      # Win32API CONDITION_VARIABLE is supported from Windows Vista only
+      set(ZMQ_CV_IMPL_DEFAULT "win32api")
+    elseif(CMAKE_USE_PTHREADS_INIT)
+      set(ZMQ_CV_IMPL_DEFAULT "pthreads")
     else()
-        if(WIN32 AND NOT CMAKE_SYSTEM_VERSION VERSION_LESS "6.0")
-            # Win32API CONDITION_VARIABLE is supported from Windows Vista only
-            set(ZMQ_CV_IMPL_DEFAULT "win32api")
-        elseif(CMAKE_USE_PTHREADS_INIT)
-            set(ZMQ_CV_IMPL_DEFAULT "pthreads")
-        else()
-            set(ZMQ_CV_IMPL_DEFAULT "none")
-        endif()
+      set(ZMQ_CV_IMPL_DEFAULT "none")
     endif()
+  endif()
 
-    # TODO a vxworks implementation also exists, but vxworks is not currently supported with cmake at all
-    set(ZMQ_CV_IMPL "${ZMQ_CV_IMPL_DEFAULT}" CACHE STRING "Choose condition_variable_t implementation. Valid values are
+  # TODO a vxworks implementation also exists, but vxworks is not currently supported with cmake at all
+  set(ZMQ_CV_IMPL
+      "${ZMQ_CV_IMPL_DEFAULT}"
+      CACHE STRING "Choose condition_variable_t implementation. Valid values are
        stl11, win32api, pthreads, none [default=autodetect]")
 endif()
 
 message(STATUS "Using condition_variable_t implementation: ${ZMQ_CV_IMPL}")
 if(ZMQ_CV_IMPL STREQUAL "stl11")
-    set(ZMQ_USE_CV_IMPL_STL11 1)
+  set(ZMQ_USE_CV_IMPL_STL11 1)
 elseif(ZMQ_CV_IMPL STREQUAL "win32api")
-    set(ZMQ_USE_CV_IMPL_WIN32API 1)
+  set(ZMQ_USE_CV_IMPL_WIN32API 1)
 elseif(ZMQ_CV_IMPL STREQUAL "pthreads")
-    set(ZMQ_USE_CV_IMPL_PTHREADS 1)
+  set(ZMQ_USE_CV_IMPL_PTHREADS 1)
 elseif(ZMQ_CV_IMPL STREQUAL "none")
-    set(ZMQ_USE_CV_IMPL_NONE 1)
+  set(ZMQ_USE_CV_IMPL_NONE 1)
 else()
-    message(ERROR "Unknown value for ZMQ_CV_IMPL: ${ZMQ_CV_IMPL}")
+  message(ERROR "Unknown value for ZMQ_CV_IMPL: ${ZMQ_CV_IMPL}")
 endif()
-###################### END condition_variable_t selection
+# ##################### END condition_variable_t selection
 
-if(CMAKE_SYSTEM_NAME STREQUAL "WindowsStore" AND CMAKE_SYSTEM_VERSION STREQUAL "10.0")
-  set(ZMQ_HAVE_WINDOWS_UWP ON)
-endif()
 if(NOT MSVC)
   check_include_files(ifaddrs.h ZMQ_HAVE_IFADDRS)
   check_include_files(sys/uio.h ZMQ_HAVE_UIO)
@@ -391,10 +586,12 @@ if(NOT MSVC)
   set(CMAKE_REQUIRED_LIBRARIES)
 
   check_cxx_symbol_exists(fork unistd.h HAVE_FORK)
-  check_cxx_symbol_exists(gethrtimei sys/time.h HAVE_GETHRTIME)
+  check_cxx_symbol_exists(gethrtime sys/time.h HAVE_GETHRTIME)
   check_cxx_symbol_exists(mkdtemp stdlib.h HAVE_MKDTEMP)
   check_cxx_symbol_exists(accept4 sys/socket.h HAVE_ACCEPT4)
   check_cxx_symbol_exists(strnlen string.h HAVE_STRNLEN)
+else()
+  set(HAVE_STRNLEN 1)
 endif()
 
 add_definitions(-D_REENTRANT -D_THREAD_SAFE)
@@ -420,18 +617,22 @@ if(MSVC)
 
     # C++11/14/17-specific, but maybe possible via conditional defines
     zmq_check_cxx_flag_prepend("/wd26440") # Function '...' can be declared 'noexcept'
-    zmq_check_cxx_flag_prepend("/wd26432") # If you define or delete any default operation in the type '...', define or delete them all
+    zmq_check_cxx_flag_prepend("/wd26432") # If you define or delete any default operation in the type '...', define or
+                                           # delete them all
     zmq_check_cxx_flag_prepend("/wd26439") # This kind of function may not throw. Declare it 'noexcept'
-    zmq_check_cxx_flag_prepend("/wd26447") # The function is declared 'noexcept' but calls function '...' which may throw exceptions
+    zmq_check_cxx_flag_prepend("/wd26447") # The function is declared 'noexcept' but calls function '...' which may
+                                           # throw exceptions
     zmq_check_cxx_flag_prepend("/wd26433") # Function '...' should be marked with 'override'
     zmq_check_cxx_flag_prepend("/wd26409") # Avoid calling new and delete explicitly, use std::make_unique<T> instead
     # Requires GSL
     zmq_check_cxx_flag_prepend("/wd26429") # Symbol '...' is never tested for nullness, it can be marked as not_null
     zmq_check_cxx_flag_prepend("/wd26446") # Prefer to use gsl::at()
     zmq_check_cxx_flag_prepend("/wd26481") # Don't use pointer arithmetic. Use span instead
-    zmq_check_cxx_flag_prepend("/wd26472") # Don't use a static_cast for arithmetic conversions. Use brace initialization, gsl::narrow_cast or gsl::narow
+    zmq_check_cxx_flag_prepend("/wd26472") # Don't use a static_cast for arithmetic conversions. Use brace
+                                           # initialization, gsl::narrow_cast or gsl::narow
     zmq_check_cxx_flag_prepend("/wd26448") # Consider using gsl::finally if final action is intended
-    zmq_check_cxx_flag_prepend("/wd26400") # Do not assign the result of an allocation or a function call with an owner<T> return value to a raw pointer, use owner<T> instead
+    zmq_check_cxx_flag_prepend("/wd26400") # Do not assign the result of an allocation or a function call with an
+                                           # owner<T> return value to a raw pointer, use owner<T> instead
     zmq_check_cxx_flag_prepend("/wd26485") # Expression '...': No array to pointer decay(bounds.3)
   else()
     zmq_check_cxx_flag_prepend("/W3")
@@ -490,10 +691,12 @@ if(${CMAKE_CXX_COMPILER_ID} MATCHES "Sun
   zmq_check_cxx_flag_prepend("-features=zla")
 endif()
 
-if(CMAKE_SYSTEM_NAME MATCHES "SunOS" OR CMAKE_SYSTEM_NAME MATCHES "NetBSD" OR CMAKE_SYSTEM_NAME MATCHES "QNX")
+if(CMAKE_SYSTEM_NAME MATCHES "SunOS"
+   OR CMAKE_SYSTEM_NAME MATCHES "NetBSD"
+   OR CMAKE_SYSTEM_NAME MATCHES "QNX")
   message(STATUS "Checking whether atomic operations can be used")
   check_c_source_compiles(
-  "\
+    "\
   #include <atomic.h> \
   \
   int main() \
@@ -503,7 +706,7 @@ if(CMAKE_SYSTEM_NAME MATCHES "SunOS" OR
     return 0; \
   } \
   "
-  HAVE_ATOMIC_H)
+    HAVE_ATOMIC_H)
 
   if(NOT HAVE_ATOMIC_H)
     set(ZMQ_FORCE_MUTEXES 1)
@@ -511,10 +714,10 @@ if(CMAKE_SYSTEM_NAME MATCHES "SunOS" OR
 endif()
 
 if(NOT ANDROID)
-    zmq_check_noexcept()
+  zmq_check_noexcept()
 endif()
 
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 if(NOT CMAKE_CROSSCOMPILING AND NOT MSVC)
   zmq_check_sock_cloexec()
   zmq_check_o_cloexec()
@@ -531,9 +734,9 @@ if(NOT CMAKE_CROSSCOMPILING AND NOT MSVC
 endif()
 
 if(CMAKE_SYSTEM_NAME MATCHES "Linux"
-  OR CMAKE_SYSTEM_NAME MATCHES "GNU/kFreeBSD"
-  OR CMAKE_SYSTEM_NAME MATCHES "GNU/Hurd"
-  OR CYGWIN)
+   OR CMAKE_SYSTEM_NAME MATCHES "GNU/kFreeBSD"
+   OR CMAKE_SYSTEM_NAME MATCHES "GNU/Hurd"
+   OR CYGWIN)
   add_definitions(-D_GNU_SOURCE)
 elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
   add_definitions(-D__BSD_VISIBLE)
@@ -552,24 +755,26 @@ endif()
 
 find_package(AsciiDoc)
 
-cmake_dependent_option(WITH_DOC "Build Reference Guide documentation(requires DocBook)" ON
-  "ASCIIDOC_FOUND;NOT WIN32" OFF)  # Do not build docs on Windows due to issues with symlinks
+cmake_dependent_option(WITH_DOC "Build Reference Guide documentation(requires DocBook)" ON "ASCIIDOC_FOUND;NOT WIN32"
+                       OFF) # Do not build docs on Windows due to issues with symlinks
 
 if(MSVC)
   if(WITH_OPENPGM)
-    #set(OPENPGM_ROOT "" CACHE PATH "Location of OpenPGM")
+    # set(OPENPGM_ROOT "" CACHE PATH "Location of OpenPGM")
     set(OPENPGM_VERSION_MAJOR 5)
     set(OPENPGM_VERSION_MINOR 2)
     set(OPENPGM_VERSION_MICRO 122)
     if(CMAKE_CL_64)
-      find_path(OPENPGM_ROOT include/pgm/pgm.h
-          PATHS
+      find_path(
+        OPENPGM_ROOT include/pgm/pgm.h
+        PATHS
           "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
-          NO_DEFAULT_PATH)
+        NO_DEFAULT_PATH)
       message(STATUS "OpenPGM x64 detected - ${OPENPGM_ROOT}")
     else()
-      find_path(OPENPGM_ROOT include/pgm/pgm.h
-          PATHS
+      find_path(
+        OPENPGM_ROOT include/pgm/pgm.h
+        PATHS
           "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Wow6432Node\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
           "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
           NO_DEFAULT_PATH)
@@ -578,30 +783,32 @@ if(MSVC)
     set(OPENPGM_INCLUDE_DIRS ${OPENPGM_ROOT}/include)
     set(OPENPGM_LIBRARY_DIRS ${OPENPGM_ROOT}/lib)
     set(OPENPGM_LIBRARIES
-      optimized libpgm${MSVC_TOOLSET}-mt-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.lib
-      debug libpgm${MSVC_TOOLSET}-mt-gd-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.lib)
+        optimized
+        libpgm${MSVC_TOOLSET}-mt-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.lib debug
+        libpgm${MSVC_TOOLSET}-mt-gd-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.lib)
   endif()
 else()
   if(WITH_OPENPGM)
-    #  message(FATAL_ERROR "WITH_OPENPGM not implemented")
+    # message(FATAL_ERROR "WITH_OPENPGM not implemented")
 
     if(NOT OPENPGM_PKGCONFIG_NAME)
       set(OPENPGM_PKGCONFIG_NAME "openpgm-5.2")
     endif()
 
-    set(OPENPGM_PKGCONFIG_NAME ${OPENPGM_PKGCONFIG_NAME} CACHE STRING
-      "Name pkg-config shall use to find openpgm libraries and include paths"
-      FORCE)
+    set(OPENPGM_PKGCONFIG_NAME
+        ${OPENPGM_PKGCONFIG_NAME}
+        CACHE STRING "Name pkg-config shall use to find openpgm libraries and include paths" FORCE)
 
-    find_package(PkgConfig)
-    pkg_check_modules(OPENPGM  ${OPENPGM_PKGCONFIG_NAME})
+    pkg_check_modules(OPENPGM ${OPENPGM_PKGCONFIG_NAME})
 
     if(OPENPGM_FOUND)
       message(STATUS ${OPENPGM_PKGCONFIG_NAME}" found")
       set(pkg_config_names_private "${pkg_config_names_private} ${OPENPGM_PKGCONFIG_NAME}")
     else()
-      message(FATAL_ERROR
-        ${OPENPGM_PKGCONFIG_NAME}"  not found. openpgm is searchd via `pkg-config ${OPENPGM_PKGCONFIG_NAME}`. Consider providing a valid OPENPGM_PKGCONFIG_NAME")
+      message(
+        FATAL_ERROR
+          ${OPENPGM_PKGCONFIG_NAME}"  not found. openpgm is searchd via `pkg-config ${OPENPGM_PKGCONFIG_NAME}`. Consider providing a valid OPENPGM_PKGCONFIG_NAME"
+      )
     endif()
 
     # DSO symbol visibility for openpgm
@@ -613,12 +820,13 @@ else()
   endif()
 endif()
 
-
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 # force off-tree build
 
 if(${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_BINARY_DIR})
-  message(FATAL_ERROR "CMake generation is not allowed within the source directory! \
+  message(
+    FATAL_ERROR
+      "CMake generation is not allowed within the source directory! \
     Remove the CMakeCache.txt file and try again from another folder, e.g.: \
     \
       rm CMakeCache.txt \
@@ -627,18 +835,18 @@ if(${CMAKE_CURRENT_SOURCE_DIR} STREQUAL
       cmake ..")
 endif()
 
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 # default to Release build
 
 if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
-  # CMAKE_BUILD_TYPE is not used for multi-configuration generators like Visual Studio/XCode
-  # which instead use CMAKE_CONFIGURATION_TYPES
-  set(CMAKE_BUILD_TYPE Release CACHE STRING
-    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
-    FORCE)
+  # CMAKE_BUILD_TYPE is not used for multi-configuration generators like Visual Studio/XCode which instead use
+  # CMAKE_CONFIGURATION_TYPES
+  set(CMAKE_BUILD_TYPE
+      Release
+      CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
 endif()
 
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 # output directories
 
 zmq_set_with_default(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${ZeroMQ_BINARY_DIR}/bin")
@@ -650,7 +858,7 @@ endif()
 zmq_set_with_default(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${ZeroMQ_BINARY_DIR}/${zmq_library_directory}")
 zmq_set_with_default(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${ZeroMQ_BINARY_DIR}/lib")
 
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 # platform specifics
 
 if(WIN32)
@@ -665,13 +873,12 @@ if(MSVC)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP")
 
-  # Compile the static lib with debug information included
-  # note: we assume here that the default flags contain some /Z flag
-  string(REGEX REPLACE "/Z." "/Z7" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
-  string(REGEX REPLACE "/Z." "/Z7" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
+  # Compile the static lib with debug information included note: we assume here that the default flags contain some /Z
+  # flag
+  string(REGEX REPLACE "/Z.[^:]" "/Z7 " CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
+  string(REGEX REPLACE "/Z.[^:]" "/Z7 " CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
 
-  # Optimization flags.
-  # http://msdn.microsoft.com/en-us/magazine/cc301698.aspx
+  # Optimization flags. http://msdn.microsoft.com/en-us/magazine/cc301698.aspx
   if(NOT ${CMAKE_BUILD_TYPE} MATCHES "Debug")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GL")
     set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /LTCG")
@@ -680,244 +887,254 @@ if(MSVC)
   endif()
 endif()
 
-
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 # source files
 
 set(cxx-sources
-  precompiled.cpp
-  address.cpp
-  client.cpp
-  clock.cpp
-  ctx.cpp
-  curve_mechanism_base.cpp
-  curve_client.cpp
-  curve_server.cpp
-  dealer.cpp
-  devpoll.cpp
-  dgram.cpp
-  dist.cpp
-  endpoint.cpp
-  epoll.cpp
-  err.cpp
-  fq.cpp
-  io_object.cpp
-  io_thread.cpp
-  ip.cpp
-  ipc_address.cpp
-  ipc_connecter.cpp
-  ipc_listener.cpp
-  kqueue.cpp
-  lb.cpp
-  mailbox.cpp
-  mailbox_safe.cpp
-  mechanism.cpp
-  mechanism_base.cpp
-  metadata.cpp
-  msg.cpp
-  mtrie.cpp
-  norm_engine.cpp
-  object.cpp
-  options.cpp
-  own.cpp
-  null_mechanism.cpp
-  pair.cpp
-  pgm_receiver.cpp
-  pgm_sender.cpp
-  pgm_socket.cpp
-  pipe.cpp
-  plain_client.cpp
-  plain_server.cpp
-  poll.cpp
-  poller_base.cpp
-  polling_util.cpp
-  pollset.cpp
-  proxy.cpp
-  pub.cpp
-  pull.cpp
-  push.cpp
-  random.cpp
-  raw_encoder.cpp
-  raw_decoder.cpp
-  reaper.cpp
-  rep.cpp
-  req.cpp
-  router.cpp
-  select.cpp
-  server.cpp
-  session_base.cpp
-  signaler.cpp
-  socket_base.cpp
-  socks.cpp
-  socks_connecter.cpp
-  stream.cpp
-  stream_engine.cpp
-  sub.cpp
-  tcp.cpp
-  tcp_address.cpp
-  tcp_connecter.cpp
-  tcp_listener.cpp
-  thread.cpp
-  trie.cpp
-  radix_tree.cpp
-  v1_decoder.cpp
-  v1_encoder.cpp
-  v2_decoder.cpp
-  v2_encoder.cpp
-  xpub.cpp
-  xsub.cpp
-  zmq.cpp
-  zmq_utils.cpp
-  decoder_allocators.cpp
-  socket_poller.cpp
-  timers.cpp
-  config.hpp
-  radio.cpp
-  dish.cpp
-  udp_engine.cpp
-  udp_address.cpp
-  scatter.cpp
-  gather.cpp
-  ip_resolver.cpp
-  zap_client.cpp
-  # at least for VS, the header files must also be listed
-  address.hpp
-  array.hpp
-  atomic_counter.hpp
-  atomic_ptr.hpp
-  blob.hpp
-  client.hpp
-  clock.hpp
-  command.hpp
-  condition_variable.hpp
-  config.hpp
-  ctx.hpp
-  curve_client.hpp
-  curve_client_tools.hpp
-  curve_mechanism_base.hpp
-  curve_server.hpp
-  dbuffer.hpp
-  dealer.hpp
-  decoder.hpp
-  decoder_allocators.hpp
-  devpoll.hpp
-  dgram.hpp
-  dish.hpp
-  dist.hpp
-  encoder.hpp
-  endpoint.hpp
-  epoll.hpp
-  err.hpp
-  fd.hpp
-  fq.hpp
-  gather.hpp
-  generic_mtrie.hpp
-  generic_mtrie_impl.hpp
-  gssapi_client.hpp
-  gssapi_mechanism_base.hpp
-  gssapi_server.hpp
-  i_decoder.hpp
-  i_encoder.hpp
-  i_engine.hpp
-  i_mailbox.hpp
-  i_poll_events.hpp
-  io_object.hpp
-  io_thread.hpp
-  ip.hpp
-  ipc_address.hpp
-  ipc_connecter.hpp
-  ipc_listener.hpp
-  kqueue.hpp
-  lb.hpp
-  likely.hpp
-  macros.hpp
-  mailbox.hpp
-  mailbox_safe.hpp
-  mechanism.hpp
-  mechanism_base.hpp
-  metadata.hpp
-  msg.hpp
-  mtrie.hpp
-  mutex.hpp
-  norm_engine.hpp
-  null_mechanism.hpp
-  object.hpp
-  options.hpp
-  own.hpp
-  pair.hpp
-  pgm_receiver.hpp
-  pgm_sender.hpp
-  pgm_socket.hpp
-  pipe.hpp
-  plain_client.hpp
-  plain_common.hpp
-  plain_server.hpp
-  poll.hpp
-  poller.hpp
-  poller_base.hpp
-  polling_util.hpp
-  pollset.hpp
-  precompiled.hpp
-  proxy.hpp
-  pub.hpp
-  pull.hpp
-  push.hpp
-  radio.hpp
-  random.hpp
-  raw_decoder.hpp
-  raw_encoder.hpp
-  reaper.hpp
-  rep.hpp
-  req.hpp
-  router.hpp
-  scatter.hpp
-  select.hpp
-  server.hpp
-  session_base.hpp
-  signaler.hpp
-  socket_base.hpp
-  socket_poller.hpp
-  socks.hpp
-  socks_connecter.hpp
-  stdint.hpp
-  stream.hpp
-  stream_engine.hpp
-  stream_connecter_base.hpp
-  stream_connecter_base.cpp
-  stream_listener_base.hpp
-  stream_listener_base.cpp
-  sub.hpp
-  tcp.hpp
-  tcp_address.hpp
-  tcp_connecter.hpp
-  tcp_listener.hpp
-  thread.hpp
-  timers.hpp
-  tipc_address.hpp
-  tipc_connecter.hpp
-  tipc_listener.hpp
-  trie.hpp
-  udp_address.hpp
-  udp_engine.hpp
-  v1_decoder.hpp
-  v1_encoder.hpp
-  v2_decoder.hpp
-  v2_encoder.hpp
-  v2_protocol.hpp
-  vmci.hpp
-  vmci_address.hpp
-  vmci_connecter.hpp
-  vmci_listener.hpp
-  windows.hpp
-  wire.hpp
-  xpub.hpp
-  xsub.hpp
-  ypipe.hpp
-  ypipe_base.hpp
-  ypipe_conflate.hpp
-  yqueue.hpp
-  zap_client.hpp
-)
+    precompiled.cpp
+    address.cpp
+    channel.cpp
+    client.cpp
+    clock.cpp
+    ctx.cpp
+    curve_mechanism_base.cpp
+    curve_client.cpp
+    curve_server.cpp
+    dealer.cpp
+    devpoll.cpp
+    dgram.cpp
+    dist.cpp
+    endpoint.cpp
+    epoll.cpp
+    err.cpp
+    fq.cpp
+    io_object.cpp
+    io_thread.cpp
+    ip.cpp
+    ipc_address.cpp
+    ipc_connecter.cpp
+    ipc_listener.cpp
+    kqueue.cpp
+    lb.cpp
+    mailbox.cpp
+    mailbox_safe.cpp
+    mechanism.cpp
+    mechanism_base.cpp
+    metadata.cpp
+    msg.cpp
+    mtrie.cpp
+    norm_engine.cpp
+    object.cpp
+    options.cpp
+    own.cpp
+    null_mechanism.cpp
+    pair.cpp
+    peer.cpp
+    pgm_receiver.cpp
+    pgm_sender.cpp
+    pgm_socket.cpp
+    pipe.cpp
+    plain_client.cpp
+    plain_server.cpp
+    poll.cpp
+    poller_base.cpp
+    polling_util.cpp
+    pollset.cpp
+    proxy.cpp
+    pub.cpp
+    pull.cpp
+    push.cpp
+    random.cpp
+    raw_encoder.cpp
+    raw_decoder.cpp
+    raw_engine.cpp
+    reaper.cpp
+    rep.cpp
+    req.cpp
+    router.cpp
+    select.cpp
+    server.cpp
+    session_base.cpp
+    signaler.cpp
+    socket_base.cpp
+    socks.cpp
+    socks_connecter.cpp
+    stream.cpp
+    stream_engine_base.cpp
+    sub.cpp
+    tcp.cpp
+    tcp_address.cpp
+    tcp_connecter.cpp
+    tcp_listener.cpp
+    thread.cpp
+    trie.cpp
+    radix_tree.cpp
+    v1_decoder.cpp
+    v1_encoder.cpp
+    v2_decoder.cpp
+    v2_encoder.cpp
+    v3_1_encoder.cpp
+    xpub.cpp
+    xsub.cpp
+    zmq.cpp
+    zmq_utils.cpp
+    decoder_allocators.cpp
+    socket_poller.cpp
+    timers.cpp
+    config.hpp
+    radio.cpp
+    dish.cpp
+    udp_engine.cpp
+    udp_address.cpp
+    scatter.cpp
+    gather.cpp
+    ip_resolver.cpp
+    zap_client.cpp
+    zmtp_engine.cpp
+    # at least for VS, the header files must also be listed
+    address.hpp
+    array.hpp
+    atomic_counter.hpp
+    atomic_ptr.hpp
+    blob.hpp
+    channel.hpp
+    client.hpp
+    clock.hpp
+    command.hpp
+    compat.hpp
+    condition_variable.hpp
+    config.hpp
+    ctx.hpp
+    curve_client.hpp
+    curve_client_tools.hpp
+    curve_mechanism_base.hpp
+    curve_server.hpp
+    dbuffer.hpp
+    dealer.hpp
+    decoder.hpp
+    decoder_allocators.hpp
+    devpoll.hpp
+    dgram.hpp
+    dish.hpp
+    dist.hpp
+    encoder.hpp
+    endpoint.hpp
+    epoll.hpp
+    err.hpp
+    fd.hpp
+    fq.hpp
+    gather.hpp
+    generic_mtrie.hpp
+    generic_mtrie_impl.hpp
+    gssapi_client.hpp
+    gssapi_mechanism_base.hpp
+    gssapi_server.hpp
+    i_decoder.hpp
+    i_encoder.hpp
+    i_engine.hpp
+    i_mailbox.hpp
+    i_poll_events.hpp
+    io_object.hpp
+    io_thread.hpp
+    ip.hpp
+    ipc_address.hpp
+    ipc_connecter.hpp
+    ipc_listener.hpp
+    kqueue.hpp
+    lb.hpp
+    likely.hpp
+    macros.hpp
+    mailbox.hpp
+    mailbox_safe.hpp
+    mechanism.hpp
+    mechanism_base.hpp
+    metadata.hpp
+    msg.hpp
+    mtrie.hpp
+    mutex.hpp
+    norm_engine.hpp
+    null_mechanism.hpp
+    object.hpp
+    options.hpp
+    own.hpp
+    pair.hpp
+    peer.hpp
+    pgm_receiver.hpp
+    pgm_sender.hpp
+    pgm_socket.hpp
+    pipe.hpp
+    plain_client.hpp
+    plain_common.hpp
+    plain_server.hpp
+    poll.hpp
+    poller.hpp
+    poller_base.hpp
+    polling_util.hpp
+    pollset.hpp
+    precompiled.hpp
+    proxy.hpp
+    pub.hpp
+    pull.hpp
+    push.hpp
+    radio.hpp
+    random.hpp
+    raw_decoder.hpp
+    raw_encoder.hpp
+    raw_engine.hpp
+    reaper.hpp
+    rep.hpp
+    req.hpp
+    router.hpp
+    scatter.hpp
+    secure_allocator.hpp
+    select.hpp
+    server.hpp
+    session_base.hpp
+    signaler.hpp
+    socket_base.hpp
+    socket_poller.hpp
+    socks.hpp
+    socks_connecter.hpp
+    stdint.hpp
+    stream.hpp
+    stream_engine_base.hpp
+    stream_connecter_base.hpp
+    stream_connecter_base.cpp
+    stream_listener_base.hpp
+    stream_listener_base.cpp
+    sub.hpp
+    tcp.hpp
+    tcp_address.hpp
+    tcp_connecter.hpp
+    tcp_listener.hpp
+    thread.hpp
+    timers.hpp
+    tipc_address.hpp
+    tipc_connecter.hpp
+    tipc_listener.hpp
+    trie.hpp
+    udp_address.hpp
+    udp_engine.hpp
+    v1_decoder.hpp
+    v1_encoder.hpp
+    v2_decoder.hpp
+    v2_encoder.hpp
+    v3_1_encoder.hpp
+    v2_protocol.hpp
+    vmci.hpp
+    vmci_address.hpp
+    vmci_connecter.hpp
+    vmci_listener.hpp
+    windows.hpp
+    wire.hpp
+    xpub.hpp
+    xsub.hpp
+    ypipe.hpp
+    ypipe_base.hpp
+    ypipe_conflate.hpp
+    yqueue.hpp
+    zap_client.hpp
+    zmtp_engine.hpp)
 
 if(MINGW)
   # Generate the right type when using -m32 or -m64
@@ -925,7 +1142,7 @@ if(MINGW)
     set(CMAKE_RC_COMPILER_INIT windres)
     enable_language(RC)
     set(CMAKE_RC_COMPILE_OBJECT
-      "<CMAKE_RC_COMPILER> <FLAGS> -O coff --target=${rc_target} <DEFINES> -i <SOURCE> -o <OBJECT>")
+        "<CMAKE_RC_COMPILER> <FLAGS> -O coff --target=${rc_target} <DEFINES> -i <SOURCE> -o <OBJECT>")
   endmacro()
 
   if(NOT CMAKE_SYSTEM_PROCESSOR)
@@ -934,12 +1151,12 @@ if(MINGW)
 
   # Also happens on x86_64 systems...what a worthless variable
   if(CMAKE_SYSTEM_PROCESSOR MATCHES "i386"
-    OR CMAKE_SYSTEM_PROCESSOR MATCHES "i486"
-    OR CMAKE_SYSTEM_PROCESSOR MATCHES "i586"
-    OR CMAKE_SYSTEM_PROCESSOR MATCHES "i686"
-    OR CMAKE_SYSTEM_PROCESSOR MATCHES "x86"
-    OR CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64"
-    OR CMAKE_SYSTEM_PROCESSOR MATCHES "amd64")
+     OR CMAKE_SYSTEM_PROCESSOR MATCHES "i486"
+     OR CMAKE_SYSTEM_PROCESSOR MATCHES "i586"
+     OR CMAKE_SYSTEM_PROCESSOR MATCHES "i686"
+     OR CMAKE_SYSTEM_PROCESSOR MATCHES "x86"
+     OR CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64"
+     OR CMAKE_SYSTEM_PROCESSOR MATCHES "amd64")
 
     if(CMAKE_SIZEOF_VOID_P EQUAL 8)
       set_rc_arch("pe-x86-64")
@@ -949,17 +1166,11 @@ if(MINGW)
   endif()
 endif()
 
-set(public_headers
-  include/zmq.h
-  include/zmq_utils.h)
-
-set(readme-docs
-  AUTHORS
-  COPYING
-  COPYING.LESSER
-  NEWS)
+set(public_headers include/zmq.h include/zmq_utils.h)
+
+set(readme-docs AUTHORS COPYING COPYING.LESSER NEWS)
 
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 # optional modules
 
 if(WITH_OPENPGM)
@@ -969,6 +1180,16 @@ if(WITH_OPENPGM)
   set(OPTIONAL_LIBRARIES ${OPENPGM_LIBRARIES})
 endif()
 
+if(WITH_NORM)
+  find_package(norm)
+    if(norm_FOUND)
+      message(STATUS "Building with NORM")
+      set(ZMQ_HAVE_NORM 1)
+    else()
+      message(FATAL_ERROR "NORM not found")
+    endif()
+endif()
+
 if(WITH_VMCI)
   add_definitions(-DZMQ_HAVE_VMCI)
   include_directories(${VMCI_INCLUDE_DIRS})
@@ -976,11 +1197,10 @@ if(WITH_VMCI)
 endif()
 
 if(ZMQ_HAVE_TIPC)
-  add_definitions(-DZMQ_HAVE_TIPC)
   list(APPEND cxx-sources tipc_address.cpp tipc_connecter.cpp tipc_listener.cpp)
 endif()
 
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 # source generators
 
 foreach(source ${cxx-sources})
@@ -989,7 +1209,7 @@ endforeach()
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
 
-#   Delete any src/platform.hpp left by configure
+# Delete any src/platform.hpp left by configure
 file(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/src/platform.hpp)
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/builds/cmake/platform.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/platform.hpp)
@@ -1016,18 +1236,17 @@ if(MSVC)
 
   add_custom_command(
     OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/NSIS.template.in
-    COMMAND ${CMAKE_COMMAND}
-    ARGS -E
-    copy
-    ${nsis-template}
-    ${CMAKE_CURRENT_BINARY_DIR}/NSIS.template.in
+    COMMAND ${CMAKE_COMMAND} ARGS -E copy ${nsis-template} ${CMAKE_CURRENT_BINARY_DIR}/NSIS.template.in
     DEPENDS ${nsis-template})
 endif()
 
-option (WITH_DOCS "Build html docs" ON)
-if (WITH_DOCS)
+option(WITH_DOCS "Build html docs" ON)
+if(WITH_DOCS)
   file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc)
-  file(GLOB docs RELATIVE ${CMAKE_CURRENT_BINARY_DIR}/ "${CMAKE_CURRENT_SOURCE_DIR}/doc/*.txt")
+  file(
+    GLOB docs
+    RELATIVE ${CMAKE_CURRENT_BINARY_DIR}/
+    "${CMAKE_CURRENT_SOURCE_DIR}/doc/*.txt")
   set(html-docs)
   foreach(txt ${docs})
     string(REGEX REPLACE ".*/(.*)\\.txt" "\\1.html" html ${txt})
@@ -1035,14 +1254,9 @@ if (WITH_DOCS)
     set(dst doc/${html})
     if(WITH_DOC)
       add_custom_command(
-        OUTPUT  ${dst}
-        COMMAND ${ASCIIDOC_EXECUTABLE}
-        -d manpage
-        -b xhtml11
-        -f ${CMAKE_CURRENT_SOURCE_DIR}/doc/asciidoc.conf
-        -azmq_version=${ZMQ_VERSION}
-        -o ${dst}
-        ${src}
+        OUTPUT ${dst}
+        COMMAND ${ASCIIDOC_EXECUTABLE} -d manpage -b xhtml11 -f ${CMAKE_CURRENT_SOURCE_DIR}/doc/asciidoc.conf
+                -azmq_version=${ZMQ_VERSION} -o ${dst} ${src}
         DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${src}
         WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
         COMMENT "Generating ${html}")
@@ -1053,161 +1267,165 @@ endif()
 
 if(ZMQ_BUILD_FRAMEWORK)
   add_custom_command(
-  TARGET libzmq
-  POST_BUILD
-  COMMAND ${CMAKE_COMMAND}
-  ARGS -E make_directory "${CMAKE_LIBRARY_OUTPUT_PATH}/ZeroMQ.framework/Versions/${ZMQ_VERSION}/MacOS"
-  COMMENT "Perf tools")
+    TARGET libzmq
+    POST_BUILD
+    COMMAND ${CMAKE_COMMAND} ARGS -E make_directory
+            "${CMAKE_LIBRARY_OUTPUT_PATH}/ZeroMQ.framework/Versions/${ZMQ_VERSION}/MacOS"
+    COMMENT "Perf tools")
 endif()
 
-if(MSVC)
+option(ENABLE_PRECOMPILED "Enable precompiled headers, if possible" ON)
+if(MSVC AND ENABLE_PRECOMPILED)
   # default for all sources is to use precompiled headers
   foreach(source ${sources})
     # C and C++ can not use the same precompiled header
     if(${source} MATCHES ".cpp$" AND NOT ${source} STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}/src/precompiled.cpp")
-      set_source_files_properties(${source}
-        PROPERTIES
-        COMPILE_FLAGS "/Yuprecompiled.hpp"
-        OBJECT_DEPENDS precompiled.hpp)
+      set_source_files_properties(${source} PROPERTIES COMPILE_FLAGS "/Yuprecompiled.hpp" OBJECT_DEPENDS
+                                                                                          precompiled.hpp)
     endif()
   endforeach()
   # create precompiled header
   set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/src/precompiled.cpp
-    PROPERTIES
-    COMPILE_FLAGS "/Ycprecompiled.hpp"
-    OBJECT_OUTPUTS precompiled.hpp)
+                              PROPERTIES COMPILE_FLAGS "/Ycprecompiled.hpp" OBJECT_OUTPUTS precompiled.hpp)
 endif()
 
-
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 # output
-option(BUILD_SHARED "Whether or not to build the shared object"  ON)
+option(BUILD_SHARED "Whether or not to build the shared object" ON)
 option(BUILD_STATIC "Whether or not to build the static archive" ON)
 
-list(APPEND target_outputs "")
-
-if(BUILD_SHARED)
-  list(APPEND target_outputs "libzmq")
-endif()
-
-if(BUILD_STATIC)
-  list(APPEND target_outputs "libzmq-static")
-endif()
-
 if(MSVC)
-  # Suppress linker warnings caused by #ifdef omission
-  # of file content.
+  # Suppress linker warnings caused by #ifdef omission of file content.
   set(CMAKE_STATIC_LINKER_FLAGS "${CMAKE_STATIC_LINKER_FLAGS} /ignore:4221")
   set(PDB_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
-  set(PDB_NAME "libzmq${MSVC_TOOLSET}-mt-gd-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}")
+  set(PDB_NAME
+      "lib${ZMQ_OUTPUT_BASENAME}${MSVC_TOOLSET}-mt-gd-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}")
   function(enable_vs_guideline_checker target)
-    set_target_properties(${target} PROPERTIES
-      VS_GLOBAL_EnableCppCoreCheck true
-      VS_GLOBAL_CodeAnalysisRuleSet CppCoreCheckRules.ruleset
-      VS_GLOBAL_RunCodeAnalysis true)
+    set_target_properties(
+      ${target} PROPERTIES VS_GLOBAL_EnableCppCoreCheck true VS_GLOBAL_CodeAnalysisRuleSet CppCoreCheckRules.ruleset
+                           VS_GLOBAL_RunCodeAnalysis true)
   endfunction()
   if(BUILD_SHARED)
-    add_library(libzmq SHARED ${sources} ${public_headers} ${html-docs} ${readme-docs} ${CMAKE_CURRENT_BINARY_DIR}/NSIS.template.in ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
+    add_library(libzmq SHARED ${sources} ${public_headers} ${html-docs} ${readme-docs}
+                              ${CMAKE_CURRENT_BINARY_DIR}/NSIS.template.in ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
     if(ENABLE_ANALYSIS)
       enable_vs_guideline_checker(libzmq)
     endif()
-    set_target_properties(libzmq PROPERTIES
-      PUBLIC_HEADER "${public_headers}"
-      RELEASE_POSTFIX "${MSVC_TOOLSET}-mt-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
-      RELWITHDEBINFO_POSTFIX "${MSVC_TOOLSET}-mt-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
-      MINSIZEREL_POSTFIX "${MSVC_TOOLSET}-mt-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
-      DEBUG_POSTFIX "${MSVC_TOOLSET}-mt-gd-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
-      RUNTIME_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
-      COMPILE_DEFINITIONS "DLL_EXPORT"
-      OUTPUT_NAME "libzmq")
+    set_target_properties(
+      libzmq
+      PROPERTIES PUBLIC_HEADER "${public_headers}"
+                 RELEASE_POSTFIX "${MSVC_TOOLSET}-mt-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
+                 RELWITHDEBINFO_POSTFIX
+                 "${MSVC_TOOLSET}-mt-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
+                 MINSIZEREL_POSTFIX "${MSVC_TOOLSET}-mt-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
+                 DEBUG_POSTFIX "${MSVC_TOOLSET}-mt-gd-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
+                 RUNTIME_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
+                 COMPILE_DEFINITIONS "DLL_EXPORT"
+                 OUTPUT_NAME "lib${ZMQ_OUTPUT_BASENAME}")
+    if(ZMQ_HAVE_WINDOWS_UWP)
+      set_target_properties(libzmq PROPERTIES LINK_FLAGS_DEBUG "/OPT:NOICF /OPT:NOREF")
+    endif()
   endif()
 
   if(BUILD_STATIC)
     add_library(libzmq-static STATIC ${sources} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
-    set_target_properties(libzmq-static PROPERTIES
-      PUBLIC_HEADER "${public_headers}"
-      RELEASE_POSTFIX "${MSVC_TOOLSET}-mt-s-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
-      RELWITHDEBINFO_POSTFIX "${MSVC_TOOLSET}-mt-s-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
-      MINSIZEREL_POSTFIX "${MSVC_TOOLSET}-mt-s-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
-      DEBUG_POSTFIX "${MSVC_TOOLSET}-mt-sgd-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
-      COMPILE_FLAGS "/DZMQ_STATIC"
-      OUTPUT_NAME "libzmq")
+    set_target_properties(
+      libzmq-static
+      PROPERTIES PUBLIC_HEADER "${public_headers}"
+                 RELEASE_POSTFIX "${MSVC_TOOLSET}-mt-s-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
+                 RELWITHDEBINFO_POSTFIX
+                 "${MSVC_TOOLSET}-mt-s-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
+                 MINSIZEREL_POSTFIX
+                 "${MSVC_TOOLSET}-mt-s-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
+                 DEBUG_POSTFIX "${MSVC_TOOLSET}-mt-sgd-${ZMQ_VERSION_MAJOR}_${ZMQ_VERSION_MINOR}_${ZMQ_VERSION_PATCH}"
+                 COMPILE_FLAGS "/DZMQ_STATIC"
+                 OUTPUT_NAME "lib${ZMQ_OUTPUT_BASENAME}")
   endif()
 else()
-  # avoid building everything twice for shared + static
-  # only on *nix, as Windows needs different preprocessor defines in static builds
+  # avoid building everything twice for shared + static only on *nix, as Windows needs different preprocessor defines in
+  # static builds
   if(NOT MINGW)
     add_library(objects OBJECT ${sources})
     set_property(TARGET objects PROPERTY POSITION_INDEPENDENT_CODE ON)
-    target_include_directories(objects
-      PUBLIC
-      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-      $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
-      $<INSTALL_INTERFACE:include>)
+    target_include_directories(
+      objects PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+                     $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}> $<INSTALL_INTERFACE:include>)
   endif()
 
   if(BUILD_SHARED)
     if(MINGW)
-      add_library(libzmq SHARED ${sources} ${public_headers} ${html-docs} ${readme-docs} ${zmq-pkgconfig} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
+      add_library(libzmq SHARED ${sources} ${public_headers} ${html-docs} ${readme-docs} ${zmq-pkgconfig}
+                                ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
     else()
-      add_library(libzmq SHARED $<TARGET_OBJECTS:objects> ${public_headers} ${html-docs} ${readme-docs} ${zmq-pkgconfig} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
+      add_library(libzmq SHARED $<TARGET_OBJECTS:objects> ${public_headers} ${html-docs} ${readme-docs}
+                                ${zmq-pkgconfig} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
     endif()
-    # NOTE: the SOVERSION and VERSION MUST be the same as the one generated by libtool! It is NOT the same as the version of the package.
-    set_target_properties(libzmq PROPERTIES
-      COMPILE_DEFINITIONS "DLL_EXPORT"
-      PUBLIC_HEADER "${public_headers}"
-      VERSION "5.2.2"
-      SOVERSION "5"
-      OUTPUT_NAME "zmq"
-      PREFIX "lib")
+    # NOTE: the SOVERSION and VERSION MUST be the same as the one generated by libtool! It is NOT the same as the
+    # version of the package.
+    set_target_properties(
+      libzmq PROPERTIES COMPILE_DEFINITIONS "DLL_EXPORT" PUBLIC_HEADER "${public_headers}" VERSION "5.2.3"
+                        SOVERSION "5" OUTPUT_NAME "${ZMQ_OUTPUT_BASENAME}" PREFIX "lib")
     if(ZMQ_BUILD_FRAMEWORK)
-      set_target_properties(libzmq PROPERTIES
-        FRAMEWORK TRUE
-        MACOSX_FRAMEWORK_IDENTIFIER "org.zeromq.libzmq"
-        MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${ZMQ_VERSION}
-        MACOSX_FRAMEWORK_BUNDLE_VERSION ${ZMQ_VERSION})
-      set_source_files_properties(${html-docs} PROPERTIES
-        MACOSX_PACKAGE_LOCATION doc)
-      set_source_files_properties(${readme-docs} PROPERTIES
-        MACOSX_PACKAGE_LOCATION etc)
-      set_source_files_properties(${zmq-pkgconfig} PROPERTIES
-        MACOSX_PACKAGE_LOCATION lib/pkgconfig)
+      set_target_properties(
+        libzmq
+        PROPERTIES FRAMEWORK TRUE MACOSX_FRAMEWORK_IDENTIFIER "org.zeromq.libzmq" MACOSX_FRAMEWORK_SHORT_VERSION_STRING
+                                                                                  ${ZMQ_VERSION}
+                   MACOSX_FRAMEWORK_BUNDLE_VERSION ${ZMQ_VERSION})
+      set_source_files_properties(${html-docs} PROPERTIES MACOSX_PACKAGE_LOCATION doc)
+      set_source_files_properties(${readme-docs} PROPERTIES MACOSX_PACKAGE_LOCATION etc)
+      set_source_files_properties(${zmq-pkgconfig} PROPERTIES MACOSX_PACKAGE_LOCATION lib/pkgconfig)
     endif()
   endif()
 
   if(BUILD_STATIC)
     if(MINGW)
-      add_library(libzmq-static STATIC ${sources} ${public_headers} ${html-docs}
-        ${readme-docs} ${zmq-pkgconfig} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
+      add_library(libzmq-static STATIC ${sources} ${public_headers} ${html-docs} ${readme-docs} ${zmq-pkgconfig}
+                                       ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
     else()
-      add_library(libzmq-static STATIC $<TARGET_OBJECTS:objects> ${public_headers}
-        ${html-docs} ${readme-docs} ${zmq-pkgconfig} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
+      add_library(libzmq-static STATIC $<TARGET_OBJECTS:objects> ${public_headers} ${html-docs} ${readme-docs}
+                                       ${zmq-pkgconfig} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
     endif()
     if(CMAKE_SYSTEM_NAME MATCHES "QNX")
       target_link_libraries(libzmq-static m)
     endif()
-    set_target_properties(libzmq-static PROPERTIES
-      PUBLIC_HEADER "${public_headers}"
-      OUTPUT_NAME "zmq"
-      PREFIX "lib")
+    set_target_properties(
+      libzmq-static PROPERTIES PUBLIC_HEADER "${public_headers}" OUTPUT_NAME "${ZMQ_OUTPUT_BASENAME}" PREFIX "lib")
   endif()
 endif()
 
 if(BUILD_STATIC)
-  target_compile_definitions(libzmq-static
-    PUBLIC ZMQ_STATIC)
+  target_compile_definitions(libzmq-static PUBLIC ZMQ_STATIC)
+endif()
+
+list(APPEND target_outputs "")
+
+if(BUILD_SHARED)
+  list(APPEND target_outputs "libzmq")
+endif()
+
+if(BUILD_STATIC)
+  list(APPEND target_outputs "libzmq-static")
 endif()
 
 foreach(target ${target_outputs})
-  target_include_directories(${target}
-    PUBLIC
-      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-      $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
-      $<INSTALL_INTERFACE:include>)
+  target_include_directories(
+    ${target} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+                     $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}> $<INSTALL_INTERFACE:include>)
 endforeach()
 
 if(BUILD_SHARED)
-  target_link_libraries(libzmq ${OPTIONAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
+  target_link_libraries(libzmq ${CMAKE_THREAD_LIBS_INIT})
+  if(GNUTLS_FOUND)
+    target_link_libraries(libzmq ${GNUTLS_LIBRARIES})
+  endif()
+
+  if(NSS3_FOUND)
+    target_link_libraries(libzmq ${NSS3_LIBRARIES})
+  endif()
+
+  if(LIBBSD_FOUND)
+    target_link_libraries(libzmq ${LIBBSD_LIBRARIES})
+  endif()
 
   if(SODIUM_FOUND)
     target_link_libraries(libzmq ${SODIUM_LIBRARIES})
@@ -1234,10 +1452,25 @@ if(BUILD_SHARED)
   if(RT_LIBRARY)
     target_link_libraries(libzmq -lrt)
   endif()
+
+  if(norm_FOUND)
+      target_link_libraries(libzmq norm::norm)
+  endif()
 endif()
 
 if(BUILD_STATIC)
-  target_link_libraries(libzmq-static ${OPTIONAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
+  target_link_libraries(libzmq-static ${CMAKE_THREAD_LIBS_INIT})
+  if(GNUTLS_FOUND)
+    target_link_libraries(libzmq-static ${GNUTLS_LIBRARIES})
+  endif()
+
+  if(LIBBSD_FOUND)
+    target_link_libraries(libzmq-static ${LIBBSD_LIBRARIES})
+  endif()
+
+  if(NSS3_FOUND)
+    target_link_libraries(libzmq-static ${NSS3_LIBRARIES})
+  endif()
 
   if(SODIUM_FOUND)
     target_link_libraries(libzmq-static ${SODIUM_LIBRARIES})
@@ -1268,17 +1501,21 @@ if(BUILD_STATIC)
   if(CMAKE_SYSTEM_NAME MATCHES "QNX")
     add_definitions(-DUNITY_EXCLUDE_MATH_H)
   endif()
+
+  if(norm_FOUND)
+      target_link_libraries(libzmq-static norm::norm)
+  endif()
 endif()
 
 if(BUILD_SHARED)
   set(perf-tools
-    local_lat
-    remote_lat
-    local_thr
-    remote_thr
-    inproc_lat
-    inproc_thr
-    proxy_thr)
+      local_lat
+      remote_lat
+      local_thr
+      remote_thr
+      inproc_lat
+      inproc_thr
+      proxy_thr)
 
   if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug") # Why?
     option(WITH_PERF_TOOL "Build with perf-tools" ON)
@@ -1291,41 +1528,60 @@ if(BUILD_SHARED)
       add_executable(${perf-tool} perf/${perf-tool}.cpp)
       target_link_libraries(${perf-tool} libzmq)
 
+      if(GNUTLS_FOUND)
+        target_link_libraries(${perf-tool} ${GNUTLS_LIBRARIES})
+      endif()
+
+      if(LIBBSD_FOUND)
+        target_link_libraries(${perf-tool} ${LIBBSD_LIBRARIES})
+      endif()
+
+      if(NSS3_FOUND)
+        target_link_libraries(${perf-tool} ${NSS3_LIBRARIES})
+      endif()
+
+      if(SODIUM_FOUND)
+        target_link_libraries(${perf-tool} ${SODIUM_LIBRARIES})
+      endif()
+
       if(ZMQ_BUILD_FRAMEWORK)
         # Copy perf-tools binaries into Framework
         add_custom_command(
-          TARGET libzmq ${perf-tool}
-          POST_BUILD
-          COMMAND ${CMAKE_COMMAND}
-          ARGS -E copy "$<TARGET_FILE:${perf-tool}>" "${LIBRARY_OUTPUT_PATH}/ZeroMQ.framework/Versions/${ZMQ_VERSION_STRING}/MacOS/${perf-tool}"
+          TARGET libzmq
+          ${perf-tool} POST_BUILD
+          COMMAND ${CMAKE_COMMAND} ARGS -E copy "$<TARGET_FILE:${perf-tool}>"
+                  "${LIBRARY_OUTPUT_PATH}/ZeroMQ.framework/Versions/${ZMQ_VERSION_STRING}/MacOS/${perf-tool}"
           VERBATIM
           COMMENT "Perf tools")
       else()
-        install(TARGETS ${perf-tool}
-          RUNTIME DESTINATION bin
-          COMPONENT PerfTools)
+        install(TARGETS ${perf-tool} RUNTIME DESTINATION bin COMPONENT PerfTools)
+      endif()
+      if(ZMQ_HAVE_WINDOWS_UWP)
+        set_target_properties(${perf-tool} PROPERTIES LINK_FLAGS_DEBUG "/OPT:NOICF /OPT:NOREF")
       endif()
     endforeach()
 
     if(BUILD_STATIC)
       add_executable(benchmark_radix_tree perf/benchmark_radix_tree.cpp)
       target_link_libraries(benchmark_radix_tree libzmq-static)
-      target_include_directories(benchmark_radix_tree
-        PUBLIC
-        "${CMAKE_CURRENT_LIST_DIR}/src")
+      target_include_directories(benchmark_radix_tree PUBLIC "${CMAKE_CURRENT_LIST_DIR}/src")
+      if(ZMQ_HAVE_WINDOWS_UWP)
+        set_target_properties(benchmark_radix_tree PROPERTIES LINK_FLAGS_DEBUG "/OPT:NOICF /OPT:NOREF")
+      endif()
     endif()
-
+  elseif(WITH_PERF_TOOL)
+    message(FATAL_ERROR "Shared library disabled - perf-tools unavailable.")
   endif()
-elseif(WITH_PERF_TOOL)
-  message(FATAL_ERROR "Shared library disabled - perf-tools unavailable.")
 endif()
 
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 # tests
 
 option(BUILD_TESTS "Whether or not to build the tests" ON)
 
-set(ZMQ_BUILD_TESTS ${BUILD_TESTS} CACHE BOOL "Build the tests for ZeroMQ")
+set(ZMQ_BUILD_TESTS
+    ${BUILD_TESTS}
+    CACHE BOOL "Build the tests for ZeroMQ")
 
 if(ZMQ_BUILD_TESTS)
   enable_testing() # Enable testing only works in root scope
@@ -1337,30 +1593,39 @@ if(ZMQ_BUILD_TESTS)
   endif()
 endif()
 
-#-----------------------------------------------------------------------------
+# -----------------------------------------------------------------------------
 # installer
 
-if(MSVC AND(BUILD_SHARED OR BUILD_STATIC))
-  install(TARGETS ${target_outputs}
+if(MSVC AND (BUILD_SHARED OR BUILD_STATIC))
+  install(
+    TARGETS ${target_outputs}
     EXPORT ${PROJECT_NAME}-targets
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
-    COMPONENT SDK)
+    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT SDK)
   if(MSVC_IDE)
-    install(FILES ${PDB_OUTPUT_DIRECTORY}/\${CMAKE_INSTALL_CONFIG_NAME}/${PDB_NAME}.pdb DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT SDK OPTIONAL)
+    install(
+      FILES ${PDB_OUTPUT_DIRECTORY}/\${CMAKE_INSTALL_CONFIG_NAME}/${PDB_NAME}.pdb
+      DESTINATION ${CMAKE_INSTALL_BINDIR}
+      COMPONENT SDK
+      OPTIONAL)
   else()
-    install(FILES ${PDB_OUTPUT_DIRECTORY}/${PDB_NAME}.pdb DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT SDK OPTIONAL)
+    install(
+      FILES ${PDB_OUTPUT_DIRECTORY}/${PDB_NAME}.pdb
+      DESTINATION ${CMAKE_INSTALL_BINDIR}
+      COMPONENT SDK
+      OPTIONAL)
   endif()
   if(BUILD_SHARED)
-    install(TARGETS libzmq
+    install(
+      TARGETS libzmq
       RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-      PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
-      COMPONENT Runtime)
+      PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT Runtime)
   endif()
 elseif(BUILD_SHARED OR BUILD_STATIC)
-  install(TARGETS ${target_outputs}
+  install(
+    TARGETS ${target_outputs}
     EXPORT ${PROJECT_NAME}-targets
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
@@ -1369,16 +1634,6 @@ elseif(BUILD_SHARED OR BUILD_STATIC)
     PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 endif()
 
-# install(FILES ${public_headers}
-#   DESTINATION include
-#   COMPONENT SDK)
-
-#if(NOT ZMQ_BUILD_FRAMEWORK)
-#  file(GLOB private_headers "${CMAKE_CURRENT_SOURCE_DIR}/src/*.hpp")
-#  install(FILES ${sources} ${private_headers} DESTINATION src/zmq
-#    COMPONENT SourceCode)
-#endif()
-
 foreach(readme ${readme-docs})
   configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${readme} ${CMAKE_CURRENT_BINARY_DIR}/${readme}.txt)
 
@@ -1389,38 +1644,52 @@ endforeach()
 
 if(WITH_DOC)
   if(NOT ZMQ_BUILD_FRAMEWORK)
-    install(FILES ${html-docs} DESTINATION doc/zmq COMPONENT RefGuide)
+    install(
+      FILES ${html-docs}
+      DESTINATION doc/zmq
+      COMPONENT RefGuide)
   endif()
 endif()
 
 if(WIN32)
-  set(ZEROMQ_CMAKECONFIG_INSTALL_DIR "CMake" CACHE STRING "install path for ZeroMQConfig.cmake")
+  set(ZEROMQ_CMAKECONFIG_INSTALL_DIR
+      "CMake"
+      CACHE STRING "install path for ZeroMQConfig.cmake")
 else()
-  # GNUInstallDirs "DATADIR" wrong here; CMake search path wants "share".
-  set(ZEROMQ_CMAKECONFIG_INSTALL_DIR "share/cmake/${PROJECT_NAME}" CACHE STRING "install path for ZeroMQConfig.cmake")
+  # CMake search path wants either "share" (AKA GNUInstallDirs DATAROOTDIR) for arch-independent, or LIBDIR for arch-
+  # dependent, plus "cmake" as prefix
+  set(ZEROMQ_CMAKECONFIG_INSTALL_DIR
+      "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
+      CACHE STRING "install path for ZeroMQConfig.cmake")
 endif()
 
 if((NOT CMAKE_VERSION VERSION_LESS 3.0) AND (BUILD_SHARED OR BUILD_STATIC))
-  export(EXPORT ${PROJECT_NAME}-targets
-    FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
+  export(EXPORT ${PROJECT_NAME}-targets FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
 endif()
-configure_package_config_file(builds/cmake/${PROJECT_NAME}Config.cmake.in
-  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
+configure_package_config_file(
+  builds/cmake/${PROJECT_NAME}Config.cmake.in "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
   INSTALL_DESTINATION ${ZEROMQ_CMAKECONFIG_INSTALL_DIR})
-write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
+write_basic_package_version_file(
+  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
   VERSION ${ZMQ_VERSION_MAJOR}.${ZMQ_VERSION_MINOR}.${ZMQ_VERSION_PATCH}
   COMPATIBILITY AnyNewerVersion)
 if(BUILD_SHARED OR BUILD_STATIC)
-  install(EXPORT ${PROJECT_NAME}-targets
+  install(
+    EXPORT ${PROJECT_NAME}-targets
     FILE ${PROJECT_NAME}Targets.cmake
     DESTINATION ${ZEROMQ_CMAKECONFIG_INSTALL_DIR})
   install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
-    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
-    DESTINATION ${ZEROMQ_CMAKECONFIG_INSTALL_DIR})
+                ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
+          DESTINATION ${ZEROMQ_CMAKECONFIG_INSTALL_DIR})
 endif()
 
 option(ENABLE_CPACK "Enables cpack rules" ON)
 if(MSVC AND ENABLE_CPACK)
+  if(${CMAKE_BUILD_TYPE} MATCHES "Debug")
+    set(CMAKE_INSTALL_DEBUG_LIBRARIES_ONLY TRUE)
+    set(CMAKE_INSTALL_DEBUG_LIBRARIES TRUE)
+    set(CMAKE_INSTALL_UCRT_LIBRARIES TRUE)
+  endif()
   include(InstallRequiredSystemLibraries)
 
   if(CMAKE_CL_64)
@@ -1432,24 +1701,18 @@ if(MSVC AND ENABLE_CPACK)
   set(CPACK_NSIS_DISPLAY_NAME "ZeroMQ ${ZMQ_VERSION_MAJOR}.${ZMQ_VERSION_MINOR}.${ZMQ_VERSION_PATCH}(${arch_name})")
   set(CPACK_PACKAGE_FILE_NAME "ZeroMQ-${ZMQ_VERSION_MAJOR}.${ZMQ_VERSION_MINOR}.${ZMQ_VERSION_PATCH}-${arch_name}")
 
-  # TODO: I think this part was intended to be used when running cpack
-  # separately from cmake but I don't know how that works.
+  # TODO: I think this part was intended to be used when running cpack separately from cmake but I don't know how that
+  # works.
   #
-  # macro(add_crt_version version)
-  #   set(rel_dir "${CMAKE_CURRENT_BINARY_DIR}/build/${arch_name}/${version};ZeroMQ;ALL;/")
-  #   set(debug_dir "${CMAKE_CURRENT_BINARY_DIR}/debug/${arch_name}/${version};ZeroMQ;ALL;/")
-  #   if(EXISTS ${rel_dir})
-  #     list(APPEND CPACK_INSTALL_CMAKE_PROJECTS ${rel_dir})
-  #   endif()
-
-  #   if(EXISTS ${debug_dir})
-  #     list(APPEND CPACK_INSTALL_CMAKE_PROJECTS ${rel_dir})
-  #   endmacro()
-  # endmacro()
-
-  # add_crt_version(v110)
-  # add_crt_version(v100)
-  # add_crt_version(v90)
+  # macro(add_crt_version version) set(rel_dir
+  # "${CMAKE_CURRENT_BINARY_DIR}/build/${arch_name}/${version};ZeroMQ;ALL;/")
+  # set(debug_dir
+  # "${CMAKE_CURRENT_BINARY_DIR}/debug/${arch_name}/${version};ZeroMQ;ALL;/")
+  # if(EXISTS ${rel_dir}) list(APPEND CPACK_INSTALL_CMAKE_PROJECTS ${rel_dir}) endif()
+
+  # if(EXISTS ${debug_dir}) list(APPEND CPACK_INSTALL_CMAKE_PROJECTS ${rel_dir}) endmacro() endmacro()
+
+  # add_crt_version(v110) add_crt_version(v100) add_crt_version(v90)
 
   list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_BINARY_DIR})
   set(CPACK_GENERATOR "NSIS")
@@ -1458,10 +1721,9 @@ if(MSVC AND ENABLE_CPACK)
   set(CPACK_PACKAGE_VENDOR "Miru")
   set(CPACK_NSIS_CONTACT "Steven McCoy <Steven.McCoy@miru.hk>")
   set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_BINARY_DIR}\\\\COPYING.txt")
-  # set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_BINARY_DIR}\\\\README.txt")
-  # set(CPACK_RESOURCE_FILE_WELCOME "${CMAKE_CURRENT_BINARY_DIR}\\\\WELCOME.txt")
-  # There is a bug in NSI that does not handle full unix paths properly. Make
-  # sure there is at least one set of four(4) backslashes.
+  # set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_BINARY_DIR}\\\\README.txt") set(CPACK_RESOURCE_FILE_WELCOME
+  # "${CMAKE_CURRENT_BINARY_DIR}\\\\WELCOME.txt") There is a bug in NSI that does not handle full unix paths properly.
+  # Make sure there is at least one set of four(4) backslashes.
   set(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\installer.ico")
   set(CPACK_NSIS_MUI_UNIICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\installer.ico")
 
@@ -1471,48 +1733,54 @@ if(MSVC AND ENABLE_CPACK)
   set(CPACK_PACKAGE_VERSION_MAJOR ${ZMQ_VERSION_MAJOR})
   set(CPACK_PACKAGE_VERSION_MINOR ${ZMQ_VERSION_MINOR})
   set(CPACK_PACKAGE_VERSION_PATCH ${ZMQ_VERSION_PATCH})
-  # set(CPACK_PACKAGE_INSTALL_DIRECTORY "ZMQ Install Directory")
-  # set(CPACK_TEMPORARY_DIRECTORY "ZMQ Temporary CPack Directory")
+  # set(CPACK_PACKAGE_INSTALL_DIRECTORY "ZMQ Install Directory") set(CPACK_TEMPORARY_DIRECTORY "ZMQ Temporary CPack
+  # Directory")
 
   include(CPack)
 
-  cpack_add_component_group(Development
-    DISPLAY_NAME "ZeroMQ software development kit"
-    EXPANDED)
-  cpack_add_component(PerfTools
-    DISPLAY_NAME "ZeroMQ performance tools"
-    INSTALL_TYPES FullInstall DevInstall)
-  cpack_add_component(SourceCode
-    DISPLAY_NAME "ZeroMQ source code"
-    DISABLED
-    INSTALL_TYPES FullInstall)
-  cpack_add_component(SDK
-    DISPLAY_NAME "ZeroMQ headers and libraries"
-    INSTALL_TYPES FullInstall DevInstall
-    GROUP Development)
+  cpack_add_component_group(Development DISPLAY_NAME "ZeroMQ software development kit" EXPANDED)
+  cpack_add_component(PerfTools DISPLAY_NAME "ZeroMQ performance tools" INSTALL_TYPES FullInstall DevInstall)
+  cpack_add_component(SourceCode DISPLAY_NAME "ZeroMQ source code" DISABLED INSTALL_TYPES FullInstall)
+  cpack_add_component(
+    SDK
+    DISPLAY_NAME
+    "ZeroMQ headers and libraries"
+    INSTALL_TYPES
+    FullInstall
+    DevInstall
+    GROUP
+    Development)
   if(WITH_DOC)
-    cpack_add_component(RefGuide
-      DISPLAY_NAME "ZeroMQ reference guide"
-      INSTALL_TYPES FullInstall DevInstall
-      GROUP Development)
-  endif()
-  cpack_add_component(Runtime
-    DISPLAY_NAME "ZeroMQ runtime files"
+    cpack_add_component(
+      RefGuide
+      DISPLAY_NAME
+      "ZeroMQ reference guide"
+      INSTALL_TYPES
+      FullInstall
+      DevInstall
+      GROUP
+      Development)
+  endif()
+  cpack_add_component(
+    Runtime
+    DISPLAY_NAME
+    "ZeroMQ runtime files"
     REQUIRED
-    INSTALL_TYPES FullInstall DevInstall MinInstall)
-    cpack_add_install_type(FullInstall
-    DISPLAY_NAME "Full install, including source code")
-    cpack_add_install_type(DevInstall
-    DISPLAY_NAME "Developer install, headers and libraries")
-    cpack_add_install_type(MinInstall
-    DISPLAY_NAME "Minimal install, runtime only")
+    INSTALL_TYPES
+    FullInstall
+    DevInstall
+    MinInstall)
+  cpack_add_install_type(FullInstall DISPLAY_NAME "Full install, including source code")
+  cpack_add_install_type(DevInstall DISPLAY_NAME "Developer install, headers and libraries")
+  cpack_add_install_type(MinInstall DISPLAY_NAME "Minimal install, runtime only")
 endif()
 
 # Export this for library to help build this as a sub-project
-set(ZEROMQ_LIBRARY libzmq CACHE STRING "ZeroMQ library")
+set(ZEROMQ_LIBRARY
+    libzmq
+    CACHE STRING "ZeroMQ library")
 
-# Workaround for MSVS10 to avoid the Dialog Hell
-# FIXME: This could be removed with future version of CMake.
+# Workaround for MSVS10 to avoid the Dialog Hell FIXME: This could be removed with future version of CMake.
 if(MSVC_VERSION EQUAL 1600)
   set(ZMQ_SLN_FILENAME "${CMAKE_CURRENT_BINARY_DIR}/ZeroMQ.sln")
   if(EXISTS "${ZMQ_SLN_FILENAME}")
@@ -1521,4 +1789,18 @@ if(MSVC_VERSION EQUAL 1600)
 endif()
 
 # this cannot be moved, as it does not only contain function/macro definitions
-include(ClangFormat)
+option(ENABLE_CLANG "Include Clang" ON)
+if (ENABLE_CLANG)
+  include(ClangFormat)
+endif()
+
+# fixes https://github.com/zeromq/libzmq/issues/3776 The problem is, both libzmq-static libzmq try to use/generate
+# precompiled.pch at the same time Add a dependency, so they run in order and so they dont get in each others way TODO
+# still generates warning "build\x64-Debug\ninja : warning : multiple rules generate precompiled.hpp. builds involving
+# this target will not be correct; continuing anyway [-w dupbuild=warn]"
+if(MSVC
+   AND ENABLE_PRECOMPILED
+   AND BUILD_SHARED
+   AND BUILD_STATIC)
+  add_dependencies(libzmq-static libzmq)
+endif()
diff -pruN 4.3.2-2/config.sh 4.3.3-1/config.sh
--- 4.3.2-2/config.sh	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/config.sh	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,69 @@
+#!/usr/bin/env bash
+
+function set_config_opts() {
+    CONFIG_OPTS=()
+    CONFIG_OPTS+=("CFLAGS=-g")
+    CONFIG_OPTS+=("CPPFLAGS=-I${BUILD_PREFIX}/include")
+    CONFIG_OPTS+=("CXXFLAGS=-g")
+    CONFIG_OPTS+=("LDFLAGS=-L${BUILD_PREFIX}/lib")
+    CONFIG_OPTS+=("PKG_CONFIG_PATH=${BUILD_PREFIX}/lib/pkgconfig")
+    CONFIG_OPTS+=("--prefix=${BUILD_PREFIX}")
+    CHECK="distcheck"
+
+    if [ -n "$ADDRESS_SANITIZER" ] && [ "$ADDRESS_SANITIZER" = "enabled" ]; then
+        CONFIG_OPTS+=("--enable-address-sanitizer=yes")
+        # distcheck does an out-of-tree build, and the fuzzer tests use a hard-coded relative path for simplicity
+        CHECK="check"
+        git clone --depth 1 https://github.com/zeromq/libzmq-fuzz-corpora.git tests/libzmq-fuzz-corpora
+    fi
+
+    if [ "$USE_NSS" = "yes" ]; then
+        CONFIG_OPTS+=("--with-nss")
+    fi
+
+    if [ -z "$CURVE" ]; then
+        CONFIG_OPTS+=("--disable-curve")
+    elif [ "$CURVE" = "libsodium" ]; then
+        CONFIG_OPTS+=("--with-libsodium=yes")
+
+        if ! ((command -v dpkg-query >/dev/null 2>&1 && dpkg-query --list libsodium-dev >/dev/null 2>&1) || \
+                (command -v brew >/dev/null 2>&1 && brew ls --versions libsodium >/dev/null 2>&1)); then
+            git clone --depth 1 -b stable git://github.com/jedisct1/libsodium.git
+            ( cd libsodium; ./autogen.sh; ./configure --prefix=$BUILD_PREFIX; make install)
+        fi
+    fi
+
+    if [ -n "$GSSAPI" ] && [ "$GSSAPI" = "enabled" ]; then
+        CONFIG_OPTS+=("--with-libgssapi_krb5=yes")
+    fi
+
+    if [ -n "$PGM" ] && [ "$PGM" = "enabled" ]; then
+        CONFIG_OPTS+=("--with-pgm=yes")
+    fi
+
+    if [ -n "$NORM" ] && [ "$NORM" = "enabled" ]; then
+        CONFIG_OPTS+=("--with-norm=yes")
+    fi
+
+    if [ -n "$TIPC" ] && [ "$TIPC" = "enabled" ]; then
+        sudo modprobe tipc
+    fi
+
+    if [ -n "$POLLER" ]; then
+        CONFIG_OPTS+=("--with-poller=${POLLER}")
+    fi
+
+    if [ -n "$TLS" ] && [ "$TLS" = "enabled" ]; then
+        CONFIG_OPTS+=("--with-tls=yes")
+    fi
+
+    if [ -z "$DRAFT" ] || [ "$DRAFT" = "disabled" ]; then
+        CONFIG_OPTS+=("--enable-drafts=no")
+    elif [ "$DRAFT" = "enabled" ]; then
+        CONFIG_OPTS+=("--enable-drafts=yes")
+    fi
+
+    if [ -n "$FORCE_98" ] && [ "$FORCE_98" = "enabled" ]; then
+        CONFIG_OPTS+=("--enable-force-CXX98-compat=yes")
+    fi
+}
diff -pruN 4.3.2-2/configure.ac 4.3.3-1/configure.ac
--- 4.3.2-2/configure.ac	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/configure.ac	2020-09-07 10:12:14.000000000 +0000
@@ -12,6 +12,8 @@ AC_CONFIG_AUX_DIR(config)
 AC_CONFIG_MACRO_DIR(config)
 AC_CONFIG_HEADERS([src/platform.hpp])
 AM_INIT_AUTOMAKE(foreign subdir-objects tar-ustar dist-zip)
+# Allow "configure --disable-maintainer-mode" to disable timestamp checking 
+AM_MAINTAINER_MODE([enable])
 
 m4_pattern_allow([AC_PROG_CC_C99])
 m4_include([m4/ax_check_compile_flag.m4])
@@ -48,9 +50,10 @@ AC_SUBST(PACKAGE_VERSION)
 # ZeroMQ version 4.3.0: 7:0:2 (ABI version 5)
 # ZeroMQ version 4.3.1: 7:1:2 (ABI version 5)
 # ZeroMQ version 4.3.2: 7:2:2 (ABI version 5)
+# ZeroMQ version 4.3.3: 7:3:2 (ABI version 5)
 #
 # libzmq -version-info current:revision:age
-LTVER="7:2:2"
+LTVER="7:3:2"
 AC_SUBST(LTVER)
 
 # Take a copy of original flags
@@ -140,6 +143,42 @@ if test "x$zmq_militant" = "xyes"; then
     AC_DEFINE(ZMQ_ACT_MILITANT, 1, [Enable militant API assertions])
 fi
 
+# Disable IPC on unsupported platforms.
+case "${host_os}" in
+    *vxworks*|*openvms*|*mingw*)
+        ;;
+    *)
+        AC_DEFINE(ZMQ_HAVE_IPC, 1, [Have AF_UNIX sockets for ipc transport])
+        ;;
+esac
+
+# Data race/deadlock detection
+# NOTE: Running libzmq under TSAN doesn't make much sense -- synchronization in libzmq is to some extent
+# handled by the code "knowing" what threads are allowed to do, rather than by enforcing those
+# restrictions, so TSAN generates a lot of (presumably) false positives from libzmq.
+# The settings below are intended to enable libzmq to be built with minimal support for TSAN
+# such that it can be used along with other code that is also built with TSAN.
+AC_MSG_CHECKING([whether to enable TSan])
+AC_ARG_ENABLE(thread-sanitizer, [AS_HELP_STRING([--enable-thread-sanitizer=yes/no],
+                  [Build with clang Thread Sanitizer instrumentation])],
+                  [ZMQ_TSAN="$enableval"])
+
+if test "x${ZMQ_TSAN}" = "xyes"; then
+    TSAN_FLAGS="-fno-omit-frame-pointer -fsanitize=thread"
+    TSAN_CCFLAGS="${TSAN_CCFLAGS} -mllvm -tsan-instrument-memory-accesses=0"
+    TSAN_CCFLAGS="${TSAN_CCFLAGS} -mllvm -tsan-instrument-atomics=0"
+    TSAN_CCFLAGS="${TSAN_CCFLAGS} -mllvm -tsan-instrument-func-entry-exit=1"
+    CFLAGS="${CFLAGS} ${TSAN_FLAGS} ${TSAN_CCFLAGS}"
+    CXXFLAGS="${CXXFLAGS} ${TSAN_FLAGS} ${TSAN_CCFLAGS}"
+    LDFLAGS="${LDFLAGS} ${TSAN_FLAGS} -pie"
+
+    AM_CONDITIONAL(ENABLE_TSAN, true)
+    AC_MSG_RESULT([yes])
+else
+    AM_CONDITIONAL(ENABLE_TSAN, false)
+    AC_MSG_RESULT([no])
+fi
+
 # Memory mis-use detection
 AC_MSG_CHECKING([whether to enable ASan])
 AC_ARG_ENABLE(address-sanitizer, [AS_HELP_STRING([--enable-address-sanitizer=yes/no],
@@ -147,8 +186,8 @@ AC_ARG_ENABLE(address-sanitizer, [AS_HEL
                   [ZMQ_ASAN="$enableval"])
 
 if test "x${ZMQ_ASAN}" = "xyes"; then
-    CFLAGS="${CFLAGS} -fsanitize=address"
-    CXXFLAGS="${CXXFLAGS} -fsanitize=address"
+    CFLAGS="${CFLAGS} -fsanitize=address -fsanitize=undefined -fsanitize=leak -fno-sanitize-recover=all"
+    CXXFLAGS="${CXXFLAGS} -fsanitize=address -fsanitize=undefined -fsanitize=leak -fno-sanitize-recover=all"
 
     AM_CONDITIONAL(ENABLE_ASAN, true)
     AC_MSG_RESULT([yes])
@@ -157,7 +196,7 @@ else
     AC_MSG_RESULT([no])
 fi
 
-# By default compiling with -Werror except OSX and on Solaris when building
+# By default compiling with -Werror except on OSX and Solaris when building
 # with libsodium.
 AC_ARG_ENABLE([Werror],
     [AS_HELP_STRING([--disable-Werror], [disable Werror compiler flag [default=enabled]])],
@@ -232,17 +271,14 @@ case "${host_os}" in
         ;;
     *dragonfly*)
         CPPFLAGS="-D__BSD_VISIBLE $CPPFLAGS"
+        AC_DEFINE(ZMQ_HAVE_FREEBSD, 1, [Have DragonFly OS])
         AC_DEFINE(ZMQ_HAVE_DRAGONFLY, 1, [Have DragonFly OS])
         ;;
     *darwin*)
         # Define on Darwin to enable all library features
         CPPFLAGS="-D_DARWIN_C_SOURCE $CPPFLAGS"
         libzmq_pedantic="no"
-        libzmq_werror="no"
         AC_DEFINE(ZMQ_HAVE_OSX, 1, [Have DarwinOSX OS])
-        AC_LANG_PUSH([C++])
-        LIBZMQ_CHECK_LANG_FLAG_PREPEND([-Wno-uninitialized])
-        AC_LANG_POP([C++])
         ;;
     *haiku*)
         AC_DEFINE(ZMQ_HAVE_HAIKU, 1, [Have Haiku OS])
@@ -281,7 +317,7 @@ case "${host_os}" in
         AC_DEFINE(ZMQ_HAVE_QNXNTO, 1, [Have QNX Neutrino OS])
         AC_CHECK_LIB(socket, socket)
         ;;
-    *aix*)
+    *aix*|*os400*)
         AC_DEFINE(ZMQ_HAVE_AIX, 1, [Have AIX OS])
         ;;
     *hpux*)
@@ -523,13 +559,18 @@ elif test "x$with_libsodium" = "xyes"; t
     curve_library="libsodium"
     enable_curve="yes"
 
-    # On Solaris, libsodium depends on libssp
     case "${host_os}" in
         *solaris*)
+            dnl On Solaris, libsodium depends on libssp
             LDFLAGS="-lssp $LDFLAGS"
             libzmq_pedantic="no"
             libzmq_werror="no"
         ;;
+        *darwin*)
+            dnl On Darwin, building with libsodium causes
+            dnl macro redefinition warnings
+            libzmq_werror="no"
+        ;;
     esac
 
     PKGCFG_NAMES_PRIVATE="$PKGCFG_NAMES_PRIVATE libsodium"
@@ -546,9 +587,58 @@ AM_CONDITIONAL(ENABLE_CURVE_KEYGEN, test
 AM_CONDITIONAL(USE_LIBSODIUM, test "$curve_library" = "libsodium")
 AM_CONDITIONAL(USE_TWEETNACL, test "$curve_library" = "tweetnacl")
 AM_CONDITIONAL(HAVE_CURVE, test "x$curve_library" != "x")
-
 AM_CONDITIONAL(USE_WEPOLL, test "$poller" = "wepoll")
 
+# Check requiring packages for WebSocket
+ws_crypto_library=""
+
+AC_ARG_ENABLE([ws],
+    [AS_HELP_STRING([--enable-ws], [Enable WebSocket transport [default=state of DRAFT]])],
+    [enable_ws=$enableval],
+    [enable_ws=$enable_drafts])
+
+AC_ARG_WITH([nss],
+    [AS_HELP_STRING([--with-nss], [use nss instead of built-in sha1 [default=no]])])
+
+AC_ARG_WITH([tls],
+    [AS_HELP_STRING([--with-tls], [Enable TLS (WSS transport) [default=no]])])
+
+if test "x$enable_ws" != "xno"; then
+    if test "x$with_tls" = "xyes"; then
+        PKG_CHECK_MODULES([GNUTLS], [gnutls >= 3.1.4], [
+            PKGCFG_NAMES_PRIVATE="$PKGCFG_NAMES_PRIVATE gnutls >= 3.1.4"
+            ws_crypto_library="gnutls"
+            AC_DEFINE(ZMQ_USE_GNUTLS, [1], [Use GNUTLS for TLS])
+            AC_DEFINE(ZMQ_HAVE_WS, [1], [Using websocket])
+            AC_DEFINE(ZMQ_HAVE_WSS, [1], [WSS enabled])
+            AC_MSG_NOTICE(Using gnutls)
+        ],[
+          AC_MSG_ERROR([GnuTLS is not installed. Install it, then run configure again])
+        ])
+    elif test "x$with_nss" = "xyes"; then
+        PKG_CHECK_MODULES([NSS3], [nss], [
+            PKGCFG_NAMES_PRIVATE="$PKGCFG_NAMES_PRIVATE nss"
+            AC_DEFINE(ZMQ_USE_NSS, [1], [Using NSS])
+            AC_DEFINE(ZMQ_HAVE_WS, [1], [Using websocket])
+            ws_crypto_library="nss"
+            AC_MSG_NOTICE(Using NSS)
+        ], [
+            AC_MSG_ERROR([nss is not installed. Install it, then run configure again])
+        ])
+    else
+        AC_DEFINE(ZMQ_HAVE_WS, [1], [Using websocket])
+        AC_DEFINE(ZMQ_USE_BUILTIN_SHA1, [1], [Using built-in sha1])
+        AC_MSG_NOTICE(Using builting SHA1)
+        ws_crypto_library="builtin"
+    fi
+fi
+
+AM_CONDITIONAL(HAVE_WS, test "x$ws_crypto_library" != "x")
+AM_CONDITIONAL(USE_NSS, test "x$ws_crypto_library" = "xnss")
+AM_CONDITIONAL(USE_BUILTIN_SHA1, test "x$ws_crypto_library" = "xbuiltin")
+AM_CONDITIONAL(USE_GNUTLS, test "x$ws_crypto_library" = "xgnutls")
+AM_CONDITIONAL(HAVE_WSS, test "x$ws_crypto_library" = "xgnutls")
+
 # build using pgm
 have_pgm_library="no"
 
@@ -559,13 +649,18 @@ AC_ARG_WITH([pgm], [AS_HELP_STRING([--wi
 
 # conditionally require pgm package
 if test "x$with_pgm_ext" != "xno"; then
-    PKG_CHECK_MODULES([pgm], [openpgm-5.2 >= 5.2], [
+    PKG_CHECK_MODULES([pgm], [openpgm-5.3 >= 5.3], [
         have_pgm_library="yes"
-        PKGCFG_NAMES_PRIVATE="$PKGCFG_NAMES_PRIVATE openpgm-5.2 >= 5.2"
+        PKGCFG_NAMES_PRIVATE="$PKGCFG_NAMES_PRIVATE openpgm-5.3 >= 5.3"
     ], [
-        PKG_CHECK_MODULES([pgm], [openpgm-5.1 >= 5.1], [
+        PKG_CHECK_MODULES([pgm], [openpgm-5.2 >= 5.2], [
             have_pgm_library="yes"
-            PKGCFG_NAMES_PRIVATE="$PKGCFG_NAMES_PRIVATE openpgm-5.1 >= 5.1"
+            PKGCFG_NAMES_PRIVATE="$PKGCFG_NAMES_PRIVATE openpgm-5.2 >= 5.2"
+        ], [
+            PKG_CHECK_MODULES([pgm], [openpgm-5.1 >= 5.1], [
+                have_pgm_library="yes"
+                PKGCFG_NAMES_PRIVATE="$PKGCFG_NAMES_PRIVATE openpgm-5.1 >= 5.1"
+            ])
         ])
     ])
 fi
@@ -662,7 +757,7 @@ AM_CONDITIONAL(ON_GNU, test "x$libzmq_on
 
 # Check for __atomic_Xxx compiler intrinsics
 AC_LANG_PUSH([C++])
-AX_CHECK_COMPILE_FLAG([-Wno-atomic-alignment],
+AX_CHECK_COMPILE_FLAG([-Watomic-alignment],
     [CXXFLAGS+=" -Wno-atomic-alignment"],
     [],
     [-Werror])
@@ -692,6 +787,45 @@ AC_COMPILE_IFELSE(
 		AC_MSG_RESULT([no])
 ])
 
+AC_ARG_ENABLE([libbsd],
+    [AS_HELP_STRING([--enable-libbsd],
+        [enable libbsd [default=auto]])],
+    [enable_libbsd=$enableval],
+    [enable_libbsd="auto"])
+
+if test "x$enable_libbsd" != "xno"; then
+    PKG_CHECK_MODULES(LIBBSD, [libbsd],
+        [
+            AC_DEFINE(ZMQ_HAVE_LIBBSD, 1, [The libbsd library is to be used])
+            AC_SUBST([LIBBSD_CFLAGS])
+            AC_SUBST([LIBBSD_LIBS])
+            PKGCFG_NAMES_PRIVATE="$PKGCFG_NAMES_PRIVATE libbsd"
+            found_libbsd="yes"
+        ],
+        [
+            found_libbsd="no"
+            if test "x$enable_libbsd" = "xyes"; then
+                AC_MSG_ERROR([Cannot find libbsd])
+            else
+                AC_MSG_WARN([Cannot find libbsd])
+            fi
+        ])
+fi
+if test "x$found_libbsd" != "xyes"; then
+    AC_MSG_CHECKING([whether strlcpy is available])
+    AC_COMPILE_IFELSE(
+        [AC_LANG_PROGRAM(
+            [[#include <string.h>]],
+            [[char buf [100]; size_t bar = strlcpy (buf, "foo", 100); (void)bar; return 0;]])
+        ],[
+            AC_MSG_RESULT([yes])
+            AC_DEFINE(ZMQ_HAVE_STRLCPY, [1],
+                [strlcpy is available])
+        ],[
+            AC_MSG_RESULT([no])
+    ])
+fi
+
 # pthread_setname is non-posix, and there are at least 4 different implementations
 AC_MSG_CHECKING([whether signature of pthread_setname_np() has 1 argument])
 AC_COMPILE_IFELSE(
@@ -904,18 +1038,51 @@ AM_CONDITIONAL([WITH_CLANG_FORMAT], [$WI
 # unittests will not build without the static libzmq.a
 AM_CONDITIONAL(ENABLE_STATIC, test "x$enable_static" = "xyes")
 
+# build using a fuzzing engine - fuzzers will be built separately and statically
+AC_ARG_WITH([fuzzing-engine], [AS_HELP_STRING([--with-fuzzing-engine],
+    [build libzmq with an exernal fuzzing engine [default=no]])],
+    [have_fuzzing_engine_ext=$withval],
+    [have_fuzzing_engine_ext=no])
+AC_ARG_WITH([fuzzing-installdir],
+    AS_HELP_STRING([--with-fuzzing-installdir=PATH],
+        [Path where to install fuzzer binaries]),
+    [fuzzing_installdir="$withval"])
+
+if test "x$have_fuzzing_engine_ext" != "xno" && test "x$fuzzing_installdir" != "x" && test "x$enable_static" = "xyes"; then
+    FUZZING_ENGINE_LIB="${have_fuzzing_engine_ext}"
+    FUZZING_INSTALLDIR="${fuzzing_installdir}"
+    AC_SUBST(FUZZING_ENGINE_LIB)
+    AC_SUBST(FUZZING_INSTALLDIR)
+    AC_DEFINE(ZMQ_USE_FUZZING_ENGINE, 1, [fuzz tests will be built with fuzzing engine])
+fi
+AM_CONDITIONAL(FUZZING_ENGINE_LIB, test "x$FUZZING_ENGINE_LIB" != "x")
+
 # clang 6 has a warning that does not make sense on multi-platform code
 AC_LANG_PUSH([C])
-AX_CHECK_COMPILE_FLAG([-Wno-tautological-constant-compare],
+AX_CHECK_COMPILE_FLAG([-Wtautological-constant-compare],
     [CFLAGS+=" -Wno-tautological-constant-compare"],
     [],
     [-Werror])
 AC_LANG_POP([C])
-AX_CHECK_COMPILE_FLAG([-Wno-tautological-constant-compare],
+AX_CHECK_COMPILE_FLAG([-Wtautological-constant-compare],
     [CXXFLAGS+=" -Wno-tautological-constant-compare"],
     [],
     [-Werror])
 
+# LTO is enabled by default on SUSE Tumbleweed and RPM lint generates an error if
+# the flag is not used to compile archives:
+# E: lto-no-text-in-archive
+AC_LANG_PUSH([C])
+AX_CHECK_COMPILE_FLAG([-ffat-lto-objects],
+    [CFLAGS+=" -ffat-lto-objects"],
+    [],
+    [-Werror])
+AC_LANG_POP([C])
+AX_CHECK_COMPILE_FLAG([-ffat-lto-objects],
+    [CXXFLAGS+=" -ffat-lto-objects"],
+    [],
+    [-Werror])
+
 # Subst LIBZMQ_EXTRA_CFLAGS & CXXFLAGS & LDFLAGS
 AC_SUBST(LIBZMQ_EXTRA_CFLAGS)
 AC_SUBST(LIBZMQ_EXTRA_CXXFLAGS)
diff -pruN 4.3.2-2/debian/changelog 4.3.3-1/debian/changelog
--- 4.3.2-2/debian/changelog	2020-02-20 20:12:19.000000000 +0000
+++ 4.3.3-1/debian/changelog	2020-09-07 16:10:59.000000000 +0000
@@ -1,3 +1,11 @@
+zeromq3 (4.3.3-1) unstable; urgency=high
+
+  * New upstream release:
+    - fixes CVE-2020-15166: Denial-of-Service on CURVE/ZAP-protected servers
+      by unauthenticated clients.
+
+ -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 07 Sep 2020 18:10:59 +0200
+
 zeromq3 (4.3.2-2) unstable; urgency=medium
 
   * Sync zmq.hpp from cppzmq (closes: #951135).
diff -pruN 4.3.2-2/doc/Makefile.am 4.3.3-1/doc/Makefile.am
--- 4.3.2-2/doc/Makefile.am	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/Makefile.am	2020-09-07 10:12:14.000000000 +0000
@@ -1,9 +1,9 @@
 #
 # documentation
 #
-MAN3 = zmq_bind.3 zmq_unbind.3 zmq_connect.3 zmq_disconnect.3 zmq_close.3 \
+MAN3 = zmq_bind.3 zmq_unbind.3 zmq_connect.3 zmq_connect_peer.3 zmq_disconnect.3 zmq_close.3 \
     zmq_ctx_new.3 zmq_ctx_term.3 zmq_ctx_get.3 zmq_ctx_set.3 zmq_ctx_shutdown.3 \
-    zmq_msg_init.3 zmq_msg_init_data.3 zmq_msg_init_size.3 \
+    zmq_msg_init.3 zmq_msg_init_data.3 zmq_msg_init_size.3 zmq_msg_init_buffer.3 \
     zmq_msg_move.3 zmq_msg_copy.3 zmq_msg_size.3 zmq_msg_data.3 zmq_msg_close.3 \
     zmq_msg_send.3 zmq_msg_recv.3 \
     zmq_msg_routing_id.3 zmq_msg_set_routing_id.3 \
diff -pruN 4.3.2-2/doc/zmq_bind.txt 4.3.3-1/doc/zmq_bind.txt
--- 4.3.2-2/doc/zmq_bind.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_bind.txt	2020-09-07 10:12:14.000000000 +0000
@@ -28,13 +28,15 @@ The 'endpoint' is a string consisting of
 'inproc':: local in-process (inter-thread) communication transport, see linkzmq:zmq_inproc[7]
 'pgm', 'epgm':: reliable multicast transport using PGM, see linkzmq:zmq_pgm[7]
 'vmci':: virtual machine communications interface (VMCI), see linkzmq:zmq_vmci[7]
+'udp':: unreliable unicast and multicast using UDP, see linkzmq:zmq_udp[7]
 
-Every 0MQ socket type except 'ZMQ_PAIR' supports one-to-many and many-to-one
+Every 0MQ socket type except 'ZMQ_PAIR' and 'ZMQ_CHANNEL' supports one-to-many and many-to-one
 semantics. The precise semantics depend on the socket type and are defined in
 linkzmq:zmq_socket[3].
 
-The 'ipc', 'tcp' and 'vmci' transports accept wildcard addresses: see linkzmq:zmq_ipc[7],
-linkzmq:zmq_tcp[7] and linkzmq:zmq_vmci[7] for details.
+The 'ipc', 'tcp', 'vmci' and 'udp' transports accept wildcard addresses: see
+linkzmq:zmq_ipc[7], linkzmq:zmq_tcp[7], linkzmq:zmq_vmci[7] and
+linkzmq:zmq_udp[7] for details.
 
 NOTE: the address syntax may be different for _zmq_bind()_ and _zmq_connect()_
 especially for the 'tcp', 'pgm' and 'epgm' transports.
diff -pruN 4.3.2-2/doc/zmq_connect_peer.txt 4.3.3-1/doc/zmq_connect_peer.txt
--- 4.3.2-2/doc/zmq_connect_peer.txt	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/doc/zmq_connect_peer.txt	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,92 @@
+zmq_connect_peer(3)
+===================
+
+
+NAME
+----
+zmq_connect_peer - create outgoing connection from socket and return the connection routing id in thread-safe and atomic way.
+
+
+SYNOPSIS
+--------
+*uint32_t zmq_connect_peer (void '*socket', const char '*endpoint');*
+
+
+DESCRIPTION
+-----------
+The _zmq_connect_peer()_ function connects a 'ZMQ_PEER' socket to an 'endpoint' and then returns the endpoint 'routing_id'.
+
+The 'endpoint' is a string consisting of a 'transport'`://` followed by an
+'address'. The 'transport' specifies the underlying protocol to use. The
+'address' specifies the transport-specific address to connect to.
+
+The function is supported only on the 'ZMQ_PEER' socket type and would return `0` with 'errno' set to 'ENOTSUP' otherwise.
+
+The _zmq_connect_peer()_ support the following transports:
+
+'tcp':: unicast transport using TCP, see linkzmq:zmq_tcp[7]
+'ipc':: local inter-process communication transport, see linkzmq:zmq_ipc[7]
+'inproc':: local in-process (inter-thread) communication transport, see linkzmq:zmq_inproc[7]
+'ws':: unicast transport using WebSockets, see linkzmq:zmq_ws[7]
+'wss':: unicast transport using WebSockets over TLS, see linkzmq:zmq_wss[7]
+
+RETURN VALUE
+------------
+The _zmq_connect_peer()_ function returns the peer 'routing_id' if successful. Otherwise it returns
+`0` and sets 'errno' to one of the values defined below.
+
+
+ERRORS
+------
+*EINVAL*::
+The endpoint supplied is invalid.
+*EPROTONOSUPPORT*::
+The requested 'transport' protocol is not supported with 'ZMQ_PEER'.
+*ENOCOMPATPROTO*::
+The requested 'transport' protocol is not compatible with the socket type.
+*ETERM*::
+The 0MQ 'context' associated with the specified 'socket' was terminated.
+*ENOTSOCK*::
+The provided 'socket' was invalid.
+*EMTHREAD*::
+No I/O thread is available to accomplish the task.
+*ENOTSUP*::
+The socket is not of type 'ZMQ_PEER'.
+*EFAULT*::
+The 'ZMQ_IMMEDIATE' option is set on the socket.
+
+EXAMPLE
+-------
+.Connecting a peer socket to a TCP transport and sending a message
+----
+/* Create a ZMQ_SUB socket */
+void *socket = zmq_socket (context, ZMQ_PEER);
+assert (socket);
+/* Connect it to the host server001, port 5555 using a TCP transport */
+uint32_t routing_id = zmq_connect (socket, "tcp://server001:5555");
+assert (routing_id == 0);
+/* Sending a message to the peer  */
+zmq_msg_t msg;
+int rc = zmq_msg_init_data (&msg, "HELLO", 5, NULL, NULL);
+assert (rc == 0);
+rc = zmq_msg_set_routing_id (&msg, routing_id);
+assert (rc == 0);
+rc = zmq_msg_send (&msg, socket, 0);
+assert (rc == 5);
+rc = zmq_msg_close (&msg);
+assert (rc == 0);
+----
+
+
+SEE ALSO
+--------
+linkzmq:zmq_connect[3]
+linkzmq:zmq_bind[3]
+linkzmq:zmq_socket[3]
+linkzmq:zmq[7]
+
+
+AUTHORS
+-------
+This page was written by the 0MQ community. To make a change please
+read the 0MQ Contribution Policy at <http://www.zeromq.org/docs:contributing>.
diff -pruN 4.3.2-2/doc/zmq_connect.txt 4.3.3-1/doc/zmq_connect.txt
--- 4.3.2-2/doc/zmq_connect.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_connect.txt	2020-09-07 10:12:14.000000000 +0000
@@ -28,8 +28,9 @@ The 'endpoint' is a string consisting of
 'inproc':: local in-process (inter-thread) communication transport, see linkzmq:zmq_inproc[7]
 'pgm', 'epgm':: reliable multicast transport using PGM, see linkzmq:zmq_pgm[7]
 'vmci':: virtual machine communications interface (VMCI), see linkzmq:zmq_vmci[7]
+'udp':: unreliable unicast and multicast using UDP, see linkzmq:zmq_udp[7]
 
-Every 0MQ socket type except 'ZMQ_PAIR' supports one-to-many and many-to-one
+Every 0MQ socket type except 'ZMQ_PAIR' and 'ZMQ_CHANNEL' supports one-to-many and many-to-one
 semantics. The precise semantics depend on the socket type and are defined in
 linkzmq:zmq_socket[3].
 
@@ -38,7 +39,7 @@ immediately but as needed by 0MQ. Thus a
 does not mean that the connection was or could actually be established.
 Because of this, for most transports and socket types the order in which
 a 'server' socket is bound and a 'client' socket is connected to it does not
-matter. The _ZMQ_PAIR_ sockets are an exception, as they do not automatically
+matter. The _ZMQ_PAIR_ and _ZMQ_CHANNEL_ sockets are an exception, as they do not automatically
 reconnect to endpoints.
 
 NOTE: following a _zmq_connect()_, for socket types except for ZMQ_ROUTER,
diff -pruN 4.3.2-2/doc/zmq_ctx_get_ext.txt 4.3.3-1/doc/zmq_ctx_get_ext.txt
--- 4.3.2-2/doc/zmq_ctx_get_ext.txt	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/doc/zmq_ctx_get_ext.txt	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,82 @@
+zmq_ctx_get_ext(3)
+==================
+
+
+NAME
+----
+
+zmq_ctx_get_ext - get extended context options
+
+
+SYNOPSIS
+--------
+*int zmq_ctx_get_ext (void '*context', int 'option_name', void '*option_value', size_t '*option_len');*
+
+
+DESCRIPTION
+-----------
+The _zmq_ctx_get()_ function shall retrieve the value for the option
+specified by the 'option_name' argument and store it in the buffer pointed to
+by the 'option_value' argument. 
+The 'option_len' argument is the size in bytes of the buffer pointed
+to by 'option_value'; upon successful completion _zmq_ctx_get_ext()_ shall
+modify the 'option_len' argument to indicate the actual size of the option
+value stored in the buffer.
+
+The _zmq_ctx_get_ext()_ function accepts all the option names accepted by
+_zmq_ctx_get()_.
+Options that make most sense to retrieve using _zmq_ctx_get_ext()_ instead of
+_zmq_ctx_get()_ are:
+
+ZMQ_THREAD_NAME_PREFIX: Get name prefix for I/O threads
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+The 'ZMQ_THREAD_NAME_PREFIX' argument gets the string prefix of each thread
+created for the internal context's thread pool.
+
+[horizontal]
+Option value type:: character string
+Option value unit:: N/A
+Default value:: empty string
+
+
+RETURN VALUE
+------------
+The _zmq_ctx_get_ext()_ function returns a value of 0 or greater if successful.
+Otherwise it returns `-1` and sets 'errno' to one of the values defined
+below.
+
+
+ERRORS
+------
+*EINVAL*::
+The requested option _option_name_ is unknown.
+
+
+EXAMPLE
+-------
+.Setting a prefix on internal ZMQ threda names:
+----
+void *context = zmq_ctx_new ();
+const char prefix[] = "MyApp";
+size_t prefixLen = sizeof(prefix);
+zmq_ctx_set (context, ZMQ_THREAD_NAME_PREFIX, &prefix, &prefixLen);
+
+char buff[256];
+size_t buffLen = sizeof(buff);
+int rc = zmq_ctx_get (context, ZMQ_THREAD_NAME_PREFIX, &buff, &buffLen);
+assert (rc == 0);
+assert (buffLen == prefixLen);
+
+----
+
+
+SEE ALSO
+--------
+linkzmq:zmq_ctx_get[3]
+linkzmq:zmq[7]
+
+
+AUTHORS
+-------
+This page was written by the 0MQ community. To make a change please
+read the 0MQ Contribution Policy at <http://www.zeromq.org/docs:contributing>.
diff -pruN 4.3.2-2/doc/zmq_ctx_get.txt 4.3.3-1/doc/zmq_ctx_get.txt
--- 4.3.2-2/doc/zmq_ctx_get.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_ctx_get.txt	2020-09-07 10:12:14.000000000 +0000
@@ -39,9 +39,9 @@ The 'ZMQ_MAX_MSGSZ' argument returns the
 allowed for this context. Default value is INT_MAX.
 
 
-ZMQ_ZERO_COPY_RCV: Get message decoding strategy
+ZMQ_ZERO_COPY_RECV: Get message decoding strategy
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-The 'ZMQ_ZERO_COPY_RCV' argument return whether message decoder uses a zero copy
+The 'ZMQ_ZERO_COPY_RECV' argument return whether message decoder uses a zero copy
 strategy when receiving messages. Default value is 1.
 NOTE: in DRAFT state, not yet available in stable releases.
 
diff -pruN 4.3.2-2/doc/zmq_ctx_set_ext.txt 4.3.3-1/doc/zmq_ctx_set_ext.txt
--- 4.3.2-2/doc/zmq_ctx_set_ext.txt	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/doc/zmq_ctx_set_ext.txt	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,86 @@
+zmq_ctx_set_ext(3)
+==================
+
+
+NAME
+----
+
+zmq_ctx_set_ext - set extended context options
+
+
+SYNOPSIS
+--------
+*int zmq_ctx_set_ext (void '*context', int 'option_name', const void '*option_value', size_t 'option_len');*
+
+
+DESCRIPTION
+-----------
+
+The _zmq_ctx_set_ext()_ function shall set the option specified by the
+'option_name' argument to the value pointed to by the 'option_value' argument
+for the 0MQ context pointed to by the 'context' argument. The 'option_len'
+argument is the size of the option value in bytes. For options taking a value of
+type "character string", the provided byte data should either contain no zero
+bytes, or end in a single zero byte (terminating ASCII NUL character).
+
+The _zmq_ctx_set_ext()_ function accepts all the option names accepted by
+_zmq_ctx_set()_.
+Options that make most sense to set using _zmq_ctx_set_ext()_ instead of
+_zmq_ctx_set()_ are the following options:
+
+ZMQ_THREAD_NAME_PREFIX: Set name prefix for I/O threads
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+The 'ZMQ_THREAD_NAME_PREFIX' argument sets a string prefix to each thread
+created for the internal context's thread pool. This option is only supported on Linux.
+This option is useful to help  debugging done via "top -H" or "gdb"; in case
+multiple processes on the system are using ZeroMQ it is useful to provide through
+this context option an application-specific prefix to distinguish ZeroMQ background
+threads that belong to different processes.
+This option only applies before creating any sockets on the context.
+
+[horizontal]
+Option value type:: character string
+Option value unit:: N/A
+Default value:: empty string
+
+
+RETURN VALUE
+------------
+The _zmq_ctx_set_ext()_ function returns zero if successful. Otherwise it
+returns `-1` and sets 'errno' to one of the values defined below.
+
+
+ERRORS
+------
+*EINVAL*::
+The requested option _option_name_ is unknown.
+
+
+EXAMPLE
+-------
+.Setting a prefix on internal ZMQ threda names:
+----
+void *context = zmq_ctx_new ();
+const char prefix[] = "MyApp";
+size_t prefixLen = sizeof(prefix);
+zmq_ctx_set (context, ZMQ_THREAD_NAME_PREFIX, &prefix, &prefixLen);
+
+char buff[256];
+size_t buffLen = sizeof(buff);
+int rc = zmq_ctx_get (context, ZMQ_THREAD_NAME_PREFIX, &buff, &buffLen);
+assert (rc == 0);
+assert (buffLen == prefixLen);
+
+----
+
+
+SEE ALSO
+--------
+linkzmq:zmq_ctx_set[3]
+linkzmq:zmq[7]
+
+
+AUTHORS
+-------
+This page was written by the 0MQ community. To make a change please
+read the 0MQ Contribution Policy at <http://www.zeromq.org/docs:contributing>.
diff -pruN 4.3.2-2/doc/zmq_ctx_set.txt 4.3.3-1/doc/zmq_ctx_set.txt
--- 4.3.2-2/doc/zmq_ctx_set.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_ctx_set.txt	2020-09-07 10:12:14.000000000 +0000
@@ -127,9 +127,9 @@ Default value:: INT_MAX
 Maximum value:: INT_MAX
 
 
-ZMQ_ZERO_COPY_RCV: Specify message decoding strategy
+ZMQ_ZERO_COPY_RECV: Specify message decoding strategy
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-The 'ZMQ_ZERO_COPY_RCV' argument specifies whether the message decoder should
+The 'ZMQ_ZERO_COPY_RECV' argument specifies whether the message decoder should
 use a zero copy strategy when receiving messages. The zero copy strategy can
 lead to increased memory usage in some cases. This option allows you to use the
 older copying strategy. You can query the value of this option with
@@ -147,7 +147,7 @@ on the context. You can query the maxima
 linkzmq:zmq_ctx_get[3] using the 'ZMQ_SOCKET_LIMIT' option.
 
 [horizontal]
-Default value:: 1024
+Default value:: 1023
 
 
 ZMQ_IPV6: Set IPv6 option
diff -pruN 4.3.2-2/doc/zmq_ctx_shutdown.txt 4.3.3-1/doc/zmq_ctx_shutdown.txt
--- 4.3.2-2/doc/zmq_ctx_shutdown.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_ctx_shutdown.txt	2020-09-07 10:12:14.000000000 +0000
@@ -19,7 +19,9 @@ The _zmq_ctx_shutdown()_ function shall
 Context shutdown will cause any blocking operations currently in progress on 
 sockets open within 'context' to return immediately with an error code of ETERM.
 With the exception of _zmq_close()_, any further operations on sockets open within
-'context' shall fail with an error code of ETERM.
+'context' shall fail with an error code of ETERM. No further sockets can be created
+using _zmq_socket()_ on a context for which _zmq_ctx_shutdown()_ has been called,
+it will return and set errno to ETERM.
 
 This function is optional, client code is still required to call the linkzmq:zmq_ctx_term[3]
 function to free all resources allocated by zeromq.
diff -pruN 4.3.2-2/doc/zmq_getsockopt.txt 4.3.3-1/doc/zmq_getsockopt.txt
--- 4.3.2-2/doc/zmq_getsockopt.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_getsockopt.txt	2020-09-07 10:12:14.000000000 +0000
@@ -297,8 +297,8 @@ Applicable socket types:: all but ZMQ_ST
 
 ZMQ_IDENTITY: Retrieve socket identity
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-This option name is now deprecated. Use ZMQ_ROUTING_ID instead. 
-ZMQ_IDENTITY remains as an alias for now. 
+This option name is now deprecated. Use ZMQ_ROUTING_ID instead.
+ZMQ_IDENTITY remains as an alias for now.
 
 
 ZMQ_IMMEDIATE: Retrieve attach-on-connect value
@@ -626,6 +626,22 @@ Default value:: 0 (only use ZMQ_RECONNEC
 Applicable socket types:: all, only for connection-oriented transport
 
 
+ZMQ_RECONNECT_STOP: Retrieve condition where reconnection will stop
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+The 'ZMQ_RECONNECT_STOP' option shall retrieve the conditions under which
+automatic reconnection will stop.
+
+The 'ZMQ_RECONNECT_STOP_CONN_REFUSED' option will stop reconnection when 0MQ
+receives the ECONNREFUSED return code from the connect.  This indicates that
+there is no code bound to the specified endpoint.
+
+[horizontal]
+Option value type:: int
+Option value unit:: 'ZMQ_RECONNECT_STOP_CONN_REFUSED'
+Default value:: 0
+Applicable socket types:: all, only for connection-oriented transports
+
+
 ZMQ_RECOVERY_IVL: Get multicast recovery interval
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 The 'ZMQ_RECOVERY_IVL' option shall retrieve the recovery interval for
@@ -786,11 +802,12 @@ Applicable socket types:: all, when usin
 ZMQ_THREAD_SAFE: Retrieve socket thread safety
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 The 'ZMQ_THREAD_SAFE' option shall retrieve a boolean value indicating whether
-or not the socket is threadsafe. Currently 'ZMQ_CLIENT' and 'ZMQ_SERVER' sockets
-are threadsafe.
+or not the socket is threadsafe. See linkzmq:zmq_socket[3] for which sockets are
+thread-safe.
 
 [horizontal]
-Option value type:: boolean
+Option value type:: int
+Option value unit:: boolean
 Applicable socket types:: all
 
 
@@ -823,7 +840,7 @@ ZMQ_ZAP_DOMAIN: Retrieve RFC 27 authenti
 
 The 'ZMQ_ZAP_DOMAIN' option shall retrieve the last ZAP domain set for
 the socket. The returned value shall be a NULL-terminated string and MAY
-be empty. An empty string means that ZAP authentication is disabled. 
+be empty. An empty string means that ZAP authentication is disabled.
 The returned size SHALL include the terminating null byte.
 
 [horizontal]
diff -pruN 4.3.2-2/doc/zmq_msg_close.txt 4.3.3-1/doc/zmq_msg_close.txt
--- 4.3.2-2/doc/zmq_msg_close.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_close.txt	2020-09-07 10:12:14.000000000 +0000
@@ -44,6 +44,7 @@ SEE ALSO
 --------
 linkzmq:zmq_msg_init[3]
 linkzmq:zmq_msg_init_size[3]
+linkzmq:zmq_msg_init_buffer[3]
 linkzmq:zmq_msg_init_data[3]
 linkzmq:zmq_msg_data[3]
 linkzmq:zmq_msg_size[3]
diff -pruN 4.3.2-2/doc/zmq_msg_copy.txt 4.3.3-1/doc/zmq_msg_copy.txt
--- 4.3.2-2/doc/zmq_msg_copy.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_copy.txt	2020-09-07 10:12:14.000000000 +0000
@@ -22,8 +22,8 @@ CAUTION: The implementation may choose n
 content, rather to share the underlying buffer between 'src' and 'dest'. Avoid
 modifying message content after a message has been copied with
 _zmq_msg_copy()_, doing so can result in undefined behaviour. If what you need
-is an actual hard copy, allocate a new message using _zmq_msg_init_size()_ and
-copy the message content using _memcpy()_.
+is an actual hard copy, initialize a new message using _zmq_msg_init_buffer()_
+with the message content.
 
 CAUTION: Never access 'zmq_msg_t' members directly, instead always use the
 _zmq_msg_ family of functions.
@@ -46,8 +46,7 @@ EXAMPLE
 .Copying a message
 ----
 zmq_msg_t msg;
-zmq_msg_init_size (&msg, 255);
-memcpy (zmq_msg_data (&msg, "Hello, World", 12);
+zmq_msg_init_buffer (&msg, "Hello, World", 12);
 zmq_msg_t copy;
 zmq_msg_init (&copy);
 zmq_msg_copy (&copy, &msg);
@@ -61,6 +60,7 @@ SEE ALSO
 linkzmq:zmq_msg_move[3]
 linkzmq:zmq_msg_init[3]
 linkzmq:zmq_msg_init_size[3]
+linkzmq:zmq_msg_init_buffer[3]
 linkzmq:zmq_msg_init_data[3]
 linkzmq:zmq_msg_close[3]
 linkzmq:zmq[7]
diff -pruN 4.3.2-2/doc/zmq_msg_data.txt 4.3.3-1/doc/zmq_msg_data.txt
--- 4.3.2-2/doc/zmq_msg_data.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_data.txt	2020-09-07 10:12:14.000000000 +0000
@@ -37,6 +37,7 @@ SEE ALSO
 linkzmq:zmq_msg_size[3]
 linkzmq:zmq_msg_init[3]
 linkzmq:zmq_msg_init_size[3]
+linkzmq:zmq_msg_init_buffer[3]
 linkzmq:zmq_msg_init_data[3]
 linkzmq:zmq_msg_close[3]
 linkzmq:zmq[7]
diff -pruN 4.3.2-2/doc/zmq_msg_init_buffer.txt 4.3.3-1/doc/zmq_msg_init_buffer.txt
--- 4.3.2-2/doc/zmq_msg_init_buffer.txt	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_init_buffer.txt	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,59 @@
+zmq_msg_init_buffer(3)
+======================
+
+
+NAME
+----
+zmq_msg_init_buffer - initialise 0MQ message with buffer copy
+
+
+SYNOPSIS
+--------
+*int zmq_msg_init_buffer (zmq_msg_t '*msg', const void '*buf', size_t 'size');*
+
+
+DESCRIPTION
+-----------
+The _zmq_msg_init_buffer()_ function shall allocate any resources required to
+store a message 'size' bytes long and initialise the message object referenced
+by 'msg' to represent a copy of the buffer referenced by the 'buf' and
+'size' arguments.
+
+The implementation shall choose whether to store message content on the stack
+(small messages) or on the heap (large messages).
+
+CAUTION: Never access 'zmq_msg_t' members directly, instead always use the
+_zmq_msg_ family of functions.
+
+CAUTION: The functions _zmq_msg_init()_, _zmq_msg_init_data()_,
+_zmq_msg_init_buffer()_ and _zmq_msg_init_buffer()_ are mutually exclusive.
+Never initialise the same 'zmq_msg_t' twice.
+
+
+RETURN VALUE
+------------
+The _zmq_msg_init_buffer()_ function shall return zero if successful. Otherwise
+it shall return `-1` and set 'errno' to one of the values defined below.
+
+
+ERRORS
+------
+*ENOMEM*::
+Insufficient storage space is available.
+
+
+SEE ALSO
+--------
+linkzmq:zmq_msg_init_data[3]
+linkzmq:zmq_msg_init_size[3]
+linkzmq:zmq_msg_init[3]
+linkzmq:zmq_msg_close[3]
+linkzmq:zmq_msg_data[3]
+linkzmq:zmq_msg_size[3]
+linkzmq:zmq[7]
+
+
+AUTHORS
+-------
+This page was written by the 0MQ community. To make a change please
+read the 0MQ Contribution Policy at <http://www.zeromq.org/docs:contributing>.
diff -pruN 4.3.2-2/doc/zmq_msg_init_data.txt 4.3.3-1/doc/zmq_msg_init_data.txt
--- 4.3.2-2/doc/zmq_msg_init_data.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_init_data.txt	2020-09-07 10:12:14.000000000 +0000
@@ -35,9 +35,9 @@ CAUTION: If the deallocation function is
 will not be freed, and this may cause a memory leak.
 
 
-CAUTION: The functions _zmq_msg_init()_, _zmq_msg_init_data()_ and
-_zmq_msg_init_size()_ are mutually exclusive. Never initialise the same
-'zmq_msg_t' twice.
+CAUTION: The functions _zmq_msg_init()_, _zmq_msg_init_data()_,
+_zmq_msg_init_size()_ and _zmq_msg_init_buffer()_ are mutually exclusive.
+Never initialise the same 'zmq_msg_t' twice.
 
 
 RETURN VALUE
@@ -76,6 +76,7 @@ assert (rc == 0);
 SEE ALSO
 --------
 linkzmq:zmq_msg_init_size[3]
+linkzmq:zmq_msg_init_buffer[3]
 linkzmq:zmq_msg_init[3]
 linkzmq:zmq_msg_close[3]
 linkzmq:zmq_msg_data[3]
diff -pruN 4.3.2-2/doc/zmq_msg_init_size.txt 4.3.3-1/doc/zmq_msg_init_size.txt
--- 4.3.2-2/doc/zmq_msg_init_size.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_init_size.txt	2020-09-07 10:12:14.000000000 +0000
@@ -25,9 +25,9 @@ _zmq_msg_init_size()_ shall not clear th
 CAUTION: Never access 'zmq_msg_t' members directly, instead always use the
 _zmq_msg_ family of functions.
 
-CAUTION: The functions _zmq_msg_init()_, _zmq_msg_init_data()_ and
-_zmq_msg_init_size()_ are mutually exclusive. Never initialise the same
-'zmq_msg_t' twice.
+CAUTION: The functions _zmq_msg_init()_, _zmq_msg_init_data()_,
+_zmq_msg_init_size()_ and _zmq_msg_init_buffer()_ are mutually exclusive.
+Never initialise the same 'zmq_msg_t' twice.
 
 
 RETURN VALUE
@@ -45,6 +45,7 @@ Insufficient storage space is available.
 SEE ALSO
 --------
 linkzmq:zmq_msg_init_data[3]
+linkzmq:zmq_msg_init_buffer[3]
 linkzmq:zmq_msg_init[3]
 linkzmq:zmq_msg_close[3]
 linkzmq:zmq_msg_data[3]
diff -pruN 4.3.2-2/doc/zmq_msg_init.txt 4.3.3-1/doc/zmq_msg_init.txt
--- 4.3.2-2/doc/zmq_msg_init.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_init.txt	2020-09-07 10:12:14.000000000 +0000
@@ -21,9 +21,9 @@ before receiving a message with _zmq_msg
 CAUTION: Never access 'zmq_msg_t' members directly, instead always use the
 _zmq_msg_ family of functions.
 
-CAUTION: The functions _zmq_msg_init()_, _zmq_msg_init_data()_ and
-_zmq_msg_init_size()_ are mutually exclusive. Never initialise the same
-'zmq_msg_t' twice.
+CAUTION: The functions _zmq_msg_init()_, _zmq_msg_init_data()_,
+_zmq_msg_init_size()_ and _zmq_msg_init_buffer()_ are mutually exclusive.
+Never initialise the same 'zmq_msg_t' twice.
 
 
 RETURN VALUE
@@ -51,6 +51,7 @@ assert (nbytes != -1);
 SEE ALSO
 --------
 linkzmq:zmq_msg_init_size[3]
+linkzmq:zmq_msg_init_buffer[3]
 linkzmq:zmq_msg_init_data[3]
 linkzmq:zmq_msg_close[3]
 linkzmq:zmq_msg_data[3]
diff -pruN 4.3.2-2/doc/zmq_msg_move.txt 4.3.3-1/doc/zmq_msg_move.txt
--- 4.3.2-2/doc/zmq_msg_move.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_move.txt	2020-09-07 10:12:14.000000000 +0000
@@ -41,6 +41,7 @@ SEE ALSO
 linkzmq:zmq_msg_copy[3]
 linkzmq:zmq_msg_init[3]
 linkzmq:zmq_msg_init_size[3]
+linkzmq:zmq_msg_init_buffer[3]
 linkzmq:zmq_msg_init_data[3]
 linkzmq:zmq_msg_close[3]
 linkzmq:zmq[7]
diff -pruN 4.3.2-2/doc/zmq_msg_recv.txt 4.3.3-1/doc/zmq_msg_recv.txt
--- 4.3.2-2/doc/zmq_msg_recv.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_recv.txt	2020-09-07 10:12:14.000000000 +0000
@@ -54,7 +54,10 @@ values defined below.
 ERRORS
 ------
 *EAGAIN*::
-Non-blocking mode was requested and no messages are available at the moment.
+Either the timeout set via the socket-option ZMQ_RCVTIMEO (see linkzmq:zmq_setsockopt[3])
+has been reached (flag ZMQ_DONTWAIT not set) without being able to read a message
+from the socket or there are no messages available at the moment (flag ZMQ_DONTWAIT set)
+and the operation would block.
 *ENOTSUP*::
 The _zmq_msg_recv()_ operation is not supported by this socket type.
 *EFSM*::
@@ -114,6 +117,7 @@ linkzmq:zmq_recv[3]
 linkzmq:zmq_send[3]
 linkzmq:zmq_msg_send[3]
 linkzmq:zmq_getsockopt[3]
+linkzmq:zmq_setsockopt[3]
 linkzmq:zmq_socket[7]
 linkzmq:zmq[7]
 
diff -pruN 4.3.2-2/doc/zmq_msg_send.txt 4.3.3-1/doc/zmq_msg_send.txt
--- 4.3.2-2/doc/zmq_msg_send.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_send.txt	2020-09-07 10:12:14.000000000 +0000
@@ -23,10 +23,11 @@ argument to be sent to the socket refere
 'flags' argument is a combination of the flags defined below:
 
 *ZMQ_DONTWAIT*::
-For socket types (DEALER, PUSH) that block when there are no available peers 
-(or all peers have full high-water mark), specifies that the operation should 
-be performed in non-blocking mode. If the message cannot be queued on the 
-'socket', the _zmq_msg_send()_ function shall fail with 'errno' set to EAGAIN. 
+For socket types (DEALER, PUSH) that block (either with ZMQ_IMMEDIATE option set
+and no peer available, or all peers having full high-water mark), specifies that
+the operation should be performed in non-blocking mode. If the message cannot be
+queued on the 'socket', the _zmq_msg_send()_ function shall fail with 'errno' set
+to EAGAIN.
 
 *ZMQ_SNDMORE*::
 Specifies that the message being sent is a multi-part message, and that further
diff -pruN 4.3.2-2/doc/zmq_msg_size.txt 4.3.3-1/doc/zmq_msg_size.txt
--- 4.3.2-2/doc/zmq_msg_size.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_msg_size.txt	2020-09-07 10:12:14.000000000 +0000
@@ -37,6 +37,7 @@ SEE ALSO
 linkzmq:zmq_msg_data[3]
 linkzmq:zmq_msg_init[3]
 linkzmq:zmq_msg_init_size[3]
+linkzmq:zmq_msg_init_buffer[3]
 linkzmq:zmq_msg_init_data[3]
 linkzmq:zmq_msg_close[3]
 linkzmq:zmq[7]
diff -pruN 4.3.2-2/doc/zmq_poller.txt 4.3.3-1/doc/zmq_poller.txt
--- 4.3.2-2/doc/zmq_poller.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_poller.txt	2020-09-07 10:12:14.000000000 +0000
@@ -11,25 +11,33 @@ SYNOPSIS
 --------
 
 *void *zmq_poller_new (void);*
-*int zmq_poller_destroy (void **'poller_p');*
 
-*int zmq_poller_add (void *'poller', void *'socket', void *'user_data', short 'events');
-*int zmq_poller_modify (void *'poller', void *'socket', short 'events');*
-*int zmq_poller_remove (void *'poller', void *'socket');*
-
-*int zmq_poller_add_fd (void *'poller', int 'fd', void *'user_data', short 'events');*
-*int zmq_poller_modify_fd (void *'poller', int 'fd', short 'events');*
-*int zmq_poller_remove_fd (void *'poller', int 'fd');*
+*int zmq_poller_destroy (void '*poller_p');*
 
-*int zmq_poller_wait (void *'poller',
-                          zmq_poller_event_t *'event',
+*int zmq_poller_size (void '*poller');*
+
+*int zmq_poller_add (void '*poller', void '*socket', void '*user_data', short 'events');*
+
+*int zmq_poller_modify (void '*poller', void '*socket', short 'events');*
+
+*int zmq_poller_remove (void '*poller', void '*socket');*
+
+*int zmq_poller_add_fd (void '*poller', int 'fd', void '*user_data', short 'events');*
+
+*int zmq_poller_modify_fd (void '*poller', int 'fd', short 'events');*
+
+*int zmq_poller_remove_fd (void '*poller', int 'fd');*
+
+*int zmq_poller_wait (void '*poller',
+                          zmq_poller_event_t '*event',
                           long 'timeout');*
-*int zmq_poller_wait_all (void *'poller',
-                          zmq_poller_event_t *'events',
+
+*int zmq_poller_wait_all (void '*poller',
+                          zmq_poller_event_t '*events',
                           int 'n_events',
                           long 'timeout');*
 
-*int zmq_poller_fd (void *'poller', zmq_fd_t *'fd');*
+*int zmq_poller_fd (void '*poller', zmq_fd_t '*fd');*
 
 DESCRIPTION
 -----------
@@ -45,6 +53,11 @@ instance. _zmq_poller_destroy_ sets the
 successful execution. _zmq_poller_destroy_ implicitly unregisters all
 registered sockets and file descriptors.
 
+_zmq_poller_size_ queries the number of sockets or file descriptors registered
+with a poller. The initial size of a poller is 0, a successful add operation
+increases the size by 1 and a successful remove operation decreases the size
+by 1. The size is unaffected by the events specified.
+
 _zmq_poller_add_, _zmq_poller_modify_ and _zmq_poller_remove_ manage the 0MQ
 sockets registered with a poller.
 
@@ -56,8 +69,11 @@ In addition, _user_data_ may be specifie
 passed back to the caller when an event was signalled in a call to
 _zmq_poller_wait_ or _zmq_poller_wait_all_. _user_data_ may be NULL. If it is
 not NULL, it must be a valid pointer. Otherwise, behaviour is undefined.
-_zmq_poller_add_ may not be called multiple times for the same socket
-(unless _zmq_poller_remove_ has been called for that socket).
+You must only add a socket to a single poller instance once (unless 
+_zmq_poller_remove_ has been called for that socket before). You may
+add a socket to multiple poller instances, if the socket itself
+is explicitly thread-safe (Server, Client, ...). If the socket is not,
+you may invoke undefined behavior.
 
 _zmq_poller_modify_ modifies the subscribed events for a socket. It is
 legal to specify no events (i.e. 0) to disable events temporarily, and
@@ -88,11 +104,7 @@ The *zmq_poller_event_t* structure is de
 typedef struct
 {
     void *socket;
-#if defined _WIN32
-    SOCKET fd;
-#else
-    int fd;
-#endif
+    zmq_fd_t fd;
     void *user_data;
     short events;
 } zmq_poller_event_t;
@@ -120,11 +132,15 @@ registered objects. Otherwise, a liveloc
 'n_events' registered objects have an active event on each call to 
 _zmq_poller_wait_all_, it might happen that the same subset of registered 
 objects is always returned, and the caller never notices the events on the 
-others.
+others. The number of objects registered can be queried with
+_zmq_poller_size_.
 
 _zmq_poller_wait_all_ returns the number of valid elements. The valid elements
 are placed in positions '0' to 'n_events - 1' in the 'events' array. All
 members of a valid element are set to valid values by _zmq_poller_wait_all_.
+For socket events 'socket' is non-null and 'fd' is an operating system
+specific value for an invalid socket (-1 or INVALID_SOCKET). For fd events
+'socket' is NULL and 'fd' is a valid file descriptor.
 The client does therefore not need to initialize the contents of the events
 array before a call to _zmq_poller_wait_all_. It is unspecified whether the
 the remaining elements of 'events' are written to by _zmq_poller_wait_all_.
@@ -134,6 +150,9 @@ and stores it in the address pointer to
 The zmq_poller is only guaranteed to have a file descriptor if
 at least one thread-safe socket is currently registered.
 
+Note that closing a socket that is registered in a poller leads to undefined
+behavior. The socket must be unregistered first.
+
 EVENT TYPES
 -----------
 
@@ -180,6 +199,10 @@ THREAD SAFETY
 Like most other 0MQ objects, a poller is not thread-safe. All operations must
 be called from the same thread. Otherwise, behaviour is undefined.
 
+In addition to that, if you want to add a socket to multiple existing poller
+instances, the socket itself needs to be thread-safe (Server, Client, ...).
+Otherwise, behaviour is undefined. 
+
 RETURN VALUE
 ------------
 _zmq_poller_new_ returns a valid pointer to a poller, or NULL in case of a failure.
@@ -203,6 +226,12 @@ On _zmq_poller_destroy_:
 _poller_p_ did not point to a valid poller. Note that passing an invalid pointer (e.g.
 pointer to deallocated memory) may cause undefined behaviour (e.g. an access violation).
 
+On _zmq_poller_size_:
+*EFAULT*::
+_poller_ did not point to a valid poller. Note that passing an
+invalid pointer (e.g. pointer to deallocated memory) may cause undefined
+behaviour (e.g. an access violation).
+
 On _zmq_poller_add_, _zmq_poller_modify_ and _zmq_poller_remove_:
 *EFAULT*::
 _poller_ did not point to a valid poller. Note that passing an
@@ -240,14 +269,15 @@ At least one of the registered objects i
 'context' was terminated.
 *EFAULT*::
 The provided 'events' was NULL, or 'poller' did not point to a valid poller,
-or there are no registered objects and 'timeout' was negative.
+or there are no registered objects or all event subscriptions are disabled
+and 'timeout' was negative.
 *EINTR*::
 The operation was interrupted by delivery of a signal before any events were
 available.
 *EAGAIN*::
 No registered event was signalled before the timeout was reached.
 
-On _zmq_poller_fd:
+On _zmq_poller_fd_:
 *EINVAL*::
 The poller has no associated file descriptor.
 *EFAULT*::
@@ -261,14 +291,14 @@ void *poller = zmq_poller_new ();
 
 zmq_poller_event_t events [2];
 /* First item refers to 0MQ socket 'socket' */
-zmq_poller_add (poller, socket, ZMQ_POLLIN, NULL);
+zmq_poller_add (poller, socket, NULL, ZMQ_POLLIN);
 /* Second item refers to standard socket 'fd' */
-zmq_poller_add_fd (poller, fd, ZMQ_POLLIN, NULL);
+zmq_poller_add_fd (poller, fd, NULL, ZMQ_POLLIN);
 /* Poll for events indefinitely */
-int rc = zmq_poller_wait_all (items, events, 2, -1);
+int rc = zmq_poller_wait_all (poller, events, 2, -1);
 assert (rc >= 0);
 /* Returned events will be stored in 'events' */
-zmq_poller_destroy (&poller);
+zmq_poller_destroy (poller);
 ----
 
 
diff -pruN 4.3.2-2/doc/zmq_poll.txt 4.3.3-1/doc/zmq_poll.txt
--- 4.3.2-2/doc/zmq_poll.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_poll.txt	2020-09-07 10:12:14.000000000 +0000
@@ -80,6 +80,16 @@ NOTE: The _zmq_poll()_ function may be i
 system interfaces other than _poll()_, and as such may be subject to the limits
 of those interfaces in ways not defined in this documentation.
 
+THREAD SAFETY
+-------------
+The *zmq_pollitem_t* array must only be used by the thread which 
+will/is calling _zmq_poll_.
+
+If a socket is contained in multiple *zmq_pollitem_t* arrays, each owned by a
+different thread, the socket itself needs to be thead-safe (Server, Client, ...).
+Otherwise, behaviour is undefined.
+
+
 RETURN VALUE
 ------------
 Upon successful completion, the _zmq_poll()_ function shall return the number
diff -pruN 4.3.2-2/doc/zmq_recvmsg.txt 4.3.3-1/doc/zmq_recvmsg.txt
--- 4.3.2-2/doc/zmq_recvmsg.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_recvmsg.txt	2020-09-07 10:12:14.000000000 +0000
@@ -52,7 +52,10 @@ values defined below.
 ERRORS
 ------
 *EAGAIN*::
-Non-blocking mode was requested and no messages are available at the moment.
+Either the timeout set via the socket-option ZMQ_RCVTIMEO (see linkzmq:zmq_setsockopt[3])
+has been reached (flag ZMQ_DONTWAIT not set) without being able to read a message
+from the socket or there are no messages available at the moment (flag ZMQ_DONTWAIT set)
+and the operation would block.
 *ENOTSUP*::
 The _zmq_recvmsg()_ operation is not supported by this socket type.
 *EFSM*::
@@ -111,6 +114,7 @@ SEE ALSO
 linkzmq:zmq_recv[3]
 linkzmq:zmq_send[3]
 linkzmq:zmq_getsockopt[3]
+linkzmq:zmq_setsockopt[3]
 linkzmq:zmq_socket[7]
 linkzmq:zmq[7]
 
diff -pruN 4.3.2-2/doc/zmq_recv.txt 4.3.3-1/doc/zmq_recv.txt
--- 4.3.2-2/doc/zmq_recv.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_recv.txt	2020-09-07 10:12:14.000000000 +0000
@@ -50,7 +50,10 @@ in case the message was truncated. If no
 ERRORS
 ------
 *EAGAIN*::
-Non-blocking mode was requested and no messages are available at the moment.
+Either the timeout set via the socket-option ZMQ_RCVTIMEO (see linkzmq:zmq_setsockopt[3])
+has been reached (flag ZMQ_DONTWAIT not set) without being able to read a message
+from the socket or there are no messages available at the moment (flag ZMQ_DONTWAIT set)
+and the operation would block.
 *ENOTSUP*::
 The _zmq_recv()_ operation is not supported by this socket type.
 *EFSM*::
@@ -81,6 +84,7 @@ SEE ALSO
 --------
 linkzmq:zmq_send[3]
 linkzmq:zmq_getsockopt[3]
+linkzmq:zmq_setsockopt[3]
 linkzmq:zmq_socket[7]
 linkzmq:zmq[7]
 
diff -pruN 4.3.2-2/doc/zmq_send_const.txt 4.3.3-1/doc/zmq_send_const.txt
--- 4.3.2-2/doc/zmq_send_const.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_send_const.txt	2020-09-07 10:12:14.000000000 +0000
@@ -9,7 +9,7 @@ zmq_send_const - send a constant-memory
 
 SYNOPSIS
 --------
-*int zmq_send_const (void '*socket', void '*buf', size_t 'len', int 'flags');*
+*int zmq_send_const (void '*socket', const void '*buf', size_t 'len', int 'flags');*
 
 
 DESCRIPTION
@@ -20,10 +20,11 @@ to be constant-memory and will therefore
 in any way. The 'flags' argument is a combination of the flags defined below:
 
 *ZMQ_DONTWAIT*::
-For socket types (DEALER, PUSH) that block when there are no available peers 
-(or all peers have full high-water mark), specifies that the operation should 
-be performed in non-blocking mode. If the message cannot be queued on the 
-'socket', the _zmq_send_const()_ function shall fail with 'errno' set to EAGAIN.
+For socket types (DEALER, PUSH) that block (either with ZMQ_IMMEDIATE option set
+and no peer available, or all peers having full high-water mark), specifies that
+the operation should be performed in non-blocking mode. If the message cannot be
+queued on the 'socket', the _zmq_send_const()_ function shall fail with 'errno' set
+to EAGAIN.
 
 *ZMQ_SNDMORE*::
 Specifies that the message being sent is a multi-part message, and that further
diff -pruN 4.3.2-2/doc/zmq_sendmsg.txt 4.3.3-1/doc/zmq_sendmsg.txt
--- 4.3.2-2/doc/zmq_sendmsg.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_sendmsg.txt	2020-09-07 10:12:14.000000000 +0000
@@ -19,10 +19,11 @@ argument to be sent to the socket refere
 'flags' argument is a combination of the flags defined below:
 
 *ZMQ_DONTWAIT*::
-For socket types (DEALER, PUSH) that block when there are no available peers 
-(or all peers have full high-water mark), specifies that the operation should 
-be performed in non-blocking mode. If the message cannot be queued on the 
-'socket', the _zmq_sendmsg()_ function shall fail with 'errno' set to EAGAIN.
+For socket types (DEALER, PUSH) that block (either with ZMQ_IMMEDIATE option set
+and no peer available, or all peers having full high-water mark), specifies that
+the operation should be performed in non-blocking mode. If the message cannot be
+queued on the 'socket', the _zmq_sendmsg()_ function shall fail with 'errno' set
+to EAGAIN.
 
 *ZMQ_SNDMORE*::
 Specifies that the message being sent is a multi-part message, and that further
diff -pruN 4.3.2-2/doc/zmq_send.txt 4.3.3-1/doc/zmq_send.txt
--- 4.3.2-2/doc/zmq_send.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_send.txt	2020-09-07 10:12:14.000000000 +0000
@@ -9,7 +9,7 @@ zmq_send - send a message part on a sock
 
 SYNOPSIS
 --------
-*int zmq_send (void '*socket', void '*buf', size_t 'len', int 'flags');*
+*int zmq_send (void '*socket', const void '*buf', size_t 'len', int 'flags');*
 
 
 DESCRIPTION
@@ -19,10 +19,11 @@ referenced by the 'buf' and 'len' argume
 a combination of the flags defined below:
 
 *ZMQ_DONTWAIT*::
-For socket types (DEALER, PUSH) that block when there are no available peers 
-(or all peers have full high-water mark), specifies that the operation should 
-be performed in non-blocking mode. If the message cannot be queued on the 
-'socket', the _zmq_send()_ function shall fail with 'errno' set to EAGAIN.
+For socket types (DEALER, PUSH) that block (either with ZMQ_IMMEDIATE option set
+and no peer available, or all peers having full high-water mark), specifies that
+the operation should be performed in non-blocking mode. If the message cannot be
+queued on the 'socket', the _zmq_send()_ function shall fail with 'errno' set
+to EAGAIN.
 
 *ZMQ_SNDMORE*::
 Specifies that the message being sent is a multi-part message, and that further
diff -pruN 4.3.2-2/doc/zmq_setsockopt.txt 4.3.3-1/doc/zmq_setsockopt.txt
--- 4.3.2-2/doc/zmq_setsockopt.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_setsockopt.txt	2020-09-07 10:12:14.000000000 +0000
@@ -87,30 +87,30 @@ Default value:: not set
 Applicable socket types:: all, when using TCP or UDP transports.
 
 
-ZMQ_CONNECT_RID: Assign the next outbound connection id 
+ZMQ_CONNECT_RID: Assign the next outbound connection id
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-This option name is now deprecated. Use ZMQ_CONNECT_ROUTING_ID instead. 
-ZMQ_CONNECT_RID remains as an alias for now. 
+This option name is now deprecated. Use ZMQ_CONNECT_ROUTING_ID instead.
+ZMQ_CONNECT_RID remains as an alias for now.
 
 
-ZMQ_CONNECT_ROUTING_ID: Assign the next outbound routing id 
+ZMQ_CONNECT_ROUTING_ID: Assign the next outbound routing id
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-The 'ZMQ_CONNECT_ROUTING_ID' option sets the peer id of the peer connected 
-via the next zmq_connect() call, such that that connection is immediately ready for 
+The 'ZMQ_CONNECT_ROUTING_ID' option sets the peer id of the peer connected
+via the next zmq_connect() call, such that that connection is immediately ready for
 data transfer with the given routing id.  This option applies only to the first
-subsequent call to zmq_connect(), zmq_connect() calls thereafter use the default 
-connection behaviour. 
+subsequent call to zmq_connect(), zmq_connect() calls thereafter use the default
+connection behaviour.
 
-Typical use is to set this socket option ahead of each zmq_connect() call. 
-Each connection MUST be assigned a unique routing id. Assigning a 
-routing id that is already in use is not allowed. 
+Typical use is to set this socket option ahead of each zmq_connect() call.
+Each connection MUST be assigned a unique routing id. Assigning a
+routing id that is already in use is not allowed.
 
-Useful when connecting ROUTER to ROUTER, or STREAM to STREAM, as it 
-allows for immediate sending to peers. Outbound routing id framing requirements 
+Useful when connecting ROUTER to ROUTER, or STREAM to STREAM, as it
+allows for immediate sending to peers. Outbound routing id framing requirements
 for ROUTER and STREAM sockets apply.
 
-The routing id must be from 1 to 255 bytes long and MAY NOT start with 
-a zero byte (such routing ids are reserved for internal use by the 0MQ 
+The routing id must be from 1 to 255 bytes long and MAY NOT start with
+a zero byte (such routing ids are reserved for internal use by the 0MQ
 infrastructure).
 
 [horizontal]
@@ -228,6 +228,18 @@ Option value size:: 32 or 41
 Default value:: NULL
 Applicable socket types:: all, when using TCP transport
 
+ZMQ_DISCONNECT_MSG: set a disconnect message that the socket will generate when accepted peer disconnect
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+When set, the socket will generate a disconnect message when accepted peer has been disconnected.
+You may set this on ROUTER, SERVER and PEER sockets.
+The combination with ZMQ_HEARTBEAT_IVL is powerful and simplify protocols, when heartbeat recognize a connection drop it
+will generate a disconnect message that can match the protocol of the application.
+
+[horizontal]
+Option value type:: binary data
+Option value unit:: N/A
+Default value:: NULL
+Applicable socket types:: ZMQ_ROUTER, ZMQ_SERVER and ZMQ_PEER
 
 ZMQ_GSSAPI_PLAINTEXT: Disable GSSAPI encryption
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -322,6 +334,18 @@ Option value unit:: milliseconds
 Default value:: 30000
 Applicable socket types:: all but ZMQ_STREAM, only for connection-oriented transports
 
+ZMQ_HELLO_MSG: set an hello message that will be sent when a new peer connect
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+When set, the socket will automatically send an hello message when a new connection is made or accepted.
+You may set this on DEALER, ROUTER, CLIENT, SERVER and PEER sockets.
+The combination with ZMQ_HEARTBEAT_IVL is powerful and simplify protocols,
+as now heartbeat and sending the hello message can be left out of protocols and be handled by zeromq.
+
+[horizontal]
+Option value type:: binary data
+Option value unit:: N/A
+Default value:: NULL
+Applicable socket types:: ZMQ_ROUTER, ZMQ_DEALER, ZMQ_CLIENT, ZMQ_SERVER and ZMQ_PEER
 
 ZMQ_HEARTBEAT_IVL: Set interval between sending ZMTP heartbeats
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -371,8 +395,8 @@ Applicable socket types:: all, when usin
 
 ZMQ_IDENTITY: Set socket identity
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-This option name is now deprecated. Use ZMQ_ROUTING_ID instead. 
-ZMQ_IDENTITY remains as an alias for now. 
+This option name is now deprecated. Use ZMQ_ROUTING_ID instead.
+ZMQ_IDENTITY remains as an alias for now.
 
 
 ZMQ_IMMEDIATE: Queue messages only to completed connections
@@ -701,6 +725,32 @@ Default value:: 0 (only use ZMQ_RECONNEC
 Applicable socket types:: all, only for connection-oriented transports
 
 
+ZMQ_RECONNECT_STOP: Set condition where reconnection will stop
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+The 'ZMQ_RECONNECT_STOP' option shall set the conditions under which automatic
+reconnection will stop.  This can be useful when a process binds to a
+wild-card port, where the OS supplies an ephemeral port.
+
+The 'ZMQ_RECONNECT_STOP_CONN_REFUSED' option will stop reconnection when 0MQ
+receives the ECONNREFUSED return code from the connect.  This indicates that
+there is no code bound to the specified endpoint.
+
+The 'ZMQ_RECONNECT_STOP_HANDSHAKE_FAILED' option will stop reconnection if
+the 0MQ handshake fails.  This can be used to detect and/or prevent errant
+connection attempts to non-0MQ sockets.  Note that when specifying this option
+you may also want to set `ZMQ_HANDSHAKE_IVL` -- the default handshake interval
+is 30000 (30 seconds), which is typically too large.
+
+NOTE: in DRAFT state, not yet available in stable releases.
+
+[horizontal]
+Option value type:: int
+Option value unit:: 0, ZMQ_RECONNECT_STOP_CONN_REFUSED, ZMQ_RECONNECT_STOP_HANDSHAKE_FAILED, ZMQ_RECONNECT_STOP_CONN_REFUSED | ZMQ_RECONNECT_STOP_HANDSHAKE_FAILED
+Default value:: 0
+Applicable socket types:: all, only for connection-oriented transports (ZMQ_HANDSHAKE_IVL is
+not applicable for ZMQ_STREAM sockets)
+
+
 ZMQ_RECOVERY_IVL: Set multicast recovery interval
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 The 'ZMQ_RECOVERY_IVL' option shall set the recovery interval for multicast
@@ -813,7 +863,7 @@ Applicable socket types:: ZMQ_ROUTER
 ZMQ_ROUTING_ID: Set socket routing id
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 The 'ZMQ_ROUTING_ID' option shall set the routing id of the specified 'socket'
-when connecting to a ROUTER socket. 
+when connecting to a ROUTER socket.
 
 A routing id must be at least one byte and at most 255 bytes long. Identities
 starting with a zero byte are reserved for use by the 0MQ infrastructure.
@@ -1094,7 +1144,7 @@ ZMQ_XPUB_MANUAL: change the subscription
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Sets the 'XPUB' socket subscription handling mode manual/automatic.
 A value of '0' is the default and subscription requests will be handled automatically.
-A value of '1' will change the subscription requests handling to manual, 
+A value of '1' will change the subscription requests handling to manual,
 with manual mode subscription requests are not added to the subscription list.
 To add subscription the user need to call setsockopt with ZMQ_SUBSCRIBE on XPUB socket.
 
@@ -1125,7 +1175,7 @@ Applicable socket types:: ZMQ_XPUB
 ZMQ_XPUB_NODROP: do not silently drop messages if SENDHWM is reached
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Sets the 'XPUB' socket behaviour to return error EAGAIN if SENDHWM is
-reached and the message could not be send. 
+reached and the message could not be send.
 
 A value of `0` is the default and drops the message silently when the peers
 SNDHWM is reached.  A value of `1` returns an 'EAGAIN' error code if the
@@ -1154,10 +1204,26 @@ Default value:: NULL
 Applicable socket types:: ZMQ_XPUB
 
 
+ZMQ_ONLY_FIRST_SUBSCRIBE: Process only first subscribe/unsubscribe in a multipart message
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+If set, only the first part of the multipart message is processed as
+a subscribe/unsubscribe message. The rest are forwarded as user data
+regardless of message contents.
+
+It not set (default), subscribe/unsubscribe messages in a multipart message
+are processed as such regardless of their number and order.
+
+[horizontal]
+Option value type:: int
+Option value unit:: boolean
+Default value:: 0 (false)
+Applicable socket types:: ZMQ_XSUB, ZMQ_XPUB
+
+
 ZMQ_ZAP_DOMAIN: Set RFC 27 authentication domain
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-Sets the domain for ZAP (ZMQ RFC 27) authentication. A ZAP domain must be 
-specified to enable authentication. When the ZAP domain is empty, which is 
+Sets the domain for ZAP (ZMQ RFC 27) authentication. A ZAP domain must be
+specified to enable authentication. When the ZAP domain is empty, which is
 the default, ZAP authentication is disabled. This is not compatible with
 previous versions of libzmq, so it can be controlled by ZMQ_ZAP_ENFORCE_DOMAIN
 which for now is disabled by default.
@@ -1196,7 +1262,7 @@ all filters call zmq_setsockopt(socket,
 Filter is a null-terminated string with ipv6 or ipv4 CIDR.
 
 NOTE: This option is deprecated, please use authentication via the ZAP API
-and IP address whitelisting / blacklisting.
+and IP address allowing / blocking.
 
 [horizontal]
 Option value type:: binary data
@@ -1219,7 +1285,7 @@ LOCAL_PEERCRED socket options (currently
 OS X).
 
 NOTE: This option is deprecated, please use authentication via the ZAP API
-and IPC whitelisting / blacklisting.
+and IPC allowing / blocking.
 
 [horizontal]
 Option value type:: gid_t
@@ -1241,7 +1307,7 @@ NOTE: PID filters are only available on
 socket option (currently only Linux).
 
 NOTE: This option is deprecated, please use authentication via the ZAP API
-and IPC whitelisting / blacklisting.
+and IPC allowing / blocking.
 
 [horizontal]
 Option value type:: pid_t
@@ -1264,7 +1330,7 @@ LOCAL_PEERCRED socket options (currently
 OS X).
 
 NOTE: This option is deprecated, please use authentication via the ZAP API
-and IPC whitelisting / blacklisting.
+and IPC allowing / blocking.
 
 [horizontal]
 Option value type:: uid_t
diff -pruN 4.3.2-2/doc/zmq_socket.txt 4.3.3-1/doc/zmq_socket.txt
--- 4.3.2-2/doc/zmq_socket.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_socket.txt	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,7 @@ the event that a peer is unavailable to
 
 Conventional sockets allow only strict one-to-one (two peers), many-to-one
 (many clients, one server), or in some cases one-to-many (multicast)
-relationships. With the exception of 'ZMQ_PAIR', 0MQ sockets may be connected
+relationships. With the exception of 'ZMQ_PAIR' and 'ZMQ_CHANNEL', 0MQ sockets may be connected
 *to multiple endpoints* using _zmq_connect()_, while simultaneously accepting
 incoming connections *from multiple endpoints* bound to the socket using
 _zmq_bind()_, thus allowing many-to-many relationships.
@@ -49,8 +49,8 @@ _zmq_bind()_, thus allowing many-to-many
 .Thread safety
 0MQ has both thread safe socket type and _not_ thread safe socket types.
 Applications MUST NOT use a _not_ thread safe socket
-from multiple threads except after migrating a socket from one thread to
-another with a "full fence" memory barrier.
+from multiple threads under any circumstances. Doing so results in undefined
+behaviour.
 
 Following are the thread safe sockets:
 * ZMQ_CLIENT
@@ -59,6 +59,8 @@ Following are the thread safe sockets:
 * ZMQ_RADIO
 * ZMQ_SCATTER
 * ZMQ_GATHER
+* ZMQ_PEER
+* ZMQ_CHANNEL
 
 .Socket types
 The following sections present the socket types defined by 0MQ, grouped by the
@@ -85,14 +87,15 @@ the 'ZMQ_CLIENT'.
 If the 'ZMQ_CLIENT' socket has established a connection, linkzmq:zmq_send[3]
 will accept messages, queue them, and send them as rapidly as the network
 allows. The outgoing buffer limit is defined by the high water mark for the
-socket. If the outgoing buffer is full, or if there is no connected peer,
-linkzmq:zmq_send[3] will block, by default. The 'ZMQ_CLIENT' socket will not
-drop messages.
+socket. If the outgoing buffer is full, or, for connection-oriented transports,
+if the ZMQ_IMMEDIATE option is set and there is no connected peer,
+linkzmq:zmq_send[3] will block.
+The 'ZMQ_CLIENT' socket will not drop messages.
 
 When a 'ZMQ_CLIENT' socket is connected to multiple 'ZMQ_SERVER' sockets,
 outgoing messages are distributed between connected peers on a round-robin
 basis. Likewise, the 'ZMQ_CLIENT' socket receives messages fairly from each
-connected  peer. This usage is sensible only for stateless protocols.
+connected peer. This usage is sensible only for stateless protocols.
 
 'ZMQ_CLIENT' sockets are threadsafe and can be used from multiple threads
 at the same time. Note that replies from a 'ZMQ_SERVER' socket will go to
@@ -128,7 +131,7 @@ a message to a given 'ZMQ_CLIENT' peer t
 
 If the 'routing_id' is not specified, or does not refer to a connected client
 peer, the send call will fail with EHOSTUNREACH. If the outgoing buffer for
-the client peer is full, the send call shall block, unless ZMQ_DONT_WAIT is
+the client peer is full, the send call shall block, unless ZMQ_DONTWAIT is
 used in the send, in which case it shall fail with EAGAIN. The 'ZMQ_SERVER'
 socket shall not drop messages in any case.
 
@@ -307,10 +310,11 @@ downstream _nodes_. The _zmq_recv()_ fun
 socket type.
 
 When a 'ZMQ_PUSH' socket enters the 'mute' state due to having reached the
-high water mark for all downstream _nodes_, or if there are no downstream
-_nodes_ at all, then any linkzmq:zmq_send[3] operations on the socket shall
-block until the mute state ends or at least one downstream _node_
-becomes available for sending; messages are not discarded.
+high water mark for all downstream _nodes_, or, for connection-oriented transports,
+if the ZMQ_IMMEDIATE option is set and there are no downstream _nodes_ at all,
+then any linkzmq:zmq_send[3] operations on the socket shall block until the mute
+state ends or at least one downstream _node_ becomes available for sending;
+messages are not discarded.
 
 [horizontal]
 .Summary of ZMQ_PUSH characteristics
@@ -338,6 +342,60 @@ Incoming routing strategy:: Fair-queued
 Outgoing routing strategy:: N/A
 Action in mute state:: Block
 
+Scatter-gather pattern
+~~~~~~~~~~~~~~~~
+The scatter-gather pattern is the thread-safe version of the pipeline pattern.
+The scatter-gather pattern is used for distributing data to _nodes_ arranged in
+a pipeline. Data always flows down the pipeline, and each stage of the pipeline
+is connected to at least one _node_. When a pipeline stage is connected to
+multiple _nodes_ data is round-robined among all connected _nodes_.
+
+ZMQ_SCATTER
+^^^^^^^^
+A socket of type 'ZMQ_SCATTER' is used by a scatter-gather _node_ to send messages
+to downstream scatter-gather _nodes_. Messages are round-robined to all connected
+downstream _nodes_. The _zmq_recv()_ function is not implemented for this
+socket type.
+
+When a 'ZMQ_SCATTER' socket enters the 'mute' state due to having reached the
+high water mark for all downstream _nodes_, or, for connection-oriented transports,
+if the ZMQ_IMMEDIATE option is set and there are no downstream _nodes_ at all,
+then any linkzmq:zmq_send[3] operations on the socket shall block until the mute
+state ends or at least one downstream _node_ becomes available for sending;
+messages are not discarded.
+
+NOTE: 'ZMQ_SCATTER' sockets are threadsafe. They do not accept ZMQ_RCVMORE on receives.
+This limits them to single part data.
+
+[horizontal]
+.Summary of ZMQ_SCATTER characteristics
+Compatible peer sockets:: 'ZMQ_SCATTER'
+Direction:: Unidirectional
+Send/receive pattern:: Send only
+Incoming routing strategy:: N/A
+Outgoing routing strategy:: Round-robin
+Action in mute state:: Block
+
+
+ZMQ_GATHER
+^^^^^^^^
+A socket of type 'ZMQ_GATHER' is used by a scatter-gather _node_ to receive messages
+from upstream scatter-gather _nodes_. Messages are fair-queued from among all
+connected upstream _nodes_. The _zmq_send()_ function is not implemented for
+this socket type.
+
+NOTE: 'ZMQ_GATHER' sockets are threadsafe. They do not accept ZMQ_RCVMORE on receives.
+This limits them to single part data.
+
+[horizontal]
+.Summary of ZMQ_GATHER characteristics
+Compatible peer sockets:: 'ZMQ_GATHER'
+Direction:: Unidirectional
+Send/receive pattern:: Receive only
+Incoming routing strategy:: Fair-queued
+Outgoing routing strategy:: N/A
+Action in mute state:: Block
+
 
 Exclusive pair pattern
 ~~~~~~~~~~~~~~~~~~~~~~
@@ -354,7 +412,8 @@ time.  No message routing or filtering i
 'ZMQ_PAIR' socket.
 
 When a 'ZMQ_PAIR' socket enters the 'mute' state due to having reached the
-high water mark for the connected peer, or if no peer is connected, then
+high water mark for the connected peer, or, for connection-oriented transports,
+if the ZMQ_IMMEDIATE option is set and there is no connected peer, then
 any linkzmq:zmq_send[3] operations on the socket shall block until the peer
 becomes available for sending; messages are not discarded.
 
@@ -377,6 +436,89 @@ Outgoing routing strategy:: N/A
 Action in mute state:: Block
 
 
+Peer-to-peer pattern
+~~~~~~~~~~~~~~~~~~~~~~
+
+The peer-to-peer pattern is used to connect a peer to multiple peers.
+Peer can both connect and bind and mix both of them with the same socket.
+The peer-to-peer pattern is useful to build peer-to-peer networks (e.g zyre, bitcoin, torrent)
+where a peer can both accept connections from other peers or connect to them.
+
+NOTE: Peer-to-peer is still in draft phase.
+
+ZMQ_PEER
+^^^^^^^^
+A 'ZMQ_PEER' socket talks to a set of 'ZMQ_PEER' sockets.
+
+To connect and fetch the 'routing_id' of the peer use linkzmq:zmq_connect_peer[3].
+
+Each received message has a 'routing_id' that is a 32-bit unsigned integer.
+The application can fetch this with linkzmq:zmq_msg_routing_id[3].
+
+To send a message to a given 'ZMQ_PEER' peer the application must set the peer's
+'routing_id' on the message, using linkzmq:zmq_msg_set_routing_id[3].
+
+If the 'routing_id' is not specified, or does not refer to a connected client
+peer, the send call will fail with EHOSTUNREACH. If the outgoing buffer for
+the peer is full, the send call shall block, unless ZMQ_DONTWAIT is
+used in the send, in which case it shall fail with EAGAIN. The 'ZMQ_PEER'
+socket shall not drop messages in any case.
+
+NOTE: 'ZMQ_PEER' sockets are threadsafe. They do not accept the ZMQ_SNDMORE
+option on sends not ZMQ_RCVMORE on receives. This limits them to single part
+data.
+
+[horizontal]
+.Summary of ZMQ_PEER characteristics
+Compatible peer sockets:: 'ZMQ_PEER'
+Direction:: Bidirectional
+Send/receive pattern:: Unrestricted
+Outgoing routing strategy:: See text
+Incoming routing strategy:: Fair-queued
+Action in mute state:: Return EAGAIN
+
+Channel pattern
+~~~~~~~~~~~~~~~~~~~~~~
+The channel pattern is the thread-safe version of the exclusive pair pattern.
+The channel pattern is used to connect a peer to precisely one other
+peer. This pattern is used for inter-thread communication across the inproc
+transport.
+
+NOTE: Channel is still in draft phase.
+
+ZMQ_CHANNEL
+^^^^^^^^
+A socket of type 'ZMQ_CHANNEL' can only be connected to a single peer at any one
+time.  No message routing or filtering is performed on messages sent over a
+'ZMQ_CHANNEL' socket.
+
+When a 'ZMQ_CHANNEL' socket enters the 'mute' state due to having reached the
+high water mark for the connected peer, or, for connection-oriented transports,
+if the ZMQ_IMMEDIATE option is set and there is no connected peer, then
+any linkzmq:zmq_send[3] operations on the socket shall block until the peer
+becomes available for sending; messages are not discarded.
+
+While 'ZMQ_CHANNEL' sockets can be used over transports other than linkzmq:zmq_inproc[7],
+their inability to auto-reconnect coupled with the fact new incoming connections will
+be terminated while any previous connections (including ones in a closing state)
+exist makes them unsuitable for TCP in most cases.
+
+NOTE: 'ZMQ_CHANNEL' sockets are designed for inter-thread communication across
+the linkzmq:zmq_inproc[7] transport and do not implement functionality such
+as auto-reconnection.
+
+NOTE: 'ZMQ_CHANNEL' sockets are threadsafe. They do not accept ZMQ_RCVMORE on receives.
+This limits them to single part data.
+
+[horizontal]
+.Summary of ZMQ_CHANNEL characteristics
+Compatible peer sockets:: 'ZMQ_CHANNEL'
+Direction:: Bidirectional
+Send/receive pattern:: Unrestricted
+Incoming routing strategy:: N/A
+Outgoing routing strategy:: N/A
+Action in mute state:: Block
+
 Native Pattern
 ~~~~~~~~~~~~~~
 The native pattern is used for communicating with TCP peers and allows
@@ -437,9 +579,9 @@ sequence of _zmq_send(request)_ and subs
 request sent is round-robined among all _services_, and each reply received is
 matched with the last issued request.
 
-If no services are available, then any send operation on the socket shall
-block until at least one _service_ becomes available. The REQ socket shall
-not discard messages.
+For connection-oriented transports, If the ZMQ_IMMEDIATE option is set and there
+is no service available, then any send operation on the socket shall block until
+at least one _service_ becomes available. The REQ socket shall not discard messages.
 
 [horizontal]
 .Summary of ZMQ_REQ characteristics
@@ -476,10 +618,10 @@ request/reply sockets. Each message sent
 peers, and each message received is fair-queued from all connected peers.
 
 When a 'ZMQ_DEALER' socket enters the 'mute' state due to having reached the
-high water mark for all peers, or if there are no peers at all, then any
-linkzmq:zmq_send[3] operations on the socket shall block until the mute
-state ends or at least one peer becomes available for sending; messages are not
-discarded.
+high water mark for all peers, or, for connection-oriented transports, if the
+ZMQ_IMMEDIATE option is set and there are no peers at all, then any
+linkzmq:zmq_send[3] operations on the socket shall block until the mute state
+ends or at least one peer becomes available for sending; messages are not discarded.
 
 When a 'ZMQ_DEALER' socket is connected to a 'ZMQ_REP' socket each message sent
 must consist of an empty message part, the _delimiter_, followed by one or more
@@ -553,7 +695,7 @@ The provided 'context' is invalid.
 *EMFILE*::
 The limit on the total number of open 0MQ sockets has been reached.
 *ETERM*::
-The context specified was terminated.
+The context specified was shutdown or terminated.
 
 EXAMPLE
 -------
diff -pruN 4.3.2-2/doc/zmq.txt 4.3.3-1/doc/zmq.txt
--- 4.3.2-2/doc/zmq.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq.txt	2020-09-07 10:12:14.000000000 +0000
@@ -82,6 +82,7 @@ The following functions are provided to
 Initialise a message::
     linkzmq:zmq_msg_init[3]
     linkzmq:zmq_msg_init_size[3]
+    linkzmq:zmq_msg_init_buffer[3]
     linkzmq:zmq_msg_init_data[3]
 
 Sending and receiving a message::
diff -pruN 4.3.2-2/doc/zmq_unbind.txt 4.3.3-1/doc/zmq_unbind.txt
--- 4.3.2-2/doc/zmq_unbind.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/doc/zmq_unbind.txt	2020-09-07 10:12:14.000000000 +0000
@@ -28,9 +28,9 @@ The 'endpoint' argument is as described
 Unbinding wild-card address from a socket
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 When wild-card `*` 'endpoint' (described in linkzmq:zmq_tcp[7],
-linkzmq:zmq_ipc[7] and linkzmq:zmq_vmci[7]) was used in _zmq_bind()_, the caller should use
-real 'endpoint' obtained from the ZMQ_LAST_ENDPOINT socket option
-to unbind this 'endpoint' from a socket.
+linkzmq:zmq_ipc[7], linkzmq:zmq_udp[7] and linkzmq:zmq_vmci[7]) was used in
+_zmq_bind()_, the caller should use real 'endpoint' obtained from the 
+ZMQ_LAST_ENDPOINT socket option to unbind this 'endpoint' from a socket.
 
 RETURN VALUE
 ------------
diff -pruN 4.3.2-2/Dockerfile 4.3.3-1/Dockerfile
--- 4.3.2-2/Dockerfile	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/Dockerfile	2020-09-07 10:12:14.000000000 +0000
@@ -1,11 +1,32 @@
-FROM ubuntu:14.04
+FROM debian:buster-slim AS builder
+LABEL maintainer="ZeroMQ Project <zeromq@imatix.com>"
+ARG DEBIAN_FRONTEND=noninteractive
+RUN apt-get update -qq \
+    && apt-get install -qq --yes --no-install-recommends \
+        autoconf \
+        automake \
+        build-essential \
+        git \
+        libkrb5-dev \
+        libsodium-dev \
+        libtool \
+        pkg-config \
+    && rm -rf /var/lib/apt/lists/*
+WORKDIR /opt/libzmq
+COPY . .
+RUN ./autogen.sh \
+    && ./configure --prefix=/usr/local --with-libsodium --with-libgssapi_krb5 \
+    && make \
+    && make check \
+    && make install
 
-MAINTAINER ZeroMQ Project <zeromq@imatix.com>
-
-RUN apt-get update
-RUN DEBIAN_FRONTEND=noninteractive apt-get install -y git build-essential libtool autoconf automake pkg-config unzip libkrb5-dev
-RUN cd /tmp && git clone git://github.com/jedisct1/libsodium.git && cd libsodium && git checkout e2a30a && ./autogen.sh && ./configure && make check && make install && ldconfig
-RUN cd /tmp && git clone --depth 1 git://github.com/zeromq/libzmq.git && cd libzmq && ./autogen.sh && ./configure && make
-# RUN cd /tmp/libzmq && make check
-RUN cd /tmp/libzmq && make install && ldconfig
-RUN rm /tmp/* -rf
+FROM debian:buster-slim
+LABEL maintainer="ZeroMQ Project <zeromq@imatix.com>"
+ARG DEBIAN_FRONTEND=noninteractive
+RUN apt-get update -qq \
+    && apt-get install -qq --yes --no-install-recommends \
+        libkrb5-dev \
+        libsodium23 \
+    && rm -rf /var/lib/apt/lists/*
+COPY --from=builder /usr/local /usr/local
+RUN ldconfig && ldconfig -p | grep libzmq
diff -pruN 4.3.2-2/external/sha1/license.txt 4.3.3-1/external/sha1/license.txt
--- 4.3.2-2/external/sha1/license.txt	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/external/sha1/license.txt	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,26 @@
+Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
+All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions
+are met:
+1. Redistributions of source code must retain the above copyright
+       notice, this list of conditions and the following disclaimer.
+2. Redistributions in binary form must reproduce the above copyright
+       notice, this list of conditions and the following disclaimer in the
+       documentation and/or other materials provided with the distribution.
+3. Neither the name of the project nor the names of its contributors
+       may be used to endorse or promote products derived from this software
+       without specific prior written permission.
+
+THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
+ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ARE DISCLAIMED.      IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
+FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGE.
diff -pruN 4.3.2-2/external/sha1/sha1.c 4.3.3-1/external/sha1/sha1.c
--- 4.3.2-2/external/sha1/sha1.c	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/external/sha1/sha1.c	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,336 @@
+/*
+ * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *	  notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *	  notice, this list of conditions and the following disclaimer in the
+ *	  documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the project nor the names of its contributors
+ *	  may be used to endorse or promote products derived from this software
+ *	  without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.	IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+/*
+ * FIPS pub 180-1: Secure Hash Algorithm (SHA-1)
+ * based on: http://www.itl.nist.gov/fipspubs/fip180-1.htm
+ * implemented by Jun-ichiro itojun Itoh <itojun@itojun.org>
+ */
+
+#include "sha1.h"
+#include <string.h>
+
+
+/* constant table */
+static uint32_t _K[] = {0x5a827999, 0x6ed9eba1, 0x8f1bbcdc, 0xca62c1d6};
+
+#define K(t)	_K[(t) / 20]
+
+#define F0(b, c, d) (((b) & (c)) | ((~(b)) & (d)))
+#define F1(b, c, d) (((b) ^ (c)) ^ (d))
+#define F2(b, c, d) (((b) & (c)) | ((b) & (d)) | ((c) & (d)))
+#define F3(b, c, d) (((b) ^ (c)) ^ (d))
+
+#define S(n, x)		(((x) << (n)) | ((x) >> (32 - (n))))
+
+#define H(n)	(ctxt->h.b32[(n)])
+#define COUNT	(ctxt->count)
+#define BCOUNT	(ctxt->c.b64[0] / 8)
+#define W(n)	(ctxt->m.b32[(n)])
+
+#define PUTBYTE(x) \
+do { \
+	ctxt->m.b8[(COUNT % 64)] = (x);		\
+	COUNT++;				\
+	COUNT %= 64;				\
+	ctxt->c.b64[0] += 8;			\
+	if (COUNT % 64 == 0)			\
+		sha1_step(ctxt);		\
+} while (0)
+
+#define PUTPAD(x) \
+do { \
+	ctxt->m.b8[(COUNT % 64)] = (x);		\
+	COUNT++;				\
+	COUNT %= 64;				\
+	if (COUNT % 64 == 0)			\
+		sha1_step(ctxt);		\
+} while (0)
+
+static void sha1_step(struct sha1_ctxt *);
+
+static void
+sha1_step(struct sha1_ctxt * ctxt)
+{
+	uint32_t		a,
+				b,
+				c,
+				d,
+				e;
+	size_t		t,
+				s;
+	uint32_t		tmp;
+
+#ifndef WORDS_BIGENDIAN
+	struct sha1_ctxt tctxt;
+
+	memmove(&tctxt.m.b8[0], &ctxt->m.b8[0], 64);
+	ctxt->m.b8[0] = tctxt.m.b8[3];
+	ctxt->m.b8[1] = tctxt.m.b8[2];
+	ctxt->m.b8[2] = tctxt.m.b8[1];
+	ctxt->m.b8[3] = tctxt.m.b8[0];
+	ctxt->m.b8[4] = tctxt.m.b8[7];
+	ctxt->m.b8[5] = tctxt.m.b8[6];
+	ctxt->m.b8[6] = tctxt.m.b8[5];
+	ctxt->m.b8[7] = tctxt.m.b8[4];
+	ctxt->m.b8[8] = tctxt.m.b8[11];
+	ctxt->m.b8[9] = tctxt.m.b8[10];
+	ctxt->m.b8[10] = tctxt.m.b8[9];
+	ctxt->m.b8[11] = tctxt.m.b8[8];
+	ctxt->m.b8[12] = tctxt.m.b8[15];
+	ctxt->m.b8[13] = tctxt.m.b8[14];
+	ctxt->m.b8[14] = tctxt.m.b8[13];
+	ctxt->m.b8[15] = tctxt.m.b8[12];
+	ctxt->m.b8[16] = tctxt.m.b8[19];
+	ctxt->m.b8[17] = tctxt.m.b8[18];
+	ctxt->m.b8[18] = tctxt.m.b8[17];
+	ctxt->m.b8[19] = tctxt.m.b8[16];
+	ctxt->m.b8[20] = tctxt.m.b8[23];
+	ctxt->m.b8[21] = tctxt.m.b8[22];
+	ctxt->m.b8[22] = tctxt.m.b8[21];
+	ctxt->m.b8[23] = tctxt.m.b8[20];
+	ctxt->m.b8[24] = tctxt.m.b8[27];
+	ctxt->m.b8[25] = tctxt.m.b8[26];
+	ctxt->m.b8[26] = tctxt.m.b8[25];
+	ctxt->m.b8[27] = tctxt.m.b8[24];
+	ctxt->m.b8[28] = tctxt.m.b8[31];
+	ctxt->m.b8[29] = tctxt.m.b8[30];
+	ctxt->m.b8[30] = tctxt.m.b8[29];
+	ctxt->m.b8[31] = tctxt.m.b8[28];
+	ctxt->m.b8[32] = tctxt.m.b8[35];
+	ctxt->m.b8[33] = tctxt.m.b8[34];
+	ctxt->m.b8[34] = tctxt.m.b8[33];
+	ctxt->m.b8[35] = tctxt.m.b8[32];
+	ctxt->m.b8[36] = tctxt.m.b8[39];
+	ctxt->m.b8[37] = tctxt.m.b8[38];
+	ctxt->m.b8[38] = tctxt.m.b8[37];
+	ctxt->m.b8[39] = tctxt.m.b8[36];
+	ctxt->m.b8[40] = tctxt.m.b8[43];
+	ctxt->m.b8[41] = tctxt.m.b8[42];
+	ctxt->m.b8[42] = tctxt.m.b8[41];
+	ctxt->m.b8[43] = tctxt.m.b8[40];
+	ctxt->m.b8[44] = tctxt.m.b8[47];
+	ctxt->m.b8[45] = tctxt.m.b8[46];
+	ctxt->m.b8[46] = tctxt.m.b8[45];
+	ctxt->m.b8[47] = tctxt.m.b8[44];
+	ctxt->m.b8[48] = tctxt.m.b8[51];
+	ctxt->m.b8[49] = tctxt.m.b8[50];
+	ctxt->m.b8[50] = tctxt.m.b8[49];
+	ctxt->m.b8[51] = tctxt.m.b8[48];
+	ctxt->m.b8[52] = tctxt.m.b8[55];
+	ctxt->m.b8[53] = tctxt.m.b8[54];
+	ctxt->m.b8[54] = tctxt.m.b8[53];
+	ctxt->m.b8[55] = tctxt.m.b8[52];
+	ctxt->m.b8[56] = tctxt.m.b8[59];
+	ctxt->m.b8[57] = tctxt.m.b8[58];
+	ctxt->m.b8[58] = tctxt.m.b8[57];
+	ctxt->m.b8[59] = tctxt.m.b8[56];
+	ctxt->m.b8[60] = tctxt.m.b8[63];
+	ctxt->m.b8[61] = tctxt.m.b8[62];
+	ctxt->m.b8[62] = tctxt.m.b8[61];
+	ctxt->m.b8[63] = tctxt.m.b8[60];
+#endif
+
+	a = H(0);
+	b = H(1);
+	c = H(2);
+	d = H(3);
+	e = H(4);
+
+	for (t = 0; t < 20; t++)
+	{
+		s = t & 0x0f;
+		if (t >= 16)
+			W(s) = S(1, W((s + 13) & 0x0f) ^ W((s + 8) & 0x0f) ^ W((s + 2) & 0x0f) ^ W(s));
+		tmp = S(5, a) + F0(b, c, d) + e + W(s) + K(t);
+		e = d;
+		d = c;
+		c = S(30, b);
+		b = a;
+		a = tmp;
+	}
+	for (t = 20; t < 40; t++)
+	{
+		s = t & 0x0f;
+		W(s) = S(1, W((s + 13) & 0x0f) ^ W((s + 8) & 0x0f) ^ W((s + 2) & 0x0f) ^ W(s));
+		tmp = S(5, a) + F1(b, c, d) + e + W(s) + K(t);
+		e = d;
+		d = c;
+		c = S(30, b);
+		b = a;
+		a = tmp;
+	}
+	for (t = 40; t < 60; t++)
+	{
+		s = t & 0x0f;
+		W(s) = S(1, W((s + 13) & 0x0f) ^ W((s + 8) & 0x0f) ^ W((s + 2) & 0x0f) ^ W(s));
+		tmp = S(5, a) + F2(b, c, d) + e + W(s) + K(t);
+		e = d;
+		d = c;
+		c = S(30, b);
+		b = a;
+		a = tmp;
+	}
+	for (t = 60; t < 80; t++)
+	{
+		s = t & 0x0f;
+		W(s) = S(1, W((s + 13) & 0x0f) ^ W((s + 8) & 0x0f) ^ W((s + 2) & 0x0f) ^ W(s));
+		tmp = S(5, a) + F3(b, c, d) + e + W(s) + K(t);
+		e = d;
+		d = c;
+		c = S(30, b);
+		b = a;
+		a = tmp;
+	}
+
+	H(0) = H(0) + a;
+	H(1) = H(1) + b;
+	H(2) = H(2) + c;
+	H(3) = H(3) + d;
+	H(4) = H(4) + e;
+
+	memset(&ctxt->m.b8[0], 0, 64);
+}
+
+/*------------------------------------------------------------*/
+
+void
+sha1_init(struct sha1_ctxt * ctxt)
+{
+	memset(ctxt, 0, sizeof(struct sha1_ctxt));
+	H(0) = 0x67452301;
+	H(1) = 0xefcdab89;
+	H(2) = 0x98badcfe;
+	H(3) = 0x10325476;
+	H(4) = 0xc3d2e1f0;
+}
+
+void
+sha1_pad(struct sha1_ctxt * ctxt)
+{
+	size_t		padlen;			/* pad length in bytes */
+	size_t		padstart;
+
+	PUTPAD(0x80);
+
+	padstart = COUNT % 64;
+	padlen = 64 - padstart;
+	if (padlen < 8)
+	{
+		memset(&ctxt->m.b8[padstart], 0, padlen);
+		COUNT += (uint8_t) padlen;
+		COUNT %= 64;
+		sha1_step(ctxt);
+		padstart = COUNT % 64;	/* should be 0 */
+		padlen = 64 - padstart; /* should be 64 */
+	}
+	memset(&ctxt->m.b8[padstart], 0, padlen - 8);
+    COUNT += ((uint8_t) padlen - 8);
+	COUNT %= 64;
+#ifdef WORDS_BIGENDIAN
+	PUTPAD(ctxt->c.b8[0]);
+	PUTPAD(ctxt->c.b8[1]);
+	PUTPAD(ctxt->c.b8[2]);
+	PUTPAD(ctxt->c.b8[3]);
+	PUTPAD(ctxt->c.b8[4]);
+	PUTPAD(ctxt->c.b8[5]);
+	PUTPAD(ctxt->c.b8[6]);
+	PUTPAD(ctxt->c.b8[7]);
+#else
+	PUTPAD(ctxt->c.b8[7]);
+	PUTPAD(ctxt->c.b8[6]);
+	PUTPAD(ctxt->c.b8[5]);
+	PUTPAD(ctxt->c.b8[4]);
+	PUTPAD(ctxt->c.b8[3]);
+	PUTPAD(ctxt->c.b8[2]);
+	PUTPAD(ctxt->c.b8[1]);
+	PUTPAD(ctxt->c.b8[0]);
+#endif
+}
+
+void
+sha1_loop(struct sha1_ctxt * ctxt, const uint8_t *input0, size_t len)
+{
+	const uint8_t *input;
+	size_t		gaplen;
+	size_t		gapstart;
+	size_t		off;
+	size_t		copysiz;
+
+	input = (const uint8_t *) input0;
+	off = 0;
+
+	while (off < len)
+	{
+		gapstart = COUNT % 64;
+		gaplen = 64 - gapstart;
+
+		copysiz = (gaplen < len - off) ? gaplen : len - off;
+		memmove(&ctxt->m.b8[gapstart], &input[off], copysiz);
+		COUNT += (uint8_t) copysiz;
+		COUNT %= 64;
+		ctxt->c.b64[0] += copysiz * 8;
+		if (COUNT % 64 == 0)
+			sha1_step(ctxt);
+		off += copysiz;
+	}
+}
+
+void
+sha1_result(struct sha1_ctxt * ctxt, uint8_t *digest0)
+{
+	uint8_t	   *digest;
+
+	digest = (uint8_t *) digest0;
+	sha1_pad(ctxt);
+#ifdef WORDS_BIGENDIAN
+	memmove(digest, &ctxt->h.b8[0], 20);
+#else
+	digest[0] = ctxt->h.b8[3];
+	digest[1] = ctxt->h.b8[2];
+	digest[2] = ctxt->h.b8[1];
+	digest[3] = ctxt->h.b8[0];
+	digest[4] = ctxt->h.b8[7];
+	digest[5] = ctxt->h.b8[6];
+	digest[6] = ctxt->h.b8[5];
+	digest[7] = ctxt->h.b8[4];
+	digest[8] = ctxt->h.b8[11];
+	digest[9] = ctxt->h.b8[10];
+	digest[10] = ctxt->h.b8[9];
+	digest[11] = ctxt->h.b8[8];
+	digest[12] = ctxt->h.b8[15];
+	digest[13] = ctxt->h.b8[14];
+	digest[14] = ctxt->h.b8[13];
+	digest[15] = ctxt->h.b8[12];
+	digest[16] = ctxt->h.b8[19];
+	digest[17] = ctxt->h.b8[18];
+	digest[18] = ctxt->h.b8[17];
+	digest[19] = ctxt->h.b8[16];
+#endif
+}
\ No newline at end of file
diff -pruN 4.3.2-2/external/sha1/sha1.h 4.3.3-1/external/sha1/sha1.h
--- 4.3.2-2/external/sha1/sha1.h	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/external/sha1/sha1.h	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,87 @@
+/*	contrib/pgcrypto/sha1.h */
+/*	   $KAME: sha1.h,v 1.4 2000/02/22 14:01:18 itojun Exp $    */
+
+/*
+ * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *	  notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *	  notice, this list of conditions and the following disclaimer in the
+ *	  documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the project nor the names of its contributors
+ *	  may be used to endorse or promote products derived from this software
+ *	  without specific prior written permission.
+ *
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.	IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+/*
+ * FIPS pub 180-1: Secure Hash Algorithm (SHA-1)
+ * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * based on: http://www.itl.nist.gov/fipspubs/fip180-1.htm
+ * implemented by Jun-ichiro itojun Itoh <itojun@itojun.org>
+ */
+
+#ifndef _NETINET6_SHA1_H_
+#define _NETINET6_SHA1_H_
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <stdlib.h>
+#include "../../src/stdint.hpp"
+
+struct sha1_ctxt
+{
+	union
+	{
+		uint8_t	b8[20];
+		uint32_t b32[5];
+	} h;
+	union
+	{
+		uint8_t b8[8];
+		uint64_t b64[1];
+	} c;
+	union
+	{
+		uint8_t b8[64];
+		uint32_t b32[16];
+	} m;
+	uint8_t count;
+};
+
+void sha1_init(struct sha1_ctxt *);
+void sha1_pad(struct sha1_ctxt *);
+void sha1_loop(struct sha1_ctxt *, const uint8_t *, size_t);
+void sha1_result(struct sha1_ctxt *, uint8_t *);
+
+//  Compatibility with OpenSSL API
+#define SHA_DIGEST_LENGTH 20
+typedef struct sha1_ctxt SHA_CTX;
+
+#define SHA1_Init(x)            sha1_init((x))
+#define SHA1_Update(x, y, z)    sha1_loop((x), (y), (z))
+#define SHA1_Final(x, y)        sha1_result((y), (x))
+
+#define SHA1_RESULTLEN	(160/8)
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif   /* _NETINET6_SHA1_H_ */
diff -pruN 4.3.2-2/.github/CONTRIBUTING.md 4.3.3-1/.github/CONTRIBUTING.md
--- 4.3.2-2/.github/CONTRIBUTING.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/.github/CONTRIBUTING.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,48 @@
+# Pull Request Notice
+
+Before sending a pull request make sure each commit solves one clear, minimal,
+plausible problem. Further each commit should have the following format:
+
+```
+Problem: X is broken
+
+Solution: do Y and Z to fix X
+```
+
+Please try to have the code changes conform to our coding style. For your
+convenience, you can install clang-format (at least version 5.0) and then
+run ```make clang-format-check```. Don't fix existing issues, if any - just
+make sure your changes are compliant. ```make clang-format-diff``` will
+automatically apply the required changes.
+To set a specific clang-format binary with autotools, you can for example
+run: ```./configure CLANG_FORMAT=clang-format-5.0```
+
+Please avoid sending a pull request with recursive merge nodes, as they
+are impossible to fix once merged. Please rebase your branch on
+zeromq/libzmq master instead of merging it.
+
+```
+git remote add upstream git@github.com:zeromq/libzmq.git
+git fetch upstream
+git rebase upstream/master
+git push -f
+```
+
+In case you already merged instead of rebasing you can drop the merge commit.
+
+```
+git rebase -i HEAD~10
+```
+
+Now, find your merge commit and mark it as drop and save. Finally rebase!
+
+If you are a new contributor please have a look at our contributing guidelines:
+[CONTRIBUTING](http://zeromq.org/docs:contributing)
+
+# FIRST TIME CONTRIBUTORS PLEASE NOTE
+
+Please add an additional commit with a relicensing grant.
+
+[Example](https://github.com/zeromq/libzmq/commit/fecbd42dbe45455fff3b6456350ceca047b82050)
+
+[More information on RELICENSING effort](https://github.com/zeromq/libzmq/tree/master/RELICENSE/README.md)
diff -pruN 4.3.2-2/.github/PULL_REQUEST_TEMPLATE.md 4.3.3-1/.github/PULL_REQUEST_TEMPLATE.md
--- 4.3.2-2/.github/PULL_REQUEST_TEMPLATE.md	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/.github/PULL_REQUEST_TEMPLATE.md	1970-01-01 00:00:00.000000000 +0000
@@ -1,48 +0,0 @@
-# Pull Request Notice
-
-Before sending a pull request make sure each commit solves one clear, minimal,
-plausible problem. Further each commit should have the following format:
-
-```
-Problem: X is broken
-
-Solution: do Y and Z to fix X
-```
-
-Please try to have the code changes conform to our coding style. For your
-convenience, you can install clang-format (at least version 5.0) and then
-run ```make clang-format-check```. Don't fix existing issues, if any - just
-make sure your changes are compliant. ```make clang-format-diff``` will
-automatically apply the required changes.
-To set a specific clang-format binary with autotools, you can for example
-run: ```./configure CLANG_FORMAT=clang-format-5.0```
-
-Please avoid sending a pull request with recursive merge nodes, as they
-are impossible to fix once merged. Please rebase your branch on
-zeromq/libzmq master instead of merging it.
-
-```
-git remote add upstream git@github.com:zeromq/libzmq.git
-git fetch upstream
-git rebase upstream/master
-git push -f
-```
-
-In case you already merged instead of rebasing you can drop the merge commit.
-
-```
-git rebase -i HEAD~10
-```
-
-Now, find your merge commit and mark it as drop and save. Finally rebase!
-
-If you are a new contributor please have a look at our contributing guidelines:
-[CONTRIBUTING](http://zeromq.org/docs:contributing)
-
-# FIRST TIME CONTRIBUTORS PLEASE NOTE
-
-Please add an additional commit with a relicensing grant.
-
-[Example](https://github.com/zeromq/libzmq/commit/fecbd42dbe45455fff3b6456350ceca047b82050)
-
-[More information on RELICENSING effort](https://github.com/zeromq/libzmq/tree/master/RELICENSE/README.md)
diff -pruN 4.3.2-2/.github/workflows/CI.yaml 4.3.3-1/.github/workflows/CI.yaml
--- 4.3.2-2/.github/workflows/CI.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/.github/workflows/CI.yaml	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,91 @@
+name: CI
+on: [push, pull_request]
+
+jobs:
+  build:
+    runs-on: ${{ matrix.os }}
+    strategy:
+      fail-fast: false
+      matrix:
+        include:
+          - platform: x64
+            configuration: release  
+            os: windows-2019
+            WITH_LIBSODIUM: ON
+            ENABLE_CURVE: ON
+            CMAKE_GENERATOR: Visual Studio 16 2019
+            MSVCVERSION: v142
+            MSVCYEAR: vs2019
+            ARTIFACT_NAME: v142-x64
+            ENABLE_DRAFTS: ON
+          # - platform: Win32
+          #   configuration: Release            
+          #   os: windows-2016           
+          #   WITH_LIBSODIUM: ON
+          #   ENABLE_CURVE: ON            
+          #   CMAKE_GENERATOR: "Visual Studio 15 2017"
+          #   MSVCVERSION: "v141"
+          #   MSVCYEAR: "vs2017"            
+          #   ARTIFACT_NAME: v141
+          #   ENABLE_DRAFTS: ON            
+          - platform: x64
+            configuration: Release
+            os: windows-2016           
+            WITH_LIBSODIUM: ON            
+            ENABLE_CURVE: ON            
+            CMAKE_GENERATOR: "Visual Studio 15 2017 Win64"
+            MSVCVERSION: "v141"
+            MSVCYEAR: "vs2017"
+            ARTIFACT_NAME: v141-x64
+            ENABLE_DRAFTS: ON
+    env:
+      platform: ${{ matrix.platform }}
+      configuration: ${{ matrix.configuration }}
+      WITH_LIBSODIUM: ${{ matrix.WITH_LIBSODIUM }}
+      ENABLE_CURVE: ${{ matrix.ENABLE_CURVE }}
+      CMAKE_GENERATOR: ${{ matrix.CMAKE_GENERATOR }}
+      MSVCVERSION: ${{ matrix.MSVCVERSION }}
+      MSVCYEAR: ${{ matrix.MSVCYEAR }}
+      ARTIFACT_NAME: ${{ matrix.ARTIFACT_NAME }}
+      ENABLE_DRAFTS: ${{ matrix.ENABLE_DRAFTS }}
+      SODIUM_INCLUDE_DIR: ${{ github.workspace }}\libsodium\src\libsodium\include"
+      SODIUM_LIBRARY_DIR: ${{ github.workspace }}\libsodium\bin\${{ matrix.platform }}\${{ matrix.configuration }}\${{ matrix.MSVCVERSION }}\dynamic"
+      LIBZMQ_SRCDIR: ${{ github.workspace }}\libzmq
+    steps:    
+    - name: Add msbuild to PATH
+      uses: microsoft/setup-msbuild@v1.0.0
+      if: matrix.os == 'windows-2019'
+    - name: Add msbuild to PATH 2016
+      run: echo "##[add-path]C:\Program Files (x86)\Microsoft Visual Studio\2017\Enterprise\MSBuild\15.0\Bin"
+      if: matrix.os == 'windows-2016'    
+    - uses: actions/checkout@v2
+      if: matrix.WITH_LIBSODIUM == 'ON'
+      with:
+        repository: jedisct1/libsodium
+        ref: stable
+        path: libsodium        
+    - name: Compile libsodium
+      if: matrix.WITH_LIBSODIUM == 'ON'
+      shell: cmd
+      working-directory: libsodium
+      run: msbuild /v:minimal /p:Configuration=%Configuration%DLL builds\msvc\%MSVCYEAR%\libsodium\libsodium.vcxproj
+    - name: Copy libsodium
+      if: matrix.WITH_LIBSODIUM == 'ON'
+      shell: powershell
+      working-directory: libsodium
+      run: Copy-Item "bin\${env:Platform}\${env:Configuration}\${env:MSVCVERSION}\dynamic\libsodium.lib" -Destination "bin\${env:Platform}\${env:Configuration}\${env:MSVCVERSION}\dynamic\sodium.lib"
+    - uses: actions/checkout@v2    
+      with:    
+        path: libzmq
+    - run: md build_libzmq      
+      shell: cmd
+    - name: build
+      shell: cmd
+      working-directory: build_libzmq
+      run: |        
+        cmake -D CMAKE_INCLUDE_PATH="%SODIUM_INCLUDE_DIR%" -D CMAKE_LIBRARY_PATH="%SODIUM_LIBRARY_DIR%" -D WITH_LIBSODIUM="%WITH_LIBSODIUM%" -D ENABLE_DRAFTS="%ENABLE_DRAFTS%" -D ENABLE_ANALYSIS="%ENABLE_ANALYSIS%" -D ENABLE_CURVE="%ENABLE_CURVE%" -D API_POLLER="%API_POLLER%" -D POLLER="%POLLER%" %EXTRA_FLAGS% -D WITH_LIBSODIUM="%WITH_LIBSODIUM%" -D LIBZMQ_WERROR="%LIBZMQ_WERROR%" -G "%CMAKE_GENERATOR%" "%LIBZMQ_SRCDIR%"
+        cmake --build . --config %configuration% --target install -- -verbosity:Minimal -maxcpucount           
+    - name: test      
+      shell: cmd      
+      working-directory: build_libzmq
+      run: ctest -C "%Configuration%"
diff -pruN 4.3.2-2/.github/workflows/Fuzzers.yaml 4.3.3-1/.github/workflows/Fuzzers.yaml
--- 4.3.2-2/.github/workflows/Fuzzers.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/.github/workflows/Fuzzers.yaml	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,35 @@
+name: Fuzzers
+on:
+  push:
+    branches:
+      - master
+  pull_request:
+    paths:
+      - '.github/workflows/Fuzzers.yaml'
+      - 'src/*'
+      - 'tests/*fuzzer.cpp'
+jobs:
+  Fuzzing:
+    runs-on: ubuntu-latest
+    if: github.repository == 'zeromq/libzmq'
+    strategy:
+      matrix:
+        san: [address, memory, undefined]
+    steps:
+    - name: Build Fuzzers (${{ matrix.san }})
+      id: build
+      uses: google/oss-fuzz/infra/cifuzz/actions/build_fuzzers@master
+      with:
+        sanitizer: ${{ matrix.san }}
+        oss-fuzz-project-name: 'libzmq'
+        allowed-broken-targets-percentage: 0
+        dry-run: false
+    - name: Run Fuzzers (${{ matrix.san }})
+      id: run
+      uses: google/oss-fuzz/infra/cifuzz/actions/run_fuzzers@master
+      with:
+        sanitizer: ${{ matrix.san }}
+        oss-fuzz-project-name: 'libzmq'
+        allowed-broken-targets-percentage: 0
+        dry-run: false
+        fuzz-seconds: 300
diff -pruN 4.3.2-2/.gitignore 4.3.3-1/.gitignore
--- 4.3.2-2/.gitignore	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/.gitignore	2020-09-07 10:12:14.000000000 +0000
@@ -1,19 +1,47 @@
 syntax: glob # for hg-git users
+
+# Generated build scripts and IDE generating files
+## autotools
 /Makefile
 builds/Makefile
 builds/deprecated-msvc/Makefile
-configure
 doc/Makefile
-Makefile.in
-configure
 libtool
-libtestutil.a
-libunity.a
+### automake
+Makefile.in
+.deps/
+.dirstamp
+### autoconf
+autom4te.cache
+aclocal.m4
 config
 config.status
 config.log
-aclocal.m4
-autom4te.cache
+configure
+stamp-h1
+## CMake
+cmake-build-debug/
+build/
+## Android
+builds/android/prefix
+## IntelliJ
+.idea/
+## Visual Code
+.vscode/
+## other results-like folders
+bin/
+lib/
+obj/
+## Doxygen
+doxygen/
+## Packaging 
+packaging/nuget/*.nupkg
+
+# Test related build files
+libtestutil.a
+libunity.a
+
+# Some build outputs and temporal files
 *.o
 *.gcno
 *.gcda
@@ -28,169 +56,67 @@ autom4te.cache
 *.ps
 *~
 .*~
-.deps
-.dirstamp
 .libs
-curve_keygen
-test_ancillaries
-test_heartbeats
-test_msg_ffn
-test_sockopt_hwm
-test_resource
-test_ipc_wildcard
-test_stream_empty
-test_stream_timeout
-test_issue_566
-test_ctx_destroy
-test_term_endpoint
-test_system
-test_monitor
-test_last_endpoint
-test_pair_inproc
-test_pair_ipc
-test_pair_tcp
-test_rebind_ipc
-test_reqrep_inproc
-test_reqrep_ipc
-test_reqrep_tcp
-test_shutdown_stress
-test_hwm
-test_timeo
-test_reqrep_device
-test_reqrep_drop
-test_sub_forward
-test_invalid_rep
-test_msg_flags
-test_ts_context
-test_connect_resolve
-test_immediate
-test_term_endpoint
-test_router_mandatory
-test_disconnect_inproc
-test_unbind_inproc
-test_unbind_wildcard
-test_raw_sock
-test_disconnect_inproc
-test_ctx_options
-test_iov
-test_security
-test_security_curve
-test_security_no_zap_handler
-test_probe_router
-test_stream
-test_spec_dealer
-test_spec_pushpull
-test_spec_rep
-test_spec_req
-test_spec_router
-test_req_correlate
-test_req_relaxed
-test_fork
-test_conflate
-test_inproc_connect
-test_linger
-test_security_null
-test_security_plain
-test_proxy
-test_proxy_single_socket
-test_proxy_terminate
-test_abstract_ipc
-test_filter_ipc
-test_connect_delay_tipc
-test_pair_tipc
-test_reqrep_device_tipc
-test_reqrep_tipc
-test_router_handover
-test_router_mandatory_tipc
-test_router_notify
-test_shutdown_stress_tipc
-test_sub_forward_tipc
-test_term_endpoint_tipc
-test_many_sockets
-test_diffserv
-test_connect_rid
-test_srcfd
-test_stream_disconnect
-test_proxy_chain
-test_bind_src_address
-test_metadata
-test_id2fd
-test_capabilities
-test_hwm_pubsub
-test_router_mandatory_hwm
-test_xpub_nodrop
-test_xpub_manual
-test_xpub_welcome_msg
-test_atomics
-test_client_drop_more
-test_client_server
-test_server_drop_more
-test_thread_safe
-test_thread_safe_polling
-test_getsockopt_memset
-test_setsockopt
-test_stream_exceeds_buffer
-test_poller
-test_timers
-test_radio_dish
-test_udp
-test_scatter_gather
-test_socketopt_hwm
-test_use_fd
-test_pub_invert_matching
-test_dgram
-test_base85
-test_bind_after_connect_tcp
-test_sodium
-test_zmq_poll_fd
-test_reconnect_ivl
-test_address_tipc
-test_app_meta
-test_security_gssapi
-test_security_zap
-test_socket_null
-test_xpub_verbose
-test_mock_pub_sub
-test_proxy_hwm
-unittest_ip_resolver
-unittest_mtrie
-unittest_poller
-unittest_radix_tree
-unittest_udp_address
-unittest_ypipe
+
+# /src
+## Ignore generated files in configuration process
+src/platform.hpp*
+src/libzmq.pc
+
+# /tools
+## Executable binaries are ignored
+tools/curve_keygen
+## Executable source files must be tracked
+!tools/*.[ch]
+!tools/*.[ch]pp
+
+# /tests
+## Test binaries and logs are ignored
+tests/test*
 tests/test*.log
 tests/test*.trs
+## Test source files must be tracked
+!tests/test*.[ch]
+!tests/test*.[ch]pp
+## Build script and documentations must be tracked
+!tests/CMakeLists.txt
+!tests/README.md
+
+# /unittests
+## Unit test binaries and logs are ignored
+unittests/unittest_*
 unittests/unittest*.log
 unittests/unittest*.trs
-src/platform.hpp*
-src/stamp-h1
-local_lat
-local_thr
-remote_lat
-remote_thr
-inproc_lat
-inproc_thr
-proxy_thr
-benchmark_radix_tree
-!local_lat/
-!local_thr/
-!remote_lat/
-!remote_thr/
-!inproc_lat/
-!inproc_thr/
-!benchmark_radix_tree/
-doc/*.1
-doc/*.3
-doc/*.7
+## Unit test source files must be tracked
+!unittests/unittest*.[ch]
+!unittests/unittest*.[ch]pp
+## Build script and documentations must be tracked
+!unittests/CMakeLists.txt
+!unittests/README.md
+
+# check test log files
+test-suite*.log
+
+# /perf
+## Benchmarking binaries and result files are ignored
+perf/*_lat
+perf/*_thr
+perf/benchmark_*
+perf/results
+## Benchmarking source files must be tracked
+!perf/*.[ch]
+!perf/*.[ch]pp
+## Benchmarking tool scripts must be tracked
+!perf/*.py
+!perf/*.sh
+
+# /doc
+## Generated document files 
+doc/*.[137]
 doc/*.html
 doc/*.xml
-doxygen/
-src/libzmq.pc
-bin/
-lib/
-obj/
-builds/android/prefix/
-packaging/nuget/*.nupkg
+
+# external libraries and release archive files
 foreign/openpgm/*
 !foreign/openpgm/*.tar.bz2
 !foreign/openpgm/*.tar.gz
@@ -198,5 +124,4 @@ foreign/openpgm/*
 zeromq-*.tar.gz
 zeromq-*.zip
 core
-build
-test-suite.log
+
diff -pruN 4.3.2-2/include/zmq.h 4.3.3-1/include/zmq.h
--- 4.3.2-2/include/zmq.h	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/include/zmq.h	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,7 @@
 /*  Version macros for compile-time API version detection                     */
 #define ZMQ_VERSION_MAJOR 4
 #define ZMQ_VERSION_MINOR 3
-#define ZMQ_VERSION_PATCH 2
+#define ZMQ_VERSION_PATCH 3
 
 #define ZMQ_MAKE_VERSION(major, minor, patch)                                  \
     ((major) *10000 + (minor) *100 + (patch))
@@ -71,7 +71,6 @@ extern "C" {
 #error You need at least Windows XP target
 #endif
 #endif
-#include <winsock2.h>
 #endif
 
 /*  Handle DSO symbol visibility                                             */
@@ -398,7 +397,7 @@ ZMQ_EXPORT const char *zmq_msg_gets (con
 #define ZMQ_GSSAPI 3
 
 /*  RADIO-DISH protocol                                                       */
-#define ZMQ_GROUP_MAX_LENGTH 15
+#define ZMQ_GROUP_MAX_LENGTH 255
 
 /*  Deprecated options and aliases                                            */
 #define ZMQ_IDENTITY ZMQ_ROUTING_ID
@@ -475,6 +474,7 @@ ZMQ_EXPORT const char *zmq_msg_gets (con
 #define ZMQ_PROTOCOL_ERROR_ZAP_BAD_VERSION 0x20000003
 #define ZMQ_PROTOCOL_ERROR_ZAP_INVALID_STATUS_CODE 0x20000004
 #define ZMQ_PROTOCOL_ERROR_ZAP_INVALID_METADATA 0x20000005
+#define ZMQ_PROTOCOL_ERROR_WS_UNSPECIFIED 0x30000000
 
 ZMQ_EXPORT void *zmq_socket (void *, int type_);
 ZMQ_EXPORT int zmq_close (void *s_);
@@ -492,6 +492,20 @@ zmq_send_const (void *s_, const void *bu
 ZMQ_EXPORT int zmq_recv (void *s_, void *buf_, size_t len_, int flags_);
 ZMQ_EXPORT int zmq_socket_monitor (void *s_, const char *addr_, int events_);
 
+/******************************************************************************/
+/*  Hide socket fd type; this was before zmq_poller_event_t typedef below     */
+/******************************************************************************/
+
+#if defined _WIN32
+// Windows uses a pointer-sized unsigned integer to store the socket fd.
+#if defined _WIN64
+typedef unsigned __int64 zmq_fd_t;
+#else
+typedef unsigned int zmq_fd_t;
+#endif
+#else
+typedef int zmq_fd_t;
+#endif
 
 /******************************************************************************/
 /*  Deprecated I/O multiplexing. Prefer using zmq_poller API                  */
@@ -505,11 +519,7 @@ ZMQ_EXPORT int zmq_socket_monitor (void
 typedef struct zmq_pollitem_t
 {
     void *socket;
-#if defined _WIN32
-    SOCKET fd;
-#else
-    int fd;
-#endif
+    zmq_fd_t fd;
     short events;
     short revents;
 } zmq_pollitem_t;
@@ -648,6 +658,8 @@ ZMQ_EXPORT void zmq_threadclose (void *t
 #define ZMQ_GATHER 16
 #define ZMQ_SCATTER 17
 #define ZMQ_DGRAM 18
+#define ZMQ_PEER 19
+#define ZMQ_CHANNEL 20
 
 /*  DRAFT Socket options.                                                     */
 #define ZMQ_ZAP_ENFORCE_DOMAIN 93
@@ -660,19 +672,45 @@ ZMQ_EXPORT void zmq_threadclose (void *t
 #define ZMQ_SOCKS_PASSWORD 100
 #define ZMQ_IN_BATCH_SIZE 101
 #define ZMQ_OUT_BATCH_SIZE 102
+#define ZMQ_WSS_KEY_PEM 103
+#define ZMQ_WSS_CERT_PEM 104
+#define ZMQ_WSS_TRUST_PEM 105
+#define ZMQ_WSS_HOSTNAME 106
+#define ZMQ_WSS_TRUST_SYSTEM 107
+#define ZMQ_ONLY_FIRST_SUBSCRIBE 108
+#define ZMQ_RECONNECT_STOP 109
+#define ZMQ_HELLO_MSG 110
+#define ZMQ_DISCONNECT_MSG 111
+
+/*  DRAFT ZMQ_RECONNECT_STOP options                                          */
+#define ZMQ_RECONNECT_STOP_CONN_REFUSED 0x1
+#define ZMQ_RECONNECT_STOP_HANDSHAKE_FAILED 0x2
 
 /*  DRAFT Context options                                                     */
 #define ZMQ_ZERO_COPY_RECV 10
 
+/*  DRAFT Context methods.                                                    */
+ZMQ_EXPORT int zmq_ctx_set_ext (void *context_,
+                                int option_,
+                                const void *optval_,
+                                size_t optvallen_);
+ZMQ_EXPORT int zmq_ctx_get_ext (void *context_,
+                                int option_,
+                                void *optval_,
+                                size_t *optvallen_);
+
 /*  DRAFT Socket methods.                                                     */
 ZMQ_EXPORT int zmq_join (void *s, const char *group);
 ZMQ_EXPORT int zmq_leave (void *s, const char *group);
+ZMQ_EXPORT uint32_t zmq_connect_peer (void *s_, const char *addr_);
 
 /*  DRAFT Msg methods.                                                        */
 ZMQ_EXPORT int zmq_msg_set_routing_id (zmq_msg_t *msg, uint32_t routing_id);
 ZMQ_EXPORT uint32_t zmq_msg_routing_id (zmq_msg_t *msg);
 ZMQ_EXPORT int zmq_msg_set_group (zmq_msg_t *msg, const char *group);
 ZMQ_EXPORT const char *zmq_msg_group (zmq_msg_t *msg);
+ZMQ_EXPORT int
+zmq_msg_init_buffer (zmq_msg_t *msg_, const void *buf_, size_t size_);
 
 /*  DRAFT Msg property names.                                                 */
 #define ZMQ_MSG_PROPERTY_ROUTING_ID "Routing-Id"
@@ -690,12 +728,6 @@ ZMQ_EXPORT const char *zmq_msg_group (zm
 
 #define ZMQ_HAVE_POLLER
 
-#if defined _WIN32
-typedef SOCKET zmq_fd_t;
-#else
-typedef int zmq_fd_t;
-#endif
-
 typedef struct zmq_poller_event_t
 {
     void *socket;
@@ -706,6 +738,7 @@ typedef struct zmq_poller_event_t
 
 ZMQ_EXPORT void *zmq_poller_new (void);
 ZMQ_EXPORT int zmq_poller_destroy (void **poller_p);
+ZMQ_EXPORT int zmq_poller_size (void *poller);
 ZMQ_EXPORT int
 zmq_poller_add (void *poller, void *socket, void *user_data, short events);
 ZMQ_EXPORT int zmq_poller_modify (void *poller, void *socket, short events);
diff -pruN 4.3.2-2/INSTALL 4.3.3-1/INSTALL
--- 4.3.2-2/INSTALL	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/INSTALL	2020-09-07 10:12:14.000000000 +0000
@@ -137,6 +137,17 @@ The simplest way to compile this package
   6. Often, you can also type `make uninstall' to remove the installed
      files again.
 
+OS X Builds - Documentation
+===========================
+
+Basic installation on OS X may fail in `Making all in doc' step. This
+error can be resolved by adding environment variable for shell.
+
+export XML_CATALOG_FILES=/usr/local/etc/xml/catalog 
+
+Write comamnd above in shell for instant resolve, or append command into
+shell profile file and reload for permanent resolve.
+
 Compilers and Options
 =====================
 
diff -pruN 4.3.2-2/Makefile.am 4.3.3-1/Makefile.am
--- 4.3.2-2/Makefile.am	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/Makefile.am	2020-09-07 10:12:14.000000000 +0000
@@ -26,11 +26,14 @@ src_libzmq_la_SOURCES = \
 	src/atomic_counter.hpp \
 	src/atomic_ptr.hpp \
 	src/blob.hpp \
+	src/channel.cpp \
+	src/channel.hpp \
 	src/client.cpp \
 	src/client.hpp \
 	src/clock.cpp \
 	src/clock.hpp \
 	src/command.hpp \
+	src/compat.hpp \
 	src/condition_variable.hpp \
 	src/config.hpp \
 	src/ctx.cpp \
@@ -126,6 +129,8 @@ src_libzmq_la_SOURCES = \
 	src/own.hpp \
 	src/pair.cpp \
 	src/pair.hpp \
+	src/peer.cpp \
+	src/peer.hpp \
 	src/pgm_receiver.cpp \
 	src/pgm_receiver.hpp \
 	src/pgm_sender.cpp \
@@ -169,6 +174,8 @@ src_libzmq_la_SOURCES = \
 	src/raw_decoder.hpp \
 	src/raw_encoder.cpp \
 	src/raw_encoder.hpp \
+	src/raw_engine.cpp \
+	src/raw_engine.hpp \
 	src/reaper.cpp \
 	src/reaper.hpp \
 	src/rep.cpp \
@@ -179,6 +186,7 @@ src_libzmq_la_SOURCES = \
 	src/router.hpp \
 	src/scatter.cpp \
 	src/scatter.hpp \
+	src/secure_allocator.hpp \
 	src/select.cpp \
 	src/select.hpp \
 	src/server.cpp \
@@ -200,8 +208,8 @@ src_libzmq_la_SOURCES = \
 	src/stream_connecter_base.hpp \
 	src/stream_listener_base.cpp \
 	src/stream_listener_base.hpp \
-	src/stream_engine.cpp \
-	src/stream_engine.hpp \
+	src/stream_engine_base.cpp \
+	src/stream_engine_base.hpp \
 	src/sub.cpp \
 	src/sub.hpp \
 	src/tcp.cpp \
@@ -236,6 +244,8 @@ src_libzmq_la_SOURCES = \
 	src/v1_encoder.hpp \
 	src/v2_encoder.cpp \
 	src/v2_encoder.hpp \
+	src/v3_1_encoder.cpp \
+	src/v3_1_encoder.hpp \
 	src/v2_protocol.hpp \
 	src/vmci.cpp \
 	src/vmci.hpp \
@@ -263,6 +273,8 @@ src_libzmq_la_SOURCES = \
 	src/socket_poller.hpp \
 	src/zap_client.cpp \
 	src/zap_client.hpp \
+	src/zmtp_engine.cpp \
+	src/zmtp_engine.hpp \
 	src/zmq_draft.h
 
 if USE_WEPOLL
@@ -277,6 +289,37 @@ src_libzmq_la_SOURCES += \
 	src/tweetnacl.h
 endif
 
+if HAVE_WS
+src_libzmq_la_SOURCES += \
+	src/ws_address.cpp \
+	src/ws_address.hpp \
+	src/wss_address.cpp \
+	src/wss_address.hpp \
+	src/ws_connecter.cpp \
+	src/ws_connecter.hpp \
+	src/ws_decoder.cpp \
+	src/ws_decoder.hpp \
+	src/ws_encoder.cpp \
+	src/ws_encoder.hpp \
+	src/ws_engine.cpp \
+	src/ws_engine.hpp \
+	src/ws_listener.cpp \
+	src/ws_listener.hpp \
+	src/ws_protocol.hpp
+endif
+
+if USE_BUILTIN_SHA1
+src_libzmq_la_SOURCES += \
+	external/sha1/sha1.c \
+	external/sha1/sha1.h
+endif
+
+if HAVE_WSS
+src_libzmq_la_SOURCES += \
+	src/wss_engine.cpp \
+	src/wss_engine.hpp
+endif
+
 if ON_MINGW
 src_libzmq_la_LDFLAGS = \
 	-no-undefined \
@@ -308,11 +351,21 @@ if HAVE_VSCRIPT_COMPLEX
 src_libzmq_la_LDFLAGS += $(VSCRIPT_LDFLAGS),$(srcdir)/src/libzmq.vers
 endif
 
-src_libzmq_la_CPPFLAGS = $(CODE_COVERAGE_CPPFLAGS) $(LIBUNWIND_CFLAGS)
-src_libzmq_la_CFLAGS = $(CODE_COVERAGE_CFLAGS) $(LIBUNWIND_CFLAGS)
+src_libzmq_la_CPPFLAGS = $(CODE_COVERAGE_CPPFLAGS) $(LIBUNWIND_CFLAGS) $(LIBBSD_CFLAGS)
+src_libzmq_la_CFLAGS = $(CODE_COVERAGE_CFLAGS) $(LIBUNWIND_CFLAGS) $(LIBBSD_CFLAGS)
 src_libzmq_la_CXXFLAGS = @LIBZMQ_EXTRA_CXXFLAGS@ $(CODE_COVERAGE_CXXFLAGS) \
-	$(LIBUNWIND_CFLAGS)
-src_libzmq_la_LIBADD = $(CODE_COVERAGE_LDFLAGS) $(LIBUNWIND_LIBS)
+	$(LIBUNWIND_CFLAGS) $(LIBBSD_CFLAGS)
+src_libzmq_la_LIBADD = $(CODE_COVERAGE_LDFLAGS) $(LIBUNWIND_LIBS) $(LIBBSD_LIBS)
+
+if USE_NSS
+src_libzmq_la_CPPFLAGS += ${NSS3_CFLAGS}
+src_libzmq_la_LIBADD += ${NSS3_LIBS}
+endif
+
+if USE_GNUTLS
+src_libzmq_la_CPPFLAGS += ${GNUTLS_CFLAGS}
+src_libzmq_la_LIBADD += ${GNUTLS_LIBS}
+endif
 
 if USE_LIBSODIUM
 src_libzmq_la_CPPFLAGS += ${sodium_CFLAGS}
@@ -459,7 +512,8 @@ test_apps = \
 	tests/test_sodium \
 	tests/test_reconnect_ivl \
 	tests/test_mock_pub_sub \
-	tests/test_socket_null
+	tests/test_socket_null \
+	tests/test_tcp_accept_filter
 
 UNITY_CPPFLAGS = -I$(top_srcdir)/external/unity -DUNITY_USE_COMMAND_LINE_ARGS -DUNITY_EXCLUDE_FLOAT
 UNITY_LIBS = $(top_builddir)/external/unity/libunity.a
@@ -483,297 +537,297 @@ tests_libtestutil_a_CPPFLAGS = ${UNITY_C
 noinst_LIBRARIES = external/unity/libunity.a tests/libtestutil.a
 
 tests_test_ancillaries_SOURCES = tests/test_ancillaries.cpp
-tests_test_ancillaries_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_ancillaries_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_ancillaries_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_system_SOURCES = tests/test_system.cpp
-tests_test_system_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_system_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_system_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_pair_inproc_SOURCES = tests/test_pair_inproc.cpp
-tests_test_pair_inproc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_pair_inproc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_pair_inproc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_pair_tcp_SOURCES = tests/test_pair_tcp.cpp
-tests_test_pair_tcp_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_pair_tcp_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_pair_tcp_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_reqrep_inproc_SOURCES = tests/test_reqrep_inproc.cpp
-tests_test_reqrep_inproc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_reqrep_inproc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_reqrep_inproc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_reqrep_tcp_SOURCES = tests/test_reqrep_tcp.cpp
-tests_test_reqrep_tcp_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_reqrep_tcp_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_reqrep_tcp_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_hwm_SOURCES = tests/test_hwm.cpp
-tests_test_hwm_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_hwm_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_hwm_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_hwm_pubsub_SOURCES = tests/test_hwm_pubsub.cpp
-tests_test_hwm_pubsub_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_hwm_pubsub_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_hwm_pubsub_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_reqrep_device_SOURCES = tests/test_reqrep_device.cpp
-tests_test_reqrep_device_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_reqrep_device_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_reqrep_device_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_sub_forward_SOURCES = tests/test_sub_forward.cpp
-tests_test_sub_forward_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_sub_forward_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_sub_forward_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_invalid_rep_SOURCES = tests/test_invalid_rep.cpp
-tests_test_invalid_rep_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_invalid_rep_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_invalid_rep_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_msg_flags_SOURCES = tests/test_msg_flags.cpp
-tests_test_msg_flags_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_msg_flags_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_msg_flags_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_msg_ffn_SOURCES = tests/test_msg_ffn.cpp
-tests_test_msg_ffn_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_msg_ffn_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_msg_ffn_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_connect_resolve_SOURCES = tests/test_connect_resolve.cpp
-tests_test_connect_resolve_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_connect_resolve_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_connect_resolve_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_immediate_SOURCES = tests/test_immediate.cpp
-tests_test_immediate_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_immediate_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_immediate_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_last_endpoint_SOURCES = tests/test_last_endpoint.cpp
-tests_test_last_endpoint_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_last_endpoint_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_last_endpoint_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_term_endpoint_SOURCES = tests/test_term_endpoint.cpp
-tests_test_term_endpoint_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_term_endpoint_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_term_endpoint_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_srcfd_SOURCES = tests/test_srcfd.cpp
-tests_test_srcfd_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_srcfd_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_srcfd_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_monitor_SOURCES = tests/test_monitor.cpp
-tests_test_monitor_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_monitor_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_monitor_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_router_mandatory_SOURCES = tests/test_router_mandatory.cpp
-tests_test_router_mandatory_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_router_mandatory_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_router_mandatory_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_router_mandatory_hwm_SOURCES = tests/test_router_mandatory_hwm.cpp
-tests_test_router_mandatory_hwm_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_router_mandatory_hwm_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_router_mandatory_hwm_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_router_handover_SOURCES = tests/test_router_handover.cpp
-tests_test_router_handover_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_router_handover_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_router_handover_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_probe_router_SOURCES = tests/test_probe_router.cpp
-tests_test_probe_router_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_probe_router_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_probe_router_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_stream_SOURCES = tests/test_stream.cpp
-tests_test_stream_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_stream_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_stream_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_stream_empty_SOURCES = tests/test_stream_empty.cpp
-tests_test_stream_empty_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_stream_empty_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_stream_empty_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_stream_timeout_SOURCES = tests/test_stream_timeout.cpp
-tests_test_stream_timeout_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_stream_timeout_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_stream_timeout_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_stream_disconnect_SOURCES = tests/test_stream_disconnect.cpp
-tests_test_stream_disconnect_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_stream_disconnect_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_stream_disconnect_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_disconnect_inproc_SOURCES = tests/test_disconnect_inproc.cpp
-tests_test_disconnect_inproc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_disconnect_inproc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_disconnect_inproc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_unbind_wildcard_SOURCES = tests/test_unbind_wildcard.cpp
-tests_test_unbind_wildcard_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_unbind_wildcard_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_unbind_wildcard_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_ctx_options_SOURCES = tests/test_ctx_options.cpp
-tests_test_ctx_options_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_ctx_options_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_ctx_options_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_iov_SOURCES = tests/test_iov.cpp
-tests_test_iov_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_iov_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_iov_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_ctx_destroy_SOURCES = tests/test_ctx_destroy.cpp
-tests_test_ctx_destroy_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_ctx_destroy_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_ctx_destroy_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_security_no_zap_handler_SOURCES = tests/test_security_no_zap_handler.cpp
-tests_test_security_no_zap_handler_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_security_no_zap_handler_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_security_no_zap_handler_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_security_null_SOURCES = tests/test_security_null.cpp
-tests_test_security_null_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_security_null_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_security_null_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_security_plain_SOURCES = tests/test_security_plain.cpp
-tests_test_security_plain_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_security_plain_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_security_plain_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_security_zap_SOURCES = tests/test_security_zap.cpp
-tests_test_security_zap_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_security_zap_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_security_zap_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_spec_req_SOURCES = tests/test_spec_req.cpp
-tests_test_spec_req_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_spec_req_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_spec_req_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_spec_rep_SOURCES = tests/test_spec_rep.cpp
-tests_test_spec_rep_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_spec_rep_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_spec_rep_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_spec_dealer_SOURCES = tests/test_spec_dealer.cpp
-tests_test_spec_dealer_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_spec_dealer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_spec_dealer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_spec_router_SOURCES = tests/test_spec_router.cpp
-tests_test_spec_router_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_spec_router_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_spec_router_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_spec_pushpull_SOURCES = tests/test_spec_pushpull.cpp
-tests_test_spec_pushpull_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_spec_pushpull_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_spec_pushpull_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_req_correlate_SOURCES = tests/test_req_correlate.cpp
-tests_test_req_correlate_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_req_correlate_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_req_correlate_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_req_relaxed_SOURCES = tests/test_req_relaxed.cpp
-tests_test_req_relaxed_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_req_relaxed_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_req_relaxed_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_conflate_SOURCES = tests/test_conflate.cpp
-tests_test_conflate_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_conflate_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_conflate_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_inproc_connect_SOURCES = tests/test_inproc_connect.cpp
-tests_test_inproc_connect_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_inproc_connect_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_inproc_connect_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_issue_566_SOURCES = tests/test_issue_566.cpp
-tests_test_issue_566_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_issue_566_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_issue_566_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_proxy_SOURCES = tests/test_proxy.cpp
-tests_test_proxy_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_proxy_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_proxy_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_proxy_hwm_SOURCES = tests/test_proxy_hwm.cpp
-tests_test_proxy_hwm_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_proxy_hwm_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_proxy_hwm_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_proxy_single_socket_SOURCES = tests/test_proxy_single_socket.cpp
-tests_test_proxy_single_socket_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_proxy_single_socket_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_proxy_single_socket_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_proxy_terminate_SOURCES = tests/test_proxy_terminate.cpp
-tests_test_proxy_terminate_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_proxy_terminate_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_proxy_terminate_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_getsockopt_memset_SOURCES = tests/test_getsockopt_memset.cpp
-tests_test_getsockopt_memset_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_getsockopt_memset_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_getsockopt_memset_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
-tests_test_many_sockets_SOURCES = tests/test_many_sockets.cpp
-tests_test_many_sockets_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
-tests_test_many_sockets_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
-
 tests_test_diffserv_SOURCES = tests/test_diffserv.cpp
-tests_test_diffserv_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_diffserv_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_diffserv_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_connect_rid_SOURCES = tests/test_connect_rid.cpp
-tests_test_connect_rid_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_connect_rid_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_connect_rid_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_bind_src_address_SOURCES = tests/test_bind_src_address.cpp
-tests_test_bind_src_address_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_bind_src_address_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_bind_src_address_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_metadata_SOURCES = tests/test_metadata.cpp
-tests_test_metadata_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_metadata_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_metadata_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_capabilities_SOURCES = tests/test_capabilities.cpp
-tests_test_capabilities_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_capabilities_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_capabilities_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_xpub_nodrop_SOURCES = tests/test_xpub_nodrop.cpp
-tests_test_xpub_nodrop_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_xpub_nodrop_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_xpub_nodrop_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_xpub_manual_SOURCES = tests/test_xpub_manual.cpp
-tests_test_xpub_manual_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_xpub_manual_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_xpub_manual_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_xpub_welcome_msg_SOURCES = tests/test_xpub_welcome_msg.cpp
-tests_test_xpub_welcome_msg_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_xpub_welcome_msg_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_xpub_welcome_msg_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_xpub_verbose_SOURCES = tests/test_xpub_verbose.cpp
-tests_test_xpub_verbose_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_xpub_verbose_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_xpub_verbose_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_atomics_SOURCES = tests/test_atomics.cpp
-tests_test_atomics_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_atomics_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_atomics_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_sockopt_hwm_SOURCES = tests/test_sockopt_hwm.cpp
-tests_test_sockopt_hwm_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_sockopt_hwm_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_sockopt_hwm_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_setsockopt_SOURCES = tests/test_setsockopt.cpp
-tests_test_setsockopt_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_setsockopt_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_setsockopt_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_heartbeats_SOURCES = tests/test_heartbeats.cpp
-tests_test_heartbeats_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_heartbeats_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_heartbeats_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_stream_exceeds_buffer_SOURCES = tests/test_stream_exceeds_buffer.cpp
-tests_test_stream_exceeds_buffer_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_stream_exceeds_buffer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_stream_exceeds_buffer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_pub_invert_matching_SOURCES = tests/test_pub_invert_matching.cpp
-tests_test_pub_invert_matching_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_pub_invert_matching_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_pub_invert_matching_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_bind_after_connect_tcp_SOURCES = tests/test_bind_after_connect_tcp.cpp
-tests_test_bind_after_connect_tcp_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_bind_after_connect_tcp_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_bind_after_connect_tcp_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_base85_SOURCES = tests/test_base85.cpp
-tests_test_base85_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_base85_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_base85_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_sodium_SOURCES = tests/test_sodium.cpp
-tests_test_sodium_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_sodium_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_sodium_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_socket_null_SOURCES = tests/test_socket_null.cpp
-tests_test_socket_null_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_socket_null_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_socket_null_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_reconnect_ivl_SOURCES = tests/test_reconnect_ivl.cpp
-tests_test_reconnect_ivl_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_reconnect_ivl_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_reconnect_ivl_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_mock_pub_sub_SOURCES = tests/test_mock_pub_sub.cpp
-tests_test_mock_pub_sub_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_mock_pub_sub_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_mock_pub_sub_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
+tests_test_tcp_accept_filter_SOURCES = tests/test_tcp_accept_filter.cpp
+tests_test_tcp_accept_filter_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_tcp_accept_filter_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
 if HAVE_CURVE
 
 test_apps += \
@@ -795,10 +849,10 @@ tests_test_security_curve_SOURCES += \
 endif
 
 tests_test_security_curve_LDADD = \
-        src/libzmq.la ${TESTUTIL_LIBS} $(LIBUNWIND_LIBS)
+        ${TESTUTIL_LIBS} src/libzmq.la $(LIBUNWIND_LIBS) $(LIBBSD_LIBS)
 tests_test_security_curve_CPPFLAGS = \
         ${TESTUTIL_CPPFLAGS} \
-	${LIBUNWIND_CFLAGS}
+	${LIBUNWIND_CFLAGS}  ${LIBBSD_CFLAGS}
 
 if USE_LIBSODIUM
 tests_test_security_curve_CPPFLAGS += \
@@ -809,6 +863,22 @@ endif
 
 endif
 
+if HAVE_WS
+test_apps += \
+	tests/test_ws_transport
+tests_test_ws_transport_SOURCES = tests/test_ws_transport.cpp
+tests_test_ws_transport_LDADD = ${TESTUTIL_LIBS} src/libzmq.la ${NSS3_LIBS}
+tests_test_ws_transport_CPPFLAGS = ${TESTUTIL_CPPFLAGS} ${NSS3_CFLAGS}
+endif
+
+if HAVE_WSS
+test_apps += \
+	tests/test_wss_transport
+tests_test_wss_transport_SOURCES = tests/test_wss_transport.cpp
+tests_test_wss_transport_LDADD = ${TESTUTIL_LIBS} src/libzmq.la ${GNUTLS_LIBS}
+tests_test_wss_transport_CPPFLAGS = ${TESTUTIL_CPPFLAGS} ${GNUTLS_CFLAGS}
+endif
+
 if !ON_MINGW
 if !ON_CYGWIN
 test_apps += \
@@ -823,39 +893,39 @@ test_apps += \
 	tests/test_filter_ipc
 
 tests_test_shutdown_stress_SOURCES = tests/test_shutdown_stress.cpp
-tests_test_shutdown_stress_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_shutdown_stress_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_shutdown_stress_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_ipc_wildcard_SOURCES = tests/test_ipc_wildcard.cpp
-tests_test_ipc_wildcard_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_ipc_wildcard_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_ipc_wildcard_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_pair_ipc_SOURCES = tests/test_pair_ipc.cpp
-tests_test_pair_ipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_pair_ipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_pair_ipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_rebind_ipc_SOURCES = tests/test_rebind_ipc.cpp
-tests_test_rebind_ipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_rebind_ipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_rebind_ipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_reqrep_ipc_SOURCES = tests/test_reqrep_ipc.cpp
-tests_test_reqrep_ipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_reqrep_ipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_reqrep_ipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_timeo_SOURCES = tests/test_timeo.cpp
-tests_test_timeo_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_timeo_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_timeo_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_filter_ipc_SOURCES = tests/test_filter_ipc.cpp
-tests_test_filter_ipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_filter_ipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_filter_ipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_use_fd_SOURCES = tests/test_use_fd.cpp
-tests_test_use_fd_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_use_fd_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_use_fd_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_zmq_poll_fd_SOURCES = tests/test_zmq_poll_fd.cpp
-tests_test_zmq_poll_fd_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_zmq_poll_fd_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_zmq_poll_fd_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 if HAVE_FORK
@@ -863,7 +933,7 @@ if !VALGRIND_ENABLED
 test_apps += tests/test_fork
 
 tests_test_fork_SOURCES = tests/test_fork.cpp
-tests_test_fork_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_fork_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_fork_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 endif
@@ -884,39 +954,39 @@ test_apps += \
 	tests/test_address_tipc
 
 tests_test_connect_delay_tipc_SOURCES = tests/test_connect_delay_tipc.cpp
-tests_test_connect_delay_tipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_connect_delay_tipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_connect_delay_tipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_pair_tipc_SOURCES = tests/test_pair_tipc.cpp
-tests_test_pair_tipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_pair_tipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_pair_tipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_reqrep_device_tipc_SOURCES = tests/test_reqrep_device_tipc.cpp
-tests_test_reqrep_device_tipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_reqrep_device_tipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_reqrep_device_tipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_reqrep_tipc_SOURCES = tests/test_reqrep_tipc.cpp
-tests_test_reqrep_tipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_reqrep_tipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_reqrep_tipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_router_mandatory_tipc_SOURCES = tests/test_router_mandatory_tipc.cpp
-tests_test_router_mandatory_tipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_router_mandatory_tipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_router_mandatory_tipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_shutdown_stress_tipc_SOURCES = tests/test_shutdown_stress_tipc.cpp
-tests_test_shutdown_stress_tipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_shutdown_stress_tipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_shutdown_stress_tipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_sub_forward_tipc_SOURCES = tests/test_sub_forward_tipc.cpp
-tests_test_sub_forward_tipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_sub_forward_tipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_sub_forward_tipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_term_endpoint_tipc_SOURCES = tests/test_term_endpoint_tipc.cpp
-tests_test_term_endpoint_tipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_term_endpoint_tipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_term_endpoint_tipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_address_tipc_SOURCES = tests/test_address_tipc.cpp
-tests_test_address_tipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_address_tipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_address_tipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 endif
@@ -925,37 +995,45 @@ if BUILD_GSSAPI
 test_apps += tests/test_security_gssapi
 
 tests_test_security_gssapi_SOURCES = tests/test_security_gssapi.cpp
-tests_test_security_gssapi_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_security_gssapi_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_security_gssapi_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 endif
 
 if ON_LINUX
 test_apps += tests/test_abstract_ipc \
-	tests/test_many_sockets \
 	tests/test_socks
 
 tests_test_abstract_ipc_SOURCES = tests/test_abstract_ipc.cpp
-tests_test_abstract_ipc_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_abstract_ipc_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_abstract_ipc_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_socks_SOURCES = tests/test_socks.cpp
-tests_test_socks_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_socks_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_socks_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
+# TODO: enable when https://github.com/zeromq/libzmq/issues/3898 is fixed
+if !ENABLE_ASAN
+test_apps += tests/test_many_sockets
+
+tests_test_many_sockets_SOURCES = tests/test_many_sockets.cpp
+tests_test_many_sockets_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_many_sockets_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+endif
+
 endif
 
 if HAVE_VMCI
 test_apps += test_pair_vmci test_reqrep_vmci
 
 test_pair_vmci_SOURCES = tests/test_pair_vmci.cpp
-test_pair_vmci_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+test_pair_vmci_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 test_pair_vmci_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 test_pair_vmci_LDFLAGS = @LIBZMQ_VMCI_LDFLAGS@
 test_pair_vmci_CXXFLAGS = @LIBZMQ_VMCI_CXXFLAGS@
 
 test_reqrep_vmci_SOURCES = tests/test_reqrep_vmci.cpp
-test_reqrep_vmci_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+test_reqrep_vmci_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 test_reqrep_vmci_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 test_reqrep_vmci_LDFLAGS = @LIBZMQ_VMCI_LDFLAGS@
 test_reqrep_vmci_CXXFLAGS = @LIBZMQ_VMCI_CXXFLAGS@
@@ -972,47 +1050,264 @@ test_apps += tests/test_poller \
 	tests/test_dgram \
 	tests/test_app_meta \
 	tests/test_xpub_manual_last_value \
-	tests/test_router_notify
+	tests/test_router_notify \
+	tests/test_peer \
+	tests/test_reconnect_options \
+	tests/test_msg_init \
+	tests/test_hello_msg \
+	tests/test_disconnect_msg \
+	tests/test_channel
 
 tests_test_poller_SOURCES = tests/test_poller.cpp
-tests_test_poller_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_poller_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_poller_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_client_server_SOURCES = tests/test_client_server.cpp
-tests_test_client_server_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_client_server_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_client_server_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_thread_safe_SOURCES = tests/test_thread_safe.cpp
-tests_test_thread_safe_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_thread_safe_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_thread_safe_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_timers_SOURCES = tests/test_timers.cpp
-tests_test_timers_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_timers_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_timers_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_radio_dish_SOURCES = tests/test_radio_dish.cpp
-tests_test_radio_dish_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_radio_dish_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_radio_dish_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_scatter_gather_SOURCES = tests/test_scatter_gather.cpp
-tests_test_scatter_gather_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_scatter_gather_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_scatter_gather_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_dgram_SOURCES = tests/test_dgram.cpp
-tests_test_dgram_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_dgram_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_dgram_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_xpub_manual_last_value_SOURCES = tests/test_xpub_manual_last_value.cpp
-tests_test_xpub_manual_last_value_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_xpub_manual_last_value_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_xpub_manual_last_value_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_app_meta_SOURCES = tests/test_app_meta.cpp
-tests_test_app_meta_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_app_meta_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_app_meta_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
 
 tests_test_router_notify_SOURCES = tests/test_router_notify.cpp
-tests_test_router_notify_LDADD = src/libzmq.la ${TESTUTIL_LIBS}
+tests_test_router_notify_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
 tests_test_router_notify_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_peer_SOURCES = tests/test_peer.cpp
+tests_test_peer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_peer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_reconnect_options_SOURCES = tests/test_reconnect_options.cpp
+tests_test_reconnect_options_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_reconnect_options_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_msg_init_SOURCES = tests/test_msg_init.cpp
+tests_test_msg_init_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_msg_init_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_hello_msg_SOURCES = tests/test_hello_msg.cpp
+tests_test_hello_msg_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_hello_msg_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_disconnect_msg_SOURCES = tests/test_disconnect_msg.cpp
+tests_test_disconnect_msg_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_disconnect_msg_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_channel_SOURCES = tests/test_channel.cpp
+tests_test_channel_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_channel_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+endif
+
+if FUZZING_ENGINE_LIB
+fuzzer_apps = tests/test_bind_null_fuzzer \
+	tests/test_connect_null_fuzzer \
+	tests/test_bind_fuzzer \
+	tests/test_connect_fuzzer \
+	tests/test_bind_stream_fuzzer \
+	tests/test_connect_stream_fuzzer \
+	tests/test_socket_options_fuzzer
+
+tests_test_bind_null_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_bind_null_fuzzer_SOURCES = tests/test_bind_null_fuzzer.cpp
+tests_test_bind_null_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_bind_null_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_bind_null_fuzzer_CXXFLAGS = -std=c++11
+
+tests_test_connect_null_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_connect_null_fuzzer_SOURCES = tests/test_connect_null_fuzzer.cpp
+tests_test_connect_null_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_connect_null_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_connect_null_fuzzer_CXXFLAGS = -std=c++11
+
+tests_test_bind_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_bind_fuzzer_SOURCES = tests/test_bind_fuzzer.cpp
+tests_test_bind_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_bind_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_bind_fuzzer_CXXFLAGS = -std=c++11
+
+tests_test_connect_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_connect_fuzzer_SOURCES = tests/test_connect_fuzzer.cpp
+tests_test_connect_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_connect_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_connect_fuzzer_CXXFLAGS = -std=c++11
+
+tests_test_socket_options_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_socket_options_fuzzer_SOURCES = tests/test_socket_options_fuzzer.cpp
+tests_test_socket_options_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_socket_options_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_socket_options_fuzzer_CXXFLAGS = -std=c++11
+
+tests_test_bind_stream_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_bind_stream_fuzzer_SOURCES = tests/test_bind_stream_fuzzer.cpp
+tests_test_bind_stream_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_bind_stream_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_bind_stream_fuzzer_CXXFLAGS = -std=c++11
+
+tests_test_connect_stream_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_connect_stream_fuzzer_SOURCES = tests/test_connect_stream_fuzzer.cpp
+tests_test_connect_stream_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_connect_stream_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_connect_stream_fuzzer_CXXFLAGS = -std=c++11
+
+if HAVE_CURVE
+fuzzer_apps += tests/test_bind_curve_fuzzer \
+	tests/test_connect_curve_fuzzer \
+	tests/test_z85_decode_fuzzer
+
+tests_test_bind_curve_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_bind_curve_fuzzer_SOURCES = tests/test_bind_curve_fuzzer.cpp
+tests_test_bind_curve_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_bind_curve_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_bind_curve_fuzzer_CXXFLAGS = -std=c++11
+
+tests_test_connect_curve_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_connect_curve_fuzzer_SOURCES = tests/test_connect_curve_fuzzer.cpp
+tests_test_connect_curve_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_connect_curve_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_connect_curve_fuzzer_CXXFLAGS = -std=c++11
+
+tests_test_z85_decode_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_z85_decode_fuzzer_SOURCES = tests/test_z85_decode_fuzzer.cpp
+tests_test_z85_decode_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_z85_decode_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_z85_decode_fuzzer_CXXFLAGS = -std=c++11
+endif
+
+if HAVE_WS
+fuzzer_apps += tests/test_connect_ws_fuzzer \
+	tests/test_bind_ws_fuzzer
+
+tests_test_connect_ws_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_connect_ws_fuzzer_SOURCES = tests/test_connect_ws_fuzzer.cpp
+tests_test_connect_ws_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_connect_ws_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_connect_ws_fuzzer_CXXFLAGS = -std=c++11
+
+tests_test_bind_ws_fuzzer_DEPENDENCIES = src/libzmq.la
+tests_test_bind_ws_fuzzer_SOURCES = tests/test_bind_ws_fuzzer.cpp
+tests_test_bind_ws_fuzzer_LDADD = ${TESTUTIL_LIBS} ${FUZZING_ENGINE_LIB} \
+		$(top_builddir)/src/.libs/libzmq.a \
+		${src_libzmq_la_LIBADD}
+tests_test_bind_ws_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+tests_test_bind_ws_fuzzer_CXXFLAGS = -std=c++11
+endif
+
+FUZZINGdir = ${prefix}/${FUZZING_INSTALLDIR}
+FUZZING_PROGRAMS = ${fuzzer_apps}
+else
+test_apps += tests/test_bind_null_fuzzer \
+	tests/test_connect_null_fuzzer \
+	tests/test_bind_fuzzer \
+	tests/test_connect_fuzzer \
+	tests/test_bind_stream_fuzzer \
+	tests/test_connect_stream_fuzzer \
+	tests/test_socket_options_fuzzer
+
+tests_test_bind_null_fuzzer_SOURCES = tests/test_bind_null_fuzzer.cpp
+tests_test_bind_null_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_bind_null_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_connect_null_fuzzer_SOURCES = tests/test_connect_null_fuzzer.cpp
+tests_test_connect_null_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_connect_null_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_bind_fuzzer_SOURCES = tests/test_bind_fuzzer.cpp
+tests_test_bind_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_bind_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_connect_fuzzer_SOURCES = tests/test_connect_fuzzer.cpp
+tests_test_connect_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_connect_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_socket_options_fuzzer_SOURCES = tests/test_socket_options_fuzzer.cpp
+tests_test_socket_options_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_socket_options_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_bind_stream_fuzzer_SOURCES = tests/test_bind_stream_fuzzer.cpp
+tests_test_bind_stream_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_bind_stream_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_connect_stream_fuzzer_SOURCES = tests/test_connect_stream_fuzzer.cpp
+tests_test_connect_stream_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_connect_stream_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+if HAVE_CURVE
+test_apps += tests/test_bind_curve_fuzzer \
+	tests/test_connect_curve_fuzzer \
+	tests/test_z85_decode_fuzzer
+
+tests_test_bind_curve_fuzzer_SOURCES = tests/test_bind_curve_fuzzer.cpp
+tests_test_bind_curve_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_bind_curve_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_connect_curve_fuzzer_SOURCES = tests/test_connect_curve_fuzzer.cpp
+tests_test_connect_curve_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_connect_curve_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_z85_decode_fuzzer_SOURCES = tests/test_z85_decode_fuzzer.cpp
+tests_test_z85_decode_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_z85_decode_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+endif
+
+if HAVE_WS
+test_apps += tests/test_connect_ws_fuzzer \
+	tests/test_bind_ws_fuzzer
+
+tests_test_connect_ws_fuzzer_SOURCES = tests/test_connect_ws_fuzzer.cpp
+tests_test_connect_ws_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_connect_ws_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+
+tests_test_bind_ws_fuzzer_SOURCES = tests/test_bind_ws_fuzzer.cpp
+tests_test_bind_ws_fuzzer_LDADD = ${TESTUTIL_LIBS} src/libzmq.la
+tests_test_bind_ws_fuzzer_CPPFLAGS = ${TESTUTIL_CPPFLAGS}
+endif
 endif
 
 if ENABLE_STATIC
@@ -1023,7 +1318,8 @@ test_apps += \
 	unittests/unittest_mtrie \
 	unittests/unittest_ip_resolver \
 	unittests/unittest_udp_address \
-	unittests/unittest_radix_tree
+	unittests/unittest_radix_tree \
+	unittests/unittest_curve_encoding
 
 unittests_unittest_poller_SOURCES = unittests/unittest_poller.cpp
 unittests_unittest_poller_CPPFLAGS = -I$(top_srcdir)/src ${TESTUTIL_CPPFLAGS} $(CODE_COVERAGE_CPPFLAGS)
@@ -1077,6 +1373,15 @@ unittests_unittest_radix_tree_LDADD =  \
         ${TESTUTIL_LIBS} \
         $(top_builddir)/src/.libs/libzmq.a \
         ${src_libzmq_la_LIBADD} \
+        $(CODE_COVERAGE_LDFLAGS)
+
+unittests_unittest_curve_encoding_SOURCES = unittests/unittest_curve_encoding.cpp
+unittests_unittest_curve_encoding_CPPFLAGS = -I$(top_srcdir)/src ${TESTUTIL_CPPFLAGS} $(CODE_COVERAGE_CPPFLAGS)
+unittests_unittest_curve_encoding_CXXFLAGS = $(CODE_COVERAGE_CXXFLAGS)
+unittests_unittest_curve_encoding_LDADD =  \
+        ${TESTUTIL_LIBS} \
+        $(top_builddir)/src/.libs/libzmq.a \
+        ${src_libzmq_la_LIBADD} \
         $(CODE_COVERAGE_LDFLAGS)
 endif
 
diff -pruN 4.3.2-2/NEWS 4.3.3-1/NEWS
--- 4.3.2-2/NEWS	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/NEWS	2020-09-07 10:12:14.000000000 +0000
@@ -1,3 +1,184 @@
+0MQ version 4.3.3 stable, released on 2020/09/07
+================================================
+
+* Security advisories:
+  * CVE-2020-15166: Denial-of-Service on CURVE/ZAP-protected servers by
+    unauthenticated clients.
+    If a raw TCP socket is opened and connected to an endpoint that is fully
+    configured with CURVE/ZAP, legitimate clients will not be able to exchange
+    any message. Handshakes complete successfully, and messages are delivered to
+    the library, but the server application never receives them.
+    For more information see the security advisory:
+    https://github.com/zeromq/libzmq/security/advisories/GHSA-25wp-cf8g-938m
+  * Stack overflow on server running PUB/XPUB socket (CURVE disabled).
+    The PUB/XPUB subscription store (mtrie) is traversed using recursive
+    function calls. In the remove (unsubscription) case, the recursive calls are
+    NOT tail calls, so even with optimizations the stack grows linearly with the
+    length of a subscription topic. Topics are under the control of remote
+    clients - they can send a subscription to arbitrary length topics. An
+    attacker can thus cause a server to create an mtrie sufficiently large such
+    that, when unsubscribing, traversal will cause a stack overflow.
+    For more information see the security advisory:
+    https://github.com/zeromq/libzmq/security/advisories/GHSA-qq65-x72m-9wr8
+  * Memory leak in PUB server induced by malicious client(s) without CURVE/ZAP.
+    Messages with metadata are never processed by PUB sockets, but the metadata
+    is kept referenced in the PUB object and never freed.
+    For more information see the security advisory:
+    https://github.com/zeromq/libzmq/security/advisories/GHSA-4p5v-h92w-6wxw
+  * Memory leak in client induced by malicious server(s) without CURVE/ZAP.
+    When a pipe processes a delimiter and is already not in active state but
+    still has an unfinished message, the message is leaked.
+    For more information see the security advisory:
+    https://github.com/zeromq/libzmq/security/advisories/GHSA-wfr2-29gj-5w87
+  * Heap overflow when receiving malformed ZMTP v1 packets (CURVE disabled).
+    By crafting a packet which is not valid ZMTP v2/v3, and which has two
+    messages larger than 8192 bytes, the decoder can be tricked into changing
+    the recorded size of the 8192 bytes static buffer, which then gets overflown
+    by the next message. The content that gets written in the overflown memory
+    is entirely decided by the sender.
+    For more information see the security advisory:
+    https://github.com/zeromq/libzmq/security/advisories/GHSA-fc3w-qxf5-7hp6
+
+* Note for packagers: an external, self-contained sha1 library is now
+  included in the source tree under external/sha1/ - it is licensed
+  under BSD-3-Clause and thus it is fully compatible with libzmq's
+  license.
+  It is only used if WebSockets support is enabled, and if neither GnuTLS nor
+  NSS are available.
+
+* Note for packagers: an internal reimplementation of strlcpy is now included,
+  for wider platform compatibility.
+  libbsd can be used and is enabled by default if available instead of the
+  internal implementation, for better security maintenance in distros.
+
+* Note for packagers: ZeroMQConfig.cmake is now installed in the arch-dependent
+  subdirectory - eg: /usr/lib/x86_64-linux-gnu/cmake/
+
+* New DRAFT (see NEWS for 4.2.0) socket type:
+  - ZMQ_CHANNEL is a thread-safe alternative to ZMQ_PAIR.
+  See doc/zmq_socket.txt for details.
+
+* New DRAFT (see NEWS for 4.2.0) socket option:
+  - ZMQ_ONLY_FIRST_SUBSCRIBE will cause only the first part of a multipart
+    message to be processed as a subscribe/unsubscribe message, and the rest
+    will be forwarded as user data to the application.
+  - ZMQ_RECONNECT_STOP will cause a connecting socket to stop trying to
+    reconnect in specific circumstances. See the manpage for details.
+  - ZMQ_HELLO_MSG to set a message that will be automatically sent to a new
+    connection.
+  - ZMQ_DISCONNECT_MSG to set a message that will be automatically received when
+    a peer disconnects.
+  See doc/zmq_setsockopt.txt and doc/zmq_getsockopt.txt for details.
+
+* New DRAFT (see NEWS for 4.2.0) zmq_ctx_get_ext/zmq_ctx_set_ext APIs were added
+  to allow enhancing the context options with variable data inputs.
+  See doc/zmq_ctx_get_ext.txt and doc/zmq_ctx_set_ext.txt for details.
+
+* New DRAFT (see NEWS for 4.2.0) transport options WS and WSS added for support
+  of WebSockets (and secure WebSockets via TLS) via the ZWS 2.0 protocol.
+  WSS requires the GnuTLS library for TLS support. ZMQ_WSS_ specific socket
+  options were added to support TLS.
+  WebSockets support is disabled by default if DRAFT APIs are disabled.
+
+* New DRAFT (see NEWS for 4.2.0) socket type, PEER, which is thread safe and a
+  related zmq_connect_peer function which atomically and thread-safely connects
+  and returns a routing-id.
+
+* New DRAFT (see NEWS for 4.2.0) zmq_msg_init_buffer API was added to allow
+  the construction of a message by copying from an existing buffer.
+
+* New DRAFT (see NEWS for 4.2.0) zmq_poller_size API was added to allow querying
+  the number of sockets/fds registered in a zmq_poller.
+
+* ZMTP 3.1 peers will receive subscribe/cancel on PUB/SUB via commands rather
+  than using the first byte of the payload.
+
+* zmq_z85_decode now checks that the input string's length is at least 5 characters
+  and always a multiple of 5 as per API specification.
+
+* Fixed #3566 - malformed CURVE message can cause memory leak
+
+* Fixed #3567 - missing ZeroMQ_INCLUDE_DIR in ZeroMQConfig.cmake when only
+                static lib is built
+
+* Fixed #3576 - CURVE plaintext secrets now stored in libsodium's secure memory
+
+* Fixed #3588 - install debug libraries for debug msvc builds with CMake
+
+* Fixed #3591 - incorrect ZMQ_MAX_SOCKETS default value in doc
+
+* Fixed #3594 - fixed stream_engine use after free due to concurrent heartbeats
+
+* Fixed #3586 - error when compiling with MinGW due to usage of MS-specific
+                __except keyword
+
+* Fixed #3603 - fixed CMake build on SL6.9
+
+* Fixed #3607 - added scripts to ease performance graph generation
+
+* Fixed #3608 - fix for IPv4 mapping not supported in DragonFlyBSD
+
+* Fixed #3636 - added ENABLE_PRECOMPILED CMake option to fix build with Ninja
+
+* Fixed #2862 - UDP engine aborts on networking-related errors from socket
+                syscalls
+
+* Fixed #3656 - segfault on sending data from XSUB to XPUB
+
+* Fixed #3646 - static-only test run fails
+
+* Fixed #3668 - fixed CMAKE_CXX_FLAGS_* regexes on MSVC
+
+* Fixed #110  - do not include winsock2.h in public zmq.h header
+
+* Fixed #3683 - allow "configure --disable-maintainer-mode"
+
+* Fixed #3686 - fix documentation about sockets blocking on send operations
+
+* Fixed #3323 - fix behavior of ZMQ_CONFLATE on PUB sockets
+
+* Fixed #3698 - fix build on IBM i/PASE/os400
+
+* Fixed #3705 - zero-sized messages cause assertion when glibc assertion are on
+
+* Fixed #3713 - remove dependency on math library by avoiding std::ceil
+
+* Fixed #3694 - build targeting Windows XP is broken
+
+* Fixed #3691 - added support for IPC on Windows 10 via AF_UNIX
+
+* Fixed #3725 - disable by default test that requires sudo on CMake
+
+* Fixed #3727 - fix zmq_poller documentation example
+
+* Fixed #3729 - do not check for FD_OOB when using WSAEventSelect on Windows
+
+* Fixed #3738 - allow renaming the library in CMake
+
+* Fixed #1808 - use AF_UNIX instead of TCP for the internal socket on Windows 10
+
+* Fixed #3758 - fix pthread_set_affinity detection in CMake
+
+* Fixed #3769 - fix undefined behaviour in array.hpp
+
+* Fixed #3772 - fix compiling under msys2-mingw
+
+* Fixed #3775 - add -latomic to the private libs flag in pkg-config if needed
+
+* Fixed #3778 - fix documentation of zmq_poller's thread safety
+
+* Fixed #3792 - do not allow creation of new sockets after zmq_ctx_shutdown
+
+* Fixed #3805 - improve performance of CURVE by reducing copies
+
+* Fixed #3814 - send subscribe/cancel as commands to ZMTP 3.1 peers
+
+* Fixed #3847 - fix building without PGM and NORM
+
+* Fixed #3849 - install .cmake file in arch-dependent subdirectory
+
+* Fixed #4005 - allow building on Windows ARM/ARM64
+
 0MQ version 4.3.2 stable, released on 2019/07/08
 ================================================
 
diff -pruN 4.3.2-2/packaging/debian/changelog 4.3.3-1/packaging/debian/changelog
--- 4.3.2-2/packaging/debian/changelog	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/packaging/debian/changelog	2020-09-07 10:12:14.000000000 +0000
@@ -1,4 +1,4 @@
-zeromq (4.3.2) UNRELEASED; urgency=low
+zeromq (4.3.3-0.1) UNRELEASED; urgency=low
 
   * Initial packaging.
 
diff -pruN 4.3.2-2/packaging/debian/control 4.3.3-1/packaging/debian/control
--- 4.3.2-2/packaging/debian/control	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/packaging/debian/control	2020-09-07 10:12:14.000000000 +0000
@@ -9,6 +9,9 @@ Build-Depends: debhelper (>= 9),
  libpgm-dev,
  libsodium-dev,
  libunwind-dev | libunwind8-dev | libunwind7-dev,
+ libnss3-dev,
+ libgnutls28-dev | libgnutls-dev,
+ libbsd-dev,
  pkg-config,
  asciidoc-base | asciidoc, xmlto,
 Standards-Version: 3.9.8
@@ -38,6 +41,9 @@ Depends: libzmq5 (= ${binary:Version}),
  libpgm-dev,
  libsodium-dev,
  libunwind-dev | libunwind8-dev | libunwind7-dev,
+ libnss3-dev,
+ libgnutls28-dev | libgnutls-dev,
+ libbsd-dev,
 Conflicts: libzmq-dev, libzmq5-dev
 Replaces: libzmq5-dev
 Provides: libzmq5-dev
diff -pruN 4.3.2-2/packaging/debian/rules 4.3.3-1/packaging/debian/rules
--- 4.3.2-2/packaging/debian/rules	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/packaging/debian/rules	2020-09-07 10:12:14.000000000 +0000
@@ -43,7 +43,7 @@ override_dh_clean:
 	rm -f config.log
 
 override_dh_auto_configure:
-	dh_auto_configure -- --with-pgm --with-libsodium --enable-drafts=$(DRAFTS) --with-libgssapi_krb5=yes --with-norm=yes
+	dh_auto_configure -- --with-pgm --with-libsodium --enable-drafts=$(DRAFTS) --with-libgssapi_krb5=yes --with-norm=yes --with-nss=yes --with-tls=yes
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
diff -pruN 4.3.2-2/packaging/debian/zeromq.dsc.obs 4.3.3-1/packaging/debian/zeromq.dsc.obs
--- 4.3.2-2/packaging/debian/zeromq.dsc.obs	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/packaging/debian/zeromq.dsc.obs	2020-09-07 10:12:14.000000000 +0000
@@ -2,11 +2,11 @@ Format: 3.0 (quilt)
 Source: zeromq
 Binary: libzmq5, libzmq3-dev, libzmq5-dbg
 Architecture: any
-Version: 4.3.2
+Version: 4.3.3-0.1
 Maintainer: libzmq Developers <zeromq-dev@lists.zeromq.org>
 Homepage: http://www.zeromq.org/
 Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9), dh-autoreconf, libkrb5-dev, libpgm-dev, libnorm-dev, libsodium-dev, libunwind-dev | libunwind8-dev | libunwind7-dev, pkg-config, asciidoc-base | asciidoc, xmlto
+Build-Depends: debhelper (>= 9), dh-autoreconf, libkrb5-dev, libpgm-dev, libnorm-dev, libsodium-dev, libunwind-dev | libunwind8-dev | libunwind7-dev, libnss3-dev, libgnutls28-dev | libgnutls-dev, libbsd-dev, pkg-config, asciidoc-base | asciidoc, xmlto
 Package-List:
  libzmq3-dev deb libdevel optional arch=any
  libzmq5 deb libs optional arch=any
diff -pruN 4.3.2-2/packaging/nuget/package.config 4.3.3-1/packaging/nuget/package.config
--- 4.3.2-2/packaging/nuget/package.config	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/packaging/nuget/package.config	2020-09-07 10:12:14.000000000 +0000
@@ -1,6 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <!-- These values are populated into the package.gsl templates by package.bat. -->
 <!-- The target attribute controls path and file name only, id controls package naming. -->
-<package id="libzmq-vc120" target="libzmq" version = "4.2.3.0" pathversion="4_2_3_0" platformtoolset="v120">
+<package id="libzmq-vc142" target="libzmq" version = "4.2.3.0" pathversion="4_2_3_0" platformtoolset="v142">
   <!--<dependency id="libsodium_vc120" version="1.0.12.0" />-->
 </package>
\ No newline at end of file
diff -pruN 4.3.2-2/packaging/nuget/package.nuspec 4.3.3-1/packaging/nuget/package.nuspec
--- 4.3.2-2/packaging/nuget/package.nuspec	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/packaging/nuget/package.nuspec	2020-09-07 10:12:14.000000000 +0000
@@ -1,98 +1,98 @@
-<?xml version="1.0" encoding="utf-8"?>
-<!--
-#################################################################
-#   GENERATED SOURCE CODE, DO NOT EDIT EXCEPT EXPERIMENTALLY    #
-#################################################################
--->
-<package xmlns="http://schemas.microsoft.com/packaging/2013/01/nuspec.xsd">
-    <metadata minClientVersion="2.5">
-        <id>libzmq-vc120</id>
-        <version>4.2.3.0</version>
-        <title>libzmq-vc120</title>
-        <authors>libzmq contributors</authors>
-        <owners>Eric Voskuil</owners>
-        <licenseUrl>https://raw.github.com/zeromq/libzmq/master/COPYING.LESSER</licenseUrl>
-        <projectUrl>https://github.com/zeromq/libzmq</projectUrl>
-        <iconUrl>https://avatars1.githubusercontent.com/u/109777?s=32</iconUrl>
-        <requireLicenseAcceptance>true</requireLicenseAcceptance>
-        <developmentDependency>false</developmentDependency>
-        <description>The 0MQ lightweight messaging kernel is a library which extends the standard socket interfaces with features traditionally provided by specialised messaging middleware products. 0MQ sockets provide an abstraction of asynchronous message queues, multiple messaging patterns, message filtering (subscriptions), seamless access to multiple transport protocols and more.</description>
-        <summary>The 0MQ lightweight messaging kernel, with tweetnacl integrated, packaged for specific Visual Studio compiler.</summary>
-        <releaseNotes>https://raw.github.com/zeromq/libzmq/master/NEWS</releaseNotes>
-        <copyright>GNU Lesser GPL v3</copyright>
-        <tags>native, libzmq, zmq, 0MQ, messaging, sockets, C++</tags>
-        <dependencies>
-        </dependencies>
-    </metadata>
-    <files>
-        <!-- include -->
-        
-        <file src="..\..\include\*.h" target="build\native\include" />
-        <file src="..\..\builds\msvc\platform.hpp" target="build\native\include" />
-
-        <!-- targets -->
-      
-        <file src="package.targets" target="build\native\libzmq-vc120.targets" />
-        <file src="package.xml" target="build\native\package.xml" />
-        
-        <!-- docs -->
-        
-        <!-- Documents (.*) -->
-        <!--<file src="..\..\docs\*" target="build\native\docs" />-->
-        
-        <!-- libraries -->
-
-        <!-- x86 Dynamic libraries (.dll) -->
-        <file src="..\..\bin\Win32\Release\v120\dynamic\libzmq.dll" target="build\native\bin\libzmq-x86-v120-mt-4_2_3_0.dll" />
-        <file src="..\..\bin\Win32\Debug\v120\dynamic\libzmq.dll" target="build\native\bin\libzmq-x86-v120-mt-gd-4_2_3_0.dll" />
-
-        <!-- x86 Debugging symbols (.pdb) -->
-        <!--<file src="..\..\bin\Win32\Release\v120\dynamic\libzmq.pdb" target="build\native\bin\libzmq-x86-v120-mt-4_2_3_0.pdb" />-->
-        <file src="..\..\bin\Win32\Debug\v120\dynamic\libzmq.pdb" target="build\native\bin\libzmq-x86-v120-mt-gd-4_2_3_0.pdb" />
-
-        <!-- x86 Import libraries (.imp.lib) -->
-        <file src="..\..\bin\Win32\Release\v120\dynamic\libzmq.lib" target="build\native\bin\libzmq-x86-v120-mt-4_2_3_0.imp.lib" />
-        <file src="..\..\bin\Win32\Debug\v120\dynamic\libzmq.lib" target="build\native\bin\libzmq-x86-v120-mt-gd-4_2_3_0.imp.lib" />
-
-        <!-- x86 Export libraries (.exp) -->
-        <file src="..\..\bin\Win32\Release\v120\dynamic\libzmq.exp" target="build\native\bin\libzmq-x86-v120-mt-4_2_3_0.exp" />
-        <file src="..\..\bin\Win32\Debug\v120\dynamic\libzmq.exp" target="build\native\bin\libzmq-x86-v120-mt-gd-4_2_3_0.exp" />
-
-        <!-- x86 Static libraries (.lib) -->
-        <file src="..\..\bin\Win32\Release\v120\static\libzmq.lib" target="build\native\bin\libzmq-x86-v120-mt-s-4_2_3_0.lib" />
-        <file src="..\..\bin\Win32\Debug\v120\static\libzmq.lib" target="build\native\bin\libzmq-x86-v120-mt-sgd-4_2_3_0.lib" />
-
-        <!-- x86 Static link time code generation libraries (.ltcg.lib) -->
-        <file src="..\..\bin\Win32\Release\v120\ltcg\libzmq.lib" target="build\native\bin\libzmq-x86-v120-mt-s-4_2_3_0.ltcg.lib" />
-        <file src="..\..\bin\Win32\Debug\v120\ltcg\libzmq.lib" target="build\native\bin\libzmq-x86-v120-mt-sgd-4_2_3_0.ltcg.lib" />
-
-        <!-- x64 Dynamic libraries (.dll) -->
-        <file src="..\..\bin\x64\Release\v120\dynamic\libzmq.dll" target="build\native\bin\libzmq-x64-v120-mt-4_2_3_0.dll" />
-        <file src="..\..\bin\x64\Debug\v120\dynamic\libzmq.dll" target="build\native\bin\libzmq-x64-v120-mt-gd-4_2_3_0.dll" />
-
-        <!-- x64 Debugging symbols (.pdb) -->
-        <!--<file src="..\..\bin\x64\Release\v120\dynamic\libzmq.pdb" target="build\native\bin\libzmq-x64-v120-mt-4_2_3_0.pdb" />-->
-        <file src="..\..\bin\x64\Debug\v120\dynamic\libzmq.pdb" target="build\native\bin\libzmq-x64-v120-mt-gd-4_2_3_0.pdb" />
-
-        <!-- x64 Import libraries (.imp.lib) -->
-        <file src="..\..\bin\x64\Release\v120\dynamic\libzmq.lib" target="build\native\bin\libzmq-x64-v120-mt-4_2_3_0.imp.lib" />
-        <file src="..\..\bin\x64\Debug\v120\dynamic\libzmq.lib" target="build\native\bin\libzmq-x64-v120-mt-gd-4_2_3_0.imp.lib" />
-
-        <!-- x64 Export libraries (.exp) -->
-        <file src="..\..\bin\x64\Release\v120\dynamic\libzmq.exp" target="build\native\bin\libzmq-x64-v120-mt-4_2_3_0.exp" />
-        <file src="..\..\bin\x64\Debug\v120\dynamic\libzmq.exp" target="build\native\bin\libzmq-x64-v120-mt-gd-4_2_3_0.exp" />
-
-        <!-- x64 Static libraries (.lib) -->
-        <file src="..\..\bin\x64\Release\v120\static\libzmq.lib" target="build\native\bin\libzmq-x64-v120-mt-s-4_2_3_0.lib" />
-        <file src="..\..\bin\x64\Debug\v120\static\libzmq.lib" target="build\native\bin\libzmq-x64-v120-mt-sgd-4_2_3_0.lib" />
-
-        <!-- x64 Static link time code generation libraries (.ltcg.lib) -->
-        <file src="..\..\bin\Win32\Release\v120\ltcg\libzmq.lib" target="build\native\bin\libzmq-x64-v120-mt-s-4_2_3_0.ltcg.lib" />
-        <file src="..\..\bin\Win32\Debug\v120\ltcg\libzmq.lib" target="build\native\bin\libzmq-x64-v120-mt-sgd-4_2_3_0.ltcg.lib" />
-    </files>
-<!--
-#################################################################
-#   GENERATED SOURCE CODE, DO NOT EDIT EXCEPT EXPERIMENTALLY    #
-#################################################################
--->
-</package>
+<?xml version="1.0" encoding="utf-8"?>
+<!--
+#################################################################
+#   GENERATED SOURCE CODE, DO NOT EDIT EXCEPT EXPERIMENTALLY    #
+#################################################################
+-->
+<package xmlns="http://schemas.microsoft.com/packaging/2013/01/nuspec.xsd">
+    <metadata minClientVersion="2.5">
+        <id>libzmq-vc142</id>
+        <version>4.2.3.0</version>
+        <title>libzmq-vc142</title>
+        <authors>libzmq contributors</authors>
+        <owners>Eric Voskuil</owners>
+        <licenseUrl>https://raw.github.com/zeromq/libzmq/master/COPYING.LESSER</licenseUrl>
+        <projectUrl>https://github.com/zeromq/libzmq</projectUrl>
+        <iconUrl>https://avatars1.githubusercontent.com/u/109777?s=32</iconUrl>
+        <requireLicenseAcceptance>true</requireLicenseAcceptance>
+        <developmentDependency>false</developmentDependency>
+        <description>The 0MQ lightweight messaging kernel is a library which extends the standard socket interfaces with features traditionally provided by specialised messaging middleware products. 0MQ sockets provide an abstraction of asynchronous message queues, multiple messaging patterns, message filtering (subscriptions), seamless access to multiple transport protocols and more.</description>
+        <summary>The 0MQ lightweight messaging kernel, with tweetnacl integrated, packaged for specific Visual Studio compiler.</summary>
+        <releaseNotes>https://raw.github.com/zeromq/libzmq/master/NEWS</releaseNotes>
+        <copyright>GNU Lesser GPL v3</copyright>
+        <tags>native, libzmq, zmq, 0MQ, messaging, sockets, C++</tags>
+        <dependencies>
+        </dependencies>
+    </metadata>
+    <files>
+        <!-- include -->
+
+        <file src="..\..\include\*.h" target="build\native\include" />
+        <file src="..\..\builds\msvc\platform.hpp" target="build\native\include" />
+
+        <!-- targets -->
+
+        <file src="package.targets" target="build\native\libzmq-vc142.targets" />
+        <file src="package.xml" target="build\native\package.xml" />
+
+        <!-- docs -->
+
+        <!-- Documents (.*) -->
+        <!--<file src="..\..\docs\*" target="build\native\docs" />-->
+
+        <!-- libraries -->
+
+        <!-- x86 Dynamic libraries (.dll) -->
+        <file src="..\..\bin\Win32\Release\v142\dynamic\libzmq.dll" target="build\native\bin\libzmq-x86-v142-mt-4_2_3_0.dll" />
+        <file src="..\..\bin\Win32\Debug\v142\dynamic\libzmq.dll" target="build\native\bin\libzmq-x86-v142-mt-gd-4_2_3_0.dll" />
+
+        <!-- x86 Debugging symbols (.pdb) -->
+        <!--<file src="..\..\bin\Win32\Release\v142\dynamic\libzmq.pdb" target="build\native\bin\libzmq-x86-v142-mt-4_2_3_0.pdb" />-->
+        <file src="..\..\bin\Win32\Debug\v142\dynamic\libzmq.pdb" target="build\native\bin\libzmq-x86-v142-mt-gd-4_2_3_0.pdb" />
+
+        <!-- x86 Import libraries (.imp.lib) -->
+        <file src="..\..\bin\Win32\Release\v142\dynamic\libzmq.lib" target="build\native\bin\libzmq-x86-v142-mt-4_2_3_0.imp.lib" />
+        <file src="..\..\bin\Win32\Debug\v142\dynamic\libzmq.lib" target="build\native\bin\libzmq-x86-v142-mt-gd-4_2_3_0.imp.lib" />
+
+        <!-- x86 Export libraries (.exp) -->
+        <file src="..\..\bin\Win32\Release\v142\dynamic\libzmq.exp" target="build\native\bin\libzmq-x86-v142-mt-4_2_3_0.exp" />
+        <file src="..\..\bin\Win32\Debug\v142\dynamic\libzmq.exp" target="build\native\bin\libzmq-x86-v142-mt-gd-4_2_3_0.exp" />
+
+        <!-- x86 Static libraries (.lib) -->
+        <file src="..\..\bin\Win32\Release\v142\static\libzmq.lib" target="build\native\bin\libzmq-x86-v142-mt-s-4_2_3_0.lib" />
+        <file src="..\..\bin\Win32\Debug\v142\static\libzmq.lib" target="build\native\bin\libzmq-x86-v142-mt-sgd-4_2_3_0.lib" />
+
+        <!-- x86 Static link time code generation libraries (.ltcg.lib) -->
+        <file src="..\..\bin\Win32\Release\v142\ltcg\libzmq.lib" target="build\native\bin\libzmq-x86-v142-mt-s-4_2_3_0.ltcg.lib" />
+        <file src="..\..\bin\Win32\Debug\v142\ltcg\libzmq.lib" target="build\native\bin\libzmq-x86-v142-mt-sgd-4_2_3_0.ltcg.lib" />
+
+        <!-- x64 Dynamic libraries (.dll) -->
+        <file src="..\..\bin\x64\Release\v142\dynamic\libzmq.dll" target="build\native\bin\libzmq-x64-v142-mt-4_2_3_0.dll" />
+        <file src="..\..\bin\x64\Debug\v142\dynamic\libzmq.dll" target="build\native\bin\libzmq-x64-v142-mt-gd-4_2_3_0.dll" />
+
+        <!-- x64 Debugging symbols (.pdb) -->
+        <!--<file src="..\..\bin\x64\Release\v142\dynamic\libzmq.pdb" target="build\native\bin\libzmq-x64-v142-mt-4_2_3_0.pdb" />-->
+        <file src="..\..\bin\x64\Debug\v142\dynamic\libzmq.pdb" target="build\native\bin\libzmq-x64-v142-mt-gd-4_2_3_0.pdb" />
+
+        <!-- x64 Import libraries (.imp.lib) -->
+        <file src="..\..\bin\x64\Release\v142\dynamic\libzmq.lib" target="build\native\bin\libzmq-x64-v142-mt-4_2_3_0.imp.lib" />
+        <file src="..\..\bin\x64\Debug\v142\dynamic\libzmq.lib" target="build\native\bin\libzmq-x64-v142-mt-gd-4_2_3_0.imp.lib" />
+
+        <!-- x64 Export libraries (.exp) -->
+        <file src="..\..\bin\x64\Release\v142\dynamic\libzmq.exp" target="build\native\bin\libzmq-x64-v142-mt-4_2_3_0.exp" />
+        <file src="..\..\bin\x64\Debug\v142\dynamic\libzmq.exp" target="build\native\bin\libzmq-x64-v142-mt-gd-4_2_3_0.exp" />
+
+        <!-- x64 Static libraries (.lib) -->
+        <file src="..\..\bin\x64\Release\v142\static\libzmq.lib" target="build\native\bin\libzmq-x64-v142-mt-s-4_2_3_0.lib" />
+        <file src="..\..\bin\x64\Debug\v142\static\libzmq.lib" target="build\native\bin\libzmq-x64-v142-mt-sgd-4_2_3_0.lib" />
+
+        <!-- x64 Static link time code generation libraries (.ltcg.lib) -->
+        <file src="..\..\bin\Win32\Release\v142\ltcg\libzmq.lib" target="build\native\bin\libzmq-x64-v142-mt-s-4_2_3_0.ltcg.lib" />
+        <file src="..\..\bin\Win32\Debug\v142\ltcg\libzmq.lib" target="build\native\bin\libzmq-x64-v142-mt-sgd-4_2_3_0.ltcg.lib" />
+    </files>
+<!--
+#################################################################
+#   GENERATED SOURCE CODE, DO NOT EDIT EXCEPT EXPERIMENTALLY    #
+#################################################################
+-->
+</package>
diff -pruN 4.3.2-2/packaging/nuget/package.targets 4.3.3-1/packaging/nuget/package.targets
--- 4.3.2-2/packaging/nuget/package.targets	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/packaging/nuget/package.targets	2020-09-07 10:12:14.000000000 +0000
@@ -1,129 +1,129 @@
-<?xml version="1.0" encoding="utf-8"?>
-<!--
-#################################################################
-#   GENERATED SOURCE CODE, DO NOT EDIT EXCEPT EXPERIMENTALLY    #
-#################################################################
--->
-<Project ToolsVersion="4.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
-
-  <!-- user interface -->
-  <ItemGroup>
-    <PropertyPageSchema Include="$(MSBuildThisFileDirectory)package.xml" />
-  </ItemGroup>
-
-  <!-- general -->
-  <ItemDefinitionGroup>
-    <ClCompile>
-      <!-- ZMQ_USE_TWEETNACL defined in packaged builds and must be defined for package consumer. -->
-      <PreprocessorDefinitions>ZMQ_USE_TWEETNACL;%(PreprocessorDefinitions)</PreprocessorDefinitions>
-      <AdditionalIncludeDirectories>$(MSBuildThisFileDirectory)include\;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-    </ClCompile>
-    <Link>
-      <AdditionalLibraryDirectories>$(MSBuildThisFileDirectory)bin\;%(AdditionalLibraryDirectories)</AdditionalLibraryDirectories>
-    </Link>
-  </ItemDefinitionGroup>
-  <ItemDefinitionGroup Condition="'$(Linkage-libzmq)' == 'static' Or '$(Linkage-libzmq)' == 'ltcg'">
-    <ClCompile>
-      <PreprocessorDefinitions>ZMQ_STATIC;%(PreprocessorDefinitions)</PreprocessorDefinitions>
-    </ClCompile>
-  </ItemDefinitionGroup>
-
-  <!-- static libraries -->
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'static' And $(Configuration.IndexOf('Release')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x86-v120-mt-s-4_2_3_0.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'static' And $(Configuration.IndexOf('Debug')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x86-v120-mt-sgd-4_2_3_0.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'static' And $(Configuration.IndexOf('Release')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x64-v120-mt-s-4_2_3_0.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'static' And $(Configuration.IndexOf('Debug')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x64-v120-mt-sgd-4_2_3_0.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-
-  <!-- static ltcg libraries -->
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'ltcg' And $(Configuration.IndexOf('Release')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x86-v120-mt-s-4_2_3_0.ltcg.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'ltcg' And $(Configuration.IndexOf('Debug')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x86-v120-mt-sgd-4_2_3_0.ltcg.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'ltcg' And $(Configuration.IndexOf('Release')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x64-v120-mt-s-4_2_3_0.ltcg.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'ltcg' And $(Configuration.IndexOf('Debug')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x64-v120-mt-sgd-4_2_3_0.ltcg.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-  
-  <!-- dynamic import libraries -->
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Release')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x86-v120-mt-4_2_3_0.imp.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Debug')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x86-v120-mt-gd-4_2_3_0.imp.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Release')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x64-v120-mt-4_2_3_0.imp.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Debug')) != -1">
-    <Link>
-      <AdditionalDependencies>libzmq-x64-v120-mt-gd-4_2_3_0.imp.lib;%(AdditionalDependencies)</AdditionalDependencies>
-    </Link>
-  </ItemDefinitionGroup>
-
-  <!-- dynamic libraries with debug symbols -->
-  <Target Name="libzmq_AfterBuild" AfterTargets="AfterBuild" />
-  <Target Name="libzmq_AfterBuild_Win32_v120_Dynamic_Release"
-          Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Release')) != -1"
-          AfterTargets="libzmq_AfterBuild">
-    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x86-v120-mt-4_2_3_0.dll" DestinationFiles="$(TargetDir)libzmq.dll" SkipUnchangedFiles="true" />
-    <!--<Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x86-v120-mt-4_2_3_0.pdb" DestinationFiles="$(TargetDir)libzmq.pdb" SkipUnchangedFiles="true" />-->
-  </Target>
-  <Target Name="libzmq_AfterBuild_Win32_v120_Dynamic_Debug"
-          Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Debug')) != -1"
-          AfterTargets="libzmq_AfterBuild">
-    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x86-v120-mt-gd-4_2_3_0.dll" DestinationFiles="$(TargetDir)libzmq.dll" SkipUnchangedFiles="true" />
-    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x86-v120-mt-gd-4_2_3_0.pdb" DestinationFiles="$(TargetDir)libzmq.pdb" SkipUnchangedFiles="true" />
-  </Target>
-  <Target Name="libzmq_AfterBuild_x64_v120_Dynamic_Release"
-          Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Release')) != -1"
-          AfterTargets="libzmq_AfterBuild">
-    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x64-v120-mt-4_2_3_0.dll" DestinationFiles="$(TargetDir)libzmq.dll" SkipUnchangedFiles="true" />
-    <!--<Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x64-v120-mt-4_2_3_0.pdb" DestinationFiles="$(TargetDir)libzmq.pdb" SkipUnchangedFiles="true" />-->
-  </Target>
-  <Target Name="libzmq_AfterBuild_x64_v120_Dynamic_Debug"
-          Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v120' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Debug')) != -1"
-          AfterTargets="libzmq_AfterBuild">
-    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x64-v120-mt-gd-4_2_3_0.dll" DestinationFiles="$(TargetDir)libzmq.dll" SkipUnchangedFiles="true" />
-    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x64-v120-mt-gd-4_2_3_0.pdb" DestinationFiles="$(TargetDir)libzmq.pdb" SkipUnchangedFiles="true" />
-  </Target>
-
-<!--
-#################################################################
-#   GENERATED SOURCE CODE, DO NOT EDIT EXCEPT EXPERIMENTALLY    #
-#################################################################
--->
-</Project>
+<?xml version="1.0" encoding="utf-8"?>
+<!--
+#################################################################
+#   GENERATED SOURCE CODE, DO NOT EDIT EXCEPT EXPERIMENTALLY    #
+#################################################################
+-->
+<Project ToolsVersion="4.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+
+  <!-- user interface -->
+  <ItemGroup>
+    <PropertyPageSchema Include="$(MSBuildThisFileDirectory)package.xml" />
+  </ItemGroup>
+
+  <!-- general -->
+  <ItemDefinitionGroup>
+    <ClCompile>
+      <!-- ZMQ_USE_TWEETNACL defined in packaged builds and must be defined for package consumer. -->
+      <PreprocessorDefinitions>ZMQ_USE_TWEETNACL;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <AdditionalIncludeDirectories>$(MSBuildThisFileDirectory)include\;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
+    </ClCompile>
+    <Link>
+      <AdditionalLibraryDirectories>$(MSBuildThisFileDirectory)bin\;%(AdditionalLibraryDirectories)</AdditionalLibraryDirectories>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Linkage-libzmq)' == 'static' Or '$(Linkage-libzmq)' == 'ltcg'">
+    <ClCompile>
+      <PreprocessorDefinitions>ZMQ_STATIC;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+    </ClCompile>
+  </ItemDefinitionGroup>
+
+  <!-- static libraries -->
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'static' And $(Configuration.IndexOf('Release')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x86-v142-mt-s-4_2_3_0.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'static' And $(Configuration.IndexOf('Debug')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x86-v142-mt-sgd-4_2_3_0.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'static' And $(Configuration.IndexOf('Release')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x64-v142-mt-s-4_2_3_0.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'static' And $(Configuration.IndexOf('Debug')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x64-v142-mt-sgd-4_2_3_0.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+
+  <!-- static ltcg libraries -->
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'ltcg' And $(Configuration.IndexOf('Release')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x86-v142-mt-s-4_2_3_0.ltcg.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'ltcg' And $(Configuration.IndexOf('Debug')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x86-v142-mt-sgd-4_2_3_0.ltcg.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'ltcg' And $(Configuration.IndexOf('Release')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x64-v142-mt-s-4_2_3_0.ltcg.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'ltcg' And $(Configuration.IndexOf('Debug')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x64-v142-mt-sgd-4_2_3_0.ltcg.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+
+  <!-- dynamic import libraries -->
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Release')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x86-v142-mt-4_2_3_0.imp.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Debug')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x86-v142-mt-gd-4_2_3_0.imp.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Release')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x64-v142-mt-4_2_3_0.imp.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Debug')) != -1">
+    <Link>
+      <AdditionalDependencies>libzmq-x64-v142-mt-gd-4_2_3_0.imp.lib;%(AdditionalDependencies)</AdditionalDependencies>
+    </Link>
+  </ItemDefinitionGroup>
+
+  <!-- dynamic libraries with debug symbols -->
+  <Target Name="libzmq_AfterBuild" AfterTargets="AfterBuild" />
+  <Target Name="libzmq_AfterBuild_Win32_v142_Dynamic_Release"
+          Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Release')) != -1"
+          AfterTargets="libzmq_AfterBuild">
+    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x86-v142-mt-4_2_3_0.dll" DestinationFiles="$(TargetDir)libzmq.dll" SkipUnchangedFiles="true" />
+    <!--<Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x86-v142-mt-4_2_3_0.pdb" DestinationFiles="$(TargetDir)libzmq.pdb" SkipUnchangedFiles="true" />-->
+  </Target>
+  <Target Name="libzmq_AfterBuild_Win32_v142_Dynamic_Debug"
+          Condition="'$(Platform)' == 'Win32' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Debug')) != -1"
+          AfterTargets="libzmq_AfterBuild">
+    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x86-v142-mt-gd-4_2_3_0.dll" DestinationFiles="$(TargetDir)libzmq.dll" SkipUnchangedFiles="true" />
+    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x86-v142-mt-gd-4_2_3_0.pdb" DestinationFiles="$(TargetDir)libzmq.pdb" SkipUnchangedFiles="true" />
+  </Target>
+  <Target Name="libzmq_AfterBuild_x64_v142_Dynamic_Release"
+          Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Release')) != -1"
+          AfterTargets="libzmq_AfterBuild">
+    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x64-v142-mt-4_2_3_0.dll" DestinationFiles="$(TargetDir)libzmq.dll" SkipUnchangedFiles="true" />
+    <!--<Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x64-v142-mt-4_2_3_0.pdb" DestinationFiles="$(TargetDir)libzmq.pdb" SkipUnchangedFiles="true" />-->
+  </Target>
+  <Target Name="libzmq_AfterBuild_x64_v142_Dynamic_Debug"
+          Condition="'$(Platform)' == 'x64' And ('$(PlatformToolset)' == 'v142' Or '$(PlatformToolset)' == 'CTP_Nov2013') And '$(Linkage-libzmq)' == 'dynamic' And $(Configuration.IndexOf('Debug')) != -1"
+          AfterTargets="libzmq_AfterBuild">
+    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x64-v142-mt-gd-4_2_3_0.dll" DestinationFiles="$(TargetDir)libzmq.dll" SkipUnchangedFiles="true" />
+    <Copy SourceFiles="$(MSBuildThisFileDirectory)bin\libzmq-x64-v142-mt-gd-4_2_3_0.pdb" DestinationFiles="$(TargetDir)libzmq.pdb" SkipUnchangedFiles="true" />
+  </Target>
+
+<!--
+#################################################################
+#   GENERATED SOURCE CODE, DO NOT EDIT EXCEPT EXPERIMENTALLY    #
+#################################################################
+-->
+</Project>
diff -pruN 4.3.2-2/packaging/nuget/package.xml 4.3.3-1/packaging/nuget/package.xml
--- 4.3.2-2/packaging/nuget/package.xml	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/packaging/nuget/package.xml	2020-09-07 10:12:14.000000000 +0000
@@ -1,22 +1,22 @@
-<?xml version="1.0" encoding="utf-8"?>
-<!--
-#################################################################
-#   GENERATED SOURCE CODE, DO NOT EDIT EXCEPT EXPERIMENTALLY    #
-#################################################################
--->
-<ProjectSchemaDefinitions xmlns="clr-namespace:Microsoft.Build.Framework.XamlTypes;assembly=Microsoft.Build.Framework">
-  <Rule Name="Linkage-libzmq-uiextension" PageTemplate="tool" DisplayName="NuGet Dependencies" SwitchPrefix="/" Order="1">
-    <Rule.Categories>
-      <Category Name="libzmq" DisplayName="libzmq" />
-    </Rule.Categories>
-    <Rule.DataSource>
-      <DataSource Persistence="ProjectFile" ItemType="" />
-    </Rule.DataSource>
-    <EnumProperty Name="Linkage-libzmq" DisplayName="Linkage" Description="How NuGet libzmq will be linked into the output of this project" Category="libzmq">
-      <EnumValue Name="" DisplayName="Not linked" />
-      <EnumValue Name="dynamic" DisplayName="Dynamic (DLL)" />
-      <EnumValue Name="static" DisplayName="Static (LIB)" />
-      <EnumValue Name="ltcg" DisplayName="Static using link time compile generation (LTCG)" />
-    </EnumProperty>
-  </Rule>
+<?xml version="1.0" encoding="utf-8"?>
+<!--
+#################################################################
+#   GENERATED SOURCE CODE, DO NOT EDIT EXCEPT EXPERIMENTALLY    #
+#################################################################
+-->
+<ProjectSchemaDefinitions xmlns="clr-namespace:Microsoft.Build.Framework.XamlTypes;assembly=Microsoft.Build.Framework">
+  <Rule Name="Linkage-libzmq-uiextension" PageTemplate="tool" DisplayName="NuGet Dependencies" SwitchPrefix="/" Order="1">
+    <Rule.Categories>
+      <Category Name="libzmq" DisplayName="libzmq" />
+    </Rule.Categories>
+    <Rule.DataSource>
+      <DataSource Persistence="ProjectFile" ItemType="" />
+    </Rule.DataSource>
+    <EnumProperty Name="Linkage-libzmq" DisplayName="Linkage" Description="How NuGet libzmq will be linked into the output of this project" Category="libzmq">
+      <EnumValue Name="" DisplayName="Not linked" />
+      <EnumValue Name="dynamic" DisplayName="Dynamic (DLL)" />
+      <EnumValue Name="static" DisplayName="Static (LIB)" />
+      <EnumValue Name="ltcg" DisplayName="Static using link time compile generation (LTCG)" />
+    </EnumProperty>
+  </Rule>
 </ProjectSchemaDefinitions>
\ No newline at end of file
diff -pruN 4.3.2-2/packaging/obs/_service 4.3.3-1/packaging/obs/_service
--- 4.3.2-2/packaging/obs/_service	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/packaging/obs/_service	2020-09-07 10:12:14.000000000 +0000
@@ -2,6 +2,7 @@
   <service name="tar_scm">
     <param name="url">https://github.com/zeromq/libzmq</param>
     <param name="scm">git</param>
+    <param name="revision">@PARENT_TAG@</param>
     <param name="versionformat">@PARENT_TAG@+git%cd</param>
     <param name="versionrewrite-pattern">v(.*)</param>
     <param name="versionrewrite-replacement">\1</param>
diff -pruN 4.3.2-2/packaging/redhat/zeromq.spec 4.3.3-1/packaging/redhat/zeromq.spec
--- 4.3.2-2/packaging/redhat/zeromq.spec	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/packaging/redhat/zeromq.spec	2020-09-07 10:12:14.000000000 +0000
@@ -10,7 +10,7 @@
 %endif
 %define lib_name libzmq5
 Name:          zeromq
-Version:       4.3.2
+Version:       4.3.3
 Release:       1%{?dist}
 Summary:       The ZeroMQ messaging library
 Group:         Applications/Internet
@@ -19,7 +19,7 @@ URL:           http://www.zeromq.org/
 Source:        http://download.zeromq.org/%{name}-%{version}.tar.gz
 Prefix:        %{_prefix}
 Buildroot:     %{_tmppath}/%{name}-%{version}-%{release}-root
-BuildRequires:  autoconf automake libtool libsodium-devel glib2-devel
+BuildRequires:  autoconf automake libtool glib2-devel libbsd-devel
 %if ! (0%{?fedora} > 12 || 0%{?rhel} > 5)
 BuildRequires:  e2fsprogs-devel
 BuildRoot:      %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
@@ -45,6 +45,28 @@ BuildRequires:  libsodium-devel
 %else
 %define SODIUM no
 %endif
+%bcond_with nss
+%if %{with nss}
+%if 0%{?suse_version}
+BuildRequires:  mozilla-nss-devel
+%else
+BuildRequires:  nss-devel
+%endif
+%define NSS yes
+%else
+%define NSS no
+%endif
+%bcond_with tls
+%if %{with tls} && ! 0%{?centos_version} < 700
+%if 0%{?suse_version}
+BuildRequires:  libgnutls-devel
+%else
+BuildRequires:  gnutls-devel
+%endif
+%define TLS yes
+%else
+%define TLS no
+%endif
 BuildRequires: gcc, make, gcc-c++, libstdc++-devel, asciidoc, xmlto
 Requires:      libstdc++
 
@@ -60,6 +82,7 @@ Requires:      libstdc++
 %{!?_with_libgssapi_krb5: %{!?_without_libgssapi_krb5: %define _without_libgssapi_krb5 --without-liblibgssapi_krb5}}
 %{!?_with_libsodium: %{!?_without_libsodium: %define _without_libsodium --without-libsodium}}
 %{!?_with_pgm: %{!?_without_pgm: %define _without_pgm --without-pgm}}
+%{!?_with_nss: %{!?_without_nss: %define _without_nss --without-nss}}
 
 # It's an error if both --with and --without options are specified
 %{?_with_libgssapi_krb5: %{?_without_libgssapi_krb5: %{error: both _with_libgssapi_krb5 and _without_libgssapi_krb5}}}
@@ -75,6 +98,23 @@ Requires:      libstdc++
 %{?_with_pgm:BuildRequires: openpgm-devel}
 %{?_with_pgm:Requires: openpgm}
 
+%if 0%{?suse_version}
+%{?_with_nss:BuildRequires: mozilla-nss-devel}
+%{?_with_nss:Requires: mozilla-nss}
+%else
+%{?_with_nss:BuildRequires: nss-devel}
+%{?_with_nss:Requires: nss}
+%endif
+
+%if ! 0%{?centos_version} < 700
+%if 0%{?suse_version}
+%{?_with_tls:BuildRequires: libgnutls-devel}
+%else
+%{?_with_tls:BuildRequires: gnutls-devel}
+%endif
+%{?_with_tls:Requires: gnutls}
+%endif
+
 %ifarch pentium3 pentium4 athlon i386 i486 i586 i686 x86_64
 %{!?_with_pic: %{!?_without_pic: %define _with_pic --with-pic}}
 %{!?_with_gnu_ld: %{!?_without_gnu_ld: %define _with_gnu_ld --with-gnu_ld}}
@@ -110,7 +150,6 @@ This package contains the ZeroMQ shared
 Summary:  Development files and static library for the ZeroMQ library
 Group:    Development/Libraries
 Requires: %{lib_name} = %{version}-%{release}, pkgconfig
-Requires: libsodium-devel
 %bcond_with pgm
 %if %{with pgm}
 Requires:  openpgm-devel
@@ -123,6 +162,22 @@ Requires:  krb5-devel
 %if %{with libsodium}
 Requires:  libsodium-devel
 %endif
+%bcond_with nss
+%if %{with nss}
+%if 0%{?suse_version}
+Requires:  mozilla-nss-devel
+%else
+Requires:  nss-devel
+%endif
+%endif
+%bcond_with tls
+%if %{with tls} && ! 0%{?centos_version} < 700
+%if 0%{?suse_version}
+Requires:  libgnutls-devel
+%else
+Requires:  gnutls-devel
+%endif
+%endif
 
 %description devel
 The 0MQ lightweight messaging kernel is a library which extends the
@@ -164,6 +219,8 @@ autoreconf -fi
     --with-pgm=%{PGM} \
     --with-libsodium=%{SODIUM} \
     --with-libgssapi_krb5=%{GSSAPI} \
+    --with-nss=%{NSS} \
+    --with-tls=%{TLS} \
     %{?_with_pic} \
     %{?_without_pic} \
     %{?_with_gnu_ld} \
@@ -175,7 +232,7 @@ autoreconf -fi
 [ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}
 
 # Install the package to build area
-%{__make} check
+%{__make} check VERBOSE=1
 %makeinstall
 
 %post
@@ -216,6 +273,12 @@ autoreconf -fi
 %{_bindir}/curve_keygen
 
 %changelog
+* Fri Oct 4 2019 Luca Boccassi <luca.boccassi@gmail.com>
+- Add macro for optional TLS dependency
+
+* Wed Sep 11 2019 Luca Boccassi <luca.boccassi@gmail.com>
+- Add macro for optional NSS dependency
+
 * Sat Aug 19 2017 Luca Boccassi <luca.boccassi@gmail.com>
 - Fix parsing and usage of conditionals for sodium/pgm/krb5 so that they work
   in OBS
diff -pruN 4.3.2-2/perf/benchmark_radix_tree.cpp 4.3.3-1/perf/benchmark_radix_tree.cpp
--- 4.3.2-2/perf/benchmark_radix_tree.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/perf/benchmark_radix_tree.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -49,11 +49,10 @@ const int chars_len = 36;
 
 template <class T>
 void benchmark_lookup (T &subscriptions_,
-                       std::vector<unsigned char *> &input_set_,
                        std::vector<unsigned char *> &queries_)
 {
     using namespace std::chrono;
-    std::vector<duration<long, std::nano>> samples_vec;
+    std::vector<duration<long, std::nano> > samples_vec;
     samples_vec.reserve (samples);
 
     for (std::size_t run = 0; run < warmup_runs; ++run) {
@@ -114,10 +113,10 @@ int main ()
                  static_cast<unsigned long long> (nqueries),
                  static_cast<unsigned long long> (key_length));
     std::puts ("[trie]");
-    benchmark_lookup (trie, input_set, queries);
+    benchmark_lookup (trie, queries);
 
     std::puts ("[radix_tree]");
-    benchmark_lookup (radix_tree, input_set, queries);
+    benchmark_lookup (radix_tree, queries);
 
     for (auto &op : input_set)
         delete[] op;
diff -pruN 4.3.2-2/perf/generate_csv.sh 4.3.3-1/perf/generate_csv.sh
--- 4.3.2-2/perf/generate_csv.sh	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/perf/generate_csv.sh	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,147 @@
+#!/bin/bash
+
+#
+# This script assumes that 2 machines are used to generate performance results.
+# First machine is assumed to be the one where this script runs.
+# Second machine is the "REMOTE_IP_SSH" machine; we assume to have passwordless SSH access.
+#
+# Usage example:
+#    export REMOTE_IP_SSH=10.0.0.1
+#    export LOCAL_TEST_ENDPOINT="tcp://192.168.1.1:1234"
+#    export REMOTE_TEST_ENDPOINT="tcp://192.168.1.2:1234"
+#    export REMOTE_LIBZMQ_PATH="/home/fmontorsi/libzmq/perf"
+#    ./generate_csv.sh
+#
+
+set -u
+
+# configurable values (via environment variables):
+REMOTE_IP_SSH=${REMOTE_IP_SSH:-127.0.0.1}
+REMOTE_LIBZMQ_PATH=${REMOTE_LIBZMQ_PATH:-/root/libzmq/perf}
+LOCAL_TEST_ENDPOINT=${LOCAL_TEST_ENDPOINT:-tcp://192.168.1.1:1234}
+REMOTE_TEST_ENDPOINT=${REMOTE_TEST_ENDPOINT:-tcp://192.168.1.2:1234}
+
+# constant values:
+MESSAGE_SIZE_LIST="8 16 32 64 128 256 512 1024 2048 4096 8192 16384 32768 65536 131072"
+OUTPUT_DIR="results"
+OUTPUT_FILE_PREFIX="results.txt"
+OUTPUT_FILE_CSV_PREFIX="results.csv"
+
+
+# utility functions:
+
+function verify_ssh()
+{
+    ssh $REMOTE_IP_SSH "ls /" >/dev/null
+    if [ $? -ne 0 ]; then
+        echo "Cannot connect via SSH passwordless to the REMOTE_IP_SSH $REMOTE_IP_SSH. Please fix the problem and retry."
+        exit 2
+    fi
+
+    ssh $REMOTE_IP_SSH "ls $REMOTE_LIBZMQ_PATH" >/dev/null
+    if [ $? -ne 0 ]; then
+        echo "The folder $REMOTE_LIBZMQ_PATH is not valid. Please fix the problem and retry."
+        exit 2
+    fi
+
+    echo "SSH connection to the remote $REMOTE_IP_SSH is working fine."
+}
+
+function run_remote_perf_util()
+{
+    local MESSAGE_SIZE_BYTES="$1"
+    local REMOTE_PERF_UTIL="$2"
+    local NUM_MESSAGES="$3"
+
+    echo "Launching on $REMOTE_IP_SSH the utility [$REMOTE_PERF_UTIL] for messages ${MESSAGE_SIZE_BYTES}B long"
+    ssh $REMOTE_IP_SSH "$REMOTE_LIBZMQ_PATH/$REMOTE_PERF_UTIL $TEST_ENDPOINT $MESSAGE_SIZE_BYTES $NUM_MESSAGES" &
+    if [ $? -ne 0 ]; then
+        echo "Failed to launch remote perf util."
+        exit 2
+    fi
+}
+
+function generate_output_file()
+{
+    local LOCAL_PERF_UTIL="$1"     # must be the utility generating the TXT output
+    local REMOTE_PERF_UTIL="$2"
+    local OUTPUT_FILE_PREFIX="$3"
+    local NUM_MESSAGES="$4"
+    local CSV_HEADER_LINE="$5"
+
+    # derived values:
+    local OUTPUT_FILE_TXT="${OUTPUT_DIR}/${OUTPUT_FILE_PREFIX}.txt"         # useful just for human-friendly debugging
+    local OUTPUT_FILE_CSV="${OUTPUT_DIR}/${OUTPUT_FILE_PREFIX}.csv"     # actually used to later produce graphs
+    local MESSAGE_SIZE_ARRAY=($MESSAGE_SIZE_LIST)
+
+    echo "Killing still-running ZMQ performance utils, if any"
+    pkill $LOCAL_PERF_UTIL                       # in case it's running from a previous test
+    if [ ! -z "$REMOTE_PERF_UTIL" ]; then
+        ssh $REMOTE_IP_SSH "pkill $REMOTE_PERF_UTIL"     # in case it's running from a previous test
+    fi
+
+    echo "Resetting output file $OUTPUT_FILE_TXT and $OUTPUT_FILE_CSV"
+    mkdir -p ${OUTPUT_DIR}
+    > $OUTPUT_FILE_TXT
+    echo "$CSV_HEADER_LINE" > $OUTPUT_FILE_CSV
+
+    for MESSAGE_SIZE in ${MESSAGE_SIZE_ARRAY[@]}; do
+        echo "Launching locally the utility [$LOCAL_PERF_UTIL] for messages ${MESSAGE_SIZE}B long"
+        ./$LOCAL_PERF_UTIL $TEST_ENDPOINT $MESSAGE_SIZE $NUM_MESSAGES >${OUTPUT_FILE_TXT}-${MESSAGE_SIZE} &
+
+        if [ ! -z "$REMOTE_PERF_UTIL" ]; then
+            run_remote_perf_util $MESSAGE_SIZE $REMOTE_PERF_UTIL $NUM_MESSAGES
+        fi
+        wait
+
+        # produce the complete human-readable output file:
+        cat ${OUTPUT_FILE_TXT}-${MESSAGE_SIZE} >>${OUTPUT_FILE_TXT}
+
+        # produce a machine-friendly file for later plotting:
+        local DATALINE="$(cat ${OUTPUT_FILE_TXT}-${MESSAGE_SIZE} | grep -o '[0-9.]*' | tr '\n' ',')"
+        echo ${DATALINE::-1} >>$OUTPUT_FILE_CSV
+        rm -f ${OUTPUT_FILE_TXT}-${MESSAGE_SIZE}
+    done
+
+    echo "All measurements completed and saved into $OUTPUT_FILE_TXT and $OUTPUT_FILE_CSV"
+}
+
+
+
+# main:
+
+verify_ssh
+
+THROUGHPUT_CSV_HEADER_LINE="# message_size,message_count,PPS[msg/s],throughput[Mb/s]"
+
+# PUSH/PULL TCP throughput CSV file:
+TEST_ENDPOINT="$LOCAL_TEST_ENDPOINT"
+generate_output_file "local_thr" "remote_thr" \
+    "pushpull_tcp_thr_results" \
+    "1000000" \
+    "$THROUGHPUT_CSV_HEADER_LINE"
+
+# PUSH/PULL INPROC throughput CSV file:
+# NOTE: in this case there is no remote utility to run and no ENDPOINT to provide:
+TEST_ENDPOINT=""  # inproc does not require any endpoint
+generate_output_file "inproc_thr" "" \
+    "pushpull_inproc_thr_results" \
+    "10000000" \
+    "$THROUGHPUT_CSV_HEADER_LINE"
+
+# PUB/SUB proxy INPROC throughput CSV file:
+# NOTE: in this case there is no remote utility to run and no ENDPOINT to provide:
+TEST_ENDPOINT="" # inproc does	not require any	endpoint
+generate_output_file "proxy_thr" "" \
+    "pubsubproxy_inproc_thr_results" \
+    "10000000" \
+    "$THROUGHPUT_CSV_HEADER_LINE"
+
+
+# REQ/REP TCP latency CSV file:
+# NOTE: in this case it's the remote_lat utility that prints out the data, so we swap the local/remote arguments to the bash func:
+TEST_ENDPOINT="$REMOTE_TEST_ENDPOINT"
+generate_output_file "remote_lat" "local_lat" \
+    "reqrep_tcp_lat_results" \
+    "10000" \
+    "# message_size,message_count,latency[us]"
diff -pruN 4.3.2-2/perf/generate_graphs.py 4.3.3-1/perf/generate_graphs.py
--- 4.3.2-2/perf/generate_graphs.py	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/perf/generate_graphs.py	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,73 @@
+#!/usr/bin/python3
+
+#
+# This script assumes that the set of CSV files produced by "generate_csv.sh" is provided as input
+# and that locally there is the "results" folder.
+#
+
+# results for TCP:
+INPUT_FILE_PUSHPULL_TCP_THROUGHPUT="results/pushpull_tcp_thr_results.csv"
+INPUT_FILE_REQREP_TCP_LATENCY="results/reqrep_tcp_lat_results.csv"
+TCP_LINK_GPBS=100
+
+# results for INPROC:
+INPUT_FILE_PUSHPULL_INPROC_THROUGHPUT="results/pushpull_inproc_thr_results.csv"
+INPUT_FILE_PUBSUBPROXY_INPROC_THROUGHPUT="results/pubsubproxy_inproc_thr_results.csv"
+
+
+# dependencies
+#
+# pip3 install matplotlib
+#
+
+import matplotlib.pyplot as plt
+import numpy as np
+
+
+# functions
+
+def plot_throughput(csv_filename, title, is_tcp=False):
+    message_size_bytes, message_count, pps, mbps = np.loadtxt(csv_filename, delimiter=',', unpack=True)
+
+    fig, ax1 = plt.subplots()
+
+    # PPS axis
+    color = 'tab:red'
+    ax1.set_xlabel('Message size [B]')
+    ax1.set_ylabel('PPS [Mmsg/s]', color=color)
+    ax1.semilogx(message_size_bytes, pps / 1e6, label='PPS [Mmsg/s]', marker='x', color=color)
+    ax1.tick_params(axis='y', labelcolor=color)
+
+    # GBPS axis
+    color = 'tab:blue'
+    ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis
+    ax2.set_ylabel('Throughput [Gb/s]', color=color)
+    ax2.semilogx(message_size_bytes, mbps / 1e3, label='Throughput [Gb/s]', marker='o')
+    if is_tcp:
+        ax2.set_yticks(np.arange(0, TCP_LINK_GPBS + 1, TCP_LINK_GPBS/10)) 
+    ax2.tick_params(axis='y', labelcolor=color)
+    ax2.grid(True)
+    
+    plt.title(title)
+    fig.tight_layout()  # otherwise the right y-label is slightly clippe
+    plt.savefig(csv_filename.replace('.csv', '.png'))
+    plt.show()
+
+def plot_latency(csv_filename, title):
+    message_size_bytes, message_count, lat = np.loadtxt(csv_filename, delimiter=',', unpack=True)
+    plt.semilogx(message_size_bytes, lat, label='Latency [us]', marker='o')
+    
+    plt.xlabel('Message size [B]')
+    plt.ylabel('Latency [us]')
+    plt.grid(True)
+    plt.title(title)
+    plt.savefig(csv_filename.replace('.csv', '.png'))
+    plt.show()
+
+
+# main
+
+plot_throughput(INPUT_FILE_PUSHPULL_TCP_THROUGHPUT, 'ZeroMQ PUSH/PULL socket throughput, TCP transport', is_tcp=True)
+plot_throughput(INPUT_FILE_PUSHPULL_INPROC_THROUGHPUT, 'ZeroMQ PUSH/PULL socket throughput, INPROC transport')
+plot_throughput(INPUT_FILE_PUBSUBPROXY_INPROC_THROUGHPUT, 'ZeroMQ PUB/SUB PROXY socket throughput, INPROC transport')
+plot_latency(INPUT_FILE_REQREP_TCP_LATENCY, 'ZeroMQ REQ/REP socket latency, TCP transport')
diff -pruN 4.3.2-2/perf/proxy_thr.cpp 4.3.3-1/perf/proxy_thr.cpp
--- 4.3.2-2/perf/proxy_thr.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/perf/proxy_thr.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -74,6 +74,17 @@
 #define TEST_ASSERT_SUCCESS_ERRNO(expr)                                        \
     test_assert_success_message_errno_helper (expr, NULL, #expr)
 
+// This macro is used to avoid-variable warning. If used with an expression,
+// the sizeof is not evaluated to avoid polluting the assembly code.
+#ifdef NDEBUG
+#define ASSERT_EXPR_SAFE(x)                                                    \
+    do {                                                                       \
+        (void) sizeof (x);                                                     \
+    } while (0)
+#else
+#define ASSERT_EXPR_SAFE(x) assert (x)
+#endif
+
 
 static uint64_t message_count = 0;
 static size_t message_size = 0;
@@ -176,7 +187,7 @@ static void publisher_thread_main (void
     }
 
     zmq_close (pubsocket);
-    printf ("publisher thread ended\n");
+    //printf ("publisher thread ended\n");
 }
 
 static void subscriber_thread_main (void *pvoid)
@@ -215,7 +226,7 @@ static void subscriber_thread_main (void
     //  Cleanup
 
     zmq_close (subsocket);
-    printf ("subscriber thread ended\n");
+    //printf ("subscriber thread ended\n");
 }
 
 static void proxy_thread_main (void *pvoid)
@@ -238,7 +249,7 @@ static void proxy_thread_main (void *pvo
         if (ep != NULL) {
             assert (strlen (ep) > 5);
             rc = zmq_bind (frontend_xsub, ep);
-            assert (rc == 0);
+            ASSERT_EXPR_SAFE (rc == 0);
         }
     }
 
@@ -252,7 +263,7 @@ static void proxy_thread_main (void *pvo
     int optval = 1;
     rc =
       zmq_setsockopt (backend_xpub, ZMQ_XPUB_NODROP, &optval, sizeof (optval));
-    assert (rc == 0);
+    ASSERT_EXPR_SAFE (rc == 0);
 
     set_hwm (backend_xpub);
 
@@ -262,7 +273,7 @@ static void proxy_thread_main (void *pvo
         if (ep != NULL) {
             assert (strlen (ep) > 5);
             rc = zmq_bind (backend_xpub, ep);
-            assert (rc == 0);
+            ASSERT_EXPR_SAFE (rc == 0);
         }
     }
 
@@ -275,7 +286,7 @@ static void proxy_thread_main (void *pvo
 
     //  Bind CONTROL
     rc = zmq_bind (control_rep, cfg->control_endpoint);
-    assert (rc == 0);
+    ASSERT_EXPR_SAFE (rc == 0);
 
     //  Start proxying!
 
@@ -284,7 +295,7 @@ static void proxy_thread_main (void *pvo
     zmq_close (frontend_xsub);
     zmq_close (backend_xpub);
     zmq_close (control_rep);
-    printf ("proxy thread ended\n");
+    //printf ("proxy thread ended\n");
 }
 
 void terminate_proxy (const proxy_hwm_cfg_t *cfg)
@@ -298,12 +309,12 @@ void terminate_proxy (const proxy_hwm_cf
 
     //  Connect CONTROL-REQ: a socket to which send commands
     int rc = zmq_connect (control_req, cfg->control_endpoint);
-    assert (rc == 0);
+    ASSERT_EXPR_SAFE (rc == 0);
 
     //  Ask the proxy to exit: the subscriber has received all messages
 
     rc = zmq_send (control_req, "TERMINATE", 9, 0);
-    assert (rc == 9);
+    ASSERT_EXPR_SAFE (rc == 9);
 
     zmq_close (control_req);
 }
@@ -314,7 +325,7 @@ void terminate_proxy (const proxy_hwm_cf
 int main (int argc, char *argv[])
 {
     if (argc != 3) {
-        printf ("usage: inproc_thr <message-size> <message-count>\n");
+        printf ("usage: proxy_thr <message-size> <message-count>\n");
         return 1;
     }
 
@@ -327,7 +338,7 @@ int main (int argc, char *argv[])
     assert (context);
 
     int rv = zmq_ctx_set (context, ZMQ_IO_THREADS, 4);
-    assert (rv == 0);
+    ASSERT_EXPR_SAFE (rv == 0);
 
     //  START ALL SECONDARY THREADS
 
@@ -395,7 +406,7 @@ int main (int argc, char *argv[])
     zmq_threadclose (proxy);
 
     int rc = zmq_ctx_term (context);
-    assert (rc == 0);
+    ASSERT_EXPR_SAFE (rc == 0);
 
     return 0;
 }
diff -pruN 4.3.2-2/README.md 4.3.3-1/README.md
--- 4.3.2-2/README.md	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/README.md	2020-09-07 10:12:14.000000000 +0000
@@ -15,24 +15,28 @@ protocols and more.
 
 ## Supported platforms <a name="#platforms"/>
 
+Libzmq is mainly written in C++98 with some optional C++11-fragments. For
+configuration either autotools or CMake is employed. See below for some lists
+of platforms, where libzmq has been successfully compiled on.
+
 ### Supported platforms with primary CI
 
-OS and version | Architecture | Compiler and version | Build system | Remarks
--------------- | ------------ | -------------------- | ------------ | -------
-Android NDK 11c | ARM | gcc ? | autotools |
-Ubuntu 14.04.5 LTS (trusty) | amd64 | clang 5.0.0 | autotools | STABLE, extras: GSSAPI, PGM, NORM, C++98 mode only
-Ubuntu 14.04.5 LTS (trusty) | amd64 | gcc 4.8.4 | autotools | STABLE, DRAFT, extras: GSSAPI, PGM, NORM, TIPC, IPV6, also POLLER=poll, POLLER=select, also valgrind and address sanitizer executions
-Ubuntu 14.04.5 LTS (trusty) | amd64 | gcc 4.8.4 | CMake 3.12.2 | STABLE
-Windows Server 2012 R2 | x86 | Visual Studio 2008 | CMake 3.12.2 | DRAFT
-Windows Server 2012 R2 | x86 | Visual Studio 2010 SP1 | CMake 3.12.2 | DRAFT
-Windows Server 2012 R2 | x86 | Visual Studio 2012 Update 5 | CMake 3.12.2 | DRAFT
-Windows Server 2012 R2 | x86, amd64 | Visual Studio 2013 Update 5 | CMake 3.12.2 | DRAFT, STABLE (x86 Release only), also POLLER=epoll
-Windows Server 2012 R2 | x86 | Visual Studio 2015 Update 3 | CMake 3.12.2 | DRAFT
-Windows Server 2016 | x86 | Visual Studio 2017 15.9.6 | CMake 3.13.3 | DRAFT
-cygwin 3.0.0 on Windows Server 2012 R2 | amd64 | gcc 7.4.0 | CMake 3.6.2 | DRAFT
-MSYS2 ? on Windows Server 2012 R2 | amd64 | gcc 6.4.0 | CMake ? | DRAFT
-Mac OS X 10.13 | amd64 | Xcode 9.4.1, Apple LLVM 9.1.0 | autotools | STABLE, DRAFT
-Mac OS X 10.13 | amd64 | Xcode 9.4.1, Apple LLVM 9.1.0 | CMake 3.11.4 | DRAFT
+| OS and version                         | Architecture            | Compiler and version          | Build system | Remarks                                                                                                                               |
+|----------------------------------------|-------------------------|-------------------------------|--------------|---------------------------------------------------------------------------------------------------------------------------------------|
+| Android NDK r20                        | arm, arm64, x86, x86_64 | llvm (see NDK)                | autotools    | DRAFT                                                                                                                                       |
+| Ubuntu 14.04.5 LTS (trusty)            | amd64                   | clang 5.0.0                   | autotools    | STABLE, extras: GSSAPI, PGM, NORM, C++98 mode only                                                                                    |
+| Ubuntu 14.04.5 LTS (trusty)            | amd64                   | gcc 4.8.4                     | autotools    | STABLE, DRAFT, extras: GSSAPI, PGM, NORM, TIPC, IPV6, also POLLER=poll, POLLER=select, also valgrind and address sanitizer executions |
+| Ubuntu 14.04.5 LTS (trusty)            | amd64                   | gcc 4.8.4                     | CMake 3.12.2 | STABLE                                                                                                                                |
+| Windows Server 2012 R2                 | x86                     | Visual Studio 2008            | CMake 3.12.2 | DRAFT                                                                                                                                 |
+| Windows Server 2012 R2                 | x86                     | Visual Studio 2010 SP1        | CMake 3.12.2 | DRAFT                                                                                                                                 |
+| Windows Server 2012 R2                 | x86                     | Visual Studio 2012 Update 5   | CMake 3.12.2 | DRAFT                                                                                                                                 |
+| Windows Server 2012 R2                 | x86, amd64              | Visual Studio 2013 Update 5   | CMake 3.12.2 | DRAFT, STABLE (x86 Release only), also POLLER=epoll                                                                                   |
+| Windows Server 2012 R2                 | x86                     | Visual Studio 2015 Update 3   | CMake 3.12.2 | DRAFT                                                                                                                                 |
+| Windows Server 2016                    | x86                     | Visual Studio 2017 15.9.6     | CMake 3.13.3 | DRAFT                                                                                                                                 |
+| cygwin 3.0.0 on Windows Server 2012 R2 | amd64                   | gcc 7.4.0                     | CMake 3.6.2  | DRAFT                                                                                                                                 |
+| MSYS2 ? on Windows Server 2012 R2      | amd64                   | gcc 6.4.0                     | CMake ?      | DRAFT                                                                                                                                 |
+| Mac OS X 10.13                         | amd64                   | Xcode 9.4.1, Apple LLVM 9.1.0 | autotools    | STABLE, DRAFT                                                                                                                         |
+| Mac OS X 10.13                         | amd64                   | Xcode 9.4.1, Apple LLVM 9.1.0 | CMake 3.11.4 | DRAFT                                                                                                                                 |
 
 Note: the platforms are regularly updated by the service providers, so this information might get out of date
 without any changes on the side of libzmq. For Appveyor, refer to https://www.appveyor.com/updates/ regarding
@@ -40,66 +44,70 @@ platform updates. For travis-ci, refer t
 
 ### Supported platforms with secondary CI
 
-OS and version | Architecture | Compiler and version | Build system | Remarks
--------------- | ------------ | -------------------- | ------------ | -------
-CentOS 6 | x86, amd64 | ? | autotools |
-CentOS 7 | amd64 | ? | autotools |
-Debian 8.0 | x86, amd64 | ? | autotools |
-Debian 9.0 | ARM64, x86, amd64 | ? | autotools |
-Fedora 28 | ARM64, ARM32, amd64 | ? | autotools |
-Fedora 29 | ARM64, ARM32, amd64 | ? | autotools |
-Fedora Rawhide | ARM64, ARM32, amd64 | ? | autotools |
-RedHat Enterprise Linux 7 | amd64, ppc64 | ? | autotools |
-SuSE Linux Enterprise 12 SP4 | ARM64, amd64, ppc64, s390x | ? | autotools |
-SuSE Linux Enterprise 15 | amd64 | ? | autotools |
-xUbuntu 12.04 | x86, amd64 | ? | autotools |
-xUbuntu 14.04 | x86, amd64 | ? | autotools |
-xUbuntu 16.04 | x86, amd64 | ? | autotools |
-xUbuntu 18.04 | x86, amd64 | ? | autotools |
-xUbuntu 18.10 | x86, amd64 | ? | autotools |
+| OS and version               | Architecture               | Compiler and version | Build system | Remarks |
+|------------------------------|----------------------------|----------------------|--------------|---------|
+| CentOS 6                     | x86, amd64                 | ?                    | autotools    |         |
+| CentOS 7                     | amd64                      | ?                    | autotools    |         |
+| Debian 8.0                   | x86, amd64                 | ?                    | autotools    |         |
+| Debian 9.0                   | ARM64, x86, amd64          | ?                    | autotools    |         |
+| Fedora 28                    | ARM64, ARM32, amd64        | ?                    | autotools    |         |
+| Fedora 29                    | ARM64, ARM32, amd64        | ?                    | autotools    |         |
+| Fedora Rawhide               | ARM64, ARM32, amd64        | ?                    | autotools    |         |
+| RedHat Enterprise Linux 7    | amd64, ppc64               | ?                    | autotools    |         |
+| SuSE Linux Enterprise 12 SP4 | ARM64, amd64, ppc64, s390x | ?                    | autotools    |         |
+| SuSE Linux Enterprise 15     | amd64                      | ?                    | autotools    |         |
+| xUbuntu 12.04                | x86, amd64                 | ?                    | autotools    |         |
+| xUbuntu 14.04                | x86, amd64                 | ?                    | autotools    |         |
+| xUbuntu 16.04                | x86, amd64                 | ?                    | autotools    |         |
+| xUbuntu 18.04                | x86, amd64                 | ?                    | autotools    |         |
+| xUbuntu 18.10                | x86, amd64                 | ?                    | autotools    |         |
 
 ### Supported platforms with known active users
 
-At the time of writing, no explicit reports have been available. Please report your experiences by opening a PR 
+At the time of writing, no explicit reports have been available. Please report your experiences by opening a PR
 adding an entry or moving an entry from the section below.
 
-Under "last report", please name either the SHA1 in case of an unreleased version, or the version number in 
+Under "last report", please name either the SHA1 in case of an unreleased version, or the version number in
 case of a released version.
 
-OS and version | Architecture | Compiler and version | Build system | Last report | Remarks
--------------- | ------------ | -------------------- | ------------ | ----------- | -------
-Solaris 10 | x86, amd64, sparc | GCC 8.1.0 | CMake | 2019/03/18 |
+| OS and version | Architecture      | Compiler and version | Build system | Last report             | Remarks |
+|----------------|-------------------|----------------------|--------------|-------------------------|---------|
+| Solaris 10     | x86, amd64, sparc | GCC 8.1.0            | CMake        | 2019/03/18              |         |
+| DragonFly BSD  | amd64             | gcc 8.3              | autotools    | 2018/08/07 git-72854e63 |         |
+| IBM i          | ppc64             | gcc 6.3              | autotools    | 2019/10/02 git-25320a3  |         |
+| QNX 7.0        | x86_64            | gcc 5.4.0            | CMake        | 4.3.2                   |         |
 
 
 ### Supported platforms without known active users
 
 Note: this list is incomplete and inaccurate and still needs some work.
 
-OS and version | Architecture | Compiler and version | Build system | Remarks
--------------- | ------------ | -------------------- | ------------ | -------
-Any Linux distribution | x86, amd64 | gcc ?+, clang ?+, icc ?+ | autotools, CMake |
-SunOS, Solaris | x86, amd64 | SunPro | autotools, CMake |
-GNU/kFreeBSD | ? | ? | autotools, CMake |
-FreeBSD | ? | ? | autotools, CMake |
-NetBSD | ? | ? | autotools, CMake |
-OpenBSD | ? | ? | autotools, CMake |
-HP-UX | ? | ? | autotools, CMake |
-GNU/Hurd | ? | ? | autotools |
-VxWorks 6.8 | ? | ? | ? |
-Windows CE | ? | ? | ? |
-Windows UWP | ? | ? | ? |
-OpenVMS | ? | ? | ? |
+| OS and version         | Architecture | Compiler and version     | Build system     | Remarks |
+|------------------------|--------------|--------------------------|------------------|---------|
+| Any Linux distribution | x86, amd64   | gcc ?+, clang ?+, icc ?+ | autotools, CMake |         |
+| SunOS, Solaris         | x86, amd64   | SunPro                   | autotools, CMake |         |
+| GNU/kFreeBSD           | ?            | ?                        | autotools, CMake |         |
+| FreeBSD                | ?            | ?                        | autotools, CMake |         |
+| NetBSD                 | ?            | ?                        | autotools, CMake |         |
+| OpenBSD                | ?            | ?                        | autotools, CMake |         |
+| DragonFly BSD          | amd64        | gcc 8.3                  | autotools, CMake |         |
+| HP-UX                  | ?            | ?                        | autotools, CMake |         |
+| GNU/Hurd               | ?            | ?                        | autotools        |         |
+| VxWorks 6.8            | ?            | ?                        | ?                |         |
+| Windows CE             | ?            | ?                        | ?                |         |
+| Windows UWP            | ?            | ?                        | ?                |         |
+| OpenVMS                | ?            | ?                        | ?                |         |
 
 ### Unsupported platforms
 
-OS and version | Architecture | Compiler and version | Remarks
--------------- | ------------ | -------------------- | -------
-QNX 6.3 | ? | gcc 3.3.5 | see #3371, support was added by a user, but not contributed to upstream
-Windows 10 | ARM, ARM64 | Visual Studio 2017 | see #3366, probably only minor issues 
+| OS and version | Architecture | Compiler and version | Remarks                                                                 |
+|----------------|--------------|----------------------|-------------------------------------------------------------------------|
+| QNX 6.3        | ?            | gcc 3.3.5            | see #3371, support was added by a user, but not contributed to upstream |
+| Windows 10     | ARM, ARM64   | Visual Studio 2017   | see #3366, probably only minor issues                                   |
 
 For more details, see [here](SupportedPlatforms.md).
 
-For some platforms (Linux, Mac OS X), [prebuilt binary packages are supplied by the ZeroMQ organization](#installation). 
+For some platforms (Linux, Mac OS X), [prebuilt binary packages are supplied by the ZeroMQ organization](#installation).
 For other platforms, you need to [build your own binaries](#build).
 
 ## Installation of binary packages <a name="installation"/>
@@ -150,6 +158,11 @@ For OSX users, packages are available vi
 
 To build from sources, see the INSTALL file included with the distribution.
 
+### Android
+
+To build from source, see [README](./builds/android/README.md) file in the
+android build directory.
+
 ## Resources
 
 Extensive documentation is provided with the distribution. Refer to
diff -pruN 4.3.2-2/RELICENSE/acsearle.md 4.3.3-1/RELICENSE/acsearle.md
--- 4.3.2-2/RELICENSE/acsearle.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/acsearle.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,14 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Liquid Instruments
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "acsearle", with
+commit author "Antony Searle", are copyright of Liquid Instruments .
+This document hereby grants the libzmq project team to relicense
+libzmq, including all past, present and future contributions of the author
+listed above.
+
+Antony Searle
+2020/02/03
diff -pruN 4.3.2-2/RELICENSE/aixxe.md 4.3.3-1/RELICENSE/aixxe.md
--- 4.3.2-2/RELICENSE/aixxe.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/aixxe.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by aixxe (aixxe)
+that grants permission to relicense his copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "aixxe", with commit author
+"aixxe <me@aixxe.net>" are copyright of aixxe.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+aixxe
+2019/07/25
\ No newline at end of file
diff -pruN 4.3.2-2/RELICENSE/asafkahlon.md 4.3.3-1/RELICENSE/asafkahlon.md
--- 4.3.2-2/RELICENSE/asafkahlon.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/asafkahlon.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Asaf Kahlon
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "asafkahlon", with
+commit author "Asaf Kahlon asafka7@gmail.com", are copyright of Asaf Kahlon.
+This document hereby grants the libzmq project team to relicense
+libzmq,
+including all past, present and future contributions of the author
+listed above.
+
+Asaf Kahlon
+2020/02/05
diff -pruN 4.3.2-2/RELICENSE/atomashpolskiy.md 4.3.3-1/RELICENSE/atomashpolskiy.md
--- 4.3.2-2/RELICENSE/atomashpolskiy.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/atomashpolskiy.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Andrei Tomashpolskiy
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "atomashpolskiy", with
+commit author "Andrei Tomashpolskiy <nordmann89@gmail.com>", are copyright of Andrei Tomashpolskiy .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Andrei Tomashpolskiy  
+2019/08/22
diff -pruN 4.3.2-2/RELICENSE/AxelNennker.md 4.3.3-1/RELICENSE/AxelNennker.md
--- 4.3.2-2/RELICENSE/AxelNennker.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/AxelNennker.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Axel Nennker that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+A portion of the commits made by the Github handle "AxelNennker", with
+commit author "Axel Nennker <axel@nennker.de>", are
+copyright of Axel Nennker.  This document hereby grants the libzmq
+project team to relicense libzmq, including all past, present and
+future contributions of the author listed above.
+
+Axel Nennker
+2019/08/11
diff -pruN 4.3.2-2/RELICENSE/bebopagogo.md 4.3.3-1/RELICENSE/bebopagogo.md
--- 4.3.2-2/RELICENSE/bebopagogo.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/bebopagogo.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Brian Adamson that grants permission to relicense its
+copyrights in the libzmq C++ library (ZeroMQ) under the Mozilla Public License v2
+(MPLv2).
+
+A portion of the commits made by the Github handle "bebopagogo", with commit
+author "bebopagogo <bebopagogo@users.noreply.github.com>" and "Brian Adamson
+<badamson@gmail.com>", are copyright of Brian Adamson. This document hereby grants
+the libzmq project team to relicense libzmq, including all past, present and
+future contributions of the author listed above.
+
+Brian Adamson 2019/08/11 s
diff -pruN 4.3.2-2/RELICENSE/benjdero.md 4.3.3-1/RELICENSE/benjdero.md
--- 4.3.2-2/RELICENSE/benjdero.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/benjdero.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Benjamin Deroche
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "benjdero", with
+commit author "Benjamin Deroche", are copyright of Benjamin Deroche.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Benjamin Deroche
+2019/10/26
\ No newline at end of file
diff -pruN 4.3.2-2/RELICENSE/bl0x.md 4.3.3-1/RELICENSE/bl0x.md
--- 4.3.2-2/RELICENSE/bl0x.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/bl0x.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Bastian Löher that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+A portion of the commits made by the Github handle "bl0x", with
+commit author "Bastian Löher <me@l-dot.de>", are
+copyright of Bastian Löher.  This document hereby grants the libzmq
+project team to relicense libzmq, including all past, present and
+future contributions of the author listed above.
+
+Bastian Löher
+2019/08/01
diff -pruN 4.3.2-2/RELICENSE/Botje.md 4.3.3-1/RELICENSE/Botje.md
--- 4.3.2-2/RELICENSE/Botje.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/Botje.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Dries Harnie
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "Botje", with
+commit author "Dries Harnie <dries@harnie.be>", are copyright of Dries Harnie.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Dries Harnie
+2019/10/31
diff -pruN 4.3.2-2/RELICENSE/brian-peloton.md 4.3.3-1/RELICENSE/brian-peloton.md
--- 4.3.2-2/RELICENSE/brian-peloton.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/brian-peloton.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Brian Silverman
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "brian-peloton", with
+commit author "brian@peloton-tech.com", are copyright of Brian Silverman .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Brian Silverman
+2019/08/14
\ No newline at end of file
diff -pruN 4.3.2-2/RELICENSE/cbusbey.md 4.3.3-1/RELICENSE/cbusbey.md
--- 4.3.2-2/RELICENSE/cbusbey.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/cbusbey.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Connamara Systems llc
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "cbusbey", with
+commit author "chris busbey", are copyright of Connamara Systems, llc.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Chris Busbey  
+2019/09/03
diff -pruN 4.3.2-2/RELICENSE/chymanfx.md 4.3.3-1/RELICENSE/chymanfx.md
--- 4.3.2-2/RELICENSE/chymanfx.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/chymanfx.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,12 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+I happily grant permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+The portion of the commits made by the Github handle "chymanfx", are
+not copyrighted in any way.
+Chyman
+2019/08/12
diff -pruN 4.3.2-2/RELICENSE/claws.md 4.3.3-1/RELICENSE/claws.md
--- 4.3.2-2/RELICENSE/claws.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/claws.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Christopher Laws
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "claws", with
+commit author "Chris Laws <clawsicus@gmail.com>", are copyright of Christopher Laws.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Christopher Laws  
+2019/08/11
diff -pruN 4.3.2-2/RELICENSE/colletted.md 4.3.3-1/RELICENSE/colletted.md
--- 4.3.2-2/RELICENSE/colletted.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/colletted.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,7 @@
+Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Denis Collette that grants permission to relicense its copyrights in the libzmq C++ library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other Open Source Initiative approved license chosen by the current ZeroMQ BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "colletted", with commit author "Denis Collette denisncollette@gmail.com", are copyright of Denis Collette. This document hereby grants the libzmq project team to relicense libzmq, including all past, present and future contributions of the author listed above.
+
+Denis Collette 2020/01/22
diff -pruN 4.3.2-2/RELICENSE/cwsmith.md 4.3.3-1/RELICENSE/cwsmith.md
--- 4.3.2-2/RELICENSE/cwsmith.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/cwsmith.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Cameron Smith
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "cwsmith", with
+commit author "Cameron Smith <smithc11@rpi.edu>", are copyright of Cameron Smith.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Cameron Smith
+2020/02/05
diff -pruN 4.3.2-2/RELICENSE/DaiyuHurst.md 4.3.3-1/RELICENSE/DaiyuHurst.md
--- 4.3.2-2/RELICENSE/DaiyuHurst.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/DaiyuHurst.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Daiyu Hurst that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+A portion of the commits made by the Github handle "daiyuhurst", with
+commit author "Daiyu Hurst <daiyu.hurst@gmail.com>", are
+copyright of Daiyu Hurst.  This document hereby grants the libzmq
+project team to relicense libzmq, including all past, present and
+future contributions of the author listed above.
+
+Daiyu Hurst
+2019/08/31
diff -pruN 4.3.2-2/RELICENSE/dennisklein.md 4.3.3-1/RELICENSE/dennisklein.md
--- 4.3.2-2/RELICENSE/dennisklein.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/dennisklein.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Dennis Klein
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "dennisklein", with
+commit author "Dennis Klein <d.klein@gsi.de>", are copyright of Dennis Klein.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Dennis Klein
+2019/08/11
diff -pruN 4.3.2-2/RELICENSE/dhammika.md 4.3.3-1/RELICENSE/dhammika.md
--- 4.3.2-2/RELICENSE/dhammika.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/dhammika.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Dhammika Pathirana
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "dhammika", with
+commit author "Dhammika Pathirana <dhammika@gmail.com>", are copyright of Dhammika Pathirana .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Dhammika Pathirana
+2019/08/12
diff -pruN 4.3.2-2/RELICENSE/dimpase.md 4.3.3-1/RELICENSE/dimpase.md
--- 4.3.2-2/RELICENSE/dimpase.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/dimpase.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,14 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Dmitrii (Dima) Pasechnik
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "dimpase", with
+commit author "Dima Pasechnik dimpase@gmail.com", are copyright of Dmitrii Pasechnik.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Dmitrii Pasechnik  2019/09/18
diff -pruN 4.3.2-2/RELICENSE/diorcety.md 4.3.3-1/RELICENSE/diorcety.md
--- 4.3.2-2/RELICENSE/diorcety.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/diorcety.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Diorcet Yann
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "diorcety", with
+commit author "yann.diorcet@xenocs.com", are copyright of Diorcet Yann.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Diorcet Yann
+2019/09/04
diff -pruN 4.3.2-2/RELICENSE/dkrikun.md 4.3.3-1/RELICENSE/dkrikun.md
--- 4.3.2-2/RELICENSE/dkrikun.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/dkrikun.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Daniel Krikun
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "dkrikun", with
+commit author "Daniel Krikun", are copyright of Daniel Krikun .
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Daniel Krikun
+2019/08/17
diff -pruN 4.3.2-2/RELICENSE/dmeehan1968.md 4.3.3-1/RELICENSE/dmeehan1968.md
--- 4.3.2-2/RELICENSE/dmeehan1968.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/dmeehan1968.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Dave Meehan
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "dmeehan1968", with
+commit author "Dave Meehan dave_meehan@replicated.co.uk", are copyright of Dave Meehan.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Dave Meehan
+2019/08/31
diff -pruN 4.3.2-2/RELICENSE/drbobbeaty.md 4.3.3-1/RELICENSE/drbobbeaty.md
--- 4.3.2-2/RELICENSE/drbobbeaty.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/drbobbeaty.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Robert Beaty
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "drbobbeaty", with
+commit author "Bob Beaty <drbob@themanfromspud.com>", are copyright of Robert Beaty .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Robert Beaty
+2019/08/10
diff -pruN 4.3.2-2/RELICENSE/drolevar.md 4.3.3-1/RELICENSE/drolevar.md
--- 4.3.2-2/RELICENSE/drolevar.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/drolevar.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Andrij Abyzov
+that grants permission to relicense his copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "drolevar", with
+commit author "Andrij Abyzov <drolevar@gmail.com>", are copyright of Andrij Abyzov.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed
+above.
+
+Andrij Abyzov
+2019/11/19
diff -pruN 4.3.2-2/RELICENSE/eldruin.md 4.3.3-1/RELICENSE/eldruin.md
--- 4.3.2-2/RELICENSE/eldruin.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/eldruin.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Diego Barrios Romero
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "eldruin", with
+commit author "Diego Barrios Romero <eldruin@gmail.com>", are copyright of Diego Barrios Romero.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Diego Barrios Romero
+2019/11/13
\ No newline at end of file
diff -pruN 4.3.2-2/RELICENSE/fanquake.md 4.3.3-1/RELICENSE/fanquake.md
--- 4.3.2-2/RELICENSE/fanquake.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/fanquake.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,17 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Michael Ford that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+A portion of the commits made by the Github handle "fanquake", with
+commit author "Michael Ford <fanquake@gmail.com>", are
+copyright of Michael Ford.  This document hereby grants the libzmq
+project team to relicense libzmq, including all past, present and
+future contributions of the author listed above.
+
+Michael Ford
+2019/08/10
+
diff -pruN 4.3.2-2/RELICENSE/ferdnyc.md 4.3.3-1/RELICENSE/ferdnyc.md
--- 4.3.2-2/RELICENSE/ferdnyc.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/ferdnyc.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Frank R. Dana Jr.
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "ferdnyc", with
+commit author "FeRD (Frank Dana)", are copyright of Frank R. Dana, Jr.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Frank Richard Dana, Jr.
+2020-03-16
diff -pruN 4.3.2-2/RELICENSE/FredTreg.md 4.3.3-1/RELICENSE/FredTreg.md
--- 4.3.2-2/RELICENSE/FredTreg.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/FredTreg.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Frédéric Trégon
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "FredTreg", with
+commit author "Frederic Tregon <frederic.tregon@gmail.com>", are copyright of Frédéric Trégon.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Frédéric Trégon
+2020/02/03
diff -pruN 4.3.2-2/RELICENSE/garlick.md 4.3.3-1/RELICENSE/garlick.md
--- 4.3.2-2/RELICENSE/garlick.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/garlick.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Jim Garlick (garlick)
+that grants permission to relicense his copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "garlick", with
+commit author "Jim Garlick <garlick.jim@gmail.com>", are copyright of
+Jim Garlick.  This document hereby grants the libzmq project team to
+relicense libzmq, including all past, present and future contributions
+of the author listed above.
+
+Jim Garlick
+2019/08/10
diff -pruN 4.3.2-2/RELICENSE/gcsideal.md 4.3.3-1/RELICENSE/gcsideal.md
--- 4.3.2-2/RELICENSE/gcsideal.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/gcsideal.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Laszlo Boszormenyi (GCS) that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "gcsideal", with
+commit author "Laszlo Boszormenyi (GCS) <gcs@debian.org>", are copyright of
+Laszlo Boszormenyi (GCS) .
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author
+listed above.
+
+Laszlo Boszormenyi (GCS)
+2020/02/13
diff -pruN 4.3.2-2/RELICENSE/grmt.md 4.3.3-1/RELICENSE/grmt.md
--- 4.3.2-2/RELICENSE/grmt.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/grmt.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by grmt.
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "grmt", with
+commit author "grmt", are copyright of grmt.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+grmt (garmt.noname@gmail.com)
+2020/05/04
diff -pruN 4.3.2-2/RELICENSE/gummif.md 4.3.3-1/RELICENSE/gummif.md
--- 4.3.2-2/RELICENSE/gummif.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/gummif.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,17 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Gudmundur Adalsteinsson that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+A portion of the commits made by the Github handle "gummif", with
+commit author "Gudmundur Adalsteinsson <ofpgummi@yahoo.com>", are
+copyright of Gudmundur Adalsteinsson.  This document hereby grants the libzmq
+project team to relicense libzmq, including all past, present and
+future contributions of the author listed above.
+
+Gudmundur Adalsteinsson
+2020/02/04
+
diff -pruN 4.3.2-2/RELICENSE/herbrechtsmeier.md 4.3.3-1/RELICENSE/herbrechtsmeier.md
--- 4.3.2-2/RELICENSE/herbrechtsmeier.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/herbrechtsmeier.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Weidmueller Interface GmbH & Co KG
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "herbrechtsmeier", with
+commit author "Stefan Herbrechtsmeier", are copyright of Weidmueller Interface GmbH & Co KG.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Stefan Herbrechtsmeier
+2019/09/09
diff -pruN 4.3.2-2/RELICENSE/hnwyllmm.md 4.3.3-1/RELICENSE/hnwyllmm.md
--- 4.3.2-2/RELICENSE/hnwyllmm.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/hnwyllmm.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Wang Yunlai
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "hnwyllmm", with
+commit author "hnwyllmm hnwyllmm@126.com", are copyright of Wang Yunlai .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Wang Yunlai 
+2019/08/13
diff -pruN 4.3.2-2/RELICENSE/hsw.md 4.3.3-1/RELICENSE/hsw.md
--- 4.3.2-2/RELICENSE/hsw.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/hsw.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Christopher Hall that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+A portion of the commits made by the Github handle "hxw", with commit
+author "Christopher Hall <hsw@ms2.hinet.net>", are copyright of
+Christopher Hall.  This document hereby grants the libzmq project team
+to relicense libzmq, including all past, present and future
+contributions of the author listed above.
+
+Christopher Hall
+2019/08/07
diff -pruN 4.3.2-2/RELICENSE/inuik.md 4.3.3-1/RELICENSE/inuik.md
--- 4.3.2-2/RELICENSE/inuik.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/inuik.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,17 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Rishi Theivendan (inuik)
+that grants permission to relicense his copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "inuik", with
+commit author "Rishi Theivendran <29522253+inuik@users.noreply.github.com>" or
+"Rishi Theivendran <rishi.theivendran@rohde-schwarz.com>", are copyright of Rishi Theivendran.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed
+above.
+
+Rishi Theivendran
+2019/07/18
diff -pruN 4.3.2-2/RELICENSE/ipechorin.md 4.3.3-1/RELICENSE/ipechorin.md
--- 4.3.2-2/RELICENSE/ipechorin.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/ipechorin.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,17 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Ivan Pechorin that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+A portion of the commits made by the Github handle "ipechorin", with
+commit author "Ivan Pechorin <ivan.pechorin@gmail.com>", are
+copyright of Ivan Pechorin.  This document hereby grants the libzmq
+project team to relicense libzmq, including all past, present and
+future contributions of the author listed above.
+
+Ivan Pechorin
+2019/09/25
+
diff -pruN 4.3.2-2/RELICENSE/jbreams.md 4.3.3-1/RELICENSE/jbreams.md
--- 4.3.2-2/RELICENSE/jbreams.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/jbreams.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,17 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Jonathan Reams
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "jbreams", with
+commit author "Jonathan Reams <jbreams@gmail.com>", are copyright of
+Jonathan Reams.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed
+above.
+
+Jonathan Reams
+2019/08/31
diff -pruN 4.3.2-2/RELICENSE/jcfr.md 4.3.3-1/RELICENSE/jcfr.md
--- 4.3.2-2/RELICENSE/jcfr.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/jcfr.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Jean-Christophe Fillion-Robin
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "jcfr", with
+commit author "Jean-Christophe Fillion-Robin <jchris.fillionr@kitware.com>", are copyright of Kitware Inc.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Jean-Christophe Fillion-Robin
+2019/09/03
diff -pruN 4.3.2-2/RELICENSE/jens.auer.md 4.3.3-1/RELICENSE/jens.auer.md
--- 4.3.2-2/RELICENSE/jens.auer.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/jens.auer.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Jens Auer
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "jens.auer", with
+commit author "Jens Auer", are copyright of Jens Auer.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Jens Auer
+2019/11/08
diff -pruN 4.3.2-2/RELICENSE/jimenezrick.md 4.3.3-1/RELICENSE/jimenezrick.md
--- 4.3.2-2/RELICENSE/jimenezrick.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/jimenezrick.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Ricardo Catalinas Jimenez
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "jimenezrick", with
+commit author "Ricardo Catalinas Jimenez", are copyright of Ricardo
+Catalinas Jimenez.
+This document hereby grants the libzmq project team to relicense
+libzmq,
+including all past, present and future contributions of the author
+listed above.
+
+Ricardo Catalinas Jimenez
+2020/02/03
diff -pruN 4.3.2-2/RELICENSE/jlauenercern.md 4.3.3-1/RELICENSE/jlauenercern.md
--- 4.3.2-2/RELICENSE/jlauenercern.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/jlauenercern.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other share-alike OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Joel Lauener
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+share-alike Open Source Initiative approved license chosen by the current 
+ZeroMQ BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "jlauenercern", with
+commit author "Joel Lauener <Joel.Lauener@cern.ch>", are copyright of Joel Lauener .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Joel Lauener 
+2019/08/12
\ No newline at end of file
diff -pruN 4.3.2-2/RELICENSE/JonDyte.md 4.3.3-1/RELICENSE/JonDyte.md
--- 4.3.2-2/RELICENSE/JonDyte.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/JonDyte.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Jon Dyte
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "JonDyte", with
+commit author "Jon Dyte <jon@totient.co.uk>", are copyright of Jon Dyte.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Jon Dyte
+2019/10/03
diff -pruN 4.3.2-2/RELICENSE/jsyoo5b.md 4.3.3-1/RELICENSE/jsyoo5b.md
--- 4.3.2-2/RELICENSE/jsyoo5b.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/jsyoo5b.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by JaeSang Yoo
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "JSYoo5B", with
+commit author "JaeSang Yoo <jsyoo5b@gmail.com>", are copyright of JaeSang Yoo.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+JaeSang Yoo  
+2020.02.29
diff -pruN 4.3.2-2/RELICENSE/kaczmarj.md 4.3.3-1/RELICENSE/kaczmarj.md
--- 4.3.2-2/RELICENSE/kaczmarj.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/kaczmarj.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Jakub Kaczmarzyk
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "kaczmarj", with
+commit author "Jakub Kaczmarzyk jakub.kaczmarzyk@gmail.com", are copyright of Jakub Kaczmarzyk.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Jakub Kaczmarzyk
+2020/07/29
diff -pruN 4.3.2-2/RELICENSE/kalantar.md 4.3.3-1/RELICENSE/kalantar.md
--- 4.3.2-2/RELICENSE/kalantar.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/kalantar.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Davit Kalantaryan
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made with commit author 
+"Davit Kalantaryan <davit.kalantaryan@desy.de>", are copyright of Davit Kalantaryan.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Davit Kalantaryan
+2020/08/06
diff -pruN 4.3.2-2/RELICENSE/kanonet.md 4.3.3-1/RELICENSE/kanonet.md
--- 4.3.2-2/RELICENSE/kanonet.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/kanonet.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,8 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Christoph Kahl that grants permission to relicense its copyrights in the libzmq C++ library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other Open Source Initiative approved license chosen by the current ZeroMQ BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "kanonet", with commit author "Christoph Kahl", are copyright of Christoph Kahl. This document hereby grants the libzmq project team to relicense libzmq, including all past, present and future contributions of the author listed above.
+
+Christoph Kahl  
+2020/01/09
\ No newline at end of file
diff -pruN 4.3.2-2/RELICENSE/KLNikita.md 4.3.3-1/RELICENSE/KLNikita.md
--- 4.3.2-2/RELICENSE/KLNikita.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/KLNikita.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Nikita Kozlov
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "KLNikita", with
+commit author "nikita kozlov <nikita@elyzion.net>", are copyright of Nikita Kozlov .
+This document hereby grants the libzmq project team to relicense
+libzmq,
+including all past, present and future contributions of the author
+listed above.
+
+Nikita Kozlov
+6 February 2020
diff -pruN 4.3.2-2/RELICENSE/kreuzberger.md 4.3.3-1/RELICENSE/kreuzberger.md
--- 4.3.2-2/RELICENSE/kreuzberger.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/kreuzberger.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Joerg Kreuzberger
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "kreuzberger", with
+commit author "Joerg Kreuzberger", are copyright of Joerg Kreuzberger .
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Joerg Kreuzberger
+2019/09/02
diff -pruN 4.3.2-2/RELICENSE/laplaceyang.md 4.3.3-1/RELICENSE/laplaceyang.md
--- 4.3.2-2/RELICENSE/laplaceyang.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/laplaceyang.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Xujing Yang (laplaceyang)
+that grants permission to relicense his copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "laplaceyang", with
+commit author "laplaceyang <laplace2013@outlook.com>", are copyright of Xujing Yang.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed
+above.
+
+Xujing Yang
+2020/04/22
diff -pruN 4.3.2-2/RELICENSE/latchmoor-services-carcich.md 4.3.3-1/RELICENSE/latchmoor-services-carcich.md
--- 4.3.2-2/RELICENSE/latchmoor-services-carcich.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/latchmoor-services-carcich.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Latchmoor Services, LLC
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "drbitboy", with
+commit author "Brian Carcich <drbitboy@gmail.com>", are copyright of Latchmoor
+Services, LLC.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Latchmoor Services, LLC
+2019/07/26
diff -pruN 4.3.2-2/RELICENSE/liedtkeInTUM.md 4.3.3-1/RELICENSE/liedtkeInTUM.md
--- 4.3.2-2/RELICENSE/liedtkeInTUM.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/liedtkeInTUM.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Sven Liedtke
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "liedtkeInTUM", with
+commit author "Sven Liedtke", are copyright of Sven Liedtke.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Sven Liedtke  
+2019/11/27
\ No newline at end of file
diff -pruN 4.3.2-2/RELICENSE/lstacul.md 4.3.3-1/RELICENSE/lstacul.md
--- 4.3.2-2/RELICENSE/lstacul.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/lstacul.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,14 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Laurent Stacul
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "stac47", with
+commit author "Laurent Stacul <laurent.stacul@gmail.com>", are copyright of
+Laurent Stacul .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Laurent Stacul
+2020/02/21
diff -pruN 4.3.2-2/RELICENSE/malexzx.md 4.3.3-1/RELICENSE/malexzx.md
--- 4.3.2-2/RELICENSE/malexzx.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/malexzx.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Aleksander Melnikov
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "malexzx", with
+commit author "Aleksander Melnikov", are copyright of Aleksander Melnikov.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Aleksander Melnikov
+2019/08/11
diff -pruN 4.3.2-2/RELICENSE/mancasg.md 4.3.3-1/RELICENSE/mancasg.md
--- 4.3.2-2/RELICENSE/mancasg.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/mancasg.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Mancaș George
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "mancasg", with
+commit author "Mancaș George <mancas.f.george@gmail.com>", are copyright of Mancaș George .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Mancaș George
+2019/07/24
diff -pruN 4.3.2-2/RELICENSE/mbarbisan.md 4.3.3-1/RELICENSE/mbarbisan.md
--- 4.3.2-2/RELICENSE/mbarbisan.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/mbarbisan.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,14 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Mark Barbisan
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "mbarbisan", with
+commit author "Mark Barbisan <mark@barbisan.ca>", are copyright of Mark Barbisan.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Mark Barbisan
+2019/08/31
+
diff -pruN 4.3.2-2/RELICENSE/mdionisio.md 4.3.3-1/RELICENSE/mdionisio.md
--- 4.3.2-2/RELICENSE/mdionisio.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/mdionisio.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Thomas M. DuBuisson
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "mdionisio", with
+commit author "Michele Dionisio", are copyright of Michele Dionisio.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Michele Dionisio
+2019/07/09
diff -pruN 4.3.2-2/RELICENSE/mesegura.md 4.3.3-1/RELICENSE/mesegura.md
--- 4.3.2-2/RELICENSE/mesegura.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/mesegura.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Manuel Segura
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "mesegura", with
+commit author "Manuel Segura", are copyright of Manuel Segura .
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Manuel Eduardo Segura
+2019/08/10
diff -pruN 4.3.2-2/RELICENSE/mileschet.md 4.3.3-1/RELICENSE/mileschet.md
--- 4.3.2-2/RELICENSE/mileschet.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/mileschet.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,6 @@
+Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+This is a statement by Roberto Santacroce Martins that grants permission to relicense its copyrights in the libzmq C++ library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other Open Source Initiative approved license chosen by the current ZeroMQ BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "mileschet", with commit author "Roberto Santacroce Martins miles.chet@gmail.com", are copyright of Roberto Santacroce Martins. This document hereby grants the libzmq project team to relicense libzmq, including all past, present and future contributions of the author listed above.
+
+Roberto Santacroce Martins 2020/07/06
diff -pruN 4.3.2-2/RELICENSE/miniway.md 4.3.3-1/RELICENSE/miniway.md
--- 4.3.2-2/RELICENSE/miniway.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/miniway.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Dongmin Yu
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "miniway", with
+commit author "Dongmin Yu <miniway@gmail.com>", are copyright of Dongmin Yu.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Dongmin Yu
+2019/08/12
diff -pruN 4.3.2-2/RELICENSE/mjvk.md 4.3.3-1/RELICENSE/mjvk.md
--- 4.3.2-2/RELICENSE/mjvk.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/mjvk.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Mark Jan van Kampen that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+A portion of the commits made by the Github handle "mjvk", with
+commit author "Mark Jan van Kampen <markjanvankampen@gmail.com>", are
+copyright of Mark Jan van Kampen.  This document hereby grants the libzmq
+project team to relicense libzmq, including all past, present and
+future contributions of the author listed above.
+
+Mark Jan van Kampen
+2020/02/24
\ No newline at end of file
diff -pruN 4.3.2-2/RELICENSE/mloy.md 4.3.3-1/RELICENSE/mloy.md
--- 4.3.2-2/RELICENSE/mloy.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/mloy.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,14 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Matthias Loy
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "mloy", with
+commit author "Matthias Loy", are copyright of Matthias Loy.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Matthias Loy
+2020/01/18
+
diff -pruN 4.3.2-2/RELICENSE/mongodb.md 4.3.3-1/RELICENSE/mongodb.md
--- 4.3.2-2/RELICENSE/mongodb.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/mongodb.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,17 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Jonathan Reams (of MongoDB, Inc.)
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "jbreams", with
+commit author "Jonathan Reams jbreams@mongodb.com" (specifically the commits merged in pull requests #1451, #1449, #1448, and #1174), are copyright of
+MongoDB, Inc.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed
+above.
+
+Jonathan Reams
+2019/10/1
diff -pruN 4.3.2-2/RELICENSE/msune.md 4.3.3-1/RELICENSE/msune.md
--- 4.3.2-2/RELICENSE/msune.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/msune.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,17 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Marc Suñé Clos (msune)
+that grants permission to relicense his copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "msune", with
+commit author "Marc Sune <marcdevel@gmail.com>" or
+"Marc Sune <marc@voltanet.io>", are copyright of Marc Suñé.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed
+above.
+
+Marc Suñé Clos
+2019/08/31
diff -pruN 4.3.2-2/RELICENSE/murphybytes.md 4.3.3-1/RELICENSE/murphybytes.md
--- 4.3.2-2/RELICENSE/murphybytes.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/murphybytes.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by John Murphy    
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "murphybytes", with
+commit author "John Murphy <murphybytes@gmail.com>", are copyright of John Murphy .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+John Murphy
+2019/08/12
diff -pruN 4.3.2-2/RELICENSE/mvilim.md 4.3.3-1/RELICENSE/mvilim.md
--- 4.3.2-2/RELICENSE/mvilim.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/mvilim.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Michael Vilim that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+A portion of the commits made by the Github handle "mvilim", with
+commit author "Michael Vilim <697a9b924bfa6f06a81e82975ddca4785b90a7b40d91044ce76f68d3bd65a9b8@697a9b924bfa6f06a81e82975ddca4785b90a7b40d91044ce76f68d3bd65a9b8.com>", are
+copyright of Michael Vilim.  This document hereby grants the libzmq
+project team to relicense libzmq, including all past, present and
+future contributions of the author listed above.
+
+Michael Vilim
+2019/08/31
diff -pruN 4.3.2-2/RELICENSE/Neopallium.md 4.3.3-1/RELICENSE/Neopallium.md
--- 4.3.2-2/RELICENSE/Neopallium.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/Neopallium.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Robert G. Jakabosky
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "Neopallium", with
+commit author "Robert G. Jakabosky <bobby@sharedrealm.com>", are copyright of Robert G. Jakabosky.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Robert Gabriel Jakabosky
+2019/08/17
diff -pruN 4.3.2-2/RELICENSE/ninoles.md 4.3.3-1/RELICENSE/ninoles.md
--- 4.3.2-2/RELICENSE/ninoles.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/ninoles.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Fabien Ninoles that grants permission to relicense
+its copyrights in the libzmq C++ library (ZeroMQ) under the Mozilla
+Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "ninoles",
+with commit author "Fabien Ninoles", are copyright of Fabien Ninoles.
+
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author
+listed above.
+
+Fabien Ninoles
+
+2020/02/11
diff -pruN 4.3.2-2/RELICENSE/nixman.md 4.3.3-1/RELICENSE/nixman.md
--- 4.3.2-2/RELICENSE/nixman.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/nixman.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by niXman (github.nixman@pm.me)
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "niXman", with
+commit author "niXman", are copyright of nixMan .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+niXman (github.nixman@pm.me)
+2019/10/03
diff -pruN 4.3.2-2/RELICENSE/paddor.md 4.3.3-1/RELICENSE/paddor.md
--- 4.3.2-2/RELICENSE/paddor.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/paddor.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Patrik Wenger
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "paddor", with
+commit author "Patrik Wenger", are copyright of Patrik Wenger .
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Patrik Wenger
+2019/08/31
diff -pruN 4.3.2-2/RELICENSE/pavel-pimenov.md 4.3.3-1/RELICENSE/pavel-pimenov.md
--- 4.3.2-2/RELICENSE/pavel-pimenov.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/pavel-pimenov.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Pavel Pimenov
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle pavel-pimenov, with
+commit author Pavel Pimenov pavel.pimenov@gmail.com, are copyright of Pavel Pimenov .
+This document hereby grants the libzmq project team to relicense
+libzmq, 
+including all past, present and future contributions of the author
+listed above.
+
+Pavel Pimenov
+2020/02/04
diff -pruN 4.3.2-2/RELICENSE/phreed.md 4.3.3-1/RELICENSE/phreed.md
--- 4.3.2-2/RELICENSE/phreed.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/phreed.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Fredrick Paul Eisele
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle phreed, with
+commit author "Fred Eisele", are copyright of Fred Eisele .
+This document hereby grants the libzmq project team to relicense
+libzmq,
+including all past, present and future contributions of the author
+listed above.
+
+Fredrick Paul Eisele
+2020/01/03
diff -pruN 4.3.2-2/RELICENSE/psl-felipefarinon.md 4.3.3-1/RELICENSE/psl-felipefarinon.md
--- 4.3.2-2/RELICENSE/psl-felipefarinon.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/psl-felipefarinon.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Felipe Goron Farinon (psl-felipefarinon)
+that grants permission to relicense his copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "psl-felipefarinon", with
+commit author "Felipe Goron Farinon", are copyright of Felipe Goron Farinon.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed
+above.
+
+Felipe Goron Farinon
+2019/09/02
diff -pruN 4.3.2-2/RELICENSE/rcxdude.md 4.3.3-1/RELICENSE/rcxdude.md
--- 4.3.2-2/RELICENSE/rcxdude.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/rcxdude.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Douglas Young
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "rcxdude", with
+commit author "Douglas Young <rcxdude@gmail.com>", are copyright of Douglas Young .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Douglas Young 
+2019/08/31
diff -pruN 4.3.2-2/RELICENSE/Ricardicus.md 4.3.3-1/RELICENSE/Ricardicus.md
--- 4.3.2-2/RELICENSE/Ricardicus.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/Ricardicus.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,6 @@
+Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+This is a statement by Rickard Hallerbäck that grants permission to relicense its copyrights in the libzmq C++ library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other Open Source Initiative approved license chosen by the current ZeroMQ BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "Ricardicus", with commit author "Rickard Hallerbäck", are copyright of Rickard Hallerbäck. This document hereby grants the libzmq project team to relicense libzmq, including all past, present and future contributions of the author listed above.
+
+Rickard Hallerbäck 2020/02/28
\ No newline at end of file
diff -pruN 4.3.2-2/RELICENSE/RPGillespie6.md 4.3.3-1/RELICENSE/RPGillespie6.md
--- 4.3.2-2/RELICENSE/RPGillespie6.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/RPGillespie6.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,16 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Bryan Gillespie (RPGillespie6)
+that grants permission to relicense his copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "RPGillespie6", with
+commit author "Bryan Gillespie <rpgillespie6@gmail.com>", are copyright of Bryan Gillespie.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed
+above.
+
+Bryan Gillespie
+2019/09/06
diff -pruN 4.3.2-2/RELICENSE/serg06.md 4.3.3-1/RELICENSE/serg06.md
--- 4.3.2-2/RELICENSE/serg06.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/serg06.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by serg06 (serg06)
+that grants permission to relicense his copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "serg06", with commit author
+"serg06 <serkhas@hotmail.com>" are copyright of serg06.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+serg06
+2020/05/25
diff -pruN 4.3.2-2/RELICENSE/skaller.md 4.3.3-1/RELICENSE/skaller.md
--- 4.3.2-2/RELICENSE/skaller.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/skaller.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by John Skallwe
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any
+other Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle “skaller", with
+commit author “skaller", are copyright of John Skaller .
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+John Skaller
+2019/09/01
diff -pruN 4.3.2-2/RELICENSE/sonoware.md 4.3.3-1/RELICENSE/sonoware.md
--- 4.3.2-2/RELICENSE/sonoware.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/sonoware.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by sonoware GmbH that grants permission to relicense its
+copyrights in the libzmq C++ library (ZeroMQ) under the Mozilla Public License
+v2 (MPLv2).
+
+A portion of the commits made by the Github handle "sonoware", with commit author
+"Stephan Senkbeil" are copyright of sonoware GmbH. 
+This document hereby grants the libzmq project team to relicense libzmq, including
+all past, present and future contributions of the authors listed above.
+
+Stephan Senkbeil <stephan.senkbeil@sonoware.de>
+2019/12/13
diff -pruN 4.3.2-2/RELICENSE/spotify.md 4.3.3-1/RELICENSE/spotify.md
--- 4.3.2-2/RELICENSE/spotify.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/spotify.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Spotify AB that grants permission to relicense its
+copyrights in the libzmq C++ library (ZeroMQ) under the Mozilla Public License
+v2 (MPLv2).
+
+A portion of the commits made by the Github handle "gimaker", with commit author
+"Staffan Gimåker", the commits made by the Github handle "danielnorberg", with
+commit author "Daniel Norberg", and the commits made by the Github handle
+"caipre", with commit author "Nick Platt", are copyright of Spotify AB. This
+document hereby grants the libzmq project team to relicense libzmq, including
+all past, present and future contributions of the authors listed above.
+
+Nick Platt <nickplatt@spotify.com>
+2019/08/21
diff -pruN 4.3.2-2/RELICENSE/std-any-emplace.md 4.3.3-1/RELICENSE/std-any-emplace.md
--- 4.3.2-2/RELICENSE/std-any-emplace.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/std-any-emplace.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other share-alike OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by the Github user "std-any-emplace"
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+share-alike Open Source Initiative approved license chosen by the current 
+ZeroMQ BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "std-any-emplace", with
+commit author "std-any-emplace", are copyright of the Github user "std-any-emplace".
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+"std-any-emplace"
+2020/01/19
\ No newline at end of file
diff -pruN 4.3.2-2/RELICENSE/StephaneVales.md 4.3.3-1/RELICENSE/StephaneVales.md
--- 4.3.2-2/RELICENSE/StephaneVales.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/StephaneVales.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Stephane Vales
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "StephaneVales", with
+commit author "Stephane Vales <7755128+stvales@users.noreply.github.com>", are copyright of Stephane Vales.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Stephane Vales
+2020/08/06
diff -pruN 4.3.2-2/RELICENSE/straubar.md 4.3.3-1/RELICENSE/straubar.md
--- 4.3.2-2/RELICENSE/straubar.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/straubar.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Alexander Straub
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "straubar", with
+commit author "Alexander Straub <alexander.straub@visus.uni-stuttgart.de>", are copyright of Alexander Straub.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Alexander Straub
+2019/09/04
diff -pruN 4.3.2-2/RELICENSE/suudy.md 4.3.3-1/RELICENSE/suudy.md
--- 4.3.2-2/RELICENSE/suudy.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/suudy.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,12 @@
+This is a statement by Peter LaDow that grants permission to relicense its
+copyrights in the libzmq C++ library (ZeroMQ) under the Mozilla Public
+License v2 (MPLv2) or any other Open Source Initiative approved license
+chosen by the current ZeroMQ BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "Suudy", with commit
+author "Suudy <pladow@gmail.com>", are copyright of Peter LaDow.  This
+document hereby grants the libzmq project team to relicense libzmq, including
+all past, present and future contributions of the author listed above.
+
+Peter LaDow
+14 August 2019
diff -pruN 4.3.2-2/RELICENSE/tarmo.md 4.3.3-1/RELICENSE/tarmo.md
--- 4.3.2-2/RELICENSE/tarmo.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/tarmo.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Tarmo Tänav that grants permission to
+relicense its copyrights in the libzmq C++ library (ZeroMQ) under the
+Mozilla Public License v2 (MPLv2) or any other Open Source Initiative
+approved license chosen by the current ZeroMQ BDFL (Benevolent
+Dictator for Life).
+
+A portion of the commits made by the Github handle "tarmo", with
+commit author "Tarmo Tänav <tarmo@itech.ee>", are copyright of Tarmo Tänav.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Tarmo Tänav
+2020/08/29
diff -pruN 4.3.2-2/RELICENSE/tberkey.md 4.3.3-1/RELICENSE/tberkey.md
--- 4.3.2-2/RELICENSE/tberkey.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/tberkey.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,14 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Telford Berkey
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "tberkey", with
+commit author "Telford Berkey <tberkey@gmail.com>", are copyright of Telford Berkey.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Telford Berkey
+
+03 Feb 2020
diff -pruN 4.3.2-2/RELICENSE/ThePrez.md 4.3.3-1/RELICENSE/ThePrez.md
--- 4.3.2-2/RELICENSE/ThePrez.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/ThePrez.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Jesse Gorzinski
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "ThePrez", with
+commit author "ThePrez &lt;jgorzinski@gmail.com&gt;", are copyright of Jesse Gorzinski.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Jesse Gorzinski
+2019/10/02
diff -pruN 4.3.2-2/RELICENSE/TobiSchluter.md 4.3.3-1/RELICENSE/TobiSchluter.md
--- 4.3.2-2/RELICENSE/TobiSchluter.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/TobiSchluter.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Tobias Schlter
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+Open Source Initiative approved license chosen by the current ZeroMQ 
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "TobiSchluter", with
+commit author "TobiSchluter", are copyright of Tobias Schlter .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Tobias Schlter
+2019/09/13
diff -pruN 4.3.2-2/RELICENSE/tomzbench.md 4.3.3-1/RELICENSE/tomzbench.md
--- 4.3.2-2/RELICENSE/tomzbench.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/tomzbench.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,14 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Thomas Chiantia
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "tomzbench", with
+commit author "Thomas<Thomas@Altronix.com>", are copyright of
+Thomas Chiantia.
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Thomas Chiantia
+2019/08/10
diff -pruN 4.3.2-2/RELICENSE/trya.md 4.3.3-1/RELICENSE/trya.md
--- 4.3.2-2/RELICENSE/trya.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/trya.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by trya.
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "trya", with
+commit author "trya", are copyright of trya.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+trya
+2019/09/23
diff -pruN 4.3.2-2/RELICENSE/viciious.md 4.3.3-1/RELICENSE/viciious.md
--- 4.3.2-2/RELICENSE/viciious.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/viciious.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Victor Luchits
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "viciious", with
+commit author "Victor Luchits", are copyright of Victor Luchits.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Victor Luchits
+2019/11/12
diff -pruN 4.3.2-2/RELICENSE/xantares.md 4.3.3-1/RELICENSE/xantares.md
--- 4.3.2-2/RELICENSE/xantares.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/xantares.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Ricardo Catalinas Jimenez
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "xantares", with
+commit author "Michel Zou <xantares09@hotmail.com>", are copyright of Michel Zou.
+This document hereby grants the libzmq project team to relicense
+libzmq,
+including all past, present and future contributions of the author
+listed above.
+
+Michel Zou
+2020/02/03
diff -pruN 4.3.2-2/RELICENSE/xqcool.mq 4.3.3-1/RELICENSE/xqcool.mq
--- 4.3.2-2/RELICENSE/xqcool.mq	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/xqcool.mq	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other share-alike OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by xqcool
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other 
+share-alike Open Source Initiative approved license chosen by the current 
+ZeroMQ BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "xqcool", with
+commit author "xqcool <xuquan316@live.com>", are copyright of xqcool .
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+xqcool  
+2020/01/01
diff -pruN 4.3.2-2/RELICENSE/yan12125.md 4.3.3-1/RELICENSE/yan12125.md
--- 4.3.2-2/RELICENSE/yan12125.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/yan12125.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,13 @@
+# Permission to Relicense under MPLv2
+
+This is a statement by Chih-Hsuan Yen
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2).
+
+A portion of the commits made by the Github handle "yan12125", with
+commit author "Chih-Hsuan Yen <yan12125@gmail.com>", are copyright of Chih-Hsuan Yen.
+This document hereby grants the libzmq project team to relicense libzmq, 
+including all past, present and future contributions of the author listed above.
+
+Chih-Hsuan Yen
+2019/10/12
diff -pruN 4.3.2-2/RELICENSE/zoobab.md 4.3.3-1/RELICENSE/zoobab.md
--- 4.3.2-2/RELICENSE/zoobab.md	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/RELICENSE/zoobab.md	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,15 @@
+# Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
+
+This is a statement by Benjamin HENRION
+that grants permission to relicense its copyrights in the libzmq C++
+library (ZeroMQ) under the Mozilla Public License v2 (MPLv2) or any other
+Open Source Initiative approved license chosen by the current ZeroMQ
+BDFL (Benevolent Dictator for Life).
+
+A portion of the commits made by the Github handle "zoobab", with
+commit author "Benjamin HENRION", are copyright of Benjamin HENRION .
+This document hereby grants the libzmq project team to relicense libzmq,
+including all past, present and future contributions of the author listed above.
+
+Benjamin HENRION (zoobab)
+Done in Brussels on the 2020/02/03
diff -pruN 4.3.2-2/SECURITY.md 4.3.3-1/SECURITY.md
--- 4.3.2-2/SECURITY.md	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/SECURITY.md	2020-09-07 10:12:14.000000000 +0000
@@ -6,6 +6,7 @@
 
 | Version | Supported          |
 | ------- | ------------------ |
+| 4.3.x   | :white_check_mark: |
 | 4.2.x   | :white_check_mark: |
 | 4.1.x   | :white_check_mark: |
 | 4.0.x   | :white_check_mark: |
@@ -18,9 +19,32 @@ please send a GPG encrypted email with t
 
 | Maintainer | Email address   | GPG fingerprint |
 | ---------- | --------------- | --------------- |
-| Doron Somech | somdoron@gmail.gom | E0B0 E3D1 55DD 6ED6 71FB  2B79 D0B9 CC44 867D 8F3D |
+| Doron Somech | somdoron@gmail.com | E0B0 E3D1 55DD 6ED6 71FB  2B79 D0B9 CC44 867D 8F3D |
 | Luca Boccassi | luca.boccassi@gmail.com | A9EA 9081 724F FAE0 484C 35A1 A81C EA22 BC8C 7E2E |
 
+## Internal severity classification
+
+We will attempt to follow this general policy when assigning a severity to
+security issues. These are guidelines more than rules, and as such end
+results might vary.
+
+
+| Severity | Definition |
+| -------- | ---------- |
+| CRITICAL | endpoints using STRONG authentication are SILENTLY affected |
+| HIGH | endpoints using STRONG authentication are VISIBLY affected |
+| MODERATE | endpoints NOT using STRONG authentication are SILENTLY affected |
+| LOW | endpoints NOT using STRONG authentication are VISIBLY affected |
+
+STRONG authentication means transports that use cryptography, for example CURVE
+and TLS.
+
+VISIBLY affected means that platform owners are likely to immediately notice
+misbehaviours, like crashes or loss of connectivity for legitimate peers.
+
+SILENTLY affected means that without close inspection, platform owners are
+unlikely to notice misbehaviours, like remote code executions or data exfiltration.
+
 ### Public keys
 <details>
 <summary>Doron Somech</summary>
diff -pruN 4.3.2-2/src/address.cpp 4.3.3-1/src/address.cpp
--- 4.3.2-2/src/address.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/address.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,6 +36,7 @@
 #include "udp_address.hpp"
 #include "ipc_address.hpp"
 #include "tipc_address.hpp"
+#include "ws_address.hpp"
 
 #if defined ZMQ_HAVE_VMCI
 #include "vmci_address.hpp"
@@ -61,8 +62,19 @@ zmq::address_t::~address_t ()
     } else if (protocol == protocol_name::udp) {
         LIBZMQ_DELETE (resolved.udp_addr);
     }
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#ifdef ZMQ_HAVE_WS
+    else if (protocol == protocol_name::ws) {
+        LIBZMQ_DELETE (resolved.ws_addr);
+    }
+#endif
+
+#ifdef ZMQ_HAVE_WSS
+    else if (protocol == protocol_name::wss) {
+        LIBZMQ_DELETE (resolved.ws_addr);
+    }
+#endif
+
+#if defined ZMQ_HAVE_IPC
     else if (protocol == protocol_name::ipc) {
         LIBZMQ_DELETE (resolved.ipc_addr);
     }
@@ -85,8 +97,15 @@ int zmq::address_t::to_string (std::stri
         return resolved.tcp_addr->to_string (addr_);
     if (protocol == protocol_name::udp && resolved.udp_addr)
         return resolved.udp_addr->to_string (addr_);
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#ifdef ZMQ_HAVE_WS
+    if (protocol == protocol_name::ws && resolved.ws_addr)
+        return resolved.ws_addr->to_string (addr_);
+#endif
+#ifdef ZMQ_HAVE_WSS
+    if (protocol == protocol_name::wss && resolved.ws_addr)
+        return resolved.ws_addr->to_string (addr_);
+#endif
+#if defined ZMQ_HAVE_IPC
     if (protocol == protocol_name::ipc && resolved.ipc_addr)
         return resolved.ipc_addr->to_string (addr_);
 #endif
diff -pruN 4.3.2-2/src/address.hpp 4.3.3-1/src/address.hpp
--- 4.3.2-2/src/address.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/address.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -45,7 +45,11 @@ namespace zmq
 class ctx_t;
 class tcp_address_t;
 class udp_address_t;
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS
+class ws_address_t;
+#ifdef ZMQ_HAVE_WSS
+class wss_address_t;
+#endif
+#if defined ZMQ_HAVE_IPC
 class ipc_address_t;
 #endif
 #if defined ZMQ_HAVE_LINUX || defined ZMQ_HAVE_VXWORKS
@@ -60,8 +64,20 @@ namespace protocol_name
 static const char inproc[] = "inproc";
 static const char tcp[] = "tcp";
 static const char udp[] = "udp";
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#ifdef ZMQ_HAVE_OPENPGM
+static const char pgm[] = "pgm";
+static const char epgm[] = "epgm";
+#endif
+#ifdef ZMQ_HAVE_NORM
+static const char norm[] = "norm";
+#endif
+#ifdef ZMQ_HAVE_WS
+static const char ws[] = "ws";
+#endif
+#ifdef ZMQ_HAVE_WSS
+static const char wss[] = "wss";
+#endif
+#if defined ZMQ_HAVE_IPC
 static const char ipc[] = "ipc";
 #endif
 #if defined ZMQ_HAVE_TIPC
@@ -91,8 +107,13 @@ struct address_t
         void *dummy;
         tcp_address_t *tcp_addr;
         udp_address_t *udp_addr;
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#ifdef ZMQ_HAVE_WS
+        ws_address_t *ws_addr;
+#endif
+#ifdef ZMQ_HAVE_WSS
+        wss_address_t *wss_addr;
+#endif
+#if defined ZMQ_HAVE_IPC
         ipc_address_t *ipc_addr;
 #endif
 #if defined ZMQ_HAVE_LINUX || defined ZMQ_HAVE_VXWORKS
diff -pruN 4.3.2-2/src/array.hpp 4.3.3-1/src/array.hpp
--- 4.3.2-2/src/array.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/array.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -33,6 +33,8 @@
 #include <vector>
 #include <algorithm>
 
+#include "macros.hpp"
+
 namespace zmq
 {
 //  Implementation of fast arrays with O(1) access, insertion and
@@ -51,21 +53,20 @@ namespace zmq
 template <int ID = 0> class array_item_t
 {
   public:
-    inline array_item_t () : _array_index (-1) {}
+    array_item_t () : _array_index (-1) {}
 
     //  The destructor doesn't have to be virtual. It is made virtual
     //  just to keep ICC and code checking tools from complaining.
-    inline virtual ~array_item_t () {}
+    virtual ~array_item_t () ZMQ_DEFAULT;
 
-    inline void set_array_index (int index_) { _array_index = index_; }
+    void set_array_index (int index_) { _array_index = index_; }
 
-    inline int get_array_index () { return _array_index; }
+    int get_array_index () const { return _array_index; }
 
   private:
     int _array_index;
 
-    array_item_t (const array_item_t &);
-    const array_item_t &operator= (const array_item_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (array_item_t)
 };
 
 
@@ -77,58 +78,62 @@ template <typename T, int ID = 0> class
   public:
     typedef typename std::vector<T *>::size_type size_type;
 
-    inline array_t () {}
-
-    inline ~array_t () {}
+    array_t () ZMQ_DEFAULT;
 
-    inline size_type size () { return _items.size (); }
+    size_type size () { return _items.size (); }
 
-    inline bool empty () { return _items.empty (); }
+    bool empty () { return _items.empty (); }
 
-    inline T *&operator[] (size_type index_) { return _items[index_]; }
+    T *&operator[] (size_type index_) { return _items[index_]; }
 
-    inline void push_back (T *item_)
+    void push_back (T *item_)
     {
         if (item_)
-            ((item_t *) item_)->set_array_index ((int) _items.size ());
+            static_cast<item_t *> (item_)->set_array_index (
+              static_cast<int> (_items.size ()));
         _items.push_back (item_);
     }
 
-    inline void erase (T *item_)
+    void erase (T *item_)
     {
-        erase (((item_t *) item_)->get_array_index ());
+        erase (static_cast<item_t *> (item_)->get_array_index ());
     }
 
-    inline void erase (size_type index_)
+    void erase (size_type index_)
     {
-        if (_items.back ())
-            ((item_t *) _items.back ())->set_array_index ((int) index_);
+        if (_items.empty ())
+            return;
+        static_cast<item_t *> (_items.back ())
+          ->set_array_index (static_cast<int> (index_));
+
         _items[index_] = _items.back ();
         _items.pop_back ();
     }
 
-    inline void swap (size_type index1_, size_type index2_)
+    void swap (size_type index1_, size_type index2_)
     {
         if (_items[index1_])
-            ((item_t *) _items[index1_])->set_array_index ((int) index2_);
+            static_cast<item_t *> (_items[index1_])
+              ->set_array_index (static_cast<int> (index2_));
         if (_items[index2_])
-            ((item_t *) _items[index2_])->set_array_index ((int) index1_);
+            static_cast<item_t *> (_items[index2_])
+              ->set_array_index (static_cast<int> (index1_));
         std::swap (_items[index1_], _items[index2_]);
     }
 
-    inline void clear () { _items.clear (); }
+    void clear () { _items.clear (); }
 
-    inline size_type index (T *item_)
+    static size_type index (T *item_)
     {
-        return (size_type) ((item_t *) item_)->get_array_index ();
+        return static_cast<size_type> (
+          static_cast<item_t *> (item_)->get_array_index ());
     }
 
   private:
     typedef std::vector<T *> items_t;
     items_t _items;
 
-    array_t (const array_t &);
-    const array_t &operator= (const array_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (array_t)
 };
 }
 
diff -pruN 4.3.2-2/src/atomic_counter.hpp 4.3.3-1/src/atomic_counter.hpp
--- 4.3.2-2/src/atomic_counter.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/atomic_counter.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -91,16 +91,13 @@ class atomic_counter_t
   public:
     typedef uint32_t integer_t;
 
-    inline atomic_counter_t (integer_t value_ = 0) ZMQ_NOEXCEPT
-        : _value (value_)
-    {
-    }
+    atomic_counter_t (integer_t value_ = 0) ZMQ_NOEXCEPT : _value (value_) {}
 
     //  Set counter _value (not thread-safe).
-    inline void set (integer_t value_) ZMQ_NOEXCEPT { _value = value_; }
+    void set (integer_t value_) ZMQ_NOEXCEPT { _value = value_; }
 
     //  Atomic addition. Returns the old _value.
-    inline integer_t add (integer_t increment_) ZMQ_NOEXCEPT
+    integer_t add (integer_t increment_) ZMQ_NOEXCEPT
     {
         integer_t old_value;
 
@@ -145,7 +142,7 @@ class atomic_counter_t
     }
 
     //  Atomic subtraction. Returns false if the counter drops to zero.
-    inline bool sub (integer_t decrement_) ZMQ_NOEXCEPT
+    bool sub (integer_t decrement_) ZMQ_NOEXCEPT
     {
 #if defined ZMQ_ATOMIC_COUNTER_WINDOWS
         LONG delta = -((LONG) decrement_);
@@ -156,7 +153,7 @@ class atomic_counter_t
           __atomic_sub_fetch (&_value, decrement_, __ATOMIC_ACQ_REL);
         return nv != 0;
 #elif defined ZMQ_ATOMIC_COUNTER_CXX11
-        integer_t old =
+        const integer_t old =
           _value.fetch_sub (decrement_, std::memory_order_acq_rel);
         return old - decrement_ != 0;
 #elif defined ZMQ_ATOMIC_COUNTER_ATOMIC_H
@@ -200,7 +197,7 @@ class atomic_counter_t
 #endif
     }
 
-    inline integer_t get () const ZMQ_NOEXCEPT { return _value; }
+    integer_t get () const ZMQ_NOEXCEPT { return _value; }
 
   private:
 #if defined ZMQ_ATOMIC_COUNTER_CXX11
@@ -214,8 +211,7 @@ class atomic_counter_t
 #endif
 
 #if !defined ZMQ_ATOMIC_COUNTER_CXX11
-    atomic_counter_t (const atomic_counter_t &);
-    const atomic_counter_t &operator= (const atomic_counter_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (atomic_counter_t)
 #endif
 #if defined(__GNUC__) || defined(__INTEL_COMPILER)                             \
   || (defined(__SUNPRO_C) && __SUNPRO_C >= 0x590)                              \
diff -pruN 4.3.2-2/src/atomic_ptr.hpp 4.3.3-1/src/atomic_ptr.hpp
--- 4.3.2-2/src/atomic_ptr.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/atomic_ptr.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -178,16 +178,16 @@ template <typename T> class atomic_ptr_t
 {
   public:
     //  Initialise atomic pointer
-    inline atomic_ptr_t () ZMQ_NOEXCEPT { _ptr = NULL; }
+    atomic_ptr_t () ZMQ_NOEXCEPT { _ptr = NULL; }
 
     //  Set value of atomic pointer in a non-threadsafe way
     //  Use this function only when you are sure that at most one
     //  thread is accessing the pointer at the moment.
-    inline void set (T *ptr_) ZMQ_NOEXCEPT { _ptr = ptr_; }
+    void set (T *ptr_) ZMQ_NOEXCEPT { _ptr = ptr_; }
 
     //  Perform atomic 'exchange pointers' operation. Pointer is set
     //  to the 'val_' value. Old value is returned.
-    inline T *xchg (T *val_) ZMQ_NOEXCEPT
+    T *xchg (T *val_) ZMQ_NOEXCEPT
     {
 #if defined ZMQ_ATOMIC_PTR_CXX11
         return _ptr.exchange (val_, std::memory_order_acq_rel);
@@ -205,7 +205,7 @@ template <typename T> class atomic_ptr_t
     //  The pointer is compared to 'cmp' argument and if they are
     //  equal, its value is set to 'val_'. Old value of the pointer
     //  is returned.
-    inline T *cas (T *cmp_, T *val_) ZMQ_NOEXCEPT
+    T *cas (T *cmp_, T *val_) ZMQ_NOEXCEPT
     {
 #if defined ZMQ_ATOMIC_PTR_CXX11
         _ptr.compare_exchange_strong (cmp_, val_, std::memory_order_acq_rel);
@@ -232,8 +232,7 @@ template <typename T> class atomic_ptr_t
 #endif
 
 #if !defined ZMQ_ATOMIC_PTR_CXX11
-    atomic_ptr_t (const atomic_ptr_t &);
-    const atomic_ptr_t &operator= (const atomic_ptr_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (atomic_ptr_t)
 #endif
 };
 
diff -pruN 4.3.2-2/src/channel.cpp 4.3.3-1/src/channel.cpp
--- 4.3.2-2/src/channel.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/channel.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,160 @@
+/*
+    Copyright (c) 2007-2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include "macros.hpp"
+#include "channel.hpp"
+#include "err.hpp"
+#include "pipe.hpp"
+#include "msg.hpp"
+
+zmq::channel_t::channel_t (class ctx_t *parent_, uint32_t tid_, int sid_) :
+    socket_base_t (parent_, tid_, sid_, true),
+    _pipe (NULL)
+{
+    options.type = ZMQ_CHANNEL;
+}
+
+zmq::channel_t::~channel_t ()
+{
+    zmq_assert (!_pipe);
+}
+
+void zmq::channel_t::xattach_pipe (pipe_t *pipe_,
+                                   bool subscribe_to_all_,
+                                   bool locally_initiated_)
+{
+    LIBZMQ_UNUSED (subscribe_to_all_);
+    LIBZMQ_UNUSED (locally_initiated_);
+
+    zmq_assert (pipe_ != NULL);
+
+    //  ZMQ_PAIR socket can only be connected to a single peer.
+    //  The socket rejects any further connection requests.
+    if (_pipe == NULL)
+        _pipe = pipe_;
+    else
+        pipe_->terminate (false);
+}
+
+void zmq::channel_t::xpipe_terminated (pipe_t *pipe_)
+{
+    if (pipe_ == _pipe)
+        _pipe = NULL;
+}
+
+void zmq::channel_t::xread_activated (pipe_t *)
+{
+    //  There's just one pipe. No lists of active and inactive pipes.
+    //  There's nothing to do here.
+}
+
+void zmq::channel_t::xwrite_activated (pipe_t *)
+{
+    //  There's just one pipe. No lists of active and inactive pipes.
+    //  There's nothing to do here.
+}
+
+int zmq::channel_t::xsend (msg_t *msg_)
+{
+    //  CHANNEL sockets do not allow multipart data (ZMQ_SNDMORE)
+    if (msg_->flags () & msg_t::more) {
+        errno = EINVAL;
+        return -1;
+    }
+
+    if (!_pipe || !_pipe->write (msg_)) {
+        errno = EAGAIN;
+        return -1;
+    }
+
+    _pipe->flush ();
+
+    //  Detach the original message from the data buffer.
+    const int rc = msg_->init ();
+    errno_assert (rc == 0);
+
+    return 0;
+}
+
+int zmq::channel_t::xrecv (msg_t *msg_)
+{
+    //  Deallocate old content of the message.
+    int rc = msg_->close ();
+    errno_assert (rc == 0);
+
+    if (!_pipe) {
+        //  Initialise the output parameter to be a 0-byte message.
+        rc = msg_->init ();
+        errno_assert (rc == 0);
+
+        errno = EAGAIN;
+        return -1;
+    }
+
+    // Drop any messages with more flag
+    bool read = _pipe->read (msg_);
+    while (read && msg_->flags () & msg_t::more) {
+        // drop all frames of the current multi-frame message
+        read = _pipe->read (msg_);
+        while (read && msg_->flags () & msg_t::more)
+            read = _pipe->read (msg_);
+
+        // get the new message
+        if (read)
+            read = _pipe->read (msg_);
+    }
+
+    if (!read) {
+        //  Initialise the output parameter to be a 0-byte message.
+        rc = msg_->init ();
+        errno_assert (rc == 0);
+
+        errno = EAGAIN;
+        return -1;
+    }
+
+    return 0;
+}
+
+bool zmq::channel_t::xhas_in ()
+{
+    if (!_pipe)
+        return false;
+
+    return _pipe->check_read ();
+}
+
+bool zmq::channel_t::xhas_out ()
+{
+    if (!_pipe)
+        return false;
+
+    return _pipe->check_write ();
+}
diff -pruN 4.3.2-2/src/channel.hpp 4.3.3-1/src/channel.hpp
--- 4.3.2-2/src/channel.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/channel.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,69 @@
+/*
+    Copyright (c) 2007-2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_CHANNEL_HPP_INCLUDED__
+#define __ZMQ_CHANNEL_HPP_INCLUDED__
+
+#include "blob.hpp"
+#include "socket_base.hpp"
+#include "session_base.hpp"
+
+namespace zmq
+{
+class ctx_t;
+class msg_t;
+class pipe_t;
+class io_thread_t;
+
+class channel_t ZMQ_FINAL : public socket_base_t
+{
+  public:
+    channel_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
+    ~channel_t ();
+
+    //  Overrides of functions from socket_base_t.
+    void xattach_pipe (zmq::pipe_t *pipe_,
+                       bool subscribe_to_all_,
+                       bool locally_initiated_);
+    int xsend (zmq::msg_t *msg_);
+    int xrecv (zmq::msg_t *msg_);
+    bool xhas_in ();
+    bool xhas_out ();
+    void xread_activated (zmq::pipe_t *pipe_);
+    void xwrite_activated (zmq::pipe_t *pipe_);
+    void xpipe_terminated (zmq::pipe_t *pipe_);
+
+  private:
+    zmq::pipe_t *_pipe;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (channel_t)
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/client.cpp 4.3.3-1/src/client.cpp
--- 4.3.2-2/src/client.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/client.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -37,6 +37,7 @@ zmq::client_t::client_t (class ctx_t *pa
     socket_base_t (parent_, tid_, sid_, true)
 {
     options.type = ZMQ_CLIENT;
+    options.can_send_hello_msg = true;
 }
 
 zmq::client_t::~client_t ()
diff -pruN 4.3.2-2/src/client.hpp 4.3.3-1/src/client.hpp
--- 4.3.2-2/src/client.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/client.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,7 @@ class msg_t;
 class pipe_t;
 class io_thread_t;
 
-class client_t : public socket_base_t
+class client_t ZMQ_FINAL : public socket_base_t
 {
   public:
     client_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -66,8 +66,7 @@ class client_t : public socket_base_t
     fq_t _fq;
     lb_t _lb;
 
-    client_t (const client_t &);
-    const client_t &operator= (const client_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (client_t)
 };
 }
 
diff -pruN 4.3.2-2/src/clock.cpp 4.3.3-1/src/clock.cpp
--- 4.3.2-2/src/clock.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/clock.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,6 +41,9 @@
 #include <cmnintrin.h>
 #else
 #include <intrin.h>
+#if defined(_M_ARM) || defined(_M_ARM64)
+#include <arm_neon.h>
+#endif
 #endif
 #endif
 
@@ -103,7 +106,7 @@ f_compatible_get_tick_count64 init_compa
     f_compatible_get_tick_count64 func = NULL;
 #if !defined ZMQ_HAVE_WINDOWS_UWP
 
-    HMODULE module = ::LoadLibraryA ("Kernel32.dll");
+    const HMODULE module = ::LoadLibraryA ("Kernel32.dll");
     if (module != NULL)
         func = reinterpret_cast<f_compatible_get_tick_count64> (
           ::GetProcAddress (module, "GetTickCount64"));
@@ -112,7 +115,8 @@ f_compatible_get_tick_count64 init_compa
         func = compatible_get_tick_count64;
 
 #if !defined ZMQ_HAVE_WINDOWS_UWP
-    ::FreeLibrary (module);
+    if (module != NULL)
+        ::FreeLibrary (module);
 #endif
 
     return func;
@@ -200,7 +204,7 @@ uint64_t zmq::clock_t::now_us ()
 
 uint64_t zmq::clock_t::now_ms ()
 {
-    uint64_t tsc = rdtsc ();
+    const uint64_t tsc = rdtsc ();
 
     //  If TSC is not supported, get precise time and chop off the microseconds.
     if (!tsc) {
@@ -234,6 +238,14 @@ uint64_t zmq::clock_t::rdtsc ()
 {
 #if (defined _MSC_VER && (defined _M_IX86 || defined _M_X64))
     return __rdtsc ();
+#elif defined(_MSC_VER) && defined(_M_ARM)   // NC => added for windows ARM
+    return __rdpmccntr64 ();
+#elif defined(_MSC_VER) && defined(_M_ARM64) // NC => added for windows ARM64
+    //return __rdpmccntr64 ();
+    //return __rdtscp (nullptr);
+    // todo: find proper implementation for ARM64
+    static uint64_t snCounter = 0;
+    return ++snCounter;
 #elif (defined __GNUC__ && (defined __i386__ || defined __x86_64__))
     uint32_t low, high;
     __asm__ volatile("rdtsc" : "=a"(low), "=d"(high));
diff -pruN 4.3.2-2/src/clock.hpp 4.3.3-1/src/clock.hpp
--- 4.3.2-2/src/clock.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/clock.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,6 +30,7 @@
 #ifndef __ZMQ_CLOCK_HPP_INCLUDED__
 #define __ZMQ_CLOCK_HPP_INCLUDED__
 
+#include "macros.hpp"
 #include "stdint.hpp"
 
 #if defined ZMQ_HAVE_OSX
@@ -72,8 +73,7 @@ class clock_t
     //  Physical time corresponding to the TSC above (in milliseconds).
     uint64_t _last_time;
 
-    clock_t (const clock_t &);
-    const clock_t &operator= (const clock_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (clock_t)
 };
 }
 
diff -pruN 4.3.2-2/src/command.hpp 4.3.3-1/src/command.hpp
--- 4.3.2-2/src/command.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/command.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -74,6 +74,7 @@ __declspec(align (64))
         reap,
         reaped,
         inproc_connected,
+        conn_failed,
         pipe_peer_stats,
         pipe_stats_publish,
         done
diff -pruN 4.3.2-2/src/compat.hpp 4.3.3-1/src/compat.hpp
--- 4.3.2-2/src/compat.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/compat.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,73 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_COMPAT_HPP_INCLUDED__
+#define __ZMQ_COMPAT_HPP_INCLUDED__
+
+#include "precompiled.hpp"
+#include <string.h>
+
+#ifdef ZMQ_HAVE_WINDOWS
+#define strcasecmp _stricmp
+#define strtok_r strtok_s
+#else
+#ifdef ZMQ_HAVE_LIBBSD
+#include <bsd/string.h>
+#elif !defined(ZMQ_HAVE_STRLCPY)
+static inline size_t
+strlcpy (char *dest_, const char *src_, const size_t dest_size_)
+{
+    size_t remain = dest_size_;
+    for (; remain && *src_; --remain, ++src_, ++dest_) {
+        *dest_ = *src_;
+    }
+    return dest_size_ - remain;
+}
+#endif
+template <size_t size>
+static inline int strcpy_s (char (&dest_)[size], const char *const src_)
+{
+    const size_t res = strlcpy (dest_, src_, size);
+    return res >= size ? ERANGE : 0;
+}
+#endif
+
+#ifndef HAVE_STRNLEN
+static inline size_t strnlen (const char *s, size_t len)
+{
+    for (size_t i = 0; i < len; i++) {
+        if (s[i] == '\0')
+            return i + 1;
+    }
+
+    return len;
+}
+#endif
+
+#endif
diff -pruN 4.3.2-2/src/condition_variable.hpp 4.3.3-1/src/condition_variable.hpp
--- 4.3.2-2/src/condition_variable.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/condition_variable.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -44,8 +44,6 @@ class condition_variable_t
   public:
     inline condition_variable_t () { zmq_assert (false); }
 
-    inline ~condition_variable_t () {}
-
     inline int wait (mutex_t *mutex_, int timeout_)
     {
         zmq_assert (false);
@@ -54,10 +52,7 @@ class condition_variable_t
 
     inline void broadcast () { zmq_assert (false); }
 
-  private:
-    //  Disable copy construction and assignment.
-    condition_variable_t (const condition_variable_t &);
-    void operator= (const condition_variable_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (condition_variable_t)
 };
 }
 
@@ -72,8 +67,6 @@ class condition_variable_t
   public:
     inline condition_variable_t () { InitializeConditionVariable (&_cv); }
 
-    inline ~condition_variable_t () {}
-
     inline int wait (mutex_t *mutex_, int timeout_)
     {
         int rc = SleepConditionVariableCS (&_cv, mutex_->get_cs (), timeout_);
@@ -95,9 +88,7 @@ class condition_variable_t
   private:
     CONDITION_VARIABLE _cv;
 
-    //  Disable copy construction and assignment.
-    condition_variable_t (const condition_variable_t &);
-    void operator= (const condition_variable_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (condition_variable_t)
 };
 }
 
@@ -110,11 +101,9 @@ namespace zmq
 class condition_variable_t
 {
   public:
-    inline condition_variable_t () {}
+    condition_variable_t () ZMQ_DEFAULT;
 
-    inline ~condition_variable_t () {}
-
-    inline int wait (mutex_t *mutex_, int timeout_)
+    int wait (mutex_t *mutex_, int timeout_)
     {
         // this assumes that the mutex mutex_ has been locked by the caller
         int res = 0;
@@ -130,7 +119,7 @@ class condition_variable_t
         return res;
     }
 
-    inline void broadcast ()
+    void broadcast ()
     {
         // this assumes that the mutex associated with _cv has been locked by the caller
         _cv.notify_all ();
@@ -139,9 +128,7 @@ class condition_variable_t
   private:
     std::condition_variable_any _cv;
 
-    //  Disable copy construction and assignment.
-    condition_variable_t (const condition_variable_t &);
-    void operator= (const condition_variable_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (condition_variable_t)
 };
 }
 
@@ -154,7 +141,7 @@ namespace zmq
 class condition_variable_t
 {
   public:
-    inline condition_variable_t () {}
+    inline condition_variable_t () ZMQ_DEFAULT;
 
     inline ~condition_variable_t ()
     {
@@ -224,9 +211,7 @@ class condition_variable_t
     mutex_t _listenersMutex;
     std::vector<SEM_ID> _listeners;
 
-    // Disable copy construction and assignment.
-    condition_variable_t (const condition_variable_t &);
-    const condition_variable_t &operator= (const condition_variable_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (condition_variable_t)
 };
 }
 
@@ -274,13 +259,14 @@ class condition_variable_t
             timeout.tv_sec = 0;
             timeout.tv_nsec = 0;
 #else
-            clock_gettime (CLOCK_MONOTONIC, &timeout);
+            rc = clock_gettime (CLOCK_MONOTONIC, &timeout);
+            posix_assert (rc);
 #endif
 
             timeout.tv_sec += timeout_ / 1000;
             timeout.tv_nsec += (timeout_ % 1000) * 1000000;
 
-            if (timeout.tv_nsec > 1000000000) {
+            if (timeout.tv_nsec >= 1000000000) {
                 timeout.tv_sec++;
                 timeout.tv_nsec -= 1000000000;
             }
@@ -318,9 +304,7 @@ class condition_variable_t
   private:
     pthread_cond_t _cond;
 
-    // Disable copy construction and assignment.
-    condition_variable_t (const condition_variable_t &);
-    const condition_variable_t &operator= (const condition_variable_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (condition_variable_t)
 };
 }
 
diff -pruN 4.3.2-2/src/ctx.cpp 4.3.3-1/src/ctx.cpp
--- 4.3.2-2/src/ctx.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ctx.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -52,10 +52,18 @@
 #include <vmci_sockets.h>
 #endif
 
+#ifdef ZMQ_USE_NSS
+#include <nss.h>
+#endif
+
+#ifdef ZMQ_USE_GNUTLS
+#include <gnutls/gnutls.h>
+#endif
+
 #define ZMQ_CTX_TAG_VALUE_GOOD 0xabadcafe
 #define ZMQ_CTX_TAG_VALUE_BAD 0xdeadbeef
 
-int clipped_maxsocket (int max_requested_)
+static int clipped_maxsocket (int max_requested_)
 {
     if (max_requested_ >= zmq::poller_t::max_fds ()
         && zmq::poller_t::max_fds () != -1)
@@ -87,9 +95,17 @@ zmq::ctx_t::ctx_t () :
 
     //  Initialise crypto library, if needed.
     zmq::random_open ();
+
+#ifdef ZMQ_USE_NSS
+    NSS_NoDB_Init (NULL);
+#endif
+
+#ifdef ZMQ_USE_GNUTLS
+    gnutls_global_init ();
+#endif
 }
 
-bool zmq::ctx_t::check_tag ()
+bool zmq::ctx_t::check_tag () const
 {
     return _tag == ZMQ_CTX_TAG_VALUE_GOOD;
 }
@@ -101,12 +117,13 @@ zmq::ctx_t::~ctx_t ()
 
     //  Ask I/O threads to terminate. If stop signal wasn't sent to I/O
     //  thread subsequent invocation of destructor would hang-up.
-    for (io_threads_t::size_type i = 0; i != _io_threads.size (); i++) {
+    const io_threads_t::size_type io_threads_size = _io_threads.size ();
+    for (io_threads_t::size_type i = 0; i != io_threads_size; i++) {
         _io_threads[i]->stop ();
     }
 
     //  Wait till I/O threads actually terminate.
-    for (io_threads_t::size_type i = 0; i != _io_threads.size (); i++) {
+    for (io_threads_t::size_type i = 0; i != io_threads_size; i++) {
         LIBZMQ_DELETE (_io_threads[i]);
     }
 
@@ -119,6 +136,14 @@ zmq::ctx_t::~ctx_t ()
     //  De-initialise crypto library, if needed.
     zmq::random_close ();
 
+#ifdef ZMQ_USE_NSS
+    NSS_Shutdown ();
+#endif
+
+#ifdef ZMQ_USE_GNUTLS
+    gnutls_global_deinit ();
+#endif
+
     //  Remove the tag, so that the object is considered dead.
     _tag = ZMQ_CTX_TAG_VALUE_BAD;
 }
@@ -132,7 +157,7 @@ int zmq::ctx_t::terminate ()
 {
     _slot_sync.lock ();
 
-    bool save_terminating = _terminating;
+    const bool save_terminating = _terminating;
     _terminating = false;
 
     // Connect up any pending inproc connections, otherwise we will hang
@@ -152,16 +177,17 @@ int zmq::ctx_t::terminate ()
         if (_pid != getpid ()) {
             // we are a forked child process. Close all file descriptors
             // inherited from the parent.
-            for (sockets_t::size_type i = 0; i != _sockets.size (); i++)
+            for (sockets_t::size_type i = 0, size = _sockets.size (); i != size;
+                 i++) {
                 _sockets[i]->get_mailbox ()->forked ();
-
+            }
             _term_mailbox.forked ();
         }
 #endif
 
         //  Check whether termination was already underway, but interrupted and now
         //  restarted.
-        bool restarted = _terminating;
+        const bool restarted = _terminating;
         _terminating = true;
 
         //  First attempt to terminate the context.
@@ -169,8 +195,10 @@ int zmq::ctx_t::terminate ()
             //  First send stop command to sockets so that any blocking calls
             //  can be interrupted. If there are no sockets we can ask reaper
             //  thread to stop.
-            for (sockets_t::size_type i = 0; i != _sockets.size (); i++)
+            for (sockets_t::size_type i = 0, size = _sockets.size (); i != size;
+                 i++) {
                 _sockets[i]->stop ();
+            }
             if (_sockets.empty ())
                 _reaper->stop ();
         }
@@ -178,7 +206,7 @@ int zmq::ctx_t::terminate ()
 
         //  Wait till reaper thread closes all the sockets.
         command_t cmd;
-        int rc = _term_mailbox.recv (&cmd, -1);
+        const int rc = _term_mailbox.recv (&cmd, -1);
         if (rc == -1 && errno == EINTR)
             return -1;
         errno_assert (rc == 0);
@@ -208,72 +236,171 @@ int zmq::ctx_t::shutdown ()
 {
     scoped_lock_t locker (_slot_sync);
 
-    if (!_starting && !_terminating) {
+    if (!_terminating) {
         _terminating = true;
 
-        //  Send stop command to sockets so that any blocking calls
-        //  can be interrupted. If there are no sockets we can ask reaper
-        //  thread to stop.
-        for (sockets_t::size_type i = 0; i != _sockets.size (); i++)
-            _sockets[i]->stop ();
-        if (_sockets.empty ())
-            _reaper->stop ();
+        if (!_starting) {
+            //  Send stop command to sockets so that any blocking calls
+            //  can be interrupted. If there are no sockets we can ask reaper
+            //  thread to stop.
+            for (sockets_t::size_type i = 0, size = _sockets.size (); i != size;
+                 i++) {
+                _sockets[i]->stop ();
+            }
+            if (_sockets.empty ())
+                _reaper->stop ();
+        }
     }
 
     return 0;
 }
 
-int zmq::ctx_t::set (int option_, int optval_)
+int zmq::ctx_t::set (int option_, const void *optval_, size_t optvallen_)
 {
-    int rc = 0;
-    if (option_ == ZMQ_MAX_SOCKETS && optval_ >= 1
-        && optval_ == clipped_maxsocket (optval_)) {
-        scoped_lock_t locker (_opt_sync);
-        _max_sockets = optval_;
-    } else if (option_ == ZMQ_IO_THREADS && optval_ >= 0) {
-        scoped_lock_t locker (_opt_sync);
-        _io_thread_count = optval_;
-    } else if (option_ == ZMQ_IPV6 && optval_ >= 0) {
-        scoped_lock_t locker (_opt_sync);
-        _ipv6 = (optval_ != 0);
-    } else if (option_ == ZMQ_BLOCKY && optval_ >= 0) {
-        scoped_lock_t locker (_opt_sync);
-        _blocky = (optval_ != 0);
-    } else if (option_ == ZMQ_MAX_MSGSZ && optval_ >= 0) {
-        scoped_lock_t locker (_opt_sync);
-        _max_msgsz = optval_ < INT_MAX ? optval_ : INT_MAX;
-    } else if (option_ == ZMQ_ZERO_COPY_RECV && optval_ >= 0) {
-        scoped_lock_t locker (_opt_sync);
-        _zero_copy = (optval_ != 0);
-    } else {
-        rc = thread_ctx_t::set (option_, optval_);
+    const bool is_int = (optvallen_ == sizeof (int));
+    int value = 0;
+    if (is_int)
+        memcpy (&value, optval_, sizeof (int));
+
+    switch (option_) {
+        case ZMQ_MAX_SOCKETS:
+            if (is_int && value >= 1 && value == clipped_maxsocket (value)) {
+                scoped_lock_t locker (_opt_sync);
+                _max_sockets = value;
+                return 0;
+            }
+            break;
+
+        case ZMQ_IO_THREADS:
+            if (is_int && value >= 0) {
+                scoped_lock_t locker (_opt_sync);
+                _io_thread_count = value;
+                return 0;
+            }
+            break;
+
+        case ZMQ_IPV6:
+            if (is_int && value >= 0) {
+                scoped_lock_t locker (_opt_sync);
+                _ipv6 = (value != 0);
+                return 0;
+            }
+            break;
+
+        case ZMQ_BLOCKY:
+            if (is_int && value >= 0) {
+                scoped_lock_t locker (_opt_sync);
+                _blocky = (value != 0);
+                return 0;
+            }
+            break;
+
+        case ZMQ_MAX_MSGSZ:
+            if (is_int && value >= 0) {
+                scoped_lock_t locker (_opt_sync);
+                _max_msgsz = value < INT_MAX ? value : INT_MAX;
+                return 0;
+            }
+            break;
+
+        case ZMQ_ZERO_COPY_RECV:
+            if (is_int && value >= 0) {
+                scoped_lock_t locker (_opt_sync);
+                _zero_copy = (value != 0);
+                return 0;
+            }
+            break;
+
+        default: {
+            return thread_ctx_t::set (option_, optval_, optvallen_);
+        }
     }
-    return rc;
+
+    errno = EINVAL;
+    return -1;
 }
 
-int zmq::ctx_t::get (int option_)
+int zmq::ctx_t::get (int option_, void *optval_, const size_t *optvallen_)
 {
-    int rc = 0;
-    if (option_ == ZMQ_MAX_SOCKETS)
-        rc = _max_sockets;
-    else if (option_ == ZMQ_SOCKET_LIMIT)
-        rc = clipped_maxsocket (65535);
-    else if (option_ == ZMQ_IO_THREADS)
-        rc = _io_thread_count;
-    else if (option_ == ZMQ_IPV6)
-        rc = _ipv6;
-    else if (option_ == ZMQ_BLOCKY)
-        rc = _blocky;
-    else if (option_ == ZMQ_MAX_MSGSZ)
-        rc = _max_msgsz;
-    else if (option_ == ZMQ_MSG_T_SIZE)
-        rc = sizeof (zmq_msg_t);
-    else if (option_ == ZMQ_ZERO_COPY_RECV) {
-        rc = _zero_copy;
-    } else {
-        rc = thread_ctx_t::get (option_);
+    const bool is_int = (*optvallen_ == sizeof (int));
+    int *value = static_cast<int *> (optval_);
+
+    switch (option_) {
+        case ZMQ_MAX_SOCKETS:
+            if (is_int) {
+                *value = _max_sockets;
+                return 0;
+            }
+            break;
+
+        case ZMQ_SOCKET_LIMIT:
+            if (is_int) {
+                *value = clipped_maxsocket (65535);
+                return 0;
+            }
+            break;
+
+        case ZMQ_IO_THREADS:
+            if (is_int) {
+                *value = _io_thread_count;
+                return 0;
+            }
+            break;
+
+        case ZMQ_IPV6:
+            if (is_int) {
+                *value = _ipv6;
+                return 0;
+            }
+            break;
+
+        case ZMQ_BLOCKY:
+            if (is_int) {
+                *value = _blocky;
+                return 0;
+            }
+            break;
+
+        case ZMQ_MAX_MSGSZ:
+            if (is_int) {
+                *value = _max_msgsz;
+                return 0;
+            }
+            break;
+
+        case ZMQ_MSG_T_SIZE:
+            if (is_int) {
+                *value = sizeof (zmq_msg_t);
+                return 0;
+            }
+            break;
+
+        case ZMQ_ZERO_COPY_RECV:
+            if (is_int) {
+                *value = _zero_copy;
+                return 0;
+            }
+            break;
+
+        default: {
+            return thread_ctx_t::get (option_, optval_, optvallen_);
+        }
     }
-    return rc;
+
+    errno = EINVAL;
+    return -1;
+}
+
+int zmq::ctx_t::get (int option_)
+{
+    int optval = 0;
+    size_t optvallen = sizeof (int);
+
+    if (get (option_, &optval, &optvallen) == 0)
+        return optval;
+
+    errno = EINVAL;
+    return -1;
 }
 
 bool zmq::ctx_t::start ()
@@ -285,7 +412,7 @@ bool zmq::ctx_t::start ()
     const int mazmq = _max_sockets;
     const int ios = _io_thread_count;
     _opt_sync.unlock ();
-    int slot_count = mazmq + ios + term_and_reaper_threads_count;
+    const int slot_count = mazmq + ios + term_and_reaper_threads_count;
     try {
         _slots.reserve (slot_count);
         _empty_slots.reserve (slot_count - term_and_reaper_threads_count);
@@ -352,17 +479,18 @@ zmq::socket_base_t *zmq::ctx_t::create_s
 {
     scoped_lock_t locker (_slot_sync);
 
-    if (unlikely (_starting)) {
-        if (!start ())
-            return NULL;
-    }
-
-    //  Once zmq_ctx_term() was called, we can't create new sockets.
+    //  Once zmq_ctx_term() or zmq_ctx_shutdown() was called, we can't create
+    //  new sockets.
     if (_terminating) {
         errno = ETERM;
         return NULL;
     }
 
+    if (unlikely (_starting)) {
+        if (!start ())
+            return NULL;
+    }
+
     //  If max_sockets limit was reached, return error.
     if (_empty_slots.empty ()) {
         errno = EMFILE;
@@ -370,11 +498,11 @@ zmq::socket_base_t *zmq::ctx_t::create_s
     }
 
     //  Choose a slot for the socket.
-    uint32_t slot = _empty_slots.back ();
+    const uint32_t slot = _empty_slots.back ();
     _empty_slots.pop_back ();
 
     //  Generate new unique socket ID.
-    int sid = (static_cast<int> (max_socket_id.add (1))) + 1;
+    const int sid = (static_cast<int> (max_socket_id.add (1))) + 1;
 
     //  Create the socket and register its mailbox.
     socket_base_t *s = socket_base_t::create (type_, this, slot, sid);
@@ -393,7 +521,7 @@ void zmq::ctx_t::destroy_socket (class s
     scoped_lock_t locker (_slot_sync);
 
     //  Free the associated thread slot.
-    uint32_t tid = socket_->get_tid ();
+    const uint32_t tid = socket_->get_tid ();
     _empty_slots.push_back (tid);
     _slots[tid] = NULL;
 
@@ -406,7 +534,7 @@ void zmq::ctx_t::destroy_socket (class s
         _reaper->stop ();
 }
 
-zmq::object_t *zmq::ctx_t::get_reaper ()
+zmq::object_t *zmq::ctx_t::get_reaper () const
 {
     return _reaper;
 }
@@ -433,50 +561,102 @@ void zmq::thread_ctx_t::start_thread (th
     thread_.start (tfn_, arg_, namebuf);
 }
 
-int zmq::thread_ctx_t::set (int option_, int optval_)
+int zmq::thread_ctx_t::set (int option_, const void *optval_, size_t optvallen_)
 {
-    int rc = 0;
-    if (option_ == ZMQ_THREAD_SCHED_POLICY && optval_ >= 0) {
-        scoped_lock_t locker (_opt_sync);
-        _thread_sched_policy = optval_;
-    } else if (option_ == ZMQ_THREAD_AFFINITY_CPU_ADD && optval_ >= 0) {
-        scoped_lock_t locker (_opt_sync);
-        _thread_affinity_cpus.insert (optval_);
-    } else if (option_ == ZMQ_THREAD_AFFINITY_CPU_REMOVE && optval_ >= 0) {
-        scoped_lock_t locker (_opt_sync);
-        if (0 == _thread_affinity_cpus.erase (optval_)) {
-            errno = EINVAL;
-            rc = -1;
-        }
-    } else if (option_ == ZMQ_THREAD_NAME_PREFIX && optval_ >= 0) {
-        std::ostringstream s;
-        s << optval_;
-        scoped_lock_t locker (_opt_sync);
-        _thread_name_prefix = s.str ();
-    } else if (option_ == ZMQ_THREAD_PRIORITY && optval_ >= 0) {
-        scoped_lock_t locker (_opt_sync);
-        _thread_priority = optval_;
-    } else {
-        errno = EINVAL;
-        rc = -1;
+    const bool is_int = (optvallen_ == sizeof (int));
+    int value = 0;
+    if (is_int)
+        memcpy (&value, optval_, sizeof (int));
+
+    switch (option_) {
+        case ZMQ_THREAD_SCHED_POLICY:
+            if (is_int && value >= 0) {
+                scoped_lock_t locker (_opt_sync);
+                _thread_sched_policy = value;
+                return 0;
+            }
+            break;
+
+        case ZMQ_THREAD_AFFINITY_CPU_ADD:
+            if (is_int && value >= 0) {
+                scoped_lock_t locker (_opt_sync);
+                _thread_affinity_cpus.insert (value);
+                return 0;
+            }
+            break;
+
+        case ZMQ_THREAD_AFFINITY_CPU_REMOVE:
+            if (is_int && value >= 0) {
+                scoped_lock_t locker (_opt_sync);
+                if (0 == _thread_affinity_cpus.erase (value)) {
+                    errno = EINVAL;
+                    return -1;
+                }
+                return 0;
+            }
+            break;
+
+        case ZMQ_THREAD_PRIORITY:
+            if (is_int && value >= 0) {
+                scoped_lock_t locker (_opt_sync);
+                _thread_priority = value;
+                return 0;
+            }
+            break;
+
+        case ZMQ_THREAD_NAME_PREFIX:
+            // start_thread() allows max 16 chars for thread name
+            if (is_int) {
+                std::ostringstream s;
+                s << value;
+                scoped_lock_t locker (_opt_sync);
+                _thread_name_prefix = s.str ();
+                return 0;
+            } else if (optvallen_ > 0 && optvallen_ <= 16) {
+                scoped_lock_t locker (_opt_sync);
+                _thread_name_prefix.assign (static_cast<const char *> (optval_),
+                                            optvallen_);
+                return 0;
+            }
+            break;
     }
-    return rc;
+
+    errno = EINVAL;
+    return -1;
 }
 
-int zmq::thread_ctx_t::get (int option_)
+int zmq::thread_ctx_t::get (int option_,
+                            void *optval_,
+                            const size_t *optvallen_)
 {
-    int rc = 0;
-    if (option_ == ZMQ_THREAD_SCHED_POLICY) {
-        scoped_lock_t locker (_opt_sync);
-        rc = _thread_sched_policy;
-    } else if (option_ == ZMQ_THREAD_NAME_PREFIX) {
-        scoped_lock_t locker (_opt_sync);
-        rc = atoi (_thread_name_prefix.c_str ());
-    } else {
-        errno = EINVAL;
-        rc = -1;
+    const bool is_int = (*optvallen_ == sizeof (int));
+    int *value = static_cast<int *> (optval_);
+
+    switch (option_) {
+        case ZMQ_THREAD_SCHED_POLICY:
+            if (is_int) {
+                scoped_lock_t locker (_opt_sync);
+                *value = _thread_sched_policy;
+                return 0;
+            }
+            break;
+
+        case ZMQ_THREAD_NAME_PREFIX:
+            if (is_int) {
+                scoped_lock_t locker (_opt_sync);
+                *value = atoi (_thread_name_prefix.c_str ());
+                return 0;
+            } else if (*optvallen_ >= _thread_name_prefix.size ()) {
+                scoped_lock_t locker (_opt_sync);
+                memcpy (optval_, _thread_name_prefix.data (),
+                        _thread_name_prefix.size ());
+                return 0;
+            }
+            break;
     }
-    return rc;
+
+    errno = EINVAL;
+    return -1;
 }
 
 void zmq::ctx_t::send_command (uint32_t tid_, const command_t &command_)
@@ -492,9 +672,10 @@ zmq::io_thread_t *zmq::ctx_t::choose_io_
     //  Find the I/O thread with minimum load.
     int min_load = -1;
     io_thread_t *selected_io_thread = NULL;
-    for (io_threads_t::size_type i = 0; i != _io_threads.size (); i++) {
+    for (io_threads_t::size_type i = 0, size = _io_threads.size (); i != size;
+         i++) {
         if (!affinity_ || (affinity_ & (uint64_t (1) << i))) {
-            int load = _io_threads[i]->get_load ();
+            const int load = _io_threads[i]->get_load ();
             if (selected_io_thread == NULL || load < min_load) {
                 min_load = load;
                 selected_io_thread = _io_threads[i];
@@ -520,7 +701,7 @@ int zmq::ctx_t::register_endpoint (const
 }
 
 int zmq::ctx_t::unregister_endpoint (const std::string &addr_,
-                                     socket_base_t *socket_)
+                                     const socket_base_t *const socket_)
 {
     scoped_lock_t locker (_endpoints_sync);
 
@@ -536,7 +717,7 @@ int zmq::ctx_t::unregister_endpoint (con
     return 0;
 }
 
-void zmq::ctx_t::unregister_endpoints (socket_base_t *socket_)
+void zmq::ctx_t::unregister_endpoints (const socket_base_t *const socket_)
 {
     scoped_lock_t locker (_endpoints_sync);
 
@@ -544,7 +725,7 @@ void zmq::ctx_t::unregister_endpoints (s
                                end = _endpoints.end ();
          it != end;) {
         if (it->second.socket == socket_)
-#if __cplusplus >= 201103L
+#if __cplusplus >= 201103L || (defined _MSC_VER && _MSC_VER >= 1700)
             it = _endpoints.erase (it);
 #else
             _endpoints.erase (it++);
@@ -584,7 +765,7 @@ void zmq::ctx_t::pend_connection (const
     const pending_connection_t pending_connection = {endpoint_, pipes_[0],
                                                      pipes_[1]};
 
-    endpoints_t::iterator it = _endpoints.find (addr_);
+    const endpoints_t::iterator it = _endpoints.find (addr_);
     if (it == _endpoints.end ()) {
         //  Still no bind.
         endpoint_.socket->inc_seqnum ();
@@ -602,7 +783,8 @@ void zmq::ctx_t::connect_pending (const
 {
     scoped_lock_t locker (_endpoints_sync);
 
-    std::pair<pending_connections_t::iterator, pending_connections_t::iterator>
+    const std::pair<pending_connections_t::iterator,
+                    pending_connections_t::iterator>
       pending = _pending_connections.equal_range (addr_);
     for (pending_connections_t::iterator p = pending.first; p != pending.second;
          ++p)
@@ -614,7 +796,7 @@ void zmq::ctx_t::connect_pending (const
 
 void zmq::ctx_t::connect_inproc_sockets (
   zmq::socket_base_t *bind_socket_,
-  options_t &bind_options_,
+  const options_t &bind_options_,
   const pending_connection_t &pending_connection_,
   side side_)
 {
@@ -646,6 +828,13 @@ void zmq::ctx_t::connect_inproc_sockets
         pending_connection_.bind_pipe->set_hwms (-1, -1);
     }
 
+#ifdef ZMQ_BUILD_DRAFT_API
+    if (bind_options_.can_recv_disconnect_msg
+        && !bind_options_.disconnect_msg.empty ())
+        pending_connection_.connect_pipe->set_disconnect_msg (
+          bind_options_.disconnect_msg);
+#endif
+
     if (side_ == bind_side) {
         command_t cmd;
         cmd.type = command_t::bind;
@@ -666,6 +855,14 @@ void zmq::ctx_t::connect_inproc_sockets
         && pending_connection_.endpoint.socket->check_tag ()) {
         send_routing_id (pending_connection_.bind_pipe, bind_options_);
     }
+
+#ifdef ZMQ_BUILD_DRAFT_API
+    //  If set, send the hello msg of the bind socket to the pending connection.
+    if (bind_options_.can_send_hello_msg
+        && bind_options_.hello_msg.size () > 0) {
+        send_hello_msg (pending_connection_.bind_pipe, bind_options_);
+    }
+#endif
 }
 
 #ifdef ZMQ_HAVE_VMCI
diff -pruN 4.3.2-2/src/ctx.hpp 4.3.3-1/src/ctx.hpp
--- 4.3.2-2/src/ctx.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ctx.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -72,8 +72,8 @@ class thread_ctx_t
                        void *arg_,
                        const char *name_ = NULL) const;
 
-    int set (int option_, int optval_);
-    int get (int option_);
+    int set (int option_, const void *optval_, size_t optvallen_);
+    int get (int option_, void *optval_, const size_t *optvallen_);
 
   protected:
     //  Synchronisation of access to context options.
@@ -90,14 +90,14 @@ class thread_ctx_t
 //  Context object encapsulates all the global state associated with
 //  the library.
 
-class ctx_t : public thread_ctx_t
+class ctx_t ZMQ_FINAL : public thread_ctx_t
 {
   public:
     //  Create the context object.
     ctx_t ();
 
     //  Returns false if object is not a context.
-    bool check_tag ();
+    bool check_tag () const;
 
     //  This function is called when user invokes zmq_ctx_term. If there are
     //  no more sockets open it'll cause all the infrastructure to be shut
@@ -115,7 +115,8 @@ class ctx_t : public thread_ctx_t
     int shutdown ();
 
     //  Set and get context properties.
-    int set (int option_, int optval_);
+    int set (int option_, const void *optval_, size_t optvallen_);
+    int get (int option_, void *optval_, const size_t *optvallen_);
     int get (int option_);
 
     //  Create and destroy a socket.
@@ -131,12 +132,13 @@ class ctx_t : public thread_ctx_t
     zmq::io_thread_t *choose_io_thread (uint64_t affinity_);
 
     //  Returns reaper thread object.
-    zmq::object_t *get_reaper ();
+    zmq::object_t *get_reaper () const;
 
     //  Management of inproc endpoints.
     int register_endpoint (const char *addr_, const endpoint_t &endpoint_);
-    int unregister_endpoint (const std::string &addr_, socket_base_t *socket_);
-    void unregister_endpoints (zmq::socket_base_t *socket_);
+    int unregister_endpoint (const std::string &addr_,
+                             const socket_base_t *socket_);
+    void unregister_endpoints (const zmq::socket_base_t *socket_);
     endpoint_t find_endpoint (const char *addr_);
     void pend_connection (const std::string &addr_,
                           const endpoint_t &endpoint_,
@@ -240,8 +242,7 @@ class ctx_t : public thread_ctx_t
     // Should we use zero copy message decoding in this context?
     bool _zero_copy;
 
-    ctx_t (const ctx_t &);
-    const ctx_t &operator= (const ctx_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (ctx_t)
 
 #ifdef HAVE_FORK
     // the process that created this context. Used to detect forking.
@@ -252,9 +253,10 @@ class ctx_t : public thread_ctx_t
         connect_side,
         bind_side
     };
-    void
+
+    static void
     connect_inproc_sockets (zmq::socket_base_t *bind_socket_,
-                            options_t &bind_options_,
+                            const options_t &bind_options_,
                             const pending_connection_t &pending_connection_,
                             side side_);
 
diff -pruN 4.3.2-2/src/curve_client.cpp 4.3.3-1/src/curve_client.cpp
--- 4.3.2-2/src/curve_client.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/curve_client.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -38,12 +38,17 @@
 #include "curve_client.hpp"
 #include "wire.hpp"
 #include "curve_client_tools.hpp"
+#include "secure_allocator.hpp"
 
 zmq::curve_client_t::curve_client_t (session_base_t *session_,
-                                     const options_t &options_) :
+                                     const options_t &options_,
+                                     const bool downgrade_sub_) :
     mechanism_base_t (session_, options_),
-    curve_mechanism_base_t (
-      session_, options_, "CurveZMQMESSAGEC", "CurveZMQMESSAGES"),
+    curve_mechanism_base_t (session_,
+                            options_,
+                            "CurveZMQMESSAGEC",
+                            "CurveZMQMESSAGES",
+                            downgrade_sub_),
     _state (send_hello),
     _tools (options_.curve_public_key,
             options_.curve_secret_key,
@@ -127,8 +132,8 @@ zmq::mechanism_t::status_t zmq::curve_cl
         return mechanism_t::ready;
     if (_state == error_received)
         return mechanism_t::error;
-    else
-        return mechanism_t::handshaking;
+
+    return mechanism_t::handshaking;
 }
 
 int zmq::curve_client_t::produce_hello (msg_t *msg_)
@@ -136,7 +141,7 @@ int zmq::curve_client_t::produce_hello (
     int rc = msg_->init_size (200);
     errno_assert (rc == 0);
 
-    rc = _tools.produce_hello (msg_->data (), cn_nonce);
+    rc = _tools.produce_hello (msg_->data (), get_and_inc_nonce ());
     if (rc == -1) {
         session->get_socket ()->event_handshake_failed_protocol (
           session->get_endpoint (), ZMQ_PROTOCOL_ERROR_ZMTP_CRYPTOGRAPHIC);
@@ -149,15 +154,14 @@ int zmq::curve_client_t::produce_hello (
         return -1;
     }
 
-    cn_nonce++;
-
     return 0;
 }
 
 int zmq::curve_client_t::process_welcome (const uint8_t *msg_data_,
                                           size_t msg_size_)
 {
-    int rc = _tools.process_welcome (msg_data_, msg_size_, cn_precom);
+    const int rc = _tools.process_welcome (msg_data_, msg_size_,
+                                           get_writable_precom_buffer ());
 
     if (rc == -1) {
         session->get_socket ()->event_handshake_failed_protocol (
@@ -175,20 +179,18 @@ int zmq::curve_client_t::process_welcome
 int zmq::curve_client_t::produce_initiate (msg_t *msg_)
 {
     const size_t metadata_length = basic_properties_len ();
-    unsigned char *metadata_plaintext =
-      static_cast<unsigned char *> (malloc (metadata_length));
-    alloc_assert (metadata_plaintext);
+    std::vector<unsigned char, secure_allocator_t<unsigned char> >
+      metadata_plaintext (metadata_length);
 
-    add_basic_properties (metadata_plaintext, metadata_length);
+    add_basic_properties (&metadata_plaintext[0], metadata_length);
 
-    size_t msg_size = 113 + 128 + crypto_box_BOXZEROBYTES + metadata_length;
+    const size_t msg_size =
+      113 + 128 + crypto_box_BOXZEROBYTES + metadata_length;
     int rc = msg_->init_size (msg_size);
     errno_assert (rc == 0);
 
-    rc = _tools.produce_initiate (msg_->data (), msg_size, cn_nonce,
-                                  metadata_plaintext, metadata_length);
-
-    free (metadata_plaintext);
+    rc = _tools.produce_initiate (msg_->data (), msg_size, get_and_inc_nonce (),
+                                  &metadata_plaintext[0], metadata_length);
 
     if (-1 == rc) {
         session->get_socket ()->event_handshake_failed_protocol (
@@ -198,8 +200,6 @@ int zmq::curve_client_t::produce_initiat
         return -1;
     }
 
-    cn_nonce++;
-
     return 0;
 }
 
@@ -217,24 +217,21 @@ int zmq::curve_client_t::process_ready (
     const size_t clen = (msg_size_ - 14) + crypto_box_BOXZEROBYTES;
 
     uint8_t ready_nonce[crypto_box_NONCEBYTES];
-    uint8_t *ready_plaintext =
-      static_cast<uint8_t *> (malloc (crypto_box_ZEROBYTES + clen));
-    alloc_assert (ready_plaintext);
-    uint8_t *ready_box =
-      static_cast<uint8_t *> (malloc (crypto_box_BOXZEROBYTES + 16 + clen));
-    alloc_assert (ready_box);
-
-    memset (ready_box, 0, crypto_box_BOXZEROBYTES);
-    memcpy (ready_box + crypto_box_BOXZEROBYTES, msg_data_ + 14,
+    std::vector<uint8_t, secure_allocator_t<uint8_t> > ready_plaintext (
+      crypto_box_ZEROBYTES + clen);
+    std::vector<uint8_t> ready_box (crypto_box_BOXZEROBYTES + 16 + clen);
+
+    std::fill (ready_box.begin (), ready_box.begin () + crypto_box_BOXZEROBYTES,
+               0);
+    memcpy (&ready_box[crypto_box_BOXZEROBYTES], msg_data_ + 14,
             clen - crypto_box_BOXZEROBYTES);
 
     memcpy (ready_nonce, "CurveZMQREADY---", 16);
     memcpy (ready_nonce + 16, msg_data_ + 6, 8);
-    cn_peer_nonce = get_uint64 (msg_data_ + 6);
+    set_peer_nonce (get_uint64 (msg_data_ + 6));
 
-    int rc = crypto_box_open_afternm (ready_plaintext, ready_box, clen,
-                                      ready_nonce, cn_precom);
-    free (ready_box);
+    int rc = crypto_box_open_afternm (&ready_plaintext[0], &ready_box[0], clen,
+                                      ready_nonce, get_precom_buffer ());
 
     if (rc != 0) {
         session->get_socket ()->event_handshake_failed_protocol (
@@ -243,9 +240,8 @@ int zmq::curve_client_t::process_ready (
         return -1;
     }
 
-    rc = parse_metadata (ready_plaintext + crypto_box_ZEROBYTES,
+    rc = parse_metadata (&ready_plaintext[crypto_box_ZEROBYTES],
                          clen - crypto_box_ZEROBYTES);
-    free (ready_plaintext);
 
     if (rc == 0)
         _state = connected;
diff -pruN 4.3.2-2/src/curve_client.hpp 4.3.3-1/src/curve_client.hpp
--- 4.3.2-2/src/curve_client.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/curve_client.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,18 +41,20 @@ namespace zmq
 class msg_t;
 class session_base_t;
 
-class curve_client_t : public curve_mechanism_base_t
+class curve_client_t ZMQ_FINAL : public curve_mechanism_base_t
 {
   public:
-    curve_client_t (session_base_t *session_, const options_t &options_);
-    virtual ~curve_client_t ();
+    curve_client_t (session_base_t *session_,
+                    const options_t &options_,
+                    const bool downgrade_sub_);
+    ~curve_client_t () ZMQ_FINAL;
 
     // mechanism implementation
-    virtual int next_handshake_command (msg_t *msg_);
-    virtual int process_handshake_command (msg_t *msg_);
-    virtual int encode (msg_t *msg_);
-    virtual int decode (msg_t *msg_);
-    virtual status_t status () const;
+    int next_handshake_command (msg_t *msg_) ZMQ_FINAL;
+    int process_handshake_command (msg_t *msg_) ZMQ_FINAL;
+    int encode (msg_t *msg_) ZMQ_FINAL;
+    int decode (msg_t *msg_) ZMQ_FINAL;
+    status_t status () const ZMQ_FINAL;
 
   private:
     enum state_t
@@ -72,10 +74,10 @@ class curve_client_t : public curve_mech
     curve_client_tools_t _tools;
 
     int produce_hello (msg_t *msg_);
-    int process_welcome (const uint8_t *cmd_data_, size_t data_size_);
+    int process_welcome (const uint8_t *msg_data_, size_t msg_size_);
     int produce_initiate (msg_t *msg_);
-    int process_ready (const uint8_t *cmd_data_, size_t data_size_);
-    int process_error (const uint8_t *cmd_data_, size_t data_size_);
+    int process_ready (const uint8_t *msg_data_, size_t msg_size_);
+    int process_error (const uint8_t *msg_data_, size_t msg_size_);
 };
 }
 
diff -pruN 4.3.2-2/src/curve_client_tools.hpp 4.3.3-1/src/curve_client_tools.hpp
--- 4.3.2-2/src/curve_client_tools.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/curve_client_tools.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -46,6 +46,9 @@
 
 #include "wire.hpp"
 #include "err.hpp"
+#include "secure_allocator.hpp"
+
+#include <vector>
 
 namespace zmq
 {
@@ -58,7 +61,8 @@ struct curve_client_tools_t
                               const uint8_t *cn_secret_)
     {
         uint8_t hello_nonce[crypto_box_NONCEBYTES];
-        uint8_t hello_plaintext[crypto_box_ZEROBYTES + 64];
+        std::vector<uint8_t, secure_allocator_t<uint8_t> > hello_plaintext (
+          crypto_box_ZEROBYTES + 64, 0);
         uint8_t hello_box[crypto_box_BOXZEROBYTES + 80];
 
         //  Prepare the full nonce
@@ -66,10 +70,9 @@ struct curve_client_tools_t
         put_uint64 (hello_nonce + 16, cn_nonce_);
 
         //  Create Box [64 * %x0](C'->S)
-        memset (hello_plaintext, 0, sizeof hello_plaintext);
-
-        int rc = crypto_box (hello_box, hello_plaintext, sizeof hello_plaintext,
-                             hello_nonce, server_key_, cn_secret_);
+        const int rc =
+          crypto_box (hello_box, &hello_plaintext[0], hello_plaintext.size (),
+                      hello_nonce, server_key_, cn_secret_);
         if (rc == -1)
             return -1;
 
@@ -104,7 +107,8 @@ struct curve_client_tools_t
         }
 
         uint8_t welcome_nonce[crypto_box_NONCEBYTES];
-        uint8_t welcome_plaintext[crypto_box_ZEROBYTES + 128];
+        std::vector<uint8_t, secure_allocator_t<uint8_t> > welcome_plaintext (
+          crypto_box_ZEROBYTES + 128);
         uint8_t welcome_box[crypto_box_BOXZEROBYTES + 144];
 
         //  Open Box [S' + cookie](C'->S)
@@ -114,16 +118,16 @@ struct curve_client_tools_t
         memcpy (welcome_nonce, "WELCOME-", 8);
         memcpy (welcome_nonce + 8, msg_data_ + 8, 16);
 
-        int rc =
-          crypto_box_open (welcome_plaintext, welcome_box, sizeof welcome_box,
-                           welcome_nonce, server_key_, cn_secret_);
+        int rc = crypto_box_open (&welcome_plaintext[0], welcome_box,
+                                  sizeof welcome_box, welcome_nonce,
+                                  server_key_, cn_secret_);
         if (rc != 0) {
             errno = EPROTO;
             return -1;
         }
 
-        memcpy (cn_server_, welcome_plaintext + crypto_box_ZEROBYTES, 32);
-        memcpy (cn_cookie_, welcome_plaintext + crypto_box_ZEROBYTES + 32,
+        memcpy (cn_server_, &welcome_plaintext[crypto_box_ZEROBYTES], 32);
+        memcpy (cn_cookie_, &welcome_plaintext[crypto_box_ZEROBYTES + 32],
                 16 + 80);
 
         //  Message independent precomputation
@@ -147,47 +151,51 @@ struct curve_client_tools_t
                                  const size_t metadata_length_)
     {
         uint8_t vouch_nonce[crypto_box_NONCEBYTES];
-        uint8_t vouch_plaintext[crypto_box_ZEROBYTES + 64];
+        std::vector<uint8_t, secure_allocator_t<uint8_t> > vouch_plaintext (
+          crypto_box_ZEROBYTES + 64);
         uint8_t vouch_box[crypto_box_BOXZEROBYTES + 80];
 
         //  Create vouch = Box [C',S](C->S')
-        memset (vouch_plaintext, 0, crypto_box_ZEROBYTES);
-        memcpy (vouch_plaintext + crypto_box_ZEROBYTES, cn_public_, 32);
-        memcpy (vouch_plaintext + crypto_box_ZEROBYTES + 32, server_key_, 32);
+        std::fill (vouch_plaintext.begin (),
+                   vouch_plaintext.begin () + crypto_box_ZEROBYTES, 0);
+        memcpy (&vouch_plaintext[crypto_box_ZEROBYTES], cn_public_, 32);
+        memcpy (&vouch_plaintext[crypto_box_ZEROBYTES + 32], server_key_, 32);
 
+        memset (vouch_nonce, 0, crypto_box_NONCEBYTES);
         memcpy (vouch_nonce, "VOUCH---", 8);
         randombytes (vouch_nonce + 8, 16);
 
-        int rc = crypto_box (vouch_box, vouch_plaintext, sizeof vouch_plaintext,
-                             vouch_nonce, cn_server_, secret_key_);
+        int rc =
+          crypto_box (vouch_box, &vouch_plaintext[0], vouch_plaintext.size (),
+                      vouch_nonce, cn_server_, secret_key_);
         if (rc == -1)
             return -1;
 
         uint8_t initiate_nonce[crypto_box_NONCEBYTES];
-        uint8_t *initiate_box = static_cast<uint8_t *> (
-          malloc (crypto_box_BOXZEROBYTES + 144 + metadata_length_));
-        alloc_assert (initiate_box);
-        uint8_t *initiate_plaintext = static_cast<uint8_t *> (
-          malloc (crypto_box_ZEROBYTES + 128 + metadata_length_));
-        alloc_assert (initiate_plaintext);
+        std::vector<uint8_t> initiate_box (crypto_box_BOXZEROBYTES + 144
+                                           + metadata_length_);
+        std::vector<uint8_t, secure_allocator_t<uint8_t> > initiate_plaintext (
+          crypto_box_ZEROBYTES + 128 + metadata_length_);
 
         //  Create Box [C + vouch + metadata](C'->S')
-        memset (initiate_plaintext, 0, crypto_box_ZEROBYTES);
-        memcpy (initiate_plaintext + crypto_box_ZEROBYTES, public_key_, 32);
-        memcpy (initiate_plaintext + crypto_box_ZEROBYTES + 32, vouch_nonce + 8,
+        std::fill (initiate_plaintext.begin (),
+                   initiate_plaintext.begin () + crypto_box_ZEROBYTES, 0);
+        memcpy (&initiate_plaintext[crypto_box_ZEROBYTES], public_key_, 32);
+        memcpy (&initiate_plaintext[crypto_box_ZEROBYTES + 32], vouch_nonce + 8,
                 16);
-        memcpy (initiate_plaintext + crypto_box_ZEROBYTES + 48,
+        memcpy (&initiate_plaintext[crypto_box_ZEROBYTES + 48],
                 vouch_box + crypto_box_BOXZEROBYTES, 80);
-        memcpy (initiate_plaintext + crypto_box_ZEROBYTES + 48 + 80,
-                metadata_plaintext_, metadata_length_);
+        if (metadata_length_) {
+            memcpy (&initiate_plaintext[crypto_box_ZEROBYTES + 48 + 80],
+                    metadata_plaintext_, metadata_length_);
+        }
 
         memcpy (initiate_nonce, "CurveZMQINITIATE", 16);
         put_uint64 (initiate_nonce + 16, cn_nonce_);
 
-        rc = crypto_box (initiate_box, initiate_plaintext,
+        rc = crypto_box (&initiate_box[0], &initiate_plaintext[0],
                          crypto_box_ZEROBYTES + 128 + metadata_length_,
                          initiate_nonce, cn_server_, cn_secret_);
-        free (initiate_plaintext);
 
         if (rc == -1)
             return -1;
@@ -203,9 +211,8 @@ struct curve_client_tools_t
         //  Short nonce, prefixed by "CurveZMQINITIATE"
         memcpy (initiate + 105, initiate_nonce + 16, 8);
         //  Box [C + vouch + metadata](C'->S')
-        memcpy (initiate + 113, initiate_box + crypto_box_BOXZEROBYTES,
+        memcpy (initiate + 113, &initiate_box[crypto_box_BOXZEROBYTES],
                 128 + metadata_length_ + crypto_box_BOXZEROBYTES);
-        free (initiate_box);
 
         return 0;
     }
@@ -240,6 +247,8 @@ struct curve_client_tools_t
         memcpy (server_key, curve_server_key_, crypto_box_PUBLICKEYBYTES);
 
         //  Generate short-term key pair
+        memset (cn_secret, 0, crypto_box_SECRETKEYBYTES);
+        memset (cn_public, 0, crypto_box_PUBLICKEYBYTES);
         rc = crypto_box_keypair (cn_public, cn_secret);
         zmq_assert (rc == 0);
     }
@@ -262,7 +271,7 @@ struct curve_client_tools_t
                           size_t size_,
                           const uint64_t cn_nonce_,
                           const uint8_t *metadata_plaintext_,
-                          const size_t metadata_length_)
+                          const size_t metadata_length_) const
     {
         return produce_initiate (data_, size_, cn_nonce_, server_key,
                                  public_key, secret_key, cn_public, cn_secret,
diff -pruN 4.3.2-2/src/curve_mechanism_base.cpp 4.3.3-1/src/curve_mechanism_base.cpp
--- 4.3.2-2/src/curve_mechanism_base.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/curve_mechanism_base.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,46 +36,180 @@
 
 #ifdef ZMQ_HAVE_CURVE
 
+#ifdef ZMQ_USE_LIBSODIUM
+//  libsodium added crypto_box_easy_afternm and crypto_box_open_easy_afternm with
+//  https: //github.com/jedisct1/libsodium/commit/aaf5fbf2e53a33b18d8ea9bdf2c6f73d7acc8c3e
+#if SODIUM_LIBRARY_VERSION_MAJOR > 7                                           \
+  || (SODIUM_LIBRARY_VERSION_MAJOR == 7 && SODIUM_LIBRARY_VERSION_MINOR >= 4)
+#define ZMQ_HAVE_CRYPTO_BOX_EASY_FNS 1
+#endif
+#endif
+
 zmq::curve_mechanism_base_t::curve_mechanism_base_t (
   session_base_t *session_,
   const options_t &options_,
   const char *encode_nonce_prefix_,
-  const char *decode_nonce_prefix_) :
+  const char *decode_nonce_prefix_,
+  const bool downgrade_sub_) :
     mechanism_base_t (session_, options_),
-    encode_nonce_prefix (encode_nonce_prefix_),
-    decode_nonce_prefix (decode_nonce_prefix_),
-    cn_nonce (1),
-    cn_peer_nonce (1)
+    curve_encoding_t (
+      encode_nonce_prefix_, decode_nonce_prefix_, downgrade_sub_)
 {
 }
 
 int zmq::curve_mechanism_base_t::encode (msg_t *msg_)
 {
-    const size_t mlen = crypto_box_ZEROBYTES + 1 + msg_->size ();
+    return curve_encoding_t::encode (msg_);
+}
+
+int zmq::curve_mechanism_base_t::decode (msg_t *msg_)
+{
+    int rc = check_basic_command_structure (msg_);
+    if (rc == -1)
+        return -1;
+
+    int error_event_code;
+    rc = curve_encoding_t::decode (msg_, &error_event_code);
+    if (-1 == rc) {
+        session->get_socket ()->event_handshake_failed_protocol (
+          session->get_endpoint (), error_event_code);
+    }
+
+    return rc;
+}
+
+zmq::curve_encoding_t::curve_encoding_t (const char *encode_nonce_prefix_,
+                                         const char *decode_nonce_prefix_,
+                                         const bool downgrade_sub_) :
+    _encode_nonce_prefix (encode_nonce_prefix_),
+    _decode_nonce_prefix (decode_nonce_prefix_),
+    _cn_nonce (1),
+    _cn_peer_nonce (1),
+    _downgrade_sub (downgrade_sub_)
+{
+}
+
+//  Right now, we only transport the lower two bit flags of zmq::msg_t, so they
+//  are binary identical, and we can just use a bitmask to select them. If we
+//  happened to add more flags, this might change.
+static const uint8_t flag_mask = zmq::msg_t::more | zmq::msg_t::command;
+static const size_t flags_len = 1;
+static const size_t nonce_prefix_len = 16;
+static const char message_command[] = "\x07MESSAGE";
+static const size_t message_command_len = sizeof (message_command) - 1;
+static const size_t message_header_len =
+  message_command_len + sizeof (zmq::curve_encoding_t::nonce_t);
+
+#ifndef ZMQ_USE_LIBSODIUM
+static const size_t crypto_box_MACBYTES = 16;
+#endif
+
+int zmq::curve_encoding_t::check_validity (msg_t *msg_, int *error_event_code_)
+{
+    const size_t size = msg_->size ();
+    const uint8_t *const message = static_cast<uint8_t *> (msg_->data ());
+
+    if (size < message_command_len
+        || 0 != memcmp (message, message_command, message_command_len)) {
+        *error_event_code_ = ZMQ_PROTOCOL_ERROR_ZMTP_UNEXPECTED_COMMAND;
+        errno = EPROTO;
+        return -1;
+    }
+
+    if (size < message_header_len + crypto_box_MACBYTES + flags_len) {
+        *error_event_code_ = ZMQ_PROTOCOL_ERROR_ZMTP_MALFORMED_COMMAND_MESSAGE;
+        errno = EPROTO;
+        return -1;
+    }
+
+    {
+        const uint64_t nonce = get_uint64 (message + message_command_len);
+        if (nonce <= _cn_peer_nonce) {
+            *error_event_code_ = ZMQ_PROTOCOL_ERROR_ZMTP_INVALID_SEQUENCE;
+            errno = EPROTO;
+            return -1;
+        }
+        set_peer_nonce (nonce);
+    }
+
+    return 0;
+}
 
+int zmq::curve_encoding_t::encode (msg_t *msg_)
+{
+    size_t sub_cancel_len = 0;
     uint8_t message_nonce[crypto_box_NONCEBYTES];
-    memcpy (message_nonce, encode_nonce_prefix, 16);
-    put_uint64 (message_nonce + 16, cn_nonce);
+    memcpy (message_nonce, _encode_nonce_prefix, nonce_prefix_len);
+    put_uint64 (message_nonce + nonce_prefix_len, get_and_inc_nonce ());
 
-    uint8_t flags = 0;
-    if (msg_->flags () & msg_t::more)
-        flags |= 0x01;
-    if (msg_->flags () & msg_t::command)
-        flags |= 0x02;
-
-    uint8_t *message_plaintext = static_cast<uint8_t *> (malloc (mlen));
-    alloc_assert (message_plaintext);
-
-    memset (message_plaintext, 0, crypto_box_ZEROBYTES);
-    message_plaintext[crypto_box_ZEROBYTES] = flags;
-    memcpy (message_plaintext + crypto_box_ZEROBYTES + 1, msg_->data (),
-            msg_->size ());
+    if (msg_->is_subscribe () || msg_->is_cancel ()) {
+        if (_downgrade_sub)
+            sub_cancel_len = 1;
+        else
+            sub_cancel_len = msg_->is_cancel ()
+                               ? zmq::msg_t::cancel_cmd_name_size
+                               : zmq::msg_t::sub_cmd_name_size;
+    }
 
-    uint8_t *message_box = static_cast<uint8_t *> (malloc (mlen));
-    alloc_assert (message_box);
+#ifdef ZMQ_HAVE_CRYPTO_BOX_EASY_FNS
+    const size_t mlen = flags_len + sub_cancel_len + msg_->size ();
+    std::vector<uint8_t> message_plaintext (mlen);
+#else
+    const size_t mlen =
+      crypto_box_ZEROBYTES + flags_len + sub_cancel_len + msg_->size ();
+    std::vector<uint8_t> message_plaintext_with_zerobytes (mlen);
+    uint8_t *const message_plaintext =
+      &message_plaintext_with_zerobytes[crypto_box_ZEROBYTES];
+
+    std::fill (message_plaintext_with_zerobytes.begin (),
+               message_plaintext_with_zerobytes.begin () + crypto_box_ZEROBYTES,
+               0);
+#endif
+
+    const uint8_t flags = msg_->flags () & flag_mask;
+    message_plaintext[0] = flags;
+
+    // For backward compatibility subscribe/cancel command messages are not stored with
+    // the message flags, and are encoded in the encoder, so that messages for < 3.0 peers
+    // can be encoded in the "old" 0/1 way rather than as commands.
+    if (sub_cancel_len == 1)
+        message_plaintext[flags_len] = msg_->is_subscribe () ? 1 : 0;
+    else if (sub_cancel_len == zmq::msg_t::sub_cmd_name_size) {
+        message_plaintext[0] |= zmq::msg_t::command;
+        memcpy (&message_plaintext[flags_len], zmq::sub_cmd_name,
+                zmq::msg_t::sub_cmd_name_size);
+    } else if (sub_cancel_len == zmq::msg_t::cancel_cmd_name_size) {
+        message_plaintext[0] |= zmq::msg_t::command;
+        memcpy (&message_plaintext[flags_len], zmq::cancel_cmd_name,
+                zmq::msg_t::cancel_cmd_name_size);
+    }
+
+    // this is copying the data from insecure memory, so there is no point in
+    // using secure_allocator_t for message_plaintext
+    if (msg_->size () > 0)
+        memcpy (&message_plaintext[flags_len + sub_cancel_len], msg_->data (),
+                msg_->size ());
 
-    int rc = crypto_box_afternm (message_box, message_plaintext, mlen,
-                                 message_nonce, cn_precom);
+#ifdef ZMQ_HAVE_CRYPTO_BOX_EASY_FNS
+    msg_t msg_box;
+    int rc =
+      msg_box.init_size (message_header_len + mlen + crypto_box_MACBYTES);
+    zmq_assert (rc == 0);
+
+    rc = crypto_box_easy_afternm (
+      static_cast<uint8_t *> (msg_box.data ()) + message_header_len,
+      &message_plaintext[0], mlen, message_nonce, _cn_precom);
+    zmq_assert (rc == 0);
+
+    msg_->move (msg_box);
+
+    uint8_t *const message = static_cast<uint8_t *> (msg_->data ());
+#else
+    std::vector<uint8_t> message_box (mlen);
+
+    int rc =
+      crypto_box_afternm (&message_box[0], &message_plaintext_with_zerobytes[0],
+                          mlen, message_nonce, _cn_precom);
     zmq_assert (rc == 0);
 
     rc = msg_->close ();
@@ -84,94 +218,94 @@ int zmq::curve_mechanism_base_t::encode
     rc = msg_->init_size (16 + mlen - crypto_box_BOXZEROBYTES);
     zmq_assert (rc == 0);
 
-    uint8_t *message = static_cast<uint8_t *> (msg_->data ());
+    uint8_t *const message = static_cast<uint8_t *> (msg_->data ());
 
-    memcpy (message, "\x07MESSAGE", 8);
-    memcpy (message + 8, message_nonce + 16, 8);
-    memcpy (message + 16, message_box + crypto_box_BOXZEROBYTES,
+    memcpy (message + message_header_len, &message_box[crypto_box_BOXZEROBYTES],
             mlen - crypto_box_BOXZEROBYTES);
+#endif
 
-    free (message_plaintext);
-    free (message_box);
-
-    cn_nonce++;
+    memcpy (message, message_command, message_command_len);
+    memcpy (message + message_command_len, message_nonce + nonce_prefix_len,
+            sizeof (nonce_t));
 
     return 0;
 }
 
-int zmq::curve_mechanism_base_t::decode (msg_t *msg_)
+int zmq::curve_encoding_t::decode (msg_t *msg_, int *error_event_code_)
 {
-    int rc = check_basic_command_structure (msg_);
-    if (rc == -1)
-        return -1;
-
-    const size_t size = msg_->size ();
-    const uint8_t *message = static_cast<uint8_t *> (msg_->data ());
-
-    if (size < 8 || memcmp (message, "\x07MESSAGE", 8)) {
-        session->get_socket ()->event_handshake_failed_protocol (
-          session->get_endpoint (), ZMQ_PROTOCOL_ERROR_ZMTP_UNEXPECTED_COMMAND);
-        errno = EPROTO;
-        return -1;
+    int rc = check_validity (msg_, error_event_code_);
+    if (0 != rc) {
+        return rc;
     }
 
-    if (size < 33) {
-        session->get_socket ()->event_handshake_failed_protocol (
-          session->get_endpoint (),
-          ZMQ_PROTOCOL_ERROR_ZMTP_MALFORMED_COMMAND_MESSAGE);
-        errno = EPROTO;
-        return -1;
-    }
+    uint8_t *const message = static_cast<uint8_t *> (msg_->data ());
 
     uint8_t message_nonce[crypto_box_NONCEBYTES];
-    memcpy (message_nonce, decode_nonce_prefix, 16);
-    memcpy (message_nonce + 16, message + 8, 8);
-    uint64_t nonce = get_uint64 (message + 8);
-    if (nonce <= cn_peer_nonce) {
-        session->get_socket ()->event_handshake_failed_protocol (
-          session->get_endpoint (), ZMQ_PROTOCOL_ERROR_ZMTP_INVALID_SEQUENCE);
-        errno = EPROTO;
-        return -1;
-    }
-    cn_peer_nonce = nonce;
-
-    const size_t clen = crypto_box_BOXZEROBYTES + msg_->size () - 16;
+    memcpy (message_nonce, _decode_nonce_prefix, nonce_prefix_len);
+    memcpy (message_nonce + nonce_prefix_len, message + message_command_len,
+            sizeof (nonce_t));
+
+#ifdef ZMQ_HAVE_CRYPTO_BOX_EASY_FNS
+    const size_t clen = msg_->size () - message_header_len;
+
+    uint8_t *const message_plaintext = message + message_header_len;
+
+    rc = crypto_box_open_easy_afternm (message_plaintext,
+                                       message + message_header_len, clen,
+                                       message_nonce, _cn_precom);
+#else
+    const size_t clen =
+      crypto_box_BOXZEROBYTES + msg_->size () - message_header_len;
+
+    std::vector<uint8_t> message_plaintext_with_zerobytes (clen);
+    std::vector<uint8_t> message_box (clen);
+
+    std::fill (message_box.begin (),
+               message_box.begin () + crypto_box_BOXZEROBYTES, 0);
+    memcpy (&message_box[crypto_box_BOXZEROBYTES], message + message_header_len,
+            msg_->size () - message_header_len);
+
+    rc = crypto_box_open_afternm (&message_plaintext_with_zerobytes[0],
+                                  &message_box[0], clen, message_nonce,
+                                  _cn_precom);
+
+    const uint8_t *const message_plaintext =
+      &message_plaintext_with_zerobytes[crypto_box_ZEROBYTES];
+#endif
 
-    uint8_t *message_plaintext = static_cast<uint8_t *> (malloc (clen));
-    alloc_assert (message_plaintext);
+    if (rc == 0) {
+        const uint8_t flags = message_plaintext[0];
 
-    uint8_t *message_box = static_cast<uint8_t *> (malloc (clen));
-    alloc_assert (message_box);
+#ifdef ZMQ_HAVE_CRYPTO_BOX_EASY_FNS
+        const size_t plaintext_size = clen - flags_len - crypto_box_MACBYTES;
 
-    memset (message_box, 0, crypto_box_BOXZEROBYTES);
-    memcpy (message_box + crypto_box_BOXZEROBYTES, message + 16,
-            msg_->size () - 16);
+        if (plaintext_size > 0) {
+            memmove (msg_->data (), &message_plaintext[flags_len],
+                     plaintext_size);
+        }
 
-    rc = crypto_box_open_afternm (message_plaintext, message_box, clen,
-                                  message_nonce, cn_precom);
-    if (rc == 0) {
+        msg_->shrink (plaintext_size);
+#else
         rc = msg_->close ();
         zmq_assert (rc == 0);
 
-        rc = msg_->init_size (clen - 1 - crypto_box_ZEROBYTES);
+        rc = msg_->init_size (clen - flags_len - crypto_box_ZEROBYTES);
         zmq_assert (rc == 0);
 
-        const uint8_t flags = message_plaintext[crypto_box_ZEROBYTES];
-        if (flags & 0x01)
-            msg_->set_flags (msg_t::more);
-        if (flags & 0x02)
-            msg_->set_flags (msg_t::command);
+        // this is copying the data to insecure memory, so there is no point in
+        // using secure_allocator_t for message_plaintext
+        if (msg_->size () > 0) {
+            memcpy (msg_->data (), &message_plaintext[flags_len],
+                    msg_->size ());
+        }
+#endif
 
-        memcpy (msg_->data (), message_plaintext + crypto_box_ZEROBYTES + 1,
-                msg_->size ());
+        msg_->set_flags (flags & flag_mask);
     } else {
         // CURVE I : connection key used for MESSAGE is wrong
-        session->get_socket ()->event_handshake_failed_protocol (
-          session->get_endpoint (), ZMQ_PROTOCOL_ERROR_ZMTP_CRYPTOGRAPHIC);
+        *error_event_code_ = ZMQ_PROTOCOL_ERROR_ZMTP_CRYPTOGRAPHIC;
         errno = EPROTO;
     }
-    free (message_plaintext);
-    free (message_box);
 
     return rc;
 }
diff -pruN 4.3.2-2/src/curve_mechanism_base.hpp 4.3.3-1/src/curve_mechanism_base.hpp
--- 4.3.2-2/src/curve_mechanism_base.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/curve_mechanism_base.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -48,29 +48,58 @@
 #include "mechanism_base.hpp"
 #include "options.hpp"
 
+#include <memory>
+
 namespace zmq
 {
-class curve_mechanism_base_t : public virtual mechanism_base_t
+class curve_encoding_t
 {
   public:
-    curve_mechanism_base_t (session_base_t *session_,
-                            const options_t &options_,
-                            const char *encode_nonce_prefix_,
-                            const char *decode_nonce_prefix_);
+    curve_encoding_t (const char *encode_nonce_prefix_,
+                      const char *decode_nonce_prefix_,
+                      const bool downgrade_sub_);
 
-    // mechanism implementation
-    virtual int encode (msg_t *msg_);
-    virtual int decode (msg_t *msg_);
+    int encode (msg_t *msg_);
+    int decode (msg_t *msg_, int *error_event_code_);
 
-  protected:
-    const char *encode_nonce_prefix;
-    const char *decode_nonce_prefix;
+    uint8_t *get_writable_precom_buffer () { return _cn_precom; }
+    const uint8_t *get_precom_buffer () const { return _cn_precom; }
 
-    uint64_t cn_nonce;
-    uint64_t cn_peer_nonce;
+    typedef uint64_t nonce_t;
+
+    nonce_t get_and_inc_nonce () { return _cn_nonce++; }
+    void set_peer_nonce (nonce_t peer_nonce_) { _cn_peer_nonce = peer_nonce_; };
+
+  private:
+    int check_validity (msg_t *msg_, int *error_event_code_);
+
+    const char *_encode_nonce_prefix;
+    const char *_decode_nonce_prefix;
+
+    nonce_t _cn_nonce;
+    nonce_t _cn_peer_nonce;
 
     //  Intermediary buffer used to speed up boxing and unboxing.
-    uint8_t cn_precom[crypto_box_BEFORENMBYTES];
+    uint8_t _cn_precom[crypto_box_BEFORENMBYTES];
+
+    const bool _downgrade_sub;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (curve_encoding_t)
+};
+
+class curve_mechanism_base_t : public virtual mechanism_base_t,
+                               public curve_encoding_t
+{
+  public:
+    curve_mechanism_base_t (session_base_t *session_,
+                            const options_t &options_,
+                            const char *encode_nonce_prefix_,
+                            const char *decode_nonce_prefix_,
+                            const bool downgrade_sub_);
+
+    // mechanism implementation
+    int encode (msg_t *msg_) ZMQ_OVERRIDE;
+    int decode (msg_t *msg_) ZMQ_OVERRIDE;
 };
 }
 
diff -pruN 4.3.2-2/src/curve_server.cpp 4.3.3-1/src/curve_server.cpp
--- 4.3.2-2/src/curve_server.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/curve_server.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -37,21 +37,28 @@
 #include "err.hpp"
 #include "curve_server.hpp"
 #include "wire.hpp"
+#include "secure_allocator.hpp"
 
 zmq::curve_server_t::curve_server_t (session_base_t *session_,
                                      const std::string &peer_address_,
-                                     const options_t &options_) :
+                                     const options_t &options_,
+                                     const bool downgrade_sub_) :
     mechanism_base_t (session_, options_),
     zap_client_common_handshake_t (
       session_, peer_address_, options_, sending_ready),
-    curve_mechanism_base_t (
-      session_, options_, "CurveZMQMESSAGES", "CurveZMQMESSAGEC")
+    curve_mechanism_base_t (session_,
+                            options_,
+                            "CurveZMQMESSAGES",
+                            "CurveZMQMESSAGEC",
+                            downgrade_sub_)
 {
     int rc;
     //  Fetch our secret key from socket options
     memcpy (_secret_key, options_.curve_secret_key, crypto_box_SECRETKEYBYTES);
 
     //  Generate short-term key pair
+    memset (_cn_secret, 0, crypto_box_SECRETKEYBYTES);
+    memset (_cn_public, 0, crypto_box_PUBLICKEYBYTES);
     rc = crypto_box_keypair (_cn_public, _cn_secret);
     zmq_assert (rc == 0);
 }
@@ -174,18 +181,19 @@ int zmq::curve_server_t::process_hello (
     memcpy (_cn_client, hello + 80, 32);
 
     uint8_t hello_nonce[crypto_box_NONCEBYTES];
-    uint8_t hello_plaintext[crypto_box_ZEROBYTES + 64];
+    std::vector<uint8_t, secure_allocator_t<uint8_t> > hello_plaintext (
+      crypto_box_ZEROBYTES + 64);
     uint8_t hello_box[crypto_box_BOXZEROBYTES + 80];
 
     memcpy (hello_nonce, "CurveZMQHELLO---", 16);
     memcpy (hello_nonce + 16, hello + 112, 8);
-    cn_peer_nonce = get_uint64 (hello + 112);
+    set_peer_nonce (get_uint64 (hello + 112));
 
     memset (hello_box, 0, crypto_box_BOXZEROBYTES);
     memcpy (hello_box + crypto_box_BOXZEROBYTES, hello + 120, 80);
 
     //  Open Box [64 * %x0](C'->S)
-    rc = crypto_box_open (hello_plaintext, hello_box, sizeof hello_box,
+    rc = crypto_box_open (&hello_plaintext[0], hello_box, sizeof hello_box,
                           hello_nonce, _cn_client, _secret_key);
     if (rc != 0) {
         // CURVE I: cannot open client HELLO -- wrong server key?
@@ -202,47 +210,54 @@ int zmq::curve_server_t::process_hello (
 int zmq::curve_server_t::produce_welcome (msg_t *msg_)
 {
     uint8_t cookie_nonce[crypto_secretbox_NONCEBYTES];
-    uint8_t cookie_plaintext[crypto_secretbox_ZEROBYTES + 64];
+    std::vector<uint8_t, secure_allocator_t<uint8_t> > cookie_plaintext (
+      crypto_secretbox_ZEROBYTES + 64);
     uint8_t cookie_ciphertext[crypto_secretbox_BOXZEROBYTES + 80];
 
     //  Create full nonce for encryption
     //  8-byte prefix plus 16-byte random nonce
+    memset (cookie_nonce, 0, crypto_secretbox_NONCEBYTES);
     memcpy (cookie_nonce, "COOKIE--", 8);
     randombytes (cookie_nonce + 8, 16);
 
     //  Generate cookie = Box [C' + s'](t)
-    memset (cookie_plaintext, 0, crypto_secretbox_ZEROBYTES);
-    memcpy (cookie_plaintext + crypto_secretbox_ZEROBYTES, _cn_client, 32);
-    memcpy (cookie_plaintext + crypto_secretbox_ZEROBYTES + 32, _cn_secret, 32);
+    std::fill (cookie_plaintext.begin (),
+               cookie_plaintext.begin () + crypto_secretbox_ZEROBYTES, 0);
+    memcpy (&cookie_plaintext[crypto_secretbox_ZEROBYTES], _cn_client, 32);
+    memcpy (&cookie_plaintext[crypto_secretbox_ZEROBYTES + 32], _cn_secret, 32);
 
     //  Generate fresh cookie key
+    memset (_cookie_key, 0, crypto_secretbox_KEYBYTES);
     randombytes (_cookie_key, crypto_secretbox_KEYBYTES);
 
     //  Encrypt using symmetric cookie key
     int rc =
-      crypto_secretbox (cookie_ciphertext, cookie_plaintext,
-                        sizeof cookie_plaintext, cookie_nonce, _cookie_key);
+      crypto_secretbox (cookie_ciphertext, &cookie_plaintext[0],
+                        cookie_plaintext.size (), cookie_nonce, _cookie_key);
     zmq_assert (rc == 0);
 
     uint8_t welcome_nonce[crypto_box_NONCEBYTES];
-    uint8_t welcome_plaintext[crypto_box_ZEROBYTES + 128];
+    std::vector<uint8_t, secure_allocator_t<uint8_t> > welcome_plaintext (
+      crypto_box_ZEROBYTES + 128);
     uint8_t welcome_ciphertext[crypto_box_BOXZEROBYTES + 144];
 
     //  Create full nonce for encryption
     //  8-byte prefix plus 16-byte random nonce
+    memset (welcome_nonce, 0, crypto_box_NONCEBYTES);
     memcpy (welcome_nonce, "WELCOME-", 8);
     randombytes (welcome_nonce + 8, crypto_box_NONCEBYTES - 8);
 
     //  Create 144-byte Box [S' + cookie](S->C')
-    memset (welcome_plaintext, 0, crypto_box_ZEROBYTES);
-    memcpy (welcome_plaintext + crypto_box_ZEROBYTES, _cn_public, 32);
-    memcpy (welcome_plaintext + crypto_box_ZEROBYTES + 32, cookie_nonce + 8,
+    std::fill (welcome_plaintext.begin (),
+               welcome_plaintext.begin () + crypto_box_ZEROBYTES, 0);
+    memcpy (&welcome_plaintext[crypto_box_ZEROBYTES], _cn_public, 32);
+    memcpy (&welcome_plaintext[crypto_box_ZEROBYTES + 32], cookie_nonce + 8,
             16);
-    memcpy (welcome_plaintext + crypto_box_ZEROBYTES + 48,
+    memcpy (&welcome_plaintext[crypto_box_ZEROBYTES + 48],
             cookie_ciphertext + crypto_secretbox_BOXZEROBYTES, 80);
 
-    rc = crypto_box (welcome_ciphertext, welcome_plaintext,
-                     sizeof welcome_plaintext, welcome_nonce, _cn_client,
+    rc = crypto_box (welcome_ciphertext, &welcome_plaintext[0],
+                     welcome_plaintext.size (), welcome_nonce, _cn_client,
                      _secret_key);
 
     //  TODO I think we should change this back to zmq_assert (rc == 0);
@@ -327,61 +342,59 @@ int zmq::curve_server_t::process_initiat
     const size_t clen = (size - 113) + crypto_box_BOXZEROBYTES;
 
     uint8_t initiate_nonce[crypto_box_NONCEBYTES];
-    uint8_t *initiate_plaintext =
-      static_cast<uint8_t *> (malloc (crypto_box_ZEROBYTES + clen));
-    alloc_assert (initiate_plaintext);
-    uint8_t *initiate_box =
-      static_cast<uint8_t *> (malloc (crypto_box_BOXZEROBYTES + clen));
-    alloc_assert (initiate_box);
+    std::vector<uint8_t, secure_allocator_t<uint8_t> > initiate_plaintext (
+      crypto_box_ZEROBYTES + clen);
+    std::vector<uint8_t> initiate_box (crypto_box_BOXZEROBYTES + clen);
 
     //  Open Box [C + vouch + metadata](C'->S')
-    memset (initiate_box, 0, crypto_box_BOXZEROBYTES);
-    memcpy (initiate_box + crypto_box_BOXZEROBYTES, initiate + 113,
+    std::fill (initiate_box.begin (),
+               initiate_box.begin () + crypto_box_BOXZEROBYTES, 0);
+    memcpy (&initiate_box[crypto_box_BOXZEROBYTES], initiate + 113,
             clen - crypto_box_BOXZEROBYTES);
 
     memcpy (initiate_nonce, "CurveZMQINITIATE", 16);
     memcpy (initiate_nonce + 16, initiate + 105, 8);
-    cn_peer_nonce = get_uint64 (initiate + 105);
+    set_peer_nonce (get_uint64 (initiate + 105));
 
-    const uint8_t *client_key = initiate_plaintext + crypto_box_ZEROBYTES;
+    const uint8_t *client_key = &initiate_plaintext[crypto_box_ZEROBYTES];
 
-    rc = crypto_box_open (initiate_plaintext, initiate_box, clen,
+    rc = crypto_box_open (&initiate_plaintext[0], &initiate_box[0], clen,
                           initiate_nonce, _cn_client, _cn_secret);
     if (rc != 0) {
         // CURVE I: cannot open client INITIATE
         session->get_socket ()->event_handshake_failed_protocol (
           session->get_endpoint (), ZMQ_PROTOCOL_ERROR_ZMTP_CRYPTOGRAPHIC);
         errno = EPROTO;
-        rc = -1;
-        goto exit;
+        return -1;
     }
 
     uint8_t vouch_nonce[crypto_box_NONCEBYTES];
-    uint8_t vouch_plaintext[crypto_box_ZEROBYTES + 64];
+    std::vector<uint8_t, secure_allocator_t<uint8_t> > vouch_plaintext (
+      crypto_box_ZEROBYTES + 64);
     uint8_t vouch_box[crypto_box_BOXZEROBYTES + 80];
 
     //  Open Box Box [C',S](C->S') and check contents
     memset (vouch_box, 0, crypto_box_BOXZEROBYTES);
     memcpy (vouch_box + crypto_box_BOXZEROBYTES,
-            initiate_plaintext + crypto_box_ZEROBYTES + 48, 80);
+            &initiate_plaintext[crypto_box_ZEROBYTES + 48], 80);
 
+    memset (vouch_nonce, 0, crypto_box_NONCEBYTES);
     memcpy (vouch_nonce, "VOUCH---", 8);
-    memcpy (vouch_nonce + 8, initiate_plaintext + crypto_box_ZEROBYTES + 32,
+    memcpy (vouch_nonce + 8, &initiate_plaintext[crypto_box_ZEROBYTES + 32],
             16);
 
-    rc = crypto_box_open (vouch_plaintext, vouch_box, sizeof vouch_box,
+    rc = crypto_box_open (&vouch_plaintext[0], vouch_box, sizeof vouch_box,
                           vouch_nonce, client_key, _cn_secret);
     if (rc != 0) {
         // CURVE I: cannot open client INITIATE vouch
         session->get_socket ()->event_handshake_failed_protocol (
           session->get_endpoint (), ZMQ_PROTOCOL_ERROR_ZMTP_CRYPTOGRAPHIC);
         errno = EPROTO;
-        rc = -1;
-        goto exit;
+        return -1;
     }
 
     //  What we decrypted must be the client's short-term public key
-    if (memcmp (vouch_plaintext + crypto_box_ZEROBYTES, _cn_client, 32)) {
+    if (memcmp (&vouch_plaintext[crypto_box_ZEROBYTES], _cn_client, 32)) {
         // TODO this case is very hard to test, as it would require a modified
         //  client that knows the server's secret short-term key
 
@@ -389,12 +402,12 @@ int zmq::curve_server_t::process_initiat
         session->get_socket ()->event_handshake_failed_protocol (
           session->get_endpoint (), ZMQ_PROTOCOL_ERROR_ZMTP_KEY_EXCHANGE);
         errno = EPROTO;
-        rc = -1;
-        goto exit;
+        return -1;
     }
 
     //  Precompute connection secret from client key
-    rc = crypto_box_beforenm (cn_precom, _cn_client, _cn_secret);
+    rc = crypto_box_beforenm (get_writable_precom_buffer (), _cn_client,
+                              _cn_secret);
     zmq_assert (rc == 0);
 
     //  Given this is a backward-incompatible change, it's behind a socket
@@ -410,9 +423,8 @@ int zmq::curve_server_t::process_initiat
             //  reply already, but removing this has some strange side-effect
             //  (probably because the pipe's in_active flag is true until a read
             //  is attempted)
-            rc = receive_and_process_zap_reply ();
-            if (rc == -1)
-                goto exit;
+            if (-1 == receive_and_process_zap_reply ())
+                return -1;
         } else if (!options.zap_enforce_domain) {
             //  This supports the Stonehouse pattern (encryption without
             //  authentication) in legacy mode (domain set but no handler).
@@ -420,21 +432,15 @@ int zmq::curve_server_t::process_initiat
         } else {
             session->get_socket ()->event_handshake_failed_no_detail (
               session->get_endpoint (), EFAULT);
-            rc = -1;
-            goto exit;
+            return -1;
         }
     } else {
         //  This supports the Stonehouse pattern (encryption without authentication).
         state = sending_ready;
     }
 
-    rc = parse_metadata (initiate_plaintext + crypto_box_ZEROBYTES + 128,
-                         clen - crypto_box_ZEROBYTES - 128);
-
-exit:
-    free (initiate_plaintext);
-    free (initiate_box);
-    return rc;
+    return parse_metadata (&initiate_plaintext[crypto_box_ZEROBYTES + 128],
+                           clen - crypto_box_ZEROBYTES - 128);
 }
 
 int zmq::curve_server_t::produce_ready (msg_t *msg_)
@@ -442,30 +448,27 @@ int zmq::curve_server_t::produce_ready (
     const size_t metadata_length = basic_properties_len ();
     uint8_t ready_nonce[crypto_box_NONCEBYTES];
 
-    uint8_t *ready_plaintext =
-      static_cast<uint8_t *> (malloc (crypto_box_ZEROBYTES + metadata_length));
-    alloc_assert (ready_plaintext);
+    std::vector<uint8_t, secure_allocator_t<uint8_t> > ready_plaintext (
+      crypto_box_ZEROBYTES + metadata_length);
 
     //  Create Box [metadata](S'->C')
-    memset (ready_plaintext, 0, crypto_box_ZEROBYTES);
-    uint8_t *ptr = ready_plaintext + crypto_box_ZEROBYTES;
+    std::fill (ready_plaintext.begin (),
+               ready_plaintext.begin () + crypto_box_ZEROBYTES, 0);
+    uint8_t *ptr = &ready_plaintext[crypto_box_ZEROBYTES];
 
     ptr += add_basic_properties (ptr, metadata_length);
-    const size_t mlen = ptr - ready_plaintext;
+    const size_t mlen = ptr - &ready_plaintext[0];
 
     memcpy (ready_nonce, "CurveZMQREADY---", 16);
-    put_uint64 (ready_nonce + 16, cn_nonce);
+    put_uint64 (ready_nonce + 16, get_and_inc_nonce ());
 
-    uint8_t *ready_box = static_cast<uint8_t *> (
-      malloc (crypto_box_BOXZEROBYTES + 16 + metadata_length));
-    alloc_assert (ready_box);
+    std::vector<uint8_t> ready_box (crypto_box_BOXZEROBYTES + 16
+                                    + metadata_length);
 
-    int rc = crypto_box_afternm (ready_box, ready_plaintext, mlen, ready_nonce,
-                                 cn_precom);
+    int rc = crypto_box_afternm (&ready_box[0], &ready_plaintext[0], mlen,
+                                 ready_nonce, get_precom_buffer ());
     zmq_assert (rc == 0);
 
-    free (ready_plaintext);
-
     rc = msg_->init_size (14 + mlen - crypto_box_BOXZEROBYTES);
     errno_assert (rc == 0);
 
@@ -475,11 +478,8 @@ int zmq::curve_server_t::produce_ready (
     //  Short nonce, prefixed by "CurveZMQREADY---"
     memcpy (ready + 6, ready_nonce + 16, 8);
     //  Box [metadata](S'->C')
-    memcpy (ready + 14, ready_box + crypto_box_BOXZEROBYTES,
+    memcpy (ready + 14, &ready_box[crypto_box_BOXZEROBYTES],
             mlen - crypto_box_BOXZEROBYTES);
-    free (ready_box);
-
-    cn_nonce++;
 
     return 0;
 }
diff -pruN 4.3.2-2/src/curve_server.hpp 4.3.3-1/src/curve_server.hpp
--- 4.3.2-2/src/curve_server.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/curve_server.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -42,20 +42,21 @@ namespace zmq
 #pragma warning(push)
 #pragma warning(disable : 4250)
 #endif
-class curve_server_t : public zap_client_common_handshake_t,
-                       public curve_mechanism_base_t
+class curve_server_t ZMQ_FINAL : public zap_client_common_handshake_t,
+                                 public curve_mechanism_base_t
 {
   public:
     curve_server_t (session_base_t *session_,
                     const std::string &peer_address_,
-                    const options_t &options_);
-    virtual ~curve_server_t ();
+                    const options_t &options_,
+                    const bool downgrade_sub_);
+    ~curve_server_t ();
 
     // mechanism implementation
-    virtual int next_handshake_command (msg_t *msg_);
-    virtual int process_handshake_command (msg_t *msg_);
-    virtual int encode (msg_t *msg_);
-    virtual int decode (msg_t *msg_);
+    int next_handshake_command (msg_t *msg_);
+    int process_handshake_command (msg_t *msg_);
+    int encode (msg_t *msg_);
+    int decode (msg_t *msg_);
 
   private:
     //  Our secret key (s)
diff -pruN 4.3.2-2/src/dbuffer.hpp 4.3.3-1/src/dbuffer.hpp
--- 4.3.2-2/src/dbuffer.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/dbuffer.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -58,39 +58,34 @@ template <typename T> class dbuffer_t;
 template <> class dbuffer_t<msg_t>
 {
   public:
-    inline dbuffer_t () :
-        _back (&_storage[0]),
-        _front (&_storage[1]),
-        _has_msg (false)
+    dbuffer_t () : _back (&_storage[0]), _front (&_storage[1]), _has_msg (false)
     {
         _back->init ();
         _front->init ();
     }
 
-    inline ~dbuffer_t ()
+    ~dbuffer_t ()
     {
         _back->close ();
         _front->close ();
     }
 
-    inline void write (const msg_t &value_)
+    void write (const msg_t &value_)
     {
-        msg_t &xvalue = const_cast<msg_t &> (value_);
-
-        zmq_assert (xvalue.check ());
-        _back->move (xvalue); // cannot just overwrite, might leak
+        zmq_assert (value_.check ());
+        *_back = value_;
 
         zmq_assert (_back->check ());
 
         if (_sync.try_lock ()) {
-            std::swap (_back, _front);
+            _front->move (*_back);
             _has_msg = true;
 
             _sync.unlock ();
         }
     }
 
-    inline bool read (msg_t *value_)
+    bool read (msg_t *value_)
     {
         if (!value_)
             return false;
@@ -111,14 +106,14 @@ template <> class dbuffer_t<msg_t>
     }
 
 
-    inline bool check_read ()
+    bool check_read ()
     {
         scoped_lock_t lock (_sync);
 
         return _has_msg;
     }
 
-    inline bool probe (bool (*fn_) (const msg_t &))
+    bool probe (bool (*fn_) (const msg_t &))
     {
         scoped_lock_t lock (_sync);
         return (*fn_) (*_front);
@@ -132,9 +127,7 @@ template <> class dbuffer_t<msg_t>
     mutex_t _sync;
     bool _has_msg;
 
-    //  Disable copying of dbuffer.
-    dbuffer_t (const dbuffer_t &);
-    const dbuffer_t &operator= (const dbuffer_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (dbuffer_t)
 };
 }
 
diff -pruN 4.3.2-2/src/dealer.cpp 4.3.3-1/src/dealer.cpp
--- 4.3.2-2/src/dealer.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/dealer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -38,6 +38,7 @@ zmq::dealer_t::dealer_t (class ctx_t *pa
     _probe_router (false)
 {
     options.type = ZMQ_DEALER;
+    options.can_send_hello_msg = true;
 }
 
 zmq::dealer_t::~dealer_t ()
@@ -76,7 +77,7 @@ int zmq::dealer_t::xsetsockopt (int opti
                                 const void *optval_,
                                 size_t optvallen_)
 {
-    bool is_int = (optvallen_ == sizeof (int));
+    const bool is_int = (optvallen_ == sizeof (int));
     int value = 0;
     if (is_int)
         memcpy (&value, optval_, sizeof (int));
diff -pruN 4.3.2-2/src/dealer.hpp 4.3.3-1/src/dealer.hpp
--- 4.3.2-2/src/dealer.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/dealer.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -47,21 +47,23 @@ class dealer_t : public socket_base_t
 {
   public:
     dealer_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
-    ~dealer_t ();
+    ~dealer_t () ZMQ_OVERRIDE;
 
   protected:
     //  Overrides of functions from socket_base_t.
     void xattach_pipe (zmq::pipe_t *pipe_,
                        bool subscribe_to_all_,
-                       bool locally_initiated_);
-    int xsetsockopt (int option_, const void *optval_, size_t optvallen_);
-    int xsend (zmq::msg_t *msg_);
-    int xrecv (zmq::msg_t *msg_);
-    bool xhas_in ();
-    bool xhas_out ();
-    void xread_activated (zmq::pipe_t *pipe_);
-    void xwrite_activated (zmq::pipe_t *pipe_);
-    void xpipe_terminated (zmq::pipe_t *pipe_);
+                       bool locally_initiated_) ZMQ_FINAL;
+    int xsetsockopt (int option_,
+                     const void *optval_,
+                     size_t optvallen_) ZMQ_OVERRIDE;
+    int xsend (zmq::msg_t *msg_) ZMQ_OVERRIDE;
+    int xrecv (zmq::msg_t *msg_) ZMQ_OVERRIDE;
+    bool xhas_in () ZMQ_OVERRIDE;
+    bool xhas_out () ZMQ_OVERRIDE;
+    void xread_activated (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    void xwrite_activated (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    void xpipe_terminated (zmq::pipe_t *pipe_) ZMQ_OVERRIDE;
 
     //  Send and recv - knowing which pipe was used.
     int sendpipe (zmq::msg_t *msg_, zmq::pipe_t **pipe_);
@@ -76,8 +78,7 @@ class dealer_t : public socket_base_t
     // if true, send an empty message to every connected router peer
     bool _probe_router;
 
-    dealer_t (const dealer_t &);
-    const dealer_t &operator= (const dealer_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (dealer_t)
 };
 }
 
diff -pruN 4.3.2-2/src/decoder_allocators.cpp 4.3.3-1/src/decoder_allocators.cpp
--- 4.3.2-2/src/decoder_allocators.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/decoder_allocators.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,8 +30,6 @@
 #include "precompiled.hpp"
 #include "decoder_allocators.hpp"
 
-#include <cmath>
-
 #include "msg.hpp"
 
 zmq::shared_message_memory_allocator::shared_message_memory_allocator (
@@ -40,9 +38,7 @@ zmq::shared_message_memory_allocator::sh
     _buf_size (0),
     _max_size (bufsize_),
     _msg_content (NULL),
-    _max_counters (static_cast<size_t> (
-      std::ceil (static_cast<double> (_max_size)
-                 / static_cast<double> (msg_t::max_vsm_size))))
+    _max_counters ((_max_size + msg_t::max_vsm_size - 1) / msg_t::max_vsm_size)
 {
 }
 
diff -pruN 4.3.2-2/src/decoder_allocators.hpp 4.3.3-1/src/decoder_allocators.hpp
--- 4.3.2-2/src/decoder_allocators.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/decoder_allocators.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -58,14 +58,14 @@ class c_single_allocator
 
     std::size_t size () const { return _buf_size; }
 
-    void resize (std::size_t new_size_) { _buf_size = new_size_; }
+    //  This buffer is fixed, size must not be changed
+    void resize (std::size_t new_size_) { LIBZMQ_UNUSED (new_size_); }
 
   private:
     std::size_t _buf_size;
     unsigned char *_buf;
 
-    c_single_allocator (c_single_allocator const &);
-    c_single_allocator &operator= (c_single_allocator const &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (c_single_allocator)
 };
 
 // This allocator allocates a reference counted buffer which is used by v2_decoder_t
@@ -103,7 +103,7 @@ class shared_message_memory_allocator
 
     void inc_ref ();
 
-    static void call_dec_ref (void *, void *buffer_);
+    static void call_dec_ref (void *, void *hint_);
 
     std::size_t size () const;
 
diff -pruN 4.3.2-2/src/decoder.hpp 4.3.3-1/src/decoder.hpp
--- 4.3.2-2/src/decoder.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/decoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -66,12 +66,10 @@ class decoder_base_t : public i_decoder
         _buf = _allocator.allocate ();
     }
 
-    //  The destructor doesn't have to be virtual. It is made virtual
-    //  just to keep ICC and code checking tools from complaining.
-    virtual ~decoder_base_t () { _allocator.deallocate (); }
+    ~decoder_base_t () ZMQ_OVERRIDE { _allocator.deallocate (); }
 
     //  Returns a buffer to be filled with binary data.
-    void get_buffer (unsigned char **data_, std::size_t *size_)
+    void get_buffer (unsigned char **data_, std::size_t *size_) ZMQ_FINAL
     {
         _buf = _allocator.allocate ();
 
@@ -101,7 +99,7 @@ class decoder_base_t : public i_decoder
     //  Number of bytes processed is returned in bytes_used_.
     int decode (const unsigned char *data_,
                 std::size_t size_,
-                std::size_t &bytes_used_)
+                std::size_t &bytes_used_) ZMQ_FINAL
     {
         bytes_used_ = 0;
 
@@ -149,7 +147,7 @@ class decoder_base_t : public i_decoder
         return 0;
     }
 
-    virtual void resize_buffer (std::size_t new_size_)
+    void resize_buffer (std::size_t new_size_) ZMQ_FINAL
     {
         _allocator.resize (new_size_);
     }
@@ -186,8 +184,7 @@ class decoder_base_t : public i_decoder
     A _allocator;
     unsigned char *_buf;
 
-    decoder_base_t (const decoder_base_t &);
-    const decoder_base_t &operator= (const decoder_base_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (decoder_base_t)
 };
 }
 
diff -pruN 4.3.2-2/src/devpoll.hpp 4.3.3-1/src/devpoll.hpp
--- 4.3.2-2/src/devpoll.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/devpoll.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -47,13 +47,13 @@ struct i_poll_events;
 
 //  Implements socket polling mechanism using the "/dev/poll" interface.
 
-class devpoll_t : public worker_poller_base_t
+class devpoll_t ZMQ_FINAL : public worker_poller_base_t
 {
   public:
     typedef fd_t handle_t;
 
     devpoll_t (const thread_ctx_t &ctx_);
-    ~devpoll_t ();
+    ~devpoll_t () ZMQ_FINAL;
 
     //  "poller" concept.
     handle_t add_fd (fd_t fd_, zmq::i_poll_events *events_);
@@ -68,7 +68,7 @@ class devpoll_t : public worker_poller_b
 
   private:
     //  Main event loop.
-    void loop ();
+    void loop () ZMQ_FINAL;
 
     //  File descriptor referring to "/dev/poll" pseudo-device.
     fd_t devpoll_fd;
@@ -90,8 +90,7 @@ class devpoll_t : public worker_poller_b
     //  Pollset manipulation function.
     void devpoll_ctl (fd_t fd_, short events_);
 
-    devpoll_t (const devpoll_t &);
-    const devpoll_t &operator= (const devpoll_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (devpoll_t)
 };
 
 typedef devpoll_t poller_t;
diff -pruN 4.3.2-2/src/dgram.cpp 4.3.3-1/src/dgram.cpp
--- 4.3.2-2/src/dgram.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/dgram.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -94,7 +94,7 @@ int zmq::dgram_t::xsend (msg_t *msg_)
 {
     // If there's no out pipe, just drop it.
     if (!_pipe) {
-        int rc = msg_->close ();
+        const int rc = msg_->close ();
         errno_assert (rc == 0);
         return -1;
     }
@@ -127,7 +127,7 @@ int zmq::dgram_t::xsend (msg_t *msg_)
     _more_out = !_more_out;
 
     //  Detach the message from the data buffer.
-    int rc = msg_->init ();
+    const int rc = msg_->init ();
     errno_assert (rc == 0);
 
     return 0;
diff -pruN 4.3.2-2/src/dgram.hpp 4.3.3-1/src/dgram.hpp
--- 4.3.2-2/src/dgram.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/dgram.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,7 @@ class msg_t;
 class pipe_t;
 class io_thread_t;
 
-class dgram_t : public socket_base_t
+class dgram_t ZMQ_FINAL : public socket_base_t
 {
   public:
     dgram_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -67,8 +67,7 @@ class dgram_t : public socket_base_t
     //  If true, more outgoing message parts are expected.
     bool _more_out;
 
-    dgram_t (const dgram_t &);
-    const dgram_t &operator= (const dgram_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (dgram_t)
 };
 }
 
diff -pruN 4.3.2-2/src/dish.cpp 4.3.3-1/src/dish.cpp
--- 4.3.2-2/src/dish.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/dish.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -44,13 +44,13 @@ zmq::dish_t::dish_t (class ctx_t *parent
     //  subscription commands are sent to the wire.
     options.linger.store (0);
 
-    int rc = _message.init ();
+    const int rc = _message.init ();
     errno_assert (rc == 0);
 }
 
 zmq::dish_t::~dish_t ()
 {
-    int rc = _message.close ();
+    const int rc = _message.close ();
     errno_assert (rc == 0);
 }
 
@@ -93,7 +93,7 @@ void zmq::dish_t::xhiccuped (pipe_t *pip
 
 int zmq::dish_t::xjoin (const char *group_)
 {
-    std::string group = std::string (group_);
+    const std::string group = std::string (group_);
 
     if (group.length () > ZMQ_GROUP_MAX_LENGTH) {
         errno = EINVAL;
@@ -117,7 +117,7 @@ int zmq::dish_t::xjoin (const char *grou
     rc = _dist.send_to_all (&msg);
     if (rc != 0)
         err = errno;
-    int rc2 = msg.close ();
+    const int rc2 = msg.close ();
     errno_assert (rc2 == 0);
     if (rc != 0)
         errno = err;
@@ -126,7 +126,7 @@ int zmq::dish_t::xjoin (const char *grou
 
 int zmq::dish_t::xleave (const char *group_)
 {
-    std::string group = std::string (group_);
+    const std::string group = std::string (group_);
 
     if (group.length () > ZMQ_GROUP_MAX_LENGTH) {
         errno = EINVAL;
@@ -149,7 +149,7 @@ int zmq::dish_t::xleave (const char *gro
     rc = _dist.send_to_all (&msg);
     if (rc != 0)
         err = errno;
-    int rc2 = msg.close ();
+    const int rc2 = msg.close ();
     errno_assert (rc2 == 0);
     if (rc != 0)
         errno = err;
@@ -233,7 +233,6 @@ void zmq::dish_t::send_subscriptions (pi
 
         //  Send it to the pipe.
         pipe_->write (&msg);
-        msg.close ();
     }
 
     pipe_->flush ();
@@ -269,7 +268,7 @@ int zmq::dish_session_t::push_msg (msg_t
         _group_msg = *msg_;
         _state = body;
 
-        int rc = msg_->init ();
+        const int rc = msg_->init ();
         errno_assert (rc == 0);
         return 0;
     }
@@ -312,7 +311,7 @@ int zmq::dish_session_t::pull_msg (msg_t
     if (!msg_->is_join () && !msg_->is_leave ())
         return rc;
 
-    int group_length = static_cast<int> (strlen (msg_->group ()));
+    const int group_length = static_cast<int> (strlen (msg_->group ()));
 
     msg_t command;
     int offset;
diff -pruN 4.3.2-2/src/dish.hpp 4.3.3-1/src/dish.hpp
--- 4.3.2-2/src/dish.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/dish.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -44,7 +44,7 @@ class ctx_t;
 class pipe_t;
 class io_thread_t;
 
-class dish_t : public socket_base_t
+class dish_t ZMQ_FINAL : public socket_base_t
 {
   public:
     dish_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -87,11 +87,10 @@ class dish_t : public socket_base_t
     bool _has_message;
     msg_t _message;
 
-    dish_t (const dish_t &);
-    const dish_t &operator= (const dish_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (dish_t)
 };
 
-class dish_session_t : public session_base_t
+class dish_session_t ZMQ_FINAL : public session_base_t
 {
   public:
     dish_session_t (zmq::io_thread_t *io_thread_,
@@ -115,8 +114,7 @@ class dish_session_t : public session_ba
 
     msg_t _group_msg;
 
-    dish_session_t (const dish_session_t &);
-    const dish_session_t &operator= (const dish_session_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (dish_session_t)
 };
 }
 
diff -pruN 4.3.2-2/src/dist.cpp 4.3.3-1/src/dist.cpp
--- 4.3.2-2/src/dist.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/dist.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -81,7 +81,7 @@ void zmq::dist_t::match (pipe_t *pipe_)
 
 void zmq::dist_t::reverse_match ()
 {
-    pipes_t::size_type prev_matching = _matching;
+    const pipes_t::size_type prev_matching = _matching;
 
     // Reset matching to 0
     unmatch ();
@@ -145,7 +145,7 @@ int zmq::dist_t::send_to_all (msg_t *msg
 int zmq::dist_t::send_to_matching (msg_t *msg_)
 {
     //  Is this end of a multipart message?
-    bool msg_more = (msg_->flags () & msg_t::more) != 0;
+    const bool msg_more = (msg_->flags () & msg_t::more) != 0;
 
     //  Push the message to matching pipes.
     distribute (msg_);
@@ -171,12 +171,14 @@ void zmq::dist_t::distribute (msg_t *msg
     }
 
     if (msg_->is_vsm ()) {
-        for (pipes_t::size_type i = 0; i < _matching; ++i)
-            if (!write (_pipes[i], msg_))
-                --i; //  Retry last write because index will have been swapped
-        int rc = msg_->close ();
-        errno_assert (rc == 0);
-        rc = msg_->init ();
+        for (pipes_t::size_type i = 0; i < _matching;) {
+            if (!write (_pipes[i], msg_)) {
+                //  Use same index again because entry will have been removed.
+            } else {
+                ++i;
+            }
+        }
+        int rc = msg_->init ();
         errno_assert (rc == 0);
         return;
     }
@@ -187,17 +189,20 @@ void zmq::dist_t::distribute (msg_t *msg
 
     //  Push copy of the message to each matching pipe.
     int failed = 0;
-    for (pipes_t::size_type i = 0; i < _matching; ++i)
+    for (pipes_t::size_type i = 0; i < _matching;) {
         if (!write (_pipes[i], msg_)) {
             ++failed;
-            --i; //  Retry last write because index will have been swapped
+            //  Use same index again because entry will have been removed.
+        } else {
+            ++i;
         }
+    }
     if (unlikely (failed))
         msg_->rm_refs (failed);
 
     //  Detach the original message from the data buffer. Note that we don't
     //  close the message. That's because we've already used all the references.
-    int rc = msg_->init ();
+    const int rc = msg_->init ();
     errno_assert (rc == 0);
 }
 
diff -pruN 4.3.2-2/src/dist.hpp 4.3.3-1/src/dist.hpp
--- 4.3.2-2/src/dist.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/dist.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -33,6 +33,7 @@
 #include <vector>
 
 #include "array.hpp"
+#include "macros.hpp"
 
 namespace zmq
 {
@@ -72,7 +73,7 @@ class dist_t
     //  Send the message to all the outbound pipes.
     int send_to_all (zmq::msg_t *msg_);
 
-    bool has_out ();
+    static bool has_out ();
 
     // check HWM of all pipes matching
     bool check_hwm ();
@@ -107,8 +108,7 @@ class dist_t
     //  True if last we are in the middle of a multipart message.
     bool _more;
 
-    dist_t (const dist_t &);
-    const dist_t &operator= (const dist_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (dist_t)
 };
 }
 
diff -pruN 4.3.2-2/src/encoder.hpp 4.3.3-1/src/encoder.hpp
--- 4.3.2-2/src/encoder.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/encoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -54,7 +54,7 @@ namespace zmq
 template <typename T> class encoder_base_t : public i_encoder
 {
   public:
-    inline explicit encoder_base_t (size_t bufsize_) :
+    explicit encoder_base_t (size_t bufsize_) :
         _write_pos (0),
         _to_write (0),
         _next (NULL),
@@ -66,17 +66,15 @@ template <typename T> class encoder_base
         alloc_assert (_buf);
     }
 
-    //  The destructor doesn't have to be virtual. It is made virtual
-    //  just to keep ICC and code checking tools from complaining.
-    inline virtual ~encoder_base_t () { free (_buf); }
+    ~encoder_base_t () ZMQ_OVERRIDE { free (_buf); }
 
     //  The function returns a batch of binary data. The data
     //  are filled to a supplied buffer. If no buffer is supplied (data_
     //  points to NULL) decoder object will provide buffer of its own.
-    inline size_t encode (unsigned char **data_, size_t size_)
+    size_t encode (unsigned char **data_, size_t size_) ZMQ_FINAL
     {
         unsigned char *buffer = !*data_ ? _buf : *data_;
-        size_t buffersize = !*data_ ? _buf_size : size_;
+        const size_t buffersize = !*data_ ? _buf_size : size_;
 
         if (in_progress () == NULL)
             return 0;
@@ -117,7 +115,7 @@ template <typename T> class encoder_base
             }
 
             //  Copy data to the buffer. If the buffer is full, return.
-            size_t to_copy = std::min (_to_write, buffersize - pos);
+            const size_t to_copy = std::min (_to_write, buffersize - pos);
             memcpy (buffer + pos, _write_pos, to_copy);
             pos += to_copy;
             _write_pos += to_copy;
@@ -128,7 +126,7 @@ template <typename T> class encoder_base
         return pos;
     }
 
-    void load_msg (msg_t *msg_)
+    void load_msg (msg_t *msg_) ZMQ_FINAL
     {
         zmq_assert (in_progress () == NULL);
         _in_progress = msg_;
@@ -141,10 +139,10 @@ template <typename T> class encoder_base
 
     //  This function should be called from derived class to write the data
     //  to the buffer and schedule next state machine action.
-    inline void next_step (void *write_pos_,
-                           size_t to_write_,
-                           step_t next_,
-                           bool new_msg_flag_)
+    void next_step (void *write_pos_,
+                    size_t to_write_,
+                    step_t next_,
+                    bool new_msg_flag_)
     {
         _write_pos = static_cast<unsigned char *> (write_pos_);
         _to_write = to_write_;
@@ -171,10 +169,9 @@ template <typename T> class encoder_base
     const size_t _buf_size;
     unsigned char *const _buf;
 
-    encoder_base_t (const encoder_base_t &);
-    void operator= (const encoder_base_t &);
-
     msg_t *_in_progress;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (encoder_base_t)
 };
 }
 
diff -pruN 4.3.2-2/src/epoll.cpp 4.3.3-1/src/epoll.cpp
--- 4.3.2-2/src/epoll.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/epoll.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -96,7 +96,7 @@ zmq::epoll_t::handle_t zmq::epoll_t::add
     pe->ev.data.ptr = pe;
     pe->events = events_;
 
-    int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_ADD, fd_, &pe->ev);
+    const int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_ADD, fd_, &pe->ev);
     errno_assert (rc != -1);
 
     //  Increase the load metric of the thread.
@@ -109,7 +109,7 @@ void zmq::epoll_t::rm_fd (handle_t handl
 {
     check_thread ();
     poll_entry_t *pe = static_cast<poll_entry_t *> (handle_);
-    int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_DEL, pe->fd, &pe->ev);
+    const int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_DEL, pe->fd, &pe->ev);
     errno_assert (rc != -1);
     pe->fd = retired_fd;
     _retired.push_back (pe);
@@ -123,7 +123,7 @@ void zmq::epoll_t::set_pollin (handle_t
     check_thread ();
     poll_entry_t *pe = static_cast<poll_entry_t *> (handle_);
     pe->ev.events |= EPOLLIN;
-    int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_MOD, pe->fd, &pe->ev);
+    const int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_MOD, pe->fd, &pe->ev);
     errno_assert (rc != -1);
 }
 
@@ -132,7 +132,7 @@ void zmq::epoll_t::reset_pollin (handle_
     check_thread ();
     poll_entry_t *pe = static_cast<poll_entry_t *> (handle_);
     pe->ev.events &= ~(static_cast<short> (EPOLLIN));
-    int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_MOD, pe->fd, &pe->ev);
+    const int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_MOD, pe->fd, &pe->ev);
     errno_assert (rc != -1);
 }
 
@@ -141,7 +141,7 @@ void zmq::epoll_t::set_pollout (handle_t
     check_thread ();
     poll_entry_t *pe = static_cast<poll_entry_t *> (handle_);
     pe->ev.events |= EPOLLOUT;
-    int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_MOD, pe->fd, &pe->ev);
+    const int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_MOD, pe->fd, &pe->ev);
     errno_assert (rc != -1);
 }
 
@@ -150,7 +150,7 @@ void zmq::epoll_t::reset_pollout (handle
     check_thread ();
     poll_entry_t *pe = static_cast<poll_entry_t *> (handle_);
     pe->ev.events &= ~(static_cast<short> (EPOLLOUT));
-    int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_MOD, pe->fd, &pe->ev);
+    const int rc = epoll_ctl (_epoll_fd, EPOLL_CTL_MOD, pe->fd, &pe->ev);
     errno_assert (rc != -1);
 }
 
@@ -170,7 +170,7 @@ void zmq::epoll_t::loop ()
 
     while (true) {
         //  Execute any due timers.
-        int timeout = static_cast<int> (execute_timers ());
+        const int timeout = static_cast<int> (execute_timers ());
 
         if (get_load () == 0) {
             if (timeout == 0)
@@ -181,16 +181,16 @@ void zmq::epoll_t::loop ()
         }
 
         //  Wait for events.
-        int n = epoll_wait (_epoll_fd, &ev_buf[0], max_io_events,
-                            timeout ? timeout : -1);
+        const int n = epoll_wait (_epoll_fd, &ev_buf[0], max_io_events,
+                                  timeout ? timeout : -1);
         if (n == -1) {
             errno_assert (errno == EINTR);
             continue;
         }
 
         for (int i = 0; i < n; i++) {
-            poll_entry_t *pe =
-              (static_cast<poll_entry_t *> (ev_buf[i].data.ptr));
+            const poll_entry_t *const pe =
+              static_cast<const poll_entry_t *> (ev_buf[i].data.ptr);
 
             if (pe->fd == retired_fd)
                 continue;
diff -pruN 4.3.2-2/src/epoll.hpp 4.3.3-1/src/epoll.hpp
--- 4.3.2-2/src/epoll.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/epoll.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -55,13 +55,13 @@ struct i_poll_events;
 //  This class implements socket polling mechanism using the Linux-specific
 //  epoll mechanism.
 
-class epoll_t : public worker_poller_base_t
+class epoll_t ZMQ_FINAL : public worker_poller_base_t
 {
   public:
     typedef void *handle_t;
 
     epoll_t (const thread_ctx_t &ctx_);
-    ~epoll_t ();
+    ~epoll_t () ZMQ_OVERRIDE;
 
     //  "poller" concept.
     handle_t add_fd (fd_t fd_, zmq::i_poll_events *events_);
@@ -103,8 +103,7 @@ class epoll_t : public worker_poller_bas
     typedef std::vector<poll_entry_t *> retired_t;
     retired_t _retired;
 
-    epoll_t (const epoll_t &);
-    const epoll_t &operator= (const epoll_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (epoll_t)
 };
 
 typedef epoll_t poller_t;
diff -pruN 4.3.2-2/src/err.cpp 4.3.3-1/src/err.cpp
--- 4.3.2-2/src/err.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/err.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -211,14 +211,14 @@ const char *zmq::wsa_error_no (int no_,
 
 void zmq::win_error (char *buffer_, size_t buffer_size_)
 {
-    DWORD errcode = GetLastError ();
+    const DWORD errcode = GetLastError ();
 #if defined _WIN32_WCE
     DWORD rc = FormatMessageW (
       FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, errcode,
       MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT), (LPWSTR) buffer_,
       buffer_size_ / sizeof (wchar_t), NULL);
 #else
-    DWORD rc = FormatMessageA (
+    const DWORD rc = FormatMessageA (
       FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, errcode,
       MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT), buffer_,
       static_cast<DWORD> (buffer_size_), NULL);
@@ -411,6 +411,7 @@ void zmq::print_backtrace (void)
     while (unw_step (&cursor) > 0) {
         unw_word_t offset;
         unw_proc_info_t p_info;
+        static const char unknown[] = "?";
         const char *file_name;
         char *demangled_name;
         char func_name[256] = "";
@@ -422,14 +423,14 @@ void zmq::print_backtrace (void)
 
         rc = unw_get_proc_name (&cursor, func_name, 256, &offset);
         if (rc == -UNW_ENOINFO)
-            strcpy (func_name, "?");
+            memcpy (func_name, unknown, sizeof unknown);
 
         addr = (void *) (p_info.start_ip + offset);
 
         if (dladdr (addr, &dl_info) && dl_info.dli_fname)
             file_name = dl_info.dli_fname;
         else
-            file_name = "?";
+            file_name = unknown;
 
         demangled_name = abi::__cxa_demangle (func_name, NULL, NULL, &rc);
 
diff -pruN 4.3.2-2/src/err.hpp 4.3.3-1/src/err.hpp
--- 4.3.2-2/src/err.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/err.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -59,6 +59,8 @@ const char *errno_to_string (int errno_)
 #if defined __clang__
 #if __has_feature(attribute_analyzer_noreturn)
 void zmq_abort (const char *errmsg_) __attribute__ ((analyzer_noreturn));
+#else
+void zmq_abort (const char *errmsg_);
 #endif
 #elif defined __MSCVER__
 __declspec(noreturn) void zmq_abort (const char *errmsg_);
diff -pruN 4.3.2-2/src/fd.hpp 4.3.3-1/src/fd.hpp
--- 4.3.2-2/src/fd.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/fd.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,18 +36,15 @@
 
 namespace zmq
 {
+typedef zmq_fd_t fd_t;
+
 #ifdef ZMQ_HAVE_WINDOWS
 #if defined _MSC_VER && _MSC_VER <= 1400
-///< \todo zmq.h uses SOCKET unconditionally, so probably VS versions before
-/// VS2008 are unsupported anyway. Apart from that, this seems to depend on
-/// the Windows SDK version rather than the VS version.
-typedef UINT_PTR fd_t;
 enum
 {
     retired_fd = (fd_t) (~0)
 };
 #else
-typedef SOCKET fd_t;
 enum
 #if _MSC_VER >= 1800
   : fd_t
@@ -57,7 +54,6 @@ enum
 };
 #endif
 #else
-typedef int fd_t;
 enum
 {
     retired_fd = -1
diff -pruN 4.3.2-2/src/fq.cpp 4.3.3-1/src/fq.cpp
--- 4.3.2-2/src/fq.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/fq.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -90,7 +90,7 @@ int zmq::fq_t::recvpipe (msg_t *msg_, pi
     while (_active > 0) {
         //  Try to fetch new message. If we've already read part of the message
         //  subsequent part should be immediately available.
-        bool fetched = _pipes[_current]->read (msg_);
+        const bool fetched = _pipes[_current]->read (msg_);
 
         //  Note that when message is not fetched, current pipe is deactivated
         //  and replaced by another active pipe. Thus we don't have to increase
diff -pruN 4.3.2-2/src/fq.hpp 4.3.3-1/src/fq.hpp
--- 4.3.2-2/src/fq.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/fq.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -77,8 +77,7 @@ class fq_t
     //  there are following parts still waiting in the current pipe.
     bool _more;
 
-    fq_t (const fq_t &);
-    const fq_t &operator= (const fq_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (fq_t)
 };
 }
 
diff -pruN 4.3.2-2/src/gather.hpp 4.3.3-1/src/gather.hpp
--- 4.3.2-2/src/gather.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/gather.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,7 +39,7 @@ class ctx_t;
 class pipe_t;
 class msg_t;
 
-class gather_t : public socket_base_t
+class gather_t ZMQ_FINAL : public socket_base_t
 {
   public:
     gather_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -59,8 +59,7 @@ class gather_t : public socket_base_t
     //  Fair queueing object for inbound pipes.
     fq_t _fq;
 
-    gather_t (const gather_t &);
-    const gather_t &operator= (const gather_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (gather_t)
 };
 }
 
diff -pruN 4.3.2-2/src/generic_mtrie.hpp 4.3.3-1/src/generic_mtrie.hpp
--- 4.3.2-2/src/generic_mtrie.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/generic_mtrie.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -33,6 +33,7 @@ along with this program.  If not, see <h
 #include <stddef.h>
 #include <set>
 
+#include "macros.hpp"
 #include "stdint.hpp"
 
 namespace zmq
@@ -83,27 +84,6 @@ template <typename T> class generic_mtri
                 Arg arg_);
 
   private:
-    bool add_helper (prefix_t prefix_, size_t size_, value_t *value_);
-    template <typename Arg>
-    void rm_helper (value_t *value_,
-                    unsigned char **buff_,
-                    size_t buffsize_,
-                    size_t maxbuffsize_,
-                    void (*func_) (prefix_t data_, size_t size_, Arg arg_),
-                    Arg arg_,
-                    bool call_on_uniq_);
-    template <typename Arg>
-    void rm_helper_multiple_subnodes (unsigned char **buff_,
-                                      size_t buffsize_,
-                                      size_t maxbuffsize_,
-                                      void (*func_) (prefix_t data_,
-                                                     size_t size_,
-                                                     Arg arg_),
-                                      Arg arg_,
-                                      bool call_on_uniq_,
-                                      value_t *pipe_);
-
-    rm_result rm_helper (prefix_t prefix_, size_t size_, value_t *value_);
     bool is_redundant () const;
 
     typedef std::set<value_t *> pipes_t;
@@ -112,15 +92,25 @@ template <typename T> class generic_mtri
     unsigned char _min;
     unsigned short _count;
     unsigned short _live_nodes;
-    union
+    union _next_t
     {
         class generic_mtrie_t<value_t> *node;
         class generic_mtrie_t<value_t> **table;
     } _next;
 
-    generic_mtrie_t (const generic_mtrie_t<value_t> &);
-    const generic_mtrie_t<value_t> &
-    operator= (const generic_mtrie_t<value_t> &);
+    struct iter
+    {
+        generic_mtrie_t<value_t> *node;
+        generic_mtrie_t<value_t> *next_node;
+        prefix_t prefix;
+        size_t size;
+        unsigned short current_child;
+        unsigned char new_min;
+        unsigned char new_max;
+        bool processed_for_removal;
+    };
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (generic_mtrie_t)
 };
 }
 
diff -pruN 4.3.2-2/src/generic_mtrie_impl.hpp 4.3.3-1/src/generic_mtrie_impl.hpp
--- 4.3.2-2/src/generic_mtrie_impl.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/generic_mtrie_impl.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -35,13 +35,16 @@ along with this program.  If not, see <h
 
 #include <new>
 #include <algorithm>
+#include <list>
 
 #include "err.hpp"
 #include "macros.hpp"
 #include "generic_mtrie.hpp"
 
+namespace zmq
+{
 template <typename T>
-zmq::generic_mtrie_t<T>::generic_mtrie_t () :
+generic_mtrie_t<T>::generic_mtrie_t () :
     _pipes (0),
     _min (0),
     _count (0),
@@ -49,7 +52,7 @@ zmq::generic_mtrie_t<T>::generic_mtrie_t
 {
 }
 
-template <typename T> zmq::generic_mtrie_t<T>::~generic_mtrie_t ()
+template <typename T> generic_mtrie_t<T>::~generic_mtrie_t ()
 {
     LIBZMQ_DELETE (_pipes);
 
@@ -65,354 +68,465 @@ template <typename T> zmq::generic_mtrie
 }
 
 template <typename T>
-bool zmq::generic_mtrie_t<T>::add (prefix_t prefix_,
-                                   size_t size_,
-                                   value_t *pipe_)
+bool generic_mtrie_t<T>::add (prefix_t prefix_, size_t size_, value_t *pipe_)
 {
-    return add_helper (prefix_, size_, pipe_);
-}
+    generic_mtrie_t<value_t> *it = this;
 
-template <typename T>
-bool zmq::generic_mtrie_t<T>::add_helper (prefix_t prefix_,
-                                          size_t size_,
-                                          value_t *pipe_)
-{
-    //  We are at the node corresponding to the prefix. We are done.
-    if (!size_) {
-        const bool result = !_pipes;
-        if (!_pipes) {
-            _pipes = new (std::nothrow) pipes_t;
-            alloc_assert (_pipes);
+    while (size_) {
+        const unsigned char c = *prefix_;
+
+        if (c < it->_min || c >= it->_min + it->_count) {
+            //  The character is out of range of currently handled
+            //  characters. We have to extend the table.
+            if (!it->_count) {
+                it->_min = c;
+                it->_count = 1;
+                it->_next.node = NULL;
+            } else if (it->_count == 1) {
+                const unsigned char oldc = it->_min;
+                generic_mtrie_t *oldp = it->_next.node;
+                it->_count = (it->_min < c ? c - it->_min : it->_min - c) + 1;
+                it->_next.table = static_cast<generic_mtrie_t **> (
+                  malloc (sizeof (generic_mtrie_t *) * it->_count));
+                alloc_assert (it->_next.table);
+                for (unsigned short i = 0; i != it->_count; ++i)
+                    it->_next.table[i] = 0;
+                it->_min = std::min (it->_min, c);
+                it->_next.table[oldc - it->_min] = oldp;
+            } else if (it->_min < c) {
+                //  The new character is above the current character range.
+                const unsigned short old_count = it->_count;
+                it->_count = c - it->_min + 1;
+                it->_next.table = static_cast<generic_mtrie_t **> (realloc (
+                  it->_next.table, sizeof (generic_mtrie_t *) * it->_count));
+                alloc_assert (it->_next.table);
+                for (unsigned short i = old_count; i != it->_count; i++)
+                    it->_next.table[i] = NULL;
+            } else {
+                //  The new character is below the current character range.
+                const unsigned short old_count = it->_count;
+                it->_count = (it->_min + old_count) - c;
+                it->_next.table = static_cast<generic_mtrie_t **> (realloc (
+                  it->_next.table, sizeof (generic_mtrie_t *) * it->_count));
+                alloc_assert (it->_next.table);
+                memmove (it->_next.table + it->_min - c, it->_next.table,
+                         old_count * sizeof (generic_mtrie_t *));
+                for (unsigned short i = 0; i != it->_min - c; i++)
+                    it->_next.table[i] = NULL;
+                it->_min = c;
+            }
         }
-        _pipes->insert (pipe_);
-        return result;
-    }
 
-    const unsigned char c = *prefix_;
-    if (c < _min || c >= _min + _count) {
-        //  The character is out of range of currently handled
-        //  characters. We have to extend the table.
-        if (!_count) {
-            _min = c;
-            _count = 1;
-            _next.node = NULL;
-        } else if (_count == 1) {
-            const unsigned char oldc = _min;
-            generic_mtrie_t *oldp = _next.node;
-            _count = (_min < c ? c - _min : _min - c) + 1;
-            _next.table = static_cast<generic_mtrie_t **> (
-              malloc (sizeof (generic_mtrie_t *) * _count));
-            alloc_assert (_next.table);
-            for (unsigned short i = 0; i != _count; ++i)
-                _next.table[i] = 0;
-            _min = std::min (_min, c);
-            _next.table[oldc - _min] = oldp;
-        } else if (_min < c) {
-            //  The new character is above the current character range.
-            const unsigned short old_count = _count;
-            _count = c - _min + 1;
-            _next.table = static_cast<generic_mtrie_t **> (
-              realloc (_next.table, sizeof (generic_mtrie_t *) * _count));
-            alloc_assert (_next.table);
-            for (unsigned short i = old_count; i != _count; i++)
-                _next.table[i] = NULL;
+        //  If next node does not exist, create one.
+        if (it->_count == 1) {
+            if (!it->_next.node) {
+                it->_next.node = new (std::nothrow) generic_mtrie_t;
+                alloc_assert (it->_next.node);
+                ++(it->_live_nodes);
+            }
+
+            ++prefix_;
+            --size_;
+            it = it->_next.node;
         } else {
-            //  The new character is below the current character range.
-            const unsigned short old_count = _count;
-            _count = (_min + old_count) - c;
-            _next.table = static_cast<generic_mtrie_t **> (
-              realloc (_next.table, sizeof (generic_mtrie_t *) * _count));
-            alloc_assert (_next.table);
-            memmove (_next.table + _min - c, _next.table,
-                     old_count * sizeof (generic_mtrie_t *));
-            for (unsigned short i = 0; i != _min - c; i++)
-                _next.table[i] = NULL;
-            _min = c;
-        }
-    }
+            if (!it->_next.table[c - it->_min]) {
+                it->_next.table[c - it->_min] =
+                  new (std::nothrow) generic_mtrie_t;
+                alloc_assert (it->_next.table[c - it->_min]);
+                ++(it->_live_nodes);
+            }
 
-    //  If next node does not exist, create one.
-    if (_count == 1) {
-        if (!_next.node) {
-            _next.node = new (std::nothrow) generic_mtrie_t;
-            alloc_assert (_next.node);
-            ++_live_nodes;
+            ++prefix_;
+            --size_;
+            it = it->_next.table[c - it->_min];
         }
-        return _next.node->add_helper (prefix_ + 1, size_ - 1, pipe_);
     }
-    if (!_next.table[c - _min]) {
-        _next.table[c - _min] = new (std::nothrow) generic_mtrie_t;
-        alloc_assert (_next.table[c - _min]);
-        ++_live_nodes;
+
+    //  We are at the node corresponding to the prefix. We are done.
+    const bool result = !it->_pipes;
+    if (!it->_pipes) {
+        it->_pipes = new (std::nothrow) pipes_t;
+        alloc_assert (it->_pipes);
     }
-    return _next.table[c - _min]->add_helper (prefix_ + 1, size_ - 1, pipe_);
-}
+    it->_pipes->insert (pipe_);
 
+    return result;
+}
 
 template <typename T>
 template <typename Arg>
-void zmq::generic_mtrie_t<T>::rm (value_t *pipe_,
-                                  void (*func_) (prefix_t data_,
-                                                 size_t size_,
-                                                 Arg arg_),
-                                  Arg arg_,
-                                  bool call_on_uniq_)
-{
+void generic_mtrie_t<T>::rm (value_t *pipe_,
+                             void (*func_) (prefix_t data_,
+                                            size_t size_,
+                                            Arg arg_),
+                             Arg arg_,
+                             bool call_on_uniq_)
+{
+    //  This used to be implemented as a non-tail recursive travesal of the trie,
+    //  which means remote clients controlled the depth of the recursion and the
+    //  stack size.
+    //  To simulate the non-tail recursion, with post-recursion changes depending on
+    //  the result of the recursive call, a stack is used to re-visit the same node
+    //  and operate on it again after children have been visisted.
+    //  A boolean is used to record whether the node had already been visited and to
+    //  determine if the pre- or post- children visit actions have to be taken.
+    //  In the case of a node with (N > 1) children, the node has to be re-visited
+    //  N times, in the correct order after each child visit.
+    std::list<struct iter> stack;
     unsigned char *buff = NULL;
-    rm_helper (pipe_, &buff, 0, 0, func_, arg_, call_on_uniq_);
-    free (buff);
-}
+    size_t maxbuffsize = 0;
+    struct iter it = {this, NULL, NULL, 0, 0, 0, false};
+    stack.push_back (it);
+
+    while (!stack.empty ()) {
+        it = stack.back ();
+        stack.pop_back ();
+
+        if (!it.processed_for_removal) {
+            //  Remove the subscription from this node.
+            if (it.node->_pipes && it.node->_pipes->erase (pipe_)) {
+                if (!call_on_uniq_ || it.node->_pipes->empty ()) {
+                    func_ (buff, it.size, arg_);
+                }
+
+                if (it.node->_pipes->empty ()) {
+                    LIBZMQ_DELETE (it.node->_pipes);
+                }
+            }
 
-template <typename T>
-template <typename Arg>
-void zmq::generic_mtrie_t<T>::rm_helper (value_t *pipe_,
-                                         unsigned char **buff_,
-                                         size_t buffsize_,
-                                         size_t maxbuffsize_,
-                                         void (*func_) (prefix_t data_,
-                                                        size_t size_,
-                                                        Arg arg_),
-                                         Arg arg_,
-                                         bool call_on_uniq_)
-{
-    //  Remove the subscription from this node.
-    if (_pipes && _pipes->erase (pipe_)) {
-        if (!call_on_uniq_ || _pipes->empty ()) {
-            func_ (*buff_, buffsize_, arg_);
-        }
+            //  Adjust the buffer.
+            if (it.size >= maxbuffsize) {
+                maxbuffsize = it.size + 256;
+                buff =
+                  static_cast<unsigned char *> (realloc (buff, maxbuffsize));
+                alloc_assert (buff);
+            }
 
-        if (_pipes->empty ()) {
-            LIBZMQ_DELETE (_pipes);
+            switch (it.node->_count) {
+                case 0:
+                    //  If there are no subnodes in the trie, we are done with this node
+                    //  pre-processing.
+                    break;
+                case 1: {
+                    //  If there's one subnode (optimisation).
+
+                    buff[it.size] = it.node->_min;
+                    //  Mark this node as pre-processed and push it, so that the next
+                    //  visit after the operation on the child can do the removals.
+                    it.processed_for_removal = true;
+                    stack.push_back (it);
+                    struct iter next = {
+                      it.node->_next.node, NULL, NULL, ++it.size, 0, 0, false};
+                    stack.push_back (next);
+                    break;
+                }
+                default: {
+                    //  If there are multiple subnodes.
+                    //  When first visiting this node, initialize the new_min/max parameters
+                    //  which will then be used after each child has been processed, on the
+                    //  post-children iterations.
+                    if (it.current_child == 0) {
+                        //  New min non-null character in the node table after the removal
+                        it.new_min = it.node->_min + it.node->_count - 1;
+                        //  New max non-null character in the node table after the removal
+                        it.new_max = it.node->_min;
+                    }
+
+                    //  Mark this node as pre-processed and push it, so that the next
+                    //  visit after the operation on the child can do the removals.
+                    buff[it.size] = it.node->_min + it.current_child;
+                    it.processed_for_removal = true;
+                    stack.push_back (it);
+                    if (it.node->_next.table[it.current_child]) {
+                        struct iter next = {
+                          it.node->_next.table[it.current_child],
+                          NULL,
+                          NULL,
+                          it.size + 1,
+                          0,
+                          0,
+                          false};
+                        stack.push_back (next);
+                    }
+                }
+            }
+        } else {
+            //  Reset back for the next time, in case this node doesn't get deleted.
+            //  This is done unconditionally, unlike when setting this variable to true.
+            it.processed_for_removal = false;
+
+            switch (it.node->_count) {
+                case 0:
+                    //  If there are no subnodes in the trie, we are done with this node
+                    //  post-processing.
+                    break;
+                case 1:
+                    //  If there's one subnode (optimisation).
+
+                    //  Prune the node if it was made redundant by the removal
+                    if (it.node->_next.node->is_redundant ()) {
+                        LIBZMQ_DELETE (it.node->_next.node);
+                        it.node->_count = 0;
+                        --it.node->_live_nodes;
+                        zmq_assert (it.node->_live_nodes == 0);
+                    }
+                    break;
+                default:
+                    //  If there are multiple subnodes.
+                    {
+                        if (it.node->_next.table[it.current_child]) {
+                            //  Prune redundant nodes from the mtrie
+                            if (it.node->_next.table[it.current_child]
+                                  ->is_redundant ()) {
+                                LIBZMQ_DELETE (
+                                  it.node->_next.table[it.current_child]);
+
+                                zmq_assert (it.node->_live_nodes > 0);
+                                --it.node->_live_nodes;
+                            } else {
+                                //  The node is not redundant, so it's a candidate for being
+                                //  the new min/max node.
+                                //
+                                //  We loop through the node array from left to right, so the
+                                //  first non-null, non-redundant node encountered is the new
+                                //  minimum index. Conversely, the last non-redundant, non-null
+                                //  node encountered is the new maximum index.
+                                if (it.current_child + it.node->_min
+                                    < it.new_min)
+                                    it.new_min =
+                                      it.current_child + it.node->_min;
+                                if (it.current_child + it.node->_min
+                                    > it.new_max)
+                                    it.new_max =
+                                      it.current_child + it.node->_min;
+                            }
+                        }
+
+                        //  If there are more children to visit, push again the current
+                        //  node, so that pre-processing can happen on the next child.
+                        //  If we are done, reset the child index so that the ::rm is
+                        //  fully idempotent.
+                        ++it.current_child;
+                        if (it.current_child >= it.node->_count)
+                            it.current_child = 0;
+                        else {
+                            stack.push_back (it);
+                            continue;
+                        }
+
+                        //  All children have been visited and removed if needed, and
+                        //  all pre- and post-visit operations have been carried.
+                        //  Resize/free the node table if needed.
+                        zmq_assert (it.node->_count > 1);
+
+                        //  Free the node table if it's no longer used.
+                        switch (it.node->_live_nodes) {
+                            case 0:
+                                free (it.node->_next.table);
+                                it.node->_next.table = NULL;
+                                it.node->_count = 0;
+                                break;
+                            case 1:
+                                //  Compact the node table if possible
+
+                                //  If there's only one live node in the table we can
+                                //  switch to using the more compact single-node
+                                //  representation
+                                zmq_assert (it.new_min == it.new_max);
+                                zmq_assert (it.new_min >= it.node->_min);
+                                zmq_assert (it.new_min
+                                            < it.node->_min + it.node->_count);
+                                {
+                                    generic_mtrie_t *node =
+                                      it.node->_next
+                                        .table[it.new_min - it.node->_min];
+                                    zmq_assert (node);
+                                    free (it.node->_next.table);
+                                    it.node->_next.node = node;
+                                }
+                                it.node->_count = 1;
+                                it.node->_min = it.new_min;
+                                break;
+                            default:
+                                if (it.new_min > it.node->_min
+                                    || it.new_max < it.node->_min
+                                                      + it.node->_count - 1) {
+                                    zmq_assert (it.new_max - it.new_min + 1
+                                                > 1);
+
+                                    generic_mtrie_t **old_table =
+                                      it.node->_next.table;
+                                    zmq_assert (it.new_min > it.node->_min
+                                                || it.new_max
+                                                     < it.node->_min
+                                                         + it.node->_count - 1);
+                                    zmq_assert (it.new_min >= it.node->_min);
+                                    zmq_assert (it.new_max
+                                                <= it.node->_min
+                                                     + it.node->_count - 1);
+                                    zmq_assert (it.new_max - it.new_min + 1
+                                                < it.node->_count);
+
+                                    it.node->_count =
+                                      it.new_max - it.new_min + 1;
+                                    it.node->_next.table =
+                                      static_cast<generic_mtrie_t **> (
+                                        malloc (sizeof (generic_mtrie_t *)
+                                                * it.node->_count));
+                                    alloc_assert (it.node->_next.table);
+
+                                    memmove (it.node->_next.table,
+                                             old_table
+                                               + (it.new_min - it.node->_min),
+                                             sizeof (generic_mtrie_t *)
+                                               * it.node->_count);
+                                    free (old_table);
+
+                                    it.node->_min = it.new_min;
+                                }
+                        }
+                    }
+            }
         }
     }
 
-    //  Adjust the buffer.
-    if (buffsize_ >= maxbuffsize_) {
-        maxbuffsize_ = buffsize_ + 256;
-        *buff_ = static_cast<unsigned char *> (realloc (*buff_, maxbuffsize_));
-        alloc_assert (*buff_);
-    }
-
-    switch (_count) {
-        case 0:
-            //  If there are no subnodes in the trie, return.
-            break;
-        case 1:
-            //  If there's one subnode (optimisation).
-
-            (*buff_)[buffsize_] = _min;
-            buffsize_++;
-            _next.node->rm_helper (pipe_, buff_, buffsize_, maxbuffsize_, func_,
-                                   arg_, call_on_uniq_);
-
-            //  Prune the node if it was made redundant by the removal
-            if (_next.node->is_redundant ()) {
-                LIBZMQ_DELETE (_next.node);
-                _count = 0;
-                --_live_nodes;
-                zmq_assert (_live_nodes == 0);
-            }
-            break;
-        default:
-            //  If there are multiple subnodes.
-            rm_helper_multiple_subnodes (buff_, buffsize_, maxbuffsize_, func_,
-                                         arg_, call_on_uniq_, pipe_);
-            break;
-    }
+    free (buff);
 }
 
 template <typename T>
-template <typename Arg>
-void zmq::generic_mtrie_t<T>::rm_helper_multiple_subnodes (
-  unsigned char **buff_,
-  size_t buffsize_,
-  size_t maxbuffsize_,
-  void (*func_) (prefix_t data_, size_t size_, Arg arg_),
-  Arg arg_,
-  bool call_on_uniq_,
-  value_t *pipe_)
+typename generic_mtrie_t<T>::rm_result
+generic_mtrie_t<T>::rm (prefix_t prefix_, size_t size_, value_t *pipe_)
 {
-    //  New min non-null character in the node table after the removal
-    unsigned char new_min = _min + _count - 1;
-    //  New max non-null character in the node table after the removal
-    unsigned char new_max = _min;
-    for (unsigned short c = 0; c != _count; c++) {
-        (*buff_)[buffsize_] = _min + c;
-        if (_next.table[c]) {
-            _next.table[c]->rm_helper (pipe_, buff_, buffsize_ + 1,
-                                       maxbuffsize_, func_, arg_,
-                                       call_on_uniq_);
-
-            //  Prune redundant nodes from the mtrie
-            if (_next.table[c]->is_redundant ()) {
-                LIBZMQ_DELETE (_next.table[c]);
+    //  This used to be implemented as a non-tail recursive travesal of the trie,
+    //  which means remote clients controlled the depth of the recursion and the
+    //  stack size.
+    //  To simulate the non-tail recursion, with post-recursion changes depending on
+    //  the result of the recursive call, a stack is used to re-visit the same node
+    //  and operate on it again after children have been visisted.
+    //  A boolean is used to record whether the node had already been visited and to
+    //  determine if the pre- or post- children visit actions have to be taken.
+    rm_result ret = not_found;
+    std::list<struct iter> stack;
+    struct iter it = {this, NULL, prefix_, size_, 0, 0, 0, false};
+    stack.push_back (it);
+
+    while (!stack.empty ()) {
+        it = stack.back ();
+        stack.pop_back ();
+
+        if (!it.processed_for_removal) {
+            if (!it.size) {
+                if (!it.node->_pipes) {
+                    ret = not_found;
+                    continue;
+                }
+
+                typename pipes_t::size_type erased =
+                  it.node->_pipes->erase (pipe_);
+                if (it.node->_pipes->empty ()) {
+                    zmq_assert (erased == 1);
+                    LIBZMQ_DELETE (it.node->_pipes);
+                    ret = last_value_removed;
+                    continue;
+                }
 
-                zmq_assert (_live_nodes > 0);
-                --_live_nodes;
-            } else {
-                //  The node is not redundant, so it's a candidate for being
-                //  the new min/max node.
-                //
-                //  We loop through the node array from left to right, so the
-                //  first non-null, non-redundant node encountered is the new
-                //  minimum index. Conversely, the last non-redundant, non-null
-                //  node encountered is the new maximum index.
-                if (c + _min < new_min)
-                    new_min = c + _min;
-                if (c + _min > new_max)
-                    new_max = c + _min;
+                ret = (erased == 1) ? values_remain : not_found;
+                continue;
             }
-        }
-    }
-
-    zmq_assert (_count > 1);
 
-    //  Free the node table if it's no longer used.
-    switch (_live_nodes) {
-        case 0:
-            free (_next.table);
-            _next.table = NULL;
-            _count = 0;
-            break;
-        case 1:
-            //  Compact the node table if possible
-
-            //  If there's only one live node in the table we can
-            //  switch to using the more compact single-node
-            //  representation
-            zmq_assert (new_min == new_max);
-            zmq_assert (new_min >= _min && new_min < _min + _count);
-            {
-                generic_mtrie_t *node = _next.table[new_min - _min];
-                zmq_assert (node);
-                free (_next.table);
-                _next.node = node;
+            it.current_child = *it.prefix;
+            if (!it.node->_count || it.current_child < it.node->_min
+                || it.current_child >= it.node->_min + it.node->_count) {
+                ret = not_found;
+                continue;
             }
-            _count = 1;
-            _min = new_min;
-            break;
-        default:
-            if (new_min > _min || new_max < _min + _count - 1) {
-                zmq_assert (new_max - new_min + 1 > 1);
-
-                generic_mtrie_t **old_table = _next.table;
-                zmq_assert (new_min > _min || new_max < _min + _count - 1);
-                zmq_assert (new_min >= _min);
-                zmq_assert (new_max <= _min + _count - 1);
-                zmq_assert (new_max - new_min + 1 < _count);
-
-                _count = new_max - new_min + 1;
-                _next.table = static_cast<generic_mtrie_t **> (
-                  malloc (sizeof (generic_mtrie_t *) * _count));
-                alloc_assert (_next.table);
-
-                memmove (_next.table, old_table + (new_min - _min),
-                         sizeof (generic_mtrie_t *) * _count);
-                free (old_table);
 
-                _min = new_min;
+            it.next_node =
+              it.node->_count == 1
+                ? it.node->_next.node
+                : it.node->_next.table[it.current_child - it.node->_min];
+            if (!it.next_node) {
+                ret = not_found;
+                continue;
             }
-    }
-}
-template <typename T>
-typename zmq::generic_mtrie_t<T>::rm_result
-zmq::generic_mtrie_t<T>::rm (prefix_t prefix_, size_t size_, value_t *pipe_)
-{
-    return rm_helper (prefix_, size_, pipe_);
-}
 
-template <typename T>
-typename zmq::generic_mtrie_t<T>::rm_result zmq::generic_mtrie_t<T>::rm_helper (
-  prefix_t prefix_, size_t size_, value_t *pipe_)
-{
-    if (!size_) {
-        if (!_pipes)
-            return not_found;
-
-        typename pipes_t::size_type erased = _pipes->erase (pipe_);
-        if (_pipes->empty ()) {
-            zmq_assert (erased == 1);
-            LIBZMQ_DELETE (_pipes);
-            return last_value_removed;
-        }
-        return (erased == 1) ? values_remain : not_found;
-    }
-
-    const unsigned char c = *prefix_;
-    if (!_count || c < _min || c >= _min + _count)
-        return not_found;
-
-    generic_mtrie_t *next_node =
-      _count == 1 ? _next.node : _next.table[c - _min];
-
-    if (!next_node)
-        return not_found;
-
-    const rm_result ret = next_node->rm_helper (prefix_ + 1, size_ - 1, pipe_);
-
-    if (next_node->is_redundant ()) {
-        LIBZMQ_DELETE (next_node);
-        zmq_assert (_count > 0);
-
-        if (_count == 1) {
-            _next.node = 0;
-            _count = 0;
-            --_live_nodes;
-            zmq_assert (_live_nodes == 0);
+            it.processed_for_removal = true;
+            stack.push_back (it);
+            struct iter next = {
+              it.next_node, NULL, it.prefix + 1, it.size - 1, 0, 0, 0, false};
+            stack.push_back (next);
         } else {
-            _next.table[c - _min] = 0;
-            zmq_assert (_live_nodes > 1);
-            --_live_nodes;
-
-            //  Compact the table if possible
-            if (_live_nodes == 1) {
-                //  If there's only one live node in the table we can
-                //  switch to using the more compact single-node
-                //  representation
-                unsigned short i;
-                for (i = 0; i < _count; ++i)
-                    if (_next.table[i])
-                        break;
-
-                zmq_assert (i < _count);
-                _min += i;
-                _count = 1;
-                generic_mtrie_t *oldp = _next.table[i];
-                free (_next.table);
-                _next.node = oldp;
-            } else if (c == _min) {
-                //  We can compact the table "from the left"
-                unsigned short i;
-                for (i = 1; i < _count; ++i)
-                    if (_next.table[i])
-                        break;
-
-                zmq_assert (i < _count);
-                _min += i;
-                _count -= i;
-                generic_mtrie_t **old_table = _next.table;
-                _next.table = static_cast<generic_mtrie_t **> (
-                  malloc (sizeof (generic_mtrie_t *) * _count));
-                alloc_assert (_next.table);
-                memmove (_next.table, old_table + i,
-                         sizeof (generic_mtrie_t *) * _count);
-                free (old_table);
-            } else if (c == _min + _count - 1) {
-                //  We can compact the table "from the right"
-                unsigned short i;
-                for (i = 1; i < _count; ++i)
-                    if (_next.table[_count - 1 - i])
-                        break;
-
-                zmq_assert (i < _count);
-                _count -= i;
-                generic_mtrie_t **old_table = _next.table;
-                _next.table = static_cast<generic_mtrie_t **> (
-                  malloc (sizeof (generic_mtrie_t *) * _count));
-                alloc_assert (_next.table);
-                memmove (_next.table, old_table,
-                         sizeof (generic_mtrie_t *) * _count);
-                free (old_table);
+            it.processed_for_removal = false;
+
+            if (it.next_node->is_redundant ()) {
+                LIBZMQ_DELETE (it.next_node);
+                zmq_assert (it.node->_count > 0);
+
+                if (it.node->_count == 1) {
+                    it.node->_next.node = NULL;
+                    it.node->_count = 0;
+                    --it.node->_live_nodes;
+                    zmq_assert (it.node->_live_nodes == 0);
+                } else {
+                    it.node->_next.table[it.current_child - it.node->_min] = 0;
+                    zmq_assert (it.node->_live_nodes > 1);
+                    --it.node->_live_nodes;
+
+                    //  Compact the table if possible
+                    if (it.node->_live_nodes == 1) {
+                        //  If there's only one live node in the table we can
+                        //  switch to using the more compact single-node
+                        //  representation
+                        unsigned short i;
+                        for (i = 0; i < it.node->_count; ++i)
+                            if (it.node->_next.table[i])
+                                break;
+
+                        zmq_assert (i < it.node->_count);
+                        it.node->_min += i;
+                        it.node->_count = 1;
+                        generic_mtrie_t *oldp = it.node->_next.table[i];
+                        free (it.node->_next.table);
+                        it.node->_next.table = NULL;
+                        it.node->_next.node = oldp;
+                    } else if (it.current_child == it.node->_min) {
+                        //  We can compact the table "from the left"
+                        unsigned short i;
+                        for (i = 1; i < it.node->_count; ++i)
+                            if (it.node->_next.table[i])
+                                break;
+
+                        zmq_assert (i < it.node->_count);
+                        it.node->_min += i;
+                        it.node->_count -= i;
+                        generic_mtrie_t **old_table = it.node->_next.table;
+                        it.node->_next.table =
+                          static_cast<generic_mtrie_t **> (malloc (
+                            sizeof (generic_mtrie_t *) * it.node->_count));
+                        alloc_assert (it.node->_next.table);
+                        memmove (it.node->_next.table, old_table + i,
+                                 sizeof (generic_mtrie_t *) * it.node->_count);
+                        free (old_table);
+                    } else if (it.current_child
+                               == it.node->_min + it.node->_count - 1) {
+                        //  We can compact the table "from the right"
+                        unsigned short i;
+                        for (i = 1; i < it.node->_count; ++i)
+                            if (it.node->_next.table[it.node->_count - 1 - i])
+                                break;
+
+                        zmq_assert (i < it.node->_count);
+                        it.node->_count -= i;
+                        generic_mtrie_t **old_table = it.node->_next.table;
+                        it.node->_next.table =
+                          static_cast<generic_mtrie_t **> (malloc (
+                            sizeof (generic_mtrie_t *) * it.node->_count));
+                        alloc_assert (it.node->_next.table);
+                        memmove (it.node->_next.table, old_table,
+                                 sizeof (generic_mtrie_t *) * it.node->_count);
+                        free (old_table);
+                    }
+                }
             }
         }
     }
@@ -422,18 +536,19 @@ typename zmq::generic_mtrie_t<T>::rm_res
 
 template <typename T>
 template <typename Arg>
-void zmq::generic_mtrie_t<T>::match (prefix_t data_,
-                                     size_t size_,
-                                     void (*func_) (value_t *pipe_, Arg arg_),
-                                     Arg arg_)
+void generic_mtrie_t<T>::match (prefix_t data_,
+                                size_t size_,
+                                void (*func_) (value_t *pipe_, Arg arg_),
+                                Arg arg_)
 {
-    generic_mtrie_t *current = this;
-    while (true) {
+    for (generic_mtrie_t *current = this; current; data_++, size_--) {
         //  Signal the pipes attached to this node.
         if (current->_pipes) {
-            for (typename pipes_t::iterator it = current->_pipes->begin ();
-                 it != current->_pipes->end (); ++it)
+            for (typename pipes_t::iterator it = current->_pipes->begin (),
+                                            end = current->_pipes->end ();
+                 it != end; ++it) {
                 func_ (*it, arg_);
+            }
         }
 
         //  If we are at the end of the message, there's nothing more to match.
@@ -444,32 +559,28 @@ void zmq::generic_mtrie_t<T>::match (pre
         if (current->_count == 0)
             break;
 
-        //  If there's one subnode (optimisation).
         if (current->_count == 1) {
-            if (data_[0] != current->_min)
+            //  If there's one subnode (optimisation).
+            if (data_[0] != current->_min) {
                 break;
+            }
             current = current->_next.node;
-            data_++;
-            size_--;
-            continue;
+        } else {
+            //  If there are multiple subnodes.
+            if (data_[0] < current->_min
+                || data_[0] >= current->_min + current->_count) {
+                break;
+            }
+            current = current->_next.table[data_[0] - current->_min];
         }
-
-        //  If there are multiple subnodes.
-        if (data_[0] < current->_min
-            || data_[0] >= current->_min + current->_count)
-            break;
-        if (!current->_next.table[data_[0] - current->_min])
-            break;
-        current = current->_next.table[data_[0] - current->_min];
-        data_++;
-        size_--;
     }
 }
 
-template <typename T> bool zmq::generic_mtrie_t<T>::is_redundant () const
+template <typename T> bool generic_mtrie_t<T>::is_redundant () const
 {
     return !_pipes && _live_nodes == 0;
 }
+}
 
 
 #endif
diff -pruN 4.3.2-2/src/gssapi_client.hpp 4.3.3-1/src/gssapi_client.hpp
--- 4.3.2-2/src/gssapi_client.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/gssapi_client.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,18 +39,18 @@ namespace zmq
 class msg_t;
 class session_base_t;
 
-class gssapi_client_t : public gssapi_mechanism_base_t
+class gssapi_client_t ZMQ_FINAL : public gssapi_mechanism_base_t
 {
   public:
     gssapi_client_t (session_base_t *session_, const options_t &options_);
-    virtual ~gssapi_client_t ();
+    ~gssapi_client_t () ZMQ_FINAL;
 
     // mechanism implementation
-    virtual int next_handshake_command (msg_t *msg_);
-    virtual int process_handshake_command (msg_t *msg_);
-    virtual int encode (msg_t *msg_);
-    virtual int decode (msg_t *msg_);
-    virtual status_t status () const;
+    int next_handshake_command (msg_t *msg_) ZMQ_FINAL;
+    int process_handshake_command (msg_t *msg_) ZMQ_FINAL;
+    int encode (msg_t *msg_) ZMQ_FINAL;
+    int decode (msg_t *msg_) ZMQ_FINAL;
+    status_t status () const ZMQ_FINAL;
 
   private:
     enum state_t
diff -pruN 4.3.2-2/src/gssapi_mechanism_base.hpp 4.3.3-1/src/gssapi_mechanism_base.hpp
--- 4.3.2-2/src/gssapi_mechanism_base.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/gssapi_mechanism_base.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -53,7 +53,7 @@ class gssapi_mechanism_base_t : public v
   public:
     gssapi_mechanism_base_t (session_base_t *session_,
                              const options_t &options_);
-    virtual ~gssapi_mechanism_base_t () = 0;
+    ~gssapi_mechanism_base_t () ZMQ_OVERRIDE = 0;
 
   protected:
     //  Produce a context-level GSSAPI token (INITIATE command)
diff -pruN 4.3.2-2/src/gssapi_server.hpp 4.3.3-1/src/gssapi_server.hpp
--- 4.3.2-2/src/gssapi_server.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/gssapi_server.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -40,21 +40,22 @@ namespace zmq
 class msg_t;
 class session_base_t;
 
-class gssapi_server_t : public gssapi_mechanism_base_t, public zap_client_t
+class gssapi_server_t ZMQ_FINAL : public gssapi_mechanism_base_t,
+                                  public zap_client_t
 {
   public:
     gssapi_server_t (session_base_t *session_,
                      const std::string &peer_address,
                      const options_t &options_);
-    virtual ~gssapi_server_t ();
+    ~gssapi_server_t () ZMQ_FINAL;
 
     // mechanism implementation
-    virtual int next_handshake_command (msg_t *msg_);
-    virtual int process_handshake_command (msg_t *msg_);
-    virtual int encode (msg_t *msg_);
-    virtual int decode (msg_t *msg_);
-    virtual int zap_msg_available ();
-    virtual status_t status () const;
+    int next_handshake_command (msg_t *msg_) ZMQ_FINAL;
+    int process_handshake_command (msg_t *msg_) ZMQ_FINAL;
+    int encode (msg_t *msg_) ZMQ_FINAL;
+    int decode (msg_t *msg_) ZMQ_FINAL;
+    int zap_msg_available () ZMQ_FINAL;
+    status_t status () const ZMQ_FINAL;
 
   private:
     enum state_t
diff -pruN 4.3.2-2/src/i_decoder.hpp 4.3.3-1/src/i_decoder.hpp
--- 4.3.2-2/src/i_decoder.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/i_decoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,6 +30,7 @@
 #ifndef __ZMQ_I_DECODER_HPP_INCLUDED__
 #define __ZMQ_I_DECODER_HPP_INCLUDED__
 
+#include "macros.hpp"
 #include "stdint.hpp"
 
 namespace zmq
@@ -41,7 +42,7 @@ class msg_t;
 class i_decoder
 {
   public:
-    virtual ~i_decoder () {}
+    virtual ~i_decoder () ZMQ_DEFAULT;
 
     virtual void get_buffer (unsigned char **data_, size_t *size_) = 0;
 
diff -pruN 4.3.2-2/src/i_encoder.hpp 4.3.3-1/src/i_encoder.hpp
--- 4.3.2-2/src/i_encoder.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/i_encoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,6 +30,7 @@
 #ifndef __ZMQ_I_ENCODER_HPP_INCLUDED__
 #define __ZMQ_I_ENCODER_HPP_INCLUDED__
 
+#include "macros.hpp"
 #include "stdint.hpp"
 
 namespace zmq
@@ -41,7 +42,7 @@ class msg_t;
 
 struct i_encoder
 {
-    virtual ~i_encoder () {}
+    virtual ~i_encoder () ZMQ_DEFAULT;
 
     //  The function returns a batch of binary data. The data
     //  are filled to a supplied buffer. If no buffer is supplied (data_
diff -pruN 4.3.2-2/src/i_engine.hpp 4.3.3-1/src/i_engine.hpp
--- 4.3.2-2/src/i_engine.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/i_engine.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -31,6 +31,7 @@
 #define __ZMQ_I_ENGINE_HPP_INCLUDED__
 
 #include "endpoint.hpp"
+#include "macros.hpp"
 
 namespace zmq
 {
@@ -40,7 +41,18 @@ class io_thread_t;
 
 struct i_engine
 {
-    virtual ~i_engine () {}
+    enum error_reason_t
+    {
+        protocol_error,
+        connection_error,
+        timeout_error
+    };
+
+    virtual ~i_engine () ZMQ_DEFAULT;
+
+    //  Indicate if the engine has an handshake stage.
+    //  If engine has handshake stage, engine must call session.engine_ready when the handshake is complete.
+    virtual bool has_handshake_stage () = 0;
 
     //  Plug the engine to the session.
     virtual void plug (zmq::io_thread_t *io_thread_,
diff -pruN 4.3.2-2/src/i_mailbox.hpp 4.3.3-1/src/i_mailbox.hpp
--- 4.3.2-2/src/i_mailbox.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/i_mailbox.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,6 +30,7 @@
 #ifndef __ZMQ_I_MAILBOX_HPP_INCLUDED__
 #define __ZMQ_I_MAILBOX_HPP_INCLUDED__
 
+#include "macros.hpp"
 #include "stdint.hpp"
 
 namespace zmq
@@ -39,7 +40,7 @@ namespace zmq
 class i_mailbox
 {
   public:
-    virtual ~i_mailbox () {}
+    virtual ~i_mailbox () ZMQ_DEFAULT;
 
     virtual void send (const command_t &cmd_) = 0;
     virtual int recv (command_t *cmd_, int timeout_) = 0;
diff -pruN 4.3.2-2/src/io_object.hpp 4.3.3-1/src/io_object.hpp
--- 4.3.2-2/src/io_object.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/io_object.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -48,7 +48,7 @@ class io_object_t : public i_poll_events
 {
   public:
     io_object_t (zmq::io_thread_t *io_thread_ = NULL);
-    ~io_object_t ();
+    ~io_object_t () ZMQ_OVERRIDE;
 
     //  When migrating an object from one I/O thread to another, first
     //  unplug it, then migrate it, then plug it to the new thread.
@@ -69,15 +69,14 @@ class io_object_t : public i_poll_events
     void cancel_timer (int id_);
 
     //  i_poll_events interface implementation.
-    void in_event ();
-    void out_event ();
-    void timer_event (int id_);
+    void in_event () ZMQ_OVERRIDE;
+    void out_event () ZMQ_OVERRIDE;
+    void timer_event (int id_) ZMQ_OVERRIDE;
 
   private:
     poller_t *_poller;
 
-    io_object_t (const io_object_t &);
-    const io_object_t &operator= (const io_object_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (io_object_t)
 };
 }
 
diff -pruN 4.3.2-2/src/io_thread.cpp 4.3.3-1/src/io_thread.cpp
--- 4.3.2-2/src/io_thread.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/io_thread.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -73,7 +73,7 @@ zmq::mailbox_t *zmq::io_thread_t::get_ma
     return &_mailbox;
 }
 
-int zmq::io_thread_t::get_load ()
+int zmq::io_thread_t::get_load () const
 {
     return _poller->get_load ();
 }
@@ -107,7 +107,7 @@ void zmq::io_thread_t::timer_event (int)
     zmq_assert (false);
 }
 
-zmq::poller_t *zmq::io_thread_t::get_poller ()
+zmq::poller_t *zmq::io_thread_t::get_poller () const
 {
     zmq_assert (_poller);
     return _poller;
diff -pruN 4.3.2-2/src/io_thread.hpp 4.3.3-1/src/io_thread.hpp
--- 4.3.2-2/src/io_thread.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/io_thread.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -43,7 +43,7 @@ class ctx_t;
 //  Generic part of the I/O thread. Polling-mechanism-specific features
 //  are implemented in separate "polling objects".
 
-class io_thread_t : public object_t, public i_poll_events
+class io_thread_t ZMQ_FINAL : public object_t, public i_poll_events
 {
   public:
     io_thread_t (zmq::ctx_t *ctx_, uint32_t tid_);
@@ -67,13 +67,13 @@ class io_thread_t : public object_t, pub
     void timer_event (int id_);
 
     //  Used by io_objects to retrieve the associated poller object.
-    poller_t *get_poller ();
+    poller_t *get_poller () const;
 
     //  Command handlers.
     void process_stop ();
 
     //  Returns load experienced by the I/O thread.
-    int get_load ();
+    int get_load () const;
 
   private:
     //  I/O thread accesses incoming commands via this mailbox.
@@ -85,8 +85,7 @@ class io_thread_t : public object_t, pub
     //  I/O multiplexing is performed using a poller object.
     poller_t *_poller;
 
-    io_thread_t (const io_thread_t &);
-    const io_thread_t &operator= (const io_thread_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (io_thread_t)
 };
 }
 
diff -pruN 4.3.2-2/src/ipc_address.cpp 4.3.3-1/src/ipc_address.cpp
--- 4.3.2-2/src/ipc_address.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ipc_address.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -28,27 +28,15 @@
 */
 
 #include "precompiled.hpp"
+#include "compat.hpp"
 #include "ipc_address.hpp"
 
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#if defined ZMQ_HAVE_IPC
 
 #include "err.hpp"
 
 #include <string>
 
-#ifndef HAVE_STRNLEN
-static size_t strnlen (const char *s, size_t len)
-{
-    for (size_t i = 0; i < len; i++) {
-        if (s[i] == '\0')
-            return i + 1;
-    }
-
-    return len;
-}
-#endif
-
 zmq::ipc_address_t::ipc_address_t ()
 {
     memset (&_address, 0, sizeof _address);
@@ -86,7 +74,8 @@ int zmq::ipc_address_t::resolve (const c
     if (path_[0] == '@')
         *_address.sun_path = '\0';
 
-    _addrlen = offsetof (sockaddr_un, sun_path) + path_len;
+    _addrlen =
+      static_cast<socklen_t> (offsetof (sockaddr_un, sun_path) + path_len);
     return 0;
 }
 
diff -pruN 4.3.2-2/src/ipc_address.hpp 4.3.3-1/src/ipc_address.hpp
--- 4.3.2-2/src/ipc_address.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ipc_address.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,13 +30,18 @@
 #ifndef __ZMQ_IPC_ADDRESS_HPP_INCLUDED__
 #define __ZMQ_IPC_ADDRESS_HPP_INCLUDED__
 
-#include <string>
+#if defined ZMQ_HAVE_IPC
 
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#include <string>
 
+#if defined _MSC_VER
+#include <afunix.h>
+#else
 #include <sys/socket.h>
 #include <sys/un.h>
+#endif
+
+#include "macros.hpp"
 
 namespace zmq
 {
@@ -58,10 +63,9 @@ class ipc_address_t
 
   private:
     struct sockaddr_un _address;
-    size_t _addrlen;
+    socklen_t _addrlen;
 
-    ipc_address_t (const ipc_address_t &);
-    const ipc_address_t &operator= (const ipc_address_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (ipc_address_t)
 };
 }
 
diff -pruN 4.3.2-2/src/ipc_connecter.cpp 4.3.3-1/src/ipc_connecter.cpp
--- 4.3.2-2/src/ipc_connecter.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ipc_connecter.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,13 +30,11 @@
 #include "precompiled.hpp"
 #include "ipc_connecter.hpp"
 
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#if defined ZMQ_HAVE_IPC
 
 #include <new>
 #include <string>
 
-#include "stream_engine.hpp"
 #include "io_thread.hpp"
 #include "random.hpp"
 #include "err.hpp"
@@ -45,11 +43,14 @@
 #include "ipc_address.hpp"
 #include "session_base.hpp"
 
+#ifdef _MSC_VER
+#include <afunix.h>
+#else
 #include <unistd.h>
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <sys/un.h>
-
+#endif
 
 zmq::ipc_connecter_t::ipc_connecter_t (class io_thread_t *io_thread_,
                                        class session_base_t *session_,
@@ -64,7 +65,7 @@ zmq::ipc_connecter_t::ipc_connecter_t (c
 
 void zmq::ipc_connecter_t::out_event ()
 {
-    fd_t fd = connect ();
+    const fd_t fd = connect ();
     rm_handle ();
 
     //  Handle the error condition by attempt to reconnect.
@@ -80,7 +81,7 @@ void zmq::ipc_connecter_t::out_event ()
 void zmq::ipc_connecter_t::start_connecting ()
 {
     //  Open the connecting socket.
-    int rc = open ();
+    const int rc = open ();
 
     //  Connect may succeed in synchronous manner.
     if (rc == 0) {
@@ -114,26 +115,33 @@ int zmq::ipc_connecter_t::open ()
 
     //  Create the socket.
     _s = open_socket (AF_UNIX, SOCK_STREAM, 0);
-    if (_s == -1)
+    if (_s == retired_fd)
         return -1;
 
     //  Set the non-blocking flag.
     unblock_socket (_s);
 
     //  Connect to the remote peer.
-    int rc = ::connect (_s, _addr->resolved.ipc_addr->addr (),
-                        _addr->resolved.ipc_addr->addrlen ());
+    const int rc = ::connect (_s, _addr->resolved.ipc_addr->addr (),
+                              _addr->resolved.ipc_addr->addrlen ());
 
     //  Connect was successful immediately.
     if (rc == 0)
         return 0;
 
-    //  Translate other error codes indicating asynchronous connect has been
-    //  launched to a uniform EINPROGRESS.
+        //  Translate other error codes indicating asynchronous connect has been
+        //  launched to a uniform EINPROGRESS.
+#ifdef ZMQ_HAVE_WINDOWS
+    const int last_error = WSAGetLastError ();
+    if (last_error == WSAEINPROGRESS || last_error == WSAEWOULDBLOCK)
+        errno = EINPROGRESS;
+    else
+        errno = wsa_error_to_errno (last_error);
+#else
     if (rc == -1 && errno == EINTR) {
         errno = EINPROGRESS;
-        return -1;
     }
+#endif
 
     //  Forward the error.
     return -1;
@@ -145,8 +153,8 @@ zmq::fd_t zmq::ipc_connecter_t::connect
     //  implementations and Solaris.
     int err = 0;
     zmq_socklen_t len = static_cast<zmq_socklen_t> (sizeof (err));
-    int rc = getsockopt (_s, SOL_SOCKET, SO_ERROR,
-                         reinterpret_cast<char *> (&err), &len);
+    const int rc = getsockopt (_s, SOL_SOCKET, SO_ERROR,
+                               reinterpret_cast<char *> (&err), &len);
     if (rc == -1) {
         if (errno == ENOPROTOOPT)
             errno = 0;
@@ -163,7 +171,7 @@ zmq::fd_t zmq::ipc_connecter_t::connect
         return retired_fd;
     }
 
-    fd_t result = _s;
+    const fd_t result = _s;
     _s = retired_fd;
     return result;
 }
diff -pruN 4.3.2-2/src/ipc_connecter.hpp 4.3.3-1/src/ipc_connecter.hpp
--- 4.3.2-2/src/ipc_connecter.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ipc_connecter.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,15 +30,14 @@
 #ifndef __IPC_CONNECTER_HPP_INCLUDED__
 #define __IPC_CONNECTER_HPP_INCLUDED__
 
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#if defined ZMQ_HAVE_IPC
 
 #include "fd.hpp"
 #include "stream_connecter_base.hpp"
 
 namespace zmq
 {
-class ipc_connecter_t : public stream_connecter_base_t
+class ipc_connecter_t ZMQ_FINAL : public stream_connecter_base_t
 {
   public:
     //  If 'delayed_start' is true connecter first waits for a while,
@@ -65,8 +64,7 @@ class ipc_connecter_t : public stream_co
     //  retired_fd if the connection was unsuccessful.
     fd_t connect ();
 
-    ipc_connecter_t (const ipc_connecter_t &);
-    const ipc_connecter_t &operator= (const ipc_connecter_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (ipc_connecter_t)
 };
 }
 
diff -pruN 4.3.2-2/src/ipc_listener.cpp 4.3.3-1/src/ipc_listener.cpp
--- 4.3.2-2/src/ipc_listener.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ipc_listener.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,8 +30,7 @@
 #include "precompiled.hpp"
 #include "ipc_listener.hpp"
 
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#if defined ZMQ_HAVE_IPC
 
 #include <new>
 
@@ -45,11 +44,23 @@
 #include "socket_base.hpp"
 #include "address.hpp"
 
+#ifdef _MSC_VER
+#ifdef ZMQ_IOTHREAD_POLLER_USE_SELECT
+#error On Windows, IPC does not work with POLLER=select, use POLLER=epoll instead, or disable IPC transport
+#endif
+
+#include <afunix.h>
+#include <direct.h>
+
+#define rmdir _rmdir
+#define unlink _unlink
+
+#else
 #include <unistd.h>
 #include <sys/socket.h>
 #include <fcntl.h>
 #include <sys/un.h>
-#include <sys/stat.h>
+#endif
 
 #ifdef ZMQ_HAVE_LOCAL_PEERCRED
 #include <sys/types.h>
@@ -64,70 +75,6 @@
 #endif
 #endif
 
-const char *zmq::ipc_listener_t::tmp_env_vars[] = {
-  "TMPDIR", "TEMPDIR", "TMP",
-  0 // Sentinel
-};
-
-
-int zmq::ipc_listener_t::create_wildcard_address (std::string &path_,
-                                                  std::string &file_)
-{
-    std::string tmp_path;
-
-    // If TMPDIR, TEMPDIR, or TMP are available and are directories, create
-    // the socket directory there.
-    const char **tmp_env = tmp_env_vars;
-    while (tmp_path.empty () && *tmp_env != 0) {
-        char *tmpdir = getenv (*tmp_env);
-        struct stat statbuf;
-
-        // Confirm it is actually a directory before trying to use
-        if (tmpdir != 0 && ::stat (tmpdir, &statbuf) == 0
-            && S_ISDIR (statbuf.st_mode)) {
-            tmp_path.assign (tmpdir);
-            if (*(tmp_path.rbegin ()) != '/') {
-                tmp_path.push_back ('/');
-            }
-        }
-
-        // Try the next environment variable
-        ++tmp_env;
-    }
-
-    // Append a directory name
-    tmp_path.append ("tmpXXXXXX");
-
-    // We need room for tmp_path + trailing NUL
-    std::vector<char> buffer (tmp_path.length () + 1);
-    strcpy (&buffer[0], tmp_path.c_str ());
-
-#ifdef HAVE_MKDTEMP
-    // Create the directory.  POSIX requires that mkdtemp() creates the
-    // directory with 0700 permissions, meaning the only possible race
-    // with socket creation could be the same user.  However, since
-    // each socket is created in a directory created by mkdtemp(), and
-    // mkdtemp() guarantees a unique directory name, there will be no
-    // collision.
-    if (mkdtemp (&buffer[0]) == 0) {
-        return -1;
-    }
-
-    path_.assign (&buffer[0]);
-    file_ = path_ + "/socket";
-#else
-    LIBZMQ_UNUSED (path_);
-    int fd = mkstemp (&buffer[0]);
-    if (fd == -1)
-        return -1;
-    ::close (fd);
-
-    file_.assign (&buffer[0]);
-#endif
-
-    return 0;
-}
-
 zmq::ipc_listener_t::ipc_listener_t (io_thread_t *io_thread_,
                                      socket_base_t *socket_,
                                      const options_t &options_) :
@@ -138,7 +85,7 @@ zmq::ipc_listener_t::ipc_listener_t (io_
 
 void zmq::ipc_listener_t::in_event ()
 {
-    fd_t fd = accept ();
+    const fd_t fd = accept ();
 
     //  If connection was reset by the peer in the meantime, just ignore it.
     //  TODO: Handle specific errors like ENFILE/EMFILE etc.
@@ -166,7 +113,7 @@ int zmq::ipc_listener_t::set_local_addre
 
     //  Allow wildcard file
     if (options.use_fd == -1 && addr[0] == '*') {
-        if (create_wildcard_address (_tmp_socket_dirname, addr) < 0) {
+        if (create_ipc_wildcard_address (_tmp_socket_dirname, addr) < 0) {
             return -1;
         }
     }
@@ -187,7 +134,7 @@ int zmq::ipc_listener_t::set_local_addre
     if (rc != 0) {
         if (!_tmp_socket_dirname.empty ()) {
             // We need to preserve errno to return to the user
-            int tmp_errno = errno;
+            const int tmp_errno = errno;
             ::rmdir (_tmp_socket_dirname.c_str ());
             _tmp_socket_dirname.clear ();
             errno = tmp_errno;
@@ -202,10 +149,10 @@ int zmq::ipc_listener_t::set_local_addre
     } else {
         //  Create a listening socket.
         _s = open_socket (AF_UNIX, SOCK_STREAM, 0);
-        if (_s == -1) {
+        if (_s == retired_fd) {
             if (!_tmp_socket_dirname.empty ()) {
                 // We need to preserve errno to return to the user
-                int tmp_errno = errno;
+                const int tmp_errno = errno;
                 ::rmdir (_tmp_socket_dirname.c_str ());
                 _tmp_socket_dirname.clear ();
                 errno = tmp_errno;
@@ -233,7 +180,7 @@ int zmq::ipc_listener_t::set_local_addre
     return 0;
 
 error:
-    int err = errno;
+    const int err = errno;
     close ();
     errno = err;
     return -1;
@@ -242,9 +189,14 @@ error:
 int zmq::ipc_listener_t::close ()
 {
     zmq_assert (_s != retired_fd);
-    int fd_for_event = _s;
+    const fd_t fd_for_event = _s;
+#ifdef ZMQ_HAVE_WINDOWS
+    int rc = closesocket (_s);
+    wsa_assert (rc != SOCKET_ERROR);
+#else
     int rc = ::close (_s);
     errno_assert (rc == 0);
+#endif
 
     _s = retired_fd;
 
@@ -296,14 +248,15 @@ bool zmq::ipc_listener_t::filter (fd_t s
              != options.ipc_pid_accept_filters.end ())
         return true;
 
-    struct passwd *pw;
-    struct group *gr;
+    const struct passwd *pw;
+    const struct group *gr;
 
     if (!(pw = getpwuid (cred.uid)))
         return false;
-    for (options_t::ipc_gid_accept_filters_t::const_iterator it =
-           options.ipc_gid_accept_filters.begin ();
-         it != options.ipc_gid_accept_filters.end (); it++) {
+    for (options_t::ipc_gid_accept_filters_t::const_iterator
+           it = options.ipc_gid_accept_filters.begin (),
+           end = options.ipc_gid_accept_filters.end ();
+         it != end; it++) {
         if (!(gr = getgrgid (*it)))
             continue;
         for (char **mem = gr->gr_mem; *mem; mem++) {
@@ -352,12 +305,27 @@ zmq::fd_t zmq::ipc_listener_t::accept ()
 #if defined ZMQ_HAVE_SOCK_CLOEXEC && defined HAVE_ACCEPT4
     fd_t sock = ::accept4 (_s, NULL, NULL, SOCK_CLOEXEC);
 #else
-    fd_t sock = ::accept (_s, NULL, NULL);
+    struct sockaddr_storage ss;
+    memset (&ss, 0, sizeof (ss));
+#if defined ZMQ_HAVE_HPUX || defined ZMQ_HAVE_VXWORKS
+    int ss_len = sizeof (ss);
+#else
+    socklen_t ss_len = sizeof (ss);
 #endif
-    if (sock == -1) {
+
+    const fd_t sock =
+      ::accept (_s, reinterpret_cast<struct sockaddr *> (&ss), &ss_len);
+#endif
+    if (sock == retired_fd) {
+#if defined ZMQ_HAVE_WINDOWS
+        const int last_error = WSAGetLastError ();
+        wsa_assert (last_error == WSAEWOULDBLOCK || last_error == WSAECONNRESET
+                    || last_error == WSAEMFILE || last_error == WSAENOBUFS);
+#else
         errno_assert (errno == EAGAIN || errno == EWOULDBLOCK || errno == EINTR
                       || errno == ECONNABORTED || errno == EPROTO
                       || errno == ENFILE);
+#endif
         return retired_fd;
     }
 
@@ -374,7 +342,7 @@ zmq::fd_t zmq::ipc_listener_t::accept ()
 
     if (zmq::set_nosigpipe (sock)) {
 #ifdef ZMQ_HAVE_WINDOWS
-        int rc = closesocket (sock);
+        const int rc = closesocket (sock);
         wsa_assert (rc != SOCKET_ERROR);
 #else
         int rc = ::close (sock);
diff -pruN 4.3.2-2/src/ipc_listener.hpp 4.3.3-1/src/ipc_listener.hpp
--- 4.3.2-2/src/ipc_listener.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ipc_listener.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,8 +30,7 @@
 #ifndef __ZMQ_IPC_LISTENER_HPP_INCLUDED__
 #define __ZMQ_IPC_LISTENER_HPP_INCLUDED__
 
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#if defined ZMQ_HAVE_IPC
 
 #include <string>
 
@@ -40,7 +39,7 @@
 
 namespace zmq
 {
-class ipc_listener_t : public stream_listener_base_t
+class ipc_listener_t ZMQ_FINAL : public stream_listener_base_t
 {
   public:
     ipc_listener_t (zmq::io_thread_t *io_thread_,
@@ -57,9 +56,6 @@ class ipc_listener_t : public stream_lis
     //  Handlers for I/O events.
     void in_event ();
 
-    // Create wildcard path address
-    static int create_wildcard_address (std::string &path_, std::string &file_);
-
     //  Filter new connections if the OS provides a mechanism to get
     //  the credentials of the peer process.  Called from accept().
 #if defined ZMQ_HAVE_SO_PEERCRED || defined ZMQ_HAVE_LOCAL_PEERCRED
@@ -77,17 +73,13 @@ class ipc_listener_t : public stream_lis
     bool _has_file;
 
     //  Name of the temporary directory (if any) that has the
-    //  the UNIX domain socket
+    //  UNIX domain socket
     std::string _tmp_socket_dirname;
 
     //  Name of the file associated with the UNIX domain address.
     std::string _filename;
 
-    // Acceptable temporary directory environment variables
-    static const char *tmp_env_vars[];
-
-    ipc_listener_t (const ipc_listener_t &);
-    const ipc_listener_t &operator= (const ipc_listener_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (ipc_listener_t)
 };
 }
 
diff -pruN 4.3.2-2/src/ip.cpp 4.3.3-1/src/ip.cpp
--- 4.3.2-2/src/ip.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ip.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -38,11 +38,21 @@
 #include <fcntl.h>
 #include <sys/types.h>
 #include <sys/socket.h>
+#include <sys/stat.h>
 #include <netdb.h>
 #include <netinet/in.h>
 #include <netinet/tcp.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+#include <vector>
 #else
 #include "tcp.hpp"
+#ifdef ZMQ_HAVE_IPC
+#include "ipc_address.hpp"
+#endif
+
+#include <direct.h>
 #endif
 
 #if defined ZMQ_HAVE_OPENVMS || defined ZMQ_HAVE_VXWORKS
@@ -71,6 +81,14 @@
 #include <TargetConditionals.h>
 #endif
 
+#ifndef ZMQ_HAVE_WINDOWS
+// Acceptable temporary directory environment variables
+static const char *tmp_env_vars[] = {
+  "TMPDIR", "TEMPDIR", "TMP",
+  0 // Sentinel
+};
+#endif
+
 zmq::fd_t zmq::open_socket (int domain_, int type_, int protocol_)
 {
     int rc;
@@ -84,9 +102,8 @@ zmq::fd_t zmq::open_socket (int domain_,
 #if defined ZMQ_HAVE_WINDOWS && defined WSA_FLAG_NO_HANDLE_INHERIT
     // if supported, create socket with WSA_FLAG_NO_HANDLE_INHERIT, such that
     // the race condition in making it non-inheritable later is avoided
-    const fd_t s =
-      WSASocket (domain_, type_, protocol_, NULL, 0,
-                 WSA_FLAG_OVERLAPPED || WSA_FLAG_NO_HANDLE_INHERIT);
+    const fd_t s = WSASocket (domain_, type_, protocol_, NULL, 0,
+                              WSA_FLAG_OVERLAPPED | WSA_FLAG_NO_HANDLE_INHERIT);
 #else
     const fd_t s = socket (domain_, type_, protocol_);
 #endif
@@ -110,7 +127,7 @@ void zmq::unblock_socket (fd_t s_)
 {
 #if defined ZMQ_HAVE_WINDOWS
     u_long nonblock = 1;
-    int rc = ioctlsocket (s_, FIONBIO, &nonblock);
+    const int rc = ioctlsocket (s_, FIONBIO, &nonblock);
     wsa_assert (rc != SOCKET_ERROR);
 #elif defined ZMQ_HAVE_OPENVMS || defined ZMQ_HAVE_VXWORKS
     int nonblock = 1;
@@ -129,14 +146,15 @@ void zmq::enable_ipv4_mapping (fd_t s_)
 {
     LIBZMQ_UNUSED (s_);
 
-#if defined IPV6_V6ONLY && !defined ZMQ_HAVE_OPENBSD
+#if defined IPV6_V6ONLY && !defined ZMQ_HAVE_OPENBSD                           \
+  && !defined ZMQ_HAVE_DRAGONFLY
 #ifdef ZMQ_HAVE_WINDOWS
     DWORD flag = 0;
 #else
     int flag = 0;
 #endif
-    int rc = setsockopt (s_, IPPROTO_IPV6, IPV6_V6ONLY,
-                         reinterpret_cast<char *> (&flag), sizeof (flag));
+    const int rc = setsockopt (s_, IPPROTO_IPV6, IPV6_V6ONLY,
+                               reinterpret_cast<char *> (&flag), sizeof (flag));
 #ifdef ZMQ_HAVE_WINDOWS
     wsa_assert (rc != SOCKET_ERROR);
 #else
@@ -149,7 +167,7 @@ int zmq::get_peer_ip_address (fd_t sockf
 {
     struct sockaddr_storage ss;
 
-    zmq_socklen_t addrlen =
+    const zmq_socklen_t addrlen =
       get_socket_address (sockfd_, socket_end_remote, &ss);
 
     if (addrlen == 0) {
@@ -167,8 +185,9 @@ int zmq::get_peer_ip_address (fd_t sockf
     }
 
     char host[NI_MAXHOST];
-    int rc = getnameinfo (reinterpret_cast<struct sockaddr *> (&ss), addrlen,
-                          host, sizeof host, NULL, 0, NI_NUMERICHOST);
+    const int rc =
+      getnameinfo (reinterpret_cast<struct sockaddr *> (&ss), addrlen, host,
+                   sizeof host, NULL, 0, NI_NUMERICHOST);
     if (rc != 0)
         return 0;
 
@@ -233,20 +252,12 @@ int zmq::bind_to_device (fd_t s_, const
 #ifdef ZMQ_HAVE_SO_BINDTODEVICE
     int rc = setsockopt (s_, SOL_SOCKET, SO_BINDTODEVICE,
                          bound_device_.c_str (), bound_device_.length ());
+    if (rc != 0) {
+        assert_success_or_recoverable (s_, rc);
+        return -1;
+    }
+    return 0;
 
-#ifdef ZMQ_HAVE_WINDOWS
-    if (rc != SOCKET_ERROR)
-        return 0;
-    const int lastError = WSAGetLastError ();
-    errno = wsa_error_to_errno (lastError);
-    wsa_assert (lastError != WSAENOTSOCK);
-    return -1;
-#else
-    if (rc == 0)
-        return 0;
-    errno_assert (errno != ENOTSOCK);
-    return -1;
-#endif
 #else
     LIBZMQ_UNUSED (s_);
     LIBZMQ_UNUSED (bound_device_);
@@ -286,9 +297,9 @@ bool zmq::initialize_network ()
     //  Intialise Windows sockets. Note that WSAStartup can be called multiple
     //  times given that WSACleanup will be called for each WSAStartup.
 
-    WORD version_requested = MAKEWORD (2, 2);
+    const WORD version_requested = MAKEWORD (2, 2);
     WSADATA wsa_data;
-    int rc = WSAStartup (version_requested, &wsa_data);
+    const int rc = WSAStartup (version_requested, &wsa_data);
     zmq_assert (rc == 0);
     zmq_assert (LOBYTE (wsa_data.wVersion) == 2
                 && HIBYTE (wsa_data.wVersion) == 2);
@@ -301,7 +312,7 @@ void zmq::shutdown_network ()
 {
 #ifdef ZMQ_HAVE_WINDOWS
     //  On Windows, uninitialise socket layer.
-    int rc = WSACleanup ();
+    const int rc = WSACleanup ();
     wsa_assert (rc != SOCKET_ERROR);
 #endif
 
@@ -316,36 +327,16 @@ void zmq::shutdown_network ()
 static void tune_socket (const SOCKET socket_)
 {
     BOOL tcp_nodelay = 1;
-    int rc =
+    const int rc =
       setsockopt (socket_, IPPROTO_TCP, TCP_NODELAY,
                   reinterpret_cast<char *> (&tcp_nodelay), sizeof tcp_nodelay);
     wsa_assert (rc != SOCKET_ERROR);
 
     zmq::tcp_tune_loopback_fast_path (socket_);
 }
-#endif
 
-int zmq::make_fdpair (fd_t *r_, fd_t *w_)
+static int make_fdpair_tcpip (zmq::fd_t *r_, zmq::fd_t *w_)
 {
-#if defined ZMQ_HAVE_EVENTFD
-    int flags = 0;
-#if defined ZMQ_HAVE_EVENTFD_CLOEXEC
-    //  Setting this option result in sane behaviour when exec() functions
-    //  are used. Old sockets are closed and don't block TCP ports, avoid
-    //  leaks, etc.
-    flags |= EFD_CLOEXEC;
-#endif
-    fd_t fd = eventfd (0, flags);
-    if (fd == -1) {
-        errno_assert (errno == ENFILE || errno == EMFILE);
-        *w_ = *r_ = -1;
-        return -1;
-    } else {
-        *w_ = *r_ = fd;
-        return 0;
-    }
-
-#elif defined ZMQ_HAVE_WINDOWS
 #if !defined _WIN32_WCE && !defined ZMQ_HAVE_WINDOWS_UWP
     //  Windows CE does not manage security attributes
     SECURITY_DESCRIPTOR sd;
@@ -372,9 +363,9 @@ int zmq::make_fdpair (fd_t *r_, fd_t *w_
     //  Create critical section only if using fixed signaler port
     //  Use problematic Event implementation for compatibility if using old port 5905.
     //  Otherwise use Mutex implementation.
-    int event_signaler_port = 5905;
+    const int event_signaler_port = 5905;
 
-    if (signaler_port == event_signaler_port) {
+    if (zmq::signaler_port == event_signaler_port) {
 #if !defined _WIN32_WCE && !defined ZMQ_HAVE_WINDOWS_UWP
         sync =
           CreateEventW (&sa, FALSE, TRUE, L"Global\\zmq-signaler-port-sync");
@@ -387,14 +378,14 @@ int zmq::make_fdpair (fd_t *r_, fd_t *w_
                                L"Global\\zmq-signaler-port-sync");
 
         win_assert (sync != NULL);
-    } else if (signaler_port != 0) {
+    } else if (zmq::signaler_port != 0) {
         wchar_t mutex_name[MAX_PATH];
 #ifdef __MINGW32__
         _snwprintf (mutex_name, MAX_PATH, L"Global\\zmq-signaler-port-%d",
-                    signaler_port);
+                    zmq::signaler_port);
 #else
         swprintf (mutex_name, MAX_PATH, L"Global\\zmq-signaler-port-%d",
-                  signaler_port);
+                  zmq::signaler_port);
 #endif
 
 #if !defined _WIN32_WCE && !defined ZMQ_HAVE_WINDOWS_UWP
@@ -415,7 +406,7 @@ int zmq::make_fdpair (fd_t *r_, fd_t *w_
 
     //  Create listening socket.
     SOCKET listener;
-    listener = open_socket (AF_INET, SOCK_STREAM, 0);
+    listener = zmq::open_socket (AF_INET, SOCK_STREAM, 0);
     wsa_assert (listener != INVALID_SOCKET);
 
     //  Set SO_REUSEADDR and TCP_NODELAY on listening socket.
@@ -432,15 +423,15 @@ int zmq::make_fdpair (fd_t *r_, fd_t *w_
     memset (&addr, 0, sizeof addr);
     addr.sin_family = AF_INET;
     addr.sin_addr.s_addr = htonl (INADDR_LOOPBACK);
-    addr.sin_port = htons (signaler_port);
+    addr.sin_port = htons (zmq::signaler_port);
 
     //  Create the writer socket.
-    *w_ = open_socket (AF_INET, SOCK_STREAM, 0);
+    *w_ = zmq::open_socket (AF_INET, SOCK_STREAM, 0);
     wsa_assert (*w_ != INVALID_SOCKET);
 
     if (sync != NULL) {
         //  Enter the critical section.
-        DWORD dwrc = WaitForSingleObject (sync, INFINITE);
+        const DWORD dwrc = WaitForSingleObject (sync, INFINITE);
         zmq_assert (dwrc == WAIT_OBJECT_0 || dwrc == WAIT_ABANDONED);
     }
 
@@ -448,7 +439,7 @@ int zmq::make_fdpair (fd_t *r_, fd_t *w_
     rc = bind (listener, reinterpret_cast<const struct sockaddr *> (&addr),
                sizeof addr);
 
-    if (rc != SOCKET_ERROR && signaler_port == 0) {
+    if (rc != SOCKET_ERROR && zmq::signaler_port == 0) {
         //  Retrieve ephemeral port number
         int addrlen = sizeof addr;
         rc = getsockname (listener, reinterpret_cast<struct sockaddr *> (&addr),
@@ -456,25 +447,28 @@ int zmq::make_fdpair (fd_t *r_, fd_t *w_
     }
 
     //  Listen for incoming connections.
-    if (rc != SOCKET_ERROR)
+    if (rc != SOCKET_ERROR) {
         rc = listen (listener, 1);
+    }
 
     //  Connect writer to the listener.
-    if (rc != SOCKET_ERROR)
+    if (rc != SOCKET_ERROR) {
         rc = connect (*w_, reinterpret_cast<struct sockaddr *> (&addr),
                       sizeof addr);
-
-    //  Set TCP_NODELAY on writer socket.
-    tune_socket (*w_);
+    }
 
     //  Accept connection from writer.
-    if (rc != SOCKET_ERROR)
+    if (rc != SOCKET_ERROR) {
+        //  Set TCP_NODELAY on writer socket.
+        tune_socket (*w_);
+
         *r_ = accept (listener, NULL, NULL);
+    }
 
     //  Send/receive large chunk to work around TCP slow start
     //  This code is a workaround for #1608
     if (*r_ != INVALID_SOCKET) {
-        size_t dummy_size =
+        const size_t dummy_size =
           1024 * 1024; //  1M to overload default receive buffer
         unsigned char *dummy =
           static_cast<unsigned char *> (malloc (dummy_size));
@@ -514,7 +508,7 @@ int zmq::make_fdpair (fd_t *r_, fd_t *w_
     if (sync != NULL) {
         //  Exit the critical section.
         BOOL brc;
-        if (signaler_port == event_signaler_port)
+        if (zmq::signaler_port == event_signaler_port)
             brc = SetEvent (sync);
         else
             brc = ReleaseMutex (sync);
@@ -526,7 +520,7 @@ int zmq::make_fdpair (fd_t *r_, fd_t *w_
     }
 
     if (*r_ != INVALID_SOCKET) {
-        make_socket_noninheritable (*r_);
+        zmq::make_socket_noninheritable (*r_);
         return 0;
     }
     //  Cleanup writer if connection failed
@@ -536,10 +530,116 @@ int zmq::make_fdpair (fd_t *r_, fd_t *w_
         *w_ = INVALID_SOCKET;
     }
     //  Set errno from saved value
-    errno = wsa_error_to_errno (saved_errno);
+    errno = zmq::wsa_error_to_errno (saved_errno);
     return -1;
+}
+#endif
 
+int zmq::make_fdpair (fd_t *r_, fd_t *w_)
+{
+#if defined ZMQ_HAVE_EVENTFD
+    int flags = 0;
+#if defined ZMQ_HAVE_EVENTFD_CLOEXEC
+    //  Setting this option result in sane behaviour when exec() functions
+    //  are used. Old sockets are closed and don't block TCP ports, avoid
+    //  leaks, etc.
+    flags |= EFD_CLOEXEC;
+#endif
+    fd_t fd = eventfd (0, flags);
+    if (fd == -1) {
+        errno_assert (errno == ENFILE || errno == EMFILE);
+        *w_ = *r_ = -1;
+        return -1;
+    }
+    *w_ = *r_ = fd;
+    return 0;
+
+
+#elif defined ZMQ_HAVE_WINDOWS
+#ifdef ZMQ_HAVE_IPC
+    ipc_address_t address;
+    std::string dirname, filename;
 
+    //  Create a listening socket.
+    const SOCKET listener = open_socket (AF_UNIX, SOCK_STREAM, 0);
+    if (listener == retired_fd) {
+        //  This may happen if the library was built on a system supporting AF_UNIX, but the system running doesn't support it.
+        goto try_tcpip;
+    }
+
+    create_ipc_wildcard_address (dirname, filename);
+
+    //  Initialise the address structure.
+    int rc = address.resolve (filename.c_str ());
+    if (rc != 0) {
+        goto error_closelistener;
+    }
+
+    //  Bind the socket to the file path.
+    rc = bind (listener, const_cast<sockaddr *> (address.addr ()),
+               address.addrlen ());
+    if (rc != 0) {
+        errno = wsa_error_to_errno (WSAGetLastError ());
+        goto error_closelistener;
+    }
+
+    //  Listen for incoming connections.
+    rc = listen (listener, 1);
+    if (rc != 0) {
+        errno = wsa_error_to_errno (WSAGetLastError ());
+        goto error_closelistener;
+    }
+
+    sockaddr_un lcladdr;
+    socklen_t lcladdr_len = sizeof lcladdr;
+
+    rc = getsockname (listener, reinterpret_cast<struct sockaddr *> (&lcladdr),
+                      &lcladdr_len);
+    wsa_assert (rc != -1);
+
+    //  Create the client socket.
+    *w_ = open_socket (AF_UNIX, SOCK_STREAM, 0);
+    if (*w_ == -1) {
+        errno = wsa_error_to_errno (WSAGetLastError ());
+        goto error_closelistener;
+    }
+
+    //  Connect to the remote peer.
+    rc = ::connect (*w_, reinterpret_cast<const struct sockaddr *> (&lcladdr),
+                    lcladdr_len);
+    if (rc == -1) {
+        goto error_closeclient;
+    }
+
+    *r_ = accept (listener, NULL, NULL);
+    errno_assert (*r_ != -1);
+
+    //  Close the listener socket, we don't need it anymore.
+    rc = closesocket (listener);
+    wsa_assert (rc == 0);
+
+    return 0;
+
+error_closeclient:
+    int saved_errno = errno;
+    rc = closesocket (*w_);
+    wsa_assert (rc == 0);
+    errno = saved_errno;
+
+error_closelistener:
+    saved_errno = errno;
+    rc = closesocket (listener);
+    wsa_assert (rc == 0);
+    errno = saved_errno;
+
+    return -1;
+
+try_tcpip:
+    // try to fallback to TCP/IP
+    // TODO: maybe remember this decision permanently?
+#endif
+
+    return make_fdpair_tcpip (r_, w_);
 #elif defined ZMQ_HAVE_OPENVMS
 
     //  Whilst OpenVMS supports socketpair - it maps to AF_INET only.  Further,
@@ -680,3 +780,131 @@ void zmq::make_socket_noninheritable (fd
     LIBZMQ_UNUSED (sock_);
 #endif
 }
+
+void zmq::assert_success_or_recoverable (zmq::fd_t s_, int rc_)
+{
+#ifdef ZMQ_HAVE_WINDOWS
+    if (rc_ != SOCKET_ERROR) {
+        return;
+    }
+#else
+    if (rc_ != -1) {
+        return;
+    }
+#endif
+
+    //  Check whether an error occurred
+    int err = 0;
+#if defined ZMQ_HAVE_HPUX || defined ZMQ_HAVE_VXWORKS
+    int len = sizeof err;
+#else
+    socklen_t len = sizeof err;
+#endif
+
+    const int rc = getsockopt (s_, SOL_SOCKET, SO_ERROR,
+                               reinterpret_cast<char *> (&err), &len);
+
+    //  Assert if the error was caused by 0MQ bug.
+    //  Networking problems are OK. No need to assert.
+#ifdef ZMQ_HAVE_WINDOWS
+    zmq_assert (rc == 0);
+    if (err != 0) {
+        wsa_assert (err == WSAECONNREFUSED || err == WSAECONNRESET
+                    || err == WSAECONNABORTED || err == WSAEINTR
+                    || err == WSAETIMEDOUT || err == WSAEHOSTUNREACH
+                    || err == WSAENETUNREACH || err == WSAENETDOWN
+                    || err == WSAENETRESET || err == WSAEACCES
+                    || err == WSAEINVAL || err == WSAEADDRINUSE);
+    }
+#else
+    //  Following code should handle both Berkeley-derived socket
+    //  implementations and Solaris.
+    if (rc == -1)
+        err = errno;
+    if (err != 0) {
+        errno = err;
+        errno_assert (errno == ECONNREFUSED || errno == ECONNRESET
+                      || errno == ECONNABORTED || errno == EINTR
+                      || errno == ETIMEDOUT || errno == EHOSTUNREACH
+                      || errno == ENETUNREACH || errno == ENETDOWN
+                      || errno == ENETRESET || errno == EINVAL);
+    }
+#endif
+}
+
+#ifdef ZMQ_HAVE_IPC
+int zmq::create_ipc_wildcard_address (std::string &path_, std::string &file_)
+{
+#if defined ZMQ_HAVE_WINDOWS
+    char buffer[MAX_PATH];
+
+    {
+        const errno_t rc = tmpnam_s (buffer);
+        errno_assert (rc == 0);
+    }
+
+    // TODO or use CreateDirectoryA and specify permissions?
+    const int rc = _mkdir (buffer);
+    if (rc != 0) {
+        return -1;
+    }
+
+    path_.assign (buffer);
+    file_ = path_ + "/socket";
+#else
+    std::string tmp_path;
+
+    // If TMPDIR, TEMPDIR, or TMP are available and are directories, create
+    // the socket directory there.
+    const char **tmp_env = tmp_env_vars;
+    while (tmp_path.empty () && *tmp_env != 0) {
+        const char *const tmpdir = getenv (*tmp_env);
+        struct stat statbuf;
+
+        // Confirm it is actually a directory before trying to use
+        if (tmpdir != 0 && ::stat (tmpdir, &statbuf) == 0
+            && S_ISDIR (statbuf.st_mode)) {
+            tmp_path.assign (tmpdir);
+            if (*(tmp_path.rbegin ()) != '/') {
+                tmp_path.push_back ('/');
+            }
+        }
+
+        // Try the next environment variable
+        ++tmp_env;
+    }
+
+    // Append a directory name
+    tmp_path.append ("tmpXXXXXX");
+
+    // We need room for tmp_path + trailing NUL
+    std::vector<char> buffer (tmp_path.length () + 1);
+    memcpy (&buffer[0], tmp_path.c_str (), tmp_path.length () + 1);
+
+#if defined HAVE_MKDTEMP
+    // Create the directory.  POSIX requires that mkdtemp() creates the
+    // directory with 0700 permissions, meaning the only possible race
+    // with socket creation could be the same user.  However, since
+    // each socket is created in a directory created by mkdtemp(), and
+    // mkdtemp() guarantees a unique directory name, there will be no
+    // collision.
+    if (mkdtemp (&buffer[0]) == 0) {
+        return -1;
+    }
+
+    path_.assign (&buffer[0]);
+    file_ = path_ + "/socket";
+#else
+    LIBZMQ_UNUSED (path_);
+    int fd = mkstemp (&buffer[0]);
+    if (fd == -1)
+        return -1;
+    ::close (fd);
+
+    file_.assign (&buffer[0]);
+#endif
+#endif
+
+    return 0;
+}
+#endif
diff -pruN 4.3.2-2/src/ip.hpp 4.3.3-1/src/ip.hpp
--- 4.3.2-2/src/ip.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ip.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -71,6 +71,16 @@ int make_fdpair (fd_t *r_, fd_t *w_);
 // Makes a socket non-inheritable to child processes.
 // Asserts on any failure.
 void make_socket_noninheritable (fd_t sock_);
+
+//  Asserts that:
+//  - an internal 0MQ error did not occur,
+//  - and, if a socket error occured, it can be recovered from.
+void assert_success_or_recoverable (fd_t s_, int rc_);
+
+#ifdef ZMQ_HAVE_IPC
+// Create an IPC wildcard path address
+int create_ipc_wildcard_address (std::string &path_, std::string &file_);
+#endif
 }
 
 #endif
diff -pruN 4.3.2-2/src/i_poll_events.hpp 4.3.3-1/src/i_poll_events.hpp
--- 4.3.2-2/src/i_poll_events.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/i_poll_events.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,6 +30,8 @@
 #ifndef __ZMQ_I_POLL_EVENTS_HPP_INCLUDED__
 #define __ZMQ_I_POLL_EVENTS_HPP_INCLUDED__
 
+#include "macros.hpp"
+
 namespace zmq
 {
 // Virtual interface to be exposed by object that want to be notified
@@ -37,7 +39,7 @@ namespace zmq
 
 struct i_poll_events
 {
-    virtual ~i_poll_events () {}
+    virtual ~i_poll_events () ZMQ_DEFAULT;
 
     // Called by I/O thread when file descriptor is ready for reading.
     virtual void in_event () = 0;
diff -pruN 4.3.2-2/src/ip_resolver.cpp 4.3.3-1/src/ip_resolver.cpp
--- 4.3.2-2/src/ip_resolver.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ip_resolver.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -97,7 +97,8 @@ zmq::ip_resolver_options_t::ip_resolver_
     _nic_name_allowed (false),
     _ipv6_wanted (false),
     _port_expected (false),
-    _dns_allowed (false)
+    _dns_allowed (false),
+    _path_allowed (false)
 {
 }
 
@@ -141,6 +142,13 @@ zmq::ip_resolver_options_t &zmq::ip_reso
     return *this;
 }
 
+zmq::ip_resolver_options_t &zmq::ip_resolver_options_t::allow_path (bool allow_)
+{
+    _path_allowed = allow_;
+
+    return *this;
+}
+
 bool zmq::ip_resolver_options_t::bindable ()
 {
     return _bindable_wanted;
@@ -166,6 +174,11 @@ bool zmq::ip_resolver_options_t::allow_d
     return _dns_allowed;
 }
 
+bool zmq::ip_resolver_options_t::allow_path ()
+{
+    return _path_allowed;
+}
+
 zmq::ip_resolver_t::ip_resolver_t (ip_resolver_options_t opts_) :
     _options (opts_)
 {
@@ -187,7 +200,7 @@ int zmq::ip_resolver_t::resolve (ip_addr
         }
 
         addr = std::string (name_, delim - name_);
-        std::string port_str = std::string (delim + 1);
+        const std::string port_str = std::string (delim + 1);
 
         if (port_str == "*") {
             if (_options.bindable ()) {
@@ -214,6 +227,13 @@ int zmq::ip_resolver_t::resolve (ip_addr
         port = 0;
     }
 
+    // Check if path is allowed in ip address, if allowed it must be truncated
+    if (_options.allow_path ()) {
+        const size_t pos = addr.find ('/');
+        if (pos != std::string::npos)
+            addr = addr.substr (0, pos);
+    }
+
     //  Trim any square brackets surrounding the address. Used for
     //  IPv6 addresses to remove the confusion with the port
     //  delimiter.
@@ -227,11 +247,15 @@ int zmq::ip_resolver_t::resolve (ip_addr
 
     //  Look for an interface name / zone_id in the address
     //  Reference: https://tools.ietf.org/html/rfc4007
-    std::size_t pos = addr.rfind ('%');
+    const std::size_t pos = addr.rfind ('%');
     uint32_t zone_id = 0;
 
     if (pos != std::string::npos) {
         std::string if_str = addr.substr (pos + 1);
+        if (if_str.empty ()) {
+            errno = EINVAL;
+            return -1;
+        }
         addr = addr.substr (0, pos);
 
         if (isalpha (if_str.at (0))) {
@@ -257,7 +281,7 @@ int zmq::ip_resolver_t::resolve (ip_addr
 
     if (!resolved && _options.allow_nic_name ()) {
         //  Try to resolve the string as a NIC name.
-        int rc = resolve_nic_name (ip_addr_, addr_str);
+        const int rc = resolve_nic_name (ip_addr_, addr_str);
 
         if (rc == 0) {
             resolved = true;
@@ -267,7 +291,7 @@ int zmq::ip_resolver_t::resolve (ip_addr
     }
 
     if (!resolved) {
-        int rc = resolve_getaddrinfo (ip_addr_, addr_str);
+        const int rc = resolve_getaddrinfo (ip_addr_, addr_str);
 
         if (rc != 0) {
             return rc;
@@ -368,7 +392,7 @@ int zmq::ip_resolver_t::resolve_getaddri
 
     //  Use the first result.
     zmq_assert (res != NULL);
-    zmq_assert ((size_t) res->ai_addrlen <= sizeof (*ip_addr_));
+    zmq_assert (static_cast<size_t> (res->ai_addrlen) <= sizeof (*ip_addr_));
     memcpy (ip_addr_, res->ai_addr, res->ai_addrlen);
 
     //  Cleanup getaddrinfo after copying the possibly referenced result.
@@ -520,7 +544,7 @@ int zmq::ip_resolver_t::resolve_nic_name
 
     //  Find the corresponding network interface.
     bool found = false;
-    for (ifaddrs *ifp = ifa; ifp != NULL; ifp = ifp->ifa_next) {
+    for (const ifaddrs *ifp = ifa; ifp != NULL; ifp = ifp->ifa_next) {
         if (ifp->ifa_addr == NULL)
             continue;
 
@@ -561,7 +585,7 @@ int zmq::ip_resolver_t::get_interface_na
 
     char *if_name_result = NULL;
 
-#if !defined ZMQ_HAVE_WINDOWS_TARGET_XP && !defined ZMQ_HAVE_WINDOWS_UWP
+#if _WIN32_WINNT > _WIN32_WINNT_WINXP && !defined ZMQ_HAVE_WINDOWS_UWP
     if_name_result = if_indextoname (index_, buffer);
 #endif
 
@@ -577,7 +601,7 @@ int zmq::ip_resolver_t::get_interface_na
 int zmq::ip_resolver_t::wchar_to_utf8 (const WCHAR *src_, char **dest_) const
 {
     int rc;
-    int buffer_len =
+    const int buffer_len =
       WideCharToMultiByte (CP_UTF8, 0, src_, -1, NULL, 0, NULL, 0);
 
     char *buffer = static_cast<char *> (malloc (buffer_len));
@@ -704,7 +728,7 @@ void zmq::ip_resolver_t::do_freeaddrinfo
 
 unsigned int zmq::ip_resolver_t::do_if_nametoindex (const char *ifname_)
 {
-#if !defined ZMQ_HAVE_WINDOWS_TARGET_XP && !defined ZMQ_HAVE_WINDOWS_UWP       \
+#if _WIN32_WINNT > _WIN32_WINNT_WINXP && !defined ZMQ_HAVE_WINDOWS_UWP         \
   && !defined ZMQ_HAVE_VXWORKS
     return if_nametoindex (ifname_);
 #else
diff -pruN 4.3.2-2/src/ip_resolver.hpp 4.3.3-1/src/ip_resolver.hpp
--- 4.3.2-2/src/ip_resolver.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ip_resolver.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -68,12 +68,14 @@ class ip_resolver_options_t
     ip_resolver_options_t &ipv6 (bool ipv6_);
     ip_resolver_options_t &expect_port (bool expect_);
     ip_resolver_options_t &allow_dns (bool allow_);
+    ip_resolver_options_t &allow_path (bool allow_);
 
     bool bindable ();
     bool allow_nic_name ();
     bool ipv6 ();
     bool expect_port ();
     bool allow_dns ();
+    bool allow_path ();
 
   private:
     bool _bindable_wanted;
@@ -81,12 +83,14 @@ class ip_resolver_options_t
     bool _ipv6_wanted;
     bool _port_expected;
     bool _dns_allowed;
+    bool _path_allowed;
 };
 
 class ip_resolver_t
 {
   public:
     ip_resolver_t (ip_resolver_options_t opts_);
+    virtual ~ip_resolver_t (){};
 
     int resolve (ip_addr_t *ip_addr_, const char *name_);
 
diff -pruN 4.3.2-2/src/kqueue.hpp 4.3.3-1/src/kqueue.hpp
--- 4.3.2-2/src/kqueue.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/kqueue.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -49,13 +49,13 @@ struct i_poll_events;
 //  Implements socket polling mechanism using the BSD-specific
 //  kqueue interface.
 
-class kqueue_t : public worker_poller_base_t
+class kqueue_t ZMQ_FINAL : public worker_poller_base_t
 {
   public:
     typedef void *handle_t;
 
     kqueue_t (const thread_ctx_t &ctx_);
-    ~kqueue_t ();
+    ~kqueue_t () ZMQ_FINAL;
 
     //  "poller" concept.
     handle_t add_fd (fd_t fd_, zmq::i_poll_events *events_);
@@ -70,7 +70,7 @@ class kqueue_t : public worker_poller_ba
 
   private:
     //  Main event loop.
-    void loop ();
+    void loop () ZMQ_FINAL;
 
     //  File descriptor referring to the kernel event queue.
     fd_t kqueue_fd;
@@ -93,8 +93,7 @@ class kqueue_t : public worker_poller_ba
     typedef std::vector<poll_entry_t *> retired_t;
     retired_t retired;
 
-    kqueue_t (const kqueue_t &);
-    const kqueue_t &operator= (const kqueue_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (kqueue_t)
 
 #ifdef HAVE_FORK
     // the process that created this context. Used to detect forking.
diff -pruN 4.3.2-2/src/lb.cpp 4.3.3-1/src/lb.cpp
--- 4.3.2-2/src/lb.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/lb.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -50,7 +50,7 @@ void zmq::lb_t::attach (pipe_t *pipe_)
 
 void zmq::lb_t::pipe_terminated (pipe_t *pipe_)
 {
-    pipes_t::size_type index = _pipes.index (pipe_);
+    const pipes_t::size_type index = _pipes.index (pipe_);
 
     //  If we are in the middle of multipart message and current pipe
     //  have disconnected, we have to drop the remainder of the message.
@@ -151,7 +151,7 @@ int zmq::lb_t::sendpipe (msg_t *msg_, pi
     }
 
     //  Detach the message from the data buffer.
-    int rc = msg_->init ();
+    const int rc = msg_->init ();
     errno_assert (rc == 0);
 
     return 0;
diff -pruN 4.3.2-2/src/lb.hpp 4.3.3-1/src/lb.hpp
--- 4.3.2-2/src/lb.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/lb.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -78,8 +78,7 @@ class lb_t
     //  True if we are dropping current message.
     bool _dropping;
 
-    lb_t (const lb_t &);
-    const lb_t &operator= (const lb_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (lb_t)
 };
 }
 
diff -pruN 4.3.2-2/src/macros.hpp 4.3.3-1/src/macros.hpp
--- 4.3.2-2/src/macros.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/macros.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -19,3 +19,45 @@
 #define ZMQ_NOEXCEPT
 #endif
 #endif
+
+#if !defined ZMQ_OVERRIDE
+#if defined ZMQ_HAVE_NOEXCEPT
+#define ZMQ_OVERRIDE override
+#else
+#define ZMQ_OVERRIDE
+#endif
+#endif
+
+#if !defined ZMQ_FINAL
+#if defined ZMQ_HAVE_NOEXCEPT
+#define ZMQ_FINAL final
+#else
+#define ZMQ_FINAL
+#endif
+#endif
+
+#if !defined ZMQ_DEFAULT
+#if defined ZMQ_HAVE_NOEXCEPT
+#define ZMQ_DEFAULT = default;
+#else
+#define ZMQ_DEFAULT                                                            \
+    {                                                                          \
+    }
+#endif
+#endif
+
+#if !defined ZMQ_NON_COPYABLE_NOR_MOVABLE
+#if defined ZMQ_HAVE_NOEXCEPT
+#define ZMQ_NON_COPYABLE_NOR_MOVABLE(classname)                                \
+  public:                                                                      \
+    classname (const classname &) = delete;                                    \
+    classname &operator= (const classname &) = delete;                         \
+    classname (classname &&) = delete;                                         \
+    classname &operator= (classname &&) = delete;
+#else
+#define ZMQ_NON_COPYABLE_NOR_MOVABLE(classname)                                \
+  private:                                                                     \
+    classname (const classname &);                                             \
+    classname &operator= (const classname &);
+#endif
+#endif
diff -pruN 4.3.2-2/src/mailbox.hpp 4.3.3-1/src/mailbox.hpp
--- 4.3.2-2/src/mailbox.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/mailbox.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -42,7 +42,7 @@
 
 namespace zmq
 {
-class mailbox_t : public i_mailbox
+class mailbox_t ZMQ_FINAL : public i_mailbox
 {
   public:
     mailbox_t ();
@@ -58,7 +58,7 @@ class mailbox_t : public i_mailbox
     // close the file descriptors in the signaller. This is used in a forked
     // child process to close the file descriptors so that they do not interfere
     // with the context in the parent process.
-    void forked () { _signaler.forked (); }
+    void forked () ZMQ_FINAL { _signaler.forked (); }
 #endif
 
   private:
@@ -79,9 +79,7 @@ class mailbox_t : public i_mailbox
     //  read commands from it.
     bool _active;
 
-    //  Disable copying of mailbox_t object.
-    mailbox_t (const mailbox_t &);
-    const mailbox_t &operator= (const mailbox_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (mailbox_t)
 };
 }
 
diff -pruN 4.3.2-2/src/mailbox_safe.cpp 4.3.3-1/src/mailbox_safe.cpp
--- 4.3.2-2/src/mailbox_safe.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/mailbox_safe.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -62,7 +62,7 @@ void zmq::mailbox_safe_t::remove_signale
 {
     // TODO: make a copy of array and signal outside the lock
     const std::vector<zmq::signaler_t *>::iterator end = _signalers.end ();
-    std::vector<signaler_t *>::iterator it =
+    const std::vector<signaler_t *>::iterator it =
       std::find (_signalers.begin (), end, signaler_);
 
     if (it != end)
@@ -106,7 +106,7 @@ int zmq::mailbox_safe_t::recv (command_t
         _sync->lock ();
     } else {
         //  Wait for signal from the command sender.
-        int rc = _cond_var.wait (_sync, timeout_);
+        const int rc = _cond_var.wait (_sync, timeout_);
         if (rc == -1) {
             errno_assert (errno == EAGAIN || errno == EINTR);
             return -1;
diff -pruN 4.3.2-2/src/mailbox_safe.hpp 4.3.3-1/src/mailbox_safe.hpp
--- 4.3.2-2/src/mailbox_safe.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/mailbox_safe.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -44,7 +44,7 @@
 
 namespace zmq
 {
-class mailbox_safe_t : public i_mailbox
+class mailbox_safe_t ZMQ_FINAL : public i_mailbox
 {
   public:
     mailbox_safe_t (mutex_t *sync_);
@@ -62,7 +62,7 @@ class mailbox_safe_t : public i_mailbox
     // close the file descriptors in the signaller. This is used in a forked
     // child process to close the file descriptors so that they do not interfere
     // with the context in the parent process.
-    void forked ()
+    void forked () ZMQ_FINAL
     {
         // TODO: call fork on the condition variable
     }
@@ -81,9 +81,7 @@ class mailbox_safe_t : public i_mailbox
 
     std::vector<zmq::signaler_t *> _signalers;
 
-    //  Disable copying of mailbox_t object.
-    mailbox_safe_t (const mailbox_safe_t &);
-    const mailbox_safe_t &operator= (const mailbox_safe_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (mailbox_safe_t)
 };
 }
 
diff -pruN 4.3.2-2/src/mechanism_base.cpp 4.3.3-1/src/mechanism_base.cpp
--- 4.3.2-2/src/mechanism_base.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/mechanism_base.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,7 +39,7 @@ zmq::mechanism_base_t::mechanism_base_t
 {
 }
 
-int zmq::mechanism_base_t::check_basic_command_structure (msg_t *msg_)
+int zmq::mechanism_base_t::check_basic_command_structure (msg_t *msg_) const
 {
     if (msg_->size () <= 1
         || msg_->size () <= (static_cast<uint8_t *> (msg_->data ()))[0]) {
diff -pruN 4.3.2-2/src/mechanism_base.hpp 4.3.3-1/src/mechanism_base.hpp
--- 4.3.2-2/src/mechanism_base.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/mechanism_base.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,12 +39,11 @@ class msg_t;
 class mechanism_base_t : public mechanism_t
 {
   protected:
-    mechanism_base_t (session_base_t *const session_,
-                      const options_t &options_);
+    mechanism_base_t (session_base_t *session_, const options_t &options_);
 
     session_base_t *const session;
 
-    int check_basic_command_structure (msg_t *msg_);
+    int check_basic_command_structure (msg_t *msg_) const;
 
     void handle_error_reason (const char *error_reason_,
                               size_t error_reason_len_);
diff -pruN 4.3.2-2/src/mechanism.cpp 4.3.3-1/src/mechanism.cpp
--- 4.3.2-2/src/mechanism.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/mechanism.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -93,24 +93,30 @@ const char socket_type_dish[] = "DISH";
 const char socket_type_gather[] = "GATHER";
 const char socket_type_scatter[] = "SCATTER";
 const char socket_type_dgram[] = "DGRAM";
+const char socket_type_peer[] = "PEER";
+const char socket_type_channel[] = "CHANNEL";
 #endif
 
-const char *zmq::mechanism_t::socket_type_string (int socket_type_) const
+const char *zmq::mechanism_t::socket_type_string (int socket_type_)
 {
     // TODO the order must of the names must correspond to the values resp. order of ZMQ_* socket type definitions in zmq.h!
-    static const char *names[] = {
-      socket_type_pair,   socket_type_pub,    socket_type_sub,
-      socket_type_req,    socket_type_rep,    socket_type_dealer,
-      socket_type_router, socket_type_pull,   socket_type_push,
-      socket_type_xpub,   socket_type_xsub,   socket_type_stream,
+    static const char *names[] = {socket_type_pair,   socket_type_pub,
+                                  socket_type_sub,    socket_type_req,
+                                  socket_type_rep,    socket_type_dealer,
+                                  socket_type_router, socket_type_pull,
+                                  socket_type_push,   socket_type_xpub,
+                                  socket_type_xsub,   socket_type_stream,
 #ifdef ZMQ_BUILD_DRAFT_API
-      socket_type_server, socket_type_client, socket_type_radio,
-      socket_type_dish,   socket_type_gather, socket_type_scatter,
-      socket_type_dgram
+                                  socket_type_server, socket_type_client,
+                                  socket_type_radio,  socket_type_dish,
+                                  socket_type_gather, socket_type_scatter,
+                                  socket_type_dgram,  socket_type_peer,
+                                  socket_type_channel
 #endif
     };
     static const size_t names_count = sizeof (names) / sizeof (names[0]);
-    zmq_assert (socket_type_ >= 0 && socket_type_ < (int) names_count);
+    zmq_assert (socket_type_ >= 0
+                && socket_type_ < static_cast<int> (names_count));
     return names[socket_type_];
 }
 
@@ -352,6 +358,10 @@ bool zmq::mechanism_t::check_socket_type
             return strequals (type_, len_, socket_type_gather);
         case ZMQ_DGRAM:
             return strequals (type_, len_, socket_type_dgram);
+        case ZMQ_PEER:
+            return strequals (type_, len_, socket_type_peer);
+        case ZMQ_CHANNEL:
+            return strequals (type_, len_, socket_type_channel);
 #endif
         default:
             break;
diff -pruN 4.3.2-2/src/mechanism.hpp 4.3.3-1/src/mechanism.hpp
--- 4.3.2-2/src/mechanism.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/mechanism.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -81,17 +81,20 @@ class mechanism_t
 
     const blob_t &get_user_id () const;
 
-    const metadata_t::dict_t &get_zmtp_properties ()
+    const metadata_t::dict_t &get_zmtp_properties () const
     {
         return _zmtp_properties;
     }
 
-    const metadata_t::dict_t &get_zap_properties () { return _zap_properties; }
+    const metadata_t::dict_t &get_zap_properties () const
+    {
+        return _zap_properties;
+    }
 
   protected:
     //  Only used to identify the socket for the Socket-Type
     //  property in the wire protocol.
-    const char *socket_type_string (int socket_type_) const;
+    static const char *socket_type_string (int socket_type_);
 
     static size_t add_property (unsigned char *ptr_,
                                 size_t ptr_capacity_,
diff -pruN 4.3.2-2/src/metadata.cpp 4.3.3-1/src/metadata.cpp
--- 4.3.2-2/src/metadata.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/metadata.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,7 +36,7 @@ zmq::metadata_t::metadata_t (const dict_
 
 const char *zmq::metadata_t::get (const std::string &property_) const
 {
-    dict_t::const_iterator it = _dict.find (property_);
+    const dict_t::const_iterator it = _dict.find (property_);
     if (it == _dict.end ()) {
         /** \todo remove this when support for the deprecated name "Identity" is dropped */
         if (property_ == "Identity")
diff -pruN 4.3.2-2/src/metadata.hpp 4.3.3-1/src/metadata.hpp
--- 4.3.2-2/src/metadata.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/metadata.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -55,14 +55,13 @@ class metadata_t
     bool drop_ref ();
 
   private:
-    metadata_t (const metadata_t &);
-    metadata_t &operator= (const metadata_t &);
-
     //  Reference counter.
     atomic_counter_t _ref_cnt;
 
     //  Dictionary holding metadata.
     const dict_t _dict;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (metadata_t)
 };
 }
 
diff -pruN 4.3.2-2/src/msg.cpp 4.3.3-1/src/msg.cpp
--- 4.3.2-2/src/msg.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/msg.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -28,6 +28,7 @@
 */
 
 #include "precompiled.hpp"
+#include "compat.hpp"
 #include "macros.hpp"
 #include "msg.hpp"
 
@@ -79,7 +80,8 @@ int zmq::msg_t::init ()
     _u.vsm.type = type_vsm;
     _u.vsm.flags = 0;
     _u.vsm.size = 0;
-    _u.vsm.group[0] = '\0';
+    _u.vsm.group.sgroup.group[0] = '\0';
+    _u.vsm.group.type = group_type_short;
     _u.vsm.routing_id = 0;
     return 0;
 }
@@ -91,13 +93,15 @@ int zmq::msg_t::init_size (size_t size_)
         _u.vsm.type = type_vsm;
         _u.vsm.flags = 0;
         _u.vsm.size = static_cast<unsigned char> (size_);
-        _u.vsm.group[0] = '\0';
+        _u.vsm.group.sgroup.group[0] = '\0';
+        _u.vsm.group.type = group_type_short;
         _u.vsm.routing_id = 0;
     } else {
         _u.lmsg.metadata = NULL;
         _u.lmsg.type = type_lmsg;
         _u.lmsg.flags = 0;
-        _u.lmsg.group[0] = '\0';
+        _u.lmsg.group.sgroup.group[0] = '\0';
+        _u.lmsg.group.type = group_type_short;
         _u.lmsg.routing_id = 0;
         _u.lmsg.content = NULL;
         if (sizeof (content_t) + size_ > size_)
@@ -117,6 +121,20 @@ int zmq::msg_t::init_size (size_t size_)
     return 0;
 }
 
+int zmq::msg_t::init_buffer (const void *buf_, size_t size_)
+{
+    const int rc = init_size (size_);
+    if (unlikely (rc < 0)) {
+        return -1;
+    }
+    if (size_) {
+        // NULL and zero size is allowed
+        assert (NULL != buf_);
+        memcpy (data (), buf_, size_);
+    }
+    return 0;
+}
+
 int zmq::msg_t::init_external_storage (content_t *content_,
                                        void *data_,
                                        size_t size_,
@@ -129,7 +147,8 @@ int zmq::msg_t::init_external_storage (c
     _u.zclmsg.metadata = NULL;
     _u.zclmsg.type = type_zclmsg;
     _u.zclmsg.flags = 0;
-    _u.zclmsg.group[0] = '\0';
+    _u.zclmsg.group.sgroup.group[0] = '\0';
+    _u.zclmsg.group.type = group_type_short;
     _u.zclmsg.routing_id = 0;
 
     _u.zclmsg.content = content_;
@@ -158,13 +177,15 @@ int zmq::msg_t::init_data (void *data_,
         _u.cmsg.flags = 0;
         _u.cmsg.data = data_;
         _u.cmsg.size = size_;
-        _u.cmsg.group[0] = '\0';
+        _u.cmsg.group.sgroup.group[0] = '\0';
+        _u.cmsg.group.type = group_type_short;
         _u.cmsg.routing_id = 0;
     } else {
         _u.lmsg.metadata = NULL;
         _u.lmsg.type = type_lmsg;
         _u.lmsg.flags = 0;
-        _u.lmsg.group[0] = '\0';
+        _u.lmsg.group.sgroup.group[0] = '\0';
+        _u.lmsg.group.type = group_type_short;
         _u.lmsg.routing_id = 0;
         _u.lmsg.content =
           static_cast<content_t *> (malloc (sizeof (content_t)));
@@ -187,7 +208,8 @@ int zmq::msg_t::init_delimiter ()
     _u.delimiter.metadata = NULL;
     _u.delimiter.type = type_delimiter;
     _u.delimiter.flags = 0;
-    _u.delimiter.group[0] = '\0';
+    _u.delimiter.group.sgroup.group[0] = '\0';
+    _u.delimiter.group.type = group_type_short;
     _u.delimiter.routing_id = 0;
     return 0;
 }
@@ -197,7 +219,8 @@ int zmq::msg_t::init_join ()
     _u.base.metadata = NULL;
     _u.base.type = type_join;
     _u.base.flags = 0;
-    _u.base.group[0] = '\0';
+    _u.base.group.sgroup.group[0] = '\0';
+    _u.base.group.type = group_type_short;
     _u.base.routing_id = 0;
     return 0;
 }
@@ -207,11 +230,42 @@ int zmq::msg_t::init_leave ()
     _u.base.metadata = NULL;
     _u.base.type = type_leave;
     _u.base.flags = 0;
-    _u.base.group[0] = '\0';
+    _u.base.group.sgroup.group[0] = '\0';
+    _u.base.group.type = group_type_short;
     _u.base.routing_id = 0;
     return 0;
 }
 
+int zmq::msg_t::init_subscribe (const size_t size_, const unsigned char *topic_)
+{
+    int rc = init_size (size_);
+    if (rc == 0) {
+        set_flags (zmq::msg_t::subscribe);
+
+        //  We explicitly allow a NULL subscription with size zero
+        if (size_) {
+            assert (topic_);
+            memcpy (data (), topic_, size_);
+        }
+    }
+    return rc;
+}
+
+int zmq::msg_t::init_cancel (const size_t size_, const unsigned char *topic_)
+{
+    int rc = init_size (size_);
+    if (rc == 0) {
+        set_flags (zmq::msg_t::cancel);
+
+        //  We explicitly allow a NULL subscription with size zero
+        if (size_) {
+            assert (topic_);
+            memcpy (data (), topic_, size_);
+        }
+    }
+    return rc;
+}
+
 int zmq::msg_t::close ()
 {
     //  Check the validity of the message.
@@ -259,6 +313,16 @@ int zmq::msg_t::close ()
         _u.base.metadata = NULL;
     }
 
+    if (_u.base.group.type == group_type_long) {
+        if (!_u.base.group.lgroup.content->refcnt.sub (1)) {
+            //  We used "placement new" operator to initialize the reference
+            //  counter so we call the destructor explicitly now.
+            _u.base.group.lgroup.content->refcnt.~atomic_counter_t ();
+
+            free (_u.base.group.lgroup.content);
+        }
+    }
+
     //  Make the message invalid.
     _u.base.type = 0;
 
@@ -294,7 +358,7 @@ int zmq::msg_t::copy (msg_t &src_)
         return -1;
     }
 
-    int rc = close ();
+    const int rc = close ();
     if (unlikely (rc < 0))
         return rc;
 
@@ -316,6 +380,9 @@ int zmq::msg_t::copy (msg_t &src_)
     if (src_._u.base.metadata != NULL)
         src_._u.base.metadata->add_ref ();
 
+    if (src_._u.base.group.type == group_type_long)
+        src_._u.base.group.lgroup.content->refcnt.add (1);
+
     *this = src_;
 
     return 0;
@@ -361,6 +428,30 @@ size_t zmq::msg_t::size () const
     }
 }
 
+void zmq::msg_t::shrink (size_t new_size_)
+{
+    //  Check the validity of the message.
+    zmq_assert (check ());
+    zmq_assert (new_size_ <= size ());
+
+    switch (_u.base.type) {
+        case type_vsm:
+            _u.vsm.size = static_cast<unsigned char> (new_size_);
+            break;
+        case type_lmsg:
+            _u.lmsg.content->size = new_size_;
+            break;
+        case type_zclmsg:
+            _u.zclmsg.content->size = new_size_;
+            break;
+        case type_cmsg:
+            _u.cmsg.size = new_size_;
+            break;
+        default:
+            zmq_assert (false);
+    }
+}
+
 unsigned char zmq::msg_t::flags () const
 {
     return _u.base.flags;
@@ -454,13 +545,21 @@ bool zmq::msg_t::is_pong () const
     return (_u.base.flags & CMD_TYPE_MASK) == pong;
 }
 
+bool zmq::msg_t::is_close_cmd () const
+{
+    return (_u.base.flags & CMD_TYPE_MASK) == close_cmd;
+}
+
 size_t zmq::msg_t::command_body_size () const
 {
     if (this->is_ping () || this->is_pong ())
         return this->size () - ping_cmd_name_size;
-    if (this->is_subscribe ())
+    else if (!(this->flags () & msg_t::command)
+             && (this->is_subscribe () || this->is_cancel ()))
+        return this->size ();
+    else if (this->is_subscribe ())
         return this->size () - sub_cmd_name_size;
-    if (this->is_cancel ())
+    else if (this->is_cancel ())
         return this->size () - cancel_cmd_name_size;
 
     return 0;
@@ -469,12 +568,17 @@ size_t zmq::msg_t::command_body_size ()
 void *zmq::msg_t::command_body ()
 {
     unsigned char *data = NULL;
+
     if (this->is_ping () || this->is_pong ())
         data =
           static_cast<unsigned char *> (this->data ()) + ping_cmd_name_size;
-    if (this->is_subscribe ())
+    //  With inproc, command flag is not set for sub/cancel
+    else if (!(this->flags () & msg_t::command)
+             && (this->is_subscribe () || this->is_cancel ()))
+        data = static_cast<unsigned char *> (this->data ());
+    else if (this->is_subscribe ())
         data = static_cast<unsigned char *> (this->data ()) + sub_cmd_name_size;
-    if (this->is_cancel ())
+    else if (this->is_cancel ())
         data =
           static_cast<unsigned char *> (this->data ()) + cancel_cmd_name_size;
 
@@ -548,7 +652,7 @@ bool zmq::msg_t::rm_refs (int refs_)
     return true;
 }
 
-uint32_t zmq::msg_t::get_routing_id ()
+uint32_t zmq::msg_t::get_routing_id () const
 {
     return _u.base.routing_id;
 }
@@ -569,14 +673,18 @@ int zmq::msg_t::reset_routing_id ()
     return 0;
 }
 
-const char *zmq::msg_t::group ()
+const char *zmq::msg_t::group () const
 {
-    return _u.base.group;
+    if (_u.base.group.type == group_type_long)
+        return _u.base.group.lgroup.content->group;
+    return _u.base.group.sgroup.group;
 }
 
 int zmq::msg_t::set_group (const char *group_)
 {
-    return set_group (group_, ZMQ_GROUP_MAX_LENGTH);
+    size_t length = strnlen (group_, ZMQ_GROUP_MAX_LENGTH);
+
+    return set_group (group_, length);
 }
 
 int zmq::msg_t::set_group (const char *group_, size_t length_)
@@ -586,8 +694,19 @@ int zmq::msg_t::set_group (const char *g
         return -1;
     }
 
-    strncpy (_u.base.group, group_, length_);
-    _u.base.group[length_] = '\0';
+    if (length_ > 14) {
+        _u.base.group.lgroup.type = group_type_long;
+        _u.base.group.lgroup.content =
+          (long_group_t *) malloc (sizeof (long_group_t));
+        assert (_u.base.group.lgroup.content);
+        new (&_u.base.group.lgroup.content->refcnt) zmq::atomic_counter_t ();
+        _u.base.group.lgroup.content->refcnt.set (1);
+        strncpy (_u.base.group.lgroup.content->group, group_, length_);
+        _u.base.group.lgroup.content->group[length_] = '\0';
+    } else {
+        strncpy (_u.base.group.sgroup.group, group_, length_);
+        _u.base.group.sgroup.group[length_] = '\0';
+    }
 
     return 0;
 }
diff -pruN 4.3.2-2/src/msg.hpp 4.3.3-1/src/msg.hpp
--- 4.3.2-2/src/msg.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/msg.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -54,6 +54,9 @@ namespace zmq
 //  Note that this structure needs to be explicitly constructed
 //  (init functions) and destructed (close function).
 
+static const char cancel_cmd_name[] = "\6CANCEL";
+static const char sub_cmd_name[] = "\x9SUBSCRIBE";
+
 class msg_t
 {
   public:
@@ -84,6 +87,7 @@ class msg_t
         pong = 8,
         subscribe = 12,
         cancel = 16,
+        close_cmd = 20,
         credential = 32,
         routing_id = 64,
         shared = 128
@@ -99,6 +103,7 @@ class msg_t
               content_t *content_ = NULL);
 
     int init_size (size_t size_);
+    int init_buffer (const void *buf_, size_t size_);
     int init_data (void *data_, size_t size_, msg_free_fn *ffn_, void *hint_);
     int init_external_storage (content_t *content_,
                                void *data_,
@@ -108,6 +113,8 @@ class msg_t
     int init_delimiter ();
     int init_join ();
     int init_leave ();
+    int init_subscribe (const size_t size_, const unsigned char *topic);
+    int init_cancel (const size_t size_, const unsigned char *topic);
     int close ();
     int move (msg_t &src_);
     int copy (msg_t &src_);
@@ -126,14 +133,16 @@ class msg_t
     bool is_leave () const;
     bool is_ping () const;
     bool is_pong () const;
+    bool is_close_cmd () const;
 
     //  These are called on each message received by the session_base class,
     //  so get them inlined to avoid the overhead of 2 function calls per msg
-    inline bool is_subscribe () const
+    bool is_subscribe () const
     {
         return (_u.base.flags & CMD_TYPE_MASK) == subscribe;
     }
-    inline bool is_cancel () const
+
+    bool is_cancel () const
     {
         return (_u.base.flags & CMD_TYPE_MASK) == cancel;
     }
@@ -144,10 +153,10 @@ class msg_t
     bool is_cmsg () const;
     bool is_lmsg () const;
     bool is_zcmsg () const;
-    uint32_t get_routing_id ();
+    uint32_t get_routing_id () const;
     int set_routing_id (uint32_t routing_id_);
     int reset_routing_id ();
-    const char *group ();
+    const char *group () const;
     int set_group (const char *group_);
     int set_group (const char *, size_t length_);
 
@@ -159,6 +168,8 @@ class msg_t
     //  references drops to 0, the message is closed and false is returned.
     bool rm_refs (int refs_);
 
+    void shrink (size_t new_size_);
+
     //  Size in bytes of the largest message that is still copied around
     //  rather than being reference-counted.
     enum
@@ -205,6 +216,33 @@ class msg_t
         type_max = 107
     };
 
+    enum group_type_t
+    {
+        group_type_short,
+        group_type_long
+    };
+
+    struct long_group_t
+    {
+        char group[ZMQ_GROUP_MAX_LENGTH + 1];
+        atomic_counter_t refcnt;
+    };
+
+    union group_t
+    {
+        unsigned char type;
+        struct
+        {
+            unsigned char type;
+            char group[15];
+        } sgroup;
+        struct
+        {
+            unsigned char type;
+            long_group_t *content;
+        } lgroup;
+    };
+
     //  Note that fields shared between different message types are not
     //  moved to the parent class (msg_t). This way we get tighter packing
     //  of the data. Shared fields can be accessed via 'base' member of
@@ -214,13 +252,13 @@ class msg_t
         struct
         {
             metadata_t *metadata;
-            unsigned char
-              unused[msg_t_size
-                     - (sizeof (metadata_t *) + 2 + 16 + sizeof (uint32_t))];
+            unsigned char unused[msg_t_size
+                                 - (sizeof (metadata_t *) + 2
+                                    + sizeof (uint32_t) + sizeof (group_t))];
             unsigned char type;
             unsigned char flags;
-            char group[16];
             uint32_t routing_id;
+            group_t group;
         } base;
         struct
         {
@@ -229,57 +267,59 @@ class msg_t
             unsigned char size;
             unsigned char type;
             unsigned char flags;
-            char group[16];
             uint32_t routing_id;
+            group_t group;
         } vsm;
         struct
         {
             metadata_t *metadata;
             content_t *content;
-            unsigned char unused[msg_t_size
-                                 - (sizeof (metadata_t *) + sizeof (content_t *)
-                                    + 2 + 16 + sizeof (uint32_t))];
+            unsigned char
+              unused[msg_t_size
+                     - (sizeof (metadata_t *) + sizeof (content_t *) + 2
+                        + sizeof (uint32_t) + sizeof (group_t))];
             unsigned char type;
             unsigned char flags;
-            char group[16];
             uint32_t routing_id;
+            group_t group;
         } lmsg;
         struct
         {
             metadata_t *metadata;
             content_t *content;
-            unsigned char unused[msg_t_size
-                                 - (sizeof (metadata_t *) + sizeof (content_t *)
-                                    + 2 + 16 + sizeof (uint32_t))];
+            unsigned char
+              unused[msg_t_size
+                     - (sizeof (metadata_t *) + sizeof (content_t *) + 2
+                        + sizeof (uint32_t) + sizeof (group_t))];
             unsigned char type;
             unsigned char flags;
-            char group[16];
             uint32_t routing_id;
+            group_t group;
         } zclmsg;
         struct
         {
             metadata_t *metadata;
             void *data;
             size_t size;
-            unsigned char
-              unused[msg_t_size
-                     - (sizeof (metadata_t *) + sizeof (void *)
-                        + sizeof (size_t) + 2 + 16 + sizeof (uint32_t))];
+            unsigned char unused[msg_t_size
+                                 - (sizeof (metadata_t *) + sizeof (void *)
+                                    + sizeof (size_t) + 2 + sizeof (uint32_t)
+                                    + sizeof (group_t))];
             unsigned char type;
             unsigned char flags;
-            char group[16];
             uint32_t routing_id;
+            group_t group;
         } cmsg;
         struct
         {
             metadata_t *metadata;
-            unsigned char
-              unused[msg_t_size
-                     - (sizeof (metadata_t *) + 2 + 16 + sizeof (uint32_t))];
+            unsigned char unused[msg_t_size
+                                 - (sizeof (metadata_t *) + 2
+                                    + sizeof (uint32_t) + sizeof (group_t))];
             unsigned char type;
             unsigned char flags;
-            char group[16];
             uint32_t routing_id;
+            group_t group;
         } delimiter;
     } _u;
 };
@@ -287,7 +327,7 @@ class msg_t
 inline int close_and_return (zmq::msg_t *msg_, int echo_)
 {
     // Since we abort on close failure we preserve errno for success case.
-    int err = errno;
+    const int err = errno;
     const int rc = msg_->close ();
     errno_assert (rc == 0);
     errno = err;
diff -pruN 4.3.2-2/src/mutex.hpp 4.3.3-1/src/mutex.hpp
--- 4.3.2-2/src/mutex.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/mutex.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -31,6 +31,7 @@
 #define __ZMQ_MUTEX_HPP_INCLUDED__
 
 #include "err.hpp"
+#include "macros.hpp"
 
 //  Mutex class encapsulates OS mutex in a platform-independent way.
 
@@ -43,27 +44,22 @@ namespace zmq
 class mutex_t
 {
   public:
-    inline mutex_t () { InitializeCriticalSection (&_cs); }
+    mutex_t () { InitializeCriticalSection (&_cs); }
 
-    inline ~mutex_t () { DeleteCriticalSection (&_cs); }
+    ~mutex_t () { DeleteCriticalSection (&_cs); }
 
-    inline void lock () { EnterCriticalSection (&_cs); }
+    void lock () { EnterCriticalSection (&_cs); }
 
-    inline bool try_lock ()
-    {
-        return (TryEnterCriticalSection (&_cs)) ? true : false;
-    }
+    bool try_lock () { return (TryEnterCriticalSection (&_cs)) ? true : false; }
 
-    inline void unlock () { LeaveCriticalSection (&_cs); }
+    void unlock () { LeaveCriticalSection (&_cs); }
 
-    inline CRITICAL_SECTION *get_cs () { return &_cs; }
+    CRITICAL_SECTION *get_cs () { return &_cs; }
 
   private:
     CRITICAL_SECTION _cs;
 
-    //  Disable copy construction and assignment.
-    mutex_t (const mutex_t &);
-    void operator= (const mutex_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (mutex_t)
 };
 }
 
@@ -100,9 +96,7 @@ class mutex_t
   private:
     SEM_ID _semId;
 
-    // Disable copy construction and assignment.
-    mutex_t (const mutex_t &);
-    const mutex_t &operator= (const mutex_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (mutex_t)
 };
 }
 
@@ -164,9 +158,7 @@ class mutex_t
     pthread_mutex_t _mutex;
     pthread_mutexattr_t _attr;
 
-    // Disable copy construction and assignment.
-    mutex_t (const mutex_t &);
-    const mutex_t &operator= (const mutex_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (mutex_t)
 };
 }
 
@@ -184,9 +176,7 @@ struct scoped_lock_t
   private:
     mutex_t &_mutex;
 
-    // Disable copy construction and assignment.
-    scoped_lock_t (const scoped_lock_t &);
-    const scoped_lock_t &operator= (const scoped_lock_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (scoped_lock_t)
 };
 
 
@@ -207,9 +197,7 @@ struct scoped_optional_lock_t
   private:
     mutex_t *_mutex;
 
-    // Disable copy construction and assignment.
-    scoped_optional_lock_t (const scoped_lock_t &);
-    const scoped_optional_lock_t &operator= (const scoped_lock_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (scoped_optional_lock_t)
 };
 }
 
diff -pruN 4.3.2-2/src/norm_engine.hpp 4.3.3-1/src/norm_engine.hpp
--- 4.3.2-2/src/norm_engine.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/norm_engine.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -18,36 +18,38 @@ class io_thread_t;
 class msg_t;
 class session_base_t;
 
-class norm_engine_t : public io_object_t, public i_engine
+class norm_engine_t ZMQ_FINAL : public io_object_t, public i_engine
 {
   public:
     norm_engine_t (zmq::io_thread_t *parent_, const options_t &options_);
-    ~norm_engine_t ();
+    ~norm_engine_t () ZMQ_FINAL;
 
     // create NORM instance, session, etc
     int init (const char *network_, bool send, bool recv);
     void shutdown ();
 
+    bool has_handshake_stage () ZMQ_FINAL { return false; };
+
     //  i_engine interface implementation.
     //  Plug the engine to the session.
-    virtual void plug (zmq::io_thread_t *io_thread_,
-                       class session_base_t *session_);
+    void plug (zmq::io_thread_t *io_thread_,
+               class session_base_t *session_) ZMQ_FINAL;
 
     //  Terminate and deallocate the engine. Note that 'detached'
     //  events are not fired on termination.
-    virtual void terminate ();
+    void terminate () ZMQ_FINAL;
 
     //  This method is called by the session to signalise that more
     //  messages can be written to the pipe.
-    virtual bool restart_input ();
+    bool restart_input () ZMQ_FINAL;
 
     //  This method is called by the session to signalise that there
     //  are messages to send available.
-    virtual void restart_output ();
+    void restart_output () ZMQ_FINAL;
 
-    virtual void zap_msg_available (){};
+    void zap_msg_available () ZMQ_FINAL {}
 
-    virtual const endpoint_uri_pair_t &get_endpoint () const;
+    const endpoint_uri_pair_t &get_endpoint () const ZMQ_FINAL;
 
     // i_poll_events interface implementation.
     // (we only need in_event() for NormEvent notification)
diff -pruN 4.3.2-2/src/null_mechanism.hpp 4.3.3-1/src/null_mechanism.hpp
--- 4.3.2-2/src/null_mechanism.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/null_mechanism.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,19 +39,19 @@ namespace zmq
 class msg_t;
 class session_base_t;
 
-class null_mechanism_t : public zap_client_t
+class null_mechanism_t ZMQ_FINAL : public zap_client_t
 {
   public:
     null_mechanism_t (session_base_t *session_,
                       const std::string &peer_address_,
                       const options_t &options_);
-    virtual ~null_mechanism_t ();
+    ~null_mechanism_t ();
 
     // mechanism implementation
-    virtual int next_handshake_command (msg_t *msg_);
-    virtual int process_handshake_command (msg_t *msg_);
-    virtual int zap_msg_available ();
-    virtual status_t status () const;
+    int next_handshake_command (msg_t *msg_);
+    int process_handshake_command (msg_t *msg_);
+    int zap_msg_available ();
+    status_t status () const;
 
   private:
     bool _ready_command_sent;
diff -pruN 4.3.2-2/src/object.cpp 4.3.3-1/src/object.cpp
--- 4.3.2-2/src/object.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/object.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -53,7 +53,7 @@ zmq::object_t::~object_t ()
 {
 }
 
-uint32_t zmq::object_t::get_tid ()
+uint32_t zmq::object_t::get_tid () const
 {
     return _tid;
 }
@@ -63,12 +63,12 @@ void zmq::object_t::set_tid (uint32_t id
     _tid = id_;
 }
 
-zmq::ctx_t *zmq::object_t::get_ctx ()
+zmq::ctx_t *zmq::object_t::get_ctx () const
 {
     return _ctx;
 }
 
-void zmq::object_t::process_command (command_t &cmd_)
+void zmq::object_t::process_command (const command_t &cmd_)
 {
     switch (cmd_.type) {
         case command_t::activate_read:
@@ -161,6 +161,10 @@ void zmq::object_t::process_command (com
             process_seqnum ();
             break;
 
+        case command_t::conn_failed:
+            process_conn_failed ();
+            break;
+
         case command_t::done:
         default:
             zmq_assert (false);
@@ -184,7 +188,7 @@ void zmq::object_t::unregister_endpoints
     return _ctx->unregister_endpoints (socket_);
 }
 
-zmq::endpoint_t zmq::object_t::find_endpoint (const char *addr_)
+zmq::endpoint_t zmq::object_t::find_endpoint (const char *addr_) const
 {
     return _ctx->find_endpoint (addr_);
 }
@@ -207,7 +211,7 @@ void zmq::object_t::destroy_socket (sock
     _ctx->destroy_socket (socket_);
 }
 
-zmq::io_thread_t *zmq::object_t::choose_io_thread (uint64_t affinity_)
+zmq::io_thread_t *zmq::object_t::choose_io_thread (uint64_t affinity_) const
 {
     return _ctx->choose_io_thread (affinity_);
 }
@@ -257,6 +261,14 @@ void zmq::object_t::send_attach (session
     send_command (cmd);
 }
 
+void zmq::object_t::send_conn_failed (session_base_t *destination_)
+{
+    command_t cmd;
+    cmd.destination = destination_;
+    cmd.type = command_t::conn_failed;
+    send_command (cmd);
+}
+
 void zmq::object_t::send_bind (own_t *destination_,
                                pipe_t *pipe_,
                                bool inc_seqnum_)
@@ -528,7 +540,12 @@ void zmq::object_t::process_seqnum ()
     zmq_assert (false);
 }
 
-void zmq::object_t::send_command (command_t &cmd_)
+void zmq::object_t::process_conn_failed ()
+{
+    zmq_assert (false);
+}
+
+void zmq::object_t::send_command (const command_t &cmd_)
 {
     _ctx->send_command (cmd_.destination->get_tid (), cmd_);
 }
diff -pruN 4.3.2-2/src/object.hpp 4.3.3-1/src/object.hpp
--- 4.3.2-2/src/object.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/object.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -31,8 +31,10 @@
 #define __ZMQ_OBJECT_HPP_INCLUDED__
 
 #include <string>
-#include "stdint.hpp"
+
 #include "endpoint.hpp"
+#include "macros.hpp"
+#include "stdint.hpp"
 
 namespace zmq
 {
@@ -57,10 +59,10 @@ class object_t
     object_t (object_t *parent_);
     virtual ~object_t ();
 
-    uint32_t get_tid ();
+    uint32_t get_tid () const;
     void set_tid (uint32_t id_);
-    ctx_t *get_ctx ();
-    void process_command (zmq::command_t &cmd_);
+    ctx_t *get_ctx () const;
+    void process_command (const zmq::command_t &cmd_);
     void send_inproc_connected (zmq::socket_base_t *socket_);
     void send_bind (zmq::own_t *destination_,
                     zmq::pipe_t *pipe_,
@@ -72,7 +74,7 @@ class object_t
     int register_endpoint (const char *addr_, const zmq::endpoint_t &endpoint_);
     int unregister_endpoint (const std::string &addr_, socket_base_t *socket_);
     void unregister_endpoints (zmq::socket_base_t *socket_);
-    zmq::endpoint_t find_endpoint (const char *addr_);
+    zmq::endpoint_t find_endpoint (const char *addr_) const;
     void pend_connection (const std::string &addr_,
                           const endpoint_t &endpoint_,
                           pipe_t **pipes_);
@@ -84,7 +86,7 @@ class object_t
     void log (const char *format_, ...);
 
     //  Chooses least loaded I/O thread.
-    zmq::io_thread_t *choose_io_thread (uint64_t affinity_);
+    zmq::io_thread_t *choose_io_thread (uint64_t affinity_) const;
 
     //  Derived object can use these functions to send commands
     //  to other objects.
@@ -115,6 +117,8 @@ class object_t
     void send_reap (zmq::socket_base_t *socket_);
     void send_reaped ();
     void send_done ();
+    void send_conn_failed (zmq::session_base_t *destination_);
+
 
     //  These handlers can be overridden by the derived objects. They are
     //  called when command arrives from another thread.
@@ -142,6 +146,8 @@ class object_t
     virtual void process_term_endpoint (std::string *endpoint_);
     virtual void process_reap (zmq::socket_base_t *socket_);
     virtual void process_reaped ();
+    virtual void process_conn_failed ();
+
 
     //  Special handler called after a command that requires a seqnum
     //  was processed. The implementation should catch up with its counter
@@ -155,10 +161,9 @@ class object_t
     //  Thread ID of the thread the object belongs to.
     uint32_t _tid;
 
-    void send_command (command_t &cmd_);
+    void send_command (const command_t &cmd_);
 
-    object_t (const object_t &);
-    const object_t &operator= (const object_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (object_t)
 };
 }
 
diff -pruN 4.3.2-2/src/options.cpp 4.3.3-1/src/options.cpp
--- 4.3.2-2/src/options.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/options.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -85,7 +85,7 @@ int zmq::do_getsockopt (void *const optv
 
 #ifdef ZMQ_HAVE_CURVE
 static int do_getsockopt_curve_key (void *const optval_,
-                                    size_t *const optvallen_,
+                                    const size_t *const optvallen_,
                                     const uint8_t (&curve_key_)[CURVE_KEYSIZE])
 {
     if (*optvallen_ == CURVE_KEYSIZE) {
@@ -102,9 +102,9 @@ static int do_getsockopt_curve_key (void
 #endif
 
 template <typename T>
-int do_setsockopt (const void *const optval_,
-                   const size_t optvallen_,
-                   T *const out_value_)
+static int do_setsockopt (const void *const optval_,
+                          const size_t optvallen_,
+                          T *const out_value_)
 {
     if (optvallen_ == sizeof (T)) {
         memcpy (out_value_, optval_, sizeof (T));
@@ -176,9 +176,9 @@ do_setsockopt_string_allow_empty_relaxed
 }
 
 template <typename T>
-int do_setsockopt_set (const void *const optval_,
-                       const size_t optvallen_,
-                       std::set<T> *const set_)
+static int do_setsockopt_set (const void *const optval_,
+                              const size_t optvallen_,
+                              std::set<T> *const set_)
 {
     if (optvallen_ == 0 && optval_ == NULL) {
         set_->clear ();
@@ -210,6 +210,7 @@ zmq::options_t::options_t () :
     linger (-1),
     connect_timeout (0),
     tcp_maxrt (0),
+    reconnect_stop (0),
     reconnect_ivl (100),
     reconnect_ivl_max (0),
     backlog (100),
@@ -247,7 +248,12 @@ zmq::options_t::options_t () :
     out_batch_size (8192),
     zero_copy (true),
     router_notify (0),
-    monitor_event_version (1)
+    monitor_event_version (1),
+    wss_trust_system (false),
+    hello_msg (),
+    can_send_hello_msg (false),
+    disconnect_msg (),
+    can_recv_disconnect_msg (false)
 {
     memset (curve_public_key, 0, CURVE_KEYSIZE);
     memset (curve_secret_key, 0, CURVE_KEYSIZE);
@@ -270,13 +276,16 @@ int zmq::options_t::set_curve_key (uint8
             mechanism = ZMQ_CURVE;
             return 0;
 
-        case CURVE_KEYSIZE_Z85 + 1:
-            if (zmq_z85_decode (destination_,
-                                reinterpret_cast<const char *> (optval_))) {
+        case CURVE_KEYSIZE_Z85 + 1: {
+            const std::string s (static_cast<const char *> (optval_),
+                                 optvallen_);
+
+            if (zmq_z85_decode (destination_, s.c_str ())) {
                 mechanism = ZMQ_CURVE;
                 return 0;
             }
             break;
+        }
 
         case CURVE_KEYSIZE_Z85:
             char z85_key[CURVE_KEYSIZE_Z85 + 1];
@@ -301,7 +310,7 @@ int zmq::options_t::setsockopt (int opti
                                 const void *optval_,
                                 size_t optvallen_)
 {
-    bool is_int = (optvallen_ == sizeof (int));
+    const bool is_int = (optvallen_ == sizeof (int));
     int value = 0;
     if (is_int)
         memcpy (&value, optval_, sizeof (int));
@@ -392,6 +401,13 @@ int zmq::options_t::setsockopt (int opti
             }
             break;
 
+        case ZMQ_RECONNECT_STOP:
+            if (is_int) {
+                reconnect_stop = value;
+                return 0;
+            }
+            break;
+
         case ZMQ_RECONNECT_IVL:
             if (is_int && value >= -1) {
                 reconnect_ivl = value;
@@ -447,7 +463,7 @@ int zmq::options_t::setsockopt (int opti
         /*  Deprecated in favor of ZMQ_IPV6  */
         case ZMQ_IPV4ONLY: {
             bool value;
-            int rc =
+            const int rc =
               do_setsockopt_int_as_bool_strict (optval_, optvallen_, &value);
             if (rc == 0)
                 ipv6 = !value;
@@ -591,7 +607,6 @@ int zmq::options_t::setsockopt (int opti
         case ZMQ_ZAP_DOMAIN:
             return do_setsockopt_string_allow_empty_relaxed (
               optval_, optvallen_, &zap_domain, UCHAR_MAX);
-            break;
 
             //  If curve encryption isn't built, these options provoke EINVAL
 #ifdef ZMQ_HAVE_CURVE
@@ -749,7 +764,8 @@ int zmq::options_t::setsockopt (int opti
 
         case ZMQ_METADATA:
             if (optvallen_ > 0 && !is_int) {
-                const std::string s (static_cast<const char *> (optval_));
+                const std::string s (static_cast<const char *> (optval_),
+                                     optvallen_);
                 const size_t pos = s.find (':');
                 if (pos != std::string::npos && pos != 0
                     && pos != s.length () - 1) {
@@ -784,6 +800,50 @@ int zmq::options_t::setsockopt (int opti
                 return 0;
             }
             break;
+
+#ifdef ZMQ_HAVE_WSS
+        case ZMQ_WSS_KEY_PEM:
+            // TODO: check if valid certificate
+            wss_key_pem = std::string ((char *) optval_, optvallen_);
+            return 0;
+        case ZMQ_WSS_CERT_PEM:
+            // TODO: check if valid certificate
+            wss_cert_pem = std::string ((char *) optval_, optvallen_);
+            return 0;
+        case ZMQ_WSS_TRUST_PEM:
+            // TODO: check if valid certificate
+            wss_trust_pem = std::string ((char *) optval_, optvallen_);
+            return 0;
+        case ZMQ_WSS_HOSTNAME:
+            wss_hostname = std::string ((char *) optval_, optvallen_);
+            return 0;
+        case ZMQ_WSS_TRUST_SYSTEM:
+            return do_setsockopt_int_as_bool_strict (optval_, optvallen_,
+                                                     &wss_trust_system);
+#endif
+
+        case ZMQ_HELLO_MSG:
+            if (optvallen_ > 0) {
+                unsigned char *bytes = (unsigned char *) optval_;
+                hello_msg =
+                  std::vector<unsigned char> (bytes, bytes + optvallen_);
+            } else {
+                hello_msg = std::vector<unsigned char> ();
+            }
+
+            return 0;
+
+        case ZMQ_DISCONNECT_MSG:
+            if (optvallen_ > 0) {
+                unsigned char *bytes = (unsigned char *) optval_;
+                disconnect_msg =
+                  std::vector<unsigned char> (bytes, bytes + optvallen_);
+            } else {
+                disconnect_msg = std::vector<unsigned char> ();
+            }
+
+            return 0;
+
 #endif
 
         default:
@@ -848,7 +908,6 @@ int zmq::options_t::getsockopt (int opti
         case ZMQ_ROUTING_ID:
             return do_getsockopt (optval_, optvallen_, routing_id,
                                   routing_id_size);
-            break;
 
         case ZMQ_RATE:
             if (is_int) {
@@ -913,6 +972,13 @@ int zmq::options_t::getsockopt (int opti
             }
             break;
 
+        case ZMQ_RECONNECT_STOP:
+            if (is_int) {
+                *value = reconnect_stop;
+                return 0;
+            }
+            break;
+
         case ZMQ_RECONNECT_IVL:
             if (is_int) {
                 *value = reconnect_ivl;
@@ -993,15 +1059,12 @@ int zmq::options_t::getsockopt (int opti
 
         case ZMQ_SOCKS_PROXY:
             return do_getsockopt (optval_, optvallen_, socks_proxy_address);
-            break;
 
         case ZMQ_SOCKS_USERNAME:
             return do_getsockopt (optval_, optvallen_, socks_proxy_username);
-            break;
 
         case ZMQ_SOCKS_PASSWORD:
             return do_getsockopt (optval_, optvallen_, socks_proxy_password);
-            break;
 
         case ZMQ_TCP_KEEPALIVE:
             if (is_int) {
@@ -1047,15 +1110,12 @@ int zmq::options_t::getsockopt (int opti
 
         case ZMQ_PLAIN_USERNAME:
             return do_getsockopt (optval_, optvallen_, plain_username);
-            break;
 
         case ZMQ_PLAIN_PASSWORD:
             return do_getsockopt (optval_, optvallen_, plain_password);
-            break;
 
         case ZMQ_ZAP_DOMAIN:
             return do_getsockopt (optval_, optvallen_, zap_domain);
-            break;
 
             //  If curve encryption isn't built, these options provoke EINVAL
 #ifdef ZMQ_HAVE_CURVE
@@ -1069,17 +1129,14 @@ int zmq::options_t::getsockopt (int opti
         case ZMQ_CURVE_PUBLICKEY:
             return do_getsockopt_curve_key (optval_, optvallen_,
                                             curve_public_key);
-            break;
 
         case ZMQ_CURVE_SECRETKEY:
             return do_getsockopt_curve_key (optval_, optvallen_,
                                             curve_secret_key);
-            break;
 
         case ZMQ_CURVE_SERVERKEY:
             return do_getsockopt_curve_key (optval_, optvallen_,
                                             curve_server_key);
-            break;
 #endif
 
         case ZMQ_CONFLATE:
@@ -1100,11 +1157,9 @@ int zmq::options_t::getsockopt (int opti
 
         case ZMQ_GSSAPI_PRINCIPAL:
             return do_getsockopt (optval_, optvallen_, gss_principal);
-            break;
 
         case ZMQ_GSSAPI_SERVICE_PRINCIPAL:
             return do_getsockopt (optval_, optvallen_, gss_service_principal);
-            break;
 
         case ZMQ_GSSAPI_PLAINTEXT:
             if (is_int) {
@@ -1172,7 +1227,6 @@ int zmq::options_t::getsockopt (int opti
 
         case ZMQ_BINDTODEVICE:
             return do_getsockopt (optval_, optvallen_, bound_device);
-            break;
 
         case ZMQ_ZAP_ENFORCE_DOMAIN:
             if (is_int) {
@@ -1202,6 +1256,7 @@ int zmq::options_t::getsockopt (int opti
                 return 0;
             }
             break;
+
         case ZMQ_IN_BATCH_SIZE:
             if (is_int) {
                 *value = in_batch_size;
diff -pruN 4.3.2-2/src/options.hpp 4.3.3-1/src/options.hpp
--- 4.3.2-2/src/options.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/options.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -47,7 +47,7 @@
 #include <sys/ucred.h>
 #endif
 
-#if __cplusplus >= 201103L
+#if __cplusplus >= 201103L || (defined _MSC_VER && _MSC_VER >= 1700)
 #include <type_traits>
 #endif
 
@@ -116,6 +116,10 @@ struct options_t
     //  Default 0 (unused)
     int tcp_maxrt;
 
+    //  Disable reconnect under certain conditions
+    //  Default 0
+    int reconnect_stop;
+
     //  Minimum interval between attempts to reconnect, in milliseconds.
     //  Default 100ms
     int reconnect_ivl;
@@ -286,6 +290,21 @@ struct options_t
 
     // Version of monitor events to emit
     int monitor_event_version;
+
+    //  WSS Keys
+    std::string wss_key_pem;
+    std::string wss_cert_pem;
+    std::string wss_trust_pem;
+    std::string wss_hostname;
+    bool wss_trust_system;
+
+    //  Hello msg
+    std::vector<unsigned char> hello_msg;
+    bool can_send_hello_msg;
+
+    //  Disconnect msg
+    std::vector<unsigned char> disconnect_msg;
+    bool can_recv_disconnect_msg;
 };
 
 inline bool get_effective_conflate_option (const options_t &options)
@@ -297,10 +316,10 @@ inline bool get_effective_conflate_optio
                || options.type == ZMQ_SUB);
 }
 
-int do_getsockopt (void *const optval_,
-                   size_t *const optvallen_,
+int do_getsockopt (void *optval_,
+                   size_t *optvallen_,
                    const void *value_,
-                   const size_t value_len_);
+                   size_t value_len_);
 
 template <typename T>
 int do_getsockopt (void *const optval_, size_t *const optvallen_, T value_)
@@ -312,17 +331,17 @@ int do_getsockopt (void *const optval_,
     return do_getsockopt (optval_, optvallen_, &value_, sizeof (T));
 }
 
-int do_getsockopt (void *const optval_,
-                   size_t *const optvallen_,
+int do_getsockopt (void *optval_,
+                   size_t *optvallen_,
                    const std::string &value_);
 
-int do_setsockopt_int_as_bool_strict (const void *const optval_,
-                                      const size_t optvallen_,
-                                      bool *const out_value_);
-
-int do_setsockopt_int_as_bool_relaxed (const void *const optval_,
-                                       const size_t optvallen_,
-                                       bool *const out_value_);
+int do_setsockopt_int_as_bool_strict (const void *optval_,
+                                      size_t optvallen_,
+                                      bool *out_value_);
+
+int do_setsockopt_int_as_bool_relaxed (const void *optval_,
+                                       size_t optvallen_,
+                                       bool *out_value_);
 }
 
 #endif
diff -pruN 4.3.2-2/src/own.cpp 4.3.3-1/src/own.cpp
--- 4.3.2-2/src/own.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/own.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -147,7 +147,7 @@ void zmq::own_t::terminate ()
     send_term_req (_owner, this);
 }
 
-bool zmq::own_t::is_terminating ()
+bool zmq::own_t::is_terminating () const
 {
     return _terminating;
 }
diff -pruN 4.3.2-2/src/own.hpp 4.3.3-1/src/own.hpp
--- 4.3.2-2/src/own.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/own.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -84,18 +84,18 @@ class own_t : public object_t
     void terminate ();
 
     //  Returns true if the object is in process of termination.
-    bool is_terminating ();
+    bool is_terminating () const;
 
     //  Derived object destroys own_t. There's no point in allowing
     //  others to invoke the destructor. At the same time, it has to be
     //  virtual so that generic own_t deallocation mechanism destroys
     //  specific type of the owned object correctly.
-    virtual ~own_t ();
+    ~own_t () ZMQ_OVERRIDE;
 
     //  Term handler is protected rather than private so that it can
     //  be intercepted by the derived class. This is useful to add custom
     //  steps to the beginning of the termination process.
-    void process_term (int linger_);
+    void process_term (int linger_) ZMQ_OVERRIDE;
 
     //  A place to hook in when physical destruction of the object
     //  is to be delayed.
@@ -109,10 +109,10 @@ class own_t : public object_t
     void set_owner (own_t *owner_);
 
     //  Handlers for incoming commands.
-    void process_own (own_t *object_);
-    void process_term_req (own_t *object_);
-    void process_term_ack ();
-    void process_seqnum ();
+    void process_own (own_t *object_) ZMQ_OVERRIDE;
+    void process_term_req (own_t *object_) ZMQ_OVERRIDE;
+    void process_term_ack () ZMQ_OVERRIDE;
+    void process_seqnum () ZMQ_OVERRIDE;
 
     //  Check whether all the pending term acks were delivered.
     //  If so, deallocate this object.
@@ -140,8 +140,7 @@ class own_t : public object_t
     //  Number of events we have to get before we can destroy the object.
     int _term_acks;
 
-    own_t (const own_t &);
-    const own_t &operator= (const own_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (own_t)
 };
 }
 
diff -pruN 4.3.2-2/src/pair.cpp 4.3.3-1/src/pair.cpp
--- 4.3.2-2/src/pair.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/pair.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -97,7 +97,7 @@ int zmq::pair_t::xsend (msg_t *msg_)
         _pipe->flush ();
 
     //  Detach the original message from the data buffer.
-    int rc = msg_->init ();
+    const int rc = msg_->init ();
     errno_assert (rc == 0);
 
     return 0;
diff -pruN 4.3.2-2/src/pair.hpp 4.3.3-1/src/pair.hpp
--- 4.3.2-2/src/pair.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/pair.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,7 @@ class msg_t;
 class pipe_t;
 class io_thread_t;
 
-class pair_t : public socket_base_t
+class pair_t ZMQ_FINAL : public socket_base_t
 {
   public:
     pair_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -64,8 +64,7 @@ class pair_t : public socket_base_t
 
     zmq::pipe_t *_last_in;
 
-    pair_t (const pair_t &);
-    const pair_t &operator= (const pair_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (pair_t)
 };
 }
 
diff -pruN 4.3.2-2/src/peer.cpp 4.3.3-1/src/peer.cpp
--- 4.3.2-2/src/peer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/peer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,70 @@
+/*
+    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include "macros.hpp"
+#include "peer.hpp"
+#include "pipe.hpp"
+#include "wire.hpp"
+#include "random.hpp"
+#include "likely.hpp"
+#include "err.hpp"
+
+zmq::peer_t::peer_t (class ctx_t *parent_, uint32_t tid_, int sid_) :
+    server_t (parent_, tid_, sid_)
+{
+    options.type = ZMQ_PEER;
+    options.can_send_hello_msg = true;
+    options.can_recv_disconnect_msg = true;
+}
+
+uint32_t zmq::peer_t::connect_peer (const char *endpoint_uri_)
+{
+    scoped_optional_lock_t sync_lock (&_sync);
+
+    // connect_peer cannot work with immediate enabled
+    if (options.immediate == 1) {
+        errno = EFAULT;
+        return 0;
+    }
+
+    int rc = socket_base_t::connect_internal (endpoint_uri_);
+    if (rc != 0)
+        return 0;
+
+    return _peer_last_routing_id;
+}
+
+void zmq::peer_t::xattach_pipe (pipe_t *pipe_,
+                                bool subscribe_to_all_,
+                                bool locally_initiated_)
+{
+    server_t::xattach_pipe (pipe_, subscribe_to_all_, locally_initiated_);
+    _peer_last_routing_id = pipe_->get_server_socket_routing_id ();
+}
diff -pruN 4.3.2-2/src/peer.hpp 4.3.3-1/src/peer.hpp
--- 4.3.2-2/src/peer.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/peer.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,67 @@
+/*
+    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_PEER_HPP_INCLUDED__
+#define __ZMQ_PEER_HPP_INCLUDED__
+
+#include <map>
+
+#include "socket_base.hpp"
+#include "server.hpp"
+#include "session_base.hpp"
+#include "stdint.hpp"
+#include "blob.hpp"
+#include "fq.hpp"
+
+namespace zmq
+{
+class ctx_t;
+class msg_t;
+class pipe_t;
+
+class peer_t ZMQ_FINAL : public server_t
+{
+  public:
+    peer_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
+
+    //  Overrides of functions from socket_base_t.
+    void xattach_pipe (zmq::pipe_t *pipe_,
+                       bool subscribe_to_all_,
+                       bool locally_initiated_);
+
+    uint32_t connect_peer (const char *endpoint_uri_);
+
+  private:
+    uint32_t _peer_last_routing_id;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (peer_t)
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/pgm_receiver.hpp 4.3.3-1/src/pgm_receiver.hpp
--- 4.3.2-2/src/pgm_receiver.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/pgm_receiver.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -46,7 +46,7 @@ namespace zmq
 class io_thread_t;
 class session_base_t;
 
-class pgm_receiver_t : public io_object_t, public i_engine
+class pgm_receiver_t ZMQ_FINAL : public io_object_t, public i_engine
 {
   public:
     pgm_receiver_t (zmq::io_thread_t *parent_, const options_t &options_);
@@ -55,6 +55,7 @@ class pgm_receiver_t : public io_object_
     int init (bool udp_encapsulation_, const char *network_);
 
     //  i_engine interface implementation.
+    bool has_handshake_stage () { return false; };
     void plug (zmq::io_thread_t *io_thread_, zmq::session_base_t *session_);
     void terminate ();
     bool restart_input ();
@@ -135,8 +136,7 @@ class pgm_receiver_t : public io_object_
     //  Poll handle associated with engine PGM waiting pipe.
     handle_t pipe_handle;
 
-    pgm_receiver_t (const pgm_receiver_t &);
-    const pgm_receiver_t &operator= (const pgm_receiver_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (pgm_receiver_t)
 };
 }
 
diff -pruN 4.3.2-2/src/pgm_sender.hpp 4.3.3-1/src/pgm_sender.hpp
--- 4.3.2-2/src/pgm_sender.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/pgm_sender.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -45,7 +45,7 @@ namespace zmq
 class io_thread_t;
 class session_base_t;
 
-class pgm_sender_t : public io_object_t, public i_engine
+class pgm_sender_t ZMQ_FINAL : public io_object_t, public i_engine
 {
   public:
     pgm_sender_t (zmq::io_thread_t *parent_, const options_t &options_);
@@ -54,6 +54,7 @@ class pgm_sender_t : public io_object_t,
     int init (bool udp_encapsulation_, const char *network_);
 
     //  i_engine interface implementation.
+    bool has_handshake_stage () { return false; };
     void plug (zmq::io_thread_t *io_thread_, zmq::session_base_t *session_);
     void terminate ();
     bool restart_input ();
@@ -115,8 +116,7 @@ class pgm_sender_t : public io_object_t,
     //  If zero, there are no data to be sent.
     size_t write_size;
 
-    pgm_sender_t (const pgm_sender_t &);
-    const pgm_sender_t &operator= (const pgm_sender_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (pgm_sender_t)
 };
 }
 #endif
diff -pruN 4.3.2-2/src/pipe.cpp 4.3.3-1/src/pipe.cpp
--- 4.3.2-2/src/pipe.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/pipe.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -38,10 +38,10 @@
 #include "ypipe.hpp"
 #include "ypipe_conflate.hpp"
 
-int zmq::pipepair (class object_t *parents_[2],
-                   class pipe_t *pipes_[2],
-                   int hwms_[2],
-                   bool conflate_[2])
+int zmq::pipepair (object_t *parents_[2],
+                   pipe_t *pipes_[2],
+                   const int hwms_[2],
+                   const bool conflate_[2])
 {
     //   Creates two pipe objects. These objects are connected by two ypipes,
     //   each to pass messages in one direction.
@@ -88,6 +88,17 @@ void zmq::send_routing_id (pipe_t *pipe_
     pipe_->flush ();
 }
 
+void zmq::send_hello_msg (pipe_t *pipe_, const options_t &options_)
+{
+    zmq::msg_t hello;
+    const int rc =
+      hello.init_buffer (&options_.hello_msg[0], options_.hello_msg.size ());
+    errno_assert (rc == 0);
+    const bool written = pipe_->write (&hello);
+    zmq_assert (written);
+    pipe_->flush ();
+}
+
 zmq::pipe_t::pipe_t (object_t *parent_,
                      upipe_t *inpipe_,
                      upipe_t *outpipe_,
@@ -113,10 +124,12 @@ zmq::pipe_t::pipe_t (object_t *parent_,
     _server_socket_routing_id (0),
     _conflate (conflate_)
 {
+    _disconnect_msg.init ();
 }
 
 zmq::pipe_t::~pipe_t ()
 {
+    _disconnect_msg.close ();
 }
 
 void zmq::pipe_t::set_peer (pipe_t *peer_)
@@ -188,7 +201,7 @@ bool zmq::pipe_t::read (msg_t *msg_)
     if (unlikely (_state != active && _state != waiting_for_delimiter))
         return false;
 
-    for (bool payload_read = false; !payload_read;) {
+    while (true) {
         if (!_in_pipe->read (msg_)) {
             _in_active = false;
             return false;
@@ -198,8 +211,9 @@ bool zmq::pipe_t::read (msg_t *msg_)
         if (unlikely (msg_->is_credential ())) {
             const int rc = msg_->close ();
             zmq_assert (rc == 0);
-        } else
-            payload_read = true;
+        } else {
+            break;
+        }
     }
 
     //  If delimiter was read, start termination process of the pipe.
@@ -232,7 +246,7 @@ bool zmq::pipe_t::check_write ()
     return true;
 }
 
-bool zmq::pipe_t::write (msg_t *msg_)
+bool zmq::pipe_t::write (const msg_t *msg_)
 {
     if (unlikely (!check_write ()))
         return false;
@@ -492,6 +506,7 @@ void zmq::pipe_t::process_delimiter ()
     if (_state == active)
         _state = delimiter_received;
     else {
+        rollback ();
         _out_pipe = NULL;
         send_pipe_term_ack (_peer);
         _state = term_ack_sent;
@@ -579,3 +594,24 @@ void zmq::pipe_t::process_pipe_peer_stat
     send_pipe_stats_publish (socket_base_, queue_count_,
                              _msgs_written - _peers_msgs_read, endpoint_pair_);
 }
+
+void zmq::pipe_t::send_disconnect_msg ()
+{
+    if (_disconnect_msg.size () > 0) {
+        // Rollback any incomplete message in the pipe, and push the disconnect message.
+        rollback ();
+
+        _out_pipe->write (_disconnect_msg, false);
+        flush ();
+        _disconnect_msg.init ();
+    }
+}
+
+void zmq::pipe_t::set_disconnect_msg (
+  const std::vector<unsigned char> &disconnect_)
+{
+    _disconnect_msg.close ();
+    const int rc =
+      _disconnect_msg.init_buffer (&disconnect_[0], disconnect_.size ());
+    errno_assert (rc == 0);
+}
diff -pruN 4.3.2-2/src/pipe.hpp 4.3.3-1/src/pipe.hpp
--- 4.3.2-2/src/pipe.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/pipe.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -38,10 +38,10 @@
 #include "blob.hpp"
 #include "options.hpp"
 #include "endpoint.hpp"
+#include "msg.hpp"
 
 namespace zmq
 {
-class msg_t;
 class pipe_t;
 
 //  Create a pipepair for bi-directional transfer of messages.
@@ -54,12 +54,12 @@ class pipe_t;
 //  read (older messages are discarded)
 int pipepair (zmq::object_t *parents_[2],
               zmq::pipe_t *pipes_[2],
-              int hwms_[2],
-              bool conflate_[2]);
+              const int hwms_[2],
+              const bool conflate_[2]);
 
 struct i_pipe_events
 {
-    virtual ~i_pipe_events () {}
+    virtual ~i_pipe_events () ZMQ_DEFAULT;
 
     virtual void read_activated (zmq::pipe_t *pipe_) = 0;
     virtual void write_activated (zmq::pipe_t *pipe_) = 0;
@@ -71,16 +71,16 @@ struct i_pipe_events
 //  The array of inbound pipes (1), the array of outbound pipes (2) and
 //  the generic array of pipes to be deallocated (3).
 
-class pipe_t : public object_t,
-               public array_item_t<1>,
-               public array_item_t<2>,
-               public array_item_t<3>
+class pipe_t ZMQ_FINAL : public object_t,
+                         public array_item_t<1>,
+                         public array_item_t<2>,
+                         public array_item_t<3>
 {
     //  This allows pipepair to create pipe objects.
     friend int pipepair (zmq::object_t *parents_[2],
                          zmq::pipe_t *pipes_[2],
-                         int hwms_[2],
-                         bool conflate_[2]);
+                         const int hwms_[2],
+                         const bool conflate_[2]);
 
   public:
     //  Specifies the object to send events to.
@@ -108,7 +108,7 @@ class pipe_t : public object_t,
     //  Writes a message to the underlying pipe. Returns false if the
     //  message does not pass check_write. If false, the message object
     //  retains ownership of its message buffer.
-    bool write (msg_t *msg_);
+    bool write (const msg_t *msg_);
 
     //  Remove unfinished parts of the outbound message from the pipe.
     void rollback () const;
@@ -147,20 +147,24 @@ class pipe_t : public object_t,
 
     void send_stats_to_peer (own_t *socket_base_);
 
+    void send_disconnect_msg ();
+    void set_disconnect_msg (const std::vector<unsigned char> &disconnect_);
+
   private:
     //  Type of the underlying lock-free pipe.
     typedef ypipe_base_t<msg_t> upipe_t;
 
     //  Command handlers.
-    void process_activate_read ();
-    void process_activate_write (uint64_t msgs_read_);
-    void process_hiccup (void *pipe_);
-    void process_pipe_peer_stats (uint64_t queue_count_,
-                                  own_t *socket_base_,
-                                  endpoint_uri_pair_t *endpoint_pair_);
-    void process_pipe_term ();
-    void process_pipe_term_ack ();
-    void process_pipe_hwm (int inhwm_, int outhwm_);
+    void process_activate_read () ZMQ_OVERRIDE;
+    void process_activate_write (uint64_t msgs_read_) ZMQ_OVERRIDE;
+    void process_hiccup (void *pipe_) ZMQ_OVERRIDE;
+    void
+    process_pipe_peer_stats (uint64_t queue_count_,
+                             own_t *socket_base_,
+                             endpoint_uri_pair_t *endpoint_pair_) ZMQ_OVERRIDE;
+    void process_pipe_term () ZMQ_OVERRIDE;
+    void process_pipe_term_ack () ZMQ_OVERRIDE;
+    void process_pipe_hwm (int inhwm_, int outhwm_) ZMQ_OVERRIDE;
 
     //  Handler for delimiter read from the pipe.
     void process_delimiter ();
@@ -179,7 +183,7 @@ class pipe_t : public object_t,
     void set_peer (pipe_t *peer_);
 
     //  Destructor is private. Pipe objects destroy themselves.
-    ~pipe_t ();
+    ~pipe_t () ZMQ_OVERRIDE;
 
     //  Underlying pipes for both directions.
     upipe_t *_in_pipe;
@@ -256,12 +260,15 @@ class pipe_t : public object_t,
     // The endpoints of this pipe.
     endpoint_uri_pair_t _endpoint_pair;
 
-    //  Disable copying.
-    pipe_t (const pipe_t &);
-    const pipe_t &operator= (const pipe_t &);
+    // Disconnect msg
+    msg_t _disconnect_msg;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (pipe_t)
 };
 
 void send_routing_id (pipe_t *pipe_, const options_t &options_);
+
+void send_hello_msg (pipe_t *pipe_, const options_t &options_);
 }
 
 #endif
diff -pruN 4.3.2-2/src/plain_client.hpp 4.3.3-1/src/plain_client.hpp
--- 4.3.2-2/src/plain_client.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/plain_client.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -37,16 +37,16 @@ namespace zmq
 {
 class msg_t;
 
-class plain_client_t : public mechanism_base_t
+class plain_client_t ZMQ_FINAL : public mechanism_base_t
 {
   public:
-    plain_client_t (session_base_t *const session_, const options_t &options_);
-    virtual ~plain_client_t ();
+    plain_client_t (session_base_t *session_, const options_t &options_);
+    ~plain_client_t ();
 
     // mechanism implementation
-    virtual int next_handshake_command (msg_t *msg_);
-    virtual int process_handshake_command (msg_t *msg_);
-    virtual status_t status () const;
+    int next_handshake_command (msg_t *msg_);
+    int process_handshake_command (msg_t *msg_);
+    status_t status () const;
 
   private:
     enum state_t
diff -pruN 4.3.2-2/src/plain_server.cpp 4.3.3-1/src/plain_server.cpp
--- 4.3.2-2/src/plain_server.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/plain_server.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -192,7 +192,7 @@ int zmq::plain_server_t::process_hello (
     return receive_and_process_zap_reply () == -1 ? -1 : 0;
 }
 
-void zmq::plain_server_t::produce_welcome (msg_t *msg_) const
+void zmq::plain_server_t::produce_welcome (msg_t *msg_)
 {
     const int rc = msg_->init_size (welcome_prefix_len);
     errno_assert (rc == 0);
diff -pruN 4.3.2-2/src/plain_server.hpp 4.3.3-1/src/plain_server.hpp
--- 4.3.2-2/src/plain_server.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/plain_server.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -38,20 +38,20 @@ namespace zmq
 class msg_t;
 class session_base_t;
 
-class plain_server_t : public zap_client_common_handshake_t
+class plain_server_t ZMQ_FINAL : public zap_client_common_handshake_t
 {
   public:
     plain_server_t (session_base_t *session_,
                     const std::string &peer_address_,
                     const options_t &options_);
-    virtual ~plain_server_t ();
+    ~plain_server_t ();
 
     // mechanism implementation
-    virtual int next_handshake_command (msg_t *msg_);
-    virtual int process_handshake_command (msg_t *msg_);
+    int next_handshake_command (msg_t *msg_);
+    int process_handshake_command (msg_t *msg_);
 
   private:
-    void produce_welcome (msg_t *msg_) const;
+    static void produce_welcome (msg_t *msg_);
     void produce_ready (msg_t *msg_) const;
     void produce_error (msg_t *msg_) const;
 
diff -pruN 4.3.2-2/src/poller_base.cpp 4.3.3-1/src/poller_base.cpp
--- 4.3.2-2/src/poller_base.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/poller_base.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -32,10 +32,6 @@
 #include "i_poll_events.hpp"
 #include "err.hpp"
 
-zmq::poller_base_t::poller_base_t ()
-{
-}
-
 zmq::poller_base_t::~poller_base_t ()
 {
     //  Make sure there is no more load on the shutdown.
@@ -72,8 +68,14 @@ void zmq::poller_base_t::cancel_timer (i
             return;
         }
 
-    //  Timer not found.
-    zmq_assert (false);
+    //  We should generally never get here. Calling 'cancel_timer ()' on
+    //  an already expired or canceled timer (or even worse - on a timer which
+    //  never existed, supplying bad sink_ and/or id_ values) does not make any
+    //  sense.
+    //  But in some edge cases this might happen. As described in issue #3645
+    //  `timer_event ()` call from `execute_timers ()` might call `cancel_timer ()`
+    //  on already canceled (deleted) timer.
+    //  As soon as that is resolved an 'assert (false)' should be put here.
 }
 
 uint64_t zmq::poller_base_t::execute_timers ()
@@ -85,26 +87,31 @@ uint64_t zmq::poller_base_t::execute_tim
     //  Get the current time.
     const uint64_t current = _clock.now_ms ();
 
-    //   Execute the timers that are already due.
-    const timers_t::iterator begin = _timers.begin ();
-    const timers_t::iterator end = _timers.end ();
+    //  Execute the timers that are already due.
     uint64_t res = 0;
-    timers_t::iterator it = begin;
-    for (; it != end; ++it) {
-        //  If we have to wait to execute the item, same will be true about
-        //  all the following items (multimap is sorted). Thus we can stop
-        //  checking the subsequent timers.
+    timer_info_t timer_temp;
+    timers_t::iterator it;
+
+    do {
+        it = _timers.begin ();
+
+        //  If we have to wait to execute the item, same will be true for
+        //  all the following items because multimap is sorted. Thus we can
+        //  stop checking the subsequent timers.
         if (it->first > current) {
             res = it->first - current;
             break;
         }
 
+        //  Save and remove the timer because timer_event() call might delete
+        //  exactly this timer and then the iterator will be invalid.
+        timer_temp = it->second;
+        _timers.erase (it);
+
         //  Trigger the timer.
-        it->second.sink->timer_event (it->second.id);
-    }
+        timer_temp.sink->timer_event (timer_temp.id);
 
-    //  Remove them from the list of active timers.
-    _timers.erase (begin, it);
+    } while (!_timers.empty ());
 
     //  Return the time to wait for the next timer (at least 1ms), or 0, if
     //  there are no more timers.
@@ -127,7 +134,7 @@ void zmq::worker_poller_base_t::start (c
     _ctx.start_thread (_worker, worker_routine, this, name_);
 }
 
-void zmq::worker_poller_base_t::check_thread ()
+void zmq::worker_poller_base_t::check_thread () const
 {
 #ifdef _DEBUG
     zmq_assert (!_worker.get_started () || _worker.is_current_thread ());
diff -pruN 4.3.2-2/src/poller_base.hpp 4.3.3-1/src/poller_base.hpp
--- 4.3.2-2/src/poller_base.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/poller_base.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -114,7 +114,7 @@ struct i_poll_events;
 // a container that is being iterated by the poller.
 
 
-// A class that can be used as a base class for implementations of the poller
+// A class that can be used as abase class for implementations of the poller
 // concept.
 //
 // For documentation of the public methods, see the description of the poller_t
@@ -122,7 +122,7 @@ struct i_poll_events;
 class poller_base_t
 {
   public:
-    poller_base_t ();
+    poller_base_t () ZMQ_DEFAULT;
     virtual ~poller_base_t ();
 
     // Methods from the poller concept.
@@ -155,8 +155,7 @@ class poller_base_t
     //  registered.
     atomic_counter_t _load;
 
-    poller_base_t (const poller_base_t &);
-    const poller_base_t &operator= (const poller_base_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (poller_base_t)
 };
 
 //  Base class for a poller with a single worker thread.
@@ -173,7 +172,7 @@ class worker_poller_base_t : public poll
     //  via an assertion.
     //  Should be called by the add_fd, removed_fd, set_*, reset_* functions
     //  to ensure correct usage.
-    void check_thread ();
+    void check_thread () const;
 
     //  Stops the worker thread. Should be called from the destructor of the
     //  leaf class.
diff -pruN 4.3.2-2/src/poll.hpp 4.3.3-1/src/poll.hpp
--- 4.3.2-2/src/poll.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/poll.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -56,7 +56,7 @@ struct i_poll_events;
 //  Implements socket polling mechanism using the POSIX.1-2001
 //  poll() system call.
 
-class poll_t : public worker_poller_base_t
+class poll_t ZMQ_FINAL : public worker_poller_base_t
 {
   public:
     typedef fd_t handle_t;
@@ -78,7 +78,7 @@ class poll_t : public worker_poller_base
 
   private:
     //  Main event loop.
-    virtual void loop ();
+    void loop () ZMQ_FINAL;
 
     void cleanup_retired ();
 
@@ -99,8 +99,7 @@ class poll_t : public worker_poller_base
     //  If true, there's at least one retired event source.
     bool retired;
 
-    poll_t (const poll_t &);
-    const poll_t &operator= (const poll_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (poll_t)
 };
 
 typedef poll_t poller_t;
diff -pruN 4.3.2-2/src/polling_util.hpp 4.3.3-1/src/polling_util.hpp
--- 4.3.2-2/src/polling_util.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/polling_util.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -33,6 +33,7 @@
 #include <stdlib.h>
 #include <vector>
 
+#include "macros.hpp"
 #include "stdint.hpp"
 #include "platform.hpp"
 #include "err.hpp"
@@ -62,11 +63,10 @@ template <typename T, size_t S> class fa
     }
 
   private:
-    fast_vector_t (const fast_vector_t &);
-    fast_vector_t &operator= (const fast_vector_t &);
-
     T _static_buf[S];
     T *_buf;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (fast_vector_t)
 };
 
 template <typename T, size_t S> class resizable_fast_vector_t
@@ -96,20 +96,17 @@ template <typename T, size_t S> class re
     ~resizable_fast_vector_t () { delete _dynamic_buf; }
 
   private:
-    resizable_fast_vector_t (const resizable_fast_vector_t &);
-    resizable_fast_vector_t &operator= (const resizable_fast_vector_t &);
-
     T _static_buf[S];
     std::vector<T> *_dynamic_buf;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (resizable_fast_vector_t)
 };
 
 #if defined ZMQ_POLL_BASED_ON_POLL
 typedef int timeout_t;
 
-timeout_t compute_timeout (const bool first_pass_,
-                           const long timeout_,
-                           const uint64_t now_,
-                           const uint64_t end_);
+timeout_t
+compute_timeout (bool first_pass_, long timeout_, uint64_t now_, uint64_t end_);
 
 #elif defined ZMQ_POLL_BASED_ON_SELECT
 inline size_t valid_pollset_bytes (const fd_set &pollset_)
diff -pruN 4.3.2-2/src/pollset.hpp 4.3.3-1/src/pollset.hpp
--- 4.3.2-2/src/pollset.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/pollset.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -50,13 +50,13 @@ struct i_poll_events;
 //  This class implements socket polling mechanism using the AIX-specific
 //  pollset mechanism.
 
-class pollset_t : public poller_base_t
+class pollset_t ZMQ_FINAL : public poller_base_t
 {
   public:
     typedef void *handle_t;
 
     pollset_t (const thread_ctx_t &ctx_);
-    ~pollset_t ();
+    ~pollset_t () ZMQ_FINAL;
 
     //  "poller" concept.
     handle_t add_fd (fd_t fd_, zmq::i_poll_events *events_);
@@ -75,7 +75,7 @@ class pollset_t : public poller_base_t
     static void worker_routine (void *arg_);
 
     //  Main event loop.
-    void loop ();
+    void loop () ZMQ_FINAL;
 
     // Reference to ZMQ context.
     const thread_ctx_t &ctx;
@@ -105,8 +105,7 @@ class pollset_t : public poller_base_t
     //  Handle of the physical thread doing the I/O work.
     thread_t worker;
 
-    pollset_t (const pollset_t &);
-    const pollset_t &operator= (const pollset_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (pollset_t)
 };
 
 typedef pollset_t poller_t;
diff -pruN 4.3.2-2/src/proxy.cpp 4.3.3-1/src/proxy.cpp
--- 4.3.2-2/src/proxy.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/proxy.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -89,9 +89,8 @@ typedef struct
 
 // Utility functions
 
-int capture (class zmq::socket_base_t *capture_,
-             zmq::msg_t *msg_,
-             int more_ = 0)
+static int
+capture (class zmq::socket_base_t *capture_, zmq::msg_t *msg_, int more_ = 0)
 {
     //  Copy message to capture socket if any
     if (capture_) {
@@ -109,12 +108,12 @@ int capture (class zmq::socket_base_t *c
     return 0;
 }
 
-int forward (class zmq::socket_base_t *from_,
-             zmq_socket_stats_t *from_stats_,
-             class zmq::socket_base_t *to_,
-             zmq_socket_stats_t *to_stats_,
-             class zmq::socket_base_t *capture_,
-             zmq::msg_t *msg_)
+static int forward (class zmq::socket_base_t *from_,
+                    zmq_socket_stats_t *from_stats_,
+                    class zmq::socket_base_t *to_,
+                    zmq_socket_stats_t *to_stats_,
+                    class zmq::socket_base_t *capture_,
+                    zmq::msg_t *msg_)
 {
     // Forward a burst of messages
     for (unsigned int i = 0; i < zmq::proxy_burst_size; i++) {
@@ -128,8 +127,8 @@ int forward (class zmq::socket_base_t *f
             if (rc < 0) {
                 if (likely (errno == EAGAIN && i > 0))
                     return 0; // End of burst
-                else
-                    return -1;
+
+                return -1;
             }
 
             complete_msg_size += msg_->size ();
@@ -184,9 +183,9 @@ static int loop_and_send_multipart_stat
     return rc;
 }
 
-int reply_stats (class zmq::socket_base_t *control_,
-                 zmq_socket_stats_t *frontend_stats_,
-                 zmq_socket_stats_t *backend_stats_)
+static int reply_stats (zmq::socket_base_t *control_,
+                        const zmq_socket_stats_t *frontend_stats_,
+                        const zmq_socket_stats_t *backend_stats_)
 {
     // first part: frontend stats - the first send might fail due to HWM
     if (loop_and_send_multipart_stat (control_, frontend_stats_->msg_in, true,
diff -pruN 4.3.2-2/src/pub.hpp 4.3.3-1/src/pub.hpp
--- 4.3.2-2/src/pub.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/pub.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,7 +39,7 @@ class io_thread_t;
 class socket_base_t;
 class msg_t;
 
-class pub_t : public xpub_t
+class pub_t ZMQ_FINAL : public xpub_t
 {
   public:
     pub_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -52,9 +52,7 @@ class pub_t : public xpub_t
     int xrecv (zmq::msg_t *msg_);
     bool xhas_in ();
 
-  private:
-    pub_t (const pub_t &);
-    const pub_t &operator= (const pub_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (pub_t)
 };
 }
 
diff -pruN 4.3.2-2/src/pull.hpp 4.3.3-1/src/pull.hpp
--- 4.3.2-2/src/pull.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/pull.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,7 @@ class pipe_t;
 class msg_t;
 class io_thread_t;
 
-class pull_t : public socket_base_t
+class pull_t ZMQ_FINAL : public socket_base_t
 {
   public:
     pull_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -61,8 +61,7 @@ class pull_t : public socket_base_t
     //  Fair queueing object for inbound pipes.
     fq_t _fq;
 
-    pull_t (const pull_t &);
-    const pull_t &operator= (const pull_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (pull_t)
 };
 }
 
diff -pruN 4.3.2-2/src/push.hpp 4.3.3-1/src/push.hpp
--- 4.3.2-2/src/push.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/push.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,7 @@ class pipe_t;
 class msg_t;
 class io_thread_t;
 
-class push_t : public socket_base_t
+class push_t ZMQ_FINAL : public socket_base_t
 {
   public:
     push_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -61,8 +61,7 @@ class push_t : public socket_base_t
     //  Load balancer managing the outbound pipes.
     lb_t _lb;
 
-    push_t (const push_t &);
-    const push_t &operator= (const push_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (push_t)
 };
 }
 
diff -pruN 4.3.2-2/src/radio.cpp 4.3.3-1/src/radio.cpp
--- 4.3.2-2/src/radio.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/radio.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -126,7 +126,7 @@ void zmq::radio_t::xpipe_terminated (pip
                                    end = _subscriptions.end ();
          it != end;) {
         if (it->second == pipe_) {
-#if __cplusplus >= 201103L
+#if __cplusplus >= 201103L || (defined _MSC_VER && _MSC_VER >= 1700)
             it = _subscriptions.erase (it);
 #else
             _subscriptions.erase (it++);
@@ -157,8 +157,8 @@ int zmq::radio_t::xsend (msg_t *msg_)
 
     _dist.unmatch ();
 
-    std::pair<subscriptions_t::iterator, subscriptions_t::iterator> range =
-      _subscriptions.equal_range (std::string (msg_->group ()));
+    const std::pair<subscriptions_t::iterator, subscriptions_t::iterator>
+      range = _subscriptions.equal_range (std::string (msg_->group ()));
 
     for (subscriptions_t::iterator it = range.first; it != range.second; ++it)
         _dist.match (it->second);
@@ -218,7 +218,7 @@ int zmq::radio_session_t::push_msg (msg_
         const size_t data_size = msg_->size ();
 
         int group_length;
-        char *group;
+        const char *group;
 
         msg_t join_leave_msg;
         int rc;
@@ -262,7 +262,7 @@ int zmq::radio_session_t::pull_msg (msg_
             return rc;
 
         const char *group = _pending_msg.group ();
-        int length = static_cast<int> (strlen (group));
+        const int length = static_cast<int> (strlen (group));
 
         //  First frame is the group
         rc = msg_->init_size (length);
diff -pruN 4.3.2-2/src/radio.hpp 4.3.3-1/src/radio.hpp
--- 4.3.2-2/src/radio.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/radio.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -45,7 +45,7 @@ class ctx_t;
 class pipe_t;
 class io_thread_t;
 
-class radio_t : public socket_base_t
+class radio_t ZMQ_FINAL : public socket_base_t
 {
   public:
     radio_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -79,11 +79,10 @@ class radio_t : public socket_base_t
     //  Drop messages if HWM reached, otherwise return with EAGAIN
     bool _lossy;
 
-    radio_t (const radio_t &);
-    const radio_t &operator= (const radio_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (radio_t)
 };
 
-class radio_session_t : public session_base_t
+class radio_session_t ZMQ_FINAL : public session_base_t
 {
   public:
     radio_session_t (zmq::io_thread_t *io_thread_,
@@ -107,8 +106,7 @@ class radio_session_t : public session_b
 
     msg_t _pending_msg;
 
-    radio_session_t (const radio_session_t &);
-    const radio_session_t &operator= (const radio_session_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (radio_session_t)
 };
 }
 
diff -pruN 4.3.2-2/src/radix_tree.cpp 4.3.3-1/src/radix_tree.cpp
--- 4.3.2-2/src/radix_tree.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/radix_tree.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -34,6 +34,7 @@
 
 #include <stdlib.h>
 #include <string.h>
+#include <iterator>
 #include <vector>
 
 node_t::node_t (unsigned char *data_) : _data (data_)
@@ -154,8 +155,8 @@ bool node_t::operator!= (node_t other_)
 
 void node_t::resize (size_t prefix_length_, size_t edgecount_)
 {
-    size_t node_size = 3 * sizeof (uint32_t) + prefix_length_
-                       + edgecount_ * (1 + sizeof (void *));
+    const size_t node_size = 3 * sizeof (uint32_t) + prefix_length_
+                             + edgecount_ * (1 + sizeof (void *));
     unsigned char *new_data =
       static_cast<unsigned char *> (realloc (_data, node_size));
     zmq_assert (new_data);
@@ -166,8 +167,8 @@ void node_t::resize (size_t prefix_lengt
 
 node_t make_node (size_t refcount_, size_t prefix_length_, size_t edgecount_)
 {
-    size_t node_size = 3 * sizeof (uint32_t) + prefix_length_
-                       + edgecount_ * (1 + sizeof (void *));
+    const size_t node_size = 3 * sizeof (uint32_t) + prefix_length_
+                             + edgecount_ * (1 + sizeof (void *));
 
     unsigned char *data = static_cast<unsigned char *> (malloc (node_size));
     zmq_assert (data);
@@ -187,7 +188,7 @@ zmq::radix_tree_t::radix_tree_t () : _ro
 
 static void free_nodes (node_t node_)
 {
-    for (size_t i = 0; i < node_.edgecount (); ++i)
+    for (size_t i = 0, count = node_.edgecount (); i < count; ++i)
         free_nodes (node_.node_at (i));
     free (node_._data);
 }
@@ -234,18 +235,19 @@ match_result_t zmq::radix_tree_t::match
     size_t parent_edge_index = 0;
 
     while (current_node.prefix_length () > 0 || current_node.edgecount () > 0) {
+        const unsigned char *const prefix = current_node.prefix ();
+        const size_t prefix_length = current_node.prefix_length ();
+
         for (prefix_byte_index = 0;
-             prefix_byte_index < current_node.prefix_length ()
-             && key_byte_index < key_size_;
+             prefix_byte_index < prefix_length && key_byte_index < key_size_;
              ++prefix_byte_index, ++key_byte_index) {
-            if (current_node.prefix ()[prefix_byte_index]
-                != key_[key_byte_index])
+            if (prefix[prefix_byte_index] != key_[key_byte_index])
                 break;
         }
 
         // Even if a prefix of the key matches and we're doing a
         // lookup, this means we've found a matching subscription.
-        if (is_lookup_ && prefix_byte_index == current_node.prefix_length ()
+        if (is_lookup_ && prefix_byte_index == prefix_length
             && current_node.refcount () > 0) {
             key_byte_index = key_size_;
             break;
@@ -253,14 +255,14 @@ match_result_t zmq::radix_tree_t::match
 
         // There was a mismatch or we've matched the whole key, so
         // there's nothing more to do.
-        if (prefix_byte_index != current_node.prefix_length ()
-            || key_byte_index == key_size_)
+        if (prefix_byte_index != prefix_length || key_byte_index == key_size_)
             break;
 
         // We need to match the rest of the key. Check if there's an
         // outgoing edge from this node.
         node_t next_node = current_node;
-        for (size_t i = 0; i < current_node.edgecount (); ++i) {
+        for (size_t i = 0, edgecount = current_node.edgecount (); i < edgecount;
+             ++i) {
             if (current_node.first_byte_at (i) == key_[key_byte_index]) {
                 parent_edge_index = edge_index;
                 edge_index = i;
@@ -283,17 +285,16 @@ match_result_t zmq::radix_tree_t::match
 
 bool zmq::radix_tree_t::add (const unsigned char *key_, size_t key_size_)
 {
-    match_result_t match_result = match (key_, key_size_);
-    size_t key_bytes_matched = match_result._key_bytes_matched;
-    size_t prefix_bytes_matched = match_result._prefix_bytes_matched;
-    size_t edge_index = match_result._edge_index;
+    const match_result_t match_result = match (key_, key_size_);
+    const size_t key_bytes_matched = match_result._key_bytes_matched;
+    const size_t prefix_bytes_matched = match_result._prefix_bytes_matched;
+    const size_t edge_index = match_result._edge_index;
     node_t current_node = match_result._current_node;
     node_t parent_node = match_result._parent_node;
 
     if (key_bytes_matched != key_size_) {
         // Not all characters match, we might have to split the node.
-        if (key_bytes_matched == 0
-            || prefix_bytes_matched == current_node.prefix_length ()) {
+        if (prefix_bytes_matched == current_node.prefix_length ()) {
             // The mismatch is at one of the outgoing edges, so we
             // create an edge from the current node to a new leaf node
             // that has the rest of the key as the prefix.
@@ -408,11 +409,11 @@ bool zmq::radix_tree_t::add (const unsig
 
 bool zmq::radix_tree_t::rm (const unsigned char *key_, size_t key_size_)
 {
-    match_result_t match_result = match (key_, key_size_);
-    size_t key_bytes_matched = match_result._key_bytes_matched;
-    size_t prefix_bytes_matched = match_result._prefix_bytes_matched;
-    size_t edge_index = match_result._edge_index;
-    size_t parent_edge_index = match_result._parent_edge_index;
+    const match_result_t match_result = match (key_, key_size_);
+    const size_t key_bytes_matched = match_result._key_bytes_matched;
+    const size_t prefix_bytes_matched = match_result._prefix_bytes_matched;
+    const size_t edge_index = match_result._edge_index;
+    const size_t parent_edge_index = match_result._parent_edge_index;
     node_t current_node = match_result._current_node;
     node_t parent_node = match_result._parent_node;
     node_t grandparent_node = match_result._grandparent_node;
@@ -431,7 +432,7 @@ bool zmq::radix_tree_t::rm (const unsign
     if (current_node == _root)
         return true;
 
-    size_t outgoing_edges = current_node.edgecount ();
+    const size_t outgoing_edges = current_node.edgecount ();
     if (outgoing_edges > 1)
         // This node can't be merged with any other node, so there's
         // nothing more to do.
@@ -444,7 +445,7 @@ bool zmq::radix_tree_t::rm (const unsign
         // Make room for the child node's prefix and edges. We need to
         // keep the old prefix length since resize() will overwrite
         // it.
-        uint32_t old_prefix_length = current_node.prefix_length ();
+        const uint32_t old_prefix_length = current_node.prefix_length ();
         current_node.resize (old_prefix_length + child.prefix_length (),
                              child.edgecount ());
 
@@ -473,7 +474,7 @@ bool zmq::radix_tree_t::rm (const unsign
         // Make room for the child node's prefix and edges. We need to
         // keep the old prefix length since resize() will overwrite
         // it.
-        uint32_t old_prefix_length = parent_node.prefix_length ();
+        const uint32_t old_prefix_length = parent_node.prefix_length ();
         parent_node.resize (old_prefix_length + other_child.prefix_length (),
                             other_child.edgecount ());
 
@@ -500,9 +501,9 @@ bool zmq::radix_tree_t::rm (const unsign
     // Replace the edge to the current node with the last edge. An
     // edge consists of a byte and a pointer to the next node. First
     // replace the byte.
-    size_t last_index = parent_node.edgecount () - 1;
-    unsigned char last_byte = parent_node.first_byte_at (last_index);
-    node_t last_node = parent_node.node_at (last_index);
+    const size_t last_index = parent_node.edgecount () - 1;
+    const unsigned char last_byte = parent_node.first_byte_at (last_index);
+    const node_t last_node = parent_node.node_at (last_index);
     parent_node.set_edge_at (edge_index, last_byte, last_node);
 
     // Move the chunk of pointers one byte to the left, effectively
@@ -541,25 +542,27 @@ bool zmq::radix_tree_t::check (const uns
 static void
 visit_keys (node_t node_,
             std::vector<unsigned char> &buffer_,
-            void (*func_) (unsigned char *data, size_t size, void *arg),
+            void (*func_) (unsigned char *data_, size_t size_, void *arg_),
             void *arg_)
 {
-    for (size_t i = 0; i < node_.prefix_length (); ++i)
-        buffer_.push_back (node_.prefix ()[i]);
+    const size_t prefix_length = node_.prefix_length ();
+    buffer_.reserve (buffer_.size () + prefix_length);
+    std::copy (node_.prefix (), node_.prefix () + prefix_length,
+               std::back_inserter (buffer_));
 
     if (node_.refcount () > 0) {
         zmq_assert (!buffer_.empty ());
         func_ (&buffer_[0], buffer_.size (), arg_);
     }
 
-    for (size_t i = 0; i < node_.edgecount (); ++i)
+    for (size_t i = 0, edgecount = node_.edgecount (); i < edgecount; ++i) {
         visit_keys (node_.node_at (i), buffer_, func_, arg_);
-    for (size_t i = 0; i < node_.prefix_length (); ++i)
-        buffer_.pop_back ();
+    }
+    buffer_.resize (buffer_.size () - prefix_length);
 }
 
 void zmq::radix_tree_t::apply (
-  void (*func_) (unsigned char *data, size_t size, void *arg), void *arg_)
+  void (*func_) (unsigned char *data_, size_t size_, void *arg_), void *arg_)
 {
     if (_root.refcount () > 0)
         func_ (NULL, 0, arg_); // Root node is always empty.
diff -pruN 4.3.2-2/src/radix_tree.hpp 4.3.3-1/src/radix_tree.hpp
--- 4.3.2-2/src/radix_tree.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/radix_tree.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -67,24 +67,23 @@ struct node_t
     bool operator== (node_t other_) const;
     bool operator!= (node_t other_) const;
 
-    inline uint32_t refcount ();
-    inline uint32_t prefix_length ();
-    inline uint32_t edgecount ();
-    inline unsigned char *prefix ();
-    inline unsigned char *first_bytes ();
-    inline unsigned char first_byte_at (size_t index_);
-    inline unsigned char *node_pointers ();
-    inline node_t node_at (size_t index_);
-    inline void set_refcount (uint32_t value_);
-    inline void set_prefix_length (uint32_t value_);
-    inline void set_edgecount (uint32_t value_);
-    inline void set_prefix (const unsigned char *prefix_);
-    inline void set_first_bytes (const unsigned char *bytes_);
-    inline void set_first_byte_at (size_t index_, unsigned char byte_);
-    inline void set_node_pointers (const unsigned char *pointers_);
-    inline void set_node_at (size_t index_, node_t node_);
-    inline void
-    set_edge_at (size_t index_, unsigned char first_byte_, node_t node_);
+    uint32_t refcount ();
+    uint32_t prefix_length ();
+    uint32_t edgecount ();
+    unsigned char *prefix ();
+    unsigned char *first_bytes ();
+    unsigned char first_byte_at (size_t index_);
+    unsigned char *node_pointers ();
+    node_t node_at (size_t index_);
+    void set_refcount (uint32_t value_);
+    void set_prefix_length (uint32_t value_);
+    void set_edgecount (uint32_t value_);
+    void set_prefix (const unsigned char *bytes_);
+    void set_first_bytes (const unsigned char *bytes_);
+    void set_first_byte_at (size_t index_, unsigned char byte_);
+    void set_node_pointers (const unsigned char *pointers_);
+    void set_node_at (size_t index_, node_t node_);
+    void set_edge_at (size_t index_, unsigned char first_byte_, node_t node_);
     void resize (size_t prefix_length_, size_t edgecount_);
 
     unsigned char *_data;
@@ -137,7 +136,7 @@ class radix_tree_t
     size_t size () const;
 
   private:
-    inline match_result_t
+    match_result_t
     match (const unsigned char *key_, size_t key_size_, bool is_lookup_) const;
 
     node_t _root;
diff -pruN 4.3.2-2/src/random.cpp 4.3.3-1/src/random.cpp
--- 4.3.2-2/src/random.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/random.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -49,7 +49,7 @@
 void zmq::seed_random ()
 {
 #if defined ZMQ_HAVE_WINDOWS
-    int pid = static_cast<int> (GetCurrentProcessId ());
+    const int pid = static_cast<int> (GetCurrentProcessId ());
 #else
     int pid = static_cast<int> (getpid ());
 #endif
@@ -59,7 +59,7 @@ void zmq::seed_random ()
 uint32_t zmq::generate_random ()
 {
     //  Compensate for the fact that rand() returns signed integer.
-    uint32_t low = static_cast<uint32_t> (rand ());
+    const uint32_t low = static_cast<uint32_t> (rand ());
     uint32_t high = static_cast<uint32_t> (rand ());
     high <<= (sizeof (int) * 8 - 1);
     return high | low;
diff -pruN 4.3.2-2/src/raw_decoder.hpp 4.3.3-1/src/raw_decoder.hpp
--- 4.3.2-2/src/raw_decoder.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/raw_decoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,30 +39,28 @@ namespace zmq
 {
 //  Decoder for 0MQ v1 framing protocol. Converts data stream into messages.
 
-class raw_decoder_t : public i_decoder
+class raw_decoder_t ZMQ_FINAL : public i_decoder
 {
   public:
     raw_decoder_t (size_t bufsize_);
-    virtual ~raw_decoder_t ();
+    ~raw_decoder_t ();
 
     //  i_decoder interface.
 
-    virtual void get_buffer (unsigned char **data_, size_t *size_);
+    void get_buffer (unsigned char **data_, size_t *size_);
 
-    virtual int
-    decode (const unsigned char *data_, size_t size_, size_t &bytes_used_);
+    int decode (const unsigned char *data_, size_t size_, size_t &bytes_used_);
 
-    virtual msg_t *msg () { return &_in_progress; }
+    msg_t *msg () { return &_in_progress; }
 
-    virtual void resize_buffer (size_t) {}
+    void resize_buffer (size_t) {}
 
   private:
     msg_t _in_progress;
 
     shared_message_memory_allocator _allocator;
 
-    raw_decoder_t (const raw_decoder_t &);
-    void operator= (const raw_decoder_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (raw_decoder_t)
 };
 }
 
diff -pruN 4.3.2-2/src/raw_encoder.hpp 4.3.3-1/src/raw_encoder.hpp
--- 4.3.2-2/src/raw_encoder.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/raw_encoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -40,7 +40,7 @@ namespace zmq
 {
 //  Encoder for 0MQ framing protocol. Converts messages into data batches.
 
-class raw_encoder_t : public encoder_base_t<raw_encoder_t>
+class raw_encoder_t ZMQ_FINAL : public encoder_base_t<raw_encoder_t>
 {
   public:
     raw_encoder_t (size_t bufsize_);
@@ -49,8 +49,7 @@ class raw_encoder_t : public encoder_bas
   private:
     void raw_message_ready ();
 
-    raw_encoder_t (const raw_encoder_t &);
-    const raw_encoder_t &operator= (const raw_encoder_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (raw_encoder_t)
 };
 }
 
diff -pruN 4.3.2-2/src/raw_engine.cpp 4.3.3-1/src/raw_engine.cpp
--- 4.3.2-2/src/raw_engine.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/raw_engine.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,138 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include "macros.hpp"
+
+#include <limits.h>
+#include <string.h>
+
+#ifndef ZMQ_HAVE_WINDOWS
+#include <unistd.h>
+#endif
+
+#include <new>
+#include <sstream>
+
+#include "raw_engine.hpp"
+#include "io_thread.hpp"
+#include "session_base.hpp"
+#include "v1_encoder.hpp"
+#include "v1_decoder.hpp"
+#include "v2_encoder.hpp"
+#include "v2_decoder.hpp"
+#include "null_mechanism.hpp"
+#include "plain_client.hpp"
+#include "plain_server.hpp"
+#include "gssapi_client.hpp"
+#include "gssapi_server.hpp"
+#include "curve_client.hpp"
+#include "curve_server.hpp"
+#include "raw_decoder.hpp"
+#include "raw_encoder.hpp"
+#include "config.hpp"
+#include "err.hpp"
+#include "ip.hpp"
+#include "tcp.hpp"
+#include "likely.hpp"
+#include "wire.hpp"
+
+zmq::raw_engine_t::raw_engine_t (
+  fd_t fd_,
+  const options_t &options_,
+  const endpoint_uri_pair_t &endpoint_uri_pair_) :
+    stream_engine_base_t (fd_, options_, endpoint_uri_pair_, false)
+{
+}
+
+zmq::raw_engine_t::~raw_engine_t ()
+{
+}
+
+void zmq::raw_engine_t::plug_internal ()
+{
+    // no handshaking for raw sock, instantiate raw encoder and decoders
+    _encoder = new (std::nothrow) raw_encoder_t (_options.out_batch_size);
+    alloc_assert (_encoder);
+
+    _decoder = new (std::nothrow) raw_decoder_t (_options.in_batch_size);
+    alloc_assert (_decoder);
+
+    _next_msg = &raw_engine_t::pull_msg_from_session;
+    _process_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+      &raw_engine_t::push_raw_msg_to_session);
+
+    properties_t properties;
+    if (init_properties (properties)) {
+        //  Compile metadata.
+        zmq_assert (_metadata == NULL);
+        _metadata = new (std::nothrow) metadata_t (properties);
+        alloc_assert (_metadata);
+    }
+
+    if (_options.raw_notify) {
+        //  For raw sockets, send an initial 0-length message to the
+        // application so that it knows a peer has connected.
+        msg_t connector;
+        connector.init ();
+        push_raw_msg_to_session (&connector);
+        connector.close ();
+        session ()->flush ();
+    }
+
+    set_pollin ();
+    set_pollout ();
+    //  Flush all the data that may have been already received downstream.
+    in_event ();
+}
+
+bool zmq::raw_engine_t::handshake ()
+{
+    return true;
+}
+
+void zmq::raw_engine_t::error (error_reason_t reason_)
+{
+    if (_options.raw_socket && _options.raw_notify) {
+        //  For raw sockets, send a final 0-length message to the application
+        //  so that it knows the peer has been disconnected.
+        msg_t terminator;
+        terminator.init ();
+        (this->*_process_msg) (&terminator);
+        terminator.close ();
+    }
+    stream_engine_base_t::error (reason_);
+}
+
+int zmq::raw_engine_t::push_raw_msg_to_session (msg_t *msg_)
+{
+    if (_metadata && _metadata != msg_->metadata ())
+        msg_->set_metadata (_metadata);
+    return push_msg_to_session (msg_);
+}
diff -pruN 4.3.2-2/src/raw_engine.hpp 4.3.3-1/src/raw_engine.hpp
--- 4.3.2-2/src/raw_engine.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/raw_engine.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,77 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_RAW_ENGINE_HPP_INCLUDED__
+#define __ZMQ_RAW_ENGINE_HPP_INCLUDED__
+
+#include <stddef.h>
+
+#include "fd.hpp"
+#include "i_engine.hpp"
+#include "io_object.hpp"
+#include "i_encoder.hpp"
+#include "i_decoder.hpp"
+#include "options.hpp"
+#include "socket_base.hpp"
+#include "metadata.hpp"
+#include "msg.hpp"
+#include "stream_engine_base.hpp"
+
+namespace zmq
+{
+//  Protocol revisions
+
+class io_thread_t;
+class session_base_t;
+class mechanism_t;
+
+//  This engine handles any socket with SOCK_STREAM semantics,
+//  e.g. TCP socket or an UNIX domain socket.
+
+class raw_engine_t ZMQ_FINAL : public stream_engine_base_t
+{
+  public:
+    raw_engine_t (fd_t fd_,
+                  const options_t &options_,
+                  const endpoint_uri_pair_t &endpoint_uri_pair_);
+    ~raw_engine_t ();
+
+  protected:
+    void error (error_reason_t reason_);
+    void plug_internal ();
+    bool handshake ();
+
+  private:
+    int push_raw_msg_to_session (msg_t *msg_);
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (raw_engine_t)
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/reaper.cpp 4.3.3-1/src/reaper.cpp
--- 4.3.2-2/src/reaper.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/reaper.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -93,7 +93,7 @@ void zmq::reaper_t::in_event ()
 
         //  Get the next command. If there is none, exit.
         command_t cmd;
-        int rc = _mailbox.recv (&cmd, 0);
+        const int rc = _mailbox.recv (&cmd, 0);
         if (rc != 0 && errno == EINTR)
             continue;
         if (rc != 0 && errno == EAGAIN)
diff -pruN 4.3.2-2/src/reaper.hpp 4.3.3-1/src/reaper.hpp
--- 4.3.2-2/src/reaper.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/reaper.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -40,7 +40,7 @@ namespace zmq
 class ctx_t;
 class socket_base_t;
 
-class reaper_t : public object_t, public i_poll_events
+class reaper_t ZMQ_FINAL : public object_t, public i_poll_events
 {
   public:
     reaper_t (zmq::ctx_t *ctx_, uint32_t tid_);
@@ -77,13 +77,12 @@ class reaper_t : public object_t, public
     //  If true, we were already asked to terminate.
     bool _terminating;
 
-    reaper_t (const reaper_t &);
-    const reaper_t &operator= (const reaper_t &);
-
 #ifdef HAVE_FORK
     // the process that created this context. Used to detect forking.
     pid_t _pid;
 #endif
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (reaper_t)
 };
 }
 
diff -pruN 4.3.2-2/src/rep.cpp 4.3.3-1/src/rep.cpp
--- 4.3.2-2/src/rep.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/rep.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -52,10 +52,10 @@ int zmq::rep_t::xsend (msg_t *msg_)
         return -1;
     }
 
-    bool more = (msg_->flags () & msg_t::more) != 0;
+    const bool more = (msg_->flags () & msg_t::more) != 0;
 
     //  Push message to the reply pipe.
-    int rc = router_t::xsend (msg_);
+    const int rc = router_t::xsend (msg_);
     if (rc != 0)
         return rc;
 
@@ -84,7 +84,7 @@ int zmq::rep_t::xrecv (msg_t *msg_)
 
             if ((msg_->flags () & msg_t::more)) {
                 //  Empty message part delimits the traceback stack.
-                bool bottom = (msg_->size () == 0);
+                const bool bottom = (msg_->size () == 0);
 
                 //  Push it to the reply pipe.
                 rc = router_t::xsend (msg_);
@@ -103,7 +103,7 @@ int zmq::rep_t::xrecv (msg_t *msg_)
     }
 
     //  Get next message part to return to the user.
-    int rc = router_t::xrecv (msg_);
+    const int rc = router_t::xrecv (msg_);
     if (rc != 0)
         return rc;
 
diff -pruN 4.3.2-2/src/rep.hpp 4.3.3-1/src/rep.hpp
--- 4.3.2-2/src/rep.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/rep.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,7 +39,7 @@ class msg_t;
 class io_thread_t;
 class socket_base_t;
 
-class rep_t : public router_t
+class rep_t ZMQ_FINAL : public router_t
 {
   public:
     rep_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -60,8 +60,7 @@ class rep_t : public router_t
     //  of the request is the backtrace stack.
     bool _request_begins;
 
-    rep_t (const rep_t &);
-    const rep_t &operator= (const rep_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (rep_t)
 };
 }
 
diff -pruN 4.3.2-2/src/req.cpp 4.3.3-1/src/req.cpp
--- 4.3.2-2/src/req.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/req.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -175,7 +175,7 @@ int zmq::req_t::xrecv (msg_t *msg_)
         _message_begins = false;
     }
 
-    int rc = recv_reply_pipe (msg_);
+    const int rc = recv_reply_pipe (msg_);
     if (rc != 0)
         return rc;
 
@@ -210,7 +210,7 @@ int zmq::req_t::xsetsockopt (int option_
                              const void *optval_,
                              size_t optvallen_)
 {
-    bool is_int = (optvallen_ == sizeof (int));
+    const bool is_int = (optvallen_ == sizeof (int));
     int value = 0;
     if (is_int)
         memcpy (&value, optval_, sizeof (int));
@@ -248,7 +248,7 @@ int zmq::req_t::recv_reply_pipe (msg_t *
 {
     while (true) {
         pipe_t *pipe = NULL;
-        int rc = dealer_t::recvpipe (msg_, &pipe);
+        const int rc = dealer_t::recvpipe (msg_, &pipe);
         if (rc != 0)
             return rc;
         if (!_reply_pipe || pipe == _reply_pipe)
diff -pruN 4.3.2-2/src/req.hpp 4.3.3-1/src/req.hpp
--- 4.3.2-2/src/req.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/req.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -40,7 +40,7 @@ class msg_t;
 class io_thread_t;
 class socket_base_t;
 
-class req_t : public dealer_t
+class req_t ZMQ_FINAL : public dealer_t
 {
   public:
     req_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -83,11 +83,10 @@ class req_t : public dealer_t
     //  still pending.
     bool _strict;
 
-    req_t (const req_t &);
-    const req_t &operator= (const req_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (req_t)
 };
 
-class req_session_t : public session_base_t
+class req_session_t ZMQ_FINAL : public session_base_t
 {
   public:
     req_session_t (zmq::io_thread_t *io_thread_,
@@ -109,8 +108,7 @@ class req_session_t : public session_bas
         body
     } _state;
 
-    req_session_t (const req_session_t &);
-    const req_session_t &operator= (const req_session_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (req_session_t)
 };
 }
 
diff -pruN 4.3.2-2/src/router.cpp 4.3.3-1/src/router.cpp
--- 4.3.2-2/src/router.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/router.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -55,6 +55,8 @@ zmq::router_t::router_t (class ctx_t *pa
     options.type = ZMQ_ROUTER;
     options.recv_routing_id = true;
     options.raw_socket = false;
+    options.can_send_hello_msg = true;
+    options.can_recv_disconnect_msg = true;
 
     _prefetched_id.init ();
     _prefetched_msg.init ();
@@ -90,7 +92,7 @@ void zmq::router_t::xattach_pipe (pipe_t
         errno_assert (rc == 0);
     }
 
-    bool routing_id_ok = identify_peer (pipe_, locally_initiated_);
+    const bool routing_id_ok = identify_peer (pipe_, locally_initiated_);
     if (routing_id_ok)
         _fq.attach (pipe_);
     else
@@ -171,7 +173,7 @@ void zmq::router_t::xpipe_terminated (pi
 
 void zmq::router_t::xread_activated (pipe_t *pipe_)
 {
-    std::set<pipe_t *>::iterator it = _anonymous_pipes.find (pipe_);
+    const std::set<pipe_t *>::iterator it = _anonymous_pipes.find (pipe_);
     if (it == _anonymous_pipes.end ())
         _fq.activated (pipe_);
     else {
@@ -209,7 +211,7 @@ int zmq::router_t::xsend (msg_t *msg_)
                 // Check whether pipe is closed or not
                 if (!_current_out->check_write ()) {
                     // Check whether pipe is full or not
-                    bool pipe_full = !_current_out->check_hwm ();
+                    const bool pipe_full = !_current_out->check_hwm ();
                     out_pipe->active = false;
                     _current_out = NULL;
 
@@ -258,10 +260,10 @@ int zmq::router_t::xsend (msg_t *msg_)
             return 0;
         }
 
-        bool ok = _current_out->write (msg_);
+        const bool ok = _current_out->write (msg_);
         if (unlikely (!ok)) {
             // Message failed to send - we must close it ourselves.
-            int rc = msg_->close ();
+            const int rc = msg_->close ();
             errno_assert (rc == 0);
             // HWM was checked before, so the pipe must be gone. Roll back
             // messages that were piped, for example REP labels.
@@ -274,12 +276,12 @@ int zmq::router_t::xsend (msg_t *msg_)
             }
         }
     } else {
-        int rc = msg_->close ();
+        const int rc = msg_->close ();
         errno_assert (rc == 0);
     }
 
     //  Detach the message from the data buffer.
-    int rc = msg_->init ();
+    const int rc = msg_->init ();
     errno_assert (rc == 0);
 
     return 0;
@@ -289,11 +291,11 @@ int zmq::router_t::xrecv (msg_t *msg_)
 {
     if (_prefetched) {
         if (!_routing_id_sent) {
-            int rc = msg_->move (_prefetched_id);
+            const int rc = msg_->move (_prefetched_id);
             errno_assert (rc == 0);
             _routing_id_sent = true;
         } else {
-            int rc = msg_->move (_prefetched_msg);
+            const int rc = msg_->move (_prefetched_msg);
             errno_assert (rc == 0);
             _prefetched = false;
         }
@@ -432,7 +434,7 @@ int zmq::router_t::get_peer_state (const
     // TODO remove the const_cast, see comment in lookup_out_pipe
     const blob_t routing_id_blob (
       static_cast<unsigned char *> (const_cast<void *> (routing_id_)),
-      routing_id_size_);
+      routing_id_size_, reference_tag_t ());
     const out_pipe_t *out_pipe = lookup_out_pipe (routing_id_blob);
     if (!out_pipe) {
         errno = EHOSTUNREACH;
@@ -469,7 +471,7 @@ bool zmq::router_t::identify_peer (pipe_
     } else if (!options.raw_socket) {
         //  Pick up handshake cases and also case where next integral routing id is set
         msg.init ();
-        bool ok = pipe_->read (&msg);
+        const bool ok = pipe_->read (&msg);
         if (!ok)
             return false;
 
@@ -487,7 +489,8 @@ bool zmq::router_t::identify_peer (pipe_
 
             //  Try to remove an existing routing id entry to allow the new
             //  connection to take the routing id.
-            out_pipe_t *existing_outpipe = lookup_out_pipe (routing_id);
+            const out_pipe_t *const existing_outpipe =
+              lookup_out_pipe (routing_id);
 
             if (existing_outpipe) {
                 if (!_handover)
diff -pruN 4.3.2-2/src/router.hpp 4.3.3-1/src/router.hpp
--- 4.3.2-2/src/router.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/router.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -49,20 +49,22 @@ class router_t : public routing_socket_b
 {
   public:
     router_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
-    ~router_t ();
+    ~router_t () ZMQ_OVERRIDE;
 
     //  Overrides of functions from socket_base_t.
     void xattach_pipe (zmq::pipe_t *pipe_,
                        bool subscribe_to_all_,
-                       bool locally_initiated_);
-    int xsetsockopt (int option_, const void *optval_, size_t optvallen_);
-    int xsend (zmq::msg_t *msg_);
-    int xrecv (zmq::msg_t *msg_);
-    bool xhas_in ();
-    bool xhas_out ();
-    void xread_activated (zmq::pipe_t *pipe_);
-    void xpipe_terminated (zmq::pipe_t *pipe_);
-    int get_peer_state (const void *routing_id_, size_t routing_id_size_) const;
+                       bool locally_initiated_) ZMQ_FINAL;
+    int
+    xsetsockopt (int option_, const void *optval_, size_t optvallen_) ZMQ_FINAL;
+    int xsend (zmq::msg_t *msg_) ZMQ_OVERRIDE;
+    int xrecv (zmq::msg_t *msg_) ZMQ_OVERRIDE;
+    bool xhas_in () ZMQ_OVERRIDE;
+    bool xhas_out () ZMQ_OVERRIDE;
+    void xread_activated (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    void xpipe_terminated (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    int get_peer_state (const void *routing_id_,
+                        size_t routing_id_size_) const ZMQ_FINAL;
 
   protected:
     //  Rollback any message parts that were sent but not yet flushed.
@@ -123,8 +125,7 @@ class router_t : public routing_socket_b
     // will be terminated.
     bool _handover;
 
-    router_t (const router_t &);
-    const router_t &operator= (const router_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (router_t)
 };
 }
 
diff -pruN 4.3.2-2/src/scatter.hpp 4.3.3-1/src/scatter.hpp
--- 4.3.2-2/src/scatter.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/scatter.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,7 @@ class pipe_t;
 class msg_t;
 class io_thread_t;
 
-class scatter_t : public socket_base_t
+class scatter_t ZMQ_FINAL : public socket_base_t
 {
   public:
     scatter_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -61,8 +61,7 @@ class scatter_t : public socket_base_t
     //  Load balancer managing the outbound pipes.
     lb_t _lb;
 
-    scatter_t (const scatter_t &);
-    const scatter_t &operator= (const scatter_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (scatter_t)
 };
 }
 
diff -pruN 4.3.2-2/src/secure_allocator.hpp 4.3.3-1/src/secure_allocator.hpp
--- 4.3.2-2/src/secure_allocator.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/secure_allocator.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,104 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_SECURE_ALLOCATOR_HPP_INCLUDED__
+#define __ZMQ_SECURE_ALLOCATOR_HPP_INCLUDED__
+
+#include "platform.hpp"
+#include "macros.hpp"
+
+#ifdef ZMQ_HAVE_CURVE
+
+#if defined(ZMQ_USE_LIBSODIUM)
+#include "sodium.h"
+#endif
+
+#include <memory>
+
+namespace zmq
+{
+#if defined(ZMQ_USE_LIBSODIUM)
+template <class T> struct secure_allocator_t
+{
+    typedef T value_type;
+
+    secure_allocator_t () ZMQ_DEFAULT;
+
+    template <class U>
+    secure_allocator_t (const secure_allocator_t<U> &) ZMQ_NOEXCEPT
+    {
+    }
+    T *allocate (std::size_t n) ZMQ_NOEXCEPT
+    {
+        T *res = static_cast<T *> (sodium_allocarray (sizeof (T), n));
+        alloc_assert (res);
+        return res;
+    }
+    void deallocate (T *p, std::size_t) ZMQ_NOEXCEPT { sodium_free (p); }
+
+    // the following is only required with C++98
+    // TODO maybe make this conditionally compiled
+    typedef T *pointer;
+    typedef const T *const_pointer;
+    typedef T &reference;
+    typedef const T &const_reference;
+    typedef std::size_t size_type;
+    typedef std::ptrdiff_t difference_type;
+    template <class U> struct rebind
+    {
+        typedef secure_allocator_t<U> other;
+    };
+
+    void construct (pointer p, const_reference val)
+    {
+        new ((void *) p) value_type (val);
+    }
+    void destroy (pointer p) { p->~value_type (); }
+    size_type max_size () const { return SIZE_MAX; }
+};
+template <class T, class U>
+bool operator== (const secure_allocator_t<T> &, const secure_allocator_t<U> &)
+{
+    return true;
+}
+template <class T, class U>
+bool operator!= (const secure_allocator_t<T> &, const secure_allocator_t<U> &)
+{
+    return false;
+}
+#else
+template <typename T> struct secure_allocator_t : std::allocator<T>
+{
+};
+#endif
+}
+
+#endif
+
+#endif
diff -pruN 4.3.2-2/src/select.cpp 4.3.3-1/src/select.cpp
--- 4.3.2-2/src/select.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/select.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -373,19 +373,15 @@ void zmq::select_t::loop ()
                     //  http://stackoverflow.com/q/35043420/188530
                     if (FD_ISSET (fd, &family_entry.fds_set.read)
                         && FD_ISSET (fd, &family_entry.fds_set.write))
-                        rc =
-                          WSAEventSelect (fd, wsa_events.events[3],
-                                          FD_READ | FD_ACCEPT | FD_CLOSE
-                                            | FD_WRITE | FD_CONNECT | FD_OOB);
+                        rc = WSAEventSelect (fd, wsa_events.events[3],
+                                             FD_READ | FD_ACCEPT | FD_CLOSE
+                                               | FD_WRITE | FD_CONNECT);
                     else if (FD_ISSET (fd, &family_entry.fds_set.read))
                         rc = WSAEventSelect (fd, wsa_events.events[0],
-                                             FD_READ | FD_ACCEPT | FD_CLOSE
-                                               | FD_OOB);
+                                             FD_READ | FD_ACCEPT | FD_CLOSE);
                     else if (FD_ISSET (fd, &family_entry.fds_set.write))
                         rc = WSAEventSelect (fd, wsa_events.events[1],
-                                             FD_WRITE | FD_CONNECT | FD_OOB);
-                    else if (FD_ISSET (fd, &family_entry.fds_set.error))
-                        rc = WSAEventSelect (fd, wsa_events.events[2], FD_OOB);
+                                             FD_WRITE | FD_CONNECT);
                     else
                         rc = 0;
 
diff -pruN 4.3.2-2/src/select.hpp 4.3.3-1/src/select.hpp
--- 4.3.2-2/src/select.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/select.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -57,13 +57,13 @@ struct i_poll_events;
 //  Implements socket polling mechanism using POSIX.1-2001 select()
 //  function.
 
-class select_t : public worker_poller_base_t
+class select_t ZMQ_FINAL : public worker_poller_base_t
 {
   public:
     typedef fd_t handle_t;
 
     select_t (const thread_ctx_t &ctx_);
-    ~select_t ();
+    ~select_t () ZMQ_FINAL;
 
     //  "poller" concept.
     handle_t add_fd (fd_t fd_, zmq::i_poll_events *events_);
@@ -78,7 +78,7 @@ class select_t : public worker_poller_ba
 
   private:
     //  Main event loop.
-    void loop ();
+    void loop () ZMQ_FINAL;
 
     //  Internal state.
     struct fds_set_t
@@ -160,8 +160,7 @@ class select_t : public worker_poller_ba
     static fd_entries_t::iterator
     find_fd_entry_by_handle (fd_entries_t &fd_entries_, handle_t handle_);
 
-    select_t (const select_t &);
-    const select_t &operator= (const select_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (select_t)
 };
 
 typedef select_t poller_t;
diff -pruN 4.3.2-2/src/server.cpp 4.3.3-1/src/server.cpp
--- 4.3.2-2/src/server.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/server.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,6 +41,8 @@ zmq::server_t::server_t (class ctx_t *pa
     _next_routing_id (generate_random ())
 {
     options.type = ZMQ_SERVER;
+    options.can_send_hello_msg = true;
+    options.can_recv_disconnect_msg = true;
 }
 
 zmq::server_t::~server_t ()
@@ -64,7 +66,8 @@ void zmq::server_t::xattach_pipe (pipe_t
     pipe_->set_server_socket_routing_id (routing_id);
     //  Add the record into output pipes lookup table
     outpipe_t outpipe = {pipe_, true};
-    bool ok = _out_pipes.ZMQ_MAP_INSERT_OR_EMPLACE (routing_id, outpipe).second;
+    const bool ok =
+      _out_pipes.ZMQ_MAP_INSERT_OR_EMPLACE (routing_id, outpipe).second;
     zmq_assert (ok);
 
     _fq.attach (pipe_);
@@ -72,7 +75,7 @@ void zmq::server_t::xattach_pipe (pipe_t
 
 void zmq::server_t::xpipe_terminated (pipe_t *pipe_)
 {
-    out_pipes_t::iterator it =
+    const out_pipes_t::iterator it =
       _out_pipes.find (pipe_->get_server_socket_routing_id ());
     zmq_assert (it != _out_pipes.end ());
     _out_pipes.erase (it);
@@ -105,7 +108,7 @@ int zmq::server_t::xsend (msg_t *msg_)
         return -1;
     }
     //  Find the pipe associated with the routing stored in the message.
-    uint32_t routing_id = msg_->get_routing_id ();
+    const uint32_t routing_id = msg_->get_routing_id ();
     out_pipes_t::iterator it = _out_pipes.find (routing_id);
 
     if (it != _out_pipes.end ()) {
@@ -123,7 +126,7 @@ int zmq::server_t::xsend (msg_t *msg_)
     int rc = msg_->reset_routing_id ();
     errno_assert (rc == 0);
 
-    bool ok = it->second.pipe->write (msg_);
+    const bool ok = it->second.pipe->write (msg_);
     if (unlikely (!ok)) {
         // Message failed to send - we must close it ourselves.
         rc = msg_->close ();
@@ -161,7 +164,7 @@ int zmq::server_t::xrecv (msg_t *msg_)
 
     zmq_assert (pipe != NULL);
 
-    uint32_t routing_id = pipe->get_server_socket_routing_id ();
+    const uint32_t routing_id = pipe->get_server_socket_routing_id ();
     msg_->set_routing_id (routing_id);
 
     return 0;
diff -pruN 4.3.2-2/src/server.hpp 4.3.3-1/src/server.hpp
--- 4.3.2-2/src/server.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/server.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -81,8 +81,7 @@ class server_t : public socket_base_t
     //  algorithm. This value is the next ID to use (if not used already).
     uint32_t _next_routing_id;
 
-    server_t (const server_t &);
-    const server_t &operator= (const server_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (server_t)
 };
 }
 
diff -pruN 4.3.2-2/src/session_base.cpp 4.3.3-1/src/session_base.cpp
--- 4.3.2-2/src/session_base.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/session_base.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -35,6 +35,7 @@
 #include "pipe.hpp"
 #include "likely.hpp"
 #include "tcp_connecter.hpp"
+#include "ws_connecter.hpp"
 #include "ipc_connecter.hpp"
 #include "tipc_connecter.hpp"
 #include "socks_connecter.hpp"
@@ -86,9 +87,23 @@ zmq::session_base_t *zmq::session_base_t
         case ZMQ_GATHER:
         case ZMQ_SCATTER:
         case ZMQ_DGRAM:
+        case ZMQ_PEER:
+        case ZMQ_CHANNEL:
+#ifdef ZMQ_BUILD_DRAFT_API
+            if (options_.can_send_hello_msg && options_.hello_msg.size () > 0)
+                s = new (std::nothrow) hello_msg_session_t (
+                  io_thread_, active_, socket_, options_, addr_);
+            else
+                s = new (std::nothrow) session_base_t (
+                  io_thread_, active_, socket_, options_, addr_);
+
+            break;
+#else
             s = new (std::nothrow)
               session_base_t (io_thread_, active_, socket_, options_, addr_);
             break;
+#endif
+
         default:
             errno = EINVAL;
             return NULL;
@@ -114,6 +129,10 @@ zmq::session_base_t::session_base_t (cla
     _io_thread (io_thread_),
     _has_linger_timer (false),
     _addr (addr_)
+#ifdef ZMQ_HAVE_WSS
+    ,
+    _wss_hostname (options_.wss_hostname)
+#endif
 {
 }
 
@@ -168,7 +187,7 @@ int zmq::session_base_t::push_msg (msg_t
         && !msg_->is_cancel ())
         return 0;
     if (_pipe && _pipe->write (msg_)) {
-        int rc = msg_->init ();
+        const int rc = msg_->init ();
         errno_assert (rc == 0);
         return 0;
     }
@@ -289,7 +308,8 @@ void zmq::session_base_t::read_activated
     }
 
     if (unlikely (_engine == NULL)) {
-        _pipe->check_read ();
+        if (_pipe)
+            _pipe->check_read ();
         return;
     }
 
@@ -320,7 +340,7 @@ void zmq::session_base_t::hiccuped (pipe
     zmq_assert (false);
 }
 
-zmq::socket_base_t *zmq::session_base_t::get_socket ()
+zmq::socket_base_t *zmq::session_base_t::get_socket () const
 {
     return _socket;
 }
@@ -380,7 +400,7 @@ int zmq::session_base_t::zap_connect ()
     return 0;
 }
 
-bool zmq::session_base_t::zap_enabled ()
+bool zmq::session_base_t::zap_enabled () const
 {
     return (options.mechanism != ZMQ_NULL || !options.zap_domain.empty ());
 }
@@ -388,7 +408,18 @@ bool zmq::session_base_t::zap_enabled ()
 void zmq::session_base_t::process_attach (i_engine *engine_)
 {
     zmq_assert (engine_ != NULL);
+    zmq_assert (!_engine);
+    _engine = engine_;
+
+    if (!engine_->has_handshake_stage ())
+        engine_ready ();
+
+    //  Plug in the engine.
+    _engine->plug (_io_thread, this);
+}
 
+void zmq::session_base_t::engine_ready ()
+{
     //  Create the pipe if it does not exist yet.
     if (!_pipe && !is_terminating ()) {
         object_t *parents[2] = {this, _socket};
@@ -399,7 +430,7 @@ void zmq::session_base_t::process_attach
         int hwms[2] = {conflate ? -1 : options.rcvhwm,
                        conflate ? -1 : options.sndhwm};
         bool conflates[2] = {conflate, conflate};
-        int rc = pipepair (parents, pipes, hwms, conflates);
+        const int rc = pipepair (parents, pipes, hwms, conflates);
         errno_assert (rc == 0);
 
         //  Plug the local end of the pipe.
@@ -411,43 +442,48 @@ void zmq::session_base_t::process_attach
 
         //  The endpoints strings are not set on bind, set them here so that
         //  events can use them.
-        pipes[0]->set_endpoint_pair (engine_->get_endpoint ());
-        pipes[1]->set_endpoint_pair (engine_->get_endpoint ());
+        pipes[0]->set_endpoint_pair (_engine->get_endpoint ());
+        pipes[1]->set_endpoint_pair (_engine->get_endpoint ());
 
         //  Ask socket to plug into the remote end of the pipe.
         send_bind (_socket, pipes[1]);
     }
-
-    //  Plug in the engine.
-    zmq_assert (!_engine);
-    _engine = engine_;
-    _engine->plug (_io_thread, this);
 }
 
-void zmq::session_base_t::engine_error (
-  zmq::stream_engine_t::error_reason_t reason_)
+void zmq::session_base_t::engine_error (bool handshaked_,
+                                        zmq::i_engine::error_reason_t reason_)
 {
     //  Engine is dead. Let's forget about it.
     _engine = NULL;
 
     //  Remove any half-done messages from the pipes.
-    if (_pipe)
+    if (_pipe) {
         clean_pipes ();
 
-    zmq_assert (reason_ == stream_engine_t::connection_error
-                || reason_ == stream_engine_t::timeout_error
-                || reason_ == stream_engine_t::protocol_error);
+#ifdef ZMQ_BUILD_DRAFT_API
+        //  Only send disconnect message if socket was accepted and handshake was completed
+        if (!_active && handshaked_ && options.can_recv_disconnect_msg
+            && !options.disconnect_msg.empty ()) {
+            _pipe->set_disconnect_msg (options.disconnect_msg);
+            _pipe->send_disconnect_msg ();
+        }
+#endif
+    }
+
+    zmq_assert (reason_ == i_engine::connection_error
+                || reason_ == i_engine::timeout_error
+                || reason_ == i_engine::protocol_error);
 
     switch (reason_) {
-        case stream_engine_t::timeout_error:
+        case i_engine::timeout_error:
             /* FALLTHROUGH */
-        case stream_engine_t::connection_error:
+        case i_engine::connection_error:
             if (_active) {
                 reconnect ();
                 break;
             }
-            /* FALLTHROUGH */
-        case stream_engine_t::protocol_error:
+
+        case i_engine::protocol_error:
             if (_pending) {
                 if (_pipe)
                     _pipe->terminate (false);
@@ -518,12 +554,25 @@ void zmq::session_base_t::timer_event (i
     _pipe->terminate (false);
 }
 
+void zmq::session_base_t::process_conn_failed ()
+{
+    std::string *ep = new (std::string);
+    _addr->to_string (*ep);
+    send_term_endpoint (_socket, ep);
+}
+
 void zmq::session_base_t::reconnect ()
 {
     //  For delayed connect situations, terminate the pipe
     //  and reestablish later on
-    if (_pipe && options.immediate == 1 && _addr->protocol != "pgm"
-        && _addr->protocol != "epgm" && _addr->protocol != "norm"
+    if (_pipe && options.immediate == 1
+#ifdef ZMQ_HAVE_OPENPGM
+        && _addr->protocol != protocol_name::pgm
+        && _addr->protocol != protocol_name::epgm
+#endif
+#ifdef ZMQ_HAVE_NORM
+        && _addr->protocol != protocol_name::norm
+#endif
         && _addr->protocol != protocol_name::udp) {
         _pipe->hiccup ();
         _pipe->terminate (false);
@@ -539,7 +588,7 @@ void zmq::session_base_t::reconnect ()
     reset ();
 
     //  Reconnect.
-    if (options.reconnect_ivl != -1)
+    if (options.reconnect_ivl > 0)
         start_connecting (true);
     else {
         std::string *ep = new (std::string);
@@ -555,54 +604,6 @@ void zmq::session_base_t::reconnect ()
         _pipe->hiccup ();
 }
 
-zmq::session_base_t::connecter_factory_entry_t
-  zmq::session_base_t::_connecter_factories[] = {
-    connecter_factory_entry_t (protocol_name::tcp,
-                               &zmq::session_base_t::create_connecter_tcp),
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
-    connecter_factory_entry_t (protocol_name::ipc,
-                               &zmq::session_base_t::create_connecter_ipc),
-#endif
-#if defined ZMQ_HAVE_TIPC
-    connecter_factory_entry_t (protocol_name::tipc,
-                               &zmq::session_base_t::create_connecter_tipc),
-#endif
-#if defined ZMQ_HAVE_VMCI
-    connecter_factory_entry_t (protocol_name::vmci,
-                               &zmq::session_base_t::create_connecter_vmci),
-#endif
-};
-
-zmq::session_base_t::connecter_factory_map_t
-  zmq::session_base_t::_connecter_factories_map (
-    _connecter_factories,
-    _connecter_factories
-      + sizeof (_connecter_factories) / sizeof (_connecter_factories[0]));
-
-zmq::session_base_t::start_connecting_entry_t
-  zmq::session_base_t::_start_connecting_entries[] = {
-    start_connecting_entry_t (protocol_name::udp,
-                              &zmq::session_base_t::start_connecting_udp),
-#if defined ZMQ_HAVE_OPENPGM
-    start_connecting_entry_t ("pgm",
-                              &zmq::session_base_t::start_connecting_pgm),
-    start_connecting_entry_t ("epgm",
-                              &zmq::session_base_t::start_connecting_pgm),
-#endif
-#if defined ZMQ_HAVE_NORM
-    start_connecting_entry_t ("norm",
-                              &zmq::session_base_t::start_connecting_norm),
-#endif
-};
-
-zmq::session_base_t::start_connecting_map_t
-  zmq::session_base_t::_start_connecting_map (
-    _start_connecting_entries,
-    _start_connecting_entries
-      + sizeof (_start_connecting_entries)
-          / sizeof (_start_connecting_entries[0]));
-
 void zmq::session_base_t::start_connecting (bool wait_)
 {
     zmq_assert (_active);
@@ -613,155 +614,198 @@ void zmq::session_base_t::start_connecti
     zmq_assert (io_thread);
 
     //  Create the connecter object.
-    const connecter_factory_map_t::const_iterator connecter_factories_it =
-      _connecter_factories_map.find (_addr->protocol);
-    if (connecter_factories_it != _connecter_factories_map.end ()) {
-        own_t *connecter =
-          (this->*connecter_factories_it->second) (io_thread, wait_);
-
-        alloc_assert (connecter);
-        launch_child (connecter);
-        return;
+    own_t *connecter = NULL;
+    if (_addr->protocol == protocol_name::tcp) {
+        if (!options.socks_proxy_address.empty ()) {
+            address_t *proxy_address = new (std::nothrow)
+              address_t (protocol_name::tcp, options.socks_proxy_address,
+                         this->get_ctx ());
+            alloc_assert (proxy_address);
+            connecter = new (std::nothrow) socks_connecter_t (
+              io_thread, this, options, _addr, proxy_address, wait_);
+            alloc_assert (connecter);
+            if (!options.socks_proxy_username.empty ()) {
+                reinterpret_cast<socks_connecter_t *> (connecter)
+                  ->set_auth_method_basic (options.socks_proxy_username,
+                                           options.socks_proxy_password);
+            }
+        } else {
+            connecter = new (std::nothrow)
+              tcp_connecter_t (io_thread, this, options, _addr, wait_);
+        }
     }
-    const start_connecting_map_t::const_iterator start_connecting_it =
-      _start_connecting_map.find (_addr->protocol);
-    if (start_connecting_it != _start_connecting_map.end ()) {
-        (this->*start_connecting_it->second) (io_thread);
-        return;
+#if defined ZMQ_HAVE_IPC
+    else if (_addr->protocol == protocol_name::ipc) {
+        connecter = new (std::nothrow)
+          ipc_connecter_t (io_thread, this, options, _addr, wait_);
     }
-
-    zmq_assert (false);
-}
-
-#if defined ZMQ_HAVE_VMCI
-zmq::own_t *zmq::session_base_t::create_connecter_vmci (io_thread_t *io_thread_,
-                                                        bool wait_)
-{
-    return new (std::nothrow)
-      vmci_connecter_t (io_thread_, this, options, _addr, wait_);
-}
 #endif
-
 #if defined ZMQ_HAVE_TIPC
-zmq::own_t *zmq::session_base_t::create_connecter_tipc (io_thread_t *io_thread_,
-                                                        bool wait_)
-{
-    return new (std::nothrow)
-      tipc_connecter_t (io_thread_, this, options, _addr, wait_);
-}
+    else if (_addr->protocol == protocol_name::tipc) {
+        connecter = new (std::nothrow)
+          tipc_connecter_t (io_thread, this, options, _addr, wait_);
+    }
 #endif
-
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
-zmq::own_t *zmq::session_base_t::create_connecter_ipc (io_thread_t *io_thread_,
-                                                       bool wait_)
-{
-    return new (std::nothrow)
-      ipc_connecter_t (io_thread_, this, options, _addr, wait_);
-}
+#if defined ZMQ_HAVE_VMCI
+    else if (_addr->protocol == protocol_name::vmci) {
+        connecter = new (std::nothrow)
+          vmci_connecter_t (io_thread, this, options, _addr, wait_);
+    }
 #endif
-
-zmq::own_t *zmq::session_base_t::create_connecter_tcp (io_thread_t *io_thread_,
-                                                       bool wait_)
-{
-    if (!options.socks_proxy_address.empty ()) {
-        address_t *proxy_address = new (std::nothrow) address_t (
-          protocol_name::tcp, options.socks_proxy_address, this->get_ctx ());
-        alloc_assert (proxy_address);
-        socks_connecter_t *connecter = new (std::nothrow) socks_connecter_t (
-          io_thread_, this, options, _addr, proxy_address, wait_);
+#if defined ZMQ_HAVE_WS
+    else if (_addr->protocol == protocol_name::ws) {
+        connecter = new (std::nothrow) ws_connecter_t (
+          io_thread, this, options, _addr, wait_, false, std::string ());
+    }
+#endif
+#if defined ZMQ_HAVE_WSS
+    else if (_addr->protocol == protocol_name::wss) {
+        connecter = new (std::nothrow) ws_connecter_t (
+          io_thread, this, options, _addr, wait_, true, _wss_hostname);
+    }
+#endif
+    if (connecter != NULL) {
         alloc_assert (connecter);
-        if (!options.socks_proxy_username.empty ()) {
-            connecter->set_auth_method_basic (options.socks_proxy_username,
-                                              options.socks_proxy_password);
-        }
-        return connecter;
+        launch_child (connecter);
+        return;
     }
-    return new (std::nothrow)
-      tcp_connecter_t (io_thread_, this, options, _addr, wait_);
-}
 
-#ifdef ZMQ_HAVE_OPENPGM
-void zmq::session_base_t::start_connecting_pgm (io_thread_t *io_thread_)
-{
-    zmq_assert (options.type == ZMQ_PUB || options.type == ZMQ_XPUB
-                || options.type == ZMQ_SUB || options.type == ZMQ_XSUB);
+    if (_addr->protocol == protocol_name::udp) {
+        zmq_assert (options.type == ZMQ_DISH || options.type == ZMQ_RADIO
+                    || options.type == ZMQ_DGRAM);
+
+        udp_engine_t *engine = new (std::nothrow) udp_engine_t (options);
+        alloc_assert (engine);
+
+        bool recv = false;
+        bool send = false;
+
+        if (options.type == ZMQ_RADIO) {
+            send = true;
+            recv = false;
+        } else if (options.type == ZMQ_DISH) {
+            send = false;
+            recv = true;
+        } else if (options.type == ZMQ_DGRAM) {
+            send = true;
+            recv = true;
+        }
 
-    //  For EPGM transport with UDP encapsulation of PGM is used.
-    bool const udp_encapsulation = _addr->protocol == "epgm";
+        int rc = engine->init (_addr, send, recv);
+        errno_assert (rc == 0);
 
-    //  At this point we'll create message pipes to the session straight
-    //  away. There's no point in delaying it as no concept of 'connect'
-    //  exists with PGM anyway.
-    if (options.type == ZMQ_PUB || options.type == ZMQ_XPUB) {
-        //  PGM sender.
-        pgm_sender_t *pgm_sender =
-          new (std::nothrow) pgm_sender_t (io_thread_, options);
-        alloc_assert (pgm_sender);
+        send_attach (this, engine);
 
-        int rc = pgm_sender->init (udp_encapsulation, _addr->address.c_str ());
-        errno_assert (rc == 0);
+        return;
+    }
 
-        send_attach (this, pgm_sender);
-    } else {
-        //  PGM receiver.
-        pgm_receiver_t *pgm_receiver =
-          new (std::nothrow) pgm_receiver_t (io_thread_, options);
-        alloc_assert (pgm_receiver);
+#ifdef ZMQ_HAVE_OPENPGM
 
-        int rc =
-          pgm_receiver->init (udp_encapsulation, _addr->address.c_str ());
-        errno_assert (rc == 0);
+    //  Both PGM and EPGM transports are using the same infrastructure.
+    if (_addr->protocol == "pgm" || _addr->protocol == "epgm") {
+        zmq_assert (options.type == ZMQ_PUB || options.type == ZMQ_XPUB
+                    || options.type == ZMQ_SUB || options.type == ZMQ_XSUB);
+
+        //  For EPGM transport with UDP encapsulation of PGM is used.
+        bool const udp_encapsulation = _addr->protocol == "epgm";
+
+        //  At this point we'll create message pipes to the session straight
+        //  away. There's no point in delaying it as no concept of 'connect'
+        //  exists with PGM anyway.
+        if (options.type == ZMQ_PUB || options.type == ZMQ_XPUB) {
+            //  PGM sender.
+            pgm_sender_t *pgm_sender =
+              new (std::nothrow) pgm_sender_t (io_thread, options);
+            alloc_assert (pgm_sender);
+
+            int rc =
+              pgm_sender->init (udp_encapsulation, _addr->address.c_str ());
+            errno_assert (rc == 0);
+
+            send_attach (this, pgm_sender);
+        } else {
+            //  PGM receiver.
+            pgm_receiver_t *pgm_receiver =
+              new (std::nothrow) pgm_receiver_t (io_thread, options);
+            alloc_assert (pgm_receiver);
+
+            int rc =
+              pgm_receiver->init (udp_encapsulation, _addr->address.c_str ());
+            errno_assert (rc == 0);
+
+            send_attach (this, pgm_receiver);
+        }
 
-        send_attach (this, pgm_receiver);
+        return;
     }
-}
 #endif
 
 #ifdef ZMQ_HAVE_NORM
-void zmq::session_base_t::start_connecting_norm (io_thread_t *io_thread_)
-{
-    //  At this point we'll create message pipes to the session straight
-    //  away. There's no point in delaying it as no concept of 'connect'
-    //  exists with NORM anyway.
-    if (options.type == ZMQ_PUB || options.type == ZMQ_XPUB) {
-        //  NORM sender.
-        norm_engine_t *norm_sender =
-          new (std::nothrow) norm_engine_t (io_thread_, options);
-        alloc_assert (norm_sender);
+    if (_addr->protocol == "norm") {
+        //  At this point we'll create message pipes to the session straight
+        //  away. There's no point in delaying it as no concept of 'connect'
+        //  exists with NORM anyway.
+        if (options.type == ZMQ_PUB || options.type == ZMQ_XPUB) {
+            //  NORM sender.
+            norm_engine_t *norm_sender =
+              new (std::nothrow) norm_engine_t (io_thread, options);
+            alloc_assert (norm_sender);
+
+            int rc = norm_sender->init (_addr->address.c_str (), true, false);
+            errno_assert (rc == 0);
+
+            send_attach (this, norm_sender);
+        } else { // ZMQ_SUB or ZMQ_XSUB
+
+            //  NORM receiver.
+            norm_engine_t *norm_receiver =
+              new (std::nothrow) norm_engine_t (io_thread, options);
+            alloc_assert (norm_receiver);
 
-        int rc = norm_sender->init (_addr->address.c_str (), true, false);
-        errno_assert (rc == 0);
+            int rc = norm_receiver->init (_addr->address.c_str (), false, true);
+            errno_assert (rc == 0);
 
-        send_attach (this, norm_sender);
-    } else { // ZMQ_SUB or ZMQ_XSUB
+            send_attach (this, norm_receiver);
+        }
+        return;
+    }
+#endif // ZMQ_HAVE_NORM
 
-        //  NORM receiver.
-        norm_engine_t *norm_receiver =
-          new (std::nothrow) norm_engine_t (io_thread_, options);
-        alloc_assert (norm_receiver);
+    zmq_assert (false);
+}
 
-        int rc = norm_receiver->init (_addr->address.c_str (), false, true);
-        errno_assert (rc == 0);
+zmq::hello_msg_session_t::hello_msg_session_t (io_thread_t *io_thread_,
+                                               bool connect_,
+                                               socket_base_t *socket_,
+                                               const options_t &options_,
+                                               address_t *addr_) :
+    session_base_t (io_thread_, connect_, socket_, options_, addr_),
+    _new_pipe (true)
+{
+}
 
-        send_attach (this, norm_receiver);
-    }
+zmq::hello_msg_session_t::~hello_msg_session_t ()
+{
 }
-#endif
 
-void zmq::session_base_t::start_connecting_udp (io_thread_t * /*io_thread_*/)
+
+int zmq::hello_msg_session_t::pull_msg (msg_t *msg_)
 {
-    zmq_assert (options.type == ZMQ_DISH || options.type == ZMQ_RADIO
-                || options.type == ZMQ_DGRAM);
+    if (_new_pipe) {
+        _new_pipe = false;
 
-    udp_engine_t *engine = new (std::nothrow) udp_engine_t (options);
-    alloc_assert (engine);
+        const int rc =
+          msg_->init_buffer (&options.hello_msg[0], options.hello_msg.size ());
+        errno_assert (rc == 0);
 
-    const bool recv = options.type == ZMQ_DISH || options.type == ZMQ_DGRAM;
-    const bool send = options.type == ZMQ_RADIO || options.type == ZMQ_DGRAM;
+        return 0;
+    }
 
-    const int rc = engine->init (_addr, send, recv);
-    errno_assert (rc == 0);
+    return session_base_t::pull_msg (msg_);
+}
 
-    send_attach (this, engine);
+void zmq::hello_msg_session_t::reset ()
+{
+    session_base_t::reset ();
+    _new_pipe = true;
 }
diff -pruN 4.3.2-2/src/session_base.hpp 4.3.3-1/src/session_base.hpp
--- 4.3.2-2/src/session_base.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/session_base.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,7 +36,8 @@
 #include "io_object.hpp"
 #include "pipe.hpp"
 #include "socket_base.hpp"
-#include "stream_engine.hpp"
+#include "i_engine.hpp"
+#include "msg.hpp"
 
 namespace zmq
 {
@@ -61,20 +62,21 @@ class session_base_t : public own_t, pub
     virtual void reset ();
     void flush ();
     void rollback ();
-    void engine_error (zmq::stream_engine_t::error_reason_t reason_);
+    void engine_error (bool handshaked_, zmq::i_engine::error_reason_t reason_);
+    void engine_ready ();
 
     //  i_pipe_events interface implementation.
-    void read_activated (zmq::pipe_t *pipe_);
-    void write_activated (zmq::pipe_t *pipe_);
-    void hiccuped (zmq::pipe_t *pipe_);
-    void pipe_terminated (zmq::pipe_t *pipe_);
+    void read_activated (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    void write_activated (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    void hiccuped (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    void pipe_terminated (zmq::pipe_t *pipe_) ZMQ_FINAL;
 
     //  Delivers a message. Returns 0 if successful; -1 otherwise.
     //  The function takes ownership of the message.
     virtual int push_msg (msg_t *msg_);
 
     int zap_connect ();
-    bool zap_enabled ();
+    bool zap_enabled () const;
 
     //  Fetches a message. Returns 0 if successful; -1 otherwise.
     //  The caller is responsible for freeing the message when no
@@ -91,7 +93,7 @@ class session_base_t : public own_t, pub
     //  The function takes ownership of the message.
     int write_zap_msg (msg_t *msg_);
 
-    socket_base_t *get_socket ();
+    socket_base_t *get_socket () const;
     const endpoint_uri_pair_t &get_endpoint () const;
 
   protected:
@@ -100,47 +102,21 @@ class session_base_t : public own_t, pub
                     zmq::socket_base_t *socket_,
                     const options_t &options_,
                     address_t *addr_);
-    virtual ~session_base_t ();
+    ~session_base_t () ZMQ_OVERRIDE;
 
   private:
     void start_connecting (bool wait_);
 
-    typedef own_t *(session_base_t::*connecter_factory_fun_t) (
-      io_thread_t *io_thread, bool wait_);
-    typedef std::pair<const std::string, connecter_factory_fun_t>
-      connecter_factory_entry_t;
-    static connecter_factory_entry_t _connecter_factories[];
-    typedef std::map<std::string, connecter_factory_fun_t>
-      connecter_factory_map_t;
-    static connecter_factory_map_t _connecter_factories_map;
-
-    own_t *create_connecter_vmci (io_thread_t *io_thread_, bool wait_);
-    own_t *create_connecter_tipc (io_thread_t *io_thread_, bool wait_);
-    own_t *create_connecter_ipc (io_thread_t *io_thread_, bool wait_);
-    own_t *create_connecter_tcp (io_thread_t *io_thread_, bool wait_);
-
-    typedef void (session_base_t::*start_connecting_fun_t) (
-      io_thread_t *io_thread);
-    typedef std::pair<const std::string, start_connecting_fun_t>
-      start_connecting_entry_t;
-    static start_connecting_entry_t _start_connecting_entries[];
-    typedef std::map<std::string, start_connecting_fun_t>
-      start_connecting_map_t;
-    static start_connecting_map_t _start_connecting_map;
-
-    void start_connecting_pgm (io_thread_t *io_thread_);
-    void start_connecting_norm (io_thread_t *io_thread_);
-    void start_connecting_udp (io_thread_t *io_thread_);
-
     void reconnect ();
 
     //  Handlers for incoming commands.
-    void process_plug ();
-    void process_attach (zmq::i_engine *engine_);
-    void process_term (int linger_);
+    void process_plug () ZMQ_FINAL;
+    void process_attach (zmq::i_engine *engine_) ZMQ_FINAL;
+    void process_term (int linger_) ZMQ_FINAL;
+    void process_conn_failed ();
 
     //  i_poll_events handlers.
-    void timer_event (int id_);
+    void timer_event (int id_) ZMQ_FINAL;
 
     //  Remove any half processed messages. Flush unflushed messages.
     //  Call this function when engine disconnect to get rid of leftovers.
@@ -189,8 +165,33 @@ class session_base_t : public own_t, pub
     //  Protocol and address to use when connecting.
     address_t *_addr;
 
-    session_base_t (const session_base_t &);
-    const session_base_t &operator= (const session_base_t &);
+#ifdef ZMQ_HAVE_WSS
+    //  TLS handshake, we need to take a copy when the session is created,
+    //  in order to maintain the value at the creation time
+    const std::string _wss_hostname;
+#endif
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (session_base_t)
+};
+
+class hello_msg_session_t ZMQ_FINAL : public session_base_t
+{
+  public:
+    hello_msg_session_t (zmq::io_thread_t *io_thread_,
+                         bool connect_,
+                         zmq::socket_base_t *socket_,
+                         const options_t &options_,
+                         address_t *addr_);
+    ~hello_msg_session_t ();
+
+    //  Overrides of the functions from session_base_t.
+    int pull_msg (msg_t *msg_);
+    void reset ();
+
+  private:
+    bool _new_pipe;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (hello_msg_session_t)
 };
 }
 
diff -pruN 4.3.2-2/src/signaler.cpp 4.3.3-1/src/signaler.cpp
--- 4.3.2-2/src/signaler.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/signaler.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -183,10 +183,14 @@ void zmq::signaler_t::send ()
     ssize_t sz = write (_w, &inc, sizeof (inc));
     errno_assert (sz == sizeof (inc));
 #elif defined ZMQ_HAVE_WINDOWS
-    unsigned char dummy = 0;
-    const int nbytes =
-      ::send (_w, reinterpret_cast<char *> (&dummy), sizeof (dummy), 0);
-    wsa_assert (nbytes != SOCKET_ERROR);
+    const char dummy = 0;
+    int nbytes;
+    do {
+        nbytes = ::send (_w, &dummy, sizeof (dummy), 0);
+        wsa_assert (nbytes != SOCKET_ERROR);
+        // wsa_assert does not abort on WSAEWOULDBLOCK. If we get this, we retry.
+    } while (nbytes == SOCKET_ERROR);
+    // Given the small size of dummy (should be 1) expect that send was able to send everything.
     zmq_assert (nbytes == sizeof (dummy));
 #elif defined ZMQ_HAVE_VXWORKS
     unsigned char dummy = 0;
@@ -223,7 +227,7 @@ void zmq::signaler_t::send ()
 #endif
 }
 
-int zmq::signaler_t::wait (int timeout_)
+int zmq::signaler_t::wait (int timeout_) const
 {
 #ifdef HAVE_FORK
     if (unlikely (pid != getpid ())) {
diff -pruN 4.3.2-2/src/signaler.hpp 4.3.3-1/src/signaler.hpp
--- 4.3.2-2/src/signaler.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/signaler.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -35,6 +35,7 @@
 #endif
 
 #include "fd.hpp"
+#include "macros.hpp"
 
 namespace zmq
 {
@@ -53,7 +54,7 @@ class signaler_t
     // May return retired_fd if the signaler could not be initialized.
     fd_t get_fd () const;
     void send ();
-    int wait (int timeout_);
+    int wait (int timeout_) const;
     void recv ();
     int recv_failable ();
 
@@ -72,10 +73,6 @@ class signaler_t
     fd_t _w;
     fd_t _r;
 
-    //  Disable copying of signaler_t object.
-    signaler_t (const signaler_t &);
-    const signaler_t &operator= (const signaler_t &);
-
 #ifdef HAVE_FORK
     // the process that created this context. Used to detect forking.
     pid_t pid;
@@ -83,6 +80,8 @@ class signaler_t
     // and forked().
     void close_internal ();
 #endif
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (signaler_t)
 };
 }
 
diff -pruN 4.3.2-2/src/socket_base.cpp 4.3.3-1/src/socket_base.cpp
--- 4.3.2-2/src/socket_base.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/socket_base.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -50,9 +50,13 @@
 
 #include "socket_base.hpp"
 #include "tcp_listener.hpp"
+#include "ws_listener.hpp"
 #include "ipc_listener.hpp"
 #include "tipc_listener.hpp"
 #include "tcp_connecter.hpp"
+#ifdef ZMQ_HAVE_WS
+#include "ws_address.hpp"
+#endif
 #include "io_thread.hpp"
 #include "session_base.hpp"
 #include "config.hpp"
@@ -69,6 +73,9 @@
 #include "mailbox.hpp"
 #include "mailbox_safe.hpp"
 
+#ifdef ZMQ_HAVE_WSS
+#include "wss_address.hpp"
+#endif
 #if defined ZMQ_HAVE_VMCI
 #include "vmci_address.hpp"
 #include "vmci_listener.hpp"
@@ -97,6 +104,8 @@
 #include "gather.hpp"
 #include "scatter.hpp"
 #include "dgram.hpp"
+#include "peer.hpp"
+#include "channel.hpp"
 
 void zmq::socket_base_t::inprocs_t::emplace (const char *endpoint_uri_,
                                              pipe_t *pipe_)
@@ -114,13 +123,15 @@ int zmq::socket_base_t::inprocs_t::erase
         return -1;
     }
 
-    for (map_t::iterator it = range.first; it != range.second; ++it)
+    for (map_t::iterator it = range.first; it != range.second; ++it) {
+        it->second->send_disconnect_msg ();
         it->second->terminate (true);
+    }
     _inprocs.erase (range.first, range.second);
     return 0;
 }
 
-void zmq::socket_base_t::inprocs_t::erase_pipe (pipe_t *pipe_)
+void zmq::socket_base_t::inprocs_t::erase_pipe (const pipe_t *pipe_)
 {
     for (map_t::iterator it = _inprocs.begin (), end = _inprocs.end ();
          it != end; ++it)
@@ -204,6 +215,12 @@ zmq::socket_base_t *zmq::socket_base_t::
         case ZMQ_DGRAM:
             s = new (std::nothrow) dgram_t (parent_, tid_, sid_);
             break;
+        case ZMQ_PEER:
+            s = new (std::nothrow) peer_t (parent_, tid_, sid_);
+            break;
+        case ZMQ_CHANNEL:
+            s = new (std::nothrow) channel_t (parent_, tid_, sid_);
+            break;
         default:
             errno = EINVAL;
             return NULL;
@@ -225,6 +242,7 @@ zmq::socket_base_t::socket_base_t (ctx_t
                                    int sid_,
                                    bool thread_safe_) :
     own_t (parent_, tid_),
+    _sync (),
     _tag (0xbaddecaf),
     _ctx_terminated (false),
     _destroyed (false),
@@ -237,7 +255,6 @@ zmq::socket_base_t::socket_base_t (ctx_t
     _monitor_events (0),
     _thread_safe (thread_safe_),
     _reaper_signaler (NULL),
-    _sync (),
     _monitor_sync ()
 {
     options.socket_id = sid_;
@@ -308,7 +325,7 @@ int zmq::socket_base_t::parse_uri (const
 {
     zmq_assert (uri_ != NULL);
 
-    std::string uri (uri_);
+    const std::string uri (uri_);
     const std::string::size_type pos = uri.find ("://");
     if (pos == std::string::npos) {
         errno = EINVAL;
@@ -328,22 +345,27 @@ int zmq::socket_base_t::check_protocol (
 {
     //  First check out whether the protocol is something we are aware of.
     if (protocol_ != protocol_name::inproc
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#if defined ZMQ_HAVE_IPC
         && protocol_ != protocol_name::ipc
 #endif
         && protocol_ != protocol_name::tcp
+#ifdef ZMQ_HAVE_WS
+        && protocol_ != protocol_name::ws
+#endif
+#ifdef ZMQ_HAVE_WSS
+        && protocol_ != protocol_name::wss
+#endif
 #if defined ZMQ_HAVE_OPENPGM
         //  pgm/epgm transports only available if 0MQ is compiled with OpenPGM.
-        && protocol_ != "pgm"
-        && protocol_ != "epgm"
+        && protocol_ != protocol_name::pgm
+        && protocol_ != protocol_name::epgm
 #endif
 #if defined ZMQ_HAVE_TIPC
         // TIPC transport is only available on Linux.
         && protocol_ != protocol_name::tipc
 #endif
 #if defined ZMQ_HAVE_NORM
-        && protocol_ != "norm"
+        && protocol_ != protocol_name::norm
 #endif
 #if defined ZMQ_HAVE_VMCI
         && protocol_ != protocol_name::vmci
@@ -357,7 +379,14 @@ int zmq::socket_base_t::check_protocol (
     //  Specifically, multicast protocols can't be combined with
     //  bi-directional messaging patterns (socket types).
 #if defined ZMQ_HAVE_OPENPGM || defined ZMQ_HAVE_NORM
-    if ((protocol_ == "pgm" || protocol_ == "epgm" || protocol_ == "norm")
+#if defined ZMQ_HAVE_OPENPGM && defined ZMQ_HAVE_NORM
+    if ((protocol_ == protocol_name::pgm || protocol_ == protocol_name::epgm
+         || protocol_ == protocol_name::norm)
+#elif defined ZMQ_HAVE_OPENPGM
+    if ((protocol_ == protocol_name::pgm || protocol_ == protocol_name::epgm)
+#else // defined ZMQ_HAVE_NORM
+    if (protocol_ == protocol_name::norm
+#endif
         && options.type != ZMQ_PUB && options.type != ZMQ_SUB
         && options.type != ZMQ_XPUB && options.type != ZMQ_XSUB) {
         errno = ENOCOMPATPROTO;
@@ -534,7 +563,15 @@ int zmq::socket_base_t::bind (const char
         return rc;
     }
 
-    if (protocol == "pgm" || protocol == "epgm" || protocol == "norm") {
+#if defined ZMQ_HAVE_OPENPGM || defined ZMQ_HAVE_NORM
+#if defined ZMQ_HAVE_OPENPGM && defined ZMQ_HAVE_NORM
+    if (protocol == protocol_name::pgm || protocol == protocol_name::epgm
+        || protocol == protocol_name::norm) {
+#elif defined ZMQ_HAVE_OPENPGM
+    if (protocol == protocol_name::pgm || protocol == protocol_name::epgm) {
+#else // defined ZMQ_HAVE_NORM
+    if (protocol == protocol_name::norm) {
+#endif
         //  For convenience's sake, bind can be used interchangeable with
         //  connect for PGM, EPGM, NORM transports.
         rc = connect (endpoint_uri_);
@@ -542,6 +579,7 @@ int zmq::socket_base_t::bind (const char
             options.connected = true;
         return rc;
     }
+#endif
 
     if (protocol == protocol_name::udp) {
         if (!(options.type == ZMQ_DGRAM || options.type == ZMQ_DISH)) {
@@ -629,8 +667,36 @@ int zmq::socket_base_t::bind (const char
         return 0;
     }
 
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#ifdef ZMQ_HAVE_WS
+#ifdef ZMQ_HAVE_WSS
+    if (protocol == protocol_name::ws || protocol == protocol_name::wss) {
+        ws_listener_t *listener = new (std::nothrow) ws_listener_t (
+          io_thread, this, options, protocol == protocol_name::wss);
+#else
+    if (protocol == protocol_name::ws) {
+        ws_listener_t *listener =
+          new (std::nothrow) ws_listener_t (io_thread, this, options, false);
+#endif
+        alloc_assert (listener);
+        rc = listener->set_local_address (address.c_str ());
+        if (rc != 0) {
+            LIBZMQ_DELETE (listener);
+            event_bind_failed (make_unconnected_bind_endpoint_pair (address),
+                               zmq_errno ());
+            return -1;
+        }
+
+        // Save last endpoint URI
+        listener->get_local_address (_last_endpoint);
+
+        add_endpoint (make_unconnected_bind_endpoint_pair (_last_endpoint),
+                      static_cast<own_t *> (listener), NULL);
+        options.connected = true;
+        return 0;
+    }
+#endif
+
+#if defined ZMQ_HAVE_IPC
     if (protocol == protocol_name::ipc) {
         ipc_listener_t *listener =
           new (std::nothrow) ipc_listener_t (io_thread, this, options);
@@ -704,7 +770,11 @@ int zmq::socket_base_t::bind (const char
 int zmq::socket_base_t::connect (const char *endpoint_uri_)
 {
     scoped_optional_lock_t sync_lock (_thread_safe ? &_sync : NULL);
+    return connect_internal (endpoint_uri_);
+}
 
+int zmq::socket_base_t::connect_internal (const char *endpoint_uri_)
+{
     if (unlikely (_ctx_terminated)) {
         errno = ETERM;
         return -1;
@@ -769,6 +839,13 @@ int zmq::socket_base_t::connect (const c
             //  the peer doesn't expect it.
             send_routing_id (new_pipes[0], options);
 
+#ifdef ZMQ_BUILD_DRAFT_API
+            //  If set, send the hello msg of the local socket to the peer.
+            if (options.can_send_hello_msg && options.hello_msg.size () > 0) {
+                send_hello_msg (new_pipes[0], options);
+            }
+#endif
+
             const endpoint_t endpoint = {this, options};
             pend_connection (std::string (endpoint_uri_), endpoint, new_pipes);
         } else {
@@ -782,6 +859,23 @@ int zmq::socket_base_t::connect (const c
                 send_routing_id (new_pipes[1], peer.options);
             }
 
+#ifdef ZMQ_BUILD_DRAFT_API
+            //  If set, send the hello msg of the local socket to the peer.
+            if (options.can_send_hello_msg && options.hello_msg.size () > 0) {
+                send_hello_msg (new_pipes[0], options);
+            }
+
+            //  If set, send the hello msg of the peer to the local socket.
+            if (peer.options.can_send_hello_msg
+                && peer.options.hello_msg.size () > 0) {
+                send_hello_msg (new_pipes[1], peer.options);
+            }
+
+            if (peer.options.can_recv_disconnect_msg
+                && peer.options.disconnect_msg.size () > 0)
+                new_pipes[0]->set_disconnect_msg (peer.options.disconnect_msg);
+#endif
+
             //  Attach remote end of the pipe to the peer socket. Note that peer's
             //  seqnum was incremented in find_endpoint function. We don't need it
             //  increased here.
@@ -866,8 +960,33 @@ int zmq::socket_base_t::connect (const c
         //  Defer resolution until a socket is opened
         paddr->resolved.tcp_addr = NULL;
     }
-#if !defined ZMQ_HAVE_WINDOWS && !defined ZMQ_HAVE_OPENVMS                     \
-  && !defined ZMQ_HAVE_VXWORKS
+#ifdef ZMQ_HAVE_WS
+#ifdef ZMQ_HAVE_WSS
+    else if (protocol == protocol_name::ws || protocol == protocol_name::wss) {
+        if (protocol == protocol_name::wss) {
+            paddr->resolved.wss_addr = new (std::nothrow) wss_address_t ();
+            alloc_assert (paddr->resolved.wss_addr);
+            rc = paddr->resolved.wss_addr->resolve (address.c_str (), false,
+                                                    options.ipv6);
+        } else
+#else
+    else if (protocol == protocol_name::ws) {
+#endif
+        {
+            paddr->resolved.ws_addr = new (std::nothrow) ws_address_t ();
+            alloc_assert (paddr->resolved.ws_addr);
+            rc = paddr->resolved.ws_addr->resolve (address.c_str (), false,
+                                                   options.ipv6);
+        }
+
+        if (rc != 0) {
+            LIBZMQ_DELETE (paddr);
+            return -1;
+        }
+    }
+#endif
+
+#if defined ZMQ_HAVE_IPC
     else if (protocol == protocol_name::ipc) {
         paddr->resolved.ipc_addr = new (std::nothrow) ipc_address_t ();
         alloc_assert (paddr->resolved.ipc_addr);
@@ -899,7 +1018,7 @@ int zmq::socket_base_t::connect (const c
     // TBD - Should we check address for ZMQ_HAVE_NORM???
 
 #ifdef ZMQ_HAVE_OPENPGM
-    if (protocol == "pgm" || protocol == "epgm") {
+    if (protocol == protocol_name::pgm || protocol == protocol_name::epgm) {
         struct pgm_addrinfo_t *res = NULL;
         uint16_t port_number = 0;
         int rc =
@@ -920,8 +1039,9 @@ int zmq::socket_base_t::connect (const c
             LIBZMQ_DELETE (paddr);
             return -1;
         }
-        sockaddr_tipc *saddr =
-          (sockaddr_tipc *) paddr->resolved.tipc_addr->addr ();
+        const sockaddr_tipc *const saddr =
+          reinterpret_cast<const sockaddr_tipc *> (
+            paddr->resolved.tipc_addr->addr ());
         // Cannot connect to random Port Identity
         if (saddr->addrtype == TIPC_ADDR_ID
             && paddr->resolved.tipc_addr->is_random ()) {
@@ -951,9 +1071,20 @@ int zmq::socket_base_t::connect (const c
 
     //  PGM does not support subscription forwarding; ask for all data to be
     //  sent to this pipe. (same for NORM, currently?)
-    const bool subscribe_to_all = protocol == "pgm" || protocol == "epgm"
-                                  || protocol == "norm"
+#if defined ZMQ_HAVE_OPENPGM && defined ZMQ_HAVE_NORM
+    const bool subscribe_to_all =
+      protocol == protocol_name::pgm || protocol == protocol_name::epgm
+      || protocol == protocol_name::norm || protocol == protocol_name::udp;
+#elif defined ZMQ_HAVE_OPENPGM
+    const bool subscribe_to_all = protocol == protocol_name::pgm
+                                  || protocol == protocol_name::epgm
                                   || protocol == protocol_name::udp;
+#elif defined ZMQ_HAVE_NORM
+    const bool subscribe_to_all =
+      protocol == protocol_name::norm || protocol == protocol_name::udp;
+#else
+    const bool subscribe_to_all = protocol == protocol_name::udp;
+#endif
     pipe_t *newpipe = NULL;
 
     if (options.immediate != 1 || subscribe_to_all) {
@@ -1408,8 +1539,11 @@ void zmq::socket_base_t::process_term (i
     unregister_endpoints (this);
 
     //  Ask all attached pipes to terminate.
-    for (pipes_t::size_type i = 0; i != _pipes.size (); ++i)
+    for (pipes_t::size_type i = 0, size = _pipes.size (); i != size; ++i) {
+        //  Only inprocs might have a disconnect message set
+        _pipes[i]->send_disconnect_msg ();
         _pipes[i]->terminate (false);
+    }
     register_term_acks (static_cast<int> (_pipes.size ()));
 
     //  Continue the termination process immediately.
@@ -1454,7 +1588,7 @@ int zmq::socket_base_t::query_pipes_stat
         errno = EAGAIN;
         return -1;
     }
-    for (pipes_t::size_type i = 0; i != _pipes.size (); ++i) {
+    for (pipes_t::size_type i = 0, size = _pipes.size (); i != size; ++i) {
         _pipes[i]->send_stats_to_peer (this);
     }
 
@@ -1464,7 +1598,7 @@ int zmq::socket_base_t::query_pipes_stat
 void zmq::socket_base_t::update_pipe_options (int option_)
 {
     if (option_ == ZMQ_SNDHWM || option_ == ZMQ_RCVHWM) {
-        for (pipes_t::size_type i = 0; i != _pipes.size (); ++i) {
+        for (pipes_t::size_type i = 0, size = _pipes.size (); i != size; ++i) {
             _pipes[i]->set_hwms (options.rcvhwm, options.sndhwm);
             _pipes[i]->send_hwms_to_peer (options.sndhwm, options.rcvhwm);
         }
@@ -1627,7 +1761,7 @@ void zmq::socket_base_t::pipe_terminated
         unregister_term_ack ();
 }
 
-void zmq::socket_base_t::extract_flags (msg_t *msg_)
+void zmq::socket_base_t::extract_flags (const msg_t *msg_)
 {
     //  Test whether routing_id flag is valid for this socket type.
     if (unlikely (msg_->flags () & msg_t::routing_id))
@@ -1716,98 +1850,98 @@ int zmq::socket_base_t::monitor (const c
 void zmq::socket_base_t::event_connected (
   const endpoint_uri_pair_t &endpoint_uri_pair_, zmq::fd_t fd_)
 {
-    uint64_t values[1] = {(uint64_t) fd_};
+    uint64_t values[1] = {static_cast<uint64_t> (fd_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_CONNECTED);
 }
 
 void zmq::socket_base_t::event_connect_delayed (
   const endpoint_uri_pair_t &endpoint_uri_pair_, int err_)
 {
-    uint64_t values[1] = {(uint64_t) err_};
+    uint64_t values[1] = {static_cast<uint64_t> (err_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_CONNECT_DELAYED);
 }
 
 void zmq::socket_base_t::event_connect_retried (
   const endpoint_uri_pair_t &endpoint_uri_pair_, int interval_)
 {
-    uint64_t values[1] = {(uint64_t) interval_};
+    uint64_t values[1] = {static_cast<uint64_t> (interval_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_CONNECT_RETRIED);
 }
 
 void zmq::socket_base_t::event_listening (
   const endpoint_uri_pair_t &endpoint_uri_pair_, zmq::fd_t fd_)
 {
-    uint64_t values[1] = {(uint64_t) fd_};
+    uint64_t values[1] = {static_cast<uint64_t> (fd_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_LISTENING);
 }
 
 void zmq::socket_base_t::event_bind_failed (
   const endpoint_uri_pair_t &endpoint_uri_pair_, int err_)
 {
-    uint64_t values[1] = {(uint64_t) err_};
+    uint64_t values[1] = {static_cast<uint64_t> (err_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_BIND_FAILED);
 }
 
 void zmq::socket_base_t::event_accepted (
   const endpoint_uri_pair_t &endpoint_uri_pair_, zmq::fd_t fd_)
 {
-    uint64_t values[1] = {(uint64_t) fd_};
+    uint64_t values[1] = {static_cast<uint64_t> (fd_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_ACCEPTED);
 }
 
 void zmq::socket_base_t::event_accept_failed (
   const endpoint_uri_pair_t &endpoint_uri_pair_, int err_)
 {
-    uint64_t values[1] = {(uint64_t) err_};
+    uint64_t values[1] = {static_cast<uint64_t> (err_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_ACCEPT_FAILED);
 }
 
 void zmq::socket_base_t::event_closed (
   const endpoint_uri_pair_t &endpoint_uri_pair_, zmq::fd_t fd_)
 {
-    uint64_t values[1] = {(uint64_t) fd_};
+    uint64_t values[1] = {static_cast<uint64_t> (fd_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_CLOSED);
 }
 
 void zmq::socket_base_t::event_close_failed (
   const endpoint_uri_pair_t &endpoint_uri_pair_, int err_)
 {
-    uint64_t values[1] = {(uint64_t) err_};
+    uint64_t values[1] = {static_cast<uint64_t> (err_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_CLOSE_FAILED);
 }
 
 void zmq::socket_base_t::event_disconnected (
   const endpoint_uri_pair_t &endpoint_uri_pair_, zmq::fd_t fd_)
 {
-    uint64_t values[1] = {(uint64_t) fd_};
+    uint64_t values[1] = {static_cast<uint64_t> (fd_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_DISCONNECTED);
 }
 
 void zmq::socket_base_t::event_handshake_failed_no_detail (
   const endpoint_uri_pair_t &endpoint_uri_pair_, int err_)
 {
-    uint64_t values[1] = {(uint64_t) err_};
+    uint64_t values[1] = {static_cast<uint64_t> (err_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_HANDSHAKE_FAILED_NO_DETAIL);
 }
 
 void zmq::socket_base_t::event_handshake_failed_protocol (
   const endpoint_uri_pair_t &endpoint_uri_pair_, int err_)
 {
-    uint64_t values[1] = {(uint64_t) err_};
+    uint64_t values[1] = {static_cast<uint64_t> (err_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_HANDSHAKE_FAILED_PROTOCOL);
 }
 
 void zmq::socket_base_t::event_handshake_failed_auth (
   const endpoint_uri_pair_t &endpoint_uri_pair_, int err_)
 {
-    uint64_t values[1] = {(uint64_t) err_};
+    uint64_t values[1] = {static_cast<uint64_t> (err_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_HANDSHAKE_FAILED_AUTH);
 }
 
 void zmq::socket_base_t::event_handshake_succeeded (
   const endpoint_uri_pair_t &endpoint_uri_pair_, int err_)
 {
-    uint64_t values[1] = {(uint64_t) err_};
+    uint64_t values[1] = {static_cast<uint64_t> (err_)};
     event (endpoint_uri_pair_, values, 1, ZMQ_EVENT_HANDSHAKE_SUCCEEDED);
 }
 
@@ -1825,7 +1959,7 @@ void zmq::socket_base_t::event (const en
 //  Send a monitor event
 void zmq::socket_base_t::monitor_event (
   uint64_t event_,
-  uint64_t values_[],
+  const uint64_t values_[],
   uint64_t values_count_,
   const endpoint_uri_pair_t &endpoint_uri_pair_) const
 {
@@ -2005,7 +2139,7 @@ zmq::routing_socket_base_t::lookup_out_p
     return it == _out_pipes.end () ? NULL : &it->second;
 }
 
-void zmq::routing_socket_base_t::erase_out_pipe (pipe_t *pipe_)
+void zmq::routing_socket_base_t::erase_out_pipe (const pipe_t *pipe_)
 {
     const size_t erased = _out_pipes.erase (pipe_->get_routing_id ());
     zmq_assert (erased);
diff -pruN 4.3.2-2/src/socket_base.hpp 4.3.3-1/src/socket_base.hpp
--- 4.3.2-2/src/socket_base.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/socket_base.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -107,15 +107,15 @@ class socket_base_t : public own_t,
 
     //  i_poll_events implementation. This interface is used when socket
     //  is handled by the poller in the reaper thread.
-    void in_event ();
-    void out_event ();
-    void timer_event (int id_);
+    void in_event () ZMQ_FINAL;
+    void out_event () ZMQ_FINAL;
+    void timer_event (int id_) ZMQ_FINAL;
 
     //  i_pipe_events interface implementation.
-    void read_activated (pipe_t *pipe_);
-    void write_activated (pipe_t *pipe_);
-    void hiccuped (pipe_t *pipe_);
-    void pipe_terminated (pipe_t *pipe_);
+    void read_activated (pipe_t *pipe_) ZMQ_FINAL;
+    void write_activated (pipe_t *pipe_) ZMQ_FINAL;
+    void hiccuped (pipe_t *pipe_) ZMQ_FINAL;
+    void pipe_terminated (pipe_t *pipe_) ZMQ_FINAL;
     void lock ();
     void unlock ();
 
@@ -170,7 +170,7 @@ class socket_base_t : public own_t,
                    uint32_t tid_,
                    int sid_,
                    bool thread_safe_ = false);
-    virtual ~socket_base_t ();
+    ~socket_base_t () ZMQ_OVERRIDE;
 
     //  Concrete algorithms for the x- methods are to be defined by
     //  individual socket types.
@@ -179,7 +179,7 @@ class socket_base_t : public own_t,
                                bool locally_initiated_ = false) = 0;
 
     //  The default implementation assumes there are no specific socket
-    //  options for the particular socket type. If not so, override this
+    //  options for the particular socket type. If not so, ZMQ_FINAL this
     //  method.
     virtual int
     xsetsockopt (int option_, const void *optval_, size_t optvallen_);
@@ -203,7 +203,12 @@ class socket_base_t : public own_t,
     virtual int xleave (const char *group_);
 
     //  Delay actual destruction of the socket.
-    void process_destroy ();
+    void process_destroy () ZMQ_FINAL;
+
+    int connect_internal (const char *endpoint_uri_);
+
+    // Mutex for synchronize access to the socket in thread safe mode
+    mutex_t _sync;
 
   private:
     // test if event should be sent and then dispatch it
@@ -214,7 +219,7 @@ class socket_base_t : public own_t,
 
     // Socket event data dispatch
     void monitor_event (uint64_t event_,
-                        uint64_t values_[],
+                        const uint64_t values_[],
                         uint64_t values_count_,
                         const endpoint_uri_pair_t &endpoint_uri_pair_) const;
 
@@ -237,7 +242,7 @@ class socket_base_t : public own_t,
       public:
         void emplace (const char *endpoint_uri_, pipe_t *pipe_);
         int erase_pipes (const std::string &endpoint_uri_str_);
-        void erase_pipe (pipe_t *pipe_);
+        void erase_pipe (const pipe_t *pipe_);
 
       private:
         typedef std::multimap<std::string, pipe_t *> map_t;
@@ -251,7 +256,7 @@ class socket_base_t : public own_t,
 
     //  Moves the flags from the message to local variables,
     //  to be later retrieved by getsockopt.
-    void extract_flags (msg_t *msg_);
+    void extract_flags (const msg_t *msg_);
 
     //  Used to check whether the object is a socket.
     uint32_t _tag;
@@ -284,13 +289,14 @@ class socket_base_t : public own_t,
     int process_commands (int timeout_, bool throttle_);
 
     //  Handlers for incoming commands.
-    void process_stop ();
-    void process_bind (zmq::pipe_t *pipe_);
-    void process_pipe_stats_publish (uint64_t outbound_queue_count_,
-                                     uint64_t inbound_queue_count_,
-                                     endpoint_uri_pair_t *endpoint_pair_);
-    void process_term (int linger_);
-    void process_term_endpoint (std::string *endpoint_);
+    void process_stop () ZMQ_FINAL;
+    void process_bind (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    void
+    process_pipe_stats_publish (uint64_t outbound_queue_count_,
+                                uint64_t inbound_queue_count_,
+                                endpoint_uri_pair_t *endpoint_pair_) ZMQ_FINAL;
+    void process_term (int linger_) ZMQ_FINAL;
+    void process_term_endpoint (std::string *endpoint_) ZMQ_FINAL;
 
     void update_pipe_options (int option_);
 
@@ -335,26 +341,23 @@ class socket_base_t : public own_t,
     // Signaler to be used in the reaping stage
     signaler_t *_reaper_signaler;
 
-    // Mutex for synchronize access to the socket in thread safe mode
-    mutex_t _sync;
-
     // Mutex to synchronize access to the monitor Pair socket
     mutex_t _monitor_sync;
 
-    socket_base_t (const socket_base_t &);
-    const socket_base_t &operator= (const socket_base_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (socket_base_t)
 };
 
 class routing_socket_base_t : public socket_base_t
 {
   protected:
     routing_socket_base_t (class ctx_t *parent_, uint32_t tid_, int sid_);
-    ~routing_socket_base_t ();
+    ~routing_socket_base_t () ZMQ_OVERRIDE;
 
     // methods from socket_base_t
-    virtual int
-    xsetsockopt (int option_, const void *optval_, size_t optvallen_);
-    virtual void xwrite_activated (pipe_t *pipe_);
+    int xsetsockopt (int option_,
+                     const void *optval_,
+                     size_t optvallen_) ZMQ_OVERRIDE;
+    void xwrite_activated (pipe_t *pipe_) ZMQ_FINAL;
 
     // own methods
     std::string extract_connect_routing_id ();
@@ -370,13 +373,14 @@ class routing_socket_base_t : public soc
     bool has_out_pipe (const blob_t &routing_id_) const;
     out_pipe_t *lookup_out_pipe (const blob_t &routing_id_);
     const out_pipe_t *lookup_out_pipe (const blob_t &routing_id_) const;
-    void erase_out_pipe (pipe_t *pipe_);
+    void erase_out_pipe (const pipe_t *pipe_);
     out_pipe_t try_erase_out_pipe (const blob_t &routing_id_);
     template <typename Func> bool any_of_out_pipes (Func func_)
     {
         bool res = false;
-        for (out_pipes_t::iterator it = _out_pipes.begin ();
-             it != _out_pipes.end () && !res; ++it) {
+        for (out_pipes_t::iterator it = _out_pipes.begin (),
+                                   end = _out_pipes.end ();
+             it != end && !res; ++it) {
             res |= func_ (*it->second.pipe);
         }
 
diff -pruN 4.3.2-2/src/socket_poller.cpp 4.3.3-1/src/socket_poller.cpp
--- 4.3.2-2/src/socket_poller.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/socket_poller.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -35,12 +35,24 @@
 
 #include <limits.h>
 
-static bool is_thread_safe (zmq::socket_base_t &socket_)
+static bool is_thread_safe (const zmq::socket_base_t &socket_)
 {
     // do not use getsockopt here, since that would fail during context termination
     return socket_.is_thread_safe ();
 }
 
+// compare elements to value
+template <class It, class T, class Pred>
+static It find_if2 (It b_, It e_, const T &value, Pred pred)
+{
+    for (; b_ != e_; ++b_) {
+        if (pred (*b_, value)) {
+            break;
+        }
+    }
+    return b_;
+}
+
 zmq::socket_poller_t::socket_poller_t () :
     _tag (0xCAFEBABE),
     _signaler (NULL)
@@ -81,33 +93,30 @@ zmq::socket_poller_t::~socket_poller_t (
 #endif
 }
 
-bool zmq::socket_poller_t::check_tag ()
+bool zmq::socket_poller_t::check_tag () const
 {
     return _tag == 0xCAFEBABE;
 }
 
-int zmq::socket_poller_t::signaler_fd (fd_t *fd_)
+int zmq::socket_poller_t::signaler_fd (fd_t *fd_) const
 {
     if (_signaler) {
         *fd_ = _signaler->get_fd ();
         return 0;
-    } else {
-        // Only thread-safe socket types are guaranteed to have a signaler.
-        errno = EINVAL;
-        return -1;
     }
+    // Only thread-safe socket types are guaranteed to have a signaler.
+    errno = EINVAL;
+    return -1;
 }
 
 int zmq::socket_poller_t::add (socket_base_t *socket_,
                                void *user_data_,
                                short events_)
 {
-    for (items_t::iterator it = _items.begin (), end = _items.end (); it != end;
-         ++it) {
-        if (it->socket == socket_) {
-            errno = EINVAL;
-            return -1;
-        }
+    if (find_if2 (_items.begin (), _items.end (), socket_, &is_socket)
+        != _items.end ()) {
+        errno = EINVAL;
+        return -1;
     }
 
     if (is_thread_safe (*socket_)) {
@@ -128,7 +137,7 @@ int zmq::socket_poller_t::add (socket_ba
         socket_->add_signaler (_signaler);
     }
 
-    item_t item = {
+    const item_t item = {
         socket_,
         0,
         user_data_,
@@ -152,15 +161,13 @@ int zmq::socket_poller_t::add (socket_ba
 
 int zmq::socket_poller_t::add_fd (fd_t fd_, void *user_data_, short events_)
 {
-    for (items_t::iterator it = _items.begin (), end = _items.end (); it != end;
-         ++it) {
-        if (!it->socket && it->fd == fd_) {
-            errno = EINVAL;
-            return -1;
-        }
+    if (find_if2 (_items.begin (), _items.end (), fd_, &is_fd)
+        != _items.end ()) {
+        errno = EINVAL;
+        return -1;
     }
 
-    item_t item = {
+    const item_t item = {
         NULL,
         fd_,
         user_data_,
@@ -182,17 +189,12 @@ int zmq::socket_poller_t::add_fd (fd_t f
     return 0;
 }
 
-int zmq::socket_poller_t::modify (socket_base_t *socket_, short events_)
+int zmq::socket_poller_t::modify (const socket_base_t *socket_, short events_)
 {
-    const items_t::iterator end = _items.end ();
-    items_t::iterator it;
+    const items_t::iterator it =
+      find_if2 (_items.begin (), _items.end (), socket_, &is_socket);
 
-    for (it = _items.begin (); it != end; ++it) {
-        if (it->socket == socket_)
-            break;
-    }
-
-    if (it == end) {
+    if (it == _items.end ()) {
         errno = EINVAL;
         return -1;
     }
@@ -206,15 +208,10 @@ int zmq::socket_poller_t::modify (socket
 
 int zmq::socket_poller_t::modify_fd (fd_t fd_, short events_)
 {
-    const items_t::iterator end = _items.end ();
-    items_t::iterator it;
-
-    for (it = _items.begin (); it != end; ++it) {
-        if (!it->socket && it->fd == fd_)
-            break;
-    }
+    const items_t::iterator it =
+      find_if2 (_items.begin (), _items.end (), fd_, &is_fd);
 
-    if (it == end) {
+    if (it == _items.end ()) {
         errno = EINVAL;
         return -1;
     }
@@ -228,15 +225,10 @@ int zmq::socket_poller_t::modify_fd (fd_
 
 int zmq::socket_poller_t::remove (socket_base_t *socket_)
 {
-    const items_t::iterator end = _items.end ();
-    items_t::iterator it;
+    const items_t::iterator it =
+      find_if2 (_items.begin (), _items.end (), socket_, &is_socket);
 
-    for (it = _items.begin (); it != end; ++it) {
-        if (it->socket == socket_)
-            break;
-    }
-
-    if (it == end) {
+    if (it == _items.end ()) {
         errno = EINVAL;
         return -1;
     }
@@ -253,15 +245,10 @@ int zmq::socket_poller_t::remove (socket
 
 int zmq::socket_poller_t::remove_fd (fd_t fd_)
 {
-    const items_t::iterator end = _items.end ();
-    items_t::iterator it;
+    const items_t::iterator it =
+      find_if2 (_items.begin (), _items.end (), fd_, &is_fd);
 
-    for (it = _items.begin (); it != end; ++it) {
-        if (!it->socket && it->fd == fd_)
-            break;
-    }
-
-    if (it == end) {
+    if (it == _items.end ()) {
         errno = EINVAL;
         return -1;
     }
@@ -323,7 +310,7 @@ int zmq::socket_poller_t::rebuild ()
             if (it->socket) {
                 if (!is_thread_safe (*it->socket)) {
                     size_t fd_size = sizeof (zmq::fd_t);
-                    int rc = it->socket->getsockopt (
+                    const int rc = it->socket->getsockopt (
                       ZMQ_FD, &_pollfds[item_nbr].fd, &fd_size);
                     zmq_assert (rc == 0);
 
@@ -416,7 +403,7 @@ void zmq::socket_poller_t::zero_trail_ev
 {
     for (int i = found_; i < n_events_; ++i) {
         events_[i].socket = NULL;
-        events_[i].fd = 0;
+        events_[i].fd = zmq::retired_fd;
         events_[i].user_data = NULL;
         events_[i].events = 0;
     }
@@ -448,6 +435,7 @@ int zmq::socket_poller_t::check_events (
 
             if (it->events & events) {
                 events_[found].socket = it->socket;
+                events_[found].fd = zmq::retired_fd;
                 events_[found].user_data = it->user_data;
                 events_[found].events = it->events & events;
                 ++found;
@@ -455,10 +443,10 @@ int zmq::socket_poller_t::check_events (
         }
         //  Else, the poll item is a raw file descriptor, simply convert
         //  the events to zmq_pollitem_t-style format.
-        else {
+        else if (it->events) {
 #if defined ZMQ_POLL_BASED_ON_POLL
-
-            short revents = _pollfds[it->pollfd_index].revents;
+            zmq_assert (it->pollfd_index >= 0);
+            const short revents = _pollfds[it->pollfd_index].revents;
             short events = 0;
 
             if (revents & POLLIN)
@@ -484,8 +472,8 @@ int zmq::socket_poller_t::check_events (
 
             if (events) {
                 events_[found].socket = NULL;
-                events_[found].user_data = it->user_data;
                 events_[found].fd = it->fd;
+                events_[found].user_data = it->user_data;
                 events_[found].events = events;
                 ++found;
             }
@@ -543,12 +531,17 @@ int zmq::socket_poller_t::wait (zmq::soc
     }
 
     if (_need_rebuild) {
-        int rc = rebuild ();
+        const int rc = rebuild ();
         if (rc == -1)
             return -1;
     }
 
     if (unlikely (_pollset_size == 0)) {
+        if (timeout_ < 0) {
+            // Fail instead of trying to sleep forever
+            errno = EFAULT;
+            return -1;
+        }
         // We'll report an error (timed out) as if the list was non-empty and
         // no event occurred within the specified timeout. Otherwise the caller
         // needs to check the return value AND the event to avoid using the
@@ -597,21 +590,18 @@ int zmq::socket_poller_t::wait (zmq::soc
               static_cast<int> (std::min<uint64_t> (end - now, INT_MAX));
 
         //  Wait for events.
-        while (true) {
-            int rc = poll (_pollfds, _pollset_size, timeout);
-            if (rc == -1 && errno == EINTR) {
-                return -1;
-            }
-            errno_assert (rc >= 0);
-            break;
+        const int rc = poll (_pollfds, _pollset_size, timeout);
+        if (rc == -1 && errno == EINTR) {
+            return -1;
         }
+        errno_assert (rc >= 0);
 
         //  Receive the signal from pollfd
         if (_use_signaler && _pollfds[0].revents & POLLIN)
             _signaler->recv ();
 
         //  Check for the events.
-        int found = check_events (events_, n_events_);
+        const int found = check_events (events_, n_events_);
         if (found) {
             if (found > 0)
                 zero_trail_events (events_, n_events_, found);
@@ -654,29 +644,26 @@ int zmq::socket_poller_t::wait (zmq::soc
         }
 
         //  Wait for events. Ignore interrupts if there's infinite timeout.
-        while (true) {
-            memcpy (inset.get (), _pollset_in.get (),
-                    valid_pollset_bytes (*_pollset_in.get ()));
-            memcpy (outset.get (), _pollset_out.get (),
-                    valid_pollset_bytes (*_pollset_out.get ()));
-            memcpy (errset.get (), _pollset_err.get (),
-                    valid_pollset_bytes (*_pollset_err.get ()));
-            const int rc = select (static_cast<int> (_max_fd + 1), inset.get (),
-                                   outset.get (), errset.get (), ptimeout);
+        memcpy (inset.get (), _pollset_in.get (),
+                valid_pollset_bytes (*_pollset_in.get ()));
+        memcpy (outset.get (), _pollset_out.get (),
+                valid_pollset_bytes (*_pollset_out.get ()));
+        memcpy (errset.get (), _pollset_err.get (),
+                valid_pollset_bytes (*_pollset_err.get ()));
+        const int rc = select (static_cast<int> (_max_fd + 1), inset.get (),
+                               outset.get (), errset.get (), ptimeout);
 #if defined ZMQ_HAVE_WINDOWS
-            if (unlikely (rc == SOCKET_ERROR)) {
-                errno = wsa_error_to_errno (WSAGetLastError ());
-                wsa_assert (errno == ENOTSOCK);
-                return -1;
-            }
+        if (unlikely (rc == SOCKET_ERROR)) {
+            errno = wsa_error_to_errno (WSAGetLastError ());
+            wsa_assert (errno == ENOTSOCK);
+            return -1;
+        }
 #else
-            if (unlikely (rc == -1)) {
-                errno_assert (errno == EINTR || errno == EBADF);
-                return -1;
-            }
-#endif
-            break;
+        if (unlikely (rc == -1)) {
+            errno_assert (errno == EINTR || errno == EBADF);
+            return -1;
         }
+#endif
 
         if (_use_signaler && FD_ISSET (_signaler->get_fd (), inset.get ()))
             _signaler->recv ();
diff -pruN 4.3.2-2/src/socket_poller.hpp 4.3.3-1/src/socket_poller.hpp
--- 4.3.2-2/src/socket_poller.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/socket_poller.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -60,35 +60,40 @@ class socket_poller_t
     socket_poller_t ();
     ~socket_poller_t ();
 
-    typedef struct event_t
-    {
-        socket_base_t *socket;
-        fd_t fd;
-        void *user_data;
-        short events;
-    } event_t;
+    typedef zmq_poller_event_t event_t;
 
     int add (socket_base_t *socket_, void *user_data_, short events_);
-    int modify (socket_base_t *socket_, short events_);
+    int modify (const socket_base_t *socket_, short events_);
     int remove (socket_base_t *socket_);
 
     int add_fd (fd_t fd_, void *user_data_, short events_);
     int modify_fd (fd_t fd_, short events_);
     int remove_fd (fd_t fd_);
     // Returns the signaler's fd if there is one, otherwise errors.
-    int signaler_fd (fd_t *fd_);
+    int signaler_fd (fd_t *fd_) const;
 
-    int wait (event_t *event_, int n_events_, long timeout_);
+    int wait (event_t *events_, int n_events_, long timeout_);
 
-    inline int size () { return static_cast<int> (_items.size ()); };
+    int size () const { return static_cast<int> (_items.size ()); };
 
     //  Return false if object is not a socket.
-    bool check_tag ();
+    bool check_tag () const;
 
   private:
-    void zero_trail_events (zmq::socket_poller_t::event_t *events_,
-                            int n_events_,
-                            int found_);
+    typedef struct item_t
+    {
+        socket_base_t *socket;
+        fd_t fd;
+        void *user_data;
+        short events;
+#if defined ZMQ_POLL_BASED_ON_POLL
+        int pollfd_index;
+#endif
+    } item_t;
+
+    static void zero_trail_events (zmq::socket_poller_t::event_t *events_,
+                                   int n_events_,
+                                   int found_);
 #if defined ZMQ_POLL_BASED_ON_POLL
     int check_events (zmq::socket_poller_t::event_t *events_, int n_events_);
 #elif defined ZMQ_POLL_BASED_ON_SELECT
@@ -98,11 +103,20 @@ class socket_poller_t
                       fd_set &outset_,
                       fd_set &errset_);
 #endif
-    int adjust_timeout (zmq::clock_t &clock_,
-                        long timeout_,
-                        uint64_t &now_,
-                        uint64_t &end_,
-                        bool &first_pass_);
+    static int adjust_timeout (zmq::clock_t &clock_,
+                               long timeout_,
+                               uint64_t &now_,
+                               uint64_t &end_,
+                               bool &first_pass_);
+    static bool is_socket (const item_t &item, const socket_base_t *socket_)
+    {
+        return item.socket == socket_;
+    }
+    static bool is_fd (const item_t &item, fd_t fd_)
+    {
+        return !item.socket && item.fd == fd_;
+    }
+
     int rebuild ();
 
     //  Used to check whether the object is a socket_poller.
@@ -111,17 +125,6 @@ class socket_poller_t
     //  Signaler used for thread safe sockets polling
     signaler_t *_signaler;
 
-    typedef struct item_t
-    {
-        socket_base_t *socket;
-        fd_t fd;
-        void *user_data;
-        short events;
-#if defined ZMQ_POLL_BASED_ON_POLL
-        int pollfd_index;
-#endif
-    } item_t;
-
     //  List of sockets
     typedef std::vector<item_t> items_t;
     items_t _items;
@@ -144,8 +147,7 @@ class socket_poller_t
     zmq::fd_t _max_fd;
 #endif
 
-    socket_poller_t (const socket_poller_t &);
-    const socket_poller_t &operator= (const socket_poller_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (socket_poller_t)
 };
 }
 
diff -pruN 4.3.2-2/src/socks_connecter.cpp 4.3.3-1/src/socks_connecter.cpp
--- 4.3.2-2/src/socks_connecter.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/socks_connecter.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -33,7 +33,6 @@
 
 #include "macros.hpp"
 #include "socks_connecter.hpp"
-#include "stream_engine.hpp"
 #include "random.hpp"
 #include "err.hpp"
 #include "ip.hpp"
@@ -80,12 +79,12 @@ void zmq::socks_connecter_t::set_auth_me
     _auth_password.clear ();
 }
 
-void zmq::socks_connecter_t::set_auth_method_basic (const std::string username,
-                                                    const std::string password)
+void zmq::socks_connecter_t::set_auth_method_basic (
+  const std::string &username_, const std::string &password_)
 {
     _auth_method = socks_basic_auth;
-    _auth_username = username;
-    _auth_password = password;
+    _auth_username = username_;
+    _auth_password = password_;
 }
 
 void zmq::socks_connecter_t::in_event ()
@@ -345,7 +344,7 @@ int zmq::socks_connecter_t::connect_to_p
     return -1;
 }
 
-zmq::fd_t zmq::socks_connecter_t::check_proxy_connection ()
+zmq::fd_t zmq::socks_connecter_t::check_proxy_connection () const
 {
     //  Async connect has finished. Check whether an error occurred
     int err = 0;
@@ -388,8 +387,8 @@ zmq::fd_t zmq::socks_connecter_t::check_
     rc = tune_tcp_socket (_s);
     rc = rc
          | tune_tcp_keepalives (
-             _s, options.tcp_keepalive, options.tcp_keepalive_cnt,
-             options.tcp_keepalive_idle, options.tcp_keepalive_intvl);
+           _s, options.tcp_keepalive, options.tcp_keepalive_cnt,
+           options.tcp_keepalive_idle, options.tcp_keepalive_intvl);
     if (rc != 0)
         return -1;
 
diff -pruN 4.3.2-2/src/socks_connecter.hpp 4.3.3-1/src/socks_connecter.hpp
--- 4.3.2-2/src/socks_connecter.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/socks_connecter.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,7 @@ class io_thread_t;
 class session_base_t;
 struct address_t;
 
-class socks_connecter_t : public stream_connecter_base_t
+class socks_connecter_t ZMQ_FINAL : public stream_connecter_base_t
 {
   public:
     //  If 'delayed_start' is true connecter first waits for a while,
@@ -54,8 +54,8 @@ class socks_connecter_t : public stream_
                        bool delayed_start_);
     ~socks_connecter_t ();
 
-    void set_auth_method_basic (const std::string username,
-                                const std::string password);
+    void set_auth_method_basic (const std::string &username,
+                                const std::string &password);
     void set_auth_method_none ();
 
 
@@ -82,19 +82,19 @@ class socks_connecter_t : public stream_
     };
 
     //  Handlers for I/O events.
-    virtual void in_event ();
-    virtual void out_event ();
+    void in_event ();
+    void out_event ();
 
     //  Internal function to start the actual connection establishment.
     void start_connecting ();
 
-    int process_server_response (const socks_choice_t &response_);
-    int process_server_response (const socks_response_t &response_);
-    int process_server_response (const socks_auth_response_t &response_);
-
-    int parse_address (const std::string &address_,
-                       std::string &hostname_,
-                       uint16_t &port_);
+    static int process_server_response (const socks_choice_t &response_);
+    static int process_server_response (const socks_response_t &response_);
+    static int process_server_response (const socks_auth_response_t &response_);
+
+    static int parse_address (const std::string &address_,
+                              std::string &hostname_,
+                              uint16_t &port_);
 
     int connect_to_proxy ();
 
@@ -107,7 +107,7 @@ class socks_connecter_t : public stream_
 
     //  Get the file descriptor of newly created connection. Returns
     //  retired_fd if the connection was unsuccessful.
-    zmq::fd_t check_proxy_connection ();
+    zmq::fd_t check_proxy_connection () const;
 
     socks_greeting_encoder_t _greeting_encoder;
     socks_choice_decoder_t _choice_decoder;
@@ -128,8 +128,7 @@ class socks_connecter_t : public stream_
 
     int _status;
 
-    socks_connecter_t (const socks_connecter_t &);
-    const socks_connecter_t &operator= (const socks_connecter_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (socks_connecter_t)
 };
 }
 
diff -pruN 4.3.2-2/src/socks.cpp 4.3.3-1/src/socks.cpp
--- 4.3.2-2/src/socks.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/socks.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -130,7 +130,7 @@ void zmq::socks_choice_decoder_t::reset
 
 
 zmq::socks_basic_auth_request_t::socks_basic_auth_request_t (
-  std::string username_, std::string password_) :
+  const std::string &username_, const std::string &password_) :
     username (username_),
     password (password_)
 {
@@ -306,7 +306,7 @@ void zmq::socks_request_encoder_t::reset
 }
 
 zmq::socks_response_t::socks_response_t (uint8_t response_code_,
-                                         std::string address_,
+                                         const std::string &address_,
                                          uint16_t port_) :
     response_code (response_code_),
     address (address_),
diff -pruN 4.3.2-2/src/socks.hpp 4.3.3-1/src/socks.hpp
--- 4.3.2-2/src/socks.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/socks.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -84,7 +84,8 @@ class socks_choice_decoder_t
 
 struct socks_basic_auth_request_t
 {
-    socks_basic_auth_request_t (std::string username_, std::string password_);
+    socks_basic_auth_request_t (const std::string &username_,
+                                const std::string &password_);
 
     const std::string username;
     const std::string password;
@@ -152,7 +153,7 @@ class socks_request_encoder_t
 struct socks_response_t
 {
     socks_response_t (uint8_t response_code_,
-                      std::string address_,
+                      const std::string &address_,
                       uint16_t port_);
     uint8_t response_code;
     std::string address;
diff -pruN 4.3.2-2/src/stream_connecter_base.cpp 4.3.3-1/src/stream_connecter_base.cpp
--- 4.3.2-2/src/stream_connecter_base.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/stream_connecter_base.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -32,6 +32,8 @@
 #include "session_base.hpp"
 #include "address.hpp"
 #include "random.hpp"
+#include "zmtp_engine.hpp"
+#include "raw_engine.hpp"
 
 #ifndef ZMQ_HAVE_WINDOWS
 #include <unistd.h>
@@ -55,8 +57,8 @@ zmq::stream_connecter_base_t::stream_con
     _socket (session_->get_socket ()),
     _delayed_start (delayed_start_),
     _reconnect_timer_started (false),
-    _session (session_),
-    _current_reconnect_ivl (options.reconnect_ivl)
+    _current_reconnect_ivl (options.reconnect_ivl),
+    _session (session_)
 {
     zmq_assert (_addr);
     _addr->to_string (_endpoint);
@@ -99,7 +101,7 @@ void zmq::stream_connecter_base_t::proce
 
 void zmq::stream_connecter_base_t::add_reconnect_timer ()
 {
-    if (options.reconnect_ivl != -1) {
+    if (options.reconnect_ivl > 0) {
         const int interval = get_new_reconnect_ivl ();
         add_timer (interval, reconnect_timer_id);
         _socket->event_connect_retried (
@@ -167,14 +169,17 @@ void zmq::stream_connecter_base_t::in_ev
 }
 
 void zmq::stream_connecter_base_t::create_engine (
-  fd_t fd, const std::string &local_address_)
+  fd_t fd_, const std::string &local_address_)
 {
     const endpoint_uri_pair_t endpoint_pair (local_address_, _endpoint,
                                              endpoint_type_connect);
 
     //  Create the engine object for this connection.
-    stream_engine_t *engine =
-      new (std::nothrow) stream_engine_t (fd, options, endpoint_pair);
+    i_engine *engine;
+    if (options.raw_socket)
+        engine = new (std::nothrow) raw_engine_t (fd_, options, endpoint_pair);
+    else
+        engine = new (std::nothrow) zmtp_engine_t (fd_, options, endpoint_pair);
     alloc_assert (engine);
 
     //  Attach the engine to the corresponding session object.
@@ -183,7 +188,7 @@ void zmq::stream_connecter_base_t::creat
     //  Shut the connecter down.
     terminate ();
 
-    _socket->event_connected (endpoint_pair, fd);
+    _socket->event_connected (endpoint_pair, fd_);
 }
 
 void zmq::stream_connecter_base_t::timer_event (int id_)
diff -pruN 4.3.2-2/src/stream_connecter_base.hpp 4.3.3-1/src/stream_connecter_base.hpp
--- 4.3.2-2/src/stream_connecter_base.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/stream_connecter_base.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -51,19 +51,19 @@ class stream_connecter_base_t : public o
                              address_t *addr_,
                              bool delayed_start_);
 
-    ~stream_connecter_base_t ();
+    ~stream_connecter_base_t () ZMQ_OVERRIDE;
 
   protected:
     //  Handlers for incoming commands.
-    void process_plug ();
-    void process_term (int linger_);
+    void process_plug () ZMQ_FINAL;
+    void process_term (int linger_) ZMQ_OVERRIDE;
 
     //  Handlers for I/O events.
-    void in_event ();
-    void timer_event (int id_);
+    void in_event () ZMQ_OVERRIDE;
+    void timer_event (int id_) ZMQ_OVERRIDE;
 
     //  Internal function to create the engine after connection was established.
-    void create_engine (fd_t fd, const std::string &local_address_);
+    virtual void create_engine (fd_t fd, const std::string &local_address_);
 
     //  Internal function to add a reconnect timer
     void add_reconnect_timer ();
@@ -111,14 +111,14 @@ class stream_connecter_base_t : public o
     //  True iff a timer has been started.
     bool _reconnect_timer_started;
 
-    //  Reference to the session we belong to.
-    zmq::session_base_t *const _session;
-
     //  Current reconnect ivl, updated for backoff strategy
     int _current_reconnect_ivl;
 
-    stream_connecter_base_t (const stream_connecter_base_t &);
-    const stream_connecter_base_t &operator= (const stream_connecter_base_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (stream_connecter_base_t)
+
+  protected:
+    //  Reference to the session we belong to.
+    zmq::session_base_t *const _session;
 };
 }
 
diff -pruN 4.3.2-2/src/stream.cpp 4.3.3-1/src/stream.cpp
--- 4.3.2-2/src/stream.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/stream.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -146,17 +146,17 @@ int zmq::stream_t::xsend (msg_t *msg_)
             _current_out = NULL;
             return 0;
         }
-        bool ok = _current_out->write (msg_);
+        const bool ok = _current_out->write (msg_);
         if (likely (ok))
             _current_out->flush ();
         _current_out = NULL;
     } else {
-        int rc = msg_->close ();
+        const int rc = msg_->close ();
         errno_assert (rc == 0);
     }
 
     //  Detach the message from the data buffer.
-    int rc = msg_->init ();
+    const int rc = msg_->init ();
     errno_assert (rc == 0);
 
     return 0;
@@ -181,11 +181,11 @@ int zmq::stream_t::xrecv (msg_t *msg_)
 {
     if (_prefetched) {
         if (!_routing_id_sent) {
-            int rc = msg_->move (_prefetched_routing_id);
+            const int rc = msg_->move (_prefetched_routing_id);
             errno_assert (rc == 0);
             _routing_id_sent = true;
         } else {
-            int rc = msg_->move (_prefetched_msg);
+            const int rc = msg_->move (_prefetched_msg);
             errno_assert (rc == 0);
             _prefetched = false;
         }
diff -pruN 4.3.2-2/src/stream_engine_base.cpp 4.3.3-1/src/stream_engine_base.cpp
--- 4.3.2-2/src/stream_engine_base.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/stream_engine_base.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,787 @@
+/*
+    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include "macros.hpp"
+
+#include <limits.h>
+#include <string.h>
+
+#ifndef ZMQ_HAVE_WINDOWS
+#include <unistd.h>
+#endif
+
+#include <new>
+#include <sstream>
+
+#include "stream_engine_base.hpp"
+#include "io_thread.hpp"
+#include "session_base.hpp"
+#include "v1_encoder.hpp"
+#include "v1_decoder.hpp"
+#include "v2_encoder.hpp"
+#include "v2_decoder.hpp"
+#include "null_mechanism.hpp"
+#include "plain_client.hpp"
+#include "plain_server.hpp"
+#include "gssapi_client.hpp"
+#include "gssapi_server.hpp"
+#include "curve_client.hpp"
+#include "curve_server.hpp"
+#include "raw_decoder.hpp"
+#include "raw_encoder.hpp"
+#include "config.hpp"
+#include "err.hpp"
+#include "ip.hpp"
+#include "tcp.hpp"
+#include "likely.hpp"
+#include "wire.hpp"
+
+static std::string get_peer_address (zmq::fd_t s_)
+{
+    std::string peer_address;
+
+    const int family = zmq::get_peer_ip_address (s_, peer_address);
+    if (family == 0)
+        peer_address.clear ();
+#if defined ZMQ_HAVE_SO_PEERCRED
+    else if (family == PF_UNIX) {
+        struct ucred cred;
+        socklen_t size = sizeof (cred);
+        if (!getsockopt (s_, SOL_SOCKET, SO_PEERCRED, &cred, &size)) {
+            std::ostringstream buf;
+            buf << ":" << cred.uid << ":" << cred.gid << ":" << cred.pid;
+            peer_address += buf.str ();
+        }
+    }
+#elif defined ZMQ_HAVE_LOCAL_PEERCRED
+    else if (family == PF_UNIX) {
+        struct xucred cred;
+        socklen_t size = sizeof (cred);
+        if (!getsockopt (_s, 0, LOCAL_PEERCRED, &cred, &size)
+            && cred.cr_version == XUCRED_VERSION) {
+            std::ostringstream buf;
+            buf << ":" << cred.cr_uid << ":";
+            if (cred.cr_ngroups > 0)
+                buf << cred.cr_groups[0];
+            buf << ":";
+            _peer_address += buf.str ();
+        }
+    }
+#endif
+
+    return peer_address;
+}
+
+zmq::stream_engine_base_t::stream_engine_base_t (
+  fd_t fd_,
+  const options_t &options_,
+  const endpoint_uri_pair_t &endpoint_uri_pair_,
+  bool has_handshake_stage_) :
+    _options (options_),
+    _inpos (NULL),
+    _insize (0),
+    _decoder (NULL),
+    _outpos (NULL),
+    _outsize (0),
+    _encoder (NULL),
+    _mechanism (NULL),
+    _next_msg (NULL),
+    _process_msg (NULL),
+    _metadata (NULL),
+    _input_stopped (false),
+    _output_stopped (false),
+    _endpoint_uri_pair (endpoint_uri_pair_),
+    _has_handshake_timer (false),
+    _has_ttl_timer (false),
+    _has_timeout_timer (false),
+    _has_heartbeat_timer (false),
+    _peer_address (get_peer_address (fd_)),
+    _s (fd_),
+    _handle (static_cast<handle_t> (NULL)),
+    _plugged (false),
+    _handshaking (true),
+    _io_error (false),
+    _session (NULL),
+    _socket (NULL),
+    _has_handshake_stage (has_handshake_stage_)
+{
+    const int rc = _tx_msg.init ();
+    errno_assert (rc == 0);
+
+    //  Put the socket into non-blocking mode.
+    unblock_socket (_s);
+}
+
+zmq::stream_engine_base_t::~stream_engine_base_t ()
+{
+    zmq_assert (!_plugged);
+
+    if (_s != retired_fd) {
+#ifdef ZMQ_HAVE_WINDOWS
+        const int rc = closesocket (_s);
+        wsa_assert (rc != SOCKET_ERROR);
+#else
+        int rc = close (_s);
+#if defined(__FreeBSD_kernel__) || defined(__FreeBSD__)
+        // FreeBSD may return ECONNRESET on close() under load but this is not
+        // an error.
+        if (rc == -1 && errno == ECONNRESET)
+            rc = 0;
+#endif
+        errno_assert (rc == 0);
+#endif
+        _s = retired_fd;
+    }
+
+    const int rc = _tx_msg.close ();
+    errno_assert (rc == 0);
+
+    //  Drop reference to metadata and destroy it if we are
+    //  the only user.
+    if (_metadata != NULL) {
+        if (_metadata->drop_ref ()) {
+            LIBZMQ_DELETE (_metadata);
+        }
+    }
+
+    LIBZMQ_DELETE (_encoder);
+    LIBZMQ_DELETE (_decoder);
+    LIBZMQ_DELETE (_mechanism);
+}
+
+void zmq::stream_engine_base_t::plug (io_thread_t *io_thread_,
+                                      session_base_t *session_)
+{
+    zmq_assert (!_plugged);
+    _plugged = true;
+
+    //  Connect to session object.
+    zmq_assert (!_session);
+    zmq_assert (session_);
+    _session = session_;
+    _socket = _session->get_socket ();
+
+    //  Connect to I/O threads poller object.
+    io_object_t::plug (io_thread_);
+    _handle = add_fd (_s);
+    _io_error = false;
+
+    plug_internal ();
+}
+
+void zmq::stream_engine_base_t::unplug ()
+{
+    zmq_assert (_plugged);
+    _plugged = false;
+
+    //  Cancel all timers.
+    if (_has_handshake_timer) {
+        cancel_timer (handshake_timer_id);
+        _has_handshake_timer = false;
+    }
+
+    if (_has_ttl_timer) {
+        cancel_timer (heartbeat_ttl_timer_id);
+        _has_ttl_timer = false;
+    }
+
+    if (_has_timeout_timer) {
+        cancel_timer (heartbeat_timeout_timer_id);
+        _has_timeout_timer = false;
+    }
+
+    if (_has_heartbeat_timer) {
+        cancel_timer (heartbeat_ivl_timer_id);
+        _has_heartbeat_timer = false;
+    }
+    //  Cancel all fd subscriptions.
+    if (!_io_error)
+        rm_fd (_handle);
+
+    //  Disconnect from I/O threads poller object.
+    io_object_t::unplug ();
+
+    _session = NULL;
+}
+
+void zmq::stream_engine_base_t::terminate ()
+{
+    unplug ();
+    delete this;
+}
+
+void zmq::stream_engine_base_t::in_event ()
+{
+    // ignore errors
+    const bool res = in_event_internal ();
+    LIBZMQ_UNUSED (res);
+}
+
+bool zmq::stream_engine_base_t::in_event_internal ()
+{
+    zmq_assert (!_io_error);
+
+    //  If still handshaking, receive and process the greeting message.
+    if (unlikely (_handshaking)) {
+        if (handshake ()) {
+            //  Handshaking was successful.
+            //  Switch into the normal message flow.
+            _handshaking = false;
+
+            if (_mechanism == NULL && _has_handshake_stage)
+                _session->engine_ready ();
+        } else
+            return false;
+    }
+
+
+    zmq_assert (_decoder);
+
+    //  If there has been an I/O error, stop polling.
+    if (_input_stopped) {
+        rm_fd (_handle);
+        _io_error = true;
+        return true; // TODO or return false in this case too?
+    }
+
+    //  If there's no data to process in the buffer...
+    if (!_insize) {
+        //  Retrieve the buffer and read as much data as possible.
+        //  Note that buffer can be arbitrarily large. However, we assume
+        //  the underlying TCP layer has fixed buffer size and thus the
+        //  number of bytes read will be always limited.
+        size_t bufsize = 0;
+        _decoder->get_buffer (&_inpos, &bufsize);
+
+        const int rc = read (_inpos, bufsize);
+
+        if (rc == -1) {
+            if (errno != EAGAIN) {
+                error (connection_error);
+                return false;
+            }
+            return true;
+        }
+
+        //  Adjust input size
+        _insize = static_cast<size_t> (rc);
+        // Adjust buffer size to received bytes
+        _decoder->resize_buffer (_insize);
+    }
+
+    int rc = 0;
+    size_t processed = 0;
+
+    while (_insize > 0) {
+        rc = _decoder->decode (_inpos, _insize, processed);
+        zmq_assert (processed <= _insize);
+        _inpos += processed;
+        _insize -= processed;
+        if (rc == 0 || rc == -1)
+            break;
+        rc = (this->*_process_msg) (_decoder->msg ());
+        if (rc == -1)
+            break;
+    }
+
+    //  Tear down the connection if we have failed to decode input data
+    //  or the session has rejected the message.
+    if (rc == -1) {
+        if (errno != EAGAIN) {
+            error (protocol_error);
+            return false;
+        }
+        _input_stopped = true;
+        reset_pollin (_handle);
+    }
+
+    _session->flush ();
+    return true;
+}
+
+void zmq::stream_engine_base_t::out_event ()
+{
+    zmq_assert (!_io_error);
+
+    //  If write buffer is empty, try to read new data from the encoder.
+    if (!_outsize) {
+        //  Even when we stop polling as soon as there is no
+        //  data to send, the poller may invoke out_event one
+        //  more time due to 'speculative write' optimisation.
+        if (unlikely (_encoder == NULL)) {
+            zmq_assert (_handshaking);
+            return;
+        }
+
+        _outpos = NULL;
+        _outsize = _encoder->encode (&_outpos, 0);
+
+        while (_outsize < static_cast<size_t> (_options.out_batch_size)) {
+            if ((this->*_next_msg) (&_tx_msg) == -1) {
+                //  ws_engine can cause an engine error and delete it, so
+                //  bail out immediately to avoid use-after-free
+                if (errno == ECONNRESET)
+                    return;
+                else
+                    break;
+            }
+            _encoder->load_msg (&_tx_msg);
+            unsigned char *bufptr = _outpos + _outsize;
+            const size_t n =
+              _encoder->encode (&bufptr, _options.out_batch_size - _outsize);
+            zmq_assert (n > 0);
+            if (_outpos == NULL)
+                _outpos = bufptr;
+            _outsize += n;
+        }
+
+        //  If there is no data to send, stop polling for output.
+        if (_outsize == 0) {
+            _output_stopped = true;
+            reset_pollout ();
+            return;
+        }
+    }
+
+    //  If there are any data to write in write buffer, write as much as
+    //  possible to the socket. Note that amount of data to write can be
+    //  arbitrarily large. However, we assume that underlying TCP layer has
+    //  limited transmission buffer and thus the actual number of bytes
+    //  written should be reasonably modest.
+    const int nbytes = write (_outpos, _outsize);
+
+    //  IO error has occurred. We stop waiting for output events.
+    //  The engine is not terminated until we detect input error;
+    //  this is necessary to prevent losing incoming messages.
+    if (nbytes == -1) {
+        reset_pollout ();
+        return;
+    }
+
+    _outpos += nbytes;
+    _outsize -= nbytes;
+
+    //  If we are still handshaking and there are no data
+    //  to send, stop polling for output.
+    if (unlikely (_handshaking))
+        if (_outsize == 0)
+            reset_pollout ();
+}
+
+void zmq::stream_engine_base_t::restart_output ()
+{
+    if (unlikely (_io_error))
+        return;
+
+    if (likely (_output_stopped)) {
+        set_pollout ();
+        _output_stopped = false;
+    }
+
+    //  Speculative write: The assumption is that at the moment new message
+    //  was sent by the user the socket is probably available for writing.
+    //  Thus we try to write the data to socket avoiding polling for POLLOUT.
+    //  Consequently, the latency should be better in request/reply scenarios.
+    out_event ();
+}
+
+bool zmq::stream_engine_base_t::restart_input ()
+{
+    zmq_assert (_input_stopped);
+    zmq_assert (_session != NULL);
+    zmq_assert (_decoder != NULL);
+
+    int rc = (this->*_process_msg) (_decoder->msg ());
+    if (rc == -1) {
+        if (errno == EAGAIN)
+            _session->flush ();
+        else {
+            error (protocol_error);
+            return false;
+        }
+        return true;
+    }
+
+    while (_insize > 0) {
+        size_t processed = 0;
+        rc = _decoder->decode (_inpos, _insize, processed);
+        zmq_assert (processed <= _insize);
+        _inpos += processed;
+        _insize -= processed;
+        if (rc == 0 || rc == -1)
+            break;
+        rc = (this->*_process_msg) (_decoder->msg ());
+        if (rc == -1)
+            break;
+    }
+
+    if (rc == -1 && errno == EAGAIN)
+        _session->flush ();
+    else if (_io_error) {
+        error (connection_error);
+        return false;
+    } else if (rc == -1) {
+        error (protocol_error);
+        return false;
+    }
+
+    else {
+        _input_stopped = false;
+        set_pollin ();
+        _session->flush ();
+
+        //  Speculative read.
+        if (!in_event_internal ())
+            return false;
+    }
+
+    return true;
+}
+
+int zmq::stream_engine_base_t::next_handshake_command (msg_t *msg_)
+{
+    zmq_assert (_mechanism != NULL);
+
+    if (_mechanism->status () == mechanism_t::ready) {
+        mechanism_ready ();
+        return pull_and_encode (msg_);
+    }
+    if (_mechanism->status () == mechanism_t::error) {
+        errno = EPROTO;
+        return -1;
+    }
+    const int rc = _mechanism->next_handshake_command (msg_);
+
+    if (rc == 0)
+        msg_->set_flags (msg_t::command);
+
+    return rc;
+}
+
+int zmq::stream_engine_base_t::process_handshake_command (msg_t *msg_)
+{
+    zmq_assert (_mechanism != NULL);
+    const int rc = _mechanism->process_handshake_command (msg_);
+    if (rc == 0) {
+        if (_mechanism->status () == mechanism_t::ready)
+            mechanism_ready ();
+        else if (_mechanism->status () == mechanism_t::error) {
+            errno = EPROTO;
+            return -1;
+        }
+        if (_output_stopped)
+            restart_output ();
+    }
+
+    return rc;
+}
+
+void zmq::stream_engine_base_t::zap_msg_available ()
+{
+    zmq_assert (_mechanism != NULL);
+
+    const int rc = _mechanism->zap_msg_available ();
+    if (rc == -1) {
+        error (protocol_error);
+        return;
+    }
+    if (_input_stopped)
+        if (!restart_input ())
+            return;
+    if (_output_stopped)
+        restart_output ();
+}
+
+const zmq::endpoint_uri_pair_t &zmq::stream_engine_base_t::get_endpoint () const
+{
+    return _endpoint_uri_pair;
+}
+
+void zmq::stream_engine_base_t::mechanism_ready ()
+{
+    if (_options.heartbeat_interval > 0 && !_has_heartbeat_timer) {
+        add_timer (_options.heartbeat_interval, heartbeat_ivl_timer_id);
+        _has_heartbeat_timer = true;
+    }
+
+    if (_has_handshake_stage)
+        _session->engine_ready ();
+
+    bool flush_session = false;
+
+    if (_options.recv_routing_id) {
+        msg_t routing_id;
+        _mechanism->peer_routing_id (&routing_id);
+        const int rc = _session->push_msg (&routing_id);
+        if (rc == -1 && errno == EAGAIN) {
+            // If the write is failing at this stage with
+            // an EAGAIN the pipe must be being shut down,
+            // so we can just bail out of the routing id set.
+            return;
+        }
+        errno_assert (rc == 0);
+        flush_session = true;
+    }
+
+    if (_options.router_notify & ZMQ_NOTIFY_CONNECT) {
+        msg_t connect_notification;
+        connect_notification.init ();
+        const int rc = _session->push_msg (&connect_notification);
+        if (rc == -1 && errno == EAGAIN) {
+            // If the write is failing at this stage with
+            // an EAGAIN the pipe must be being shut down,
+            // so we can just bail out of the notification.
+            return;
+        }
+        errno_assert (rc == 0);
+        flush_session = true;
+    }
+
+    if (flush_session)
+        _session->flush ();
+
+    _next_msg = &stream_engine_base_t::pull_and_encode;
+    _process_msg = &stream_engine_base_t::write_credential;
+
+    //  Compile metadata.
+    properties_t properties;
+    init_properties (properties);
+
+    //  Add ZAP properties.
+    const properties_t &zap_properties = _mechanism->get_zap_properties ();
+    properties.insert (zap_properties.begin (), zap_properties.end ());
+
+    //  Add ZMTP properties.
+    const properties_t &zmtp_properties = _mechanism->get_zmtp_properties ();
+    properties.insert (zmtp_properties.begin (), zmtp_properties.end ());
+
+    zmq_assert (_metadata == NULL);
+    if (!properties.empty ()) {
+        _metadata = new (std::nothrow) metadata_t (properties);
+        alloc_assert (_metadata);
+    }
+
+    if (_has_handshake_timer) {
+        cancel_timer (handshake_timer_id);
+        _has_handshake_timer = false;
+    }
+
+    _socket->event_handshake_succeeded (_endpoint_uri_pair, 0);
+}
+
+int zmq::stream_engine_base_t::write_credential (msg_t *msg_)
+{
+    zmq_assert (_mechanism != NULL);
+    zmq_assert (_session != NULL);
+
+    const blob_t &credential = _mechanism->get_user_id ();
+    if (credential.size () > 0) {
+        msg_t msg;
+        int rc = msg.init_size (credential.size ());
+        zmq_assert (rc == 0);
+        memcpy (msg.data (), credential.data (), credential.size ());
+        msg.set_flags (msg_t::credential);
+        rc = _session->push_msg (&msg);
+        if (rc == -1) {
+            rc = msg.close ();
+            errno_assert (rc == 0);
+            return -1;
+        }
+    }
+    _process_msg = &stream_engine_base_t::decode_and_push;
+    return decode_and_push (msg_);
+}
+
+int zmq::stream_engine_base_t::pull_and_encode (msg_t *msg_)
+{
+    zmq_assert (_mechanism != NULL);
+
+    if (_session->pull_msg (msg_) == -1)
+        return -1;
+    if (_mechanism->encode (msg_) == -1)
+        return -1;
+    return 0;
+}
+
+int zmq::stream_engine_base_t::decode_and_push (msg_t *msg_)
+{
+    zmq_assert (_mechanism != NULL);
+
+    if (_mechanism->decode (msg_) == -1)
+        return -1;
+
+    if (_has_timeout_timer) {
+        _has_timeout_timer = false;
+        cancel_timer (heartbeat_timeout_timer_id);
+    }
+
+    if (_has_ttl_timer) {
+        _has_ttl_timer = false;
+        cancel_timer (heartbeat_ttl_timer_id);
+    }
+
+    if (msg_->flags () & msg_t::command) {
+        process_command_message (msg_);
+    }
+
+    if (_metadata)
+        msg_->set_metadata (_metadata);
+    if (_session->push_msg (msg_) == -1) {
+        if (errno == EAGAIN)
+            _process_msg = &stream_engine_base_t::push_one_then_decode_and_push;
+        return -1;
+    }
+    return 0;
+}
+
+int zmq::stream_engine_base_t::push_one_then_decode_and_push (msg_t *msg_)
+{
+    const int rc = _session->push_msg (msg_);
+    if (rc == 0)
+        _process_msg = &stream_engine_base_t::decode_and_push;
+    return rc;
+}
+
+int zmq::stream_engine_base_t::pull_msg_from_session (msg_t *msg_)
+{
+    return _session->pull_msg (msg_);
+}
+
+int zmq::stream_engine_base_t::push_msg_to_session (msg_t *msg_)
+{
+    return _session->push_msg (msg_);
+}
+
+void zmq::stream_engine_base_t::error (error_reason_t reason_)
+{
+    zmq_assert (_session);
+
+    if ((_options.router_notify & ZMQ_NOTIFY_DISCONNECT) && !_handshaking) {
+        // For router sockets with disconnect notification, rollback
+        // any incomplete message in the pipe, and push the disconnect
+        // notification message.
+        _session->rollback ();
+
+        msg_t disconnect_notification;
+        disconnect_notification.init ();
+        _session->push_msg (&disconnect_notification);
+    }
+
+    // protocol errors have been signaled already at the point where they occurred
+    if (reason_ != protocol_error
+        && (_mechanism == NULL
+            || _mechanism->status () == mechanism_t::handshaking)) {
+        const int err = errno;
+        _socket->event_handshake_failed_no_detail (_endpoint_uri_pair, err);
+        // special case: connecting to non-ZMTP process which immediately drops connection,
+        // or which never responds with greeting, should be treated as a protocol error
+        // (i.e. stop reconnect)
+        if (((reason_ == connection_error) || (reason_ == timeout_error))
+            && (_options.reconnect_stop
+                & ZMQ_RECONNECT_STOP_HANDSHAKE_FAILED)) {
+            reason_ = protocol_error;
+        }
+    }
+
+    _socket->event_disconnected (_endpoint_uri_pair, _s);
+    _session->flush ();
+    _session->engine_error (
+      !_handshaking
+        && (_mechanism == NULL
+            || _mechanism->status () != mechanism_t::handshaking),
+      reason_);
+    unplug ();
+    delete this;
+}
+
+void zmq::stream_engine_base_t::set_handshake_timer ()
+{
+    zmq_assert (!_has_handshake_timer);
+
+    if (_options.handshake_ivl > 0) {
+        add_timer (_options.handshake_ivl, handshake_timer_id);
+        _has_handshake_timer = true;
+    }
+}
+
+bool zmq::stream_engine_base_t::init_properties (properties_t &properties_)
+{
+    if (_peer_address.empty ())
+        return false;
+    properties_.ZMQ_MAP_INSERT_OR_EMPLACE (
+      std::string (ZMQ_MSG_PROPERTY_PEER_ADDRESS), _peer_address);
+
+    //  Private property to support deprecated SRCFD
+    std::ostringstream stream;
+    stream << static_cast<int> (_s);
+    std::string fd_string = stream.str ();
+    properties_.ZMQ_MAP_INSERT_OR_EMPLACE (std::string ("__fd"),
+                                           ZMQ_MOVE (fd_string));
+    return true;
+}
+
+void zmq::stream_engine_base_t::timer_event (int id_)
+{
+    if (id_ == handshake_timer_id) {
+        _has_handshake_timer = false;
+        //  handshake timer expired before handshake completed, so engine fail
+        error (timeout_error);
+    } else if (id_ == heartbeat_ivl_timer_id) {
+        _next_msg = &stream_engine_base_t::produce_ping_message;
+        out_event ();
+        add_timer (_options.heartbeat_interval, heartbeat_ivl_timer_id);
+    } else if (id_ == heartbeat_ttl_timer_id) {
+        _has_ttl_timer = false;
+        error (timeout_error);
+    } else if (id_ == heartbeat_timeout_timer_id) {
+        _has_timeout_timer = false;
+        error (timeout_error);
+    } else
+        // There are no other valid timer ids!
+        assert (false);
+}
+
+int zmq::stream_engine_base_t::read (void *data_, size_t size_)
+{
+    const int rc = zmq::tcp_read (_s, data_, size_);
+
+    if (rc == 0) {
+        // connection closed by peer
+        errno = EPIPE;
+        return -1;
+    }
+
+    return rc;
+}
+
+int zmq::stream_engine_base_t::write (const void *data_, size_t size_)
+{
+    return zmq::tcp_write (_s, data_, size_);
+}
diff -pruN 4.3.2-2/src/stream_engine_base.hpp 4.3.3-1/src/stream_engine_base.hpp
--- 4.3.2-2/src/stream_engine_base.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/stream_engine_base.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,205 @@
+/*
+    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_STREAM_ENGINE_BASE_HPP_INCLUDED__
+#define __ZMQ_STREAM_ENGINE_BASE_HPP_INCLUDED__
+
+#include <stddef.h>
+
+#include "fd.hpp"
+#include "i_engine.hpp"
+#include "io_object.hpp"
+#include "i_encoder.hpp"
+#include "i_decoder.hpp"
+#include "options.hpp"
+#include "socket_base.hpp"
+#include "metadata.hpp"
+#include "msg.hpp"
+#include "tcp.hpp"
+
+namespace zmq
+{
+class io_thread_t;
+class session_base_t;
+class mechanism_t;
+
+//  This engine handles any socket with SOCK_STREAM semantics,
+//  e.g. TCP socket or an UNIX domain socket.
+
+class stream_engine_base_t : public io_object_t, public i_engine
+{
+  public:
+    stream_engine_base_t (fd_t fd_,
+                          const options_t &options_,
+                          const endpoint_uri_pair_t &endpoint_uri_pair_,
+                          bool has_handshake_stage_);
+    ~stream_engine_base_t () ZMQ_OVERRIDE;
+
+    //  i_engine interface implementation.
+    bool has_handshake_stage () ZMQ_FINAL { return _has_handshake_stage; };
+    void plug (zmq::io_thread_t *io_thread_,
+               zmq::session_base_t *session_) ZMQ_FINAL;
+    void terminate () ZMQ_FINAL;
+    bool restart_input () ZMQ_FINAL;
+    void restart_output () ZMQ_FINAL;
+    void zap_msg_available () ZMQ_FINAL;
+    const endpoint_uri_pair_t &get_endpoint () const ZMQ_FINAL;
+
+    //  i_poll_events interface implementation.
+    void in_event () ZMQ_FINAL;
+    void out_event ();
+    void timer_event (int id_) ZMQ_FINAL;
+
+  protected:
+    typedef metadata_t::dict_t properties_t;
+    bool init_properties (properties_t &properties_);
+
+    //  Function to handle network disconnections.
+    virtual void error (error_reason_t reason_);
+
+    int next_handshake_command (msg_t *msg_);
+    int process_handshake_command (msg_t *msg_);
+
+    int pull_msg_from_session (msg_t *msg_);
+    int push_msg_to_session (msg_t *msg_);
+
+    int pull_and_encode (msg_t *msg_);
+    virtual int decode_and_push (msg_t *msg_);
+    int push_one_then_decode_and_push (msg_t *msg_);
+
+    void set_handshake_timer ();
+
+    virtual bool handshake () { return true; };
+    virtual void plug_internal (){};
+
+    virtual int process_command_message (msg_t *msg_) { return -1; };
+    virtual int produce_ping_message (msg_t *msg_) { return -1; };
+    virtual int process_heartbeat_message (msg_t *msg_) { return -1; };
+    virtual int produce_pong_message (msg_t *msg_) { return -1; };
+
+    virtual int read (void *data, size_t size_);
+    virtual int write (const void *data_, size_t size_);
+
+    void reset_pollout () { io_object_t::reset_pollout (_handle); }
+    void set_pollout () { io_object_t::set_pollout (_handle); }
+    void set_pollin () { io_object_t::set_pollin (_handle); }
+    session_base_t *session () { return _session; }
+    socket_base_t *socket () { return _socket; }
+
+    const options_t _options;
+
+    unsigned char *_inpos;
+    size_t _insize;
+    i_decoder *_decoder;
+
+    unsigned char *_outpos;
+    size_t _outsize;
+    i_encoder *_encoder;
+
+    mechanism_t *_mechanism;
+
+    int (stream_engine_base_t::*_next_msg) (msg_t *msg_);
+    int (stream_engine_base_t::*_process_msg) (msg_t *msg_);
+
+    //  Metadata to be attached to received messages. May be NULL.
+    metadata_t *_metadata;
+
+    //  True iff the engine couldn't consume the last decoded message.
+    bool _input_stopped;
+
+    //  True iff the engine doesn't have any message to encode.
+    bool _output_stopped;
+
+    //  Representation of the connected endpoints.
+    const endpoint_uri_pair_t _endpoint_uri_pair;
+
+    //  ID of the handshake timer
+    enum
+    {
+        handshake_timer_id = 0x40
+    };
+
+    //  True is linger timer is running.
+    bool _has_handshake_timer;
+
+    //  Heartbeat stuff
+    enum
+    {
+        heartbeat_ivl_timer_id = 0x80,
+        heartbeat_timeout_timer_id = 0x81,
+        heartbeat_ttl_timer_id = 0x82
+    };
+    bool _has_ttl_timer;
+    bool _has_timeout_timer;
+    bool _has_heartbeat_timer;
+
+
+    const std::string _peer_address;
+
+  private:
+    bool in_event_internal ();
+
+    //  Unplug the engine from the session.
+    void unplug ();
+
+    int write_credential (msg_t *msg_);
+
+    void mechanism_ready ();
+
+    //  Underlying socket.
+    fd_t _s;
+
+    handle_t _handle;
+
+    bool _plugged;
+
+    //  When true, we are still trying to determine whether
+    //  the peer is using versioned protocol, and if so, which
+    //  version.  When false, normal message flow has started.
+    bool _handshaking;
+
+    msg_t _tx_msg;
+
+    bool _io_error;
+
+    //  The session this engine is attached to.
+    zmq::session_base_t *_session;
+
+    //  Socket
+    zmq::socket_base_t *_socket;
+
+    //  Indicate if engine has an handshake stage, if it does, engine must call session.engine_ready
+    //  when handshake is completed.
+    bool _has_handshake_stage;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (stream_engine_base_t)
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/stream_engine.cpp 4.3.3-1/src/stream_engine.cpp
--- 4.3.2-2/src/stream_engine.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/stream_engine.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,1268 +0,0 @@
-/*
-    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
-
-    This file is part of libzmq, the ZeroMQ core engine in C++.
-
-    libzmq is free software; you can redistribute it and/or modify it under
-    the terms of the GNU Lesser General Public License (LGPL) as published
-    by the Free Software Foundation; either version 3 of the License, or
-    (at your option) any later version.
-
-    As a special exception, the Contributors give you permission to link
-    this library with independent modules to produce an executable,
-    regardless of the license terms of these independent modules, and to
-    copy and distribute the resulting executable under terms of your choice,
-    provided that you also meet, for each linked independent module, the
-    terms and conditions of the license of that module. An independent
-    module is a module which is not derived from or based on this library.
-    If you modify this library, you must extend this exception to your
-    version of the library.
-
-    libzmq is distributed in the hope that it will be useful, but WITHOUT
-    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
-    License for more details.
-
-    You should have received a copy of the GNU Lesser General Public License
-    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-*/
-
-#include "precompiled.hpp"
-#include "macros.hpp"
-
-#include <limits.h>
-#include <string.h>
-
-#ifndef ZMQ_HAVE_WINDOWS
-#include <unistd.h>
-#endif
-
-#include <new>
-#include <sstream>
-
-#include "stream_engine.hpp"
-#include "io_thread.hpp"
-#include "session_base.hpp"
-#include "v1_encoder.hpp"
-#include "v1_decoder.hpp"
-#include "v2_encoder.hpp"
-#include "v2_decoder.hpp"
-#include "null_mechanism.hpp"
-#include "plain_client.hpp"
-#include "plain_server.hpp"
-#include "gssapi_client.hpp"
-#include "gssapi_server.hpp"
-#include "curve_client.hpp"
-#include "curve_server.hpp"
-#include "raw_decoder.hpp"
-#include "raw_encoder.hpp"
-#include "config.hpp"
-#include "err.hpp"
-#include "ip.hpp"
-#include "tcp.hpp"
-#include "likely.hpp"
-#include "wire.hpp"
-
-static std::string get_peer_address (zmq::fd_t s_)
-{
-    std::string peer_address;
-
-    const int family = zmq::get_peer_ip_address (s_, peer_address);
-    if (family == 0)
-        peer_address.clear ();
-#if defined ZMQ_HAVE_SO_PEERCRED
-    else if (family == PF_UNIX) {
-        struct ucred cred;
-        socklen_t size = sizeof (cred);
-        if (!getsockopt (s_, SOL_SOCKET, SO_PEERCRED, &cred, &size)) {
-            std::ostringstream buf;
-            buf << ":" << cred.uid << ":" << cred.gid << ":" << cred.pid;
-            peer_address += buf.str ();
-        }
-    }
-#elif defined ZMQ_HAVE_LOCAL_PEERCRED
-    else if (family == PF_UNIX) {
-        struct xucred cred;
-        socklen_t size = sizeof (cred);
-        if (!getsockopt (_s, 0, LOCAL_PEERCRED, &cred, &size)
-            && cred.cr_version == XUCRED_VERSION) {
-            std::ostringstream buf;
-            buf << ":" << cred.cr_uid << ":";
-            if (cred.cr_ngroups > 0)
-                buf << cred.cr_groups[0];
-            buf << ":";
-            _peer_address += buf.str ();
-        }
-    }
-#endif
-
-    return peer_address;
-}
-
-
-zmq::stream_engine_t::stream_engine_t (
-  fd_t fd_,
-  const options_t &options_,
-  const endpoint_uri_pair_t &endpoint_uri_pair_) :
-    _s (fd_),
-    _handle (static_cast<handle_t> (NULL)),
-    _inpos (NULL),
-    _insize (0),
-    _decoder (NULL),
-    _outpos (NULL),
-    _outsize (0),
-    _encoder (NULL),
-    _metadata (NULL),
-    _handshaking (true),
-    _greeting_size (v2_greeting_size),
-    _greeting_bytes_read (0),
-    _session (NULL),
-    _options (options_),
-    _endpoint_uri_pair (endpoint_uri_pair_),
-    _plugged (false),
-    _next_msg (&stream_engine_t::routing_id_msg),
-    _process_msg (&stream_engine_t::process_routing_id_msg),
-    _io_error (false),
-    _subscription_required (false),
-    _mechanism (NULL),
-    _input_stopped (false),
-    _output_stopped (false),
-    _has_handshake_timer (false),
-    _has_ttl_timer (false),
-    _has_timeout_timer (false),
-    _has_heartbeat_timer (false),
-    _heartbeat_timeout (0),
-    _socket (NULL),
-    _peer_address (get_peer_address (_s))
-{
-    int rc = _tx_msg.init ();
-    errno_assert (rc == 0);
-    rc = _pong_msg.init ();
-    errno_assert (rc == 0);
-
-    //  Put the socket into non-blocking mode.
-    unblock_socket (_s);
-
-
-    if (_options.heartbeat_interval > 0) {
-        _heartbeat_timeout = _options.heartbeat_timeout;
-        if (_heartbeat_timeout == -1)
-            _heartbeat_timeout = _options.heartbeat_interval;
-    }
-}
-
-zmq::stream_engine_t::~stream_engine_t ()
-{
-    zmq_assert (!_plugged);
-
-    if (_s != retired_fd) {
-#ifdef ZMQ_HAVE_WINDOWS
-        int rc = closesocket (_s);
-        wsa_assert (rc != SOCKET_ERROR);
-#else
-        int rc = close (_s);
-#if defined(__FreeBSD_kernel__) || defined(__FreeBSD__)
-        // FreeBSD may return ECONNRESET on close() under load but this is not
-        // an error.
-        if (rc == -1 && errno == ECONNRESET)
-            rc = 0;
-#endif
-        errno_assert (rc == 0);
-#endif
-        _s = retired_fd;
-    }
-
-    int rc = _tx_msg.close ();
-    errno_assert (rc == 0);
-
-    //  Drop reference to metadata and destroy it if we are
-    //  the only user.
-    if (_metadata != NULL) {
-        if (_metadata->drop_ref ()) {
-            LIBZMQ_DELETE (_metadata);
-        }
-    }
-
-    LIBZMQ_DELETE (_encoder);
-    LIBZMQ_DELETE (_decoder);
-    LIBZMQ_DELETE (_mechanism);
-}
-
-void zmq::stream_engine_t::plug (io_thread_t *io_thread_,
-                                 session_base_t *session_)
-{
-    zmq_assert (!_plugged);
-    _plugged = true;
-
-    //  Connect to session object.
-    zmq_assert (!_session);
-    zmq_assert (session_);
-    _session = session_;
-    _socket = _session->get_socket ();
-
-    //  Connect to I/O threads poller object.
-    io_object_t::plug (io_thread_);
-    _handle = add_fd (_s);
-    _io_error = false;
-
-    if (_options.raw_socket) {
-        // no handshaking for raw sock, instantiate raw encoder and decoders
-        _encoder = new (std::nothrow) raw_encoder_t (_options.out_batch_size);
-        alloc_assert (_encoder);
-
-        _decoder = new (std::nothrow) raw_decoder_t (_options.in_batch_size);
-        alloc_assert (_decoder);
-
-        // disable handshaking for raw socket
-        _handshaking = false;
-
-        _next_msg = &stream_engine_t::pull_msg_from_session;
-        _process_msg = &stream_engine_t::push_raw_msg_to_session;
-
-        properties_t properties;
-        if (init_properties (properties)) {
-            //  Compile metadata.
-            zmq_assert (_metadata == NULL);
-            _metadata = new (std::nothrow) metadata_t (properties);
-            alloc_assert (_metadata);
-        }
-
-        if (_options.raw_notify) {
-            //  For raw sockets, send an initial 0-length message to the
-            // application so that it knows a peer has connected.
-            msg_t connector;
-            connector.init ();
-            push_raw_msg_to_session (&connector);
-            connector.close ();
-            _session->flush ();
-        }
-    } else {
-        // start optional timer, to prevent handshake hanging on no input
-        set_handshake_timer ();
-
-        //  Send the 'length' and 'flags' fields of the routing id message.
-        //  The 'length' field is encoded in the long format.
-        _outpos = _greeting_send;
-        _outpos[_outsize++] = UCHAR_MAX;
-        put_uint64 (&_outpos[_outsize], _options.routing_id_size + 1);
-        _outsize += 8;
-        _outpos[_outsize++] = 0x7f;
-    }
-
-    set_pollin (_handle);
-    set_pollout (_handle);
-    //  Flush all the data that may have been already received downstream.
-    in_event ();
-}
-
-void zmq::stream_engine_t::unplug ()
-{
-    zmq_assert (_plugged);
-    _plugged = false;
-
-    //  Cancel all timers.
-    if (_has_handshake_timer) {
-        cancel_timer (handshake_timer_id);
-        _has_handshake_timer = false;
-    }
-
-    if (_has_ttl_timer) {
-        cancel_timer (heartbeat_ttl_timer_id);
-        _has_ttl_timer = false;
-    }
-
-    if (_has_timeout_timer) {
-        cancel_timer (heartbeat_timeout_timer_id);
-        _has_timeout_timer = false;
-    }
-
-    if (_has_heartbeat_timer) {
-        cancel_timer (heartbeat_ivl_timer_id);
-        _has_heartbeat_timer = false;
-    }
-    //  Cancel all fd subscriptions.
-    if (!_io_error)
-        rm_fd (_handle);
-
-    //  Disconnect from I/O threads poller object.
-    io_object_t::unplug ();
-
-    _session = NULL;
-}
-
-void zmq::stream_engine_t::terminate ()
-{
-    unplug ();
-    delete this;
-}
-
-void zmq::stream_engine_t::in_event ()
-{
-    // ignore errors
-    const bool res = in_event_internal ();
-    LIBZMQ_UNUSED (res);
-}
-
-bool zmq::stream_engine_t::in_event_internal ()
-{
-    zmq_assert (!_io_error);
-
-    //  If still handshaking, receive and process the greeting message.
-    if (unlikely (_handshaking))
-        if (!handshake ())
-            return false;
-
-    zmq_assert (_decoder);
-
-    //  If there has been an I/O error, stop polling.
-    if (_input_stopped) {
-        rm_fd (_handle);
-        _io_error = true;
-        return true; // TODO or return false in this case too?
-    }
-
-    //  If there's no data to process in the buffer...
-    if (!_insize) {
-        //  Retrieve the buffer and read as much data as possible.
-        //  Note that buffer can be arbitrarily large. However, we assume
-        //  the underlying TCP layer has fixed buffer size and thus the
-        //  number of bytes read will be always limited.
-        size_t bufsize = 0;
-        _decoder->get_buffer (&_inpos, &bufsize);
-
-        const int rc = tcp_read (_s, _inpos, bufsize);
-
-        if (rc == 0) {
-            // connection closed by peer
-            errno = EPIPE;
-            error (connection_error);
-            return false;
-        }
-        if (rc == -1) {
-            if (errno != EAGAIN) {
-                error (connection_error);
-                return false;
-            }
-            return true;
-        }
-
-        //  Adjust input size
-        _insize = static_cast<size_t> (rc);
-        // Adjust buffer size to received bytes
-        _decoder->resize_buffer (_insize);
-    }
-
-    int rc = 0;
-    size_t processed = 0;
-
-    while (_insize > 0) {
-        rc = _decoder->decode (_inpos, _insize, processed);
-        zmq_assert (processed <= _insize);
-        _inpos += processed;
-        _insize -= processed;
-        if (rc == 0 || rc == -1)
-            break;
-        rc = (this->*_process_msg) (_decoder->msg ());
-        if (rc == -1)
-            break;
-    }
-
-    //  Tear down the connection if we have failed to decode input data
-    //  or the session has rejected the message.
-    if (rc == -1) {
-        if (errno != EAGAIN) {
-            error (protocol_error);
-            return false;
-        }
-        _input_stopped = true;
-        reset_pollin (_handle);
-    }
-
-    _session->flush ();
-    return true;
-}
-
-void zmq::stream_engine_t::out_event ()
-{
-    zmq_assert (!_io_error);
-
-    //  If write buffer is empty, try to read new data from the encoder.
-    if (!_outsize) {
-        //  Even when we stop polling as soon as there is no
-        //  data to send, the poller may invoke out_event one
-        //  more time due to 'speculative write' optimisation.
-        if (unlikely (_encoder == NULL)) {
-            zmq_assert (_handshaking);
-            return;
-        }
-
-        _outpos = NULL;
-        _outsize = _encoder->encode (&_outpos, 0);
-
-        while (_outsize < static_cast<size_t> (_options.out_batch_size)) {
-            if ((this->*_next_msg) (&_tx_msg) == -1)
-                break;
-            _encoder->load_msg (&_tx_msg);
-            unsigned char *bufptr = _outpos + _outsize;
-            size_t n =
-              _encoder->encode (&bufptr, _options.out_batch_size - _outsize);
-            zmq_assert (n > 0);
-            if (_outpos == NULL)
-                _outpos = bufptr;
-            _outsize += n;
-        }
-
-        //  If there is no data to send, stop polling for output.
-        if (_outsize == 0) {
-            _output_stopped = true;
-            reset_pollout (_handle);
-            return;
-        }
-    }
-
-    //  If there are any data to write in write buffer, write as much as
-    //  possible to the socket. Note that amount of data to write can be
-    //  arbitrarily large. However, we assume that underlying TCP layer has
-    //  limited transmission buffer and thus the actual number of bytes
-    //  written should be reasonably modest.
-    const int nbytes = tcp_write (_s, _outpos, _outsize);
-
-    //  IO error has occurred. We stop waiting for output events.
-    //  The engine is not terminated until we detect input error;
-    //  this is necessary to prevent losing incoming messages.
-    if (nbytes == -1) {
-        reset_pollout (_handle);
-        return;
-    }
-
-    _outpos += nbytes;
-    _outsize -= nbytes;
-
-    //  If we are still handshaking and there are no data
-    //  to send, stop polling for output.
-    if (unlikely (_handshaking))
-        if (_outsize == 0)
-            reset_pollout (_handle);
-}
-
-void zmq::stream_engine_t::restart_output ()
-{
-    if (unlikely (_io_error))
-        return;
-
-    if (likely (_output_stopped)) {
-        set_pollout (_handle);
-        _output_stopped = false;
-    }
-
-    //  Speculative write: The assumption is that at the moment new message
-    //  was sent by the user the socket is probably available for writing.
-    //  Thus we try to write the data to socket avoiding polling for POLLOUT.
-    //  Consequently, the latency should be better in request/reply scenarios.
-    out_event ();
-}
-
-bool zmq::stream_engine_t::restart_input ()
-{
-    zmq_assert (_input_stopped);
-    zmq_assert (_session != NULL);
-    zmq_assert (_decoder != NULL);
-
-    int rc = (this->*_process_msg) (_decoder->msg ());
-    if (rc == -1) {
-        if (errno == EAGAIN)
-            _session->flush ();
-        else {
-            error (protocol_error);
-            return false;
-        }
-        return true;
-    }
-
-    while (_insize > 0) {
-        size_t processed = 0;
-        rc = _decoder->decode (_inpos, _insize, processed);
-        zmq_assert (processed <= _insize);
-        _inpos += processed;
-        _insize -= processed;
-        if (rc == 0 || rc == -1)
-            break;
-        rc = (this->*_process_msg) (_decoder->msg ());
-        if (rc == -1)
-            break;
-    }
-
-    if (rc == -1 && errno == EAGAIN)
-        _session->flush ();
-    else if (_io_error) {
-        error (connection_error);
-        return false;
-    } else if (rc == -1) {
-        error (protocol_error);
-        return false;
-    }
-
-    else {
-        _input_stopped = false;
-        set_pollin (_handle);
-        _session->flush ();
-
-        //  Speculative read.
-        if (!in_event_internal ())
-            return false;
-    }
-
-    return true;
-}
-
-//  Position of the revision field in the greeting.
-const size_t revision_pos = 10;
-
-bool zmq::stream_engine_t::handshake ()
-{
-    zmq_assert (_handshaking);
-    zmq_assert (_greeting_bytes_read < _greeting_size);
-    //  Receive the greeting.
-    const int rc = receive_greeting ();
-    if (rc == -1)
-        return false;
-    const bool unversioned = rc != 0;
-
-    if (!(this
-            ->*select_handshake_fun (unversioned,
-                                     _greeting_recv[revision_pos])) ())
-        return false;
-
-    // Start polling for output if necessary.
-    if (_outsize == 0)
-        set_pollout (_handle);
-
-    //  Handshaking was successful.
-    //  Switch into the normal message flow.
-    _handshaking = false;
-
-    if (_has_handshake_timer) {
-        cancel_timer (handshake_timer_id);
-        _has_handshake_timer = false;
-    }
-
-    return true;
-}
-
-int zmq::stream_engine_t::receive_greeting ()
-{
-    bool unversioned = false;
-    while (_greeting_bytes_read < _greeting_size) {
-        const int n = tcp_read (_s, _greeting_recv + _greeting_bytes_read,
-                                _greeting_size - _greeting_bytes_read);
-        if (n == 0) {
-            errno = EPIPE;
-            error (connection_error);
-            return -1;
-        }
-        if (n == -1) {
-            if (errno != EAGAIN)
-                error (connection_error);
-            return -1;
-        }
-
-        _greeting_bytes_read += n;
-
-        //  We have received at least one byte from the peer.
-        //  If the first byte is not 0xff, we know that the
-        //  peer is using unversioned protocol.
-        if (_greeting_recv[0] != 0xff) {
-            unversioned = true;
-            break;
-        }
-
-        if (_greeting_bytes_read < signature_size)
-            continue;
-
-        //  Inspect the right-most bit of the 10th byte (which coincides
-        //  with the 'flags' field if a regular message was sent).
-        //  Zero indicates this is a header of a routing id message
-        //  (i.e. the peer is using the unversioned protocol).
-        if (!(_greeting_recv[9] & 0x01)) {
-            unversioned = true;
-            break;
-        }
-
-        //  The peer is using versioned protocol.
-        receive_greeting_versioned ();
-    }
-    return unversioned ? 1 : 0;
-}
-
-void zmq::stream_engine_t::receive_greeting_versioned ()
-{
-    //  Send the major version number.
-    if (_outpos + _outsize == _greeting_send + signature_size) {
-        if (_outsize == 0)
-            set_pollout (_handle);
-        _outpos[_outsize++] = 3; //  Major version number
-    }
-
-    if (_greeting_bytes_read > signature_size) {
-        if (_outpos + _outsize == _greeting_send + signature_size + 1) {
-            if (_outsize == 0)
-                set_pollout (_handle);
-
-            //  Use ZMTP/2.0 to talk to older peers.
-            if (_greeting_recv[revision_pos] == ZMTP_1_0
-                || _greeting_recv[revision_pos] == ZMTP_2_0)
-                _outpos[_outsize++] = _options.type;
-            else {
-                _outpos[_outsize++] = 0; //  Minor version number
-                memset (_outpos + _outsize, 0, 20);
-
-                zmq_assert (_options.mechanism == ZMQ_NULL
-                            || _options.mechanism == ZMQ_PLAIN
-                            || _options.mechanism == ZMQ_CURVE
-                            || _options.mechanism == ZMQ_GSSAPI);
-
-                if (_options.mechanism == ZMQ_NULL)
-                    memcpy (_outpos + _outsize, "NULL", 4);
-                else if (_options.mechanism == ZMQ_PLAIN)
-                    memcpy (_outpos + _outsize, "PLAIN", 5);
-                else if (_options.mechanism == ZMQ_GSSAPI)
-                    memcpy (_outpos + _outsize, "GSSAPI", 6);
-                else if (_options.mechanism == ZMQ_CURVE)
-                    memcpy (_outpos + _outsize, "CURVE", 5);
-                _outsize += 20;
-                memset (_outpos + _outsize, 0, 32);
-                _outsize += 32;
-                _greeting_size = v3_greeting_size;
-            }
-        }
-    }
-}
-
-zmq::stream_engine_t::handshake_fun_t
-zmq::stream_engine_t::select_handshake_fun (bool unversioned,
-                                            unsigned char revision)
-{
-    //  Is the peer using ZMTP/1.0 with no revision number?
-    if (unversioned) {
-        return &stream_engine_t::handshake_v1_0_unversioned;
-    }
-    switch (revision) {
-        case ZMTP_1_0:
-            return &stream_engine_t::handshake_v1_0;
-        case ZMTP_2_0:
-            return &stream_engine_t::handshake_v2_0;
-        default:
-            return &stream_engine_t::handshake_v3_0;
-    }
-}
-
-bool zmq::stream_engine_t::handshake_v1_0_unversioned ()
-{
-    //  We send and receive rest of routing id message
-    if (_session->zap_enabled ()) {
-        // reject ZMTP 1.0 connections if ZAP is enabled
-        error (protocol_error);
-        return false;
-    }
-
-    _encoder = new (std::nothrow) v1_encoder_t (_options.out_batch_size);
-    alloc_assert (_encoder);
-
-    _decoder = new (std::nothrow)
-      v1_decoder_t (_options.in_batch_size, _options.maxmsgsize);
-    alloc_assert (_decoder);
-
-    //  We have already sent the message header.
-    //  Since there is no way to tell the encoder to
-    //  skip the message header, we simply throw that
-    //  header data away.
-    const size_t header_size =
-      _options.routing_id_size + 1 >= UCHAR_MAX ? 10 : 2;
-    unsigned char tmp[10], *bufferp = tmp;
-
-    //  Prepare the routing id message and load it into encoder.
-    //  Then consume bytes we have already sent to the peer.
-    const int rc = _tx_msg.init_size (_options.routing_id_size);
-    zmq_assert (rc == 0);
-    memcpy (_tx_msg.data (), _options.routing_id, _options.routing_id_size);
-    _encoder->load_msg (&_tx_msg);
-    const size_t buffer_size = _encoder->encode (&bufferp, header_size);
-    zmq_assert (buffer_size == header_size);
-
-    //  Make sure the decoder sees the data we have already received.
-    _inpos = _greeting_recv;
-    _insize = _greeting_bytes_read;
-
-    //  To allow for interoperability with peers that do not forward
-    //  their subscriptions, we inject a phantom subscription message
-    //  message into the incoming message stream.
-    if (_options.type == ZMQ_PUB || _options.type == ZMQ_XPUB)
-        _subscription_required = true;
-
-    //  We are sending our routing id now and the next message
-    //  will come from the socket.
-    _next_msg = &stream_engine_t::pull_msg_from_session;
-
-    //  We are expecting routing id message.
-    _process_msg = &stream_engine_t::process_routing_id_msg;
-
-    return true;
-}
-
-bool zmq::stream_engine_t::handshake_v1_0 ()
-{
-    if (_session->zap_enabled ()) {
-        // reject ZMTP 1.0 connections if ZAP is enabled
-        error (protocol_error);
-        return false;
-    }
-
-    _encoder = new (std::nothrow) v1_encoder_t (_options.out_batch_size);
-    alloc_assert (_encoder);
-
-    _decoder = new (std::nothrow)
-      v1_decoder_t (_options.in_batch_size, _options.maxmsgsize);
-    alloc_assert (_decoder);
-
-    return true;
-}
-
-bool zmq::stream_engine_t::handshake_v2_0 ()
-{
-    if (_session->zap_enabled ()) {
-        // reject ZMTP 2.0 connections if ZAP is enabled
-        error (protocol_error);
-        return false;
-    }
-
-    _encoder = new (std::nothrow) v2_encoder_t (_options.out_batch_size);
-    alloc_assert (_encoder);
-
-    _decoder = new (std::nothrow) v2_decoder_t (
-      _options.in_batch_size, _options.maxmsgsize, _options.zero_copy);
-    alloc_assert (_decoder);
-
-    return true;
-}
-
-bool zmq::stream_engine_t::handshake_v3_0 ()
-{
-    _encoder = new (std::nothrow) v2_encoder_t (_options.out_batch_size);
-    alloc_assert (_encoder);
-
-    _decoder = new (std::nothrow) v2_decoder_t (
-      _options.in_batch_size, _options.maxmsgsize, _options.zero_copy);
-    alloc_assert (_decoder);
-
-    if (_options.mechanism == ZMQ_NULL
-        && memcmp (_greeting_recv + 12, "NULL\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",
-                   20)
-             == 0) {
-        _mechanism = new (std::nothrow)
-          null_mechanism_t (_session, _peer_address, _options);
-        alloc_assert (_mechanism);
-    } else if (_options.mechanism == ZMQ_PLAIN
-               && memcmp (_greeting_recv + 12,
-                          "PLAIN\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0", 20)
-                    == 0) {
-        if (_options.as_server)
-            _mechanism = new (std::nothrow)
-              plain_server_t (_session, _peer_address, _options);
-        else
-            _mechanism = new (std::nothrow) plain_client_t (_session, _options);
-        alloc_assert (_mechanism);
-    }
-#ifdef ZMQ_HAVE_CURVE
-    else if (_options.mechanism == ZMQ_CURVE
-             && memcmp (_greeting_recv + 12,
-                        "CURVE\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0", 20)
-                  == 0) {
-        if (_options.as_server)
-            _mechanism = new (std::nothrow)
-              curve_server_t (_session, _peer_address, _options);
-        else
-            _mechanism = new (std::nothrow) curve_client_t (_session, _options);
-        alloc_assert (_mechanism);
-    }
-#endif
-#ifdef HAVE_LIBGSSAPI_KRB5
-    else if (_options.mechanism == ZMQ_GSSAPI
-             && memcmp (_greeting_recv + 12,
-                        "GSSAPI\0\0\0\0\0\0\0\0\0\0\0\0\0\0", 20)
-                  == 0) {
-        if (_options.as_server)
-            _mechanism = new (std::nothrow)
-              gssapi_server_t (_session, _peer_address, _options);
-        else
-            _mechanism =
-              new (std::nothrow) gssapi_client_t (_session, _options);
-        alloc_assert (_mechanism);
-    }
-#endif
-    else {
-        _session->get_socket ()->event_handshake_failed_protocol (
-          _session->get_endpoint (),
-          ZMQ_PROTOCOL_ERROR_ZMTP_MECHANISM_MISMATCH);
-        error (protocol_error);
-        return false;
-    }
-    _next_msg = &stream_engine_t::next_handshake_command;
-    _process_msg = &stream_engine_t::process_handshake_command;
-
-    return true;
-}
-
-int zmq::stream_engine_t::routing_id_msg (msg_t *msg_)
-{
-    int rc = msg_->init_size (_options.routing_id_size);
-    errno_assert (rc == 0);
-    if (_options.routing_id_size > 0)
-        memcpy (msg_->data (), _options.routing_id, _options.routing_id_size);
-    _next_msg = &stream_engine_t::pull_msg_from_session;
-    return 0;
-}
-
-int zmq::stream_engine_t::process_routing_id_msg (msg_t *msg_)
-{
-    if (_options.recv_routing_id) {
-        msg_->set_flags (msg_t::routing_id);
-        int rc = _session->push_msg (msg_);
-        errno_assert (rc == 0);
-    } else {
-        int rc = msg_->close ();
-        errno_assert (rc == 0);
-        rc = msg_->init ();
-        errno_assert (rc == 0);
-    }
-
-    if (_subscription_required) {
-        msg_t subscription;
-
-        //  Inject the subscription message, so that also
-        //  ZMQ 2.x peers receive published messages.
-        int rc = subscription.init_size (1);
-        errno_assert (rc == 0);
-        *static_cast<unsigned char *> (subscription.data ()) = 1;
-        rc = _session->push_msg (&subscription);
-        errno_assert (rc == 0);
-    }
-
-    _process_msg = &stream_engine_t::push_msg_to_session;
-
-    return 0;
-}
-
-int zmq::stream_engine_t::next_handshake_command (msg_t *msg_)
-{
-    zmq_assert (_mechanism != NULL);
-
-    if (_mechanism->status () == mechanism_t::ready) {
-        mechanism_ready ();
-        return pull_and_encode (msg_);
-    }
-    if (_mechanism->status () == mechanism_t::error) {
-        errno = EPROTO;
-        return -1;
-    } else {
-        const int rc = _mechanism->next_handshake_command (msg_);
-
-        if (rc == 0)
-            msg_->set_flags (msg_t::command);
-
-        return rc;
-    }
-}
-
-int zmq::stream_engine_t::process_handshake_command (msg_t *msg_)
-{
-    zmq_assert (_mechanism != NULL);
-    const int rc = _mechanism->process_handshake_command (msg_);
-    if (rc == 0) {
-        if (_mechanism->status () == mechanism_t::ready)
-            mechanism_ready ();
-        else if (_mechanism->status () == mechanism_t::error) {
-            errno = EPROTO;
-            return -1;
-        }
-        if (_output_stopped)
-            restart_output ();
-    }
-
-    return rc;
-}
-
-void zmq::stream_engine_t::zap_msg_available ()
-{
-    zmq_assert (_mechanism != NULL);
-
-    const int rc = _mechanism->zap_msg_available ();
-    if (rc == -1) {
-        error (protocol_error);
-        return;
-    }
-    if (_input_stopped)
-        if (!restart_input ())
-            return;
-    if (_output_stopped)
-        restart_output ();
-}
-
-const zmq::endpoint_uri_pair_t &zmq::stream_engine_t::get_endpoint () const
-{
-    return _endpoint_uri_pair;
-}
-
-void zmq::stream_engine_t::mechanism_ready ()
-{
-    if (_options.heartbeat_interval > 0) {
-        add_timer (_options.heartbeat_interval, heartbeat_ivl_timer_id);
-        _has_heartbeat_timer = true;
-    }
-
-    bool flush_session = false;
-
-    if (_options.recv_routing_id) {
-        msg_t routing_id;
-        _mechanism->peer_routing_id (&routing_id);
-        const int rc = _session->push_msg (&routing_id);
-        if (rc == -1 && errno == EAGAIN) {
-            // If the write is failing at this stage with
-            // an EAGAIN the pipe must be being shut down,
-            // so we can just bail out of the routing id set.
-            return;
-        }
-        errno_assert (rc == 0);
-        flush_session = true;
-    }
-
-    if (_options.router_notify & ZMQ_NOTIFY_CONNECT) {
-        msg_t connect_notification;
-        connect_notification.init ();
-        const int rc = _session->push_msg (&connect_notification);
-        if (rc == -1 && errno == EAGAIN) {
-            // If the write is failing at this stage with
-            // an EAGAIN the pipe must be being shut down,
-            // so we can just bail out of the notification.
-            return;
-        }
-        errno_assert (rc == 0);
-        flush_session = true;
-    }
-
-    if (flush_session)
-        _session->flush ();
-
-    _next_msg = &stream_engine_t::pull_and_encode;
-    _process_msg = &stream_engine_t::write_credential;
-
-    //  Compile metadata.
-    properties_t properties;
-    init_properties (properties);
-
-    //  Add ZAP properties.
-    const properties_t &zap_properties = _mechanism->get_zap_properties ();
-    properties.insert (zap_properties.begin (), zap_properties.end ());
-
-    //  Add ZMTP properties.
-    const properties_t &zmtp_properties = _mechanism->get_zmtp_properties ();
-    properties.insert (zmtp_properties.begin (), zmtp_properties.end ());
-
-    zmq_assert (_metadata == NULL);
-    if (!properties.empty ()) {
-        _metadata = new (std::nothrow) metadata_t (properties);
-        alloc_assert (_metadata);
-    }
-
-    _socket->event_handshake_succeeded (_endpoint_uri_pair, 0);
-}
-
-int zmq::stream_engine_t::pull_msg_from_session (msg_t *msg_)
-{
-    return _session->pull_msg (msg_);
-}
-
-int zmq::stream_engine_t::push_msg_to_session (msg_t *msg_)
-{
-    return _session->push_msg (msg_);
-}
-
-int zmq::stream_engine_t::push_raw_msg_to_session (msg_t *msg_)
-{
-    if (_metadata && _metadata != msg_->metadata ())
-        msg_->set_metadata (_metadata);
-    return push_msg_to_session (msg_);
-}
-
-int zmq::stream_engine_t::write_credential (msg_t *msg_)
-{
-    zmq_assert (_mechanism != NULL);
-    zmq_assert (_session != NULL);
-
-    const blob_t &credential = _mechanism->get_user_id ();
-    if (credential.size () > 0) {
-        msg_t msg;
-        int rc = msg.init_size (credential.size ());
-        zmq_assert (rc == 0);
-        memcpy (msg.data (), credential.data (), credential.size ());
-        msg.set_flags (msg_t::credential);
-        rc = _session->push_msg (&msg);
-        if (rc == -1) {
-            rc = msg.close ();
-            errno_assert (rc == 0);
-            return -1;
-        }
-    }
-    _process_msg = &stream_engine_t::decode_and_push;
-    return decode_and_push (msg_);
-}
-
-int zmq::stream_engine_t::pull_and_encode (msg_t *msg_)
-{
-    zmq_assert (_mechanism != NULL);
-
-    if (_session->pull_msg (msg_) == -1)
-        return -1;
-    if (_mechanism->encode (msg_) == -1)
-        return -1;
-    return 0;
-}
-
-int zmq::stream_engine_t::decode_and_push (msg_t *msg_)
-{
-    zmq_assert (_mechanism != NULL);
-
-    if (_mechanism->decode (msg_) == -1)
-        return -1;
-
-    if (_has_timeout_timer) {
-        _has_timeout_timer = false;
-        cancel_timer (heartbeat_timeout_timer_id);
-    }
-
-    if (_has_ttl_timer) {
-        _has_ttl_timer = false;
-        cancel_timer (heartbeat_ttl_timer_id);
-    }
-
-    if (msg_->flags () & msg_t::command) {
-        process_command_message (msg_);
-    }
-
-    if (_metadata)
-        msg_->set_metadata (_metadata);
-    if (_session->push_msg (msg_) == -1) {
-        if (errno == EAGAIN)
-            _process_msg = &stream_engine_t::push_one_then_decode_and_push;
-        return -1;
-    }
-    return 0;
-}
-
-int zmq::stream_engine_t::push_one_then_decode_and_push (msg_t *msg_)
-{
-    const int rc = _session->push_msg (msg_);
-    if (rc == 0)
-        _process_msg = &stream_engine_t::decode_and_push;
-    return rc;
-}
-
-void zmq::stream_engine_t::error (error_reason_t reason_)
-{
-    if (_options.raw_socket && _options.raw_notify) {
-        //  For raw sockets, send a final 0-length message to the application
-        //  so that it knows the peer has been disconnected.
-        msg_t terminator;
-        terminator.init ();
-        (this->*_process_msg) (&terminator);
-        terminator.close ();
-    }
-    zmq_assert (_session);
-
-    if ((_options.router_notify & ZMQ_NOTIFY_DISCONNECT) && !_handshaking) {
-        // For router sockets with disconnect notification, rollback
-        // any incomplete message in the pipe, and push the disconnect
-        // notification message.
-        _session->rollback ();
-
-        msg_t disconnect_notification;
-        disconnect_notification.init ();
-        _session->push_msg (&disconnect_notification);
-    }
-
-    // protocol errors have been signaled already at the point where they occurred
-    if (reason_ != protocol_error
-        && (_mechanism == NULL
-            || _mechanism->status () == mechanism_t::handshaking)) {
-        int err = errno;
-        _socket->event_handshake_failed_no_detail (_endpoint_uri_pair, err);
-    }
-
-    _socket->event_disconnected (_endpoint_uri_pair, _s);
-    _session->flush ();
-    _session->engine_error (reason_);
-    unplug ();
-    delete this;
-}
-
-void zmq::stream_engine_t::set_handshake_timer ()
-{
-    zmq_assert (!_has_handshake_timer);
-
-    if (!_options.raw_socket && _options.handshake_ivl > 0) {
-        add_timer (_options.handshake_ivl, handshake_timer_id);
-        _has_handshake_timer = true;
-    }
-}
-
-bool zmq::stream_engine_t::init_properties (properties_t &properties_)
-{
-    if (_peer_address.empty ())
-        return false;
-    properties_.ZMQ_MAP_INSERT_OR_EMPLACE (
-      std::string (ZMQ_MSG_PROPERTY_PEER_ADDRESS), _peer_address);
-
-    //  Private property to support deprecated SRCFD
-    std::ostringstream stream;
-    stream << static_cast<int> (_s);
-    std::string fd_string = stream.str ();
-    properties_.ZMQ_MAP_INSERT_OR_EMPLACE (std::string ("__fd"),
-                                           ZMQ_MOVE (fd_string));
-    return true;
-}
-
-void zmq::stream_engine_t::timer_event (int id_)
-{
-    if (id_ == handshake_timer_id) {
-        _has_handshake_timer = false;
-        //  handshake timer expired before handshake completed, so engine fail
-        error (timeout_error);
-    } else if (id_ == heartbeat_ivl_timer_id) {
-        _next_msg = &stream_engine_t::produce_ping_message;
-        out_event ();
-        add_timer (_options.heartbeat_interval, heartbeat_ivl_timer_id);
-    } else if (id_ == heartbeat_ttl_timer_id) {
-        _has_ttl_timer = false;
-        error (timeout_error);
-    } else if (id_ == heartbeat_timeout_timer_id) {
-        _has_timeout_timer = false;
-        error (timeout_error);
-    } else
-        // There are no other valid timer ids!
-        assert (false);
-}
-
-int zmq::stream_engine_t::produce_ping_message (msg_t *msg_)
-{
-    // 16-bit TTL + \4PING == 7
-    const size_t ping_ttl_len = msg_t::ping_cmd_name_size + 2;
-    zmq_assert (_mechanism != NULL);
-
-    int rc = msg_->init_size (ping_ttl_len);
-    errno_assert (rc == 0);
-    msg_->set_flags (msg_t::command);
-    // Copy in the command message
-    memcpy (msg_->data (), "\4PING", msg_t::ping_cmd_name_size);
-
-    uint16_t ttl_val = htons (_options.heartbeat_ttl);
-    memcpy (static_cast<uint8_t *> (msg_->data ()) + msg_t::ping_cmd_name_size,
-            &ttl_val, sizeof (ttl_val));
-
-    rc = _mechanism->encode (msg_);
-    _next_msg = &stream_engine_t::pull_and_encode;
-    if (!_has_timeout_timer && _heartbeat_timeout > 0) {
-        add_timer (_heartbeat_timeout, heartbeat_timeout_timer_id);
-        _has_timeout_timer = true;
-    }
-    return rc;
-}
-
-int zmq::stream_engine_t::produce_pong_message (msg_t *msg_)
-{
-    zmq_assert (_mechanism != NULL);
-
-    int rc = msg_->move (_pong_msg);
-    errno_assert (rc == 0);
-
-    rc = _mechanism->encode (msg_);
-    _next_msg = &stream_engine_t::pull_and_encode;
-    return rc;
-}
-
-int zmq::stream_engine_t::process_heartbeat_message (msg_t *msg_)
-{
-    if (msg_->is_ping ()) {
-        // 16-bit TTL + \4PING == 7
-        const size_t ping_ttl_len = msg_t::ping_cmd_name_size + 2;
-        const size_t ping_max_ctx_len = 16;
-        uint16_t remote_heartbeat_ttl;
-
-        // Get the remote heartbeat TTL to setup the timer
-        memcpy (&remote_heartbeat_ttl,
-                static_cast<uint8_t *> (msg_->data ())
-                  + msg_t::ping_cmd_name_size,
-                ping_ttl_len - msg_t::ping_cmd_name_size);
-        remote_heartbeat_ttl = ntohs (remote_heartbeat_ttl);
-        // The remote heartbeat is in 10ths of a second
-        // so we multiply it by 100 to get the timer interval in ms.
-        remote_heartbeat_ttl *= 100;
-
-        if (!_has_ttl_timer && remote_heartbeat_ttl > 0) {
-            add_timer (remote_heartbeat_ttl, heartbeat_ttl_timer_id);
-            _has_ttl_timer = true;
-        }
-
-        //  As per ZMTP 3.1 the PING command might contain an up to 16 bytes
-        //  context which needs to be PONGed back, so build the pong message
-        //  here and store it. Truncate it if it's too long.
-        //  Given the engine goes straight to out_event, sequential PINGs will
-        //  not be a problem.
-        const size_t context_len =
-          std::min (msg_->size () - ping_ttl_len, ping_max_ctx_len);
-        const int rc =
-          _pong_msg.init_size (msg_t::ping_cmd_name_size + context_len);
-        errno_assert (rc == 0);
-        _pong_msg.set_flags (msg_t::command);
-        memcpy (_pong_msg.data (), "\4PONG", msg_t::ping_cmd_name_size);
-        if (context_len > 0)
-            memcpy (static_cast<uint8_t *> (_pong_msg.data ())
-                      + msg_t::ping_cmd_name_size,
-                    static_cast<uint8_t *> (msg_->data ()) + ping_ttl_len,
-                    context_len);
-
-        _next_msg = &stream_engine_t::produce_pong_message;
-        out_event ();
-    }
-
-    return 0;
-}
-
-int zmq::stream_engine_t::process_command_message (msg_t *msg_)
-{
-    const uint8_t cmd_name_size =
-      *(static_cast<const uint8_t *> (msg_->data ()));
-    const size_t ping_name_size = msg_t::ping_cmd_name_size - 1;
-    const size_t sub_name_size = msg_t::sub_cmd_name_size - 1;
-    const size_t cancel_name_size = msg_t::cancel_cmd_name_size - 1;
-    //  Malformed command
-    if (unlikely (msg_->size () < cmd_name_size + sizeof (cmd_name_size)))
-        return -1;
-
-    uint8_t *cmd_name = (static_cast<uint8_t *> (msg_->data ())) + 1;
-    if (cmd_name_size == ping_name_size
-        && memcmp (cmd_name, "PING", cmd_name_size) == 0)
-        msg_->set_flags (zmq::msg_t::ping);
-    if (cmd_name_size == ping_name_size
-        && memcmp (cmd_name, "PONG", cmd_name_size) == 0)
-        msg_->set_flags (zmq::msg_t::pong);
-    if (cmd_name_size == sub_name_size
-        && memcmp (cmd_name, "SUBSCRIBE", cmd_name_size) == 0)
-        msg_->set_flags (zmq::msg_t::subscribe);
-    if (cmd_name_size == cancel_name_size
-        && memcmp (cmd_name, "CANCEL", cmd_name_size) == 0)
-        msg_->set_flags (zmq::msg_t::cancel);
-
-    if (msg_->is_ping () || msg_->is_pong ())
-        return process_heartbeat_message (msg_);
-
-    return 0;
-}
diff -pruN 4.3.2-2/src/stream_engine.hpp 4.3.3-1/src/stream_engine.hpp
--- 4.3.2-2/src/stream_engine.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/stream_engine.hpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,250 +0,0 @@
-/*
-    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
-
-    This file is part of libzmq, the ZeroMQ core engine in C++.
-
-    libzmq is free software; you can redistribute it and/or modify it under
-    the terms of the GNU Lesser General Public License (LGPL) as published
-    by the Free Software Foundation; either version 3 of the License, or
-    (at your option) any later version.
-
-    As a special exception, the Contributors give you permission to link
-    this library with independent modules to produce an executable,
-    regardless of the license terms of these independent modules, and to
-    copy and distribute the resulting executable under terms of your choice,
-    provided that you also meet, for each linked independent module, the
-    terms and conditions of the license of that module. An independent
-    module is a module which is not derived from or based on this library.
-    If you modify this library, you must extend this exception to your
-    version of the library.
-
-    libzmq is distributed in the hope that it will be useful, but WITHOUT
-    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
-    License for more details.
-
-    You should have received a copy of the GNU Lesser General Public License
-    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-*/
-
-#ifndef __ZMQ_STREAM_ENGINE_HPP_INCLUDED__
-#define __ZMQ_STREAM_ENGINE_HPP_INCLUDED__
-
-#include <stddef.h>
-
-#include "fd.hpp"
-#include "i_engine.hpp"
-#include "io_object.hpp"
-#include "i_encoder.hpp"
-#include "i_decoder.hpp"
-#include "options.hpp"
-#include "socket_base.hpp"
-#include "metadata.hpp"
-#include "msg.hpp"
-
-namespace zmq
-{
-//  Protocol revisions
-enum
-{
-    ZMTP_1_0 = 0,
-    ZMTP_2_0 = 1
-};
-
-class io_thread_t;
-class session_base_t;
-class mechanism_t;
-
-//  This engine handles any socket with SOCK_STREAM semantics,
-//  e.g. TCP socket or an UNIX domain socket.
-
-class stream_engine_t : public io_object_t, public i_engine
-{
-  public:
-    enum error_reason_t
-    {
-        protocol_error,
-        connection_error,
-        timeout_error
-    };
-
-    stream_engine_t (fd_t fd_,
-                     const options_t &options_,
-                     const endpoint_uri_pair_t &endpoint_uri_pair_);
-    ~stream_engine_t ();
-
-    //  i_engine interface implementation.
-    void plug (zmq::io_thread_t *io_thread_, zmq::session_base_t *session_);
-    void terminate ();
-    bool restart_input ();
-    void restart_output ();
-    void zap_msg_available ();
-    const endpoint_uri_pair_t &get_endpoint () const;
-
-    //  i_poll_events interface implementation.
-    void in_event ();
-    void out_event ();
-    void timer_event (int id_);
-
-  private:
-    bool in_event_internal ();
-
-    //  Unplug the engine from the session.
-    void unplug ();
-
-    //  Function to handle network disconnections.
-    void error (error_reason_t reason_);
-
-    //  Detects the protocol used by the peer.
-    bool handshake ();
-
-    //  Receive the greeting from the peer.
-    int receive_greeting ();
-    void receive_greeting_versioned ();
-
-    typedef bool (stream_engine_t::*handshake_fun_t) ();
-    static handshake_fun_t select_handshake_fun (bool unversioned,
-                                                 unsigned char revision);
-
-    bool handshake_v1_0_unversioned ();
-    bool handshake_v1_0 ();
-    bool handshake_v2_0 ();
-    bool handshake_v3_0 ();
-
-    int routing_id_msg (msg_t *msg_);
-    int process_routing_id_msg (msg_t *msg_);
-
-    int next_handshake_command (msg_t *msg_);
-    int process_handshake_command (msg_t *msg_);
-
-    int pull_msg_from_session (msg_t *msg_);
-    int push_msg_to_session (msg_t *msg_);
-
-    int push_raw_msg_to_session (msg_t *msg_);
-
-    int write_credential (msg_t *msg_);
-    int pull_and_encode (msg_t *msg_);
-    int decode_and_push (msg_t *msg_);
-    int push_one_then_decode_and_push (msg_t *msg_);
-
-    void mechanism_ready ();
-
-    size_t add_property (unsigned char *ptr_,
-                         const char *name_,
-                         const void *value_,
-                         size_t value_len_);
-
-    void set_handshake_timer ();
-
-    typedef metadata_t::dict_t properties_t;
-    bool init_properties (properties_t &properties_);
-
-    int process_command_message (msg_t *msg_);
-    int produce_ping_message (msg_t *msg_);
-    int process_heartbeat_message (msg_t *msg_);
-    int produce_pong_message (msg_t *msg_);
-
-    //  Underlying socket.
-    fd_t _s;
-
-    msg_t _tx_msg;
-    //  Need to store PING payload for PONG
-    msg_t _pong_msg;
-
-    handle_t _handle;
-
-    unsigned char *_inpos;
-    size_t _insize;
-    i_decoder *_decoder;
-
-    unsigned char *_outpos;
-    size_t _outsize;
-    i_encoder *_encoder;
-
-    //  Metadata to be attached to received messages. May be NULL.
-    metadata_t *_metadata;
-
-    //  When true, we are still trying to determine whether
-    //  the peer is using versioned protocol, and if so, which
-    //  version.  When false, normal message flow has started.
-    bool _handshaking;
-
-    static const size_t signature_size = 10;
-
-    //  Size of ZMTP/1.0 and ZMTP/2.0 greeting message
-    static const size_t v2_greeting_size = 12;
-
-    //  Size of ZMTP/3.0 greeting message
-    static const size_t v3_greeting_size = 64;
-
-    //  Expected greeting size.
-    size_t _greeting_size;
-
-    //  Greeting received from, and sent to peer
-    unsigned char _greeting_recv[v3_greeting_size];
-    unsigned char _greeting_send[v3_greeting_size];
-
-    //  Size of greeting received so far
-    unsigned int _greeting_bytes_read;
-
-    //  The session this engine is attached to.
-    zmq::session_base_t *_session;
-
-    const options_t _options;
-
-    //  Representation of the connected endpoints.
-    const endpoint_uri_pair_t _endpoint_uri_pair;
-
-    bool _plugged;
-
-    int (stream_engine_t::*_next_msg) (msg_t *msg_);
-
-    int (stream_engine_t::*_process_msg) (msg_t *msg_);
-
-    bool _io_error;
-
-    //  Indicates whether the engine is to inject a phantom
-    //  subscription message into the incoming stream.
-    //  Needed to support old peers.
-    bool _subscription_required;
-
-    mechanism_t *_mechanism;
-
-    //  True iff the engine couldn't consume the last decoded message.
-    bool _input_stopped;
-
-    //  True iff the engine doesn't have any message to encode.
-    bool _output_stopped;
-
-    //  ID of the handshake timer
-    enum
-    {
-        handshake_timer_id = 0x40
-    };
-
-    //  True is linger timer is running.
-    bool _has_handshake_timer;
-
-    //  Heartbeat stuff
-    enum
-    {
-        heartbeat_ivl_timer_id = 0x80,
-        heartbeat_timeout_timer_id = 0x81,
-        heartbeat_ttl_timer_id = 0x82
-    };
-    bool _has_ttl_timer;
-    bool _has_timeout_timer;
-    bool _has_heartbeat_timer;
-    int _heartbeat_timeout;
-
-    // Socket
-    zmq::socket_base_t *_socket;
-
-    const std::string _peer_address;
-
-    stream_engine_t (const stream_engine_t &);
-    const stream_engine_t &operator= (const stream_engine_t &);
-};
-}
-
-#endif
diff -pruN 4.3.2-2/src/stream.hpp 4.3.3-1/src/stream.hpp
--- 4.3.2-2/src/stream.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/stream.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,7 +39,7 @@ namespace zmq
 class ctx_t;
 class pipe_t;
 
-class stream_t : public routing_socket_base_t
+class stream_t ZMQ_FINAL : public routing_socket_base_t
 {
   public:
     stream_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -87,8 +87,7 @@ class stream_t : public routing_socket_b
     //  algorithm. This value is the next ID to use (if not used already).
     uint32_t _next_integral_routing_id;
 
-    stream_t (const stream_t &);
-    const stream_t &operator= (const stream_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (stream_t)
 };
 }
 
diff -pruN 4.3.2-2/src/stream_listener_base.cpp 4.3.3-1/src/stream_listener_base.cpp
--- 4.3.2-2/src/stream_listener_base.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/stream_listener_base.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -31,7 +31,8 @@
 #include "stream_listener_base.hpp"
 #include "session_base.hpp"
 #include "socket_base.hpp"
-#include "stream_engine.hpp"
+#include "zmtp_engine.hpp"
+#include "raw_engine.hpp"
 
 #ifndef ZMQ_HAVE_WINDOWS
 #include <unistd.h>
@@ -96,14 +97,17 @@ int zmq::stream_listener_base_t::close (
     return 0;
 }
 
-void zmq::stream_listener_base_t::create_engine (fd_t fd)
+void zmq::stream_listener_base_t::create_engine (fd_t fd_)
 {
     const endpoint_uri_pair_t endpoint_pair (
-      get_socket_name (fd, socket_end_local),
-      get_socket_name (fd, socket_end_remote), endpoint_type_bind);
+      get_socket_name (fd_, socket_end_local),
+      get_socket_name (fd_, socket_end_remote), endpoint_type_bind);
 
-    stream_engine_t *engine =
-      new (std::nothrow) stream_engine_t (fd, options, endpoint_pair);
+    i_engine *engine;
+    if (options.raw_socket)
+        engine = new (std::nothrow) raw_engine_t (fd_, options, endpoint_pair);
+    else
+        engine = new (std::nothrow) zmtp_engine_t (fd_, options, endpoint_pair);
     alloc_assert (engine);
 
     //  Choose I/O thread to run connecter in. Given that we are already
@@ -119,5 +123,5 @@ void zmq::stream_listener_base_t::create
     launch_child (session);
     send_attach (session, engine, false);
 
-    _socket->event_accepted (endpoint_pair, fd);
+    _socket->event_accepted (endpoint_pair, fd_);
 }
diff -pruN 4.3.2-2/src/stream_listener_base.hpp 4.3.3-1/src/stream_listener_base.hpp
--- 4.3.2-2/src/stream_listener_base.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/stream_listener_base.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -49,7 +49,7 @@ class stream_listener_base_t : public ow
     stream_listener_base_t (zmq::io_thread_t *io_thread_,
                             zmq::socket_base_t *socket_,
                             const options_t &options_);
-    ~stream_listener_base_t ();
+    ~stream_listener_base_t () ZMQ_OVERRIDE;
 
     // Get the bound address for use with wildcards
     int get_local_address (std::string &addr_) const;
@@ -60,14 +60,14 @@ class stream_listener_base_t : public ow
 
   private:
     //  Handlers for incoming commands.
-    void process_plug ();
-    void process_term (int linger_);
+    void process_plug () ZMQ_FINAL;
+    void process_term (int linger_) ZMQ_FINAL;
 
   protected:
     //  Close the listening socket.
     virtual int close ();
 
-    void create_engine (fd_t fd);
+    virtual void create_engine (fd_t fd);
 
     //  Underlying socket.
     fd_t _s;
@@ -81,9 +81,7 @@ class stream_listener_base_t : public ow
     // String representation of endpoint to bind to
     std::string _endpoint;
 
-  private:
-    stream_listener_base_t (const stream_listener_base_t &);
-    const stream_listener_base_t &operator= (const stream_listener_base_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (stream_listener_base_t)
 };
 }
 
diff -pruN 4.3.2-2/src/sub.cpp 4.3.3-1/src/sub.cpp
--- 4.3.2-2/src/sub.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/sub.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -56,15 +56,15 @@ int zmq::sub_t::xsetsockopt (int option_
 
     //  Create the subscription message.
     msg_t msg;
-    int rc = msg.init_size (optvallen_ + 1);
-    errno_assert (rc == 0);
-    unsigned char *data = static_cast<unsigned char *> (msg.data ());
-    *data = (option_ == ZMQ_SUBSCRIBE);
-    //  We explicitly allow a NULL subscription with size zero
-    if (optvallen_) {
-        assert (optval_);
-        memcpy (data + 1, optval_, optvallen_);
+    int rc;
+    const unsigned char *data = static_cast<const unsigned char *> (optval_);
+    if (option_ == ZMQ_SUBSCRIBE) {
+        rc = msg.init_subscribe (optvallen_, data);
+    } else {
+        rc = msg.init_cancel (optvallen_, data);
     }
+    errno_assert (rc == 0);
+
     //  Pass it further on in the stack.
     rc = xsub_t::xsend (&msg);
     return close_and_return (&msg, rc);
diff -pruN 4.3.2-2/src/sub.hpp 4.3.3-1/src/sub.hpp
--- 4.3.2-2/src/sub.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/sub.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,7 +39,7 @@ class msg_t;
 class io_thread_t;
 class socket_base_t;
 
-class sub_t : public xsub_t
+class sub_t ZMQ_FINAL : public xsub_t
 {
   public:
     sub_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
@@ -50,9 +50,7 @@ class sub_t : public xsub_t
     int xsend (zmq::msg_t *msg_);
     bool xhas_out ();
 
-  private:
-    sub_t (const sub_t &);
-    const sub_t &operator= (const sub_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (sub_t)
 };
 }
 
diff -pruN 4.3.2-2/src/tcp_address.cpp 4.3.3-1/src/tcp_address.cpp
--- 4.3.2-2/src/tcp_address.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tcp_address.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -75,7 +75,7 @@ int zmq::tcp_address_t::resolve (const c
     // Test the ';' to know if we have a source address in name_
     const char *src_delimiter = strrchr (name_, ';');
     if (src_delimiter) {
-        std::string src_name (name_, src_delimiter - name_);
+        const std::string src_name (name_, src_delimiter - name_);
 
         ip_resolver_options_t src_resolver_opts;
 
@@ -113,23 +113,23 @@ int zmq::tcp_address_t::resolve (const c
 }
 
 template <size_t N1, size_t N2>
-static std::string make_address_string (const char *hbuf,
-                                        uint16_t port,
-                                        const char (&ipv6_prefix)[N1],
-                                        const char (&ipv6_suffix)[N2])
+static std::string make_address_string (const char *hbuf_,
+                                        uint16_t port_,
+                                        const char (&ipv6_prefix_)[N1],
+                                        const char (&ipv6_suffix_)[N2])
 {
     const size_t max_port_str_length = 5;
-    char buf[NI_MAXHOST + sizeof ipv6_prefix + sizeof ipv6_suffix
+    char buf[NI_MAXHOST + sizeof ipv6_prefix_ + sizeof ipv6_suffix_
              + max_port_str_length];
     char *pos = buf;
-    memcpy (pos, ipv6_prefix, sizeof ipv6_prefix - 1);
-    pos += sizeof ipv6_prefix - 1;
-    const size_t hbuf_len = strlen (hbuf);
-    memcpy (pos, hbuf, hbuf_len);
+    memcpy (pos, ipv6_prefix_, sizeof ipv6_prefix_ - 1);
+    pos += sizeof ipv6_prefix_ - 1;
+    const size_t hbuf_len = strlen (hbuf_);
+    memcpy (pos, hbuf_, hbuf_len);
     pos += hbuf_len;
-    memcpy (pos, ipv6_suffix, sizeof ipv6_suffix - 1);
-    pos += sizeof ipv6_suffix - 1;
-    pos += sprintf (pos, "%d", ntohs (port));
+    memcpy (pos, ipv6_suffix_, sizeof ipv6_suffix_ - 1);
+    pos += sizeof ipv6_suffix_ - 1;
+    pos += sprintf (pos, "%d", ntohs (port_));
     return std::string (buf, pos - buf);
 }
 
@@ -203,11 +203,6 @@ zmq::tcp_address_mask_t::tcp_address_mas
     memset (&_network_address, 0, sizeof (_network_address));
 }
 
-int zmq::tcp_address_mask_t::mask () const
-{
-    return _address_mask;
-}
-
 int zmq::tcp_address_mask_t::resolve (const char *name_, bool ipv6_)
 {
     // Find '/' at the end that separates address from the cidr mask number.
@@ -264,53 +259,6 @@ int zmq::tcp_address_mask_t::resolve (co
     return 0;
 }
 
-int zmq::tcp_address_mask_t::to_string (std::string &addr_) const
-{
-    if (_network_address.family () != AF_INET
-        && _network_address.family () != AF_INET6) {
-        addr_.clear ();
-        return -1;
-    }
-    if (_address_mask == -1) {
-        addr_.clear ();
-        return -1;
-    }
-
-    char hbuf[NI_MAXHOST];
-    const int rc = getnameinfo (_network_address.as_sockaddr (),
-                                _network_address.sockaddr_len (), hbuf,
-                                sizeof (hbuf), NULL, 0, NI_NUMERICHOST);
-    if (rc != 0) {
-        addr_.clear ();
-        return rc;
-    }
-
-    const size_t max_mask_len = 4;
-    const char ipv6_prefix[] = "[";
-    const char ipv6_suffix[] = "]/";
-    const char ipv4_suffix[] = "/";
-    char
-      buf[NI_MAXHOST + sizeof ipv6_prefix + sizeof ipv6_suffix + max_mask_len];
-    char *pos = buf;
-    if (_network_address.family () == AF_INET6) {
-        memcpy (pos, ipv6_prefix, sizeof ipv6_prefix - 1);
-        pos += sizeof ipv6_prefix - 1;
-    }
-    const size_t hbuf_len = strlen (hbuf);
-    memcpy (pos, hbuf, hbuf_len);
-    pos += hbuf_len;
-    if (_network_address.family () == AF_INET6) {
-        memcpy (pos, ipv6_suffix, sizeof ipv6_suffix - 1);
-        pos += sizeof ipv6_suffix - 1;
-    } else {
-        memcpy (pos, ipv4_suffix, sizeof ipv4_suffix - 1);
-        pos += sizeof ipv4_suffix - 1;
-    }
-    pos += sprintf (pos, "%d", _address_mask);
-    addr_.assign (buf, pos - buf);
-    return 0;
-}
-
 bool zmq::tcp_address_mask_t::match_address (const struct sockaddr *ss_,
                                              const socklen_t ss_len_) const
 {
diff -pruN 4.3.2-2/src/tcp_address.hpp 4.3.3-1/src/tcp_address.hpp
--- 4.3.2-2/src/tcp_address.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tcp_address.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -82,13 +82,7 @@ class tcp_address_mask_t
     // Works only with remote hostnames.
     int resolve (const char *name_, bool ipv6_);
 
-    // The opposite to resolve()
-    int to_string (std::string &addr_) const;
-
-    int mask () const;
-
-    bool match_address (const struct sockaddr *ss_,
-                        const socklen_t ss_len_) const;
+    bool match_address (const struct sockaddr *ss_, socklen_t ss_len_) const;
 
   private:
     ip_addr_t _network_address;
diff -pruN 4.3.2-2/src/tcp_connecter.cpp 4.3.3-1/src/tcp_connecter.cpp
--- 4.3.2-2/src/tcp_connecter.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tcp_connecter.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -33,7 +33,6 @@
 
 #include "macros.hpp"
 #include "tcp_connecter.hpp"
-#include "stream_engine.hpp"
 #include "io_thread.hpp"
 #include "err.hpp"
 #include "ip.hpp"
@@ -104,6 +103,15 @@ void zmq::tcp_connecter_t::out_event ()
 
     const fd_t fd = connect ();
 
+    if (fd == retired_fd
+        && ((options.reconnect_stop & ZMQ_RECONNECT_STOP_CONN_REFUSED)
+            && errno == ECONNREFUSED)) {
+        send_conn_failed (_session);
+        close ();
+        terminate ();
+        return;
+    }
+
     //  Handle the error condition by attempt to reconnect.
     if (fd == retired_fd || !tune_socket (fd)) {
         close ();
@@ -267,6 +275,7 @@ zmq::fd_t zmq::tcp_connecter_t::connect
             || err == WSAENOBUFS) {
             wsa_assert_no (err);
         }
+        errno = wsa_error_to_errno (err);
         return retired_fd;
     }
 #else
@@ -297,8 +306,8 @@ bool zmq::tcp_connecter_t::tune_socket (
 {
     const int rc = tune_tcp_socket (fd_)
                    | tune_tcp_keepalives (
-                       fd_, options.tcp_keepalive, options.tcp_keepalive_cnt,
-                       options.tcp_keepalive_idle, options.tcp_keepalive_intvl)
+                     fd_, options.tcp_keepalive, options.tcp_keepalive_cnt,
+                     options.tcp_keepalive_idle, options.tcp_keepalive_intvl)
                    | tune_tcp_maxrt (fd_, options.tcp_maxrt);
     return rc == 0;
 }
diff -pruN 4.3.2-2/src/tcp_connecter.hpp 4.3.3-1/src/tcp_connecter.hpp
--- 4.3.2-2/src/tcp_connecter.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tcp_connecter.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,7 +36,7 @@
 
 namespace zmq
 {
-class tcp_connecter_t : public stream_connecter_base_t
+class tcp_connecter_t ZMQ_FINAL : public stream_connecter_base_t
 {
   public:
     //  If 'delayed_start' is true connecter first waits for a while,
@@ -83,8 +83,7 @@ class tcp_connecter_t : public stream_co
     //  True iff a timer has been started.
     bool _connect_timer_started;
 
-    tcp_connecter_t (const tcp_connecter_t &);
-    const tcp_connecter_t &operator= (const tcp_connecter_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (tcp_connecter_t)
 };
 }
 
diff -pruN 4.3.2-2/src/tcp.cpp 4.3.3-1/src/tcp.cpp
--- 4.3.2-2/src/tcp.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tcp.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -60,9 +60,10 @@ int zmq::tune_tcp_socket (fd_t s_)
     //  so using Nagle wouldn't improve throughput in anyway, but it would
     //  hurt latency.
     int nodelay = 1;
-    int rc = setsockopt (s_, IPPROTO_TCP, TCP_NODELAY,
-                         reinterpret_cast<char *> (&nodelay), sizeof (int));
-    tcp_assert_tuning_error (s_, rc);
+    const int rc =
+      setsockopt (s_, IPPROTO_TCP, TCP_NODELAY,
+                  reinterpret_cast<char *> (&nodelay), sizeof (int));
+    assert_success_or_recoverable (s_, rc);
     if (rc != 0)
         return rc;
 
@@ -71,7 +72,7 @@ int zmq::tune_tcp_socket (fd_t s_)
     int nodelack = 1;
     rc = setsockopt (s_, IPPROTO_TCP, TCP_NODELACK, (char *) &nodelack,
                      sizeof (int));
-    tcp_assert_tuning_error (s_, rc);
+    assert_success_or_recoverable (s_, rc);
 #endif
     return rc;
 }
@@ -81,7 +82,7 @@ int zmq::set_tcp_send_buffer (fd_t sockf
     const int rc =
       setsockopt (sockfd_, SOL_SOCKET, SO_SNDBUF,
                   reinterpret_cast<char *> (&bufsize_), sizeof bufsize_);
-    tcp_assert_tuning_error (sockfd_, rc);
+    assert_success_or_recoverable (sockfd_, rc);
     return rc;
 }
 
@@ -90,7 +91,7 @@ int zmq::set_tcp_receive_buffer (fd_t so
     const int rc =
       setsockopt (sockfd_, SOL_SOCKET, SO_RCVBUF,
                   reinterpret_cast<char *> (&bufsize_), sizeof bufsize_);
-    tcp_assert_tuning_error (sockfd_, rc);
+    assert_success_or_recoverable (sockfd_, rc);
     return rc;
 }
 
@@ -120,10 +121,10 @@ int zmq::tune_tcp_keepalives (fd_t s_,
         keepalive_opts.keepaliveinterval =
           keepalive_intvl_ != -1 ? keepalive_intvl_ * 1000 : 1000;
         DWORD num_bytes_returned;
-        int rc = WSAIoctl (s_, SIO_KEEPALIVE_VALS, &keepalive_opts,
-                           sizeof (keepalive_opts), NULL, 0,
-                           &num_bytes_returned, NULL, NULL);
-        tcp_assert_tuning_error (s_, rc);
+        const int rc = WSAIoctl (s_, SIO_KEEPALIVE_VALS, &keepalive_opts,
+                                 sizeof (keepalive_opts), NULL, 0,
+                                 &num_bytes_returned, NULL, NULL);
+        assert_success_or_recoverable (s_, rc);
         if (rc == SOCKET_ERROR)
             return rc;
     }
@@ -133,7 +134,7 @@ int zmq::tune_tcp_keepalives (fd_t s_,
         int rc =
           setsockopt (s_, SOL_SOCKET, SO_KEEPALIVE,
                       reinterpret_cast<char *> (&keepalive_), sizeof (int));
-        tcp_assert_tuning_error (s_, rc);
+        assert_success_or_recoverable (s_, rc);
         if (rc != 0)
             return rc;
 
@@ -141,7 +142,7 @@ int zmq::tune_tcp_keepalives (fd_t s_,
         if (keepalive_cnt_ != -1) {
             int rc = setsockopt (s_, IPPROTO_TCP, TCP_KEEPCNT, &keepalive_cnt_,
                                  sizeof (int));
-            tcp_assert_tuning_error (s_, rc);
+            assert_success_or_recoverable (s_, rc);
             if (rc != 0)
                 return rc;
         }
@@ -151,7 +152,7 @@ int zmq::tune_tcp_keepalives (fd_t s_,
         if (keepalive_idle_ != -1) {
             int rc = setsockopt (s_, IPPROTO_TCP, TCP_KEEPIDLE,
                                  &keepalive_idle_, sizeof (int));
-            tcp_assert_tuning_error (s_, rc);
+            assert_success_or_recoverable (s_, rc);
             if (rc != 0)
                 return rc;
         }
@@ -160,7 +161,7 @@ int zmq::tune_tcp_keepalives (fd_t s_,
         if (keepalive_idle_ != -1) {
             int rc = setsockopt (s_, IPPROTO_TCP, TCP_KEEPALIVE,
                                  &keepalive_idle_, sizeof (int));
-            tcp_assert_tuning_error (s_, rc);
+            assert_success_or_recoverable (s_, rc);
             if (rc != 0)
                 return rc;
         }
@@ -171,7 +172,7 @@ int zmq::tune_tcp_keepalives (fd_t s_,
         if (keepalive_intvl_ != -1) {
             int rc = setsockopt (s_, IPPROTO_TCP, TCP_KEEPINTVL,
                                  &keepalive_intvl_, sizeof (int));
-            tcp_assert_tuning_error (s_, rc);
+            assert_success_or_recoverable (s_, rc);
             if (rc != 0)
                 return rc;
         }
@@ -193,16 +194,16 @@ int zmq::tune_tcp_maxrt (fd_t sockfd_, i
 #if defined(ZMQ_HAVE_WINDOWS) && defined(TCP_MAXRT)
     // msdn says it's supported in >= Vista, >= Windows Server 2003
     timeout_ /= 1000; // in seconds
-    int rc =
+    const int rc =
       setsockopt (sockfd_, IPPROTO_TCP, TCP_MAXRT,
                   reinterpret_cast<char *> (&timeout_), sizeof (timeout_));
-    tcp_assert_tuning_error (sockfd_, rc);
+    assert_success_or_recoverable (sockfd_, rc);
     return rc;
 // FIXME: should be ZMQ_HAVE_TCP_USER_TIMEOUT
 #elif defined(TCP_USER_TIMEOUT)
     int rc = setsockopt (sockfd_, IPPROTO_TCP, TCP_USER_TIMEOUT, &timeout_,
                          sizeof (timeout_));
-    tcp_assert_tuning_error (sockfd_, rc);
+    assert_success_or_recoverable (sockfd_, rc);
     return rc;
 #else
     return 0;
@@ -213,7 +214,7 @@ int zmq::tcp_write (fd_t s_, const void
 {
 #ifdef ZMQ_HAVE_WINDOWS
 
-    int nbytes = send (s_, (char *) data_, static_cast<int> (size_), 0);
+    const int nbytes = send (s_, (char *) data_, static_cast<int> (size_), 0);
 
     //  If not a single byte can be written to the socket in non-blocking mode
     //  we'll get an error (this may happen during the speculative write).
@@ -316,62 +317,18 @@ int zmq::tcp_read (fd_t s_, void *data_,
 #endif
 }
 
-void zmq::tcp_assert_tuning_error (zmq::fd_t s_, int rc_)
-{
-    if (rc_ == 0)
-        return;
-
-    //  Check whether an error occurred
-    int err = 0;
-#if defined ZMQ_HAVE_HPUX || defined ZMQ_HAVE_VXWORKS
-    int len = sizeof err;
-#else
-    socklen_t len = sizeof err;
-#endif
-
-    int rc = getsockopt (s_, SOL_SOCKET, SO_ERROR,
-                         reinterpret_cast<char *> (&err), &len);
-
-    //  Assert if the error was caused by 0MQ bug.
-    //  Networking problems are OK. No need to assert.
-#ifdef ZMQ_HAVE_WINDOWS
-    zmq_assert (rc == 0);
-    if (err != 0) {
-        wsa_assert (err == WSAECONNREFUSED || err == WSAECONNRESET
-                    || err == WSAECONNABORTED || err == WSAEINTR
-                    || err == WSAETIMEDOUT || err == WSAEHOSTUNREACH
-                    || err == WSAENETUNREACH || err == WSAENETDOWN
-                    || err == WSAENETRESET || err == WSAEACCES
-                    || err == WSAEINVAL || err == WSAEADDRINUSE);
-    }
-#else
-    //  Following code should handle both Berkeley-derived socket
-    //  implementations and Solaris.
-    if (rc == -1)
-        err = errno;
-    if (err != 0) {
-        errno = err;
-        errno_assert (errno == ECONNREFUSED || errno == ECONNRESET
-                      || errno == ECONNABORTED || errno == EINTR
-                      || errno == ETIMEDOUT || errno == EHOSTUNREACH
-                      || errno == ENETUNREACH || errno == ENETDOWN
-                      || errno == ENETRESET || errno == EINVAL);
-    }
-#endif
-}
-
 void zmq::tcp_tune_loopback_fast_path (const fd_t socket_)
 {
 #if defined ZMQ_HAVE_WINDOWS && defined SIO_LOOPBACK_FAST_PATH
     int sio_loopback_fastpath = 1;
     DWORD number_of_bytes_returned = 0;
 
-    int rc = WSAIoctl (socket_, SIO_LOOPBACK_FAST_PATH, &sio_loopback_fastpath,
-                       sizeof sio_loopback_fastpath, NULL, 0,
-                       &number_of_bytes_returned, 0, 0);
+    const int rc = WSAIoctl (
+      socket_, SIO_LOOPBACK_FAST_PATH, &sio_loopback_fastpath,
+      sizeof sio_loopback_fastpath, NULL, 0, &number_of_bytes_returned, 0, 0);
 
     if (SOCKET_ERROR == rc) {
-        DWORD last_error = ::WSAGetLastError ();
+        const DWORD last_error = ::WSAGetLastError ();
 
         if (WSAEOPNOTSUPP == last_error) {
             // This system is not Windows 8 or Server 2012, and the call is not supported.
diff -pruN 4.3.2-2/src/tcp.hpp 4.3.3-1/src/tcp.hpp
--- 4.3.2-2/src/tcp.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tcp.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -66,11 +66,7 @@ int tcp_write (fd_t s_, const void *data
 //  Zero indicates the peer has closed the connection.
 int tcp_read (fd_t s_, void *data_, size_t size_);
 
-//  Asserts that an internal error did not occur.  Does not assert
-//  on network errors such as reset or aborted connections.
-void tcp_assert_tuning_error (fd_t s_, int rc_);
-
-void tcp_tune_loopback_fast_path (const fd_t socket_);
+void tcp_tune_loopback_fast_path (fd_t socket_);
 
 //  Resolves the given address_ string, opens a socket and sets socket options
 //  according to the passed options_. On success, returns the socket
diff -pruN 4.3.2-2/src/tcp_listener.cpp 4.3.3-1/src/tcp_listener.cpp
--- 4.3.2-2/src/tcp_listener.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tcp_listener.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -68,7 +68,7 @@ zmq::tcp_listener_t::tcp_listener_t (io_
 
 void zmq::tcp_listener_t::in_event ()
 {
-    fd_t fd = accept ();
+    const fd_t fd = accept ();
 
     //  If connection was reset by the peer in the meantime, just ignore it.
     //  TODO: Handle specific errors like ENFILE/EMFILE etc.
@@ -81,8 +81,8 @@ void zmq::tcp_listener_t::in_event ()
     int rc = tune_tcp_socket (fd);
     rc = rc
          | tune_tcp_keepalives (
-             fd, options.tcp_keepalive, options.tcp_keepalive_cnt,
-             options.tcp_keepalive_idle, options.tcp_keepalive_intvl);
+           fd, options.tcp_keepalive, options.tcp_keepalive_cnt,
+           options.tcp_keepalive_idle, options.tcp_keepalive_intvl);
     rc = rc | tune_tcp_maxrt (fd, options.tcp_maxrt);
     if (rc != 0) {
         _socket->event_accept_failed (
@@ -163,7 +163,7 @@ int zmq::tcp_listener_t::create_socket (
     return 0;
 
 error:
-    int err = errno;
+    const int err = errno;
     close ();
     errno = err;
     return -1;
@@ -205,7 +205,7 @@ zmq::fd_t zmq::tcp_listener_t::accept ()
     fd_t sock = ::accept4 (_s, reinterpret_cast<struct sockaddr *> (&ss),
                            &ss_len, SOCK_CLOEXEC);
 #else
-    fd_t sock =
+    const fd_t sock =
       ::accept (_s, reinterpret_cast<struct sockaddr *> (&ss), &ss_len);
 #endif
 
@@ -232,8 +232,10 @@ zmq::fd_t zmq::tcp_listener_t::accept ()
 
     if (!options.tcp_accept_filters.empty ()) {
         bool matched = false;
-        for (options_t::tcp_accept_filters_t::size_type i = 0;
-             i != options.tcp_accept_filters.size (); ++i) {
+        for (options_t::tcp_accept_filters_t::size_type
+               i = 0,
+               size = options.tcp_accept_filters.size ();
+             i != size; ++i) {
             if (options.tcp_accept_filters[i].match_address (
                   reinterpret_cast<struct sockaddr *> (&ss), ss_len)) {
                 matched = true;
@@ -242,7 +244,7 @@ zmq::fd_t zmq::tcp_listener_t::accept ()
         }
         if (!matched) {
 #ifdef ZMQ_HAVE_WINDOWS
-            int rc = closesocket (sock);
+            const int rc = closesocket (sock);
             wsa_assert (rc != SOCKET_ERROR);
 #else
             int rc = ::close (sock);
@@ -254,7 +256,7 @@ zmq::fd_t zmq::tcp_listener_t::accept ()
 
     if (zmq::set_nosigpipe (sock)) {
 #ifdef ZMQ_HAVE_WINDOWS
-        int rc = closesocket (sock);
+        const int rc = closesocket (sock);
         wsa_assert (rc != SOCKET_ERROR);
 #else
         int rc = ::close (sock);
diff -pruN 4.3.2-2/src/tcp_listener.hpp 4.3.3-1/src/tcp_listener.hpp
--- 4.3.2-2/src/tcp_listener.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tcp_listener.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,7 +36,7 @@
 
 namespace zmq
 {
-class tcp_listener_t : public stream_listener_base_t
+class tcp_listener_t ZMQ_FINAL : public stream_listener_base_t
 {
   public:
     tcp_listener_t (zmq::io_thread_t *io_thread_,
@@ -64,8 +64,7 @@ class tcp_listener_t : public stream_lis
     //  Address to listen on.
     tcp_address_t _address;
 
-    tcp_listener_t (const tcp_listener_t &);
-    const tcp_listener_t &operator= (const tcp_listener_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (tcp_listener_t)
 };
 }
 
diff -pruN 4.3.2-2/src/thread.cpp 4.3.3-1/src/thread.cpp
--- 4.3.2-2/src/thread.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/thread.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -32,6 +32,10 @@
 #include "thread.hpp"
 #include "err.hpp"
 
+#ifdef ZMQ_HAVE_WINDOWS
+#include <winnt.h>
+#endif
+
 bool zmq::thread_t::get_started () const
 {
     return _started;
@@ -46,7 +50,7 @@ static DWORD thread_routine (LPVOID arg_
 static unsigned int __stdcall thread_routine (void *arg_)
 #endif
 {
-    zmq::thread_t *self = (zmq::thread_t *) arg_;
+    zmq::thread_t *self = static_cast<zmq::thread_t *> (arg_);
     self->applyThreadName ();
     self->_tfn (self->_arg);
     return 0;
@@ -61,10 +65,10 @@ void zmq::thread_t::start (thread_fn *tf
         strncpy (_name, name_, sizeof (_name) - 1);
 #if defined _WIN32_WCE
     _descriptor =
-      (HANDLE) CreateThread (NULL, 0, &::thread_routine, this, 0, NULL);
+      (HANDLE) CreateThread (NULL, 0, &::thread_routine, this, 0, &_thread_id);
 #else
-    _descriptor =
-      (HANDLE) _beginthreadex (NULL, 0, &::thread_routine, this, 0, NULL);
+    _descriptor = (HANDLE) _beginthreadex (NULL, 0, &::thread_routine, this, 0,
+                                           &_thread_id);
 #endif
     win_assert (_descriptor != NULL);
     _started = true;
@@ -72,15 +76,15 @@ void zmq::thread_t::start (thread_fn *tf
 
 bool zmq::thread_t::is_current_thread () const
 {
-    return GetCurrentThreadId () == GetThreadId (_descriptor);
+    return GetCurrentThreadId () == _thread_id;
 }
 
 void zmq::thread_t::stop ()
 {
     if (_started) {
-        DWORD rc = WaitForSingleObject (_descriptor, INFINITE);
+        const DWORD rc = WaitForSingleObject (_descriptor, INFINITE);
         win_assert (rc != WAIT_FAILED);
-        BOOL rc2 = CloseHandle (_descriptor);
+        const BOOL rc2 = CloseHandle (_descriptor);
         win_assert (rc2 != 0);
     }
 }
@@ -113,10 +117,27 @@ struct thread_info_t
 #pragma pack(pop)
 }
 
+struct MY_EXCEPTION_REGISTRATION_RECORD
+{
+    typedef EXCEPTION_DISPOSITION (NTAPI *HandlerFunctionType) (
+      EXCEPTION_RECORD *, void *, CONTEXT *, void *);
+
+    MY_EXCEPTION_REGISTRATION_RECORD *Next;
+    HandlerFunctionType Handler;
+};
+
+static EXCEPTION_DISPOSITION NTAPI continue_execution (EXCEPTION_RECORD *rec,
+                                                       void *frame,
+                                                       CONTEXT *ctx,
+                                                       void *disp)
+{
+    return ExceptionContinueExecution;
+}
+
 void zmq::thread_t::
   applyThreadName () // to be called in secondary thread context
 {
-    if (!_name[0])
+    if (!_name[0] || !IsDebuggerPresent ())
         return;
 
     thread_info_t thread_info;
@@ -125,17 +146,21 @@ void zmq::thread_t::
     thread_info._thread_id = -1;
     thread_info._flags = 0;
 
-#pragma warning(push)
-#pragma warning(disable : 6320 6322)
-    __try {
-        DWORD MS_VC_EXCEPTION = 0x406D1388;
-        RaiseException (MS_VC_EXCEPTION, 0,
-                        sizeof (thread_info) / sizeof (ULONG_PTR),
-                        (ULONG_PTR *) &thread_info);
-    }
-    __except (EXCEPTION_CONTINUE_EXECUTION) {
-    }
-#pragma warning(pop)
+    NT_TIB *tib = ((NT_TIB *) NtCurrentTeb ());
+
+    MY_EXCEPTION_REGISTRATION_RECORD rec;
+    rec.Next = (MY_EXCEPTION_REGISTRATION_RECORD *) tib->ExceptionList;
+    rec.Handler = continue_execution;
+
+    // push our handler, raise, and finally pop our handler
+    tib->ExceptionList = (_EXCEPTION_REGISTRATION_RECORD *) &rec;
+    const DWORD MS_VC_EXCEPTION = 0x406D1388;
+    RaiseException (MS_VC_EXCEPTION, 0,
+                    sizeof (thread_info) / sizeof (ULONG_PTR),
+                    (ULONG_PTR *) &thread_info);
+    tib->ExceptionList =
+      (_EXCEPTION_REGISTRATION_RECORD
+         *) (((MY_EXCEPTION_REGISTRATION_RECORD *) tib->ExceptionList)->Next);
 }
 
 #elif defined ZMQ_HAVE_VXWORKS
@@ -252,10 +277,10 @@ bool zmq::thread_t::is_current_thread ()
 }
 
 void zmq::thread_t::setSchedulingParameters (
-  int priority_, int schedulingPolicy_, const std::set<int> &affinity_cpus_)
+  int priority_, int scheduling_policy_, const std::set<int> &affinity_cpus_)
 {
     _thread_priority = priority_;
-    _thread_sched_policy = schedulingPolicy_;
+    _thread_sched_policy = scheduling_policy_;
     _thread_affinity_cpus = affinity_cpus_;
 }
 
@@ -330,8 +355,9 @@ void zmq::thread_t::
     if (!_thread_affinity_cpus.empty ()) {
         cpu_set_t cpuset;
         CPU_ZERO (&cpuset);
-        for (std::set<int>::const_iterator it = _thread_affinity_cpus.begin ();
-             it != _thread_affinity_cpus.end (); it++) {
+        for (std::set<int>::const_iterator it = _thread_affinity_cpus.begin (),
+                                           end = _thread_affinity_cpus.end ();
+             it != end; it++) {
             CPU_SET ((int) (*it), &cpuset);
         }
         rc =
diff -pruN 4.3.2-2/src/thread.hpp 4.3.3-1/src/thread.hpp
--- 4.3.2-2/src/thread.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/thread.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -53,7 +53,7 @@ typedef void(thread_fn) (void *);
 class thread_t
 {
   public:
-    inline thread_t () :
+    thread_t () :
         _tfn (NULL),
         _arg (NULL),
         _started (false),
@@ -107,6 +107,11 @@ class thread_t
 
 #ifdef ZMQ_HAVE_WINDOWS
     HANDLE _descriptor;
+#if defined _WIN32_WCE
+    DWORD _thread_id;
+#else
+    unsigned int _thread_id;
+#endif
 #elif defined ZMQ_HAVE_VXWORKS
     int _descriptor;
     enum
@@ -124,8 +129,7 @@ class thread_t
     int _thread_sched_policy;
     std::set<int> _thread_affinity_cpus;
 
-    thread_t (const thread_t &);
-    const thread_t &operator= (const thread_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (thread_t)
 };
 }
 
diff -pruN 4.3.2-2/src/timers.cpp 4.3.3-1/src/timers.cpp
--- 4.3.2-2/src/timers.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/timers.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -43,7 +43,7 @@ zmq::timers_t::~timers_t ()
     _tag = 0xdeadbeef;
 }
 
-bool zmq::timers_t::check_tag ()
+bool zmq::timers_t::check_tag () const
 {
     return _tag == 0xCAFEDADA;
 }
diff -pruN 4.3.2-2/src/timers.hpp 4.3.3-1/src/timers.hpp
--- 4.3.2-2/src/timers.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/timers.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -74,7 +74,7 @@ class timers_t
     int execute ();
 
     //  Return false if object is not a timers class.
-    bool check_tag ();
+    bool check_tag () const;
 
   private:
     //  Used to check whether the object is a timers class.
@@ -99,10 +99,9 @@ class timers_t
     typedef std::set<int> cancelled_timers_t;
     cancelled_timers_t _cancelled_timers;
 
-    timers_t (const timers_t &);
-    const timers_t &operator= (const timers_t &);
-
     struct match_by_id;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (timers_t)
 };
 }
 
diff -pruN 4.3.2-2/src/tipc_address.cpp 4.3.3-1/src/tipc_address.cpp
--- 4.3.2-2/src/tipc_address.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tipc_address.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -44,13 +44,13 @@ zmq::tipc_address_t::tipc_address_t ()
     _random = false;
 }
 
-zmq::tipc_address_t::tipc_address_t (const sockaddr *sa, socklen_t sa_len)
+zmq::tipc_address_t::tipc_address_t (const sockaddr *sa_, socklen_t sa_len_)
 {
-    zmq_assert (sa && sa_len > 0);
+    zmq_assert (sa_ && sa_len_ > 0);
 
     memset (&address, 0, sizeof address);
-    if (sa->sa_family == AF_TIPC)
-        memcpy (&address, sa, sa_len);
+    if (sa_->sa_family == AF_TIPC)
+        memcpy (&address, sa_, sa_len_);
 
     _random = false;
 }
@@ -70,7 +70,7 @@ bool zmq::tipc_address_t::is_service ()
 
     return true;
 }
-int zmq::tipc_address_t::resolve (const char *name)
+int zmq::tipc_address_t::resolve (const char *name_)
 {
     unsigned int type = 0;
     unsigned int lower = 0;
@@ -82,7 +82,7 @@ int zmq::tipc_address_t::resolve (const
     int res;
 
 
-    if (strncmp (name, "<*>", 3) == 0) {
+    if (strncmp (name_, "<*>", 3) == 0) {
         set_random ();
         address.family = AF_TIPC;
         address.addrtype = TIPC_ADDR_ID;
@@ -92,9 +92,9 @@ int zmq::tipc_address_t::resolve (const
         return 0;
     }
 
-    res = sscanf (name, "{%u,%u,%u}", &type, &lower, &upper);
+    res = sscanf (name_, "{%u,%u,%u}", &type, &lower, &upper);
     /* Fetch optional domain suffix. */
-    if ((domain = strchr (name, '@'))) {
+    if ((domain = strchr (name_, '@'))) {
         if (sscanf (domain, "@%u.%u.%u%c", &z, &c, &n, &eof) != 3)
             return EINVAL;
     }
@@ -108,7 +108,8 @@ int zmq::tipc_address_t::resolve (const
         address.addr.nameseq.upper = upper;
         address.scope = TIPC_ZONE_SCOPE;
         return 0;
-    } else if (res == 2 && type > TIPC_RESERVED_TYPES) {
+    }
+    if (res == 2 && type > TIPC_RESERVED_TYPES) {
         address.family = AF_TIPC;
         address.addrtype = TIPC_ADDR_NAME;
         address.addr.name.name.type = type;
@@ -117,7 +118,7 @@ int zmq::tipc_address_t::resolve (const
         address.scope = 0;
         return 0;
     } else if (res == 0) {
-        res = sscanf (name, "<%u.%u.%u:%u>", &z, &c, &n, &ref);
+        res = sscanf (name_, "<%u.%u.%u:%u>", &z, &c, &n, &ref);
         if (res == 4) {
             address.family = AF_TIPC;
             address.addrtype = TIPC_ADDR_ID;
@@ -165,7 +166,7 @@ const sockaddr *zmq::tipc_address_t::add
 
 socklen_t zmq::tipc_address_t::addrlen () const
 {
-    return (socklen_t) sizeof address;
+    return static_cast<socklen_t> (sizeof address);
 }
 
 #endif
diff -pruN 4.3.2-2/src/tipc_connecter.cpp 4.3.3-1/src/tipc_connecter.cpp
--- 4.3.2-2/src/tipc_connecter.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tipc_connecter.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,7 +36,6 @@
 #include <new>
 #include <string>
 
-#include "stream_engine.hpp"
 #include "io_thread.hpp"
 #include "platform.hpp"
 #include "random.hpp"
@@ -117,7 +116,7 @@ int zmq::tipc_connecter_t::open ()
     }
     //  Create the socket.
     _s = open_socket (AF_TIPC, SOCK_STREAM, 0);
-    if (_s == -1)
+    if (_s == retired_fd)
         return -1;
 
     //  Set the non-blocking flag.
@@ -154,7 +153,8 @@ zmq::fd_t zmq::tipc_connecter_t::connect
 #else
     socklen_t len = sizeof (err);
 #endif
-    int rc = getsockopt (_s, SOL_SOCKET, SO_ERROR, (char *) &err, &len);
+    int rc = getsockopt (_s, SOL_SOCKET, SO_ERROR,
+                         reinterpret_cast<char *> (&err), &len);
     if (rc == -1)
         err = errno;
     if (err != 0) {
diff -pruN 4.3.2-2/src/tipc_connecter.hpp 4.3.3-1/src/tipc_connecter.hpp
--- 4.3.2-2/src/tipc_connecter.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tipc_connecter.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -39,7 +39,7 @@
 
 namespace zmq
 {
-class tipc_connecter_t : public stream_connecter_base_t
+class tipc_connecter_t ZMQ_FINAL : public stream_connecter_base_t
 {
   public:
     //  If 'delayed_start' is true connecter first waits for a while,
@@ -52,10 +52,10 @@ class tipc_connecter_t : public stream_c
 
   private:
     //  Handlers for I/O events.
-    void out_event ();
+    void out_event () ZMQ_FINAL;
 
     //  Internal function to start the actual connection establishment.
-    void start_connecting ();
+    void start_connecting () ZMQ_FINAL;
 
     //  Get the file descriptor of newly created connection. Returns
     //  retired_fd if the connection was unsuccessful.
@@ -66,8 +66,7 @@ class tipc_connecter_t : public stream_c
     //  EAGAIN errno if async connect was launched.
     int open ();
 
-    tipc_connecter_t (const tipc_connecter_t &);
-    const tipc_connecter_t &operator= (const tipc_connecter_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (tipc_connecter_t)
 };
 }
 
diff -pruN 4.3.2-2/src/tipc_listener.cpp 4.3.3-1/src/tipc_listener.cpp
--- 4.3.2-2/src/tipc_listener.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tipc_listener.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -93,7 +93,8 @@ int zmq::tipc_listener_t::set_local_addr
         return -1;
 
     // Cannot bind non-random Port Identity
-    struct sockaddr_tipc *a = (sockaddr_tipc *) _address.addr ();
+    const sockaddr_tipc *const a =
+      reinterpret_cast<const sockaddr_tipc *> (_address.addr ());
     if (!_address.is_random () && a->addrtype == TIPC_ADDR_ID) {
         errno = EINVAL;
         return -1;
@@ -101,7 +102,7 @@ int zmq::tipc_listener_t::set_local_addr
 
     //  Create a listening socket.
     _s = open_socket (AF_TIPC, SOCK_STREAM, 0);
-    if (_s == -1)
+    if (_s == retired_fd)
         return -1;
 
     // If random Port Identity, update address object to reflect the assigned address
@@ -111,7 +112,8 @@ int zmq::tipc_listener_t::set_local_addr
         if (sl == 0)
             goto error;
 
-        _address = tipc_address_t ((struct sockaddr *) &ss, sl);
+        _address =
+          tipc_address_t (reinterpret_cast<struct sockaddr *> (&ss), sl);
     }
 
 
@@ -156,7 +158,8 @@ zmq::fd_t zmq::tipc_listener_t::accept (
 #ifdef ZMQ_HAVE_VXWORKS
     fd_t sock = ::accept (_s, (struct sockaddr *) &ss, (int *) &ss_len);
 #else
-    fd_t sock = ::accept (_s, (struct sockaddr *) &ss, &ss_len);
+    fd_t sock =
+      ::accept (_s, reinterpret_cast<struct sockaddr *> (&ss), &ss_len);
 #endif
     if (sock == -1) {
         errno_assert (errno == EAGAIN || errno == EWOULDBLOCK
diff -pruN 4.3.2-2/src/tipc_listener.hpp 4.3.3-1/src/tipc_listener.hpp
--- 4.3.2-2/src/tipc_listener.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tipc_listener.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -42,7 +42,7 @@
 
 namespace zmq
 {
-class tipc_listener_t : public stream_listener_base_t
+class tipc_listener_t ZMQ_FINAL : public stream_listener_base_t
 {
   public:
     tipc_listener_t (zmq::io_thread_t *io_thread_,
@@ -53,11 +53,12 @@ class tipc_listener_t : public stream_li
     int set_local_address (const char *addr_);
 
   protected:
-    std::string get_socket_name (fd_t fd_, socket_end_t socket_end_) const;
+    std::string get_socket_name (fd_t fd_,
+                                 socket_end_t socket_end_) const ZMQ_FINAL;
 
   private:
     //  Handlers for I/O events.
-    void in_event ();
+    void in_event () ZMQ_FINAL;
 
     //  Accept the new connection. Returns the file descriptor of the
     //  newly created connection. The function may return retired_fd
@@ -67,8 +68,7 @@ class tipc_listener_t : public stream_li
     // Address to listen on
     tipc_address_t _address;
 
-    tipc_listener_t (const tipc_listener_t &);
-    const tipc_listener_t &operator= (const tipc_listener_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (tipc_listener_t)
 };
 }
 
diff -pruN 4.3.2-2/src/trie.cpp 4.3.3-1/src/trie.cpp
--- 4.3.2-2/src/trie.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/trie.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -236,11 +236,11 @@ bool zmq::trie_t::rm (unsigned char *pre
     return ret;
 }
 
-bool zmq::trie_t::check (unsigned char *data_, size_t size_)
+bool zmq::trie_t::check (const unsigned char *data_, size_t size_) const
 {
     //  This function is on critical path. It deliberately doesn't use
     //  recursion to get a bit better performance.
-    trie_t *current = this;
+    const trie_t *current = this;
     while (true) {
         //  We've found a corresponding subscription!
         if (current->_refcnt)
diff -pruN 4.3.2-2/src/trie.hpp 4.3.3-1/src/trie.hpp
--- 4.3.2-2/src/trie.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/trie.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -32,6 +32,7 @@
 
 #include <stddef.h>
 
+#include "macros.hpp"
 #include "stdint.hpp"
 
 namespace zmq
@@ -51,7 +52,7 @@ class trie_t
     bool rm (unsigned char *prefix_, size_t size_);
 
     //  Check whether particular key is in the trie.
-    bool check (unsigned char *data_, size_t size_);
+    bool check (const unsigned char *data_, size_t size_) const;
 
     //  Apply the function supplied to each subscription in the trie.
     void apply (void (*func_) (unsigned char *data_, size_t size_, void *arg_),
@@ -77,8 +78,7 @@ class trie_t
         class trie_t **table;
     } _next;
 
-    trie_t (const trie_t &);
-    const trie_t &operator= (const trie_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (trie_t)
 };
 }
 
diff -pruN 4.3.2-2/src/tweetnacl.c 4.3.3-1/src/tweetnacl.c
--- 4.3.2-2/src/tweetnacl.c	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/tweetnacl.c	2020-09-07 10:12:14.000000000 +0000
@@ -679,7 +679,7 @@ sv scalarmult(gf p[4],gf q[4],const u8 *
   set25519(p[2],gf1);
   set25519(p[3],gf0);
   for (i = 255;i >= 0;--i) {
-    u8 b = (s[i/8]>>(i&7))&1;
+      const u8 b = (s[i/8]>>(i&7))&1;
     cswap(p,q,b);
     add(q,p);
     add(p,p);
diff -pruN 4.3.2-2/src/udp_address.cpp 4.3.3-1/src/udp_address.cpp
--- 4.3.2-2/src/udp_address.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/udp_address.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -68,7 +68,7 @@ int zmq::udp_address_t::resolve (const c
     //  URL
     const char *src_delimiter = strrchr (name_, ';');
     if (src_delimiter) {
-        std::string src_name (name_, src_delimiter - name_);
+        const std::string src_name (name_, src_delimiter - name_);
 
         ip_resolver_options_t src_resolver_opts;
 
@@ -104,11 +104,14 @@ int zmq::udp_address_t::resolve (const c
         if (src_name == "*") {
             _bind_interface = 0;
         } else {
+#if _WIN32_WINNT > _WIN32_WINNT_WINXP && !defined ZMQ_HAVE_WINDOWS_UWP         \
+  && !defined ZMQ_HAVE_VXWORKS
             _bind_interface = if_nametoindex (src_name.c_str ());
             if (_bind_interface == 0) {
                 //  Error, probably not an interface name.
                 _bind_interface = -1;
             }
+#endif
         }
 
         has_interface = true;
@@ -125,13 +128,13 @@ int zmq::udp_address_t::resolve (const c
 
     ip_resolver_t resolver (resolver_opts);
 
-    int rc = resolver.resolve (&_target_address, name_);
+    const int rc = resolver.resolve (&_target_address, name_);
     if (rc != 0) {
         return -1;
     }
 
     _is_multicast = _target_address.is_multicast ();
-    uint16_t port = _target_address.port ();
+    const uint16_t port = _target_address.port ();
 
     if (has_interface) {
         //  If we have an interface specifier then the target address must be a
diff -pruN 4.3.2-2/src/udp_address.hpp 4.3.3-1/src/udp_address.hpp
--- 4.3.2-2/src/udp_address.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/udp_address.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -47,7 +47,7 @@ class udp_address_t
     udp_address_t ();
     virtual ~udp_address_t ();
 
-    int resolve (const char *name_, bool receiver_, bool ipv6_);
+    int resolve (const char *name_, bool bind_, bool ipv6_);
 
     //  The opposite to resolve()
     virtual int to_string (std::string &addr_);
diff -pruN 4.3.2-2/src/udp_engine.cpp 4.3.3-1/src/udp_engine.cpp
--- 4.3.2-2/src/udp_engine.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/udp_engine.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -73,7 +73,7 @@ zmq::udp_engine_t::~udp_engine_t ()
 
     if (_fd != retired_fd) {
 #ifdef ZMQ_HAVE_WINDOWS
-        int rc = closesocket (_fd);
+        const int rc = closesocket (_fd);
         wsa_assert (rc != SOCKET_ERROR);
 #else
         int rc = close (_fd);
@@ -116,9 +116,17 @@ void zmq::udp_engine_t::plug (io_thread_
 
     const udp_address_t *const udp_addr = _address->resolved.udp_addr;
 
+    int rc = 0;
+
     // Bind the socket to a device if applicable
-    if (!_options.bound_device.empty ())
-        bind_to_device (_fd, _options.bound_device);
+    if (!_options.bound_device.empty ()) {
+        rc = rc | bind_to_device (_fd, _options.bound_device);
+        if (rc != 0) {
+            assert_success_or_recoverable (_fd, rc);
+            error (connection_error);
+            return;
+        }
+    }
 
     if (_send_enabled) {
         if (!_options.raw_socket) {
@@ -127,73 +135,18 @@ void zmq::udp_engine_t::plug (io_thread_
             _out_address_len = out->sockaddr_len ();
 
             if (out->is_multicast ()) {
-                int level;
-                int optname;
-
-                if (out->family () == AF_INET6) {
-                    level = IPPROTO_IPV6;
-                    optname = IPV6_MULTICAST_LOOP;
-                } else {
-                    level = IPPROTO_IP;
-                    optname = IP_MULTICAST_LOOP;
-                }
-
-                int loop = _options.multicast_loop;
-                int rc =
-                  setsockopt (_fd, level, optname,
-                              reinterpret_cast<char *> (&loop), sizeof (loop));
-
-#ifdef ZMQ_HAVE_WINDOWS
-                wsa_assert (rc != SOCKET_ERROR);
-#else
-                errno_assert (rc == 0);
-#endif
-
-                int hops = _options.multicast_hops;
-
-                if (hops > 0) {
-                    rc = setsockopt (_fd, level, IP_MULTICAST_TTL,
-                                     reinterpret_cast<char *> (&hops),
-                                     sizeof (hops));
-                } else {
-                    rc = 0;
-                }
-
-#ifdef ZMQ_HAVE_WINDOWS
-                wsa_assert (rc != SOCKET_ERROR);
-#else
-                errno_assert (rc == 0);
-#endif
-                if (out->family () == AF_INET6) {
-                    int bind_if = udp_addr->bind_if ();
-
-                    if (bind_if > 0) {
-                        //  If a bind interface is provided we tell the
-                        //  kernel to use it to send multicast packets
-                        rc = setsockopt (_fd, IPPROTO_IPV6, IPV6_MULTICAST_IF,
-                                         reinterpret_cast<char *> (&bind_if),
-                                         sizeof (bind_if));
-                    } else {
-                        rc = 0;
-                    }
-                } else {
-                    struct in_addr bind_addr =
-                      udp_addr->bind_addr ()->ipv4.sin_addr;
-
-                    if (bind_addr.s_addr != INADDR_ANY) {
-                        rc = setsockopt (_fd, IPPROTO_IP, IP_MULTICAST_IF,
-                                         reinterpret_cast<char *> (&bind_addr),
-                                         sizeof (bind_addr));
-                    } else {
-                        rc = 0;
-                    }
+                const bool is_ipv6 = (out->family () == AF_INET6);
+                rc = rc
+                     | set_udp_multicast_loop (_fd, is_ipv6,
+                                               _options.multicast_loop);
+
+                if (_options.multicast_hops > 0) {
+                    rc = rc
+                         | set_udp_multicast_ttl (_fd, is_ipv6,
+                                                  _options.multicast_hops);
                 }
 
-#ifdef ZMQ_HAVE_WINDOWS
-                wsa_assert (rc != SOCKET_ERROR);
-#else
-                errno_assert (rc == 0);
-#endif
+                rc = rc | set_udp_multicast_iface (_fd, is_ipv6, udp_addr);
             }
         } else {
             /// XXX fixme ?
@@ -201,38 +154,21 @@ void zmq::udp_engine_t::plug (io_thread_
             _out_address_len =
               static_cast<zmq_socklen_t> (sizeof (sockaddr_in));
         }
-
-        set_pollout (_handle);
     }
 
     if (_recv_enabled) {
-        int on = 1;
-        int rc = setsockopt (_fd, SOL_SOCKET, SO_REUSEADDR,
-                             reinterpret_cast<char *> (&on), sizeof (on));
-#ifdef ZMQ_HAVE_WINDOWS
-        wsa_assert (rc != SOCKET_ERROR);
-#else
-        errno_assert (rc == 0);
-#endif
+        rc = rc | set_udp_reuse_address (_fd, true);
 
         const ip_addr_t *bind_addr = udp_addr->bind_addr ();
         ip_addr_t any = ip_addr_t::any (bind_addr->family ());
         const ip_addr_t *real_bind_addr;
 
-        bool multicast = udp_addr->is_mcast ();
+        const bool multicast = udp_addr->is_mcast ();
 
         if (multicast) {
             //  Multicast addresses should be allowed to bind to more than
             //  one port as all ports should receive the message
-#ifdef SO_REUSEPORT
-            rc = setsockopt (_fd, SOL_SOCKET, SO_REUSEPORT,
-                             reinterpret_cast<char *> (&on), sizeof (on));
-#ifdef ZMQ_HAVE_WINDOWS
-            wsa_assert (rc != SOCKET_ERROR);
-#else
-            errno_assert (rc == 0);
-#endif
-#endif
+            rc = rc | set_udp_reuse_port (_fd, true);
 
             //  In multicast we should bind ANY and use the mreq struct to
             //  specify the interface
@@ -243,63 +179,173 @@ void zmq::udp_engine_t::plug (io_thread_
             real_bind_addr = bind_addr;
         }
 
-#ifdef ZMQ_HAVE_VXWORKS
-        rc = bind (_fd, (sockaddr *) real_bind_addr->as_sockaddr (),
-                   real_bind_addr->sockaddr_len ());
-#else
-        rc = bind (_fd, real_bind_addr->as_sockaddr (),
-                   real_bind_addr->sockaddr_len ());
+        if (rc != 0) {
+            error (protocol_error);
+            return;
+        }
 
-#endif
-#ifdef ZMQ_HAVE_WINDOWS
-        wsa_assert (rc != SOCKET_ERROR);
-#else
-        errno_assert (rc == 0);
-#endif
+#ifdef ZMQ_HAVE_VXWORKS
+        rc = rc
+             | bind (_fd, (sockaddr *) real_bind_addr->as_sockaddr (),
+                     real_bind_addr->sockaddr_len ());
+#else
+        rc = rc
+             | bind (_fd, real_bind_addr->as_sockaddr (),
+                     real_bind_addr->sockaddr_len ());
+#endif
+        if (rc != 0) {
+            assert_success_or_recoverable (_fd, rc);
+            error (connection_error);
+            return;
+        }
 
         if (multicast) {
-            const ip_addr_t *mcast_addr = udp_addr->target_addr ();
+            rc = rc | add_membership (_fd, udp_addr);
+        }
+    }
 
-            if (mcast_addr->family () == AF_INET) {
-                struct ip_mreq mreq;
-                mreq.imr_multiaddr = mcast_addr->ipv4.sin_addr;
-                mreq.imr_interface = bind_addr->ipv4.sin_addr;
-
-                rc =
-                  setsockopt (_fd, IPPROTO_IP, IP_ADD_MEMBERSHIP,
-                              reinterpret_cast<char *> (&mreq), sizeof (mreq));
+    if (rc != 0) {
+        error (protocol_error);
+    } else {
+        if (_send_enabled) {
+            set_pollout (_handle);
+        }
 
-                errno_assert (rc == 0);
-            } else if (mcast_addr->family () == AF_INET6) {
-                struct ipv6_mreq mreq;
-                int iface = _address->resolved.udp_addr->bind_if ();
-
-                zmq_assert (iface >= -1);
-
-                mreq.ipv6mr_multiaddr = mcast_addr->ipv6.sin6_addr;
-                mreq.ipv6mr_interface = iface;
-
-                rc =
-                  setsockopt (_fd, IPPROTO_IPV6, IPV6_ADD_MEMBERSHIP,
-                              reinterpret_cast<char *> (&mreq), sizeof (mreq));
+        if (_recv_enabled) {
+            set_pollin (_handle);
 
-                errno_assert (rc == 0);
-            } else {
-                //  Shouldn't happen
-                abort ();
-            }
+            //  Call restart output to drop all join/leave commands
+            restart_output ();
+        }
+    }
+}
 
-#ifdef ZMQ_HAVE_WINDOWS
-            wsa_assert (rc != SOCKET_ERROR);
+int zmq::udp_engine_t::set_udp_multicast_loop (fd_t s_,
+                                               bool is_ipv6_,
+                                               bool loop_)
+{
+    int level;
+    int optname;
+
+    if (is_ipv6_) {
+        level = IPPROTO_IPV6;
+        optname = IPV6_MULTICAST_LOOP;
+    } else {
+        level = IPPROTO_IP;
+        optname = IP_MULTICAST_LOOP;
+    }
+
+    int loop = loop_ ? 1 : 0;
+    const int rc = setsockopt (s_, level, optname,
+                               reinterpret_cast<char *> (&loop), sizeof (loop));
+    assert_success_or_recoverable (s_, rc);
+    return rc;
+}
+
+int zmq::udp_engine_t::set_udp_multicast_ttl (fd_t s_, bool is_ipv6_, int hops_)
+{
+    int level;
+
+    if (is_ipv6_) {
+        level = IPPROTO_IPV6;
+    } else {
+        level = IPPROTO_IP;
+    }
+
+    const int rc =
+      setsockopt (s_, level, IP_MULTICAST_TTL,
+                  reinterpret_cast<char *> (&hops_), sizeof (hops_));
+    assert_success_or_recoverable (s_, rc);
+    return rc;
+}
+
+int zmq::udp_engine_t::set_udp_multicast_iface (fd_t s_,
+                                                bool is_ipv6_,
+                                                const udp_address_t *addr_)
+{
+    int rc = 0;
+
+    if (is_ipv6_) {
+        int bind_if = addr_->bind_if ();
+
+        if (bind_if > 0) {
+            //  If a bind interface is provided we tell the
+            //  kernel to use it to send multicast packets
+            rc = setsockopt (s_, IPPROTO_IPV6, IPV6_MULTICAST_IF,
+                             reinterpret_cast<char *> (&bind_if),
+                             sizeof (bind_if));
+        }
+    } else {
+        struct in_addr bind_addr = addr_->bind_addr ()->ipv4.sin_addr;
+
+        if (bind_addr.s_addr != INADDR_ANY) {
+            rc = setsockopt (s_, IPPROTO_IP, IP_MULTICAST_IF,
+                             reinterpret_cast<char *> (&bind_addr),
+                             sizeof (bind_addr));
+        }
+    }
+
+    assert_success_or_recoverable (s_, rc);
+    return rc;
+}
+
+int zmq::udp_engine_t::set_udp_reuse_address (fd_t s_, bool on_)
+{
+    int on = on_ ? 1 : 0;
+    const int rc = setsockopt (s_, SOL_SOCKET, SO_REUSEADDR,
+                               reinterpret_cast<char *> (&on), sizeof (on));
+    assert_success_or_recoverable (s_, rc);
+    return rc;
+}
+
+int zmq::udp_engine_t::set_udp_reuse_port (fd_t s_, bool on_)
+{
+#ifndef SO_REUSEPORT
+    return 0;
 #else
-            errno_assert (rc == 0);
+    int on = on_ ? 1 : 0;
+    int rc = setsockopt (s_, SOL_SOCKET, SO_REUSEPORT,
+                         reinterpret_cast<char *> (&on), sizeof (on));
+    assert_success_or_recoverable (s_, rc);
+    return rc;
 #endif
-        }
-        set_pollin (_handle);
+}
 
-        //  Call restart output to drop all join/leave commands
-        restart_output ();
+int zmq::udp_engine_t::add_membership (fd_t s_, const udp_address_t *addr_)
+{
+    const ip_addr_t *mcast_addr = addr_->target_addr ();
+    int rc = 0;
+
+    if (mcast_addr->family () == AF_INET) {
+        struct ip_mreq mreq;
+        mreq.imr_multiaddr = mcast_addr->ipv4.sin_addr;
+        mreq.imr_interface = addr_->bind_addr ()->ipv4.sin_addr;
+
+        rc = setsockopt (s_, IPPROTO_IP, IP_ADD_MEMBERSHIP,
+                         reinterpret_cast<char *> (&mreq), sizeof (mreq));
+
+    } else if (mcast_addr->family () == AF_INET6) {
+        struct ipv6_mreq mreq;
+        const int iface = addr_->bind_if ();
+
+        zmq_assert (iface >= -1);
+
+        mreq.ipv6mr_multiaddr = mcast_addr->ipv6.sin6_addr;
+        mreq.ipv6mr_interface = iface;
+
+        rc = setsockopt (s_, IPPROTO_IPV6, IPV6_ADD_MEMBERSHIP,
+                         reinterpret_cast<char *> (&mreq), sizeof (mreq));
     }
+
+    assert_success_or_recoverable (s_, rc);
+    return rc;
+}
+
+void zmq::udp_engine_t::error (error_reason_t reason_)
+{
+    zmq_assert (_session);
+    _session->engine_error (false, reason_);
+    terminate ();
 }
 
 void zmq::udp_engine_t::terminate ()
@@ -315,7 +361,8 @@ void zmq::udp_engine_t::terminate ()
     delete this;
 }
 
-void zmq::udp_engine_t::sockaddr_to_msg (zmq::msg_t *msg_, sockaddr_in *addr_)
+void zmq::udp_engine_t::sockaddr_to_msg (zmq::msg_t *msg_,
+                                         const sockaddr_in *addr_)
 {
     const char *const name = inet_ntoa (addr_->sin_addr);
 
@@ -342,7 +389,7 @@ void zmq::udp_engine_t::sockaddr_to_msg
     *address = 0;
 }
 
-int zmq::udp_engine_t::resolve_raw_address (char *name_, size_t length_)
+int zmq::udp_engine_t::resolve_raw_address (const char *name_, size_t length_)
 {
     memset (&_raw_address, 0, sizeof _raw_address);
 
@@ -351,7 +398,7 @@ int zmq::udp_engine_t::resolve_raw_addre
     // Find delimiter, cannot use memrchr as it is not supported on windows
     if (length_ != 0) {
         int chars_left = static_cast<int> (length_);
-        char *current_char = name_ + length_;
+        const char *current_char = name_ + length_;
         do {
             if (*(--current_char) == ':') {
                 delimiter = current_char;
@@ -365,11 +412,11 @@ int zmq::udp_engine_t::resolve_raw_addre
         return -1;
     }
 
-    std::string addr_str (name_, delimiter - name_);
-    std::string port_str (delimiter + 1, name_ + length_ - delimiter - 1);
+    const std::string addr_str (name_, delimiter - name_);
+    const std::string port_str (delimiter + 1, name_ + length_ - delimiter - 1);
 
     //  Parse the port number (0 is not a valid port).
-    uint16_t port = static_cast<uint16_t> (atoi (port_str.c_str ()));
+    const uint16_t port = static_cast<uint16_t> (atoi (port_str.c_str ()));
     if (port == 0) {
         errno = EINVAL;
         return -1;
@@ -396,8 +443,8 @@ void zmq::udp_engine_t::out_event ()
     if (rc == 0) {
         msg_t body_msg;
         rc = _session->pull_msg (&body_msg);
-        //  TODO rc is not checked here. We seem to assume rc == 0. An
-        //  assertion should be added.
+        //  If there's a group, there should also be a body
+        errno_assert (rc == 0);
 
         const size_t group_size = group_msg.size ();
         const size_t body_size = body_msg.size ();
@@ -412,7 +459,7 @@ void zmq::udp_engine_t::out_event ()
                 rc = group_msg.close ();
                 errno_assert (rc == 0);
 
-                body_msg.close ();
+                rc = body_msg.close ();
                 errno_assert (rc == 0);
 
                 return;
@@ -439,17 +486,28 @@ void zmq::udp_engine_t::out_event ()
 #ifdef ZMQ_HAVE_WINDOWS
         rc = sendto (_fd, _out_buffer, static_cast<int> (size), 0, _out_address,
                      _out_address_len);
-        wsa_assert (rc != SOCKET_ERROR);
 #elif defined ZMQ_HAVE_VXWORKS
         rc = sendto (_fd, reinterpret_cast<caddr_t> (_out_buffer), size, 0,
                      (sockaddr *) _out_address, _out_address_len);
-        errno_assert (rc != -1);
 #else
         rc = sendto (_fd, _out_buffer, size, 0, _out_address, _out_address_len);
-        errno_assert (rc != -1);
 #endif
-    } else
+        if (rc < 0) {
+#ifdef ZMQ_HAVE_WINDOWS
+            if (WSAGetLastError () != WSAEWOULDBLOCK) {
+                assert_success_or_recoverable (_fd, rc);
+                error (connection_error);
+            }
+#else
+            if (rc != EWOULDBLOCK) {
+                assert_success_or_recoverable (_fd, rc);
+                error (connection_error);
+            }
+#endif
+        }
+    } else {
         reset_pollout (_handle);
+    }
 }
 
 const zmq::endpoint_uri_pair_t &zmq::udp_engine_t::get_endpoint () const
@@ -479,20 +537,22 @@ void zmq::udp_engine_t::in_event ()
     const int nbytes =
       recvfrom (_fd, _in_buffer, MAX_UDP_MSG, 0,
                 reinterpret_cast<sockaddr *> (&in_address), &in_addrlen);
+
+    if (nbytes < 0) {
 #ifdef ZMQ_HAVE_WINDOWS
-    if (nbytes == SOCKET_ERROR) {
-        const int last_error = WSAGetLastError ();
-        wsa_assert (last_error == WSAENETDOWN || last_error == WSAENETRESET
-                    || last_error == WSAEWOULDBLOCK);
-        return;
-    }
+        if (WSAGetLastError () != WSAEWOULDBLOCK) {
+            assert_success_or_recoverable (_fd, nbytes);
+            error (connection_error);
+        }
 #else
-    if (nbytes == -1) {
-        errno_assert (errno != EBADF && errno != EFAULT && errno != ENOMEM
-                      && errno != ENOTSOCK);
+        if (nbytes != EWOULDBLOCK) {
+            assert_success_or_recoverable (_fd, nbytes);
+            error (connection_error);
+        }
+#endif
         return;
     }
-#endif
+
     int rc;
     int body_size;
     int body_offset;
diff -pruN 4.3.2-2/src/udp_engine.hpp 4.3.3-1/src/udp_engine.hpp
--- 4.3.2-2/src/udp_engine.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/udp_engine.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -14,7 +14,7 @@ namespace zmq
 class io_thread_t;
 class session_base_t;
 
-class udp_engine_t : public io_object_t, public i_engine
+class udp_engine_t ZMQ_FINAL : public io_object_t, public i_engine
 {
   public:
     udp_engine_t (const options_t &options_);
@@ -22,6 +22,8 @@ class udp_engine_t : public io_object_t,
 
     int init (address_t *address_, bool send_, bool recv_);
 
+    bool has_handshake_stage () ZMQ_FINAL { return false; };
+
     //  i_engine interface implementation.
     //  Plug the engine to the session.
     void plug (zmq::io_thread_t *io_thread_, class session_base_t *session_);
@@ -46,8 +48,24 @@ class udp_engine_t : public io_object_t,
     const endpoint_uri_pair_t &get_endpoint () const;
 
   private:
-    int resolve_raw_address (char *addr_, size_t length_);
-    void sockaddr_to_msg (zmq::msg_t *msg_, sockaddr_in *addr_);
+    int resolve_raw_address (const char *name_, size_t length_);
+    static void sockaddr_to_msg (zmq::msg_t *msg_, const sockaddr_in *addr_);
+
+    static int set_udp_reuse_address (fd_t s_, bool on_);
+    static int set_udp_reuse_port (fd_t s_, bool on_);
+    // Indicate, if the multicast data being sent should be looped back
+    static int set_udp_multicast_loop (fd_t s_, bool is_ipv6_, bool loop_);
+    // Set multicast TTL
+    static int set_udp_multicast_ttl (fd_t s_, bool is_ipv6_, int hops_);
+    // Set multicast address/interface
+    int set_udp_multicast_iface (fd_t s_,
+                                 bool is_ipv6_,
+                                 const udp_address_t *addr_);
+    // Join a multicast group
+    int add_membership (fd_t s_, const udp_address_t *addr_);
+
+    //  Function to handle network issues.
+    void error (error_reason_t reason_);
 
     const endpoint_uri_pair_t _empty_endpoint;
 
diff -pruN 4.3.2-2/src/v1_decoder.cpp 4.3.3-1/src/v1_decoder.cpp
--- 4.3.2-2/src/v1_decoder.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/v1_decoder.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -52,7 +52,7 @@ zmq::v1_decoder_t::v1_decoder_t (size_t
 
 zmq::v1_decoder_t::~v1_decoder_t ()
 {
-    int rc = _in_progress.close ();
+    const int rc = _in_progress.close ();
     errno_assert (rc == 0);
 }
 
diff -pruN 4.3.2-2/src/v1_decoder.hpp 4.3.3-1/src/v1_decoder.hpp
--- 4.3.2-2/src/v1_decoder.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/v1_decoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,13 +36,13 @@ namespace zmq
 {
 //  Decoder for ZMTP/1.0 protocol. Converts data batches into messages.
 
-class v1_decoder_t : public decoder_base_t<v1_decoder_t>
+class v1_decoder_t ZMQ_FINAL : public decoder_base_t<v1_decoder_t>
 {
   public:
     v1_decoder_t (size_t bufsize_, int64_t maxmsgsize_);
     ~v1_decoder_t ();
 
-    virtual msg_t *msg () { return &_in_progress; }
+    msg_t *msg () { return &_in_progress; }
 
   private:
     int one_byte_size_ready (unsigned char const *);
@@ -55,8 +55,7 @@ class v1_decoder_t : public decoder_base
 
     const int64_t _max_msg_size;
 
-    v1_decoder_t (const v1_decoder_t &);
-    void operator= (const v1_decoder_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (v1_decoder_t)
 };
 }
 
diff -pruN 4.3.2-2/src/v1_encoder.cpp 4.3.3-1/src/v1_encoder.cpp
--- 4.3.2-2/src/v1_encoder.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/v1_encoder.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -55,23 +55,41 @@ void zmq::v1_encoder_t::size_ready ()
 
 void zmq::v1_encoder_t::message_ready ()
 {
+    size_t header_size = 2; // flags byte + size byte
     //  Get the message size.
     size_t size = in_progress ()->size ();
 
     //  Account for the 'flags' byte.
     size++;
 
+    //  Account for the subscribe/cancel byte.
+    if (in_progress ()->is_subscribe () || in_progress ()->is_cancel ())
+        size++;
+
     //  For messages less than 255 bytes long, write one byte of message size.
     //  For longer messages write 0xff escape character followed by 8-byte
     //  message size. In both cases 'flags' field follows.
     if (size < UCHAR_MAX) {
         _tmpbuf[0] = static_cast<unsigned char> (size);
         _tmpbuf[1] = (in_progress ()->flags () & msg_t::more);
-        next_step (_tmpbuf, 2, &v1_encoder_t::size_ready, false);
     } else {
         _tmpbuf[0] = UCHAR_MAX;
         put_uint64 (_tmpbuf + 1, size);
         _tmpbuf[9] = (in_progress ()->flags () & msg_t::more);
-        next_step (_tmpbuf, 10, &v1_encoder_t::size_ready, false);
+        header_size = 10;
     }
+
+    //  Encode the subscribe/cancel byte. This is done in the encoder as
+    //  opposed to when the subscribe message is created to allow different
+    //  protocol behaviour on the wire in the v3.1 and legacy encoders.
+    //  It results in the work being done multiple times in case the sub
+    //  is sending the subscription/cancel to multiple pubs, but it cannot
+    //  be avoided. This processing can be moved to xsub once support for
+    //  ZMTP < 3.1 is dropped.
+    if (in_progress ()->is_subscribe ())
+        _tmpbuf[header_size++] = 1;
+    else if (in_progress ()->is_cancel ())
+        _tmpbuf[header_size++] = 0;
+
+    next_step (_tmpbuf, header_size, &v1_encoder_t::size_ready, false);
 }
diff -pruN 4.3.2-2/src/v1_encoder.hpp 4.3.3-1/src/v1_encoder.hpp
--- 4.3.2-2/src/v1_encoder.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/v1_encoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,7 +36,7 @@ namespace zmq
 {
 //  Encoder for ZMTP/1.0 protocol. Converts messages into data batches.
 
-class v1_encoder_t : public encoder_base_t<v1_encoder_t>
+class v1_encoder_t ZMQ_FINAL : public encoder_base_t<v1_encoder_t>
 {
   public:
     v1_encoder_t (size_t bufsize_);
@@ -46,10 +46,9 @@ class v1_encoder_t : public encoder_base
     void size_ready ();
     void message_ready ();
 
-    unsigned char _tmpbuf[10];
+    unsigned char _tmpbuf[11];
 
-    v1_encoder_t (const v1_encoder_t &);
-    const v1_encoder_t &operator= (const v1_encoder_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (v1_encoder_t)
 };
 }
 
diff -pruN 4.3.2-2/src/v2_decoder.cpp 4.3.3-1/src/v2_decoder.cpp
--- 4.3.2-2/src/v2_decoder.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/v2_decoder.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -55,7 +55,7 @@ zmq::v2_decoder_t::v2_decoder_t (size_t
 
 zmq::v2_decoder_t::~v2_decoder_t ()
 {
-    int rc = _in_progress.close ();
+    const int rc = _in_progress.close ();
     errno_assert (rc == 0);
 }
 
@@ -115,8 +115,8 @@ int zmq::v2_decoder_t::size_ready (uint6
 
     shared_message_memory_allocator &allocator = get_allocator ();
     if (unlikely (!_zero_copy
-                  || msg_size_ > (size_t) (allocator.data () + allocator.size ()
-                                           - read_pos_))) {
+                  || msg_size_ > static_cast<size_t> (
+                       allocator.data () + allocator.size () - read_pos_))) {
         // a new message has started, but the size would exceed the pre-allocated arena
         // this happens every time when a message does not fit completely into the buffer
         rc = _in_progress.init_size (static_cast<size_t> (msg_size_));
diff -pruN 4.3.2-2/src/v2_decoder.hpp 4.3.3-1/src/v2_decoder.hpp
--- 4.3.2-2/src/v2_decoder.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/v2_decoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -38,15 +38,15 @@ namespace zmq
 //  Decoder for ZMTP/2.x framing protocol. Converts data stream into messages.
 //  The class has to inherit from shared_message_memory_allocator because
 //  the base class calls allocate in its constructor.
-class v2_decoder_t
+class v2_decoder_t ZMQ_FINAL
     : public decoder_base_t<v2_decoder_t, shared_message_memory_allocator>
 {
   public:
     v2_decoder_t (size_t bufsize_, int64_t maxmsgsize_, bool zero_copy_);
-    virtual ~v2_decoder_t ();
+    ~v2_decoder_t ();
 
     //  i_decoder interface.
-    virtual msg_t *msg () { return &_in_progress; }
+    msg_t *msg () { return &_in_progress; }
 
   private:
     int flags_ready (unsigned char const *);
@@ -63,8 +63,7 @@ class v2_decoder_t
     const bool _zero_copy;
     const int64_t _max_msg_size;
 
-    v2_decoder_t (const v2_decoder_t &);
-    void operator= (const v2_decoder_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (v2_decoder_t)
 };
 }
 
diff -pruN 4.3.2-2/src/v2_encoder.cpp 4.3.3-1/src/v2_encoder.cpp
--- 4.3.2-2/src/v2_encoder.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/v2_encoder.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -50,6 +50,8 @@ zmq::v2_encoder_t::~v2_encoder_t ()
 void zmq::v2_encoder_t::message_ready ()
 {
     //  Encode flags.
+    size_t size = in_progress ()->size ();
+    size_t header_size = 2; // flags byte + size byte
     unsigned char &protocol_flags = _tmp_buf[0];
     protocol_flags = 0;
     if (in_progress ()->flags () & msg_t::more)
@@ -58,18 +60,32 @@ void zmq::v2_encoder_t::message_ready ()
         protocol_flags |= v2_protocol_t::large_flag;
     if (in_progress ()->flags () & msg_t::command)
         protocol_flags |= v2_protocol_t::command_flag;
+    if (in_progress ()->is_subscribe () || in_progress ()->is_cancel ())
+        ++size;
 
     //  Encode the message length. For messages less then 256 bytes,
     //  the length is encoded as 8-bit unsigned integer. For larger
     //  messages, 64-bit unsigned integer in network byte order is used.
-    const size_t size = in_progress ()->size ();
     if (unlikely (size > UCHAR_MAX)) {
         put_uint64 (_tmp_buf + 1, size);
-        next_step (_tmp_buf, 9, &v2_encoder_t::size_ready, false);
+        header_size = 9; // flags byte + size 8 bytes
     } else {
         _tmp_buf[1] = static_cast<uint8_t> (size);
-        next_step (_tmp_buf, 2, &v2_encoder_t::size_ready, false);
     }
+
+    //  Encode the subscribe/cancel byte. This is done in the encoder as
+    //  opposed to when the subscribe message is created to allow different
+    //  protocol behaviour on the wire in the v3.1 and legacy encoders.
+    //  It results in the work being done multiple times in case the sub
+    //  is sending the subscription/cancel to multiple pubs, but it cannot
+    //  be avoided. This processing can be moved to xsub once support for
+    //  ZMTP < 3.1 is dropped.
+    if (in_progress ()->is_subscribe ())
+        _tmp_buf[header_size++] = 1;
+    else if (in_progress ()->is_cancel ())
+        _tmp_buf[header_size++] = 0;
+
+    next_step (_tmp_buf, header_size, &v2_encoder_t::size_ready, false);
 }
 
 void zmq::v2_encoder_t::size_ready ()
diff -pruN 4.3.2-2/src/v2_encoder.hpp 4.3.3-1/src/v2_encoder.hpp
--- 4.3.2-2/src/v2_encoder.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/v2_encoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,20 +36,20 @@ namespace zmq
 {
 //  Encoder for 0MQ framing protocol. Converts messages into data stream.
 
-class v2_encoder_t : public encoder_base_t<v2_encoder_t>
+class v2_encoder_t ZMQ_FINAL : public encoder_base_t<v2_encoder_t>
 {
   public:
     v2_encoder_t (size_t bufsize_);
-    virtual ~v2_encoder_t ();
+    ~v2_encoder_t ();
 
   private:
     void size_ready ();
     void message_ready ();
 
-    unsigned char _tmp_buf[9];
+    //  flags byte + size byte (or 8 bytes) + sub/cancel byte
+    unsigned char _tmp_buf[10];
 
-    v2_encoder_t (const v2_encoder_t &);
-    const v2_encoder_t &operator= (const v2_encoder_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (v2_encoder_t)
 };
 }
 
diff -pruN 4.3.2-2/src/v3_1_encoder.cpp 4.3.3-1/src/v3_1_encoder.cpp
--- 4.3.2-2/src/v3_1_encoder.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/v3_1_encoder.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,105 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include "v2_protocol.hpp"
+#include "v3_1_encoder.hpp"
+#include "msg.hpp"
+#include "likely.hpp"
+#include "wire.hpp"
+
+#include <limits.h>
+
+zmq::v3_1_encoder_t::v3_1_encoder_t (size_t bufsize_) :
+    encoder_base_t<v3_1_encoder_t> (bufsize_)
+{
+    //  Write 0 bytes to the batch and go to message_ready state.
+    next_step (NULL, 0, &v3_1_encoder_t::message_ready, true);
+}
+
+zmq::v3_1_encoder_t::~v3_1_encoder_t ()
+{
+}
+
+void zmq::v3_1_encoder_t::message_ready ()
+{
+    //  Encode flags.
+    size_t size = in_progress ()->size ();
+    size_t header_size = 2; // flags byte + size byte
+    unsigned char &protocol_flags = _tmp_buf[0];
+    protocol_flags = 0;
+    if (in_progress ()->flags () & msg_t::more)
+        protocol_flags |= v2_protocol_t::more_flag;
+    if (in_progress ()->size () > UCHAR_MAX)
+        protocol_flags |= v2_protocol_t::large_flag;
+    if (in_progress ()->flags () & msg_t::command
+        || in_progress ()->is_subscribe () || in_progress ()->is_cancel ()) {
+        protocol_flags |= v2_protocol_t::command_flag;
+        if (in_progress ()->is_subscribe ())
+            size += zmq::msg_t::sub_cmd_name_size;
+        else if (in_progress ()->is_cancel ())
+            size += zmq::msg_t::cancel_cmd_name_size;
+    }
+
+    //  Encode the message length. For messages less then 256 bytes,
+    //  the length is encoded as 8-bit unsigned integer. For larger
+    //  messages, 64-bit unsigned integer in network byte order is used.
+    if (unlikely (size > UCHAR_MAX)) {
+        put_uint64 (_tmp_buf + 1, size);
+        header_size = 9; // flags byte + size 8 bytes
+    } else {
+        _tmp_buf[1] = static_cast<uint8_t> (size);
+    }
+
+    //  Encode the sub/cancel command string. This is done in the encoder as
+    //  opposed to when the subscribe message is created to allow different
+    //  protocol behaviour on the wire in the v3.1 and legacy encoders.
+    //  It results in the work being done multiple times in case the sub
+    //  is sending the subscription/cancel to multiple pubs, but it cannot
+    //  be avoided. This processing can be moved to xsub once support for
+    //  ZMTP < 3.1 is dropped.
+    if (in_progress ()->is_subscribe ()) {
+        memcpy (_tmp_buf + header_size, zmq::sub_cmd_name,
+                zmq::msg_t::sub_cmd_name_size);
+        header_size += zmq::msg_t::sub_cmd_name_size;
+    } else if (in_progress ()->is_cancel ()) {
+        memcpy (_tmp_buf + header_size, zmq::cancel_cmd_name,
+                zmq::msg_t::cancel_cmd_name_size);
+        header_size += zmq::msg_t::cancel_cmd_name_size;
+    }
+
+    next_step (_tmp_buf, header_size, &v3_1_encoder_t::size_ready, false);
+}
+
+void zmq::v3_1_encoder_t::size_ready ()
+{
+    //  Write message body into the buffer.
+    next_step (in_progress ()->data (), in_progress ()->size (),
+               &v3_1_encoder_t::message_ready, true);
+}
diff -pruN 4.3.2-2/src/v3_1_encoder.hpp 4.3.3-1/src/v3_1_encoder.hpp
--- 4.3.2-2/src/v3_1_encoder.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/v3_1_encoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,56 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_V3_1_ENCODER_HPP_INCLUDED__
+#define __ZMQ_V3_1_ENCODER_HPP_INCLUDED__
+
+#include "encoder.hpp"
+#include "msg.hpp"
+
+namespace zmq
+{
+//  Encoder for 0MQ framing protocol. Converts messages into data stream.
+
+class v3_1_encoder_t ZMQ_FINAL : public encoder_base_t<v3_1_encoder_t>
+{
+  public:
+    v3_1_encoder_t (size_t bufsize_);
+    ~v3_1_encoder_t () ZMQ_FINAL;
+
+  private:
+    void size_ready ();
+    void message_ready ();
+
+    unsigned char _tmp_buf[9 + zmq::msg_t::sub_cmd_name_size];
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (v3_1_encoder_t)
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/vmci_address.hpp 4.3.3-1/src/vmci_address.hpp
--- 4.3.2-2/src/vmci_address.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/vmci_address.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -61,8 +61,8 @@ class vmci_address_t
     ctx_t *parent;
 
     vmci_address_t ();
-    vmci_address_t (const vmci_address_t &);
-    const vmci_address_t &operator= (const vmci_address_t &);
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (vmci_address_t)
 };
 }
 
diff -pruN 4.3.2-2/src/vmci_connecter.cpp 4.3.3-1/src/vmci_connecter.cpp
--- 4.3.2-2/src/vmci_connecter.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/vmci_connecter.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -179,7 +179,7 @@ void zmq::vmci_connecter_t::start_connec
 
 void zmq::vmci_connecter_t::add_reconnect_timer ()
 {
-    if (options.reconnect_ivl != -1) {
+    if (options.reconnect_ivl > 0) {
         int rc_ivl = get_new_reconnect_ivl ();
         add_timer (rc_ivl, reconnect_timer_id);
         socket->event_connect_retried (
diff -pruN 4.3.2-2/src/vmci_connecter.hpp 4.3.3-1/src/vmci_connecter.hpp
--- 4.3.2-2/src/vmci_connecter.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/vmci_connecter.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -46,7 +46,7 @@ class session_base_t;
 struct address_t;
 
 //  TODO consider refactoring this to derive from stream_connecter_base_t
-class vmci_connecter_t : public own_t, public io_object_t
+class vmci_connecter_t ZMQ_FINAL : public own_t, public io_object_t
 {
   public:
     //  If 'delayed_start' is true connecter first waits for a while,
@@ -128,8 +128,7 @@ class vmci_connecter_t : public own_t, p
     // Socket
     zmq::socket_base_t *socket;
 
-    vmci_connecter_t (const vmci_connecter_t &);
-    const vmci_connecter_t &operator= (const vmci_connecter_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (vmci_connecter_t)
 };
 }
 
diff -pruN 4.3.2-2/src/vmci_listener.hpp 4.3.3-1/src/vmci_listener.hpp
--- 4.3.2-2/src/vmci_listener.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/vmci_listener.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -47,7 +47,7 @@ class io_thread_t;
 class socket_base_t;
 
 //  TODO consider refactoring this to derive from stream_listener_base_t
-class vmci_listener_t : public own_t, public io_object_t
+class vmci_listener_t ZMQ_FINAL : public own_t, public io_object_t
 {
   public:
     vmci_listener_t (zmq::io_thread_t *io_thread_,
@@ -89,8 +89,7 @@ class vmci_listener_t : public own_t, pu
     // String representation of endpoint to bind to
     std::string endpoint;
 
-    vmci_listener_t (const vmci_listener_t &);
-    const vmci_listener_t &operator= (const vmci_listener_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (vmci_listener_t)
 };
 }
 
diff -pruN 4.3.2-2/src/windows.hpp 4.3.3-1/src/windows.hpp
--- 4.3.2-2/src/windows.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/windows.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -43,10 +43,6 @@
 #define _WIN32_WINNT 0x0600
 #endif
 
-#if defined ZMQ_HAVE_WINDOWS_UWP
-#define _WIN32_WINNT _WIN32_WINNT_WIN10
-#endif
-
 #ifdef __MINGW32__
 //  Require Windows XP or higher with MinGW for getaddrinfo().
 #if (_WIN32_WINNT >= 0x0501)
diff -pruN 4.3.2-2/src/ws_address.cpp 4.3.3-1/src/ws_address.cpp
--- 4.3.2-2/src/ws_address.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_address.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,166 @@
+/*
+    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include <string>
+#include <sstream>
+
+#include "macros.hpp"
+#include "ws_address.hpp"
+#include "stdint.hpp"
+#include "err.hpp"
+#include "ip.hpp"
+
+#ifndef ZMQ_HAVE_WINDOWS
+#include <sys/types.h>
+#include <arpa/inet.h>
+#include <netinet/tcp.h>
+#include <net/if.h>
+#include <netdb.h>
+#include <ctype.h>
+#include <unistd.h>
+#include <stdlib.h>
+#endif
+
+#include <limits.h>
+
+zmq::ws_address_t::ws_address_t ()
+{
+    memset (&_address, 0, sizeof (_address));
+}
+
+zmq::ws_address_t::ws_address_t (const sockaddr *sa_, socklen_t sa_len_)
+{
+    zmq_assert (sa_ && sa_len_ > 0);
+
+    memset (&_address, 0, sizeof (_address));
+    if (sa_->sa_family == AF_INET
+        && sa_len_ >= static_cast<socklen_t> (sizeof (_address.ipv4)))
+        memcpy (&_address.ipv4, sa_, sizeof (_address.ipv4));
+    else if (sa_->sa_family == AF_INET6
+             && sa_len_ >= static_cast<socklen_t> (sizeof (_address.ipv6)))
+        memcpy (&_address.ipv6, sa_, sizeof (_address.ipv6));
+
+    _path = std::string ("");
+
+    char hbuf[NI_MAXHOST];
+    const int rc = getnameinfo (addr (), addrlen (), hbuf, sizeof (hbuf), NULL,
+                                0, NI_NUMERICHOST);
+    if (rc != 0) {
+        _host = std::string ("localhost");
+        return;
+    }
+
+    std::ostringstream os;
+
+    if (_address.family () == AF_INET6)
+        os << std::string ("[");
+
+    os << std::string (hbuf);
+
+    if (_address.family () == AF_INET6)
+        os << std::string ("]");
+
+    _host = os.str ();
+}
+
+int zmq::ws_address_t::resolve (const char *name_, bool local_, bool ipv6_)
+{
+    //  find the host part, It's important to use str*r*chr to only get
+    //  the latest colon since IPv6 addresses use colons as delemiters.
+    const char *delim = strrchr (name_, ':');
+    if (delim == NULL) {
+        errno = EINVAL;
+        return -1;
+    }
+    _host = std::string (name_, delim - name_);
+
+    // find the path part, which is optional
+    delim = strrchr (name_, '/');
+    std::string host_name;
+    if (delim) {
+        _path = std::string (delim);
+        // remove the path, otherwise resolving the port will fail with wildcard
+        host_name = std::string (name_, delim - name_);
+    } else {
+        _path = std::string ("/");
+        host_name = name_;
+    }
+
+    ip_resolver_options_t resolver_opts;
+    resolver_opts.bindable (local_)
+      .allow_dns (!local_)
+      .allow_nic_name (local_)
+      .ipv6 (ipv6_)
+      .allow_path (true)
+      .expect_port (true);
+
+    ip_resolver_t resolver (resolver_opts);
+
+    return resolver.resolve (&_address, host_name.c_str ());
+}
+
+int zmq::ws_address_t::to_string (std::string &addr_) const
+{
+    std::ostringstream os;
+    os << std::string ("ws://") << host () << std::string (":")
+       << _address.port () << _path;
+    addr_ = os.str ();
+
+    return 0;
+}
+
+const sockaddr *zmq::ws_address_t::addr () const
+{
+    return _address.as_sockaddr ();
+}
+
+socklen_t zmq::ws_address_t::addrlen () const
+{
+    return _address.sockaddr_len ();
+}
+
+const char *zmq::ws_address_t::host () const
+{
+    return _host.c_str ();
+}
+
+const char *zmq::ws_address_t::path () const
+{
+    return _path.c_str ();
+}
+
+#if defined ZMQ_HAVE_WINDOWS
+unsigned short zmq::ws_address_t::family () const
+#else
+sa_family_t zmq::ws_address_t::family () const
+#endif
+{
+    return _address.family ();
+}
diff -pruN 4.3.2-2/src/ws_address.hpp 4.3.3-1/src/ws_address.hpp
--- 4.3.2-2/src/ws_address.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_address.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,77 @@
+/*
+    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_WS_ADDRESS_HPP_INCLUDED__
+#define __ZMQ_WS_ADDRESS_HPP_INCLUDED__
+
+#if !defined ZMQ_HAVE_WINDOWS
+#include <sys/socket.h>
+#include <netinet/in.h>
+#endif
+
+#include "ip_resolver.hpp"
+
+namespace zmq
+{
+class ws_address_t
+{
+  public:
+    ws_address_t ();
+    ws_address_t (const sockaddr *sa_, socklen_t sa_len_);
+
+    //  This function translates textual WS address into an address
+    //  structure. If 'local' is true, names are resolved as local interface
+    //  names. If it is false, names are resolved as remote hostnames.
+    //  If 'ipv6' is true, the name may resolve to IPv6 address.
+    int resolve (const char *name_, bool local_, bool ipv6_);
+
+    //  The opposite to resolve()
+    int to_string (std::string &addr_) const;
+
+#if defined ZMQ_HAVE_WINDOWS
+    unsigned short family () const;
+#else
+    sa_family_t family () const;
+#endif
+    const sockaddr *addr () const;
+    socklen_t addrlen () const;
+
+    const char *host () const;
+    const char *path () const;
+
+  protected:
+    ip_addr_t _address;
+
+  private:
+    std::string _host;
+    std::string _path;
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/ws_connecter.cpp 4.3.3-1/src/ws_connecter.cpp
--- 4.3.2-2/src/ws_connecter.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_connecter.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,305 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include <new>
+#include <string>
+
+#include "macros.hpp"
+#include "ws_connecter.hpp"
+#include "io_thread.hpp"
+#include "err.hpp"
+#include "ip.hpp"
+#include "tcp.hpp"
+#include "address.hpp"
+#include "ws_address.hpp"
+#include "ws_engine.hpp"
+#include "session_base.hpp"
+
+#ifdef ZMQ_HAVE_WSS
+#include "wss_engine.hpp"
+#include "wss_address.hpp"
+#endif
+
+#if !defined ZMQ_HAVE_WINDOWS
+#include <unistd.h>
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <arpa/inet.h>
+#include <netinet/tcp.h>
+#include <netinet/in.h>
+#include <netdb.h>
+#include <fcntl.h>
+#ifdef ZMQ_HAVE_VXWORKS
+#include <sockLib.h>
+#endif
+#ifdef ZMQ_HAVE_OPENVMS
+#include <ioctl.h>
+#endif
+#endif
+
+#ifdef __APPLE__
+#include <TargetConditionals.h>
+#endif
+
+zmq::ws_connecter_t::ws_connecter_t (class io_thread_t *io_thread_,
+                                     class session_base_t *session_,
+                                     const options_t &options_,
+                                     address_t *addr_,
+                                     bool delayed_start_,
+                                     bool wss_,
+                                     const std::string &tls_hostname_) :
+    stream_connecter_base_t (
+      io_thread_, session_, options_, addr_, delayed_start_),
+    _connect_timer_started (false),
+    _wss (wss_),
+    _hostname (tls_hostname_)
+{
+}
+
+zmq::ws_connecter_t::~ws_connecter_t ()
+{
+    zmq_assert (!_connect_timer_started);
+}
+
+void zmq::ws_connecter_t::process_term (int linger_)
+{
+    if (_connect_timer_started) {
+        cancel_timer (connect_timer_id);
+        _connect_timer_started = false;
+    }
+
+    stream_connecter_base_t::process_term (linger_);
+}
+
+void zmq::ws_connecter_t::out_event ()
+{
+    if (_connect_timer_started) {
+        cancel_timer (connect_timer_id);
+        _connect_timer_started = false;
+    }
+
+    //  TODO this is still very similar to (t)ipc_connecter_t, maybe the
+    //  differences can be factored out
+
+    rm_handle ();
+
+    const fd_t fd = connect ();
+
+    //  Handle the error condition by attempt to reconnect.
+    if (fd == retired_fd || !tune_socket (fd)) {
+        close ();
+        add_reconnect_timer ();
+        return;
+    }
+
+    if (_wss)
+#ifdef ZMQ_HAVE_WSS
+        create_engine (fd,
+                       get_socket_name<wss_address_t> (fd, socket_end_local));
+#else
+        assert (false);
+#endif
+    else
+        create_engine (fd,
+                       get_socket_name<ws_address_t> (fd, socket_end_local));
+}
+
+void zmq::ws_connecter_t::timer_event (int id_)
+{
+    if (id_ == connect_timer_id) {
+        _connect_timer_started = false;
+        rm_handle ();
+        close ();
+        add_reconnect_timer ();
+    } else
+        stream_connecter_base_t::timer_event (id_);
+}
+
+void zmq::ws_connecter_t::start_connecting ()
+{
+    //  Open the connecting socket.
+    const int rc = open ();
+
+    //  Connect may succeed in synchronous manner.
+    if (rc == 0) {
+        _handle = add_fd (_s);
+        out_event ();
+    }
+
+    //  Connection establishment may be delayed. Poll for its completion.
+    else if (rc == -1 && errno == EINPROGRESS) {
+        _handle = add_fd (_s);
+        set_pollout (_handle);
+        _socket->event_connect_delayed (
+          make_unconnected_connect_endpoint_pair (_endpoint), zmq_errno ());
+
+        //  add userspace connect timeout
+        add_connect_timer ();
+    }
+
+    //  Handle any other error condition by eventual reconnect.
+    else {
+        if (_s != retired_fd)
+            close ();
+        add_reconnect_timer ();
+    }
+}
+
+void zmq::ws_connecter_t::add_connect_timer ()
+{
+    if (options.connect_timeout > 0) {
+        add_timer (options.connect_timeout, connect_timer_id);
+        _connect_timer_started = true;
+    }
+}
+
+int zmq::ws_connecter_t::open ()
+{
+    zmq_assert (_s == retired_fd);
+
+    tcp_address_t tcp_addr;
+    _s = tcp_open_socket (_addr->address.c_str (), options, false, true,
+                          &tcp_addr);
+    if (_s == retired_fd)
+        return -1;
+
+    // Set the socket to non-blocking mode so that we get async connect().
+    unblock_socket (_s);
+
+    //  Connect to the remote peer.
+#ifdef ZMQ_HAVE_VXWORKS
+    int rc = ::connect (_s, (sockaddr *) tcp_addr.addr (), tcp_addr.addrlen ());
+#else
+    const int rc = ::connect (_s, tcp_addr.addr (), tcp_addr.addrlen ());
+#endif
+    //  Connect was successful immediately.
+    if (rc == 0) {
+        return 0;
+    }
+
+    //  Translate error codes indicating asynchronous connect has been
+    //  launched to a uniform EINPROGRESS.
+#ifdef ZMQ_HAVE_WINDOWS
+    const int last_error = WSAGetLastError ();
+    if (last_error == WSAEINPROGRESS || last_error == WSAEWOULDBLOCK)
+        errno = EINPROGRESS;
+    else
+        errno = wsa_error_to_errno (last_error);
+#else
+    if (errno == EINTR)
+        errno = EINPROGRESS;
+#endif
+    return -1;
+}
+
+zmq::fd_t zmq::ws_connecter_t::connect ()
+{
+    //  Async connect has finished. Check whether an error occurred
+    int err = 0;
+#if defined ZMQ_HAVE_HPUX || defined ZMQ_HAVE_VXWORKS
+    int len = sizeof err;
+#else
+    socklen_t len = sizeof err;
+#endif
+
+    const int rc = getsockopt (_s, SOL_SOCKET, SO_ERROR,
+                               reinterpret_cast<char *> (&err), &len);
+
+    //  Assert if the error was caused by 0MQ bug.
+    //  Networking problems are OK. No need to assert.
+#ifdef ZMQ_HAVE_WINDOWS
+    zmq_assert (rc == 0);
+    if (err != 0) {
+        if (err == WSAEBADF || err == WSAENOPROTOOPT || err == WSAENOTSOCK
+            || err == WSAENOBUFS) {
+            wsa_assert_no (err);
+        }
+        return retired_fd;
+    }
+#else
+    //  Following code should handle both Berkeley-derived socket
+    //  implementations and Solaris.
+    if (rc == -1)
+        err = errno;
+    if (err != 0) {
+        errno = err;
+#if !defined(TARGET_OS_IPHONE) || !TARGET_OS_IPHONE
+        errno_assert (errno != EBADF && errno != ENOPROTOOPT
+                      && errno != ENOTSOCK && errno != ENOBUFS);
+#else
+        errno_assert (errno != ENOPROTOOPT && errno != ENOTSOCK
+                      && errno != ENOBUFS);
+#endif
+        return retired_fd;
+    }
+#endif
+
+    //  Return the newly connected socket.
+    const fd_t result = _s;
+    _s = retired_fd;
+    return result;
+}
+
+bool zmq::ws_connecter_t::tune_socket (const fd_t fd_)
+{
+    const int rc =
+      tune_tcp_socket (fd_) | tune_tcp_maxrt (fd_, options.tcp_maxrt);
+    return rc == 0;
+}
+
+void zmq::ws_connecter_t::create_engine (fd_t fd_,
+                                         const std::string &local_address_)
+{
+    const endpoint_uri_pair_t endpoint_pair (local_address_, _endpoint,
+                                             endpoint_type_connect);
+
+    //  Create the engine object for this connection.
+    i_engine *engine = NULL;
+    if (_wss)
+#ifdef ZMQ_HAVE_WSS
+        engine = new (std::nothrow)
+          wss_engine_t (fd_, options, endpoint_pair, *_addr->resolved.ws_addr,
+                        true, NULL, _hostname);
+#else
+        assert (false);
+#endif
+    else
+        engine = new (std::nothrow) ws_engine_t (
+          fd_, options, endpoint_pair, *_addr->resolved.ws_addr, true);
+    alloc_assert (engine);
+
+    //  Attach the engine to the corresponding session object.
+    send_attach (_session, engine);
+
+    //  Shut the connecter down.
+    terminate ();
+
+    _socket->event_connected (endpoint_pair, fd_);
+}
diff -pruN 4.3.2-2/src/ws_connecter.hpp 4.3.3-1/src/ws_connecter.hpp
--- 4.3.2-2/src/ws_connecter.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_connecter.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,98 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __WS_CONNECTER_HPP_INCLUDED__
+#define __WS_CONNECTER_HPP_INCLUDED__
+
+#include "fd.hpp"
+#include "stdint.hpp"
+#include "stream_connecter_base.hpp"
+
+namespace zmq
+{
+class ws_connecter_t ZMQ_FINAL : public stream_connecter_base_t
+{
+  public:
+    //  If 'delayed_start' is true connecter first waits for a while,
+    //  then starts connection process.
+    ws_connecter_t (zmq::io_thread_t *io_thread_,
+                    zmq::session_base_t *session_,
+                    const options_t &options_,
+                    address_t *addr_,
+                    bool delayed_start_,
+                    bool wss_,
+                    const std::string &tls_hostname_);
+    ~ws_connecter_t ();
+
+  protected:
+    void create_engine (fd_t fd, const std::string &local_address_);
+
+  private:
+    //  ID of the timer used to check the connect timeout, must be different from stream_connecter_base_t::reconnect_timer_id.
+    enum
+    {
+        connect_timer_id = 2
+    };
+
+    //  Handlers for incoming commands.
+    void process_term (int linger_);
+
+    //  Handlers for I/O events.
+    void out_event ();
+    void timer_event (int id_);
+
+    //  Internal function to start the actual connection establishment.
+    void start_connecting ();
+
+    //  Internal function to add a connect timer
+    void add_connect_timer ();
+
+    //  Open TCP connecting socket. Returns -1 in case of error,
+    //  0 if connect was successful immediately. Returns -1 with
+    //  EAGAIN errno if async connect was launched.
+    int open ();
+
+    //  Get the file descriptor of newly created connection. Returns
+    //  retired_fd if the connection was unsuccessful.
+    fd_t connect ();
+
+    //  Tunes a connected socket.
+    bool tune_socket (fd_t fd_);
+
+    //  True iff a timer has been started.
+    bool _connect_timer_started;
+
+    bool _wss;
+    const std::string &_hostname;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (ws_connecter_t)
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/ws_decoder.cpp 4.3.3-1/src/ws_decoder.cpp
--- 4.3.2-2/src/ws_decoder.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_decoder.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,276 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include <stdlib.h>
+#include <string.h>
+#include <cmath>
+
+#include "ws_protocol.hpp"
+#include "ws_decoder.hpp"
+#include "likely.hpp"
+#include "wire.hpp"
+#include "err.hpp"
+
+zmq::ws_decoder_t::ws_decoder_t (size_t bufsize_,
+                                 int64_t maxmsgsize_,
+                                 bool zero_copy_,
+                                 bool must_mask_) :
+    decoder_base_t<ws_decoder_t, shared_message_memory_allocator> (bufsize_),
+    _msg_flags (0),
+    _zero_copy (zero_copy_),
+    _max_msg_size (maxmsgsize_),
+    _must_mask (must_mask_),
+    _size (0)
+{
+    memset (_tmpbuf, 0, sizeof (_tmpbuf));
+    int rc = _in_progress.init ();
+    errno_assert (rc == 0);
+
+    //  At the beginning, read one byte and go to opcode_ready state.
+    next_step (_tmpbuf, 1, &ws_decoder_t::opcode_ready);
+}
+
+zmq::ws_decoder_t::~ws_decoder_t ()
+{
+    const int rc = _in_progress.close ();
+    errno_assert (rc == 0);
+}
+
+int zmq::ws_decoder_t::opcode_ready (unsigned char const *)
+{
+    const bool final = (_tmpbuf[0] & 0x80) != 0; // final bit
+    if (!final)
+        return -1; // non final messages are not supported
+
+    _opcode = static_cast<zmq::ws_protocol_t::opcode_t> (_tmpbuf[0] & 0xF);
+
+    _msg_flags = 0;
+
+    switch (_opcode) {
+        case zmq::ws_protocol_t::opcode_binary:
+            break;
+        case zmq::ws_protocol_t::opcode_close:
+            _msg_flags = msg_t::command | msg_t::close_cmd;
+            break;
+        case zmq::ws_protocol_t::opcode_ping:
+            _msg_flags = msg_t::ping | msg_t::command;
+            break;
+        case zmq::ws_protocol_t::opcode_pong:
+            _msg_flags = msg_t::pong | msg_t::command;
+            break;
+        default:
+            return -1;
+    }
+
+    next_step (_tmpbuf, 1, &ws_decoder_t::size_first_byte_ready);
+
+    return 0;
+}
+
+int zmq::ws_decoder_t::size_first_byte_ready (unsigned char const *read_from_)
+{
+    const bool is_masked = (_tmpbuf[0] & 0x80) != 0;
+
+    if (is_masked != _must_mask) // wrong mask value
+        return -1;
+
+    _size = static_cast<uint64_t> (_tmpbuf[0] & 0x7F);
+
+    if (_size < 126) {
+        if (_must_mask)
+            next_step (_tmpbuf, 4, &ws_decoder_t::mask_ready);
+        else if (_opcode == ws_protocol_t::opcode_binary) {
+            if (_size == 0)
+                return -1;
+            next_step (_tmpbuf, 1, &ws_decoder_t::flags_ready);
+        } else
+            return size_ready (read_from_);
+    } else if (_size == 126)
+        next_step (_tmpbuf, 2, &ws_decoder_t::short_size_ready);
+    else
+        next_step (_tmpbuf, 8, &ws_decoder_t::long_size_ready);
+
+    return 0;
+}
+
+
+int zmq::ws_decoder_t::short_size_ready (unsigned char const *read_from_)
+{
+    _size = (_tmpbuf[0] << 8) | _tmpbuf[1];
+
+    if (_must_mask)
+        next_step (_tmpbuf, 4, &ws_decoder_t::mask_ready);
+    else if (_opcode == ws_protocol_t::opcode_binary) {
+        if (_size == 0)
+            return -1;
+        next_step (_tmpbuf, 1, &ws_decoder_t::flags_ready);
+    } else
+        return size_ready (read_from_);
+
+    return 0;
+}
+
+int zmq::ws_decoder_t::long_size_ready (unsigned char const *read_from_)
+{
+    //  The payload size is encoded as 64-bit unsigned integer.
+    //  The most significant byte comes first.
+    _size = get_uint64 (_tmpbuf);
+
+    if (_must_mask)
+        next_step (_tmpbuf, 4, &ws_decoder_t::mask_ready);
+    else if (_opcode == ws_protocol_t::opcode_binary) {
+        if (_size == 0)
+            return -1;
+        next_step (_tmpbuf, 1, &ws_decoder_t::flags_ready);
+    } else
+        return size_ready (read_from_);
+
+    return 0;
+}
+
+int zmq::ws_decoder_t::mask_ready (unsigned char const *read_from_)
+{
+    memcpy (_mask, _tmpbuf, 4);
+
+    if (_opcode == ws_protocol_t::opcode_binary) {
+        if (_size == 0)
+            return -1;
+
+        next_step (_tmpbuf, 1, &ws_decoder_t::flags_ready);
+    } else
+        return size_ready (read_from_);
+
+    return 0;
+}
+
+int zmq::ws_decoder_t::flags_ready (unsigned char const *read_from_)
+{
+    unsigned char flags;
+
+    if (_must_mask)
+        flags = _tmpbuf[0] ^ _mask[0];
+    else
+        flags = _tmpbuf[0];
+
+    if (flags & ws_protocol_t::more_flag)
+        _msg_flags |= msg_t::more;
+    if (flags & ws_protocol_t::command_flag)
+        _msg_flags |= msg_t::command;
+
+    _size--;
+
+    return size_ready (read_from_);
+}
+
+
+int zmq::ws_decoder_t::size_ready (unsigned char const *read_pos_)
+{
+    //  Message size must not exceed the maximum allowed size.
+    if (_max_msg_size >= 0)
+        if (unlikely (_size > static_cast<uint64_t> (_max_msg_size))) {
+            errno = EMSGSIZE;
+            return -1;
+        }
+
+    //  Message size must fit into size_t data type.
+    if (unlikely (_size != static_cast<size_t> (_size))) {
+        errno = EMSGSIZE;
+        return -1;
+    }
+
+    int rc = _in_progress.close ();
+    assert (rc == 0);
+
+    // the current message can exceed the current buffer. We have to copy the buffer
+    // data into a new message and complete it in the next receive.
+
+    shared_message_memory_allocator &allocator = get_allocator ();
+    if (unlikely (!_zero_copy || allocator.data () > read_pos_
+                  || static_cast<size_t> (read_pos_ - allocator.data ())
+                       > allocator.size ()
+                  || _size > static_cast<size_t> (
+                       allocator.data () + allocator.size () - read_pos_))) {
+        // a new message has started, but the size would exceed the pre-allocated arena
+        // (or read_pos_ is in the initial handshake buffer)
+        // this happens every time when a message does not fit completely into the buffer
+        rc = _in_progress.init_size (static_cast<size_t> (_size));
+    } else {
+        // construct message using n bytes from the buffer as storage
+        // increase buffer ref count
+        // if the message will be a large message, pass a valid refcnt memory location as well
+        rc = _in_progress.init (
+          const_cast<unsigned char *> (read_pos_), static_cast<size_t> (_size),
+          shared_message_memory_allocator::call_dec_ref, allocator.buffer (),
+          allocator.provide_content ());
+
+        // For small messages, data has been copied and refcount does not have to be increased
+        if (_in_progress.is_zcmsg ()) {
+            allocator.advance_content ();
+            allocator.inc_ref ();
+        }
+    }
+
+    if (unlikely (rc)) {
+        errno_assert (errno == ENOMEM);
+        rc = _in_progress.init ();
+        errno_assert (rc == 0);
+        errno = ENOMEM;
+        return -1;
+    }
+
+    _in_progress.set_flags (_msg_flags);
+    // this sets read_pos to
+    // the message data address if the data needs to be copied
+    // for small message / messages exceeding the current buffer
+    // or
+    // to the current start address in the buffer because the message
+    // was constructed to use n bytes from the address passed as argument
+    next_step (_in_progress.data (), _in_progress.size (),
+               &ws_decoder_t::message_ready);
+
+    return 0;
+}
+
+int zmq::ws_decoder_t::message_ready (unsigned char const *)
+{
+    if (_must_mask) {
+        int mask_index = _opcode == ws_protocol_t::opcode_binary ? 1 : 0;
+
+        unsigned char *data =
+          static_cast<unsigned char *> (_in_progress.data ());
+        for (size_t i = 0; i < _size; ++i, mask_index++)
+            data[i] = data[i] ^ _mask[mask_index % 4];
+    }
+
+    //  Message is completely read. Signal this to the caller
+    //  and prepare to decode next message.
+    next_step (_tmpbuf, 1, &ws_decoder_t::opcode_ready);
+    return 1;
+}
diff -pruN 4.3.2-2/src/ws_decoder.hpp 4.3.3-1/src/ws_decoder.hpp
--- 4.3.2-2/src/ws_decoder.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_decoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,81 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_WS_DECODER_HPP_INCLUDED__
+#define __ZMQ_WS_DECODER_HPP_INCLUDED__
+
+#include "decoder.hpp"
+#include "decoder_allocators.hpp"
+#include "ws_protocol.hpp"
+
+namespace zmq
+{
+//  Decoder for Web socket framing protocol. Converts data stream into messages.
+//  The class has to inherit from shared_message_memory_allocator because
+//  the base class calls allocate in its constructor.
+class ws_decoder_t ZMQ_FINAL
+    : public decoder_base_t<ws_decoder_t, shared_message_memory_allocator>
+{
+  public:
+    ws_decoder_t (size_t bufsize_,
+                  int64_t maxmsgsize_,
+                  bool zero_copy_,
+                  bool must_mask_);
+    ~ws_decoder_t ();
+
+    //  i_decoder interface.
+    msg_t *msg () { return &_in_progress; }
+
+  private:
+    int opcode_ready (unsigned char const *);
+    int size_first_byte_ready (unsigned char const *);
+    int short_size_ready (unsigned char const *);
+    int long_size_ready (unsigned char const *);
+    int mask_ready (unsigned char const *);
+    int flags_ready (unsigned char const *);
+    int message_ready (unsigned char const *);
+
+    int size_ready (unsigned char const *);
+
+    unsigned char _tmpbuf[8];
+    unsigned char _msg_flags;
+    msg_t _in_progress;
+
+    const bool _zero_copy;
+    const int64_t _max_msg_size;
+    const bool _must_mask;
+    uint64_t _size;
+    zmq::ws_protocol_t::opcode_t _opcode;
+    unsigned char _mask[4];
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (ws_decoder_t)
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/ws_encoder.cpp 4.3.3-1/src/ws_encoder.cpp
--- 4.3.2-2/src/ws_encoder.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_encoder.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,138 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include "ws_protocol.hpp"
+#include "ws_encoder.hpp"
+#include "msg.hpp"
+#include "likely.hpp"
+#include "wire.hpp"
+#include "random.hpp"
+
+#include <limits.h>
+
+zmq::ws_encoder_t::ws_encoder_t (size_t bufsize_, bool must_mask_) :
+    encoder_base_t<ws_encoder_t> (bufsize_),
+    _must_mask (must_mask_)
+{
+    //  Write 0 bytes to the batch and go to message_ready state.
+    next_step (NULL, 0, &ws_encoder_t::message_ready, true);
+    _masked_msg.init ();
+}
+
+zmq::ws_encoder_t::~ws_encoder_t ()
+{
+    _masked_msg.close ();
+}
+
+void zmq::ws_encoder_t::message_ready ()
+{
+    int offset = 0;
+
+    _is_binary = false;
+
+    if (in_progress ()->is_ping ())
+        _tmp_buf[offset++] = 0x80 | zmq::ws_protocol_t::opcode_ping;
+    else if (in_progress ()->is_pong ())
+        _tmp_buf[offset++] = 0x80 | zmq::ws_protocol_t::opcode_pong;
+    else if (in_progress ()->is_close_cmd ())
+        _tmp_buf[offset++] = 0x80 | zmq::ws_protocol_t::opcode_close;
+    else {
+        _tmp_buf[offset++] = 0x82; // Final | binary
+        _is_binary = true;
+    }
+
+    _tmp_buf[offset] = _must_mask ? 0x80 : 0x00;
+
+    size_t size = in_progress ()->size ();
+    if (_is_binary)
+        size++;
+
+    if (size <= 125)
+        _tmp_buf[offset++] |= static_cast<unsigned char> (size & 127);
+    else if (size <= 0xFFFF) {
+        _tmp_buf[offset++] |= 126;
+        _tmp_buf[offset++] = static_cast<unsigned char> ((size >> 8) & 0xFF);
+        _tmp_buf[offset++] = static_cast<unsigned char> (size & 0xFF);
+    } else {
+        _tmp_buf[offset++] |= 127;
+        put_uint64 (_tmp_buf + offset, size);
+        offset += 8;
+    }
+
+    if (_must_mask) {
+        const uint32_t random = generate_random ();
+        put_uint32 (_tmp_buf + offset, random);
+        put_uint32 (_mask, random);
+        offset += 4;
+    }
+
+    if (_is_binary) {
+        //  Encode flags.
+        unsigned char protocol_flags = 0;
+        if (in_progress ()->flags () & msg_t::more)
+            protocol_flags |= ws_protocol_t::more_flag;
+        if (in_progress ()->flags () & msg_t::command)
+            protocol_flags |= ws_protocol_t::command_flag;
+
+        _tmp_buf[offset++] =
+          _must_mask ? protocol_flags ^ _mask[0] : protocol_flags;
+    }
+
+    next_step (_tmp_buf, offset, &ws_encoder_t::size_ready, false);
+}
+
+void zmq::ws_encoder_t::size_ready ()
+{
+    if (_must_mask) {
+        assert (in_progress () != &_masked_msg);
+        const size_t size = in_progress ()->size ();
+
+        unsigned char *src =
+          static_cast<unsigned char *> (in_progress ()->data ());
+        unsigned char *dest = src;
+
+        //  If msg is shared or data is constant we cannot mask in-place, allocate a new msg for it
+        if (in_progress ()->flags () & msg_t::shared
+            || in_progress ()->is_cmsg ()) {
+            _masked_msg.close ();
+            _masked_msg.init_size (size);
+            dest = static_cast<unsigned char *> (_masked_msg.data ());
+        }
+
+        int mask_index = _is_binary ? 1 : 0;
+        for (size_t i = 0; i < size; ++i, mask_index++)
+            dest[i] = src[i] ^ _mask[mask_index % 4];
+
+        next_step (dest, size, &ws_encoder_t::message_ready, true);
+    } else {
+        next_step (in_progress ()->data (), in_progress ()->size (),
+                   &ws_encoder_t::message_ready, true);
+    }
+}
diff -pruN 4.3.2-2/src/ws_encoder.hpp 4.3.3-1/src/ws_encoder.hpp
--- 4.3.2-2/src/ws_encoder.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_encoder.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,59 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_WS_ENCODER_HPP_INCLUDED__
+#define __ZMQ_WS_ENCODER_HPP_INCLUDED__
+
+#include "encoder.hpp"
+
+namespace zmq
+{
+//  Encoder for web socket framing protocol. Converts messages into data stream.
+
+class ws_encoder_t ZMQ_FINAL : public encoder_base_t<ws_encoder_t>
+{
+  public:
+    ws_encoder_t (size_t bufsize_, bool must_mask_);
+    ~ws_encoder_t ();
+
+  private:
+    void size_ready ();
+    void message_ready ();
+
+    unsigned char _tmp_buf[16];
+    bool _must_mask;
+    unsigned char _mask[4];
+    msg_t _masked_msg;
+    bool _is_binary;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (ws_encoder_t)
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/ws_engine.cpp 4.3.3-1/src/ws_engine.cpp
--- 4.3.2-2/src/ws_engine.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_engine.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,1075 @@
+/*
+Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+This file is part of libzmq, the ZeroMQ core engine in C++.
+
+libzmq is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License (LGPL) as published
+by the Free Software Foundation; either version 3 of the License, or
+(at your option) any later version.
+
+As a special exception, the Contributors give you permission to link
+this library with independent modules to produce an executable,
+regardless of the license terms of these independent modules, and to
+copy and distribute the resulting executable under terms of your choice,
+provided that you also meet, for each linked independent module, the
+terms and conditions of the license of that module. An independent
+module is a module which is not derived from or based on this library.
+If you modify this library, you must extend this exception to your
+version of the library.
+
+libzmq is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+License for more details.
+
+You should have received a copy of the GNU Lesser General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+
+#ifdef ZMQ_USE_NSS
+#include <secoid.h>
+#include <sechash.h>
+#define SHA_DIGEST_LENGTH 20
+#elif defined ZMQ_USE_BUILTIN_SHA1
+#include "../external/sha1/sha1.h"
+#elif defined ZMQ_USE_GNUTLS
+#define SHA_DIGEST_LENGTH 20
+#include <gnutls/gnutls.h>
+#include <gnutls/crypto.h>
+#endif
+
+#if !defined ZMQ_HAVE_WINDOWS
+#include <sys/types.h>
+#include <unistd.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+#ifdef ZMQ_HAVE_VXWORKS
+#include <sockLib.h>
+#endif
+#endif
+
+#include <cstring>
+
+#include "compat.hpp"
+#include "tcp.hpp"
+#include "ws_engine.hpp"
+#include "session_base.hpp"
+#include "err.hpp"
+#include "ip.hpp"
+#include "random.hpp"
+#include "ws_decoder.hpp"
+#include "ws_encoder.hpp"
+#include "null_mechanism.hpp"
+#include "plain_server.hpp"
+#include "plain_client.hpp"
+
+#ifdef ZMQ_HAVE_CURVE
+#include "curve_client.hpp"
+#include "curve_server.hpp"
+#endif
+
+//  OSX uses a different name for this socket option
+#ifndef IPV6_ADD_MEMBERSHIP
+#define IPV6_ADD_MEMBERSHIP IPV6_JOIN_GROUP
+#endif
+
+#ifdef __APPLE__
+#include <TargetConditionals.h>
+#endif
+
+static int
+encode_base64 (const unsigned char *in_, int in_len_, char *out_, int out_len_);
+
+static void compute_accept_key (char *key_,
+                                unsigned char hash_[SHA_DIGEST_LENGTH]);
+
+zmq::ws_engine_t::ws_engine_t (fd_t fd_,
+                               const options_t &options_,
+                               const endpoint_uri_pair_t &endpoint_uri_pair_,
+                               const ws_address_t &address_,
+                               bool client_) :
+    stream_engine_base_t (fd_, options_, endpoint_uri_pair_, true),
+    _client (client_),
+    _address (address_),
+    _client_handshake_state (client_handshake_initial),
+    _server_handshake_state (handshake_initial),
+    _header_name_position (0),
+    _header_value_position (0),
+    _header_upgrade_websocket (false),
+    _header_connection_upgrade (false),
+    _heartbeat_timeout (0)
+{
+    memset (_websocket_key, 0, MAX_HEADER_VALUE_LENGTH + 1);
+    memset (_websocket_accept, 0, MAX_HEADER_VALUE_LENGTH + 1);
+    memset (_websocket_protocol, 0, 256);
+
+    _next_msg = &ws_engine_t::next_handshake_command;
+    _process_msg = &ws_engine_t::process_handshake_command;
+    _close_msg.init ();
+
+    if (_options.heartbeat_interval > 0) {
+        _heartbeat_timeout = _options.heartbeat_timeout;
+        if (_heartbeat_timeout == -1)
+            _heartbeat_timeout = _options.heartbeat_interval;
+    }
+}
+
+zmq::ws_engine_t::~ws_engine_t ()
+{
+    _close_msg.close ();
+}
+
+void zmq::ws_engine_t::start_ws_handshake ()
+{
+    if (_client) {
+        const char *protocol;
+        if (_options.mechanism == ZMQ_NULL)
+            protocol = "ZWS2.0/NULL,ZWS2.0";
+        else if (_options.mechanism == ZMQ_PLAIN)
+            protocol = "ZWS2.0/PLAIN";
+#ifdef ZMQ_HAVE_CURVE
+        else if (_options.mechanism == ZMQ_CURVE)
+            protocol = "ZWS2.0/CURVE";
+#endif
+        else {
+            // Avoid unitialized variable error breaking UWP build
+            protocol = "";
+            assert (false);
+        }
+
+        unsigned char nonce[16];
+        int *p = reinterpret_cast<int *> (nonce);
+
+        // The nonce doesn't have to be secure one, it is just use to avoid proxy cache
+        *p = zmq::generate_random ();
+        *(p + 1) = zmq::generate_random ();
+        *(p + 2) = zmq::generate_random ();
+        *(p + 3) = zmq::generate_random ();
+
+        int size =
+          encode_base64 (nonce, 16, _websocket_key, MAX_HEADER_VALUE_LENGTH);
+        assert (size > 0);
+
+        size = snprintf (
+          reinterpret_cast<char *> (_write_buffer), WS_BUFFER_SIZE,
+          "GET %s HTTP/1.1\r\n"
+          "Host: %s\r\n"
+          "Upgrade: websocket\r\n"
+          "Connection: Upgrade\r\n"
+          "Sec-WebSocket-Key: %s\r\n"
+          "Sec-WebSocket-Protocol: %s\r\n"
+          "Sec-WebSocket-Version: 13\r\n\r\n",
+          _address.path (), _address.host (), _websocket_key, protocol);
+        assert (size > 0 && size < WS_BUFFER_SIZE);
+        _outpos = _write_buffer;
+        _outsize = size;
+        set_pollout ();
+    }
+}
+
+void zmq::ws_engine_t::plug_internal ()
+{
+    start_ws_handshake ();
+    set_pollin ();
+    in_event ();
+}
+
+int zmq::ws_engine_t::routing_id_msg (msg_t *msg_)
+{
+    const int rc = msg_->init_size (_options.routing_id_size);
+    errno_assert (rc == 0);
+    if (_options.routing_id_size > 0)
+        memcpy (msg_->data (), _options.routing_id, _options.routing_id_size);
+    _next_msg = &ws_engine_t::pull_msg_from_session;
+
+    return 0;
+}
+
+int zmq::ws_engine_t::process_routing_id_msg (msg_t *msg_)
+{
+    if (_options.recv_routing_id) {
+        msg_->set_flags (msg_t::routing_id);
+        const int rc = session ()->push_msg (msg_);
+        errno_assert (rc == 0);
+    } else {
+        int rc = msg_->close ();
+        errno_assert (rc == 0);
+        rc = msg_->init ();
+        errno_assert (rc == 0);
+    }
+
+    _process_msg = &ws_engine_t::push_msg_to_session;
+
+    return 0;
+}
+
+bool zmq::ws_engine_t::select_protocol (const char *protocol_)
+{
+    if (_options.mechanism == ZMQ_NULL && (strcmp ("ZWS2.0", protocol_) == 0)) {
+        _next_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+          &ws_engine_t::routing_id_msg);
+        _process_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+          &ws_engine_t::process_routing_id_msg);
+
+        // No mechanism in place, enabling heartbeat
+        if (_options.heartbeat_interval > 0 && !_has_heartbeat_timer) {
+            add_timer (_options.heartbeat_interval, heartbeat_ivl_timer_id);
+            _has_heartbeat_timer = true;
+        }
+
+        return true;
+    }
+    if (_options.mechanism == ZMQ_NULL
+        && strcmp ("ZWS2.0/NULL", protocol_) == 0) {
+        _mechanism = new (std::nothrow)
+          null_mechanism_t (session (), _peer_address, _options);
+        alloc_assert (_mechanism);
+        return true;
+    } else if (_options.mechanism == ZMQ_PLAIN
+               && strcmp ("ZWS2.0/PLAIN", protocol_) == 0) {
+        if (_options.as_server)
+            _mechanism = new (std::nothrow)
+              plain_server_t (session (), _peer_address, _options);
+        else
+            _mechanism =
+              new (std::nothrow) plain_client_t (session (), _options);
+        alloc_assert (_mechanism);
+        return true;
+    }
+#ifdef ZMQ_HAVE_CURVE
+    else if (_options.mechanism == ZMQ_CURVE
+             && strcmp ("ZWS2.0/CURVE", protocol_) == 0) {
+        if (_options.as_server)
+            _mechanism = new (std::nothrow)
+              curve_server_t (session (), _peer_address, _options, false);
+        else
+            _mechanism =
+              new (std::nothrow) curve_client_t (session (), _options, false);
+        alloc_assert (_mechanism);
+        return true;
+    }
+#endif
+
+    return false;
+}
+
+bool zmq::ws_engine_t::handshake ()
+{
+    bool complete;
+
+    if (_client)
+        complete = client_handshake ();
+    else
+        complete = server_handshake ();
+
+    if (complete) {
+        _encoder =
+          new (std::nothrow) ws_encoder_t (_options.out_batch_size, _client);
+        alloc_assert (_encoder);
+
+        _decoder = new (std::nothrow)
+          ws_decoder_t (_options.in_batch_size, _options.maxmsgsize,
+                        _options.zero_copy, !_client);
+        alloc_assert (_decoder);
+
+        socket ()->event_handshake_succeeded (_endpoint_uri_pair, 0);
+
+        set_pollout ();
+    }
+
+    return complete;
+}
+
+bool zmq::ws_engine_t::server_handshake ()
+{
+    const int nbytes = read (_read_buffer, WS_BUFFER_SIZE);
+    if (nbytes == -1) {
+        if (errno != EAGAIN)
+            error (zmq::i_engine::connection_error);
+        return false;
+    }
+
+    _inpos = _read_buffer;
+    _insize = nbytes;
+
+    while (_insize > 0) {
+        const char c = static_cast<char> (*_inpos);
+
+        switch (_server_handshake_state) {
+            case handshake_initial:
+                if (c == 'G')
+                    _server_handshake_state = request_line_G;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_G:
+                if (c == 'E')
+                    _server_handshake_state = request_line_GE;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_GE:
+                if (c == 'T')
+                    _server_handshake_state = request_line_GET;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_GET:
+                if (c == ' ')
+                    _server_handshake_state = request_line_GET_space;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_GET_space:
+                if (c == '\r' || c == '\n')
+                    _server_handshake_state = handshake_error;
+                // TODO: instead of check what is not allowed check what is allowed
+                if (c != ' ')
+                    _server_handshake_state = request_line_resource;
+                else
+                    _server_handshake_state = request_line_GET_space;
+                break;
+            case request_line_resource:
+                if (c == '\r' || c == '\n')
+                    _server_handshake_state = handshake_error;
+                else if (c == ' ')
+                    _server_handshake_state = request_line_resource_space;
+                else
+                    _server_handshake_state = request_line_resource;
+                break;
+            case request_line_resource_space:
+                if (c == 'H')
+                    _server_handshake_state = request_line_H;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_H:
+                if (c == 'T')
+                    _server_handshake_state = request_line_HT;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_HT:
+                if (c == 'T')
+                    _server_handshake_state = request_line_HTT;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_HTT:
+                if (c == 'P')
+                    _server_handshake_state = request_line_HTTP;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_HTTP:
+                if (c == '/')
+                    _server_handshake_state = request_line_HTTP_slash;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_HTTP_slash:
+                if (c == '1')
+                    _server_handshake_state = request_line_HTTP_slash_1;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_HTTP_slash_1:
+                if (c == '.')
+                    _server_handshake_state = request_line_HTTP_slash_1_dot;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_HTTP_slash_1_dot:
+                if (c == '1')
+                    _server_handshake_state = request_line_HTTP_slash_1_dot_1;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_HTTP_slash_1_dot_1:
+                if (c == '\r')
+                    _server_handshake_state = request_line_cr;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case request_line_cr:
+                if (c == '\n')
+                    _server_handshake_state = header_field_begin_name;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case header_field_begin_name:
+                switch (c) {
+                    case '\r':
+                        _server_handshake_state = handshake_end_line_cr;
+                        break;
+                    case '\n':
+                        _server_handshake_state = handshake_error;
+                        break;
+                    default:
+                        _header_name[0] = c;
+                        _header_name_position = 1;
+                        _server_handshake_state = header_field_name;
+                        break;
+                }
+                break;
+            case header_field_name:
+                if (c == '\r' || c == '\n')
+                    _server_handshake_state = handshake_error;
+                else if (c == ':') {
+                    _header_name[_header_name_position] = '\0';
+                    _server_handshake_state = header_field_colon;
+                } else if (_header_name_position + 1 > MAX_HEADER_NAME_LENGTH)
+                    _server_handshake_state = handshake_error;
+                else {
+                    _header_name[_header_name_position] = c;
+                    _header_name_position++;
+                    _server_handshake_state = header_field_name;
+                }
+                break;
+            case header_field_colon:
+            case header_field_value_trailing_space:
+                if (c == '\n')
+                    _server_handshake_state = handshake_error;
+                else if (c == '\r')
+                    _server_handshake_state = header_field_cr;
+                else if (c == ' ')
+                    _server_handshake_state = header_field_value_trailing_space;
+                else {
+                    _header_value[0] = c;
+                    _header_value_position = 1;
+                    _server_handshake_state = header_field_value;
+                }
+                break;
+            case header_field_value:
+                if (c == '\n')
+                    _server_handshake_state = handshake_error;
+                else if (c == '\r') {
+                    _header_value[_header_value_position] = '\0';
+
+                    if (strcasecmp ("upgrade", _header_name) == 0)
+                        _header_upgrade_websocket =
+                          strcasecmp ("websocket", _header_value) == 0;
+                    else if (strcasecmp ("connection", _header_name) == 0)
+                        _header_connection_upgrade =
+                          strcasecmp ("upgrade", _header_value) == 0;
+                    else if (strcasecmp ("Sec-WebSocket-Key", _header_name)
+                             == 0)
+                        strcpy_s (_websocket_key, _header_value);
+                    else if (strcasecmp ("Sec-WebSocket-Protocol", _header_name)
+                             == 0) {
+                        // Currently only the ZWS2.0 is supported
+                        // Sec-WebSocket-Protocol can appear multiple times or be a comma separated list
+                        // if _websocket_protocol is already set we skip the check
+                        if (_websocket_protocol[0] == '\0') {
+                            char *rest = 0;
+                            char *p = strtok_r (_header_value, ",", &rest);
+                            while (p != NULL) {
+                                if (*p == ' ')
+                                    p++;
+
+                                if (select_protocol (p)) {
+                                    strcpy_s (_websocket_protocol, p);
+                                    break;
+                                }
+
+                                p = strtok_r (NULL, ",", &rest);
+                            }
+                        }
+                    }
+
+                    _server_handshake_state = header_field_cr;
+                } else if (_header_value_position + 1 > MAX_HEADER_VALUE_LENGTH)
+                    _server_handshake_state = handshake_error;
+                else {
+                    _header_value[_header_value_position] = c;
+                    _header_value_position++;
+                    _server_handshake_state = header_field_value;
+                }
+                break;
+            case header_field_cr:
+                if (c == '\n')
+                    _server_handshake_state = header_field_begin_name;
+                else
+                    _server_handshake_state = handshake_error;
+                break;
+            case handshake_end_line_cr:
+                if (c == '\n') {
+                    if (_header_connection_upgrade && _header_upgrade_websocket
+                        && _websocket_protocol[0] != '\0'
+                        && _websocket_key[0] != '\0') {
+                        _server_handshake_state = handshake_complete;
+
+                        unsigned char hash[SHA_DIGEST_LENGTH];
+                        compute_accept_key (_websocket_key, hash);
+
+                        const int accept_key_len = encode_base64 (
+                          hash, SHA_DIGEST_LENGTH, _websocket_accept,
+                          MAX_HEADER_VALUE_LENGTH);
+                        assert (accept_key_len > 0);
+                        _websocket_accept[accept_key_len] = '\0';
+
+                        const int written =
+                          snprintf (reinterpret_cast<char *> (_write_buffer),
+                                    WS_BUFFER_SIZE,
+                                    "HTTP/1.1 101 Switching Protocols\r\n"
+                                    "Upgrade: websocket\r\n"
+                                    "Connection: Upgrade\r\n"
+                                    "Sec-WebSocket-Accept: %s\r\n"
+                                    "Sec-WebSocket-Protocol: %s\r\n"
+                                    "\r\n",
+                                    _websocket_accept, _websocket_protocol);
+                        assert (written >= 0 && written < WS_BUFFER_SIZE);
+                        _outpos = _write_buffer;
+                        _outsize = written;
+
+                        _inpos++;
+                        _insize--;
+
+                        return true;
+                    }
+                    _server_handshake_state = handshake_error;
+                } else
+                    _server_handshake_state = handshake_error;
+                break;
+            default:
+                assert (false);
+        }
+
+        _inpos++;
+        _insize--;
+
+        if (_server_handshake_state == handshake_error) {
+            // TODO: send bad request
+
+            socket ()->event_handshake_failed_protocol (
+              _endpoint_uri_pair, ZMQ_PROTOCOL_ERROR_WS_UNSPECIFIED);
+
+            error (zmq::i_engine::protocol_error);
+            return false;
+        }
+    }
+    return false;
+}
+
+bool zmq::ws_engine_t::client_handshake ()
+{
+    const int nbytes = read (_read_buffer, WS_BUFFER_SIZE);
+    if (nbytes == -1) {
+        if (errno != EAGAIN)
+            error (zmq::i_engine::connection_error);
+        return false;
+    }
+
+    _inpos = _read_buffer;
+    _insize = nbytes;
+
+    while (_insize > 0) {
+        const char c = static_cast<char> (*_inpos);
+
+        switch (_client_handshake_state) {
+            case client_handshake_initial:
+                if (c == 'H')
+                    _client_handshake_state = response_line_H;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_H:
+                if (c == 'T')
+                    _client_handshake_state = response_line_HT;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_HT:
+                if (c == 'T')
+                    _client_handshake_state = response_line_HTT;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_HTT:
+                if (c == 'P')
+                    _client_handshake_state = response_line_HTTP;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_HTTP:
+                if (c == '/')
+                    _client_handshake_state = response_line_HTTP_slash;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_HTTP_slash:
+                if (c == '1')
+                    _client_handshake_state = response_line_HTTP_slash_1;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_HTTP_slash_1:
+                if (c == '.')
+                    _client_handshake_state = response_line_HTTP_slash_1_dot;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_HTTP_slash_1_dot:
+                if (c == '1')
+                    _client_handshake_state = response_line_HTTP_slash_1_dot_1;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_HTTP_slash_1_dot_1:
+                if (c == ' ')
+                    _client_handshake_state =
+                      response_line_HTTP_slash_1_dot_1_space;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_HTTP_slash_1_dot_1_space:
+                if (c == ' ')
+                    _client_handshake_state =
+                      response_line_HTTP_slash_1_dot_1_space;
+                else if (c == '1')
+                    _client_handshake_state = response_line_status_1;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_status_1:
+                if (c == '0')
+                    _client_handshake_state = response_line_status_10;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_status_10:
+                if (c == '1')
+                    _client_handshake_state = response_line_status_101;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_status_101:
+                if (c == ' ')
+                    _client_handshake_state = response_line_status_101_space;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_status_101_space:
+                if (c == ' ')
+                    _client_handshake_state = response_line_status_101_space;
+                else if (c == 'S')
+                    _client_handshake_state = response_line_s;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_s:
+                if (c == 'w')
+                    _client_handshake_state = response_line_sw;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_sw:
+                if (c == 'i')
+                    _client_handshake_state = response_line_swi;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_swi:
+                if (c == 't')
+                    _client_handshake_state = response_line_swit;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_swit:
+                if (c == 'c')
+                    _client_handshake_state = response_line_switc;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_switc:
+                if (c == 'h')
+                    _client_handshake_state = response_line_switch;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_switch:
+                if (c == 'i')
+                    _client_handshake_state = response_line_switchi;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_switchi:
+                if (c == 'n')
+                    _client_handshake_state = response_line_switchin;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_switchin:
+                if (c == 'g')
+                    _client_handshake_state = response_line_switching;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_switching:
+                if (c == ' ')
+                    _client_handshake_state = response_line_switching_space;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_switching_space:
+                if (c == 'P')
+                    _client_handshake_state = response_line_p;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_p:
+                if (c == 'r')
+                    _client_handshake_state = response_line_pr;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_pr:
+                if (c == 'o')
+                    _client_handshake_state = response_line_pro;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_pro:
+                if (c == 't')
+                    _client_handshake_state = response_line_prot;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_prot:
+                if (c == 'o')
+                    _client_handshake_state = response_line_proto;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_proto:
+                if (c == 'c')
+                    _client_handshake_state = response_line_protoc;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_protoc:
+                if (c == 'o')
+                    _client_handshake_state = response_line_protoco;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_protoco:
+                if (c == 'l')
+                    _client_handshake_state = response_line_protocol;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_protocol:
+                if (c == 's')
+                    _client_handshake_state = response_line_protocols;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_protocols:
+                if (c == '\r')
+                    _client_handshake_state = response_line_cr;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case response_line_cr:
+                if (c == '\n')
+                    _client_handshake_state = client_header_field_begin_name;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case client_header_field_begin_name:
+                switch (c) {
+                    case '\r':
+                        _client_handshake_state = client_handshake_end_line_cr;
+                        break;
+                    case '\n':
+                        _client_handshake_state = client_handshake_error;
+                        break;
+                    default:
+                        _header_name[0] = c;
+                        _header_name_position = 1;
+                        _client_handshake_state = client_header_field_name;
+                        break;
+                }
+                break;
+            case client_header_field_name:
+                if (c == '\r' || c == '\n')
+                    _client_handshake_state = client_handshake_error;
+                else if (c == ':') {
+                    _header_name[_header_name_position] = '\0';
+                    _client_handshake_state = client_header_field_colon;
+                } else if (_header_name_position + 1 > MAX_HEADER_NAME_LENGTH)
+                    _client_handshake_state = client_handshake_error;
+                else {
+                    _header_name[_header_name_position] = c;
+                    _header_name_position++;
+                    _client_handshake_state = client_header_field_name;
+                }
+                break;
+            case client_header_field_colon:
+            case client_header_field_value_trailing_space:
+                if (c == '\n')
+                    _client_handshake_state = client_handshake_error;
+                else if (c == '\r')
+                    _client_handshake_state = client_header_field_cr;
+                else if (c == ' ')
+                    _client_handshake_state =
+                      client_header_field_value_trailing_space;
+                else {
+                    _header_value[0] = c;
+                    _header_value_position = 1;
+                    _client_handshake_state = client_header_field_value;
+                }
+                break;
+            case client_header_field_value:
+                if (c == '\n')
+                    _client_handshake_state = client_handshake_error;
+                else if (c == '\r') {
+                    _header_value[_header_value_position] = '\0';
+
+                    if (strcasecmp ("upgrade", _header_name) == 0)
+                        _header_upgrade_websocket =
+                          strcasecmp ("websocket", _header_value) == 0;
+                    else if (strcasecmp ("connection", _header_name) == 0)
+                        _header_connection_upgrade =
+                          strcasecmp ("upgrade", _header_value) == 0;
+                    else if (strcasecmp ("Sec-WebSocket-Accept", _header_name)
+                             == 0)
+                        strcpy_s (_websocket_accept, _header_value);
+                    else if (strcasecmp ("Sec-WebSocket-Protocol", _header_name)
+                             == 0) {
+                        if (_mechanism) {
+                            _client_handshake_state = client_handshake_error;
+                            break;
+                        }
+                        if (select_protocol (_header_value))
+                            strcpy_s (_websocket_protocol, _header_value);
+                    }
+                    _client_handshake_state = client_header_field_cr;
+                } else if (_header_value_position + 1 > MAX_HEADER_VALUE_LENGTH)
+                    _client_handshake_state = client_handshake_error;
+                else {
+                    _header_value[_header_value_position] = c;
+                    _header_value_position++;
+                    _client_handshake_state = client_header_field_value;
+                }
+                break;
+            case client_header_field_cr:
+                if (c == '\n')
+                    _client_handshake_state = client_header_field_begin_name;
+                else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            case client_handshake_end_line_cr:
+                if (c == '\n') {
+                    if (_header_connection_upgrade && _header_upgrade_websocket
+                        && _websocket_protocol[0] != '\0'
+                        && _websocket_accept[0] != '\0') {
+                        _client_handshake_state = client_handshake_complete;
+
+                        // TODO: validate accept key
+
+                        _inpos++;
+                        _insize--;
+
+                        return true;
+                    }
+                    _client_handshake_state = client_handshake_error;
+                } else
+                    _client_handshake_state = client_handshake_error;
+                break;
+            default:
+                assert (false);
+        }
+
+        _inpos++;
+        _insize--;
+
+        if (_client_handshake_state == client_handshake_error) {
+            socket ()->event_handshake_failed_protocol (
+              _endpoint_uri_pair, ZMQ_PROTOCOL_ERROR_WS_UNSPECIFIED);
+
+            error (zmq::i_engine::protocol_error);
+            return false;
+        }
+    }
+
+    return false;
+}
+
+int zmq::ws_engine_t::decode_and_push (msg_t *msg_)
+{
+    zmq_assert (_mechanism != NULL);
+
+    //  with WS engine, ping and pong commands are control messages and should not go through any mechanism
+    if (msg_->is_ping () || msg_->is_pong () || msg_->is_close_cmd ()) {
+        if (process_command_message (msg_) == -1)
+            return -1;
+    } else if (_mechanism->decode (msg_) == -1)
+        return -1;
+
+    if (_has_timeout_timer) {
+        _has_timeout_timer = false;
+        cancel_timer (heartbeat_timeout_timer_id);
+    }
+
+    if (msg_->flags () & msg_t::command && !msg_->is_ping ()
+        && !msg_->is_pong () && !msg_->is_close_cmd ())
+        process_command_message (msg_);
+
+    if (_metadata)
+        msg_->set_metadata (_metadata);
+    if (session ()->push_msg (msg_) == -1) {
+        if (errno == EAGAIN)
+            _process_msg = &ws_engine_t::push_one_then_decode_and_push;
+        return -1;
+    }
+    return 0;
+}
+
+int zmq::ws_engine_t::produce_close_message (msg_t *msg_)
+{
+    int rc = msg_->move (_close_msg);
+    errno_assert (rc == 0);
+
+    _next_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+      &ws_engine_t::produce_no_msg_after_close);
+
+    return rc;
+}
+
+int zmq::ws_engine_t::produce_no_msg_after_close (msg_t *msg_)
+{
+    _next_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+      &ws_engine_t::close_connection_after_close);
+
+    errno = EAGAIN;
+    return -1;
+}
+
+int zmq::ws_engine_t::close_connection_after_close (msg_t *msg_)
+{
+    error (connection_error);
+    errno = ECONNRESET;
+    return -1;
+}
+
+int zmq::ws_engine_t::produce_ping_message (msg_t *msg_)
+{
+    int rc = msg_->init ();
+    errno_assert (rc == 0);
+    msg_->set_flags (msg_t::command | msg_t::ping);
+
+    _next_msg = &ws_engine_t::pull_and_encode;
+    if (!_has_timeout_timer && _heartbeat_timeout > 0) {
+        add_timer (_heartbeat_timeout, heartbeat_timeout_timer_id);
+        _has_timeout_timer = true;
+    }
+
+    return rc;
+}
+
+
+int zmq::ws_engine_t::produce_pong_message (msg_t *msg_)
+{
+    int rc = msg_->init ();
+    errno_assert (rc == 0);
+    msg_->set_flags (msg_t::command | msg_t::pong);
+
+    _next_msg = &ws_engine_t::pull_and_encode;
+    return rc;
+}
+
+
+int zmq::ws_engine_t::process_command_message (msg_t *msg_)
+{
+    if (msg_->is_ping ()) {
+        _next_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+          &ws_engine_t::produce_pong_message);
+        out_event ();
+    } else if (msg_->is_close_cmd ()) {
+        int rc = _close_msg.copy (*msg_);
+        errno_assert (rc == 0);
+        _next_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+          &ws_engine_t::produce_close_message);
+        out_event ();
+    }
+
+    return 0;
+}
+
+static int
+encode_base64 (const unsigned char *in_, int in_len_, char *out_, int out_len_)
+{
+    static const unsigned char base64enc_tab[65] =
+      "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
+
+    int io = 0;
+    uint32_t v = 0;
+    int rem = 0;
+
+    for (int ii = 0; ii < in_len_; ii++) {
+        unsigned char ch;
+        ch = in_[ii];
+        v = (v << 8) | ch;
+        rem += 8;
+        while (rem >= 6) {
+            rem -= 6;
+            if (io >= out_len_)
+                return -1; /* truncation is failure */
+            out_[io++] = base64enc_tab[(v >> rem) & 63];
+        }
+    }
+    if (rem) {
+        v <<= (6 - rem);
+        if (io >= out_len_)
+            return -1; /* truncation is failure */
+        out_[io++] = base64enc_tab[v & 63];
+    }
+    while (io & 3) {
+        if (io >= out_len_)
+            return -1; /* truncation is failure */
+        out_[io++] = '=';
+    }
+    if (io >= out_len_)
+        return -1; /* no room for null terminator */
+    out_[io] = 0;
+    return io;
+}
+
+static void compute_accept_key (char *key_, unsigned char *hash_)
+{
+    const char *magic_string = "258EAFA5-E914-47DA-95CA-C5AB0DC85B11";
+#ifdef ZMQ_USE_NSS
+    unsigned int len;
+    HASH_HashType type = HASH_GetHashTypeByOidTag (SEC_OID_SHA1);
+    HASHContext *ctx = HASH_Create (type);
+    assert (ctx);
+
+    HASH_Begin (ctx);
+    HASH_Update (ctx, (unsigned char *) key_, (unsigned int) strlen (key_));
+    HASH_Update (ctx, (unsigned char *) magic_string,
+                 (unsigned int) strlen (magic_string));
+    HASH_End (ctx, hash_, &len, SHA_DIGEST_LENGTH);
+    HASH_Destroy (ctx);
+#elif defined ZMQ_USE_BUILTIN_SHA1
+    sha1_ctxt ctx;
+    SHA1_Init (&ctx);
+    SHA1_Update (&ctx, (unsigned char *) key_, strlen (key_));
+    SHA1_Update (&ctx, (unsigned char *) magic_string, strlen (magic_string));
+
+    SHA1_Final (hash_, &ctx);
+#elif defined ZMQ_USE_GNUTLS
+    gnutls_hash_hd_t hd;
+    gnutls_hash_init (&hd, GNUTLS_DIG_SHA1);
+    gnutls_hash (hd, key_, strlen (key_));
+    gnutls_hash (hd, magic_string, strlen (magic_string));
+    gnutls_hash_deinit (hd, hash_);
+#else
+#error "No sha1 implementation set"
+#endif
+}
diff -pruN 4.3.2-2/src/ws_engine.hpp 4.3.3-1/src/ws_engine.hpp
--- 4.3.2-2/src/ws_engine.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_engine.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,182 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_WS_ENGINE_HPP_INCLUDED__
+#define __ZMQ_WS_ENGINE_HPP_INCLUDED__
+
+#include "io_object.hpp"
+#include "address.hpp"
+#include "msg.hpp"
+#include "stream_engine_base.hpp"
+#include "ws_address.hpp"
+
+#define WS_BUFFER_SIZE 8192
+#define MAX_HEADER_NAME_LENGTH 1024
+#define MAX_HEADER_VALUE_LENGTH 2048
+
+namespace zmq
+{
+class io_thread_t;
+class session_base_t;
+
+typedef enum
+{
+    handshake_initial = 0,
+    request_line_G,
+    request_line_GE,
+    request_line_GET,
+    request_line_GET_space,
+    request_line_resource,
+    request_line_resource_space,
+    request_line_H,
+    request_line_HT,
+    request_line_HTT,
+    request_line_HTTP,
+    request_line_HTTP_slash,
+    request_line_HTTP_slash_1,
+    request_line_HTTP_slash_1_dot,
+    request_line_HTTP_slash_1_dot_1,
+    request_line_cr,
+    header_field_begin_name,
+    header_field_name,
+    header_field_colon,
+    header_field_value_trailing_space,
+    header_field_value,
+    header_field_cr,
+    handshake_end_line_cr,
+    handshake_complete,
+
+    handshake_error = -1
+} ws_server_handshake_state_t;
+
+
+typedef enum
+{
+    client_handshake_initial = 0,
+    response_line_H,
+    response_line_HT,
+    response_line_HTT,
+    response_line_HTTP,
+    response_line_HTTP_slash,
+    response_line_HTTP_slash_1,
+    response_line_HTTP_slash_1_dot,
+    response_line_HTTP_slash_1_dot_1,
+    response_line_HTTP_slash_1_dot_1_space,
+    response_line_status_1,
+    response_line_status_10,
+    response_line_status_101,
+    response_line_status_101_space,
+    response_line_s,
+    response_line_sw,
+    response_line_swi,
+    response_line_swit,
+    response_line_switc,
+    response_line_switch,
+    response_line_switchi,
+    response_line_switchin,
+    response_line_switching,
+    response_line_switching_space,
+    response_line_p,
+    response_line_pr,
+    response_line_pro,
+    response_line_prot,
+    response_line_proto,
+    response_line_protoc,
+    response_line_protoco,
+    response_line_protocol,
+    response_line_protocols,
+    response_line_cr,
+    client_header_field_begin_name,
+    client_header_field_name,
+    client_header_field_colon,
+    client_header_field_value_trailing_space,
+    client_header_field_value,
+    client_header_field_cr,
+    client_handshake_end_line_cr,
+    client_handshake_complete,
+
+    client_handshake_error = -1
+} ws_client_handshake_state_t;
+
+class ws_engine_t : public stream_engine_base_t
+{
+  public:
+    ws_engine_t (fd_t fd_,
+                 const options_t &options_,
+                 const endpoint_uri_pair_t &endpoint_uri_pair_,
+                 const ws_address_t &address_,
+                 bool client_);
+    ~ws_engine_t ();
+
+  protected:
+    int decode_and_push (msg_t *msg_);
+    int process_command_message (msg_t *msg_);
+    int produce_pong_message (msg_t *msg_);
+    int produce_ping_message (msg_t *msg_);
+    bool handshake ();
+    void plug_internal ();
+    void start_ws_handshake ();
+
+  private:
+    int routing_id_msg (msg_t *msg_);
+    int process_routing_id_msg (msg_t *msg_);
+    int produce_close_message (msg_t *msg_);
+    int produce_no_msg_after_close (msg_t *msg_);
+    int close_connection_after_close (msg_t *msg_);
+
+    bool select_protocol (const char *protocol);
+
+    bool client_handshake ();
+    bool server_handshake ();
+
+    bool _client;
+    ws_address_t _address;
+
+    ws_client_handshake_state_t _client_handshake_state;
+    ws_server_handshake_state_t _server_handshake_state;
+
+    unsigned char _read_buffer[WS_BUFFER_SIZE];
+    unsigned char _write_buffer[WS_BUFFER_SIZE];
+    char _header_name[MAX_HEADER_NAME_LENGTH + 1];
+    int _header_name_position;
+    char _header_value[MAX_HEADER_VALUE_LENGTH + 1];
+    int _header_value_position;
+
+    bool _header_upgrade_websocket;
+    bool _header_connection_upgrade;
+    char _websocket_protocol[256];
+    char _websocket_key[MAX_HEADER_VALUE_LENGTH + 1];
+    char _websocket_accept[MAX_HEADER_VALUE_LENGTH + 1];
+
+    int _heartbeat_timeout;
+    msg_t _close_msg;
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/ws_listener.cpp 4.3.3-1/src/ws_listener.cpp
--- 4.3.2-2/src/ws_listener.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_listener.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,335 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include <new>
+
+#include <string>
+#include <stdio.h>
+
+#include "ws_listener.hpp"
+#include "io_thread.hpp"
+#include "config.hpp"
+#include "err.hpp"
+#include "ip.hpp"
+#include "tcp.hpp"
+#include "socket_base.hpp"
+#include "address.hpp"
+#include "ws_engine.hpp"
+#include "session_base.hpp"
+
+#ifdef ZMQ_HAVE_WSS
+#include "wss_engine.hpp"
+#include "wss_address.hpp"
+#endif
+
+#ifndef ZMQ_HAVE_WINDOWS
+#include <unistd.h>
+#include <sys/socket.h>
+#include <arpa/inet.h>
+#include <netinet/tcp.h>
+#include <netinet/in.h>
+#include <netdb.h>
+#include <fcntl.h>
+#ifdef ZMQ_HAVE_VXWORKS
+#include <sockLib.h>
+#endif
+#endif
+
+#ifdef ZMQ_HAVE_OPENVMS
+#include <ioctl.h>
+#endif
+
+zmq::ws_listener_t::ws_listener_t (io_thread_t *io_thread_,
+                                   socket_base_t *socket_,
+                                   const options_t &options_,
+                                   bool wss_) :
+    stream_listener_base_t (io_thread_, socket_, options_),
+    _wss (wss_)
+{
+#ifdef ZMQ_HAVE_WSS
+    if (_wss) {
+        int rc = gnutls_certificate_allocate_credentials (&_tls_cred);
+        zmq_assert (rc == GNUTLS_E_SUCCESS);
+
+        gnutls_datum_t cert = {(unsigned char *) options_.wss_cert_pem.c_str (),
+                               (unsigned int) options_.wss_cert_pem.length ()};
+        gnutls_datum_t key = {(unsigned char *) options_.wss_key_pem.c_str (),
+                              (unsigned int) options_.wss_key_pem.length ()};
+        rc = gnutls_certificate_set_x509_key_mem (_tls_cred, &cert, &key,
+                                                  GNUTLS_X509_FMT_PEM);
+        zmq_assert (rc == GNUTLS_E_SUCCESS);
+    }
+#endif
+}
+
+zmq::ws_listener_t::~ws_listener_t ()
+{
+#ifdef ZMQ_HAVE_WSS
+    if (_wss)
+        gnutls_certificate_free_credentials (_tls_cred);
+#endif
+}
+
+void zmq::ws_listener_t::in_event ()
+{
+    const fd_t fd = accept ();
+
+    //  If connection was reset by the peer in the meantime, just ignore it.
+    //  TODO: Handle specific errors like ENFILE/EMFILE etc.
+    if (fd == retired_fd) {
+        _socket->event_accept_failed (
+          make_unconnected_bind_endpoint_pair (_endpoint), zmq_errno ());
+        return;
+    }
+
+    int rc = tune_tcp_socket (fd);
+    rc = rc | tune_tcp_maxrt (fd, options.tcp_maxrt);
+    if (rc != 0) {
+        _socket->event_accept_failed (
+          make_unconnected_bind_endpoint_pair (_endpoint), zmq_errno ());
+        return;
+    }
+
+    //  Create the engine object for this connection.
+    create_engine (fd);
+}
+
+std::string zmq::ws_listener_t::get_socket_name (zmq::fd_t fd_,
+                                                 socket_end_t socket_end_) const
+{
+    std::string socket_name;
+
+#ifdef ZMQ_HAVE_WSS
+    if (_wss)
+        socket_name = zmq::get_socket_name<wss_address_t> (fd_, socket_end_);
+    else
+#endif
+        socket_name = zmq::get_socket_name<ws_address_t> (fd_, socket_end_);
+
+    return socket_name + _address.path ();
+}
+
+int zmq::ws_listener_t::create_socket (const char *addr_)
+{
+    tcp_address_t address;
+    _s = tcp_open_socket (addr_, options, true, true, &address);
+    if (_s == retired_fd) {
+        return -1;
+    }
+
+    //  TODO why is this only done for the listener?
+    make_socket_noninheritable (_s);
+
+    //  Allow reusing of the address.
+    int flag = 1;
+    int rc;
+#ifdef ZMQ_HAVE_WINDOWS
+    //  TODO this was changed for Windows from SO_REUSEADDRE to
+    //  SE_EXCLUSIVEADDRUSE by 0ab65324195ad70205514d465b03d851a6de051c,
+    //  so the comment above is no longer correct; also, now the settings are
+    //  different between listener and connecter with a src address.
+    //  is this intentional?
+    rc = setsockopt (_s, SOL_SOCKET, SO_EXCLUSIVEADDRUSE,
+                     reinterpret_cast<const char *> (&flag), sizeof (int));
+    wsa_assert (rc != SOCKET_ERROR);
+#elif defined ZMQ_HAVE_VXWORKS
+    rc =
+      setsockopt (_s, SOL_SOCKET, SO_REUSEADDR, (char *) &flag, sizeof (int));
+    errno_assert (rc == 0);
+#else
+    rc = setsockopt (_s, SOL_SOCKET, SO_REUSEADDR, &flag, sizeof (int));
+    errno_assert (rc == 0);
+#endif
+
+    //  Bind the socket to the network interface and port.
+#if defined ZMQ_HAVE_VXWORKS
+    rc = bind (_s, (sockaddr *) _address.addr (), _address.addrlen ());
+#else
+    rc = bind (_s, address.addr (), address.addrlen ());
+#endif
+#ifdef ZMQ_HAVE_WINDOWS
+    if (rc == SOCKET_ERROR) {
+        errno = wsa_error_to_errno (WSAGetLastError ());
+        goto error;
+    }
+#else
+    if (rc != 0)
+        goto error;
+#endif
+
+    //  Listen for incoming connections.
+    rc = listen (_s, options.backlog);
+#ifdef ZMQ_HAVE_WINDOWS
+    if (rc == SOCKET_ERROR) {
+        errno = wsa_error_to_errno (WSAGetLastError ());
+        goto error;
+    }
+#else
+    if (rc != 0)
+        goto error;
+#endif
+
+    return 0;
+
+error:
+    const int err = errno;
+    close ();
+    errno = err;
+    return -1;
+}
+
+int zmq::ws_listener_t::set_local_address (const char *addr_)
+{
+    if (options.use_fd != -1) {
+        //  in this case, the addr_ passed is not used and ignored, since the
+        //  socket was already created by the application
+        _s = options.use_fd;
+    } else {
+        const int rc = _address.resolve (addr_, true, options.ipv6);
+        if (rc != 0)
+            return -1;
+
+        //  remove the path, otherwise resolving the port will fail with wildcard
+        const char *delim = strrchr (addr_, '/');
+        std::string host_address;
+        if (delim) {
+            host_address = std::string (addr_, delim - addr_);
+        } else {
+            host_address = addr_;
+        }
+
+        if (create_socket (host_address.c_str ()) == -1)
+            return -1;
+    }
+
+    _endpoint = get_socket_name (_s, socket_end_local);
+
+    _socket->event_listening (make_unconnected_bind_endpoint_pair (_endpoint),
+                              _s);
+    return 0;
+}
+
+zmq::fd_t zmq::ws_listener_t::accept ()
+{
+    //  The situation where connection cannot be accepted due to insufficient
+    //  resources is considered valid and treated by ignoring the connection.
+    //  Accept one connection and deal with different failure modes.
+    zmq_assert (_s != retired_fd);
+
+    struct sockaddr_storage ss;
+    memset (&ss, 0, sizeof (ss));
+#if defined ZMQ_HAVE_HPUX || defined ZMQ_HAVE_VXWORKS
+    int ss_len = sizeof (ss);
+#else
+    socklen_t ss_len = sizeof (ss);
+#endif
+#if defined ZMQ_HAVE_SOCK_CLOEXEC && defined HAVE_ACCEPT4
+    fd_t sock = ::accept4 (_s, reinterpret_cast<struct sockaddr *> (&ss),
+                           &ss_len, SOCK_CLOEXEC);
+#else
+    const fd_t sock =
+      ::accept (_s, reinterpret_cast<struct sockaddr *> (&ss), &ss_len);
+#endif
+
+    if (sock == retired_fd) {
+#if defined ZMQ_HAVE_WINDOWS
+        const int last_error = WSAGetLastError ();
+        wsa_assert (last_error == WSAEWOULDBLOCK || last_error == WSAECONNRESET
+                    || last_error == WSAEMFILE || last_error == WSAENOBUFS);
+#elif defined ZMQ_HAVE_ANDROID
+        errno_assert (errno == EAGAIN || errno == EWOULDBLOCK || errno == EINTR
+                      || errno == ECONNABORTED || errno == EPROTO
+                      || errno == ENOBUFS || errno == ENOMEM || errno == EMFILE
+                      || errno == ENFILE || errno == EINVAL);
+#else
+        errno_assert (errno == EAGAIN || errno == EWOULDBLOCK || errno == EINTR
+                      || errno == ECONNABORTED || errno == EPROTO
+                      || errno == ENOBUFS || errno == ENOMEM || errno == EMFILE
+                      || errno == ENFILE);
+#endif
+        return retired_fd;
+    }
+
+    make_socket_noninheritable (sock);
+
+    if (zmq::set_nosigpipe (sock)) {
+#ifdef ZMQ_HAVE_WINDOWS
+        const int rc = closesocket (sock);
+        wsa_assert (rc != SOCKET_ERROR);
+#else
+        int rc = ::close (sock);
+        errno_assert (rc == 0);
+#endif
+        return retired_fd;
+    }
+
+    // Set the IP Type-Of-Service priority for this client socket
+    if (options.tos != 0)
+        set_ip_type_of_service (sock, options.tos);
+
+    return sock;
+}
+
+void zmq::ws_listener_t::create_engine (fd_t fd_)
+{
+    const endpoint_uri_pair_t endpoint_pair (
+      get_socket_name (fd_, socket_end_local),
+      get_socket_name (fd_, socket_end_remote), endpoint_type_bind);
+
+    i_engine *engine = NULL;
+    if (_wss)
+#ifdef ZMQ_HAVE_WSS
+        engine = new (std::nothrow)
+          wss_engine_t (fd_, options, endpoint_pair, _address, false, _tls_cred,
+                        std::string ());
+#else
+        zmq_assert (false);
+#endif
+    else
+        engine = new (std::nothrow)
+          ws_engine_t (fd_, options, endpoint_pair, _address, false);
+
+    alloc_assert (engine);
+
+    //  Choose I/O thread to run connecter in. Given that we are already
+    //  running in an I/O thread, there must be at least one available.
+    io_thread_t *io_thread = choose_io_thread (options.affinity);
+    zmq_assert (io_thread);
+
+    //  Create and launch a session object.
+    session_base_t *session =
+      session_base_t::create (io_thread, false, _socket, options, NULL);
+    errno_assert (session);
+    session->inc_seqnum ();
+    launch_child (session);
+    send_attach (session, engine, false);
+
+    _socket->event_accepted (endpoint_pair, fd_);
+}
diff -pruN 4.3.2-2/src/ws_listener.hpp 4.3.3-1/src/ws_listener.hpp
--- 4.3.2-2/src/ws_listener.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_listener.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,84 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_WS_LISTENER_HPP_INCLUDED__
+#define __ZMQ_WS_LISTENER_HPP_INCLUDED__
+
+#include "fd.hpp"
+#include "ws_address.hpp"
+#include "stream_listener_base.hpp"
+
+#ifdef ZMQ_USE_GNUTLS
+#include <gnutls/gnutls.h>
+#endif
+
+namespace zmq
+{
+class ws_listener_t ZMQ_FINAL : public stream_listener_base_t
+{
+  public:
+    ws_listener_t (zmq::io_thread_t *io_thread_,
+                   zmq::socket_base_t *socket_,
+                   const options_t &options_,
+                   bool wss_);
+
+    ~ws_listener_t ();
+
+    //  Set address to listen on.
+    int set_local_address (const char *addr_);
+
+  protected:
+    std::string get_socket_name (fd_t fd_, socket_end_t socket_end_) const;
+    void create_engine (fd_t fd);
+
+  private:
+    //  Handlers for I/O events.
+    void in_event ();
+
+    //  Accept the new connection. Returns the file descriptor of the
+    //  newly created connection. The function may return retired_fd
+    //  if the connection was dropped while waiting in the listen backlog
+    //  or was denied because of accept filters.
+    fd_t accept ();
+
+    int create_socket (const char *addr_);
+
+    //  Address to listen on.
+    ws_address_t _address;
+
+    bool _wss;
+#ifdef ZMQ_HAVE_WSS
+    gnutls_certificate_credentials_t _tls_cred;
+#endif
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (ws_listener_t)
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/ws_protocol.hpp 4.3.3-1/src/ws_protocol.hpp
--- 4.3.2-2/src/ws_protocol.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/ws_protocol.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,58 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_WS_PROTOCOL_HPP_INCLUDED__
+#define __ZMQ_WS_PROTOCOL_HPP_INCLUDED__
+
+namespace zmq
+{
+//  Definition of constants for WS transport protocol.
+class ws_protocol_t
+{
+  public:
+    //  Message flags.
+    enum opcode_t
+    {
+        opcode_continuation = 0,
+        opcode_text = 0x01,
+        opcode_binary = 0x02,
+        opcode_close = 0x08,
+        opcode_ping = 0x09,
+        opcode_pong = 0xA
+    };
+
+    enum
+    {
+        more_flag = 1,
+        command_flag = 2
+    };
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/wss_address.cpp 4.3.3-1/src/wss_address.cpp
--- 4.3.2-2/src/wss_address.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/wss_address.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,53 @@
+/*
+    Copyright (c) 2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include <string>
+#include <sstream>
+
+#include "wss_address.hpp"
+
+zmq::wss_address_t::wss_address_t () : ws_address_t ()
+{
+}
+
+zmq::wss_address_t::wss_address_t (const sockaddr *sa_, socklen_t sa_len_) :
+    ws_address_t (sa_, sa_len_)
+{
+}
+
+int zmq::wss_address_t::to_string (std::string &addr_) const
+{
+    std::ostringstream os;
+    os << std::string ("wss://") << host () << std::string (":")
+       << _address.port () << path ();
+    addr_ = os.str ();
+
+    return 0;
+}
diff -pruN 4.3.2-2/src/wss_address.hpp 4.3.3-1/src/wss_address.hpp
--- 4.3.2-2/src/wss_address.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/wss_address.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,47 @@
+/*
+    Copyright (c) 2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_WSS_ADDRESS_HPP_INCLUDED__
+#define __ZMQ_WSS_ADDRESS_HPP_INCLUDED__
+
+#include "ws_address.hpp"
+
+namespace zmq
+{
+class wss_address_t : public ws_address_t
+{
+  public:
+    wss_address_t ();
+    wss_address_t (const sockaddr *sa_, socklen_t sa_len_);
+    //  The opposite to resolve()
+    int to_string (std::string &addr_) const;
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/wss_engine.cpp 4.3.3-1/src/wss_engine.cpp
--- 4.3.2-2/src/wss_engine.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/wss_engine.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,227 @@
+/*
+Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+This file is part of libzmq, the ZeroMQ core engine in C++.
+
+libzmq is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License (LGPL) as published
+by the Free Software Foundation; either version 3 of the License, or
+(at your option) any later version.
+
+As a special exception, the Contributors give you permission to link
+this library with independent modules to produce an executable,
+regardless of the license terms of these independent modules, and to
+copy and distribute the resulting executable under terms of your choice,
+provided that you also meet, for each linked independent module, the
+terms and conditions of the license of that module. An independent
+module is a module which is not derived from or based on this library.
+If you modify this library, you must extend this exception to your
+version of the library.
+
+libzmq is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+License for more details.
+
+You should have received a copy of the GNU Lesser General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include "wss_engine.hpp"
+
+static int verify_certificate_callback (gnutls_session_t session)
+{
+    unsigned int status;
+    const char *hostname;
+
+    // read hostname
+    hostname = (const char *) gnutls_session_get_ptr (session);
+
+    int rc = gnutls_certificate_verify_peers3 (session, hostname, &status);
+    zmq_assert (rc >= 0);
+
+    if (status != 0) {
+        // TODO: somehow log the error
+        // Certificate is not trusted
+        return GNUTLS_E_CERTIFICATE_ERROR;
+    }
+
+    // notify gnutls to continue handshake normally
+    return 0;
+}
+
+
+zmq::wss_engine_t::wss_engine_t (fd_t fd_,
+                                 const options_t &options_,
+                                 const endpoint_uri_pair_t &endpoint_uri_pair_,
+                                 ws_address_t &address_,
+                                 bool client_,
+                                 void *tls_server_cred_,
+                                 const std::string &hostname_) :
+    ws_engine_t (fd_, options_, endpoint_uri_pair_, address_, client_),
+    _established (false),
+    _tls_client_cred (NULL)
+{
+    int rc = 0;
+
+    if (client_) {
+        // TODO: move to session_base, to allow changing the socket options between connect calls
+        rc = gnutls_certificate_allocate_credentials (&_tls_client_cred);
+        zmq_assert (rc == 0);
+
+        if (options_.wss_trust_system)
+            gnutls_certificate_set_x509_system_trust (_tls_client_cred);
+
+        if (options_.wss_trust_pem.length () > 0) {
+            gnutls_datum_t trust = {
+              (unsigned char *) options_.wss_trust_pem.c_str (),
+              (unsigned int) options_.wss_trust_pem.length ()};
+            rc = gnutls_certificate_set_x509_trust_mem (
+              _tls_client_cred, &trust, GNUTLS_X509_FMT_PEM);
+            zmq_assert (rc >= 0);
+        }
+
+        gnutls_certificate_set_verify_function (_tls_client_cred,
+                                                verify_certificate_callback);
+
+        rc = gnutls_init (&_tls_session, GNUTLS_CLIENT | GNUTLS_NONBLOCK);
+        zmq_assert (rc == GNUTLS_E_SUCCESS);
+
+        if (!hostname_.empty ())
+            gnutls_server_name_set (_tls_session, GNUTLS_NAME_DNS,
+                                    hostname_.c_str (), hostname_.size ());
+
+        gnutls_session_set_ptr (
+          _tls_session,
+          hostname_.empty () ? NULL : const_cast<char *> (hostname_.c_str ()));
+
+        rc = gnutls_credentials_set (_tls_session, GNUTLS_CRD_CERTIFICATE,
+                                     _tls_client_cred);
+        zmq_assert (rc == GNUTLS_E_SUCCESS);
+    } else {
+        zmq_assert (tls_server_cred_);
+
+        rc = gnutls_init (&_tls_session, GNUTLS_SERVER | GNUTLS_NONBLOCK);
+        zmq_assert (rc == GNUTLS_E_SUCCESS);
+
+        rc = gnutls_credentials_set (_tls_session, GNUTLS_CRD_CERTIFICATE,
+                                     tls_server_cred_);
+        zmq_assert (rc == GNUTLS_E_SUCCESS);
+    }
+
+    gnutls_set_default_priority (_tls_session);
+    gnutls_transport_set_int (_tls_session, fd_);
+}
+
+zmq::wss_engine_t::~wss_engine_t ()
+{
+    gnutls_deinit (_tls_session);
+
+    if (_tls_client_cred)
+        gnutls_certificate_free_credentials (_tls_client_cred);
+}
+
+void zmq::wss_engine_t::plug_internal ()
+{
+    set_pollin ();
+    in_event ();
+}
+
+void zmq::wss_engine_t::out_event ()
+{
+    if (_established)
+        return ws_engine_t::out_event ();
+
+    do_handshake ();
+}
+
+bool zmq::wss_engine_t::do_handshake ()
+{
+    int rc = gnutls_handshake (_tls_session);
+
+    reset_pollout ();
+
+    if (rc == GNUTLS_E_SUCCESS) {
+        start_ws_handshake ();
+        _established = true;
+        return false;
+    } else if (rc == GNUTLS_E_AGAIN) {
+        int direction = gnutls_record_get_direction (_tls_session);
+        if (direction == 1)
+            set_pollout ();
+
+        return false;
+    } else if (rc == GNUTLS_E_INTERRUPTED
+               || rc == GNUTLS_E_WARNING_ALERT_RECEIVED) {
+        return false;
+    } else {
+        error (zmq::i_engine::connection_error);
+        return false;
+    }
+
+    return true;
+}
+
+bool zmq::wss_engine_t::handshake ()
+{
+    if (!_established) {
+        if (!do_handshake ()) {
+            return false;
+        }
+    }
+
+    return ws_engine_t::handshake ();
+}
+
+int zmq::wss_engine_t::read (void *data_, size_t size_)
+{
+    ssize_t rc = gnutls_record_recv (_tls_session, data_, size_);
+
+    if (rc == GNUTLS_E_REHANDSHAKE) {
+        gnutls_alert_send (_tls_session, GNUTLS_AL_WARNING,
+                           GNUTLS_A_NO_RENEGOTIATION);
+        return 0;
+    }
+
+    if (rc == GNUTLS_E_INTERRUPTED) {
+        errno = EINTR;
+        return -1;
+    }
+
+    if (rc == GNUTLS_E_AGAIN) {
+        errno = EAGAIN;
+        return -1;
+    }
+
+    if (rc < 0) {
+        errno = EINVAL;
+        return -1;
+    }
+
+    // TODO: change return type to ssize_t (signed)
+    return rc;
+}
+
+int zmq::wss_engine_t::write (const void *data_, size_t size_)
+{
+    ssize_t rc = gnutls_record_send (_tls_session, data_, size_);
+
+    if (rc == GNUTLS_E_INTERRUPTED) {
+        errno = EINTR;
+        return -1;
+    }
+
+    if (rc == GNUTLS_E_AGAIN) {
+        errno = EAGAIN;
+        return -1;
+    }
+
+    if (rc < 0) {
+        errno = EINVAL;
+        return -1;
+    }
+
+    // TODO: change return type to ssize_t (signed)
+    return rc;
+}
diff -pruN 4.3.2-2/src/wss_engine.hpp 4.3.3-1/src/wss_engine.hpp
--- 4.3.2-2/src/wss_engine.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/wss_engine.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,69 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_WSS_ENGINE_HPP_INCLUDED__
+#define __ZMQ_WSS_ENGINE_HPP_INCLUDED__
+
+#include <gnutls/gnutls.h>
+#include "ws_engine.hpp"
+
+#define WSS_BUFFER_SIZE 8192
+
+namespace zmq
+{
+class wss_engine_t : public ws_engine_t
+{
+  public:
+    wss_engine_t (fd_t fd_,
+                  const options_t &options_,
+                  const endpoint_uri_pair_t &endpoint_uri_pair_,
+                  ws_address_t &address_,
+                  bool client_,
+                  void *tls_server_cred_,
+                  const std::string &hostname_);
+    ~wss_engine_t ();
+
+    void out_event ();
+
+  protected:
+    bool handshake ();
+    void plug_internal ();
+    int read (void *data, size_t size_);
+    int write (const void *data_, size_t size_);
+
+  private:
+    bool do_handshake ();
+
+    bool _established;
+    gnutls_certificate_credentials_t _tls_client_cred;
+    gnutls_session_t _tls_session;
+};
+}
+
+#endif
diff -pruN 4.3.2-2/src/xpub.cpp 4.3.3-1/src/xpub.cpp
--- 4.3.2-2/src/xpub.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/xpub.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,10 @@ zmq::xpub_t::xpub_t (class ctx_t *parent
     socket_base_t (parent_, tid_, sid_),
     _verbose_subs (false),
     _verbose_unsubs (false),
-    _more (false),
+    _more_send (false),
+    _more_recv (false),
+    _process_subscribe (false),
+    _only_first_subscribe (false),
     _lossy (true),
     _manual (false),
     _send_last_pipe (false),
@@ -56,6 +59,11 @@ zmq::xpub_t::xpub_t (class ctx_t *parent
 zmq::xpub_t::~xpub_t ()
 {
     _welcome_msg.close ();
+    for (std::deque<metadata_t *>::iterator it = _pending_metadata.begin (),
+                                            end = _pending_metadata.end ();
+         it != end; ++it)
+        if (*it && (*it)->drop_ref ())
+            LIBZMQ_DELETE (*it);
 }
 
 void zmq::xpub_t::xattach_pipe (pipe_t *pipe_,
@@ -76,9 +84,9 @@ void zmq::xpub_t::xattach_pipe (pipe_t *
     if (_welcome_msg.size () > 0) {
         msg_t copy;
         copy.init ();
-        int rc = copy.copy (_welcome_msg);
+        const int rc = copy.copy (_welcome_msg);
         errno_assert (rc == 0);
-        bool ok = pipe_->write (&copy);
+        const bool ok = pipe_->write (&copy);
         zmq_assert (ok);
         pipe_->flush ();
     }
@@ -91,93 +99,100 @@ void zmq::xpub_t::xattach_pipe (pipe_t *
 void zmq::xpub_t::xread_activated (pipe_t *pipe_)
 {
     //  There are some subscriptions waiting. Let's process them.
-    msg_t sub;
-    while (pipe_->read (&sub)) {
-        metadata_t *metadata = sub.metadata ();
-        unsigned char *msg_data = static_cast<unsigned char *> (sub.data ()),
+    msg_t msg;
+    while (pipe_->read (&msg)) {
+        metadata_t *metadata = msg.metadata ();
+        unsigned char *msg_data = static_cast<unsigned char *> (msg.data ()),
                       *data = NULL;
         size_t size = 0;
         bool subscribe = false;
+        bool is_subscribe_or_cancel = false;
+        bool notify = false;
 
-        //  Apply the subscription to the trie
-        if (sub.is_subscribe () || sub.is_cancel ()) {
-            data = static_cast<unsigned char *> (sub.command_body ());
-            size = sub.command_body_size ();
-            subscribe = sub.is_subscribe ();
-        } else if (sub.size () > 0) {
-            unsigned char first = *msg_data;
-            if (first == 0 || first == 1) {
+        const bool first_part = !_more_recv;
+        _more_recv = (msg.flags () & msg_t::more) != 0;
+
+        if (first_part || _process_subscribe) {
+            //  Apply the subscription to the trie
+            if (msg.is_subscribe () || msg.is_cancel ()) {
+                data = static_cast<unsigned char *> (msg.command_body ());
+                size = msg.command_body_size ();
+                subscribe = msg.is_subscribe ();
+                is_subscribe_or_cancel = true;
+            } else if (msg.size () > 0 && (*msg_data == 0 || *msg_data == 1)) {
                 data = msg_data + 1;
-                size = sub.size () - 1;
-                subscribe = first == 1;
+                size = msg.size () - 1;
+                subscribe = *msg_data == 1;
+                is_subscribe_or_cancel = true;
             }
-        } else {
-            //  Process user message coming upstream from xsub socket
-            _pending_data.push_back (blob_t (msg_data, sub.size ()));
-            if (metadata)
-                metadata->add_ref ();
-            _pending_metadata.push_back (metadata);
-            _pending_flags.push_back (sub.flags ());
-            sub.close ();
-            continue;
         }
 
-        if (_manual) {
-            // Store manual subscription to use on termination
-            if (!subscribe)
-                _manual_subscriptions.rm (data, size, pipe_);
-            else
-                _manual_subscriptions.add (data, size, pipe_);
-
-            _pending_pipes.push_back (pipe_);
-
-            //  ZMTP 3.1 hack: we need to support sub/cancel commands, but
-            //  we can't give them back to userspace as it would be an API
-            //  breakage since the payload of the message is completely
-            //  different. Manually craft an old-style message instead.
-            data = data - 1;
-            size = size + 1;
-            if (subscribe)
-                *data = 1;
-            else
-                *data = 0;
+        if (first_part)
+            _process_subscribe =
+              !_only_first_subscribe || is_subscribe_or_cancel;
+
+        if (is_subscribe_or_cancel) {
+            if (_manual) {
+                // Store manual subscription to use on termination
+                if (!subscribe)
+                    _manual_subscriptions.rm (data, size, pipe_);
+                else
+                    _manual_subscriptions.add (data, size, pipe_);
 
-            _pending_data.push_back (blob_t (data, size));
-            if (metadata)
-                metadata->add_ref ();
-            _pending_metadata.push_back (metadata);
-            _pending_flags.push_back (0);
-        } else {
-            bool notify;
-            if (!subscribe) {
-                mtrie_t::rm_result rm_result =
-                  _subscriptions.rm (data, size, pipe_);
-                //  TODO reconsider what to do if rm_result == mtrie_t::not_found
-                notify = rm_result != mtrie_t::values_remain || _verbose_unsubs;
+                _pending_pipes.push_back (pipe_);
             } else {
-                bool first_added = _subscriptions.add (data, size, pipe_);
-                notify = first_added || _verbose_subs;
+                if (!subscribe) {
+                    const mtrie_t::rm_result rm_result =
+                      _subscriptions.rm (data, size, pipe_);
+                    //  TODO reconsider what to do if rm_result == mtrie_t::not_found
+                    notify =
+                      rm_result != mtrie_t::values_remain || _verbose_unsubs;
+                } else {
+                    const bool first_added =
+                      _subscriptions.add (data, size, pipe_);
+                    notify = first_added || _verbose_subs;
+                }
             }
 
             //  If the request was a new subscription, or the subscription
-            //  was removed, or verbose mode is enabled, store it so that
-            //  it can be passed to the user on next recv call.
-            if (options.type == ZMQ_XPUB && notify) {
-                data = data - 1;
-                size = size + 1;
+            //  was removed, or verbose mode or manual mode are enabled, store it
+            //  so that it can be passed to the user on next recv call.
+            if (_manual || (options.type == ZMQ_XPUB && notify)) {
+                //  ZMTP 3.1 hack: we need to support sub/cancel commands, but
+                //  we can't give them back to userspace as it would be an API
+                //  breakage since the payload of the message is completely
+                //  different. Manually craft an old-style message instead.
+                //  Although with other transports it would be possible to simply
+                //  reuse the same buffer and prefix a 0/1 byte to the topic, with
+                //  inproc the subscribe/cancel command string is not present in
+                //  the message, so this optimization is not possible.
+                //  The pushback makes a copy of the data array anyway, so the
+                //  number of buffer copies does not change.
+                blob_t notification (size + 1);
                 if (subscribe)
-                    *data = 1;
+                    *notification.data () = 1;
                 else
-                    *data = 0;
+                    *notification.data () = 0;
+                memcpy (notification.data () + 1, data, size);
 
-                _pending_data.push_back (blob_t (data, size));
+                _pending_data.push_back (ZMQ_MOVE (notification));
                 if (metadata)
                     metadata->add_ref ();
                 _pending_metadata.push_back (metadata);
                 _pending_flags.push_back (0);
             }
+        } else if (options.type != ZMQ_PUB) {
+            //  Process user message coming upstream from xsub socket,
+            //  but not if the type is PUB, which never processes user
+            //  messages
+            _pending_data.push_back (blob_t (msg_data, msg.size ()));
+            if (metadata)
+                metadata->add_ref ();
+            _pending_metadata.push_back (metadata);
+            _pending_flags.push_back (msg.flags ());
         }
-        sub.close ();
+
+        msg.close ();
     }
 }
 
@@ -192,7 +207,7 @@ int zmq::xpub_t::xsetsockopt (int option
 {
     if (option_ == ZMQ_XPUB_VERBOSE || option_ == ZMQ_XPUB_VERBOSER
         || option_ == ZMQ_XPUB_MANUAL_LAST_VALUE || option_ == ZMQ_XPUB_NODROP
-        || option_ == ZMQ_XPUB_MANUAL) {
+        || option_ == ZMQ_XPUB_MANUAL || option_ == ZMQ_ONLY_FIRST_SUBSCRIBE) {
         if (optvallen_ != sizeof (int)
             || *static_cast<const int *> (optval_) < 0) {
             errno = EINVAL;
@@ -211,6 +226,8 @@ int zmq::xpub_t::xsetsockopt (int option
             _lossy = (*static_cast<const int *> (optval_) == 0);
         else if (option_ == ZMQ_XPUB_MANUAL)
             _manual = (*static_cast<const int *> (optval_) != 0);
+        else if (option_ == ZMQ_ONLY_FIRST_SUBSCRIBE)
+            _only_first_subscribe = (*static_cast<const int *> (optval_) != 0);
     } else if (option_ == ZMQ_SUBSCRIBE && _manual) {
         if (_last_pipe != NULL)
             _subscriptions.add ((unsigned char *) optval_, optvallen_,
@@ -223,7 +240,7 @@ int zmq::xpub_t::xsetsockopt (int option
         _welcome_msg.close ();
 
         if (optvallen_ > 0) {
-            int rc = _welcome_msg.init_size (optvallen_);
+            const int rc = _welcome_msg.init_size (optvallen_);
             errno_assert (rc == 0);
 
             unsigned char *data =
@@ -254,7 +271,7 @@ void zmq::xpub_t::xpipe_terminated (pipe
         //  Remove pipe without actually sending the message as it was taken
         //  care of by the manual call above. subscriptions is the real mtrie,
         //  so the pipe must be removed from there or it will be left over.
-        _subscriptions.rm (pipe_, stub, (void *) NULL, false);
+        _subscriptions.rm (pipe_, stub, static_cast<void *> (NULL), false);
     } else {
         //  Remove the pipe from the trie. If there are topics that nobody
         //  is interested in anymore, send corresponding unsubscriptions
@@ -278,10 +295,13 @@ void zmq::xpub_t::mark_last_pipe_as_matc
 
 int zmq::xpub_t::xsend (msg_t *msg_)
 {
-    bool msg_more = (msg_->flags () & msg_t::more) != 0;
+    const bool msg_more = (msg_->flags () & msg_t::more) != 0;
 
     //  For the first part of multi-part message, find the matching pipes.
-    if (!_more) {
+    if (!_more_send) {
+        // Ensure nothing from previous failed attempt to send is left matched
+        _dist.unmatch ();
+
         if (unlikely (_manual && _last_pipe && _send_last_pipe)) {
             _subscriptions.match (static_cast<unsigned char *> (msg_->data ()),
                                   msg_->size (), mark_last_pipe_as_matching,
@@ -303,7 +323,7 @@ int zmq::xpub_t::xsend (msg_t *msg_)
             //  all the pipes as non-matching.
             if (!msg_more)
                 _dist.unmatch ();
-            _more = msg_more;
+            _more_send = msg_more;
             rc = 0; //  Yay, sent successfully
         }
     } else
diff -pruN 4.3.2-2/src/xpub.hpp 4.3.3-1/src/xpub.hpp
--- 4.3.2-2/src/xpub.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/xpub.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -48,20 +48,21 @@ class xpub_t : public socket_base_t
 {
   public:
     xpub_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
-    ~xpub_t ();
+    ~xpub_t () ZMQ_OVERRIDE;
 
     //  Implementations of virtual functions from socket_base_t.
     void xattach_pipe (zmq::pipe_t *pipe_,
                        bool subscribe_to_all_ = false,
-                       bool locally_initiated_ = false);
-    int xsend (zmq::msg_t *msg_);
-    bool xhas_out ();
-    int xrecv (zmq::msg_t *msg_);
-    bool xhas_in ();
-    void xread_activated (zmq::pipe_t *pipe_);
-    void xwrite_activated (zmq::pipe_t *pipe_);
-    int xsetsockopt (int option_, const void *optval_, size_t optvallen_);
-    void xpipe_terminated (zmq::pipe_t *pipe_);
+                       bool locally_initiated_ = false) ZMQ_OVERRIDE;
+    int xsend (zmq::msg_t *msg_) ZMQ_FINAL;
+    bool xhas_out () ZMQ_FINAL;
+    int xrecv (zmq::msg_t *msg_) ZMQ_OVERRIDE;
+    bool xhas_in () ZMQ_OVERRIDE;
+    void xread_activated (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    void xwrite_activated (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    int
+    xsetsockopt (int option_, const void *optval_, size_t optvallen_) ZMQ_FINAL;
+    void xpipe_terminated (zmq::pipe_t *pipe_) ZMQ_FINAL;
 
   private:
     //  Function to be applied to the trie to send all the subscriptions
@@ -71,7 +72,7 @@ class xpub_t : public socket_base_t
                                      xpub_t *self_);
 
     //  Function to be applied to each matching pipes.
-    static void mark_as_matching (zmq::pipe_t *pipe_, xpub_t *arg_);
+    static void mark_as_matching (zmq::pipe_t *pipe_, xpub_t *self_);
 
     //  List of all subscriptions mapped to corresponding pipes.
     mtrie_t _subscriptions;
@@ -91,7 +92,19 @@ class xpub_t : public socket_base_t
     bool _verbose_unsubs;
 
     //  True if we are in the middle of sending a multi-part message.
-    bool _more;
+    bool _more_send;
+
+    //  True if we are in the middle of receiving a multi-part message.
+    bool _more_recv;
+
+    //  If true, subscribe and cancel messages are processed for the rest
+    //  of multipart message.
+    bool _process_subscribe;
+
+    //  This option is enabled with ZMQ_ONLY_FIRST_SUBSCRIBE.
+    //  If true, messages following subscribe/unsubscribe in a multipart
+    //  message are treated as user data regardless of the first byte.
+    bool _only_first_subscribe;
 
     //  Drop messages if HWM reached, otherwise return with EAGAIN
     bool _lossy;
@@ -103,7 +116,7 @@ class xpub_t : public socket_base_t
     bool _send_last_pipe;
 
     //  Function to be applied to match the last pipe.
-    static void mark_last_pipe_as_matching (zmq::pipe_t *pipe_, xpub_t *arg_);
+    static void mark_last_pipe_as_matching (zmq::pipe_t *pipe_, xpub_t *self_);
 
     //  Last pipe that sent subscription message, only used if xpub is on manual
     pipe_t *_last_pipe;
@@ -120,8 +133,7 @@ class xpub_t : public socket_base_t
     std::deque<metadata_t *> _pending_metadata;
     std::deque<unsigned char> _pending_flags;
 
-    xpub_t (const xpub_t &);
-    const xpub_t &operator= (const xpub_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (xpub_t)
 };
 }
 
diff -pruN 4.3.2-2/src/xsub.cpp 4.3.3-1/src/xsub.cpp
--- 4.3.2-2/src/xsub.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/xsub.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -37,7 +37,10 @@
 zmq::xsub_t::xsub_t (class ctx_t *parent_, uint32_t tid_, int sid_) :
     socket_base_t (parent_, tid_, sid_),
     _has_message (false),
-    _more (false)
+    _more_send (false),
+    _more_recv (false),
+    _process_subscribe (false),
+    _only_first_subscribe (false)
 {
     options.type = ZMQ_XSUB;
 
@@ -45,13 +48,13 @@ zmq::xsub_t::xsub_t (class ctx_t *parent
     //  subscription commands are sent to the wire.
     options.linger.store (0);
 
-    int rc = _message.init ();
+    const int rc = _message.init ();
     errno_assert (rc == 0);
 }
 
 zmq::xsub_t::~xsub_t ()
 {
-    int rc = _message.close ();
+    const int rc = _message.close ();
     errno_assert (rc == 0);
 }
 
@@ -94,36 +97,59 @@ void zmq::xsub_t::xhiccuped (pipe_t *pip
     pipe_->flush ();
 }
 
+int zmq::xsub_t::xsetsockopt (int option_,
+                              const void *optval_,
+                              size_t optvallen_)
+{
+    if (option_ == ZMQ_ONLY_FIRST_SUBSCRIBE) {
+        if (optvallen_ != sizeof (int)
+            || *static_cast<const int *> (optval_) < 0) {
+            errno = EINVAL;
+            return -1;
+        }
+        _only_first_subscribe = (*static_cast<const int *> (optval_) != 0);
+        return 0;
+    }
+    errno = EINVAL;
+    return -1;
+}
+
 int zmq::xsub_t::xsend (msg_t *msg_)
 {
     size_t size = msg_->size ();
     unsigned char *data = static_cast<unsigned char *> (msg_->data ());
 
+    const bool first_part = !_more_send;
+    _more_send = (msg_->flags () & msg_t::more) != 0;
+
+    if (first_part) {
+        _process_subscribe = !_only_first_subscribe;
+    } else if (!_process_subscribe) {
+        //  User message sent upstream to XPUB socket
+        return _dist.send_to_all (msg_);
+    }
+
     if (msg_->is_subscribe () || (size > 0 && *data == 1)) {
         //  Process subscribe message
         //  This used to filter out duplicate subscriptions,
         //  however this is alread done on the XPUB side and
         //  doing it here as well breaks ZMQ_XPUB_VERBOSE
         //  when there are forwarding devices involved.
-        if (msg_->is_subscribe ()) {
-            data = static_cast<unsigned char *> (msg_->command_body ());
-            size = msg_->command_body_size ();
-        } else {
+        if (!msg_->is_subscribe ()) {
             data = data + 1;
             size = size - 1;
         }
         _subscriptions.add (data, size);
+        _process_subscribe = true;
         return _dist.send_to_all (msg_);
     }
     if (msg_->is_cancel () || (size > 0 && *data == 0)) {
         //  Process unsubscribe message
-        if (msg_->is_cancel ()) {
-            data = static_cast<unsigned char *> (msg_->command_body ());
-            size = msg_->command_body_size ();
-        } else {
+        if (!msg_->is_cancel ()) {
             data = data + 1;
             size = size - 1;
         }
+        _process_subscribe = true;
         if (_subscriptions.rm (data, size))
             return _dist.send_to_all (msg_);
     } else
@@ -149,10 +175,10 @@ int zmq::xsub_t::xrecv (msg_t *msg_)
     //  If there's already a message prepared by a previous call to zmq_poll,
     //  return it straight ahead.
     if (_has_message) {
-        int rc = msg_->move (_message);
+        const int rc = msg_->move (_message);
         errno_assert (rc == 0);
         _has_message = false;
-        _more = (msg_->flags () & msg_t::more) != 0;
+        _more_recv = (msg_->flags () & msg_t::more) != 0;
         return 0;
     }
 
@@ -170,8 +196,8 @@ int zmq::xsub_t::xrecv (msg_t *msg_)
 
         //  Check whether the message matches at least one subscription.
         //  Non-initial parts of the message are passed
-        if (_more || !options.filter || match (msg_)) {
-            _more = (msg_->flags () & msg_t::more) != 0;
+        if (_more_recv || !options.filter || match (msg_)) {
+            _more_recv = (msg_->flags () & msg_t::more) != 0;
             return 0;
         }
 
@@ -187,7 +213,7 @@ int zmq::xsub_t::xrecv (msg_t *msg_)
 bool zmq::xsub_t::xhas_in ()
 {
     //  There are subsequent parts of the partly-read message available.
-    if (_more)
+    if (_more_recv)
         return true;
 
     //  If there's already a message prepared by a previous call to zmq_poll,
@@ -225,7 +251,7 @@ bool zmq::xsub_t::xhas_in ()
 
 bool zmq::xsub_t::match (msg_t *msg_)
 {
-    bool matching = _subscriptions.check (
+    const bool matching = _subscriptions.check (
       static_cast<unsigned char *> (msg_->data ()), msg_->size ());
 
     return matching ^ options.invert_matching;
@@ -239,19 +265,11 @@ void zmq::xsub_t::send_subscription (uns
 
     //  Create the subscription message.
     msg_t msg;
-    int rc = msg.init_size (size_ + 1);
+    const int rc = msg.init_subscribe (size_, data_);
     errno_assert (rc == 0);
-    unsigned char *data = static_cast<unsigned char *> (msg.data ());
-    data[0] = 1;
-
-    //  We explicitly allow a NULL subscription with size zero
-    if (size_) {
-        assert (data_);
-        memcpy (data + 1, data_, size_);
-    }
 
     //  Send it to the pipe.
-    bool sent = pipe->write (&msg);
+    const bool sent = pipe->write (&msg);
     //  If we reached the SNDHWM, and thus cannot send the subscription, drop
     //  the subscription message instead. This matches the behaviour of
     //  zmq_setsockopt(ZMQ_SUBSCRIBE, ...), which also drops subscriptions
diff -pruN 4.3.2-2/src/xsub.hpp 4.3.3-1/src/xsub.hpp
--- 4.3.2-2/src/xsub.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/xsub.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -50,21 +50,24 @@ class xsub_t : public socket_base_t
 {
   public:
     xsub_t (zmq::ctx_t *parent_, uint32_t tid_, int sid_);
-    ~xsub_t ();
+    ~xsub_t () ZMQ_OVERRIDE;
 
   protected:
     //  Overrides of functions from socket_base_t.
     void xattach_pipe (zmq::pipe_t *pipe_,
                        bool subscribe_to_all_,
-                       bool locally_initiated_);
-    int xsend (zmq::msg_t *msg_);
-    bool xhas_out ();
-    int xrecv (zmq::msg_t *msg_);
-    bool xhas_in ();
-    void xread_activated (zmq::pipe_t *pipe_);
-    void xwrite_activated (zmq::pipe_t *pipe_);
-    void xhiccuped (pipe_t *pipe_);
-    void xpipe_terminated (zmq::pipe_t *pipe_);
+                       bool locally_initiated_) ZMQ_FINAL;
+    int xsetsockopt (int option_,
+                     const void *optval_,
+                     size_t optvallen_) ZMQ_OVERRIDE;
+    int xsend (zmq::msg_t *msg_) ZMQ_OVERRIDE;
+    bool xhas_out () ZMQ_OVERRIDE;
+    int xrecv (zmq::msg_t *msg_) ZMQ_FINAL;
+    bool xhas_in () ZMQ_FINAL;
+    void xread_activated (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    void xwrite_activated (zmq::pipe_t *pipe_) ZMQ_FINAL;
+    void xhiccuped (pipe_t *pipe_) ZMQ_FINAL;
+    void xpipe_terminated (zmq::pipe_t *pipe_) ZMQ_FINAL;
 
   private:
     //  Check whether the message matches at least one subscription.
@@ -93,12 +96,24 @@ class xsub_t : public socket_base_t
     bool _has_message;
     msg_t _message;
 
+    //  If true, part of a multipart message was already sent, but
+    //  there are following parts still waiting.
+    bool _more_send;
+
     //  If true, part of a multipart message was already received, but
     //  there are following parts still waiting.
-    bool _more;
+    bool _more_recv;
+
+    //  If true, subscribe and cancel messages are processed for the rest
+    //  of multipart message.
+    bool _process_subscribe;
+
+    //  This option is enabled with ZMQ_ONLY_FIRST_SUBSCRIBE.
+    //  If true, messages following subscribe/unsubscribe in a multipart
+    //  message are treated as user data regardless of the first byte.
+    bool _only_first_subscribe;
 
-    xsub_t (const xsub_t &);
-    const xsub_t &operator= (const xsub_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (xsub_t)
 };
 }
 
diff -pruN 4.3.2-2/src/ypipe_base.hpp 4.3.3-1/src/ypipe_base.hpp
--- 4.3.2-2/src/ypipe_base.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ypipe_base.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -31,6 +31,7 @@
 #ifndef __ZMQ_YPIPE_BASE_HPP_INCLUDED__
 #define __ZMQ_YPIPE_BASE_HPP_INCLUDED__
 
+#include "macros.hpp"
 
 namespace zmq
 {
@@ -41,7 +42,7 @@ namespace zmq
 template <typename T> class ypipe_base_t
 {
   public:
-    virtual ~ypipe_base_t () {}
+    virtual ~ypipe_base_t () ZMQ_DEFAULT;
     virtual void write (const T &value_, bool incomplete_) = 0;
     virtual bool unwrite (T *value_) = 0;
     virtual bool flush () = 0;
diff -pruN 4.3.2-2/src/ypipe_conflate.hpp 4.3.3-1/src/ypipe_conflate.hpp
--- 4.3.2-2/src/ypipe_conflate.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ypipe_conflate.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -43,15 +43,11 @@ namespace zmq
 //  reader_awake flag is needed here to mimic ypipe delicate behaviour
 //  around the reader being asleep (see 'c' pointer being NULL in ypipe.hpp)
 
-template <typename T> class ypipe_conflate_t : public ypipe_base_t<T>
+template <typename T> class ypipe_conflate_t ZMQ_FINAL : public ypipe_base_t<T>
 {
   public:
     //  Initialises the pipe.
-    inline ypipe_conflate_t () : reader_awake (false) {}
-
-    //  The destructor doesn't have to be virtual. It is made virtual
-    //  just to keep ICC and code checking tools from complaining.
-    inline virtual ~ypipe_conflate_t () {}
+    ypipe_conflate_t () : reader_awake (false) {}
 
     //  Following function (write) deliberately copies uninitialised data
     //  when used with zmq_msg. Initialising the VSM body for
@@ -61,7 +57,7 @@ template <typename T> class ypipe_confla
 #pragma message save
 #pragma message disable(UNINIT)
 #endif
-    inline void write (const T &value_, bool incomplete_)
+    void write (const T &value_, bool incomplete_)
     {
         (void) incomplete_;
 
@@ -73,18 +69,18 @@ template <typename T> class ypipe_confla
 #endif
 
     // There are no incomplete items for conflate ypipe
-    inline bool unwrite (T *) { return false; }
+    bool unwrite (T *) { return false; }
 
     //  Flush is no-op for conflate ypipe. Reader asleep behaviour
     //  is as of the usual ypipe.
     //  Returns false if the reader thread is sleeping. In that case,
     //  caller is obliged to wake the reader up before using the pipe again.
-    inline bool flush () { return reader_awake; }
+    bool flush () { return reader_awake; }
 
     //  Check whether item is available for reading.
-    inline bool check_read ()
+    bool check_read ()
     {
-        bool res = dbuffer.check_read ();
+        const bool res = dbuffer.check_read ();
         if (!res)
             reader_awake = false;
 
@@ -93,7 +89,7 @@ template <typename T> class ypipe_confla
 
     //  Reads an item from the pipe. Returns false if there is no value.
     //  available.
-    inline bool read (T *value_)
+    bool read (T *value_)
     {
         if (!check_read ())
             return false;
@@ -104,15 +100,13 @@ template <typename T> class ypipe_confla
     //  Applies the function fn to the first elemenent in the pipe
     //  and returns the value returned by the fn.
     //  The pipe mustn't be empty or the function crashes.
-    inline bool probe (bool (*fn_) (const T &)) { return dbuffer.probe (fn_); }
+    bool probe (bool (*fn_) (const T &)) { return dbuffer.probe (fn_); }
 
   protected:
     dbuffer_t<T> dbuffer;
     bool reader_awake;
 
-    //  Disable copying of ypipe object.
-    ypipe_conflate_t (const ypipe_conflate_t &);
-    const ypipe_conflate_t &operator= (const ypipe_conflate_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (ypipe_conflate_t)
 };
 }
 
diff -pruN 4.3.2-2/src/ypipe.hpp 4.3.3-1/src/ypipe.hpp
--- 4.3.2-2/src/ypipe.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/ypipe.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -43,11 +43,11 @@ namespace zmq
 //  N is granularity of the pipe, i.e. how many items are needed to
 //  perform next memory allocation.
 
-template <typename T, int N> class ypipe_t : public ypipe_base_t<T>
+template <typename T, int N> class ypipe_t ZMQ_FINAL : public ypipe_base_t<T>
 {
   public:
     //  Initialises the pipe.
-    inline ypipe_t ()
+    ypipe_t ()
     {
         //  Insert terminator element into the queue.
         _queue.push ();
@@ -58,10 +58,6 @@ template <typename T, int N> class ypipe
         _c.set (&_queue.back ());
     }
 
-    //  The destructor doesn't have to be virtual. It is made virtual
-    //  just to keep ICC and code checking tools from complaining.
-    inline virtual ~ypipe_t () {}
-
     //  Following function (write) deliberately copies uninitialised data
     //  when used with zmq_msg. Initialising the VSM body for
     //  non-VSM messages won't be good for performance.
@@ -75,7 +71,7 @@ template <typename T, int N> class ypipe
     //  set to true the item is assumed to be continued by items
     //  subsequently written to the pipe. Incomplete items are never
     //  flushed down the stream.
-    inline void write (const T &value_, bool incomplete_)
+    void write (const T &value_, bool incomplete_)
     {
         //  Place the value to the queue, add new terminator element.
         _queue.back () = value_;
@@ -92,7 +88,7 @@ template <typename T, int N> class ypipe
 
     //  Pop an incomplete item from the pipe. Returns true if such
     //  item exists, false otherwise.
-    inline bool unwrite (T *value_)
+    bool unwrite (T *value_)
     {
         if (_f == &_queue.back ())
             return false;
@@ -104,7 +100,7 @@ template <typename T, int N> class ypipe
     //  Flush all the completed items into the pipe. Returns false if
     //  the reader thread is sleeping. In that case, caller is obliged to
     //  wake the reader up before using the pipe again.
-    inline bool flush ()
+    bool flush ()
     {
         //  If there are no un-flushed items, do nothing.
         if (_w == _f)
@@ -129,7 +125,7 @@ template <typename T, int N> class ypipe
     }
 
     //  Check whether item is available for reading.
-    inline bool check_read ()
+    bool check_read ()
     {
         //  Was the value prefetched already? If so, return.
         if (&_queue.front () != _r && _r)
@@ -154,7 +150,7 @@ template <typename T, int N> class ypipe
 
     //  Reads an item from the pipe. Returns false if there is no value.
     //  available.
-    inline bool read (T *value_)
+    bool read (T *value_)
     {
         //  Try to prefetch a value.
         if (!check_read ())
@@ -170,9 +166,9 @@ template <typename T, int N> class ypipe
     //  Applies the function fn to the first elemenent in the pipe
     //  and returns the value returned by the fn.
     //  The pipe mustn't be empty or the function crashes.
-    inline bool probe (bool (*fn_) (const T &))
+    bool probe (bool (*fn_) (const T &))
     {
-        bool rc = check_read ();
+        const bool rc = check_read ();
         zmq_assert (rc);
 
         return (*fn_) (_queue.front ());
@@ -202,9 +198,7 @@ template <typename T, int N> class ypipe
     //  atomic operations.
     atomic_ptr_t<T> _c;
 
-    //  Disable copying of ypipe object.
-    ypipe_t (const ypipe_t &);
-    const ypipe_t &operator= (const ypipe_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (ypipe_t)
 };
 }
 
diff -pruN 4.3.2-2/src/yqueue.hpp 4.3.3-1/src/yqueue.hpp
--- 4.3.2-2/src/yqueue.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/yqueue.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -179,7 +179,7 @@ template <typename T, int N> class yqueu
         chunk_t *next;
     };
 
-    inline chunk_t *allocate_chunk ()
+    static inline chunk_t *allocate_chunk ()
     {
 #ifdef HAVE_POSIX_MEMALIGN
         void *pv;
@@ -187,7 +187,7 @@ template <typename T, int N> class yqueu
             return (chunk_t *) pv;
         return NULL;
 #else
-        return (chunk_t *) malloc (sizeof (chunk_t));
+        return static_cast<chunk_t *> (malloc (sizeof (chunk_t)));
 #endif
     }
 
@@ -207,9 +207,7 @@ template <typename T, int N> class yqueu
     //  us from having to call malloc/free.
     atomic_ptr_t<chunk_t> _spare_chunk;
 
-    //  Disable copying of yqueue.
-    yqueue_t (const yqueue_t &);
-    const yqueue_t &operator= (const yqueue_t &);
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (yqueue_t)
 };
 }
 
diff -pruN 4.3.2-2/src/zap_client.cpp 4.3.3-1/src/zap_client.cpp
--- 4.3.2-2/src/zap_client.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/zap_client.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -274,8 +274,8 @@ zmq::mechanism_t::status_t zap_client_co
         return mechanism_t::ready;
     if (state == error_sent)
         return mechanism_t::error;
-    else
-        return mechanism_t::handshaking;
+
+    return mechanism_t::handshaking;
 }
 
 int zap_client_common_handshake_t::zap_msg_available ()
diff -pruN 4.3.2-2/src/zap_client.hpp 4.3.3-1/src/zap_client.hpp
--- 4.3.2-2/src/zap_client.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/zap_client.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -37,7 +37,7 @@ namespace zmq
 class zap_client_t : public virtual mechanism_base_t
 {
   public:
-    zap_client_t (session_base_t *const session_,
+    zap_client_t (session_base_t *session_,
                   const std::string &peer_address_,
                   const options_t &options_);
 
@@ -77,18 +77,18 @@ class zap_client_common_handshake_t : pu
         ready
     };
 
-    zap_client_common_handshake_t (session_base_t *const session_,
+    zap_client_common_handshake_t (session_base_t *session_,
                                    const std::string &peer_address_,
                                    const options_t &options_,
                                    state_t zap_reply_ok_state_);
 
     //  methods from mechanism_t
-    status_t status () const;
-    int zap_msg_available ();
+    status_t status () const ZMQ_FINAL;
+    int zap_msg_available () ZMQ_FINAL;
 
     //  zap_client_t methods
-    int receive_and_process_zap_reply ();
-    void handle_zap_status_code ();
+    int receive_and_process_zap_reply () ZMQ_FINAL;
+    void handle_zap_status_code () ZMQ_FINAL;
 
     //  Current FSM state
     state_t state;
diff -pruN 4.3.2-2/src/zmq.cpp 4.3.3-1/src/zmq.cpp
--- 4.3.2-2/src/zmq.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/zmq.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -40,6 +40,7 @@
 
 #include "macros.hpp"
 #include "poller.hpp"
+#include "peer.hpp"
 
 #if !defined ZMQ_HAVE_POLLER
 //  On AIX platform, poll.h has to be included first to get consistent
@@ -153,8 +154,8 @@ int zmq_ctx_term (void *ctx_)
         return -1;
     }
 
-    int rc = (static_cast<zmq::ctx_t *> (ctx_))->terminate ();
-    int en = errno;
+    const int rc = (static_cast<zmq::ctx_t *> (ctx_))->terminate ();
+    const int en = errno;
 
     //  Shut down only if termination was not interrupted by a signal.
     if (!rc || en != EINTR) {
@@ -176,22 +177,45 @@ int zmq_ctx_shutdown (void *ctx_)
 
 int zmq_ctx_set (void *ctx_, int option_, int optval_)
 {
+    return zmq_ctx_set_ext (ctx_, option_, &optval_, sizeof (int));
+}
+
+int zmq_ctx_set_ext (void *ctx_,
+                     int option_,
+                     const void *optval_,
+                     size_t optvallen_)
+{
     if (!ctx_ || !(static_cast<zmq::ctx_t *> (ctx_))->check_tag ()) {
         errno = EFAULT;
         return -1;
     }
-    return (static_cast<zmq::ctx_t *> (ctx_))->set (option_, optval_);
+    return (static_cast<zmq::ctx_t *> (ctx_))
+      ->set (option_, optval_, optvallen_);
 }
 
 int zmq_ctx_get (void *ctx_, int option_)
 {
+    int optval = 0;
+    size_t optvallen = sizeof (int);
+    if (zmq_ctx_get_ext (ctx_, option_, &optval, &optvallen) == 0) {
+        return optval;
+    }
+
+    errno = EFAULT;
+    return -1;
+}
+
+int zmq_ctx_get_ext (void *ctx_, int option_, void *optval_, size_t *optvallen_)
+{
     if (!ctx_ || !(static_cast<zmq::ctx_t *> (ctx_))->check_tag ()) {
         errno = EFAULT;
         return -1;
     }
-    return (static_cast<zmq::ctx_t *> (ctx_))->get (option_);
+    return (static_cast<zmq::ctx_t *> (ctx_))
+      ->get (option_, optval_, optvallen_);
 }
 
+
 //  Stable/legacy context API
 
 void *zmq_init (int io_threads_)
@@ -236,7 +260,7 @@ void *zmq_socket (void *ctx_, int type_)
     }
     zmq::ctx_t *ctx = static_cast<zmq::ctx_t *> (ctx_);
     zmq::socket_base_t *s = ctx->create_socket (type_);
-    return (void *) s;
+    return static_cast<void *> (s);
 }
 
 int zmq_close (void *s_)
@@ -313,6 +337,28 @@ int zmq_connect (void *s_, const char *a
     return s->connect (addr_);
 }
 
+uint32_t zmq_connect_peer (void *s_, const char *addr_)
+{
+    zmq::peer_t *s = static_cast<zmq::peer_t *> (s_);
+    if (!s_ || !s->check_tag ()) {
+        errno = ENOTSOCK;
+        return 0;
+    }
+
+    int socket_type;
+    size_t socket_type_size = sizeof (socket_type);
+    if (s->getsockopt (ZMQ_TYPE, &socket_type, &socket_type_size) != 0)
+        return 0;
+
+    if (socket_type != ZMQ_PEER) {
+        errno = ENOTSUP;
+        return 0;
+    }
+
+    return s->connect_peer (addr_);
+}
+
+
 int zmq_unbind (void *s_, const char *addr_)
 {
     zmq::socket_base_t *s = as_socket_base_t (s_);
@@ -335,7 +381,7 @@ static inline int
 s_sendmsg (zmq::socket_base_t *s_, zmq_msg_t *msg_, int flags_)
 {
     size_t sz = zmq_msg_size (msg_);
-    int rc = s_->send (reinterpret_cast<zmq::msg_t *> (msg_), flags_);
+    const int rc = s_->send (reinterpret_cast<zmq::msg_t *> (msg_), flags_);
     if (unlikely (rc < 0))
         return -1;
 
@@ -359,18 +405,14 @@ int zmq_send (void *s_, const void *buf_
     if (!s)
         return -1;
     zmq_msg_t msg;
-    if (zmq_msg_init_size (&msg, len_))
+    int rc = zmq_msg_init_buffer (&msg, buf_, len_);
+    if (unlikely (rc < 0))
         return -1;
 
-    //  We explicitly allow a send from NULL, size zero
-    if (len_) {
-        assert (buf_);
-        memcpy (zmq_msg_data (&msg), buf_, len_);
-    }
-    int rc = s_sendmsg (s, &msg, flags_);
+    rc = s_sendmsg (s, &msg, flags_);
     if (unlikely (rc < 0)) {
-        int err = errno;
-        int rc2 = zmq_msg_close (&msg);
+        const int err = errno;
+        const int rc2 = zmq_msg_close (&msg);
         errno_assert (rc2 == 0);
         errno = err;
         return -1;
@@ -393,8 +435,8 @@ int zmq_send_const (void *s_, const void
 
     rc = s_sendmsg (s, &msg, flags_);
     if (unlikely (rc < 0)) {
-        int err = errno;
-        int rc2 = zmq_msg_close (&msg);
+        const int err = errno;
+        const int rc2 = zmq_msg_close (&msg);
         errno_assert (rc2 == 0);
         errno = err;
         return -1;
@@ -436,8 +478,8 @@ int zmq_sendiov (void *s_, iovec *a_, si
             flags_ = flags_ & ~ZMQ_SNDMORE;
         rc = s_sendmsg (s, &msg, flags_);
         if (unlikely (rc < 0)) {
-            int err = errno;
-            int rc2 = zmq_msg_close (&msg);
+            const int err = errno;
+            const int rc2 = zmq_msg_close (&msg);
             errno_assert (rc2 == 0);
             errno = err;
             rc = -1;
@@ -451,12 +493,12 @@ int zmq_sendiov (void *s_, iovec *a_, si
 
 static int s_recvmsg (zmq::socket_base_t *s_, zmq_msg_t *msg_, int flags_)
 {
-    int rc = s_->recv (reinterpret_cast<zmq::msg_t *> (msg_), flags_);
+    const int rc = s_->recv (reinterpret_cast<zmq::msg_t *> (msg_), flags_);
     if (unlikely (rc < 0))
         return -1;
 
     //  Truncate returned size to INT_MAX to avoid overflow to negative values
-    size_t sz = zmq_msg_size (msg_);
+    const size_t sz = zmq_msg_size (msg_);
     return static_cast<int> (sz < INT_MAX ? sz : INT_MAX);
 }
 
@@ -476,9 +518,9 @@ int zmq_recv (void *s_, void *buf_, size
     int rc = zmq_msg_init (&msg);
     errno_assert (rc == 0);
 
-    int nbytes = s_recvmsg (s, &msg, flags_);
+    const int nbytes = s_recvmsg (s, &msg, flags_);
     if (unlikely (nbytes < 0)) {
-        int err = errno;
+        const int err = errno;
         rc = zmq_msg_close (&msg);
         errno_assert (rc == 0);
         errno = err;
@@ -486,7 +528,7 @@ int zmq_recv (void *s_, void *buf_, size
     }
 
     //  An oversized message is silently truncated.
-    size_t to_copy = size_t (nbytes) < len_ ? size_t (nbytes) : len_;
+    const size_t to_copy = size_t (nbytes) < len_ ? size_t (nbytes) : len_;
 
     //  We explicitly allow a null buffer argument if len is zero
     if (to_copy) {
@@ -525,7 +567,7 @@ int zmq_recviov (void *s_, iovec *a_, si
         return -1;
     }
 
-    size_t count = *count_;
+    const size_t count = *count_;
     int nread = 0;
     bool recvmore = true;
 
@@ -536,9 +578,9 @@ int zmq_recviov (void *s_, iovec *a_, si
         int rc = zmq_msg_init (&msg);
         errno_assert (rc == 0);
 
-        int nbytes = s_recvmsg (s, &msg, flags_);
+        const int nbytes = s_recvmsg (s, &msg, flags_);
         if (unlikely (nbytes < 0)) {
-            int err = errno;
+            const int err = errno;
             rc = zmq_msg_close (&msg);
             errno_assert (rc == 0);
             errno = err;
@@ -577,6 +619,11 @@ int zmq_msg_init_size (zmq_msg_t *msg_,
     return (reinterpret_cast<zmq::msg_t *> (msg_))->init_size (size_);
 }
 
+int zmq_msg_init_buffer (zmq_msg_t *msg_, const void *buf_, size_t size_)
+{
+    return (reinterpret_cast<zmq::msg_t *> (msg_))->init_buffer (buf_, size_);
+}
+
 int zmq_msg_init_data (
   zmq_msg_t *msg_, void *data_, size_t size_, zmq_free_fn *ffn_, void *hint_)
 {
@@ -703,7 +750,7 @@ const char *zmq_msg_gets (const zmq_msg_
 // Polling.
 
 #if defined ZMQ_HAVE_POLLER
-inline int zmq_poller_poll (zmq_pollitem_t *items_, int nitems_, long timeout_)
+static int zmq_poller_poll (zmq_pollitem_t *items_, int nitems_, long timeout_)
 {
     // implement zmq_poll on top of zmq_poller
     int rc;
@@ -808,9 +855,15 @@ int zmq_poll (zmq_pollitem_t *items_, in
     // if poller is present, use that if there is at least 1 thread-safe socket,
     // otherwise fall back to the previous implementation as it's faster.
     for (int i = 0; i != nitems_; i++) {
-        if (items_[i].socket
-            && as_socket_base_t (items_[i].socket)->is_thread_safe ()) {
-            return zmq_poller_poll (items_, nitems_, timeout_);
+        if (items_[i].socket) {
+            zmq::socket_base_t *s = as_socket_base_t (items_[i].socket);
+            if (s) {
+                if (s->is_thread_safe ())
+                    return zmq_poller_poll (items_, nitems_, timeout_);
+            } else {
+                //as_socket_base_t returned NULL : socket is invalid
+                return -1;
+            }
         }
     }
 #endif // ZMQ_HAVE_POLLER
@@ -926,12 +979,12 @@ int zmq_poll (zmq_pollitem_t *items_, in
 #if defined ZMQ_POLL_BASED_ON_POLL
 
         //  Compute the timeout for the subsequent poll.
-        zmq::timeout_t timeout =
+        const zmq::timeout_t timeout =
           zmq::compute_timeout (first_pass, timeout_, now, end);
 
         //  Wait for events.
         {
-            int rc = poll (&pollfds[0], nitems_, timeout);
+            const int rc = poll (&pollfds[0], nitems_, timeout);
             if (rc == -1 && errno == EINTR) {
                 return -1;
             }
@@ -1112,8 +1165,8 @@ void *zmq_poller_new (void)
 int zmq_poller_destroy (void **poller_p_)
 {
     if (poller_p_) {
-        zmq::socket_poller_t *const poller =
-          static_cast<zmq::socket_poller_t *> (*poller_p_);
+        const zmq::socket_poller_t *const poller =
+          static_cast<const zmq::socket_poller_t *> (*poller_p_);
         if (poller && poller->check_tag ()) {
             delete poller;
             *poller_p_ = NULL;
@@ -1172,6 +1225,14 @@ static int check_poller_fd_registration_
     return 0;
 }
 
+int zmq_poller_size (void *poller_)
+{
+    if (-1 == check_poller (poller_))
+        return -1;
+
+    return (static_cast<zmq::socket_poller_t *> (poller_))->size ();
+}
+
 int zmq_poller_add (void *poller_, void *s_, void *user_data_, short events_)
 {
     if (-1 == check_poller_registration_args (poller_, s_)
@@ -1204,7 +1265,8 @@ int zmq_poller_modify (void *poller_, vo
         || -1 == check_events (events_))
         return -1;
 
-    zmq::socket_base_t *socket = static_cast<zmq::socket_base_t *> (s_);
+    const zmq::socket_base_t *const socket =
+      static_cast<const zmq::socket_base_t *> (s_);
 
     return (static_cast<zmq::socket_poller_t *> (poller_))
       ->modify (socket, events_);
@@ -1240,12 +1302,13 @@ int zmq_poller_remove_fd (void *poller_,
 
 int zmq_poller_wait (void *poller_, zmq_poller_event_t *event_, long timeout_)
 {
-    int rc = zmq_poller_wait_all (poller_, event_, 1, timeout_);
+    const int rc = zmq_poller_wait_all (poller_, event_, 1, timeout_);
 
     if (rc < 0 && event_) {
-        // TODO this is not portable... zmq_poller_event_t contains pointers,
-        // for which nullptr does not need to be represented by all-zeroes
-        memset (event_, 0, sizeof (zmq_poller_event_t));
+        event_->socket = NULL;
+        event_->fd = zmq::retired_fd;
+        event_->user_data = NULL;
+        event_->events = 0;
     }
     // wait_all returns number of events, but we return 0 for any success
     return rc >= 0 ? 0 : rc;
@@ -1268,7 +1331,7 @@ int zmq_poller_wait_all (void *poller_,
         return -1;
     }
 
-    int rc =
+    const int rc =
       (static_cast<zmq::socket_poller_t *> (poller_))
         ->wait (reinterpret_cast<zmq::socket_poller_t::event_t *> (events_),
                 n_events_, timeout_);
@@ -1282,9 +1345,8 @@ int zmq_poller_fd (void *poller_, zmq_fd
         || !(static_cast<zmq::socket_poller_t *> (poller_)->check_tag ())) {
         errno = EFAULT;
         return -1;
-    } else {
-        return static_cast<zmq::socket_poller_t *> (poller_)->signaler_fd (fd_);
     }
+    return static_cast<zmq::socket_poller_t *> (poller_)->signaler_fd (fd_);
 }
 
 //  Peer-specific state
@@ -1426,12 +1488,12 @@ int zmq_device (int /* type */, void *fr
 
 int zmq_has (const char *capability_)
 {
-#if !defined(ZMQ_HAVE_WINDOWS) && !defined(ZMQ_HAVE_OPENVMS)
+#if defined(ZMQ_HAVE_IPC)
     if (strcmp (capability_, zmq::protocol_name::ipc) == 0)
         return true;
 #endif
 #if defined(ZMQ_HAVE_OPENPGM)
-    if (strcmp (capability_, "pgm") == 0)
+    if (strcmp (capability_, zmq::protocol_name::pgm) == 0)
         return true;
 #endif
 #if defined(ZMQ_HAVE_TIPC)
@@ -1439,7 +1501,7 @@ int zmq_has (const char *capability_)
         return true;
 #endif
 #if defined(ZMQ_HAVE_NORM)
-    if (strcmp (capability_, "norm") == 0)
+    if (strcmp (capability_, zmq::protocol_name::norm) == 0)
         return true;
 #endif
 #if defined(ZMQ_HAVE_CURVE)
@@ -1458,6 +1520,14 @@ int zmq_has (const char *capability_)
     if (strcmp (capability_, "draft") == 0)
         return true;
 #endif
+#if defined(ZMQ_HAVE_WS)
+    if (strcmp (capability_, "WS") == 0)
+        return true;
+#endif
+#if defined(ZMQ_HAVE_WSS)
+    if (strcmp (capability_, "WSS") == 0)
+        return true;
+#endif
     //  Whatever the application asked for, we don't have
     return false;
 }
diff -pruN 4.3.2-2/src/zmq_draft.h 4.3.3-1/src/zmq_draft.h
--- 4.3.2-2/src/zmq_draft.h	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/zmq_draft.h	2020-09-07 10:12:14.000000000 +0000
@@ -45,6 +45,8 @@
 #define ZMQ_GATHER 16
 #define ZMQ_SCATTER 17
 #define ZMQ_DGRAM 18
+#define ZMQ_PEER 19
+#define ZMQ_CHANNEL 20
 
 /*  DRAFT Socket options.                                                     */
 #define ZMQ_ZAP_ENFORCE_DOMAIN 93
@@ -57,10 +59,33 @@
 #define ZMQ_SOCKS_PASSWORD 100
 #define ZMQ_IN_BATCH_SIZE 101
 #define ZMQ_OUT_BATCH_SIZE 102
+#define ZMQ_WSS_KEY_PEM 103
+#define ZMQ_WSS_CERT_PEM 104
+#define ZMQ_WSS_TRUST_PEM 105
+#define ZMQ_WSS_HOSTNAME 106
+#define ZMQ_WSS_TRUST_SYSTEM 107
+#define ZMQ_ONLY_FIRST_SUBSCRIBE 108
+#define ZMQ_RECONNECT_STOP 109
+#define ZMQ_HELLO_MSG 110
+#define ZMQ_DISCONNECT_MSG 111
+
+/*  DRAFT ZMQ_RECONNECT_STOP options                                          */
+#define ZMQ_RECONNECT_STOP_CONN_REFUSED 0x1
+#define ZMQ_RECONNECT_STOP_HANDSHAKE_FAILED 0x2
 
 /*  DRAFT Context options                                                     */
 #define ZMQ_ZERO_COPY_RECV 10
 
+/*  DRAFT Context methods.                                                    */
+int zmq_ctx_set_ext (void *context_,
+                     int option_,
+                     const void *optval_,
+                     size_t optvallen_);
+int zmq_ctx_get_ext (void *context_,
+                     int option_,
+                     void *optval_,
+                     size_t *optvallen_);
+
 /*  DRAFT Socket methods.                                                     */
 int zmq_join (void *s_, const char *group_);
 int zmq_leave (void *s_, const char *group_);
@@ -70,6 +95,7 @@ int zmq_msg_set_routing_id (zmq_msg_t *m
 uint32_t zmq_msg_routing_id (zmq_msg_t *msg_);
 int zmq_msg_set_group (zmq_msg_t *msg_, const char *group_);
 const char *zmq_msg_group (zmq_msg_t *msg_);
+int zmq_msg_init_buffer (zmq_msg_t *msg_, const void *buf_, size_t size_);
 
 /*  DRAFT Msg property names.                                                 */
 #define ZMQ_MSG_PROPERTY_ROUTING_ID "Routing-Id"
@@ -101,6 +127,7 @@ typedef struct zmq_poller_event_t
 
 void *zmq_poller_new (void);
 int zmq_poller_destroy (void **poller_p_);
+int zmq_poller_size (void *poller_);
 int zmq_poller_add (void *poller_,
                     void *socket_,
                     void *user_data_,
diff -pruN 4.3.2-2/src/zmq_utils.cpp 4.3.3-1/src/zmq_utils.cpp
--- 4.3.2-2/src/zmq_utils.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/src/zmq_utils.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -63,19 +63,19 @@ void *zmq_stopwatch_start ()
     uint64_t *watch = static_cast<uint64_t *> (malloc (sizeof (uint64_t)));
     alloc_assert (watch);
     *watch = zmq::clock_t::now_us ();
-    return (void *) watch;
+    return static_cast<void *> (watch);
 }
 
 unsigned long zmq_stopwatch_intermediate (void *watch_)
 {
-    uint64_t end = zmq::clock_t::now_us ();
-    uint64_t start = *static_cast<uint64_t *> (watch_);
+    const uint64_t end = zmq::clock_t::now_us ();
+    const uint64_t start = *static_cast<uint64_t *> (watch_);
     return static_cast<unsigned long> (end - start);
 }
 
 unsigned long zmq_stopwatch_stop (void *watch_)
 {
-    unsigned long res = zmq_stopwatch_intermediate (watch_);
+    const unsigned long res = zmq_stopwatch_intermediate (watch_);
     free (watch_);
     return res;
 }
@@ -166,6 +166,11 @@ uint8_t *zmq_z85_decode (uint8_t *dest_,
     unsigned int byte_nbr = 0;
     unsigned int char_nbr = 0;
     uint32_t value = 0;
+    size_t src_len = strlen (string_);
+
+    if (src_len < 5 || src_len % 5 != 0)
+        goto error_inval;
+
     while (string_[char_nbr]) {
         //  Accumulate value in base 85
         if (UINT32_MAX / 85 < value) {
@@ -173,12 +178,12 @@ uint8_t *zmq_z85_decode (uint8_t *dest_,
             goto error_inval;
         }
         value *= 85;
-        uint8_t index = string_[char_nbr++] - 32;
+        const uint8_t index = string_[char_nbr++] - 32;
         if (index >= sizeof (decoder)) {
             //  Invalid z85 encoding, character outside range
             goto error_inval;
         }
-        uint32_t summand = decoder[index];
+        const uint32_t summand = decoder[index];
         if (summand == 0xFF || summand > (UINT32_MAX - value)) {
             //  Invalid z85 encoding, invalid character or represented value exceeds 0xffffffff
             goto error_inval;
@@ -223,7 +228,7 @@ int zmq_curve_keypair (char *z85_public_
 
     zmq::random_open ();
 
-    int res = crypto_box_keypair (public_key, secret_key);
+    const int res = crypto_box_keypair (public_key, secret_key);
     zmq_z85_encode (z85_public_key_, public_key, 32);
     zmq_z85_encode (z85_secret_key_, secret_key, 32);
 
diff -pruN 4.3.2-2/src/zmtp_engine.cpp 4.3.3-1/src/zmtp_engine.cpp
--- 4.3.2-2/src/zmtp_engine.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/zmtp_engine.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,587 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "precompiled.hpp"
+#include "macros.hpp"
+
+#include <limits.h>
+#include <string.h>
+
+#ifndef ZMQ_HAVE_WINDOWS
+#include <unistd.h>
+#endif
+
+#include <new>
+#include <sstream>
+
+#include "zmtp_engine.hpp"
+#include "io_thread.hpp"
+#include "session_base.hpp"
+#include "v1_encoder.hpp"
+#include "v1_decoder.hpp"
+#include "v2_encoder.hpp"
+#include "v2_decoder.hpp"
+#include "v3_1_encoder.hpp"
+#include "null_mechanism.hpp"
+#include "plain_client.hpp"
+#include "plain_server.hpp"
+#include "gssapi_client.hpp"
+#include "gssapi_server.hpp"
+#include "curve_client.hpp"
+#include "curve_server.hpp"
+#include "raw_decoder.hpp"
+#include "raw_encoder.hpp"
+#include "config.hpp"
+#include "err.hpp"
+#include "ip.hpp"
+#include "likely.hpp"
+#include "wire.hpp"
+
+zmq::zmtp_engine_t::zmtp_engine_t (
+  fd_t fd_,
+  const options_t &options_,
+  const endpoint_uri_pair_t &endpoint_uri_pair_) :
+    stream_engine_base_t (fd_, options_, endpoint_uri_pair_, true),
+    _greeting_size (v2_greeting_size),
+    _greeting_bytes_read (0),
+    _subscription_required (false),
+    _heartbeat_timeout (0)
+{
+    _next_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+      &zmtp_engine_t::routing_id_msg);
+    _process_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+      &zmtp_engine_t::process_routing_id_msg);
+
+    int rc = _pong_msg.init ();
+    errno_assert (rc == 0);
+
+    rc = _routing_id_msg.init ();
+    errno_assert (rc == 0);
+
+    if (_options.heartbeat_interval > 0) {
+        _heartbeat_timeout = _options.heartbeat_timeout;
+        if (_heartbeat_timeout == -1)
+            _heartbeat_timeout = _options.heartbeat_interval;
+    }
+}
+
+zmq::zmtp_engine_t::~zmtp_engine_t ()
+{
+    const int rc = _routing_id_msg.close ();
+    errno_assert (rc == 0);
+}
+
+void zmq::zmtp_engine_t::plug_internal ()
+{
+    // start optional timer, to prevent handshake hanging on no input
+    set_handshake_timer ();
+
+    //  Send the 'length' and 'flags' fields of the routing id message.
+    //  The 'length' field is encoded in the long format.
+    _outpos = _greeting_send;
+    _outpos[_outsize++] = UCHAR_MAX;
+    put_uint64 (&_outpos[_outsize], _options.routing_id_size + 1);
+    _outsize += 8;
+    _outpos[_outsize++] = 0x7f;
+
+    set_pollin ();
+    set_pollout ();
+    //  Flush all the data that may have been already received downstream.
+    in_event ();
+}
+
+//  Position of the revision and minor fields in the greeting.
+const size_t revision_pos = 10;
+const size_t minor_pos = 11;
+
+bool zmq::zmtp_engine_t::handshake ()
+{
+    zmq_assert (_greeting_bytes_read < _greeting_size);
+    //  Receive the greeting.
+    const int rc = receive_greeting ();
+    if (rc == -1)
+        return false;
+    const bool unversioned = rc != 0;
+
+    if (!(this
+            ->*select_handshake_fun (unversioned, _greeting_recv[revision_pos],
+                                     _greeting_recv[minor_pos])) ())
+        return false;
+
+    // Start polling for output if necessary.
+    if (_outsize == 0)
+        set_pollout ();
+
+    return true;
+}
+
+int zmq::zmtp_engine_t::receive_greeting ()
+{
+    bool unversioned = false;
+    while (_greeting_bytes_read < _greeting_size) {
+        const int n = read (_greeting_recv + _greeting_bytes_read,
+                            _greeting_size - _greeting_bytes_read);
+        if (n == -1) {
+            if (errno != EAGAIN)
+                error (connection_error);
+            return -1;
+        }
+
+        _greeting_bytes_read += n;
+
+        //  We have received at least one byte from the peer.
+        //  If the first byte is not 0xff, we know that the
+        //  peer is using unversioned protocol.
+        if (_greeting_recv[0] != 0xff) {
+            unversioned = true;
+            break;
+        }
+
+        if (_greeting_bytes_read < signature_size)
+            continue;
+
+        //  Inspect the right-most bit of the 10th byte (which coincides
+        //  with the 'flags' field if a regular message was sent).
+        //  Zero indicates this is a header of a routing id message
+        //  (i.e. the peer is using the unversioned protocol).
+        if (!(_greeting_recv[9] & 0x01)) {
+            unversioned = true;
+            break;
+        }
+
+        //  The peer is using versioned protocol.
+        receive_greeting_versioned ();
+    }
+    return unversioned ? 1 : 0;
+}
+
+void zmq::zmtp_engine_t::receive_greeting_versioned ()
+{
+    //  Send the major version number.
+    if (_outpos + _outsize == _greeting_send + signature_size) {
+        if (_outsize == 0)
+            set_pollout ();
+        _outpos[_outsize++] = 3; //  Major version number
+    }
+
+    if (_greeting_bytes_read > signature_size) {
+        if (_outpos + _outsize == _greeting_send + signature_size + 1) {
+            if (_outsize == 0)
+                set_pollout ();
+
+            //  Use ZMTP/2.0 to talk to older peers.
+            if (_greeting_recv[revision_pos] == ZMTP_1_0
+                || _greeting_recv[revision_pos] == ZMTP_2_0)
+                _outpos[_outsize++] = _options.type;
+            else {
+                _outpos[_outsize++] = 1; //  Minor version number
+                memset (_outpos + _outsize, 0, 20);
+
+                zmq_assert (_options.mechanism == ZMQ_NULL
+                            || _options.mechanism == ZMQ_PLAIN
+                            || _options.mechanism == ZMQ_CURVE
+                            || _options.mechanism == ZMQ_GSSAPI);
+
+                if (_options.mechanism == ZMQ_NULL)
+                    memcpy (_outpos + _outsize, "NULL", 4);
+                else if (_options.mechanism == ZMQ_PLAIN)
+                    memcpy (_outpos + _outsize, "PLAIN", 5);
+                else if (_options.mechanism == ZMQ_GSSAPI)
+                    memcpy (_outpos + _outsize, "GSSAPI", 6);
+                else if (_options.mechanism == ZMQ_CURVE)
+                    memcpy (_outpos + _outsize, "CURVE", 5);
+                _outsize += 20;
+                memset (_outpos + _outsize, 0, 32);
+                _outsize += 32;
+                _greeting_size = v3_greeting_size;
+            }
+        }
+    }
+}
+
+zmq::zmtp_engine_t::handshake_fun_t zmq::zmtp_engine_t::select_handshake_fun (
+  bool unversioned_, unsigned char revision_, unsigned char minor_)
+{
+    //  Is the peer using ZMTP/1.0 with no revision number?
+    if (unversioned_) {
+        return &zmtp_engine_t::handshake_v1_0_unversioned;
+    }
+    switch (revision_) {
+        case ZMTP_1_0:
+            return &zmtp_engine_t::handshake_v1_0;
+        case ZMTP_2_0:
+            return &zmtp_engine_t::handshake_v2_0;
+        case ZMTP_3_x:
+            switch (minor_) {
+                case 0:
+                    return &zmtp_engine_t::handshake_v3_0;
+                default:
+                    return &zmtp_engine_t::handshake_v3_1;
+            }
+        default:
+            return &zmtp_engine_t::handshake_v3_1;
+    }
+}
+
+bool zmq::zmtp_engine_t::handshake_v1_0_unversioned ()
+{
+    //  We send and receive rest of routing id message
+    if (session ()->zap_enabled ()) {
+        // reject ZMTP 1.0 connections if ZAP is enabled
+        error (protocol_error);
+        return false;
+    }
+
+    _encoder = new (std::nothrow) v1_encoder_t (_options.out_batch_size);
+    alloc_assert (_encoder);
+
+    _decoder = new (std::nothrow)
+      v1_decoder_t (_options.in_batch_size, _options.maxmsgsize);
+    alloc_assert (_decoder);
+
+    //  We have already sent the message header.
+    //  Since there is no way to tell the encoder to
+    //  skip the message header, we simply throw that
+    //  header data away.
+    const size_t header_size =
+      _options.routing_id_size + 1 >= UCHAR_MAX ? 10 : 2;
+    unsigned char tmp[10], *bufferp = tmp;
+
+    //  Prepare the routing id message and load it into encoder.
+    //  Then consume bytes we have already sent to the peer.
+    int rc = _routing_id_msg.close ();
+    zmq_assert (rc == 0);
+    rc = _routing_id_msg.init_size (_options.routing_id_size);
+    zmq_assert (rc == 0);
+    memcpy (_routing_id_msg.data (), _options.routing_id,
+            _options.routing_id_size);
+    _encoder->load_msg (&_routing_id_msg);
+    const size_t buffer_size = _encoder->encode (&bufferp, header_size);
+    zmq_assert (buffer_size == header_size);
+
+    //  Make sure the decoder sees the data we have already received.
+    _inpos = _greeting_recv;
+    _insize = _greeting_bytes_read;
+
+    //  To allow for interoperability with peers that do not forward
+    //  their subscriptions, we inject a phantom subscription message
+    //  message into the incoming message stream.
+    if (_options.type == ZMQ_PUB || _options.type == ZMQ_XPUB)
+        _subscription_required = true;
+
+    //  We are sending our routing id now and the next message
+    //  will come from the socket.
+    _next_msg = &zmtp_engine_t::pull_msg_from_session;
+
+    //  We are expecting routing id message.
+    _process_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+      &zmtp_engine_t::process_routing_id_msg);
+
+    return true;
+}
+
+bool zmq::zmtp_engine_t::handshake_v1_0 ()
+{
+    if (session ()->zap_enabled ()) {
+        // reject ZMTP 1.0 connections if ZAP is enabled
+        error (protocol_error);
+        return false;
+    }
+
+    _encoder = new (std::nothrow) v1_encoder_t (_options.out_batch_size);
+    alloc_assert (_encoder);
+
+    _decoder = new (std::nothrow)
+      v1_decoder_t (_options.in_batch_size, _options.maxmsgsize);
+    alloc_assert (_decoder);
+
+    return true;
+}
+
+bool zmq::zmtp_engine_t::handshake_v2_0 ()
+{
+    if (session ()->zap_enabled ()) {
+        // reject ZMTP 2.0 connections if ZAP is enabled
+        error (protocol_error);
+        return false;
+    }
+
+    _encoder = new (std::nothrow) v2_encoder_t (_options.out_batch_size);
+    alloc_assert (_encoder);
+
+    _decoder = new (std::nothrow) v2_decoder_t (
+      _options.in_batch_size, _options.maxmsgsize, _options.zero_copy);
+    alloc_assert (_decoder);
+
+    return true;
+}
+
+bool zmq::zmtp_engine_t::handshake_v3_x (const bool downgrade_sub_)
+{
+    if (_options.mechanism == ZMQ_NULL
+        && memcmp (_greeting_recv + 12, "NULL\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",
+                   20)
+             == 0) {
+        _mechanism = new (std::nothrow)
+          null_mechanism_t (session (), _peer_address, _options);
+        alloc_assert (_mechanism);
+    } else if (_options.mechanism == ZMQ_PLAIN
+               && memcmp (_greeting_recv + 12,
+                          "PLAIN\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0", 20)
+                    == 0) {
+        if (_options.as_server)
+            _mechanism = new (std::nothrow)
+              plain_server_t (session (), _peer_address, _options);
+        else
+            _mechanism =
+              new (std::nothrow) plain_client_t (session (), _options);
+        alloc_assert (_mechanism);
+    }
+#ifdef ZMQ_HAVE_CURVE
+    else if (_options.mechanism == ZMQ_CURVE
+             && memcmp (_greeting_recv + 12,
+                        "CURVE\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0", 20)
+                  == 0) {
+        if (_options.as_server)
+            _mechanism = new (std::nothrow) curve_server_t (
+              session (), _peer_address, _options, downgrade_sub_);
+        else
+            _mechanism = new (std::nothrow)
+              curve_client_t (session (), _options, downgrade_sub_);
+        alloc_assert (_mechanism);
+    }
+#endif
+#ifdef HAVE_LIBGSSAPI_KRB5
+    else if (_options.mechanism == ZMQ_GSSAPI
+             && memcmp (_greeting_recv + 12,
+                        "GSSAPI\0\0\0\0\0\0\0\0\0\0\0\0\0\0", 20)
+                  == 0) {
+        if (_options.as_server)
+            _mechanism = new (std::nothrow)
+              gssapi_server_t (session (), _peer_address, _options);
+        else
+            _mechanism =
+              new (std::nothrow) gssapi_client_t (session (), _options);
+        alloc_assert (_mechanism);
+    }
+#endif
+    else {
+        socket ()->event_handshake_failed_protocol (
+          session ()->get_endpoint (),
+          ZMQ_PROTOCOL_ERROR_ZMTP_MECHANISM_MISMATCH);
+        error (protocol_error);
+        return false;
+    }
+    _next_msg = &zmtp_engine_t::next_handshake_command;
+    _process_msg = &zmtp_engine_t::process_handshake_command;
+
+    return true;
+}
+
+bool zmq::zmtp_engine_t::handshake_v3_0 ()
+{
+    _encoder = new (std::nothrow) v2_encoder_t (_options.out_batch_size);
+    alloc_assert (_encoder);
+
+    _decoder = new (std::nothrow) v2_decoder_t (
+      _options.in_batch_size, _options.maxmsgsize, _options.zero_copy);
+    alloc_assert (_decoder);
+
+    return zmq::zmtp_engine_t::handshake_v3_x (true);
+}
+
+bool zmq::zmtp_engine_t::handshake_v3_1 ()
+{
+    _encoder = new (std::nothrow) v3_1_encoder_t (_options.out_batch_size);
+    alloc_assert (_encoder);
+
+    _decoder = new (std::nothrow) v2_decoder_t (
+      _options.in_batch_size, _options.maxmsgsize, _options.zero_copy);
+    alloc_assert (_decoder);
+
+    return zmq::zmtp_engine_t::handshake_v3_x (false);
+}
+
+int zmq::zmtp_engine_t::routing_id_msg (msg_t *msg_)
+{
+    const int rc = msg_->init_size (_options.routing_id_size);
+    errno_assert (rc == 0);
+    if (_options.routing_id_size > 0)
+        memcpy (msg_->data (), _options.routing_id, _options.routing_id_size);
+    _next_msg = &zmtp_engine_t::pull_msg_from_session;
+    return 0;
+}
+
+int zmq::zmtp_engine_t::process_routing_id_msg (msg_t *msg_)
+{
+    if (_options.recv_routing_id) {
+        msg_->set_flags (msg_t::routing_id);
+        const int rc = session ()->push_msg (msg_);
+        errno_assert (rc == 0);
+    } else {
+        int rc = msg_->close ();
+        errno_assert (rc == 0);
+        rc = msg_->init ();
+        errno_assert (rc == 0);
+    }
+
+    if (_subscription_required) {
+        msg_t subscription;
+
+        //  Inject the subscription message, so that also
+        //  ZMQ 2.x peers receive published messages.
+        int rc = subscription.init_size (1);
+        errno_assert (rc == 0);
+        *static_cast<unsigned char *> (subscription.data ()) = 1;
+        rc = session ()->push_msg (&subscription);
+        errno_assert (rc == 0);
+    }
+
+    _process_msg = &zmtp_engine_t::push_msg_to_session;
+
+    return 0;
+}
+
+int zmq::zmtp_engine_t::produce_ping_message (msg_t *msg_)
+{
+    // 16-bit TTL + \4PING == 7
+    const size_t ping_ttl_len = msg_t::ping_cmd_name_size + 2;
+    zmq_assert (_mechanism != NULL);
+
+    int rc = msg_->init_size (ping_ttl_len);
+    errno_assert (rc == 0);
+    msg_->set_flags (msg_t::command);
+    // Copy in the command message
+    memcpy (msg_->data (), "\4PING", msg_t::ping_cmd_name_size);
+
+    uint16_t ttl_val = htons (_options.heartbeat_ttl);
+    memcpy (static_cast<uint8_t *> (msg_->data ()) + msg_t::ping_cmd_name_size,
+            &ttl_val, sizeof (ttl_val));
+
+    rc = _mechanism->encode (msg_);
+    _next_msg = &zmtp_engine_t::pull_and_encode;
+    if (!_has_timeout_timer && _heartbeat_timeout > 0) {
+        add_timer (_heartbeat_timeout, heartbeat_timeout_timer_id);
+        _has_timeout_timer = true;
+    }
+    return rc;
+}
+
+int zmq::zmtp_engine_t::produce_pong_message (msg_t *msg_)
+{
+    zmq_assert (_mechanism != NULL);
+
+    int rc = msg_->move (_pong_msg);
+    errno_assert (rc == 0);
+
+    rc = _mechanism->encode (msg_);
+    _next_msg = &zmtp_engine_t::pull_and_encode;
+    return rc;
+}
+
+int zmq::zmtp_engine_t::process_heartbeat_message (msg_t *msg_)
+{
+    if (msg_->is_ping ()) {
+        // 16-bit TTL + \4PING == 7
+        const size_t ping_ttl_len = msg_t::ping_cmd_name_size + 2;
+        const size_t ping_max_ctx_len = 16;
+        uint16_t remote_heartbeat_ttl;
+
+        // Get the remote heartbeat TTL to setup the timer
+        memcpy (&remote_heartbeat_ttl,
+                static_cast<uint8_t *> (msg_->data ())
+                  + msg_t::ping_cmd_name_size,
+                ping_ttl_len - msg_t::ping_cmd_name_size);
+        remote_heartbeat_ttl = ntohs (remote_heartbeat_ttl);
+        // The remote heartbeat is in 10ths of a second
+        // so we multiply it by 100 to get the timer interval in ms.
+        remote_heartbeat_ttl *= 100;
+
+        if (!_has_ttl_timer && remote_heartbeat_ttl > 0) {
+            add_timer (remote_heartbeat_ttl, heartbeat_ttl_timer_id);
+            _has_ttl_timer = true;
+        }
+
+        //  As per ZMTP 3.1 the PING command might contain an up to 16 bytes
+        //  context which needs to be PONGed back, so build the pong message
+        //  here and store it. Truncate it if it's too long.
+        //  Given the engine goes straight to out_event, sequential PINGs will
+        //  not be a problem.
+        const size_t context_len =
+          std::min (msg_->size () - ping_ttl_len, ping_max_ctx_len);
+        const int rc =
+          _pong_msg.init_size (msg_t::ping_cmd_name_size + context_len);
+        errno_assert (rc == 0);
+        _pong_msg.set_flags (msg_t::command);
+        memcpy (_pong_msg.data (), "\4PONG", msg_t::ping_cmd_name_size);
+        if (context_len > 0)
+            memcpy (static_cast<uint8_t *> (_pong_msg.data ())
+                      + msg_t::ping_cmd_name_size,
+                    static_cast<uint8_t *> (msg_->data ()) + ping_ttl_len,
+                    context_len);
+
+        _next_msg = static_cast<int (stream_engine_base_t::*) (msg_t *)> (
+          &zmtp_engine_t::produce_pong_message);
+        out_event ();
+    }
+
+    return 0;
+}
+
+int zmq::zmtp_engine_t::process_command_message (msg_t *msg_)
+{
+    const uint8_t cmd_name_size =
+      *(static_cast<const uint8_t *> (msg_->data ()));
+    const size_t ping_name_size = msg_t::ping_cmd_name_size - 1;
+    const size_t sub_name_size = msg_t::sub_cmd_name_size - 1;
+    const size_t cancel_name_size = msg_t::cancel_cmd_name_size - 1;
+    //  Malformed command
+    if (unlikely (msg_->size () < cmd_name_size + sizeof (cmd_name_size)))
+        return -1;
+
+    const uint8_t *const cmd_name =
+      static_cast<const uint8_t *> (msg_->data ()) + 1;
+    if (cmd_name_size == ping_name_size
+        && memcmp (cmd_name, "PING", cmd_name_size) == 0)
+        msg_->set_flags (zmq::msg_t::ping);
+    if (cmd_name_size == ping_name_size
+        && memcmp (cmd_name, "PONG", cmd_name_size) == 0)
+        msg_->set_flags (zmq::msg_t::pong);
+    if (cmd_name_size == sub_name_size
+        && memcmp (cmd_name, "SUBSCRIBE", cmd_name_size) == 0)
+        msg_->set_flags (zmq::msg_t::subscribe);
+    if (cmd_name_size == cancel_name_size
+        && memcmp (cmd_name, "CANCEL", cmd_name_size) == 0)
+        msg_->set_flags (zmq::msg_t::cancel);
+
+    if (msg_->is_ping () || msg_->is_pong ())
+        return process_heartbeat_message (msg_);
+
+    return 0;
+}
diff -pruN 4.3.2-2/src/zmtp_engine.hpp 4.3.3-1/src/zmtp_engine.hpp
--- 4.3.2-2/src/zmtp_engine.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/src/zmtp_engine.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,136 @@
+/*
+    Copyright (c) 2007-2019 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __ZMQ_ZMTP_ENGINE_HPP_INCLUDED__
+#define __ZMQ_ZMTP_ENGINE_HPP_INCLUDED__
+
+#include <stddef.h>
+
+#include "fd.hpp"
+#include "i_engine.hpp"
+#include "io_object.hpp"
+#include "i_encoder.hpp"
+#include "i_decoder.hpp"
+#include "options.hpp"
+#include "socket_base.hpp"
+#include "metadata.hpp"
+#include "msg.hpp"
+#include "stream_engine_base.hpp"
+
+namespace zmq
+{
+//  Protocol revisions
+enum
+{
+    ZMTP_1_0 = 0,
+    ZMTP_2_0 = 1,
+    ZMTP_3_x = 3
+};
+
+class io_thread_t;
+class session_base_t;
+class mechanism_t;
+
+//  This engine handles any socket with SOCK_STREAM semantics,
+//  e.g. TCP socket or an UNIX domain socket.
+
+class zmtp_engine_t ZMQ_FINAL : public stream_engine_base_t
+{
+  public:
+    zmtp_engine_t (fd_t fd_,
+                   const options_t &options_,
+                   const endpoint_uri_pair_t &endpoint_uri_pair_);
+    ~zmtp_engine_t ();
+
+  protected:
+    //  Detects the protocol used by the peer.
+    bool handshake ();
+
+    void plug_internal ();
+
+    int process_command_message (msg_t *msg_);
+    int produce_ping_message (msg_t *msg_);
+    int process_heartbeat_message (msg_t *msg_);
+    int produce_pong_message (msg_t *msg_);
+
+  private:
+    //  Receive the greeting from the peer.
+    int receive_greeting ();
+    void receive_greeting_versioned ();
+
+    typedef bool (zmtp_engine_t::*handshake_fun_t) ();
+    static handshake_fun_t select_handshake_fun (bool unversioned,
+                                                 unsigned char revision,
+                                                 unsigned char minor);
+
+    bool handshake_v1_0_unversioned ();
+    bool handshake_v1_0 ();
+    bool handshake_v2_0 ();
+    bool handshake_v3_x (bool downgrade_sub);
+    bool handshake_v3_0 ();
+    bool handshake_v3_1 ();
+
+    int routing_id_msg (msg_t *msg_);
+    int process_routing_id_msg (msg_t *msg_);
+
+    msg_t _routing_id_msg;
+
+    //  Need to store PING payload for PONG
+    msg_t _pong_msg;
+
+    static const size_t signature_size = 10;
+
+    //  Size of ZMTP/1.0 and ZMTP/2.0 greeting message
+    static const size_t v2_greeting_size = 12;
+
+    //  Size of ZMTP/3.0 greeting message
+    static const size_t v3_greeting_size = 64;
+
+    //  Expected greeting size.
+    size_t _greeting_size;
+
+    //  Greeting received from, and sent to peer
+    unsigned char _greeting_recv[v3_greeting_size];
+    unsigned char _greeting_send[v3_greeting_size];
+
+    //  Size of greeting received so far
+    unsigned int _greeting_bytes_read;
+
+    //  Indicates whether the engine is to inject a phantom
+    //  subscription message into the incoming stream.
+    //  Needed to support old peers.
+    bool _subscription_required;
+
+    int _heartbeat_timeout;
+
+    ZMQ_NON_COPYABLE_NOR_MOVABLE (zmtp_engine_t)
+};
+}
+
+#endif
diff -pruN 4.3.2-2/tests/CMakeLists.txt 4.3.3-1/tests/CMakeLists.txt
--- 4.3.2-2/tests/CMakeLists.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/CMakeLists.txt	2020-09-07 10:12:14.000000000 +0000
@@ -5,102 +5,107 @@ cmake_minimum_required(VERSION "2.8.1")
 project(tests)
 
 set(tests
-  test_ancillaries
-  test_system
-  test_pair_inproc
-  test_pair_tcp
-  test_reqrep_inproc
-  test_reqrep_tcp
-  test_hwm
-  test_hwm_pubsub
-  test_reqrep_device
-  test_sub_forward
-  test_invalid_rep
-  test_msg_flags
-  test_msg_ffn
-  test_connect_resolve
-  test_immediate
-  test_last_endpoint
-  test_term_endpoint
-  test_router_mandatory
-  test_probe_router
-  test_stream
-  test_stream_empty
-  test_stream_disconnect
-  test_disconnect_inproc
-  test_unbind_wildcard
-  test_ctx_options
-  test_ctx_destroy
-  test_security_no_zap_handler
-  test_security_null
-  test_security_plain
-  test_security_zap
-  test_iov
-  test_spec_req
-  test_spec_rep
-  test_spec_dealer
-  test_spec_router
-  test_spec_pushpull
-  test_req_correlate
-  test_req_relaxed
-  test_conflate
-  test_inproc_connect
-  test_issue_566
-  test_shutdown_stress
-  test_timeo
-  test_many_sockets
-  test_diffserv
-  test_connect_rid
-  test_xpub_nodrop
-  test_pub_invert_matching
-  test_setsockopt
-  test_sockopt_hwm
-  test_heartbeats
-  test_atomics
-  test_bind_src_address
-  test_capabilities
-  test_metadata
-  test_router_handover
-  test_srcfd
-  test_stream_timeout
-  test_xpub_manual
-  test_xpub_welcome_msg
-  test_xpub_verbose
-  test_base85
-  test_bind_after_connect_tcp
-  test_sodium
-  test_monitor
-  test_socket_null
-  test_reconnect_ivl
-  test_mock_pub_sub
-)
+    test_ancillaries
+    test_system
+    test_pair_inproc
+    test_pair_tcp
+    test_reqrep_inproc
+    test_reqrep_tcp
+    test_hwm
+    test_hwm_pubsub
+    test_reqrep_device
+    test_sub_forward
+    test_invalid_rep
+    test_msg_flags
+    test_msg_ffn
+    test_connect_resolve
+    test_immediate
+    test_last_endpoint
+    test_term_endpoint
+    test_router_mandatory
+    test_probe_router
+    test_stream
+    test_stream_empty
+    test_stream_disconnect
+    test_disconnect_inproc
+    test_unbind_wildcard
+    test_ctx_options
+    test_ctx_destroy
+    test_security_no_zap_handler
+    test_security_null
+    test_security_plain
+    test_security_zap
+    test_iov
+    test_spec_req
+    test_spec_rep
+    test_spec_dealer
+    test_spec_router
+    test_spec_pushpull
+    test_req_correlate
+    test_req_relaxed
+    test_conflate
+    test_inproc_connect
+    test_issue_566
+    test_shutdown_stress
+    test_timeo
+    test_many_sockets
+    test_diffserv
+    test_connect_rid
+    test_xpub_nodrop
+    test_pub_invert_matching
+    test_setsockopt
+    test_sockopt_hwm
+    test_heartbeats
+    test_atomics
+    test_bind_src_address
+    test_capabilities
+    test_metadata
+    test_router_handover
+    test_srcfd
+    test_stream_timeout
+    test_xpub_manual
+    test_xpub_welcome_msg
+    test_xpub_verbose
+    test_base85
+    test_bind_after_connect_tcp
+    test_sodium
+    test_monitor
+    test_socket_null
+    test_reconnect_ivl
+    test_reconnect_options
+    test_tcp_accept_filter
+    test_mock_pub_sub)
 
 if(NOT WIN32)
-  list(APPEND tests
-    test_security_gssapi)
+  list(APPEND tests test_security_gssapi test_socks test_connect_null_fuzzer test_bind_null_fuzzer test_connect_fuzzer test_bind_fuzzer)
 endif()
 
 if(ZMQ_HAVE_CURVE)
-  list(APPEND tests
-    test_security_curve)
+  list(APPEND tests test_security_curve)
+  if(NOT WIN32)
+    list(APPEND tests test_connect_curve_fuzzer test_bind_curve_fuzzer test_z85_decode_fuzzer)
+  endif()
 endif()
 
-find_program(CAPSH_PROGRAM NAMES capsh)
+option(ENABLE_CAPSH "Run tests that require sudo and capsh (for cap_net_admin)" OFF)
+if(ENABLE_CAPSH)
+  find_program(CAPSH_PROGRAM NAMES capsh)
 
-if (CAPSH_PROGRAM)
-    list(APPEND tests
-        test_pair_tcp_cap_net_admin
-        )
-else()
+  if(CAPSH_PROGRAM)
+    list(APPEND tests test_pair_tcp_cap_net_admin)
+  else()
     message(STATUS "capsh not found, skipping tests that require CAP_NET_ADMIN")
+  endif()
+endif()
+
+if(ZMQ_HAVE_IPC)
+  list(APPEND tests test_ipc_wildcard test_pair_ipc test_reqrep_ipc test_rebind_ipc)
 endif()
 
 if(NOT WIN32)
-  list(APPEND tests
-    test_ipc_wildcard
-    test_pair_ipc
-    test_rebind_ipc
-    test_reqrep_ipc
+  list(
+    APPEND
+    tests
     test_proxy
     test_proxy_hwm
     test_proxy_single_socket
@@ -110,17 +115,16 @@ if(NOT WIN32)
     test_stream_exceeds_buffer
     test_router_mandatory_hwm
     test_use_fd
-    test_zmq_poll_fd
-  )
+    test_zmq_poll_fd)
   if(HAVE_FORK)
     list(APPEND tests test_fork)
   endif()
   if(CMAKE_SYSTEM_NAME MATCHES "Linux")
-    list(APPEND tests
-      test_abstract_ipc
-      )
+    list(APPEND tests test_abstract_ipc)
     if(ZMQ_HAVE_TIPC)
-      list(APPEND tests
+      list(
+        APPEND
+        tests
         test_address_tipc
         test_pair_tipc
         test_reqrep_device_tipc
@@ -129,21 +133,19 @@ if(NOT WIN32)
         test_sub_forward_tipc
         test_connect_delay_tipc
         test_shutdown_stress_tipc
-        test_term_endpoint_tipc
-      )
+        test_term_endpoint_tipc)
     endif()
   endif()
 endif()
 
 if(WITH_VMCI)
-  list(APPEND tests
-    test_pair_vmci
-    test_reqrep_vmci
-  )
+  list(APPEND tests test_pair_vmci test_reqrep_vmci)
 endif()
 
 if(ENABLE_DRAFTS)
-  list(APPEND tests
+  list(
+    APPEND
+    tests
     test_poller
     test_thread_safe
     test_client_server
@@ -154,9 +156,21 @@ if(ENABLE_DRAFTS)
     test_app_meta
     test_router_notify
     test_xpub_manual_last_value
+    test_peer
+    test_msg_init
+    test_channel
+    test_hello_msg
+    test_disconnect_msg
   )
 endif()
 
+if(ZMQ_HAVE_WS)
+  list(APPEND tests test_ws_transport)
+  if(ZMQ_HAVE_WSS)
+    list(APPEND tests test_wss_transport)
+  endif()
+endif()
+
 # add location of platform.hpp for Windows builds
 if(WIN32)
   add_definitions(-DZMQ_CUSTOM_PLATFORM_HPP)
@@ -165,12 +179,11 @@ if(WIN32)
   link_libraries(ws2_32.lib)
 endif()
 
-add_library(unity STATIC
-  "${CMAKE_CURRENT_LIST_DIR}/../external/unity/unity.c"
-  "${CMAKE_CURRENT_LIST_DIR}/../external/unity/unity.h"
+add_library(
+  unity STATIC
+  "${CMAKE_CURRENT_LIST_DIR}/../external/unity/unity.c" "${CMAKE_CURRENT_LIST_DIR}/../external/unity/unity.h"
   "${CMAKE_CURRENT_LIST_DIR}/../external/unity/unity_internals.h")
-set_target_properties(unity PROPERTIES
-  PUBLIC_HEADER "${CMAKE_CURRENT_LIST_DIR}/../external/unity/unity.h")
+set_target_properties(unity PROPERTIES PUBLIC_HEADER "${CMAKE_CURRENT_LIST_DIR}/../external/unity/unity.h")
 target_compile_definitions(unity PUBLIC "UNITY_USE_COMMAND_LINE_ARGS" "UNITY_EXCLUDE_FLOAT")
 target_include_directories(unity PUBLIC "${CMAKE_CURRENT_LIST_DIR}/../external/unity")
 
@@ -182,22 +195,21 @@ set(TESTUTIL_SOURCES
     testutil_security.cpp
     testutil_security.hpp
     testutil_unity.cpp
-    testutil_unity.hpp
-    )
+    testutil_unity.hpp)
 if(BUILD_STATIC)
-    add_library(testutil-static STATIC ${TESTUTIL_SOURCES})
-    target_link_libraries(testutil-static libzmq-static ${OPTIONAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} unity)
+  add_library(testutil-static STATIC ${TESTUTIL_SOURCES})
+  target_link_libraries(testutil-static libzmq-static ${OPTIONAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} unity)
 endif()
 if(BUILD_SHARED)
-    add_library(testutil STATIC ${TESTUTIL_SOURCES})
-    target_link_libraries(testutil libzmq ${OPTIONAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} unity)
+  add_library(testutil STATIC ${TESTUTIL_SOURCES})
+  target_link_libraries(testutil libzmq ${OPTIONAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} unity)
 endif()
 if(BUILD_STATIC AND NOT BUILD_SHARED)
-    # use testutil-static for both tests and unit tests
-    set(TESTUTIL_LIB testutil-static)
+  # use testutil-static for both tests and unit tests
+  set(TESTUTIL_LIB testutil-static)
 else()
-    # use testutil for tests and testutil-static for unit tests
-    set(TESTUTIL_LIB testutil)
+  # use testutil for tests and testutil-static for unit tests
+  set(TESTUTIL_LIB testutil)
 endif()
 
 if(MSVC_VERSION LESS 1700)
@@ -214,21 +226,22 @@ if(WIN32)
   add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
 endif()
 
+# Does not work, times out every time
+if(WIN32)
+  list(REMOVE_ITEM tests test_many_sockets)
+endif()
+
 foreach(test ${tests})
   # target_sources not supported before CMake 3.1
   if(ZMQ_HAVE_CURVE AND ${test} MATCHES test_security_curve)
-    add_executable(${test} ${test}.cpp
-      "../src/tweetnacl.c"
-      "../src/err.cpp"
-      "../src/random.cpp"
-      "../src/clock.cpp")
+    add_executable(${test} ${test}.cpp "../src/tweetnacl.c" "../src/err.cpp" "../src/random.cpp" "../src/clock.cpp")
   else()
     add_executable(${test} ${test}.cpp)
   endif()
   target_link_libraries(${test} ${TESTUTIL_LIB})
   if(WIN32)
-    # This is the output for Debug dynamic builds on Visual Studio 6.0
-    # You should provide the correct directory, don't know how to do it automatically
+    # This is the output for Debug dynamic builds on Visual Studio 6.0 You should provide the correct directory, don't
+    # know how to do it automatically
     find_path(LIBZMQ_PATH "libzmq.lib" PATHS "../bin/Win32/Debug/v120/dynamic")
     if(NOT ${LIBZMQ_PATH} STREQUAL "LIBZMQ_PATH-NOTFOUND")
       set_target_properties(${test} PROPERTIES LINK_FLAGS "/LIBPATH:${LIBZMQ_PATH}")
@@ -239,7 +252,7 @@ foreach(test ${tests})
       link_directories(${test} PRIVATE "${ZeroMQ_SOURCE_DIR}/../lib")
     endif()
   endif()
-  
+
   if(RT_LIBRARY)
     target_link_libraries(${test} ${RT_LIBRARY})
   endif()
@@ -250,9 +263,12 @@ foreach(test ${tests})
   endif()
 
   if(WIN32)
-    add_test(NAME ${test} WORKING_DIRECTORY ${LIBRARY_OUTPUT_PATH} COMMAND ${test})
+    add_test(
+      NAME ${test}
+      WORKING_DIRECTORY ${LIBRARY_OUTPUT_PATH}
+      COMMAND ${test})
   else()
-    if (${test} MATCHES "_cap_net_admin")
+    if(${test} MATCHES "_cap_net_admin")
       add_test(NAME ${test} COMMAND sh -c "sudo ${CAPSH_PROGRAM} --caps=cap_net_admin+eip -- -c $<TARGET_FILE:${test}>")
     else()
       add_test(NAME ${test} COMMAND ${test})
@@ -262,29 +278,25 @@ foreach(test ${tests})
   set_tests_properties(${test} PROPERTIES SKIP_RETURN_CODE 77)
 endforeach()
 
-#override timeout for these tests
+# override timeout for these tests
 if(ZMQ_HAVE_CURVE)
   set_tests_properties(test_security_curve PROPERTIES TIMEOUT 60)
 endif()
 set_tests_properties(test_heartbeats PROPERTIES TIMEOUT 60)
 
-if(WIN32 AND ${POLLER} MATCHES "epoll")
-  set_tests_properties(test_many_sockets PROPERTIES TIMEOUT 120)
-endif()
-
 if(WIN32 AND ENABLE_DRAFTS)
   set_tests_properties(test_radio_dish PROPERTIES TIMEOUT 30)
 endif()
 
-#add additional required flags
-#ZMQ_USE_TWEETNACL will already be defined when not using sodium
+# add additional required flags ZMQ_USE_TWEETNACL will already be defined when not using sodium
 if(ZMQ_HAVE_CURVE AND NOT ZMQ_USE_TWEETNACL)
   target_compile_definitions(test_security_curve PRIVATE "-DZMQ_USE_TWEETNACL")
 endif()
 
 set_tests_properties(test_security_zap PROPERTIES TIMEOUT 60)
+set_tests_properties(test_reconnect_ivl PROPERTIES TIMEOUT 15)
 
-#Check whether all tests in the current folder are present
+# Check whether all tests in the current folder are present
 file(READ "${CMAKE_CURRENT_LIST_FILE}" CURRENT_LIST_FILE_CONTENT)
 file(GLOB ALL_TEST_SOURCES "test_*.cpp")
 foreach(TEST_SOURCE ${ALL_TEST_SOURCES})
diff -pruN 4.3.2-2/tests/test_abstract_ipc.cpp 4.3.3-1/tests/test_abstract_ipc.cpp
--- 4.3.2-2/tests/test_abstract_ipc.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_abstract_ipc.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -35,6 +35,7 @@
 SETUP_TEARDOWN_TESTCONTEXT
 
 static const char test_endpoint[] = "ipc://@tmp-tester";
+static const char test_endpoint_empty[] = "ipc://@";
 
 void test_roundtrip ()
 {
@@ -56,11 +57,20 @@ void test_roundtrip ()
     test_context_socket_close (sb);
 }
 
+void test_empty_abstract_name ()
+{
+    void *sb = test_context_socket (ZMQ_DEALER);
+    TEST_ASSERT_FAILURE_ERRNO (EINVAL, zmq_bind (sb, test_endpoint_empty));
+
+    test_context_socket_close (sb);
+}
+
 int main (void)
 {
     setup_test_environment ();
 
     UNITY_BEGIN ();
     RUN_TEST (test_roundtrip);
+    RUN_TEST (test_empty_abstract_name);
     return UNITY_END ();
 }
diff -pruN 4.3.2-2/tests/test_app_meta.cpp 4.3.3-1/tests/test_app_meta.cpp
--- 4.3.2-2/tests/test_app_meta.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_app_meta.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -109,7 +109,7 @@ void test_app_meta_reqrep ()
     rc = zmq_msg_init_size (&msg, 1);
     TEST_ASSERT_EQUAL_INT (0, rc);
 
-    char *data = (char *) zmq_msg_data (&msg);
+    char *data = static_cast<char *> (zmq_msg_data (&msg));
     data[0] = 1;
 
     rc = zmq_msg_send (&msg, req_sock, 0);
@@ -123,10 +123,10 @@ void test_app_meta_reqrep ()
 
     TEST_ASSERT_EQUAL_STRING ("hello", zmq_msg_gets (&msg, "X-hello"));
     TEST_ASSERT_EQUAL_STRING ("primary", zmq_msg_gets (&msg, "X-connection"));
-    char *bindata = (char *) zmq_msg_gets (&msg, "X-bin");
+    const char *const bindata = zmq_msg_gets (&msg, "X-bin");
     TEST_ASSERT_NOT_NULL (bindata);
     uint8_t rawdata[4];
-    void *ret = zmq_z85_decode (rawdata, bindata);
+    const uint8_t *const ret = zmq_z85_decode (rawdata, bindata);
     TEST_ASSERT_NOT_NULL (ret);
     TEST_ASSERT_EQUAL_UINT8 (0, rawdata[0]);
     TEST_ASSERT_EQUAL_UINT8 (1, rawdata[1]);
diff -pruN 4.3.2-2/tests/test_base85.cpp 4.3.3-1/tests/test_base85.cpp
--- 4.3.2-2/tests/test_base85.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_base85.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -94,11 +94,12 @@ void test__zmq_z85_encode__zmq_z85_decod
   const uint8_t (&test_data_)[SIZE])
 {
     char test_data_z85[SIZE * 5 / 4 + 1];
-    char *res1 = zmq_z85_encode (test_data_z85, test_data_, SIZE);
+    const char *const res1 = zmq_z85_encode (test_data_z85, test_data_, SIZE);
     TEST_ASSERT_NOT_NULL (res1);
 
     uint8_t test_data_decoded[SIZE];
-    uint8_t *res2 = zmq_z85_decode (test_data_decoded, test_data_z85);
+    const uint8_t *const res2 =
+      zmq_z85_decode (test_data_decoded, test_data_z85);
     TEST_ASSERT_NOT_NULL (res2);
 
     TEST_ASSERT_EQUAL_UINT8_ARRAY (test_data_, test_data_decoded, SIZE);
@@ -111,11 +112,11 @@ void test__zmq_z85_decode__zmq_z85_encod
 {
     const size_t decoded_size = (SIZE - 1) * 4 / 5;
     uint8_t test_data_decoded[decoded_size];
-    uint8_t *res1 = zmq_z85_decode (test_data_decoded, test_data_);
+    const uint8_t *const res1 = zmq_z85_decode (test_data_decoded, test_data_);
     TEST_ASSERT_NOT_NULL (res1);
 
     char test_data_z85[SIZE];
-    char *res2 =
+    const char *const res2 =
       zmq_z85_encode (test_data_z85, test_data_decoded, decoded_size);
     TEST_ASSERT_NOT_NULL (res2);
 
diff -pruN 4.3.2-2/tests/test_bind_curve_fuzzer.cpp 4.3.3-1/tests/test_bind_curve_fuzzer.cpp
--- 4.3.2-2/tests/test_bind_curve_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_bind_curve_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,150 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include <string.h>
+
+#include "testutil.hpp"
+#include "testutil_security.hpp"
+
+// Test that the ZMTP engine handles invalid handshake when binding
+// https://rfc.zeromq.org/spec/37/
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    const char *fixed_client_public =
+      "{{k*81)yMWEF{/BxdMd[5RL^qRFxBgoL<8m.D^KD";
+    const char *fixed_client_secret =
+      "N?Gmik8R[2ACw{b7*[-$S6[4}aO#?DB?#=<OQPc7";
+    const char *fixed_server_public =
+      "3.9-xXwy{g*w72TP*3iB9IJJRxlBH<ufTAvPd2>C";
+    const char *fixed_server_secret =
+      "T}t5GLq%&Qm1)y3ywu-}pY3KEA//{^Ut!M1ut+B4";
+    void *handler;
+    void *zap_thread;
+    void *server;
+    void *server_mon;
+    char my_endpoint[MAX_SOCKET_STRING];
+
+    setup_test_context ();
+    memcpy (valid_client_public, fixed_client_public, 41);
+    setup_context_and_server_side (
+      &handler, &zap_thread, &server, &server_mon, my_endpoint, &zap_handler,
+      &socket_config_curve_server, (void *) fixed_server_secret);
+    fd_t client = connect_socket (my_endpoint);
+
+    //  If there is not enough data for a full greeting, just send what we can
+    //  Otherwise send greeting first, as expected by the protocol
+    uint8_t buf[512];
+    if (size >= 64) {
+        send (client, (void *) data, 64, MSG_NOSIGNAL);
+        data += 64;
+        size -= 64;
+    }
+    recv (client, buf, 64, 0);
+    // Then send HELLO and expect WELCOME if there's enough data
+    if (size >= 202) {
+        send (client, (void *) data, 202, MSG_NOSIGNAL);
+        data += 202;
+        size -= 202;
+        recv (client, buf, 170, MSG_DONTWAIT);
+    }
+    // Then send READY and expect INITIATE if there's enough data
+    if (size >= 301) {
+        send (client, (void *) data, 301, MSG_NOSIGNAL);
+        data += 301;
+        size -= 301;
+        recv (client, buf, 512, MSG_DONTWAIT);
+    }
+    msleep (250);
+    for (ssize_t sent = 0; size > 0 && (sent != -1 || errno == EINTR);
+         size -= sent > 0 ? sent : 0, data += sent > 0 ? sent : 0)
+        sent = send (client, (const char *) data, size, MSG_NOSIGNAL);
+    msleep (250);
+
+    //  Drain the queue, if any
+    zmq_msg_t msg;
+    zmq_msg_init (&msg);
+    while (-1 != zmq_msg_recv (&msg, server, ZMQ_DONTWAIT)) {
+        zmq_msg_close (&msg);
+        zmq_msg_init (&msg);
+    }
+
+    //  A well-behaved client should work while the malformed data from the other
+    //  is being received
+    curve_client_data_t curve_client_data = {
+      fixed_server_public, fixed_client_public, fixed_client_secret};
+    void *client_mon;
+    void *client_good = create_and_connect_client (
+      my_endpoint, socket_config_curve_client, &curve_client_data, &client_mon);
+
+    bounce (server, client_good);
+
+    close (client);
+    test_context_socket_close_zero_linger (client_good);
+    test_context_socket_close_zero_linger (client_mon);
+    shutdown_context_and_server_side (zap_thread, server, server_mon, handler);
+    teardown_test_context ();
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_bind_curve_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_bind_curve_fuzzer_seed_corpus", &data,
+          &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_bind_curve_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_bind_fuzzer.cpp 4.3.3-1/tests/test_bind_fuzzer.cpp
--- 4.3.2-2/tests/test_bind_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_bind_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,96 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include <string>
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+#ifndef PATH_MAX
+#define PATH_MAX 1024
+#endif
+
+// Test that zmq_bind can handle malformed strings
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    //  This test might create socket files, so move to /tmp to avoid clobbering
+    //  the working directory with random filenames
+    char *pwd = (char *) malloc (PATH_MAX + 1);
+    TEST_ASSERT_NOT_NULL (pwd);
+    TEST_ASSERT_NOT_NULL (getcwd (pwd, PATH_MAX + 1));
+    TEST_ASSERT_SUCCESS_ERRNO (chdir ("/tmp"));
+
+    setup_test_context ();
+    std::string my_endpoint (reinterpret_cast<const char *> (data), size);
+    void *socket = test_context_socket (ZMQ_PUB);
+    zmq_bind (socket, my_endpoint.c_str ());
+
+    test_context_socket_close_zero_linger (socket);
+    teardown_test_context ();
+    TEST_ASSERT_SUCCESS_ERRNO (chdir (pwd));
+    free (pwd);
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_bind_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_bind_fuzzer_seed_corpus", &data, &len,
+          &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_bind_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_bind_null_fuzzer.cpp 4.3.3-1/tests/test_bind_null_fuzzer.cpp
--- 4.3.2-2/tests/test_bind_null_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_bind_null_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,113 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+// Test that the ZMTP engine handles invalid handshake when binding
+// https://rfc.zeromq.org/spec/37/
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    setup_test_context ();
+    char my_endpoint[MAX_SOCKET_STRING];
+    void *server = test_context_socket (ZMQ_PUB);
+    //  As per API by default there's no limit to the size of a message,
+    //  but the sanitizer allocator will barf over a gig or so
+    int64_t max_msg_size = 64 * 1024 * 1024;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (server, ZMQ_MAXMSGSIZE, &max_msg_size, sizeof (int64_t)));
+    bind_loopback_ipv4 (server, my_endpoint, sizeof (my_endpoint));
+    fd_t client = connect_socket (my_endpoint);
+
+    void *client_good = test_context_socket (ZMQ_SUB);
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (client_good, ZMQ_SUBSCRIBE, "", 0));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client_good, my_endpoint));
+
+    //  If there is not enough data for a full greeting, just send what we can
+    //  Otherwise send greeting first, as expected by the protocol
+    uint8_t buf[64];
+    if (size >= 64) {
+        send (client, (void *) data, 64, MSG_NOSIGNAL);
+        data += 64;
+        size -= 64;
+    }
+    recv (client, buf, 64, 0);
+    msleep (250);
+    for (ssize_t sent = 0; size > 0 && (sent != -1 || errno == EINTR);
+         size -= sent > 0 ? sent : 0, data += sent > 0 ? sent : 0)
+        sent = send (client, (const char *) data, size, MSG_NOSIGNAL);
+    msleep (250);
+
+    TEST_ASSERT_EQUAL_INT (6, zmq_send_const (server, "HELLO", 6, 0));
+    TEST_ASSERT_EQUAL_INT (6, zmq_recv (client_good, buf, 6, 0));
+
+    close (client);
+    test_context_socket_close_zero_linger (client_good);
+    test_context_socket_close_zero_linger (server);
+    teardown_test_context ();
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_bind_null_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_bind_null_fuzzer_seed_corpus", &data,
+          &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_bind_null_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_bind_stream_fuzzer.cpp 4.3.3-1/tests/test_bind_stream_fuzzer.cpp
--- 4.3.2-2/tests/test_bind_stream_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_bind_stream_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,132 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+// Test that the ZMTP engine handles invalid handshake when binding
+// https://rfc.zeromq.org/spec/37/
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    setup_test_context ();
+    char my_endpoint[MAX_SOCKET_STRING];
+    void *server = test_context_socket (ZMQ_STREAM);
+    //  As per API by default there's no limit to the size of a message,
+    //  but the sanitizer allocator will barf over a gig or so
+    int64_t max_msg_size = 64 * 1024 * 1024;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (server, ZMQ_MAXMSGSIZE, &max_msg_size, sizeof (int64_t)));
+    bind_loopback_ipv4 (server, my_endpoint, sizeof (my_endpoint));
+    fd_t client = connect_socket (my_endpoint);
+
+    //  If there is not enough data for a full greeting, just send what we can
+    //  Otherwise send greeting first, as expected by the protocol
+    uint8_t buf[64];
+    if (size >= 64) {
+        send (client, (void *) data, 64, MSG_NOSIGNAL);
+        data += 64;
+        size -= 64;
+    }
+    recv (client, buf, 64, MSG_DONTWAIT);
+    msleep (250);
+    for (ssize_t sent = 0; size > 0 && (sent != -1 || errno == EINTR);
+         size -= sent > 0 ? sent : 0, data += sent > 0 ? sent : 0)
+        sent = send (client, (const char *) data, size, MSG_NOSIGNAL);
+    msleep (250);
+
+    zmq_msg_t msg;
+    zmq_msg_init (&msg);
+    while (-1 != zmq_msg_recv (&msg, server, ZMQ_DONTWAIT)) {
+        zmq_msg_close (&msg);
+        zmq_msg_init (&msg);
+    }
+
+    void *client_good = test_context_socket (ZMQ_DEALER);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client_good, my_endpoint));
+
+    TEST_ASSERT_EQUAL_INT (6, zmq_send_const (client_good, "HELLO", 6, 0));
+    zmq_msg_t routing_id;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init (&routing_id));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_recv (&routing_id, server, 0));
+    TEST_ASSERT_TRUE (zmq_msg_more (&routing_id));
+    char const *peer_address = zmq_msg_gets (&routing_id, "Peer-Address");
+    zmq_msg_close (&routing_id);
+    TEST_ASSERT_NOT_NULL (peer_address);
+    TEST_ASSERT_EQUAL_STRING ("127.0.0.1", peer_address);
+    TEST_ASSERT_EQUAL_INT (
+      0, TEST_ASSERT_SUCCESS_ERRNO (zmq_recv (server, buf, 64, 0)));
+    zmq_msg_init (&msg);
+    while (-1 != zmq_msg_recv (&msg, server, ZMQ_DONTWAIT)) {
+        zmq_msg_close (&msg);
+        zmq_msg_init (&msg);
+    }
+
+    close (client);
+    test_context_socket_close_zero_linger (client_good);
+    test_context_socket_close_zero_linger (server);
+    teardown_test_context ();
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_bind_stream_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_bind_stream_fuzzer_seed_corpus",
+          &data, &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_bind_stream_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_bind_ws_fuzzer.cpp 4.3.3-1/tests/test_bind_ws_fuzzer.cpp
--- 4.3.2-2/tests/test_bind_ws_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_bind_ws_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,125 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+// Test that the ZMTP WebSocket engine handles invalid handshake when connecting
+// https://rfc.zeromq.org/spec/45/
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    setup_test_context ();
+    char my_endpoint[MAX_SOCKET_STRING];
+    size_t my_endpoint_size = sizeof (my_endpoint);
+    void *server = test_context_socket (ZMQ_DEALER);
+    //  As per API by default there's no limit to the size of a message,
+    //  but the sanitizer allocator will barf over a gig or so
+    int64_t max_msg_size = 64 * 1024 * 1024;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (server, ZMQ_MAXMSGSIZE, &max_msg_size, sizeof (int64_t)));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (server, "ws://127.0.0.1:*"));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_getsockopt (server, ZMQ_LAST_ENDPOINT,
+                                               my_endpoint, &my_endpoint_size));
+    //  Remove trailing /
+    my_endpoint[my_endpoint_size - 2] = '\0';
+    fd_t client = connect_socket (my_endpoint, AF_INET, IPPROTO_WS);
+
+    void *client_good = test_context_socket (ZMQ_DEALER);
+    my_endpoint[my_endpoint_size - 2] = '/';
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client_good, my_endpoint));
+
+    //  If there is not enough data for a full handshake, just send what we can
+    //  Otherwise send websocket handshake first, as expected by the protocol
+    uint8_t buf[256];
+    if (size >= 192) {
+        send (client, (void *) data, 192, MSG_NOSIGNAL);
+        data += 192;
+        size -= 192;
+    }
+    recv (client, buf, 256, MSG_DONTWAIT);
+    msleep (250);
+    for (ssize_t sent = 0; size > 0 && (sent != -1 || errno == EINTR);
+         size -= sent > 0 ? sent : 0, data += sent > 0 ? sent : 0)
+        sent = send (client, (const char *) data, size, MSG_NOSIGNAL);
+    msleep (250);
+    recv (client, buf, 256, MSG_DONTWAIT);
+
+    zmq_msg_t msg;
+    zmq_msg_init (&msg);
+    while (-1 != zmq_msg_recv (&msg, server, ZMQ_DONTWAIT)) {
+        zmq_msg_close (&msg);
+        zmq_msg_init (&msg);
+    }
+
+    send_string_expect_success (client_good, "abc", 0);
+    recv_string_expect_success (server, "abc", 0);
+
+    close (client);
+    test_context_socket_close_zero_linger (client_good);
+    test_context_socket_close_zero_linger (server);
+    teardown_test_context ();
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_bind_ws_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_bind_ws_fuzzer_seed_corpus", &data,
+          &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_bind_ws_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_capabilities.cpp 4.3.3-1/tests/test_capabilities.cpp
--- 4.3.2-2/tests/test_capabilities.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_capabilities.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -40,7 +40,7 @@ void tearDown ()
 
 void test_capabilities ()
 {
-#if !defined(ZMQ_HAVE_WINDOWS) && !defined(ZMQ_HAVE_OPENVMS)
+#if defined(ZMQ_HAVE_IPC)
     TEST_ASSERT_TRUE (zmq_has ("ipc"));
 #else
     TEST_ASSERT_TRUE (!zmq_has ("ipc"));
diff -pruN 4.3.2-2/tests/test_channel.cpp 4.3.3-1/tests/test_channel.cpp
--- 4.3.2-2/tests/test_channel.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_channel.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,81 @@
+/*
+    Copyright (c) 2007-2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+#include <unity.h>
+
+void *sb;
+void *sc;
+
+void setUp ()
+{
+    setup_test_context ();
+
+    sb = test_context_socket (ZMQ_CHANNEL);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (sb, "inproc://a"));
+
+    sc = test_context_socket (ZMQ_CHANNEL);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sc, "inproc://a"));
+}
+
+void tearDown ()
+{
+    test_context_socket_close (sc);
+    test_context_socket_close (sb);
+
+    teardown_test_context ();
+}
+
+void test_roundtrip ()
+{
+    send_string_expect_success (sb, "HELLO", 0);
+    recv_string_expect_success (sc, "HELLO", 0);
+
+    send_string_expect_success (sc, "WORLD", 0);
+    recv_string_expect_success (sb, "WORLD", 0);
+}
+
+void test_sndmore_fails ()
+{
+    int rc = zmq_send (sc, "X", 1, ZMQ_SNDMORE);
+    TEST_ASSERT_EQUAL_INT (-1, rc);
+    TEST_ASSERT_EQUAL_INT (EINVAL, errno);
+}
+
+int main ()
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_roundtrip);
+    RUN_TEST (test_sndmore_fails);
+    return UNITY_END ();
+}
diff -pruN 4.3.2-2/tests/test_client_server.cpp 4.3.3-1/tests/test_client_server.cpp
--- 4.3.2-2/tests/test_client_server.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_client_server.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -97,7 +97,7 @@ void test_routing_id ()
         zmq_msg_t msg;
         TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_size (&msg, 1));
 
-        char *data = (char *) zmq_msg_data (&msg);
+        char *data = static_cast<char *> (zmq_msg_data (&msg));
         data[0] = 2;
 
         TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_set_routing_id (&msg, routing_id));
diff -pruN 4.3.2-2/tests/test_connect_curve_fuzzer.cpp 4.3.3-1/tests/test_connect_curve_fuzzer.cpp
--- 4.3.2-2/tests/test_connect_curve_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_connect_curve_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,139 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include "testutil.hpp"
+#include "testutil_security.hpp"
+
+// Test that the ZMTP engine handles invalid handshake when connecting
+// https://rfc.zeromq.org/spec/37/
+// https://rfc.zeromq.org/spec/26/
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    const char *fixed_client_public =
+      "{{k*81)yMWEF{/BxdMd[5RL^qRFxBgoL<8m.D^KD";
+    const char *fixed_client_secret =
+      "N?Gmik8R[2ACw{b7*[-$S6[4}aO#?DB?#=<OQPc7";
+    const char *fixed_server_public =
+      "3.9-xXwy{g*w72TP*3iB9IJJRxlBH<ufTAvPd2>C";
+
+    setup_test_context ();
+    char my_endpoint[MAX_SOCKET_STRING];
+    fd_t server = bind_socket_resolve_port ("127.0.0.1", "0", my_endpoint);
+
+    curve_client_data_t curve_client_data = {
+      fixed_server_public, fixed_client_public, fixed_client_secret};
+    void *client_mon;
+    void *client = create_and_connect_client (
+      my_endpoint, socket_config_curve_client, &curve_client_data, &client_mon);
+
+    fd_t server_accept =
+      TEST_ASSERT_SUCCESS_RAW_ERRNO (accept (server, NULL, NULL));
+
+    //  If there is not enough data for a full greeting, just send what we can
+    //  Otherwise send greeting first, as expected by the protocol
+    uint8_t buf[512];
+    if (size >= 64) {
+        send (server_accept, (void *) data, 64, MSG_NOSIGNAL);
+        data += 64;
+        size -= 64;
+    }
+    recv (server_accept, buf, 64, 0);
+    // Then expect HELLO and send WELCOME if there's enough data
+    if (size >= 170) {
+        recv (server_accept, buf, 202, 0);
+        send (server_accept, (void *) data, 170, MSG_NOSIGNAL);
+        data += 170;
+        size -= 170;
+    }
+    // Then expect INITIATE and send READY if there's enough data
+    if (size >= 72) {
+        recv (server_accept, buf, 512, 0);
+        send (server_accept, (void *) data, 72, MSG_NOSIGNAL);
+        data += 72;
+        size -= 72;
+    }
+    msleep (250);
+    for (ssize_t sent = 0; size > 0 && (sent != -1 || errno == EINTR);
+         size -= sent > 0 ? sent : 0, data += sent > 0 ? sent : 0)
+        sent = send (server_accept, (const char *) data, size, MSG_NOSIGNAL);
+    recv (server_accept, buf, 512, MSG_DONTWAIT);
+    msleep (250);
+
+    zmq_msg_t msg;
+    zmq_msg_init (&msg);
+    while (-1 != zmq_msg_recv (&msg, client, ZMQ_DONTWAIT)) {
+        zmq_msg_close (&msg);
+        zmq_msg_init (&msg);
+    }
+
+    close (server_accept);
+    close (server);
+
+    test_context_socket_close_zero_linger (client);
+    test_context_socket_close_zero_linger (client_mon);
+    teardown_test_context ();
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_connect_curve_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_connect_curve_fuzzer_seed_corpus",
+          &data, &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_connect_curve_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_connect_fuzzer.cpp 4.3.3-1/tests/test_connect_fuzzer.cpp
--- 4.3.2-2/tests/test_connect_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_connect_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,83 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include <string>
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+// Test that zmq_connect can handle malformed strings
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    setup_test_context ();
+    std::string my_endpoint (reinterpret_cast<const char *> (data), size);
+    void *socket = test_context_socket (ZMQ_PUB);
+    zmq_connect (socket, my_endpoint.c_str ());
+
+    test_context_socket_close_zero_linger (socket);
+    teardown_test_context ();
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_connect_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_connect_fuzzer_seed_corpus", &data,
+          &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_connect_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_connect_null_fuzzer.cpp 4.3.3-1/tests/test_connect_null_fuzzer.cpp
--- 4.3.2-2/tests/test_connect_null_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_connect_null_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,118 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+// Test that the ZMTP engine handles invalid handshake when connecting
+// https://rfc.zeromq.org/spec/37/
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    setup_test_context ();
+    char my_endpoint[MAX_SOCKET_STRING];
+    fd_t server = bind_socket_resolve_port ("127.0.0.1", "0", my_endpoint);
+
+    void *client = test_context_socket (ZMQ_SUB);
+    //  As per API by default there's no limit to the size of a message,
+    //  but the sanitizer allocator will barf over a gig or so
+    int64_t max_msg_size = 64 * 1024 * 1024;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (client, ZMQ_MAXMSGSIZE, &max_msg_size, sizeof (int64_t)));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (client, ZMQ_SUBSCRIBE, "", 0));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client, my_endpoint));
+
+    fd_t server_accept =
+      TEST_ASSERT_SUCCESS_RAW_ERRNO (accept (server, NULL, NULL));
+
+    //  If there is not enough data for a full greeting, just send what we can
+    //  Otherwise send greeting first, as expected by the protocol
+    uint8_t buf[64];
+    if (size >= 64) {
+        send (server_accept, (void *) data, 64, MSG_NOSIGNAL);
+        data += 64;
+        size -= 64;
+    }
+    recv (server_accept, buf, 64, 0);
+    msleep (250);
+    for (ssize_t sent = 0; size > 0 && (sent != -1 || errno == EINTR);
+         size -= sent > 0 ? sent : 0, data += sent > 0 ? sent : 0)
+        sent = send (server_accept, (const char *) data, size, MSG_NOSIGNAL);
+    msleep (250);
+
+    zmq_msg_t msg;
+    zmq_msg_init (&msg);
+    while (-1 != zmq_msg_recv (&msg, client, ZMQ_DONTWAIT)) {
+        zmq_msg_close (&msg);
+        zmq_msg_init (&msg);
+    }
+
+    close (server_accept);
+    close (server);
+
+    test_context_socket_close_zero_linger (client);
+    teardown_test_context ();
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_connect_null_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_connect_null_fuzzer_seed_corpus",
+          &data, &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_connect_null_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_connect_stream_fuzzer.cpp 4.3.3-1/tests/test_connect_stream_fuzzer.cpp
--- 4.3.2-2/tests/test_connect_stream_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_connect_stream_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,117 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+// Test that the ZMTP engine handles invalid handshake when connecting
+// https://rfc.zeromq.org/spec/37/
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    setup_test_context ();
+    char my_endpoint[MAX_SOCKET_STRING];
+    fd_t server = bind_socket_resolve_port ("127.0.0.1", "0", my_endpoint);
+
+    void *client = test_context_socket (ZMQ_STREAM);
+    //  As per API by default there's no limit to the size of a message,
+    //  but the sanitizer allocator will barf over a gig or so
+    int64_t max_msg_size = 64 * 1024 * 1024;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (client, ZMQ_MAXMSGSIZE, &max_msg_size, sizeof (int64_t)));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client, my_endpoint));
+
+    fd_t server_accept =
+      TEST_ASSERT_SUCCESS_RAW_ERRNO (accept (server, NULL, NULL));
+
+    //  If there is not enough data for a full greeting, just send what we can
+    //  Otherwise send greeting first, as expected by the protocol
+    uint8_t buf[64];
+    if (size >= 64) {
+        send (server_accept, (void *) data, 64, MSG_NOSIGNAL);
+        data += 64;
+        size -= 64;
+    }
+    recv (server_accept, buf, 64, MSG_DONTWAIT);
+    msleep (250);
+    for (ssize_t sent = 0; size > 0 && (sent != -1 || errno == EINTR);
+         size -= sent > 0 ? sent : 0, data += sent > 0 ? sent : 0)
+        sent = send (server_accept, (const char *) data, size, MSG_NOSIGNAL);
+    msleep (250);
+
+    zmq_msg_t msg;
+    zmq_msg_init (&msg);
+    while (-1 != zmq_msg_recv (&msg, client, ZMQ_DONTWAIT)) {
+        zmq_msg_close (&msg);
+        zmq_msg_init (&msg);
+    }
+
+    close (server_accept);
+    close (server);
+
+    test_context_socket_close_zero_linger (client);
+    teardown_test_context ();
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_connect_null_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_connect_null_fuzzer_seed_corpus",
+          &data, &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_connect_null_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_connect_ws_fuzzer.cpp 4.3.3-1/tests/test_connect_ws_fuzzer.cpp
--- 4.3.2-2/tests/test_connect_ws_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_connect_ws_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,125 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+// Test that the ZMTP WebSocket engine handles invalid handshake when connecting
+// https://rfc.zeromq.org/spec/45/
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    setup_test_context ();
+    char my_endpoint[MAX_SOCKET_STRING];
+    fd_t server = bind_socket_resolve_port ("127.0.0.1", "0", my_endpoint,
+                                            AF_INET, IPPROTO_WS);
+
+    void *client = test_context_socket (ZMQ_PULL);
+    //  As per API by default there's no limit to the size of a message,
+    //  but the sanitizer allocator will barf over a gig or so
+    int64_t max_msg_size = 64 * 1024 * 1024;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (client, ZMQ_MAXMSGSIZE, &max_msg_size, sizeof (int64_t)));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client, my_endpoint));
+
+    fd_t server_accept =
+      TEST_ASSERT_SUCCESS_RAW_ERRNO (accept (server, NULL, NULL));
+
+    //  If there is not enough data for a full handshake, just send what we can
+    //  Otherwise send websocket handshake first, as expected by the protocol
+    uint8_t buf[256];
+    recv (server_accept, buf, 256, 0);
+    if (size >= 166) {
+        send (server_accept, (void *) data, 166, MSG_NOSIGNAL);
+        data += 166;
+        size -= 166;
+    }
+    recv (server_accept, buf, 256, MSG_DONTWAIT);
+    //  Then send the READY command
+    if (size >= 29) {
+        send (server_accept, (void *) data, 29, MSG_NOSIGNAL);
+        data += 29;
+        size -= 29;
+    }
+    msleep (250);
+    for (ssize_t sent = 0; size > 0 && (sent != -1 || errno == EINTR);
+         size -= sent > 0 ? sent : 0, data += sent > 0 ? sent : 0)
+        sent = send (server_accept, (const char *) data, size, MSG_NOSIGNAL);
+    msleep (250);
+
+    zmq_msg_t msg;
+    zmq_msg_init (&msg);
+    while (-1 != zmq_msg_recv (&msg, client, ZMQ_DONTWAIT)) {
+        zmq_msg_close (&msg);
+        zmq_msg_init (&msg);
+    }
+
+    close (server_accept);
+    close (server);
+
+    test_context_socket_close_zero_linger (client);
+    teardown_test_context ();
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_connect_ws_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_connect_ws_fuzzer_seed_corpus", &data,
+          &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_connect_ws_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_ctx_destroy.cpp 4.3.3-1/tests/test_ctx_destroy.cpp
--- 4.3.2-2/tests/test_ctx_destroy.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_ctx_destroy.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -88,7 +88,46 @@ void test_ctx_shutdown ()
     // Close the socket.
     TEST_ASSERT_SUCCESS_ERRNO (zmq_close (socket));
 
-    // Destory the context, will now not hang as we have closed the socket.
+    // Destroy the context, will now not hang as we have closed the socket.
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_ctx_destroy (ctx));
+}
+
+void test_ctx_shutdown_socket_opened_after ()
+{
+    //  Set up our context.
+    void *ctx = zmq_ctx_new ();
+    TEST_ASSERT_NOT_NULL (ctx);
+
+    // Open a socket to start context, and close it immediately again.
+    void *socket = zmq_socket (ctx, ZMQ_PULL);
+    TEST_ASSERT_NOT_NULL (socket);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_close (socket));
+
+    // Shutdown context.
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_ctx_shutdown (ctx));
+
+    // Opening socket should now fail.
+    TEST_ASSERT_NULL (zmq_socket (ctx, ZMQ_PULL));
+    TEST_ASSERT_FAILURE_ERRNO (ETERM, -1);
+
+    // Destroy the context.
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_ctx_destroy (ctx));
+}
+
+void test_ctx_shutdown_only_socket_opened_after ()
+{
+    //  Set up our context.
+    void *ctx = zmq_ctx_new ();
+    TEST_ASSERT_NOT_NULL (ctx);
+
+    // Shutdown context.
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_ctx_shutdown (ctx));
+
+    // Opening socket should now fail.
+    TEST_ASSERT_NULL (zmq_socket (ctx, ZMQ_PULL));
+    TEST_ASSERT_FAILURE_ERRNO (ETERM, -1);
+
+    // Destroy the context.
     TEST_ASSERT_SUCCESS_ERRNO (zmq_ctx_destroy (ctx));
 }
 
@@ -123,8 +162,8 @@ struct poller_test_data_t
 
 void run_poller (void *data_)
 {
-    struct poller_test_data_t *poller_test_data =
-      (struct poller_test_data_t *) data_;
+    const poller_test_data_t *const poller_test_data =
+      static_cast<const poller_test_data_t *> (data_);
 
     void *socket =
       zmq_socket (poller_test_data->ctx, poller_test_data->socket_type);
@@ -201,6 +240,8 @@ int main (void)
     UNITY_BEGIN ();
     RUN_TEST (test_ctx_destroy);
     RUN_TEST (test_ctx_shutdown);
+    RUN_TEST (test_ctx_shutdown_socket_opened_after);
+    RUN_TEST (test_ctx_shutdown_only_socket_opened_after);
     RUN_TEST (test_zmq_ctx_term_null_fails);
     RUN_TEST (test_zmq_term_null_fails);
     RUN_TEST (test_zmq_ctx_shutdown_null_fails);
diff -pruN 4.3.2-2/tests/test_ctx_options.cpp 4.3.3-1/tests/test_ctx_options.cpp
--- 4.3.2-2/tests/test_ctx_options.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_ctx_options.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -116,7 +116,6 @@ void test_ctx_thread_opts ()
     }
 
 
-#ifdef ZMQ_THREAD_AFFINITY_CPU_ADD
     // test affinity:
 
     // this should result in background threads being placed only on the
@@ -138,16 +137,28 @@ void test_ctx_thread_opts ()
                                                 ZMQ_THREAD_AFFINITY_CPU_REMOVE,
                                                 cpus_remove[idx]));
     }
-#endif
 
 
-#ifdef ZMQ_THREAD_NAME_PREFIX
-    // test thread name prefix:
+    // test INTEGER thread name prefix:
 
     TEST_ASSERT_SUCCESS_ERRNO (
       zmq_ctx_set (get_test_context (), ZMQ_THREAD_NAME_PREFIX, 1234));
     TEST_ASSERT_EQUAL_INT (
       1234, zmq_ctx_get (get_test_context (), ZMQ_THREAD_NAME_PREFIX));
+
+#ifdef ZMQ_BUILD_DRAFT_API
+    // test STRING thread name prefix:
+
+    const char prefix[] = "MyPrefix9012345"; // max len is 16 chars
+
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_ctx_set_ext (get_test_context (), ZMQ_THREAD_NAME_PREFIX, prefix,
+                       sizeof (prefix) / sizeof (char)));
+
+    char buf[16];
+    size_t buflen = sizeof (buf) / sizeof (char);
+    zmq_ctx_get_ext (get_test_context (), ZMQ_THREAD_NAME_PREFIX, buf, &buflen);
+    TEST_ASSERT_EQUAL_STRING (prefix, buf);
 #endif
 }
 
diff -pruN 4.3.2-2/tests/test_disconnect_inproc.cpp 4.3.3-1/tests/test_disconnect_inproc.cpp
--- 4.3.2-2/tests/test_disconnect_inproc.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_disconnect_inproc.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -68,7 +68,8 @@ void test_disconnect_inproc ()
                 zmq_msg_t msg;
                 zmq_msg_init (&msg);
                 TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_recv (&msg, pub_socket, 0));
-                char *buffer = (char *) zmq_msg_data (&msg);
+                const char *const buffer =
+                  static_cast<const char *> (zmq_msg_data (&msg));
 
                 if (buffer[0] == 0) {
                     TEST_ASSERT_TRUE (isSubscribed);
diff -pruN 4.3.2-2/tests/test_disconnect_msg.cpp 4.3.3-1/tests/test_disconnect_msg.cpp
--- 4.3.2-2/tests/test_disconnect_msg.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_disconnect_msg.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,118 @@
+/*
+    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+SETUP_TEARDOWN_TESTCONTEXT
+
+void test (const char *address)
+{
+    //  Create a server
+    void *server = test_context_socket (ZMQ_SERVER);
+
+    //  set server socket options
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (server, ZMQ_DISCONNECT_MSG, "D", 1));
+
+    //  bind server
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (server, address));
+
+    //  Create a client
+    void *client = test_context_socket (ZMQ_CLIENT);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (client, ZMQ_HELLO_MSG, "H", 1));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client, address));
+
+    // Receive the hello message from client
+    recv_string_expect_success (server, "H", 0);
+
+    // Kill the client
+    test_context_socket_close (client);
+
+    // Receive the disconnect message
+    recv_string_expect_success (server, "D", 0);
+
+    //  Clean up.
+    test_context_socket_close (server);
+}
+
+void test_tcp ()
+{
+    test ("tcp://127.0.0.1:5569");
+}
+
+void test_inproc ()
+{
+    test ("inproc://disconnect-msg");
+}
+
+
+void test_inproc_disconnect ()
+{
+    const char *address = "inproc://disconnect-msg";
+
+    //  Create a server
+    void *server = test_context_socket (ZMQ_SERVER);
+
+    //  set server socket options
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (server, ZMQ_DISCONNECT_MSG, "D", 1));
+
+    //  bind server
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (server, address));
+
+    //  Create a client
+    void *client = test_context_socket (ZMQ_CLIENT);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (client, ZMQ_HELLO_MSG, "H", 1));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client, address));
+
+    // Receive the hello message from client
+    recv_string_expect_success (server, "H", 0);
+
+    // disconnect the client
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_disconnect (client, address));
+
+    // Receive the disconnect message
+    recv_string_expect_success (server, "D", 0);
+
+    //  Clean up.
+    test_context_socket_close (client);
+    test_context_socket_close (server);
+}
+
+int main ()
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_tcp);
+    RUN_TEST (test_inproc);
+    RUN_TEST (test_inproc_disconnect);
+    return UNITY_END ();
+}
diff -pruN 4.3.2-2/tests/test_heartbeats.cpp 4.3.3-1/tests/test_heartbeats.cpp
--- 4.3.2-2/tests/test_heartbeats.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_heartbeats.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -50,7 +50,7 @@ SETUP_TEARDOWN_TESTCONTEXT
 
 static int get_monitor_event (void *monitor_)
 {
-    for (int i = 0; i < 2; i++) {
+    for (int i = 0; i < 10; i++) {
         //  First frame in message contains event number and value
         zmq_msg_t msg;
         TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init (&msg));
@@ -60,8 +60,8 @@ static int get_monitor_event (void *moni
         }
         TEST_ASSERT_TRUE (zmq_msg_more (&msg));
 
-        uint8_t *data = (uint8_t *) zmq_msg_data (&msg);
-        uint16_t event = *(uint16_t *) (data);
+        uint8_t *data = static_cast<uint8_t *> (zmq_msg_data (&msg));
+        uint16_t event = *reinterpret_cast<uint16_t *> (data);
 
         //  Second frame in message contains event address
         TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init (&msg));
@@ -91,29 +91,24 @@ static void recv_with_retry (raw_socket
 
 static void mock_handshake (raw_socket fd_, int mock_ping_)
 {
-    const uint8_t zmtp_greeting[33] = {0xff, 0, 0, 0,   0,   0,   0,   0, 0,
-                                       0x7f, 3, 0, 'N', 'U', 'L', 'L', 0};
     char buffer[128];
     memset (buffer, 0, sizeof (buffer));
-    memcpy (buffer, zmtp_greeting, sizeof (zmtp_greeting));
+    memcpy (buffer, zmtp_greeting_null, sizeof (zmtp_greeting_null));
 
-    int rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (send (fd_, buffer, 64, 0));
-    TEST_ASSERT_EQUAL_INT (64, rc);
+    int rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (
+      send (fd_, buffer, sizeof (zmtp_greeting_null), 0));
+    TEST_ASSERT_EQUAL_INT (sizeof (zmtp_greeting_null), rc);
 
-    recv_with_retry (fd_, buffer, 64);
-
-    const uint8_t zmtp_ready[43] = {
-      4,   41,  5,   'R', 'E', 'A', 'D', 'Y', 11,  'S', 'o', 'c', 'k', 'e', 't',
-      '-', 'T', 'y', 'p', 'e', 0,   0,   0,   6,   'D', 'E', 'A', 'L', 'E', 'R',
-      8,   'I', 'd', 'e', 'n', 't', 'i', 't', 'y', 0,   0,   0,   0};
+    recv_with_retry (fd_, buffer, sizeof (zmtp_greeting_null));
 
     memset (buffer, 0, sizeof (buffer));
-    memcpy (buffer, zmtp_ready, 43);
-    rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (send (fd_, buffer, 43, 0));
-    TEST_ASSERT_EQUAL_INT (43, rc);
+    memcpy (buffer, zmtp_ready_dealer, sizeof (zmtp_ready_dealer));
+    rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (
+      send (fd_, buffer, sizeof (zmtp_ready_dealer), 0));
+    TEST_ASSERT_EQUAL_INT (sizeof (zmtp_ready_dealer), rc);
 
     //  greeting
-    recv_with_retry (fd_, buffer, 43);
+    recv_with_retry (fd_, buffer, sizeof (zmtp_ready_dealer));
 
     if (mock_ping_) {
         //  test PING context - should be replicated in the PONG
@@ -226,21 +221,7 @@ static void test_heartbeat_timeout (int
     prep_server_socket (!mock_ping_, 0, &server, &server_mon, my_endpoint,
                         MAX_SOCKET_STRING, server_type_);
 
-    struct sockaddr_in ip4addr;
-    raw_socket s;
-
-    ip4addr.sin_family = AF_INET;
-    ip4addr.sin_port = htons (atoi (strrchr (my_endpoint, ':') + 1));
-#if defined(ZMQ_HAVE_WINDOWS) && (_WIN32_WINNT < 0x0600)
-    ip4addr.sin_addr.s_addr = inet_addr ("127.0.0.1");
-#else
-    inet_pton (AF_INET, "127.0.0.1", &ip4addr.sin_addr);
-#endif
-
-    s = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);
-    rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (
-      connect (s, (struct sockaddr *) &ip4addr, sizeof ip4addr));
-    TEST_ASSERT_GREATER_THAN_INT (-1, rc);
+    fd_t s = connect_socket (my_endpoint);
 
     // Mock a ZMTP 3 client so we can forcibly time out a connection
     mock_handshake (s, mock_ping_);
@@ -417,7 +398,9 @@ void test_setsockopt_heartbeat_ttl_near_
 
 int main (void)
 {
-    setup_test_environment ();
+    //  The test cases are very long-running. The default timeout of 60 seconds
+    //  is not always enough.
+    setup_test_environment (90);
 
     UNITY_BEGIN ();
 
diff -pruN 4.3.2-2/tests/test_hello_msg.cpp 4.3.3-1/tests/test_hello_msg.cpp
--- 4.3.2-2/tests/test_hello_msg.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_hello_msg.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,107 @@
+/*
+    Copyright (c) 2007-2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+SETUP_TEARDOWN_TESTCONTEXT
+
+void test (const char *address)
+{
+    //  Create a router
+    void *router = test_context_socket (ZMQ_ROUTER);
+    char my_endpoint[MAX_SOCKET_STRING];
+
+    //  set router socket options
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (router, ZMQ_HELLO_MSG, "H", 1));
+
+    //  bind router
+    test_bind (router, address, my_endpoint, MAX_SOCKET_STRING);
+
+    //  Create a dealer
+    void *dealer = test_context_socket (ZMQ_DEALER);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (dealer, my_endpoint));
+
+    // Receive the hello message
+    recv_string_expect_success (dealer, "H", 0);
+
+    //  Clean up.
+    test_context_socket_close (dealer);
+    test_context_socket_close (router);
+}
+
+void test_tcp ()
+{
+    test ("tcp://127.0.0.1:*");
+}
+
+void test_inproc ()
+{
+    test ("inproc://hello-msg");
+}
+
+void test_inproc_late_bind ()
+{
+    char address[] = "inproc://late-hello-msg";
+
+    //  Create a server
+    void *server = test_context_socket (ZMQ_SERVER);
+
+    //  set server socket options
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (server, ZMQ_HELLO_MSG, "W", 1));
+
+    //  Create a dealer
+    void *client = test_context_socket (ZMQ_CLIENT);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (client, ZMQ_HELLO_MSG, "H", 1));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client, address));
+
+    //  bind server after the dealer
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (server, address));
+
+    // Receive the welcome message from server
+    recv_string_expect_success (client, "W", 0);
+
+    // Receive the hello message from client
+    recv_string_expect_success (server, "H", 0);
+
+    //  Clean up.
+    test_context_socket_close (client);
+    test_context_socket_close (server);
+}
+
+int main ()
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_tcp);
+    RUN_TEST (test_inproc);
+    RUN_TEST (test_inproc_late_bind);
+    return UNITY_END ();
+}
diff -pruN 4.3.2-2/tests/test_hwm_pubsub.cpp 4.3.3-1/tests/test_hwm_pubsub.cpp
--- 4.3.2-2/tests/test_hwm_pubsub.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_hwm_pubsub.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -38,13 +38,13 @@
 
 SETUP_TEARDOWN_TESTCONTEXT
 
-int test_defaults (int send_hwm_, int msg_cnt_, const char *endpoint)
+int test_defaults (int send_hwm_, int msg_cnt_, const char *endpoint_)
 {
     char pub_endpoint[SOCKET_STRING_LEN];
 
     // Set up and bind XPUB socket
     void *pub_socket = test_context_socket (ZMQ_XPUB);
-    test_bind (pub_socket, endpoint, pub_endpoint, sizeof pub_endpoint);
+    test_bind (pub_socket, endpoint_, pub_endpoint, sizeof pub_endpoint);
 
     // Set up and connect SUB socket
     void *sub_socket = test_context_socket (ZMQ_SUB);
@@ -86,10 +86,10 @@ int test_defaults (int send_hwm_, int ms
     return recv_count;
 }
 
-int receive (void *socket_, int *is_termination)
+int receive (void *socket_, int *is_termination_)
 {
     int recv_count = 0;
-    *is_termination = 0;
+    *is_termination_ = 0;
 
     // Now receive all sent messages
     char buffer[255];
@@ -98,7 +98,7 @@ int receive (void *socket_, int *is_term
         ++recv_count;
 
         if (len == 3 && strncmp (buffer, "end", len) == 0) {
-            *is_termination = 1;
+            *is_termination_ = 1;
             return recv_count;
         }
     }
@@ -106,13 +106,13 @@ int receive (void *socket_, int *is_term
     return recv_count;
 }
 
-int test_blocking (int send_hwm_, int msg_cnt_, const char *endpoint)
+int test_blocking (int send_hwm_, int msg_cnt_, const char *endpoint_)
 {
     char pub_endpoint[SOCKET_STRING_LEN];
 
     // Set up bind socket
     void *pub_socket = test_context_socket (ZMQ_XPUB);
-    test_bind (pub_socket, endpoint, pub_endpoint, sizeof pub_endpoint);
+    test_bind (pub_socket, endpoint_, pub_endpoint, sizeof pub_endpoint);
 
     // Set up connect socket
     void *sub_socket = test_context_socket (ZMQ_SUB);
diff -pruN 4.3.2-2/tests/test_inproc_connect.cpp 4.3.3-1/tests/test_inproc_connect.cpp
--- 4.3.2-2/tests/test_inproc_connect.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_inproc_connect.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -236,10 +236,8 @@ void test_simultaneous_connect_bind_thre
 
     // Spawn all threads as simultaneously as possible
     for (unsigned int i = 0; i < no_of_times; ++i) {
-        threads[i * 2 + 0] =
-          zmq_threadstart (&simult_conn, (void *) thr_args[i]);
-        threads[i * 2 + 1] =
-          zmq_threadstart (&simult_bind, (void *) thr_args[i]);
+        threads[i * 2 + 0] = zmq_threadstart (&simult_conn, thr_args[i]);
+        threads[i * 2 + 1] = zmq_threadstart (&simult_bind, thr_args[i]);
     }
 
     // Close all threads
diff -pruN 4.3.2-2/tests/test_many_sockets.cpp 4.3.3-1/tests/test_many_sockets.cpp
--- 4.3.2-2/tests/test_many_sockets.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_many_sockets.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -56,8 +56,7 @@ void test_system_max ()
 
     //  System is out of resources, further calls to zmq_socket should return NULL
     for (unsigned int i = 0; i < 10; ++i) {
-        void *socket = zmq_socket (get_test_context (), ZMQ_PAIR);
-        TEST_ASSERT_NULL (socket);
+        TEST_ASSERT_NULL (zmq_socket (get_test_context (), ZMQ_PAIR));
     }
     // Clean up.
     for (unsigned int i = 0; i < sockets.size (); ++i)
@@ -80,8 +79,7 @@ void test_zmq_default_max ()
 
     //  Further calls to zmq_socket should return NULL
     for (unsigned int i = 0; i < 10; ++i) {
-        void *socket = zmq_socket (get_test_context (), ZMQ_PAIR);
-        TEST_ASSERT_NULL (socket);
+        TEST_ASSERT_NULL (zmq_socket (get_test_context (), ZMQ_PAIR));
     }
 
     //  Clean up
diff -pruN 4.3.2-2/tests/test_mock_pub_sub.cpp 4.3.3-1/tests/test_mock_pub_sub.cpp
--- 4.3.2-2/tests/test_mock_pub_sub.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_mock_pub_sub.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -19,17 +19,6 @@
 
 #include "testutil.hpp"
 #include "testutil_unity.hpp"
-#if defined(ZMQ_HAVE_WINDOWS)
-#include <winsock2.h>
-#include <ws2tcpip.h>
-#include <stdexcept>
-#define close closesocket
-typedef SOCKET raw_socket;
-#else
-#include <arpa/inet.h>
-#include <unistd.h>
-typedef int raw_socket;
-#endif
 
 #include <stdlib.h>
 #include <string.h>
@@ -52,8 +41,8 @@ static int get_monitor_event (void *moni
         }
         TEST_ASSERT_TRUE (zmq_msg_more (&msg));
 
-        uint8_t *data = (uint8_t *) zmq_msg_data (&msg);
-        uint16_t event = *(uint16_t *) (data);
+        uint8_t *data = static_cast<uint8_t *> (zmq_msg_data (&msg));
+        uint16_t event = *reinterpret_cast<uint16_t *> (data);
 
         //  Second frame in message contains event address
         TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init (&msg));
@@ -67,7 +56,7 @@ static int get_monitor_event (void *moni
     return -1;
 }
 
-static void recv_with_retry (raw_socket fd_, char *buffer_, int bytes_)
+static void recv_with_retry (fd_t fd_, char *buffer_, int bytes_)
 {
     int received = 0;
     while (true) {
@@ -81,39 +70,46 @@ static void recv_with_retry (raw_socket
     }
 }
 
-static void mock_handshake (raw_socket fd_)
+static void mock_handshake (fd_t fd_, bool sub_command, bool mock_pub)
 {
-    const uint8_t zmtp_greeting[33] = {0xff, 0, 0, 0,   0,   0,   0,   0, 0,
-                                       0x7f, 3, 0, 'N', 'U', 'L', 'L', 0};
     char buffer[128];
     memset (buffer, 0, sizeof (buffer));
-    memcpy (buffer, zmtp_greeting, sizeof (zmtp_greeting));
+    memcpy (buffer, zmtp_greeting_null, sizeof (zmtp_greeting_null));
 
+    //  Mock ZMTP 3.1 which uses commands
+    if (sub_command) {
+        buffer[11] = 1;
+    }
     int rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (send (fd_, buffer, 64, 0));
     TEST_ASSERT_EQUAL_INT (64, rc);
 
     recv_with_retry (fd_, buffer, 64);
 
-    const uint8_t zmtp_ready[27] = {
-      4,   25,  5,   'R', 'E', 'A', 'D', 'Y', 11, 'S', 'o', 'c', 'k', 'e',
-      't', '-', 'T', 'y', 'p', 'e', 0,   0,   0,  3,   'S', 'U', 'B'};
+    if (!mock_pub) {
+        rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (send (
+          fd_, (const char *) zmtp_ready_sub, sizeof (zmtp_ready_sub), 0));
+        TEST_ASSERT_EQUAL_INT (sizeof (zmtp_ready_sub), rc);
+    } else {
+        rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (send (
+          fd_, (const char *) zmtp_ready_xpub, sizeof (zmtp_ready_xpub), 0));
+        TEST_ASSERT_EQUAL_INT (sizeof (zmtp_ready_xpub), rc);
+    }
 
+    //  greeting - XPUB has one extra byte
     memset (buffer, 0, sizeof (buffer));
-    memcpy (buffer, zmtp_ready, 27);
-    rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (send (fd_, buffer, 27, 0));
-    TEST_ASSERT_EQUAL_INT (27, rc);
-
-    //  greeting - XPUB so one extra byte
-    recv_with_retry (fd_, buffer, 28);
+    recv_with_retry (fd_, buffer,
+                     mock_pub ? sizeof (zmtp_ready_sub)
+                              : sizeof (zmtp_ready_xpub));
 }
 
 static void prep_server_socket (void **server_out_,
                                 void **mon_out_,
                                 char *endpoint_,
-                                size_t ep_length_)
+                                size_t ep_length_,
+                                int socket_type)
 {
     //  We'll be using this socket in raw mode
-    void *server = test_context_socket (ZMQ_XPUB);
+    void *server = test_context_socket (socket_type);
 
     int value = 0;
     TEST_ASSERT_SUCCESS_ERRNO (
@@ -136,61 +132,76 @@ static void prep_server_socket (void **s
     *mon_out_ = server_mon;
 }
 
-static void test_mock_sub (bool sub_command)
+static void test_mock_pub_sub (bool sub_command_, bool mock_pub_)
 {
     int rc;
     char my_endpoint[MAX_SOCKET_STRING];
 
     void *server, *server_mon;
-    prep_server_socket (&server, &server_mon, my_endpoint, MAX_SOCKET_STRING);
-
-    struct sockaddr_in ip4addr;
-    raw_socket s;
+    prep_server_socket (&server, &server_mon, my_endpoint, MAX_SOCKET_STRING,
+                        mock_pub_ ? ZMQ_SUB : ZMQ_XPUB);
 
-    ip4addr.sin_family = AF_INET;
-    ip4addr.sin_port = htons (atoi (strrchr (my_endpoint, ':') + 1));
-#if defined(ZMQ_HAVE_WINDOWS) && (_WIN32_WINNT < 0x0600)
-    ip4addr.sin_addr.s_addr = inet_addr ("127.0.0.1");
-#else
-    inet_pton (AF_INET, "127.0.0.1", &ip4addr.sin_addr);
-#endif
-
-    s = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);
-    rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (
-      connect (s, (struct sockaddr *) &ip4addr, sizeof ip4addr));
-    TEST_ASSERT_GREATER_THAN_INT (-1, rc);
+    fd_t s = connect_socket (my_endpoint);
 
     // Mock a ZMTP 3 client so we can forcibly try sub commands
-    mock_handshake (s);
+    mock_handshake (s, sub_command_, mock_pub_);
 
     // By now everything should report as connected
     rc = get_monitor_event (server_mon);
     TEST_ASSERT_EQUAL_INT (ZMQ_EVENT_ACCEPTED, rc);
 
-    if (sub_command) {
-        const uint8_t sub[13] = {4,   11,  9,   'S', 'U', 'B', 'S',
-                                 'C', 'R', 'I', 'B', 'E', 'A'};
-        rc =
-          TEST_ASSERT_SUCCESS_RAW_ERRNO (send (s, (const char *) sub, 13, 0));
-        TEST_ASSERT_EQUAL_INT (13, rc);
-    } else {
-        const uint8_t sub[4] = {0, 2, 1, 'A'};
-        rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (send (s, (const char *) sub, 4, 0));
-        TEST_ASSERT_EQUAL_INT (4, rc);
-    }
-
-    char buffer[16];
+    char buffer[32];
     memset (buffer, 0, sizeof (buffer));
-    rc = zmq_recv (server, buffer, 2, 0);
-    TEST_ASSERT_EQUAL_INT (2, rc);
-    TEST_ASSERT_EQUAL_INT (0, memcmp (buffer, "\1A", 2));
 
-    rc = zmq_send (server, "ALOL", 4, 0);
-    TEST_ASSERT_EQUAL_INT (4, rc);
+    if (mock_pub_) {
+        rc = zmq_setsockopt (server, ZMQ_SUBSCRIBE, "A", 1);
+        TEST_ASSERT_EQUAL_INT (0, rc);
+        //  SUB binds, let its state machine run
+        //  Because zeromq attach the pipe after the handshake, we need more time here before we can run the state-machine
+        msleep (1);
+        zmq_recv (server, buffer, 16, ZMQ_DONTWAIT);
+
+        if (sub_command_) {
+            recv_with_retry (s, buffer, 13);
+            TEST_ASSERT_EQUAL_INT (0,
+                                   memcmp (buffer, "\4\xb\x9SUBSCRIBEA", 13));
+        } else {
+            recv_with_retry (s, buffer, 4);
+            TEST_ASSERT_EQUAL_INT (0, memcmp (buffer, "\0\2\1A", 4));
+        }
 
-    memset (buffer, 0, sizeof (buffer));
-    recv_with_retry (s, buffer, 6);
-    TEST_ASSERT_EQUAL_INT (0, memcmp (buffer, "\0\4ALOL", 6));
+        memcpy (buffer, "\0\4ALOL", 6);
+        rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (send (s, buffer, 6, 0));
+        TEST_ASSERT_EQUAL_INT (6, rc);
+
+        memset (buffer, 0, sizeof (buffer));
+        rc = zmq_recv (server, buffer, 4, 0);
+        TEST_ASSERT_EQUAL_INT (4, rc);
+        TEST_ASSERT_EQUAL_INT (0, memcmp (buffer, "ALOL", 4));
+    } else {
+        if (sub_command_) {
+            const uint8_t sub[13] = {4,   11,  9,   'S', 'U', 'B', 'S',
+                                     'C', 'R', 'I', 'B', 'E', 'A'};
+            rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (
+              send (s, (const char *) sub, 13, 0));
+            TEST_ASSERT_EQUAL_INT (13, rc);
+        } else {
+            const uint8_t sub[4] = {0, 2, 1, 'A'};
+            rc = TEST_ASSERT_SUCCESS_RAW_ERRNO (
+              send (s, (const char *) sub, 4, 0));
+            TEST_ASSERT_EQUAL_INT (4, rc);
+        }
+        rc = zmq_recv (server, buffer, 2, 0);
+        TEST_ASSERT_EQUAL_INT (2, rc);
+        TEST_ASSERT_EQUAL_INT (0, memcmp (buffer, "\1A", 2));
+
+        rc = zmq_send (server, "ALOL", 4, 0);
+        TEST_ASSERT_EQUAL_INT (4, rc);
+
+        memset (buffer, 0, sizeof (buffer));
+        recv_with_retry (s, buffer, 6);
+        TEST_ASSERT_EQUAL_INT (0, memcmp (buffer, "\0\4ALOL", 6));
+    }
 
     close (s);
 
@@ -200,12 +211,22 @@ static void test_mock_sub (bool sub_comm
 
 void test_mock_sub_command ()
 {
-    test_mock_sub (true);
+    test_mock_pub_sub (true, false);
 }
 
 void test_mock_sub_legacy ()
 {
-    test_mock_sub (false);
+    test_mock_pub_sub (false, false);
+}
+
+void test_mock_pub_command ()
+{
+    test_mock_pub_sub (true, true);
+}
+
+void test_mock_pub_legacy ()
+{
+    test_mock_pub_sub (false, true);
 }
 
 int main (void)
@@ -216,6 +237,8 @@ int main (void)
 
     RUN_TEST (test_mock_sub_command);
     RUN_TEST (test_mock_sub_legacy);
+    RUN_TEST (test_mock_pub_command);
+    RUN_TEST (test_mock_pub_legacy);
 
     return UNITY_END ();
 }
diff -pruN 4.3.2-2/tests/test_monitor.cpp 4.3.3-1/tests/test_monitor.cpp
--- 4.3.2-2/tests/test_monitor.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_monitor.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -116,6 +116,12 @@ void test_monitor_basic ()
     if (event != ZMQ_EVENT_DISCONNECTED) {
         TEST_ASSERT_EQUAL_INT (ZMQ_EVENT_MONITOR_STOPPED, event);
     }
+    //  TODO: When not waiting until the monitor stopped, the I/O thread runs
+    //  into some deadlock. This must be fixed, but until it is fixed, we wait
+    //  here in order to have more reliable test execution.
+    while (event != ZMQ_EVENT_MONITOR_STOPPED) {
+        event = get_monitor_event (server_mon, NULL, NULL);
+    }
 
     //  Close down the sockets
     //  TODO why does this use zero_linger?
@@ -196,12 +202,12 @@ void test_monitor_versioned_basic (bind_
     //  Now do a basic ping test
     bind_function_ (server, server_endpoint, sizeof server_endpoint);
 
-    int ipv6_;
-    size_t ipv6_size_ = sizeof (ipv6_);
+    int ipv6;
+    size_t ipv6_size = sizeof (ipv6);
     TEST_ASSERT_SUCCESS_ERRNO (
-      zmq_getsockopt (server, ZMQ_IPV6, &ipv6_, &ipv6_size_));
+      zmq_getsockopt (server, ZMQ_IPV6, &ipv6, &ipv6_size));
     TEST_ASSERT_SUCCESS_ERRNO (
-      zmq_setsockopt (client, ZMQ_IPV6, &ipv6_, sizeof (int)));
+      zmq_setsockopt (client, ZMQ_IPV6, &ipv6, sizeof (int)));
     TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client, server_endpoint));
     bounce (server, client);
 
@@ -255,6 +261,12 @@ void test_monitor_versioned_basic (bind_
     if (event != ZMQ_EVENT_DISCONNECTED) {
         TEST_ASSERT_EQUAL_INT (ZMQ_EVENT_MONITOR_STOPPED, event);
     }
+    //  TODO: When not waiting until the monitor stopped, the I/O thread runs
+    //  into some deadlock. This must be fixed, but until it is fixed, we wait
+    //  here in order to have more reliable test execution.
+    while (event != ZMQ_EVENT_MONITOR_STOPPED) {
+        event = get_monitor_event_v2 (server_mon, NULL, NULL, NULL);
+    }
     free (client_local_address);
     free (client_remote_address);
 
@@ -327,14 +339,14 @@ void test_monitor_versioned_stats (bind_
       push, ZMQ_SNDBUF, &tcp_buffer_size, sizeof (tcp_buffer_size)));
     bind_function_ (push, server_endpoint, sizeof (server_endpoint));
 
-    int ipv6_;
-    size_t ipv6_size_ = sizeof (ipv6_);
+    int ipv6;
+    size_t ipv6_size = sizeof (ipv6);
     TEST_ASSERT_SUCCESS_ERRNO (
-      zmq_getsockopt (push, ZMQ_IPV6, &ipv6_, &ipv6_size_));
+      zmq_getsockopt (push, ZMQ_IPV6, &ipv6, &ipv6_size));
     for (int i = 0; i < pulls_count; ++i) {
         pulls[i] = test_context_socket (ZMQ_PULL);
         TEST_ASSERT_SUCCESS_ERRNO (
-          zmq_setsockopt (pulls[i], ZMQ_IPV6, &ipv6_, sizeof (int)));
+          zmq_setsockopt (pulls[i], ZMQ_IPV6, &ipv6, sizeof (int)));
         int timeout_ms = 10;
         TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (
           pulls[i], ZMQ_RCVTIMEO, &timeout_ms, sizeof (timeout_ms)));
diff -pruN 4.3.2-2/tests/test_msg_ffn.cpp 4.3.3-1/tests/test_msg_ffn.cpp
--- 4.3.2-2/tests/test_msg_ffn.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_msg_ffn.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -41,7 +41,7 @@ void ffn (void *data_, void *hint_)
     memcpy (hint_, (void *) "freed", 5);
 }
 
-void test_msg_ffn ()
+void test_msg_init_ffn ()
 {
     //  Create the infrastructure
     char my_endpoint[MAX_SOCKET_STRING];
@@ -121,6 +121,6 @@ int main (void)
     setup_test_environment ();
 
     UNITY_BEGIN ();
-    RUN_TEST (test_msg_ffn);
+    RUN_TEST (test_msg_init_ffn);
     return UNITY_END ();
 }
diff -pruN 4.3.2-2/tests/test_msg_init.cpp 4.3.3-1/tests/test_msg_init.cpp
--- 4.3.2-2/tests/test_msg_init.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_msg_init.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,86 @@
+/*
+    Copyright (c) 2007-2017 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+#include <string.h>
+
+SETUP_TEARDOWN_TESTCONTEXT
+
+void test_msg_init ()
+{
+    zmq_msg_t msg;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init (&msg));
+    TEST_ASSERT_EQUAL_INT (0, zmq_msg_size (&msg));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_close (&msg));
+}
+
+void test_msg_init_size ()
+{
+    const char *data = "foobar";
+    zmq_msg_t msg;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_size (&msg, 6));
+    TEST_ASSERT_EQUAL_INT (6, zmq_msg_size (&msg));
+    memcpy (zmq_msg_data (&msg), data, 6);
+    TEST_ASSERT_EQUAL_STRING_LEN (data, zmq_msg_data (&msg), 6);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_close (&msg));
+
+    zmq_msg_t msg2;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_size (&msg2, 0));
+    TEST_ASSERT_EQUAL_INT (0, zmq_msg_size (&msg2));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_close (&msg2));
+}
+
+void test_msg_init_buffer ()
+{
+    const char *data = "foobar";
+    zmq_msg_t msg;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_buffer (&msg, data, 6));
+    TEST_ASSERT_EQUAL_INT (6, zmq_msg_size (&msg));
+    TEST_ASSERT (data != zmq_msg_data (&msg));
+    TEST_ASSERT_EQUAL_STRING_LEN (data, zmq_msg_data (&msg), 6);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_close (&msg));
+
+    zmq_msg_t msg2;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_buffer (&msg2, NULL, 0));
+    TEST_ASSERT_EQUAL_INT (0, zmq_msg_size (&msg2));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_close (&msg2));
+}
+
+int main (void)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_msg_init);
+    RUN_TEST (test_msg_init_size);
+    RUN_TEST (test_msg_init_buffer);
+    return UNITY_END ();
+}
diff -pruN 4.3.2-2/tests/test_pair_ipc.cpp 4.3.3-1/tests/test_pair_ipc.cpp
--- 4.3.2-2/tests/test_pair_ipc.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_pair_ipc.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,6 +30,8 @@
 #include "testutil.hpp"
 #include "testutil_unity.hpp"
 
+#include <string>
+
 SETUP_TEARDOWN_TESTCONTEXT
 
 void test_roundtrip ()
@@ -48,11 +50,32 @@ void test_roundtrip ()
     test_context_socket_close (sb);
 }
 
+static const char prefix[] = "ipc://";
+
+void test_endpoint_too_long ()
+{
+    std::string endpoint_too_long;
+    endpoint_too_long.append (prefix);
+    for (size_t i = 0; i < 108; ++i) {
+        endpoint_too_long.append ("a");
+    }
+
+    void *sb = test_context_socket (ZMQ_PAIR);
+    // TODO ENAMETOOLONG is not listed in the errors returned by zmq_bind,
+    // should this be EINVAL?
+    TEST_ASSERT_FAILURE_ERRNO (ENAMETOOLONG,
+                               zmq_bind (sb, endpoint_too_long.data ()));
+
+    test_context_socket_close (sb);
+}
+
+
 int main (void)
 {
     setup_test_environment ();
 
     UNITY_BEGIN ();
     RUN_TEST (test_roundtrip);
+    RUN_TEST (test_endpoint_too_long);
     return UNITY_END ();
 }
diff -pruN 4.3.2-2/tests/test_peer.cpp 4.3.3-1/tests/test_peer.cpp
--- 4.3.2-2/tests/test_peer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_peer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,113 @@
+/*
+    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+SETUP_TEARDOWN_TESTCONTEXT
+
+void test_peer ()
+{
+    size_t len = MAX_SOCKET_STRING;
+    char my_endpoint[MAX_SOCKET_STRING];
+
+    void *peer1 = test_context_socket (ZMQ_PEER);
+    bind_loopback (peer1, false, my_endpoint, len);
+
+    void *peer2 = test_context_socket (ZMQ_PEER);
+    uint32_t peer1_routing_id = zmq_connect_peer (peer2, my_endpoint);
+    TEST_ASSERT_NOT_EQUAL (0, peer1_routing_id);
+
+    {
+        zmq_msg_t msg;
+        TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_size (&msg, 1));
+
+        char *data = static_cast<char *> (zmq_msg_data (&msg));
+        data[0] = 1;
+
+        TEST_ASSERT_SUCCESS_ERRNO (
+          zmq_msg_set_routing_id (&msg, peer1_routing_id));
+
+        int rc = zmq_msg_send (&msg, peer2, 0);
+        TEST_ASSERT_EQUAL_INT (1, rc);
+    }
+
+    uint32_t peer2_routing_id;
+    {
+        zmq_msg_t msg;
+        TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init (&msg));
+
+        int rc = TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_recv (&msg, peer1, 0));
+        TEST_ASSERT_EQUAL_INT (1, rc);
+
+        peer2_routing_id = zmq_msg_routing_id (&msg);
+        TEST_ASSERT_NOT_EQUAL (0, peer2_routing_id);
+
+        TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_close (&msg));
+    }
+
+    {
+        zmq_msg_t msg;
+        TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_size (&msg, 1));
+
+        char *data = static_cast<char *> (zmq_msg_data (&msg));
+        data[0] = 2;
+
+        TEST_ASSERT_SUCCESS_ERRNO (
+          zmq_msg_set_routing_id (&msg, peer2_routing_id));
+
+        int rc = zmq_msg_send (&msg, peer1, 0);
+        TEST_ASSERT_EQUAL_INT (1, rc);
+    }
+
+    {
+        zmq_msg_t msg;
+        TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init (&msg));
+
+        int rc = zmq_msg_recv (&msg, peer2, 0);
+        TEST_ASSERT_EQUAL_INT (1, rc);
+
+        uint32_t routing_id = zmq_msg_routing_id (&msg);
+        TEST_ASSERT_EQUAL_UINT32 (peer1_routing_id, routing_id);
+
+        TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_close (&msg));
+    }
+
+    test_context_socket_close (peer1);
+    test_context_socket_close (peer2);
+}
+
+int main (void)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_peer);
+    return UNITY_END ();
+}
diff -pruN 4.3.2-2/tests/test_poller.cpp 4.3.3-1/tests/test_poller.cpp
--- 4.3.2-2/tests/test_poller.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_poller.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -60,6 +60,17 @@ void test_null_poller_pointers_destroy_i
     TEST_ASSERT_FAILURE_ERRNO (EFAULT, zmq_poller_destroy (&null_poller));
 }
 
+void test_null_poller_pointers_size_direct ()
+{
+    TEST_ASSERT_FAILURE_ERRNO (EFAULT, zmq_poller_size (NULL));
+}
+
+void test_null_poller_pointers_size_indirect ()
+{
+    void *null_poller = NULL;
+    TEST_ASSERT_FAILURE_ERRNO (EFAULT, zmq_poller_size (&null_poller));
+}
+
 void test_null_poller_pointers_add_direct ()
 {
     void *socket = test_context_socket (ZMQ_PAIR);
@@ -198,7 +209,7 @@ void test_null_poller_pointers_wait_all_
 void test_null_poller_pointer_poller_fd ()
 {
     void *null_poller = NULL;
-    zmq_fd_t fd;
+    fd_t fd;
     TEST_ASSERT_FAILURE_ERRNO (EFAULT, zmq_poller_fd (&null_poller, &fd));
 }
 
@@ -274,7 +285,7 @@ void test_call_poller_fd_no_signaler ()
     TEST_ASSERT_SUCCESS_ERRNO (
       zmq_poller_add (poller, socket, NULL, ZMQ_POLLIN));
 
-    zmq_fd_t fd;
+    fd_t fd;
     TEST_ASSERT_FAILURE_ERRNO (EINVAL, zmq_poller_fd (poller, &fd));
 
     TEST_ASSERT_SUCCESS_ERRNO (zmq_poller_destroy (&poller));
@@ -292,7 +303,7 @@ void test_call_poller_fd ()
     TEST_ASSERT_SUCCESS_ERRNO (
       zmq_poller_add (poller, socket, NULL, ZMQ_POLLIN));
 
-    zmq_fd_t fd;
+    fd_t fd;
     TEST_ASSERT_SUCCESS_ERRNO (zmq_poller_fd (poller, &fd));
 
     TEST_ASSERT_SUCCESS_ERRNO (zmq_poller_destroy (&poller));
@@ -330,6 +341,42 @@ TEST_CASE_FUNC_PARAM (call_poller_wait_a
 TEST_CASE_FUNC_PARAM (call_poller_wait_all_null_event_fails_event_count_zero,
                       test_with_valid_poller)
 
+void call_poller_size (void *poller_, void *socket_)
+{
+    int rc = zmq_poller_size (poller_);
+    TEST_ASSERT_SUCCESS_ERRNO (rc);
+    TEST_ASSERT_EQUAL (rc, 0);
+
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_poller_add (poller_, socket_, NULL, ZMQ_POLLIN));
+    rc = zmq_poller_size (poller_);
+    TEST_ASSERT_SUCCESS_ERRNO (rc);
+    TEST_ASSERT_EQUAL (rc, 1);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_poller_modify (poller_, socket_, 0));
+    rc = zmq_poller_size (poller_);
+    TEST_ASSERT_SUCCESS_ERRNO (rc);
+    TEST_ASSERT_EQUAL (rc, 1);
+
+    fd_t plain_socket = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_poller_add_fd (poller_, plain_socket, NULL, ZMQ_POLLOUT));
+    rc = zmq_poller_size (poller_);
+    TEST_ASSERT_SUCCESS_ERRNO (rc);
+    TEST_ASSERT_EQUAL (rc, 2);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_poller_remove (poller_, socket_));
+    rc = zmq_poller_size (poller_);
+    TEST_ASSERT_SUCCESS_ERRNO (rc);
+    TEST_ASSERT_EQUAL (rc, 1);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_poller_remove_fd (poller_, plain_socket));
+    TEST_ASSERT_SUCCESS_ERRNO (close (plain_socket));
+    rc = zmq_poller_size (poller_);
+    TEST_ASSERT_SUCCESS_ERRNO (rc);
+    TEST_ASSERT_EQUAL (rc, 0);
+}
+
 void call_poller_add_twice_fails (void *poller_, void *socket_)
 {
     TEST_ASSERT_SUCCESS_ERRNO (
@@ -449,6 +496,7 @@ void call_poller_modify_fd_invalid_event
     TEST_ASSERT_SUCCESS_ERRNO (close (plain_socket));
 }
 
+TEST_CASE_FUNC_PARAM (call_poller_size, test_with_empty_poller)
 TEST_CASE_FUNC_PARAM (call_poller_add_twice_fails, test_with_empty_poller)
 TEST_CASE_FUNC_PARAM (call_poller_remove_unregistered_fails,
                       test_with_empty_poller)
@@ -512,6 +560,17 @@ void call_poller_wait_all_empty_with_tim
                                zmq_poller_wait_all (poller_, &event, 0, -1));
 }
 
+void call_poller_wait_all_inf_disabled_fails (void *poller_, void *socket_)
+{
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_poller_add (poller_, socket_, NULL, 0));
+
+    zmq_poller_event_t events[1];
+    TEST_ASSERT_FAILURE_ERRNO (EAGAIN,
+                               zmq_poller_wait_all (poller_, events, 1, 0));
+    TEST_ASSERT_FAILURE_ERRNO (EFAULT,
+                               zmq_poller_wait_all (poller_, events, 1, -1));
+}
+
 TEST_CASE_FUNC_PARAM (call_poller_wait_empty_with_timeout_fails,
                       test_with_empty_poller)
 TEST_CASE_FUNC_PARAM (call_poller_wait_empty_without_timeout_fails,
@@ -522,6 +581,8 @@ TEST_CASE_FUNC_PARAM (call_poller_wait_a
                       test_with_empty_poller)
 TEST_CASE_FUNC_PARAM (call_poller_wait_all_empty_with_timeout_fails,
                       test_with_empty_poller)
+TEST_CASE_FUNC_PARAM (call_poller_wait_all_inf_disabled_fails,
+                      test_with_empty_poller)
 
 void test_poll_basic ()
 {
@@ -625,6 +686,9 @@ void test_poll_client_server ()
     TEST_ASSERT_SUCCESS_ERRNO (zmq_poller_wait (poller, &event, 500));
     TEST_ASSERT_EQUAL_PTR (server, event.socket);
     TEST_ASSERT_NULL (event.user_data);
+#ifndef _WIN32
+    TEST_ASSERT (event.fd == -1);
+#endif
     recv_string_expect_success (server, client_server_msg, 0);
 
     //  Polling on pollout
@@ -633,6 +697,9 @@ void test_poll_client_server ()
     TEST_ASSERT_SUCCESS_ERRNO (zmq_poller_wait (poller, &event, 0));
     TEST_ASSERT_EQUAL_PTR (server, event.socket);
     TEST_ASSERT_NULL (event.user_data);
+#ifndef _WIN32
+    TEST_ASSERT (event.fd == -1);
+#endif
     TEST_ASSERT_EQUAL_INT (ZMQ_POLLOUT, event.events);
 
     //  Stop polling server
@@ -653,6 +720,8 @@ int main (void)
     UNITY_BEGIN ();
     RUN_TEST (test_null_poller_pointers_destroy_direct);
     RUN_TEST (test_null_poller_pointers_destroy_indirect);
+    RUN_TEST (test_null_poller_pointers_size_direct);
+    RUN_TEST (test_null_poller_pointers_size_indirect);
     RUN_TEST (test_null_poller_pointers_add_direct);
     RUN_TEST (test_null_poller_pointers_add_indirect);
     RUN_TEST (test_null_poller_pointers_modify_direct);
@@ -677,6 +746,7 @@ int main (void)
     RUN_TEST (test_call_poller_wait_all_null_event_fails_event_count_nonzero);
     RUN_TEST (test_call_poller_wait_all_null_event_fails_event_count_zero);
 
+    RUN_TEST (test_call_poller_size);
     RUN_TEST (test_call_poller_add_twice_fails);
     RUN_TEST (test_call_poller_remove_unregistered_fails);
     RUN_TEST (test_call_poller_modify_unregistered_fails);
@@ -695,6 +765,7 @@ int main (void)
     RUN_TEST (test_call_poller_wait_all_empty_negative_count_fails);
     RUN_TEST (test_call_poller_wait_all_empty_without_timeout_fails);
     RUN_TEST (test_call_poller_wait_all_empty_with_timeout_fails);
+    RUN_TEST (test_call_poller_wait_all_inf_disabled_fails);
 
     RUN_TEST (test_call_poller_fd_no_signaler);
     RUN_TEST (test_call_poller_fd);
diff -pruN 4.3.2-2/tests/test_proxy.cpp 4.3.3-1/tests/test_proxy.cpp
--- 4.3.2-2/tests/test_proxy.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_proxy.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -80,7 +80,7 @@ void *g_workers_pkts_out = NULL;
 
 static void client_task (void *db_)
 {
-    struct thread_data *databag = (struct thread_data *) db_;
+    const thread_data *const databag = static_cast<const thread_data *> (db_);
     // Endpoint socket gets random port to avoid test failing when port in use
     void *endpoint = zmq_socket (get_test_context (), ZMQ_PAIR);
     TEST_ASSERT_NOT_NULL (endpoint);
@@ -373,16 +373,16 @@ void check_proxy_stats (void *control_pr
     if (is_verbose) {
         printf (
           "frontend: pkts_in=%lu bytes_in=%lu  pkts_out=%lu bytes_out=%lu\n",
-          (unsigned long int) total_stats.frontend.msg_in,
-          (unsigned long int) total_stats.frontend.bytes_in,
-          (unsigned long int) total_stats.frontend.msg_out,
-          (unsigned long int) total_stats.frontend.bytes_out);
+          static_cast<unsigned long int> (total_stats.frontend.msg_in),
+          static_cast<unsigned long int> (total_stats.frontend.bytes_in),
+          static_cast<unsigned long int> (total_stats.frontend.msg_out),
+          static_cast<unsigned long int> (total_stats.frontend.bytes_out));
         printf (
           "backend: pkts_in=%lu bytes_in=%lu  pkts_out=%lu bytes_out=%lu\n",
-          (unsigned long int) total_stats.backend.msg_in,
-          (unsigned long int) total_stats.backend.bytes_in,
-          (unsigned long int) total_stats.backend.msg_out,
-          (unsigned long int) total_stats.backend.bytes_out);
+          static_cast<unsigned long int> (total_stats.backend.msg_in),
+          static_cast<unsigned long int> (total_stats.backend.bytes_in),
+          static_cast<unsigned long int> (total_stats.backend.msg_out),
+          static_cast<unsigned long int> (total_stats.backend.bytes_out));
 
         printf ("clients sent out %d requests\n",
                 zmq_atomic_counter_value (g_clients_pkts_out));
diff -pruN 4.3.2-2/tests/test_proxy_hwm.cpp 4.3.3-1/tests/test_proxy_hwm.cpp
--- 4.3.2-2/tests/test_proxy_hwm.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_proxy_hwm.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -71,19 +71,20 @@ typedef struct
     void *subscriber_received_all;
 } proxy_hwm_cfg_t;
 
-static void lower_hwm (void *skt)
+static void lower_hwm (void *skt_)
 {
-    int send_hwm_ = HWM;
+    int send_hwm = HWM;
     TEST_ASSERT_SUCCESS_ERRNO (
-      zmq_setsockopt (skt, ZMQ_SNDHWM, &send_hwm_, sizeof (send_hwm_)));
+      zmq_setsockopt (skt_, ZMQ_SNDHWM, &send_hwm, sizeof (send_hwm)));
 
     TEST_ASSERT_SUCCESS_ERRNO (
-      zmq_setsockopt (skt, ZMQ_RCVHWM, &send_hwm_, sizeof (send_hwm_)));
+      zmq_setsockopt (skt_, ZMQ_RCVHWM, &send_hwm, sizeof (send_hwm)));
 }
 
-static void publisher_thread_main (void *pvoid)
+static void publisher_thread_main (void *pvoid_)
 {
-    proxy_hwm_cfg_t *cfg = (proxy_hwm_cfg_t *) pvoid;
+    const proxy_hwm_cfg_t *const cfg =
+      static_cast<const proxy_hwm_cfg_t *> (pvoid_);
 
     void *pubsocket = zmq_socket (cfg->context, ZMQ_XPUB);
     assert (pubsocket);
@@ -136,9 +137,10 @@ static void publisher_thread_main (void
     zmq_close (pubsocket);
 }
 
-static void subscriber_thread_main (void *pvoid)
+static void subscriber_thread_main (void *pvoid_)
 {
-    proxy_hwm_cfg_t *cfg = (proxy_hwm_cfg_t *) pvoid;
+    const proxy_hwm_cfg_t *const cfg =
+      static_cast<const proxy_hwm_cfg_t *> (pvoid_);
 
     void *subsocket = zmq_socket (cfg->context, ZMQ_SUB);
     assert (subsocket);
@@ -190,7 +192,7 @@ static void subscriber_thread_main (void
     zmq_close (subsocket);
 }
 
-bool recv_stat (void *sock_, bool last_, uint64_t *res)
+bool recv_stat (void *sock_, bool last_, uint64_t *res_)
 {
     zmq_msg_t stats_msg;
 
@@ -205,7 +207,7 @@ bool recv_stat (void *sock_, bool last_,
     }
 
     assert (rc == sizeof (uint64_t));
-    memcpy (res, zmq_msg_data (&stats_msg), zmq_msg_size (&stats_msg));
+    memcpy (res_, zmq_msg_data (&stats_msg), zmq_msg_size (&stats_msg));
 
     rc = zmq_msg_close (&stats_msg);
     assert (rc == 0);
@@ -264,10 +266,10 @@ bool check_proxy_stats (void *control_pr
     return true;
 }
 
-static void proxy_stats_asker_thread_main (void *pvoid)
+static void proxy_stats_asker_thread_main (void *pvoid_)
 {
-    proxy_hwm_cfg_t *cfg = (proxy_hwm_cfg_t *) pvoid;
-
+    const proxy_hwm_cfg_t *const cfg =
+      static_cast<const proxy_hwm_cfg_t *> (pvoid_);
 
     // CONTROL REQ
 
@@ -316,12 +318,12 @@ static void proxy_stats_asker_thread_mai
     zmq_close (control_req);
 }
 
-static void proxy_thread_main (void *pvoid)
+static void proxy_thread_main (void *pvoid_)
 {
-    proxy_hwm_cfg_t *cfg = (proxy_hwm_cfg_t *) pvoid;
+    const proxy_hwm_cfg_t *const cfg =
+      static_cast<const proxy_hwm_cfg_t *> (pvoid_);
     int rc;
 
-
     // FRONTEND SUB
 
     void *frontend_xsub = zmq_socket (
diff -pruN 4.3.2-2/tests/test_radio_dish.cpp 4.3.3-1/tests/test_radio_dish.cpp
--- 4.3.2-2/tests/test_radio_dish.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_radio_dish.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -96,6 +96,35 @@ void test_leave_unjoined_fails ()
     test_context_socket_close (dish);
 }
 
+void test_long_group ()
+{
+    size_t len = MAX_SOCKET_STRING;
+    char my_endpoint[MAX_SOCKET_STRING];
+
+    void *radio = test_context_socket (ZMQ_RADIO);
+    bind_loopback (radio, false, my_endpoint, len);
+
+    void *dish = test_context_socket (ZMQ_DISH);
+
+    // Joining to a long group, over 14 chars
+    char group[19] = "0123456789ABCDEFGH";
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_join (dish, group));
+
+    // Connecting
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (dish, my_endpoint));
+
+    msleep (SETTLE_TIME);
+
+    //  This is going to be sent to the dish
+    msg_send_expect_success (radio, group, "HELLO");
+
+    //  Check the correct message arrived
+    msg_recv_cmp (dish, group, "HELLO");
+
+    test_context_socket_close (dish);
+    test_context_socket_close (radio);
+}
+
 void test_join_too_long_fails ()
 {
     void *dish = test_context_socket (ZMQ_DISH);
@@ -257,9 +286,8 @@ static const char *mcast_url (int ipv6_)
 {
     if (ipv6_) {
         return "udp://[" MCAST_IPV6 "]:5555";
-    } else {
-        return "udp://" MCAST_IPV4 ":5555";
     }
+    return "udp://" MCAST_IPV4 ":5555";
 }
 
 //  OSX uses a different name for this socket option
@@ -299,14 +327,14 @@ static bool is_multicast_available (int
         any_ipv6->sin6_flowinfo = 0;
         any_ipv6->sin6_scope_id = 0;
 
-        rc = inet_pton (AF_INET6, "::", &any_ipv6->sin6_addr);
+        rc = test_inet_pton (AF_INET6, "::", &any_ipv6->sin6_addr);
         if (rc == 0) {
             goto out;
         }
 
         *mcast_ipv6 = *any_ipv6;
 
-        rc = inet_pton (AF_INET6, MCAST_IPV6, &mcast_ipv6->sin6_addr);
+        rc = test_inet_pton (AF_INET6, MCAST_IPV6, &mcast_ipv6->sin6_addr);
         if (rc == 0) {
             goto out;
         }
@@ -319,14 +347,14 @@ static bool is_multicast_available (int
         any_ipv4->sin_family = AF_INET;
         any_ipv4->sin_port = htons (5555);
 
-        rc = inet_pton (AF_INET, "0.0.0.0", &any_ipv4->sin_addr);
+        rc = test_inet_pton (AF_INET, "0.0.0.0", &any_ipv4->sin_addr);
         if (rc == 0) {
             goto out;
         }
 
         *mcast_ipv4 = *any_ipv4;
 
-        rc = inet_pton (AF_INET, MCAST_IPV4, &mcast_ipv4->sin_addr);
+        rc = test_inet_pton (AF_INET, MCAST_IPV4, &mcast_ipv4->sin_addr);
         if (rc == 0) {
             goto out;
         }
@@ -351,7 +379,7 @@ static bool is_multicast_available (int
 
     if (ipv6_) {
         struct ipv6_mreq mreq;
-        struct sockaddr_in6 *mcast_ipv6 = &mcast.ipv6;
+        const sockaddr_in6 *const mcast_ipv6 = &mcast.ipv6;
 
         mreq.ipv6mr_multiaddr = mcast_ipv6->sin6_addr;
         mreq.ipv6mr_interface = 0;
@@ -370,7 +398,7 @@ static bool is_multicast_available (int
         }
     } else {
         struct ip_mreq mreq;
-        struct sockaddr_in *mcast_ipv4 = &mcast.ipv4;
+        const sockaddr_in *const mcast_ipv4 = &mcast.ipv4;
 
         mreq.imr_multiaddr = mcast_ipv4->sin_addr;
         mreq.imr_interface.s_addr = htonl (INADDR_ANY);
@@ -506,6 +534,7 @@ int main (void)
     UNITY_BEGIN ();
     RUN_TEST (test_leave_unjoined_fails);
     RUN_TEST (test_join_too_long_fails);
+    RUN_TEST (test_long_group);
     RUN_TEST (test_join_twice_fails);
     RUN_TEST (test_radio_bind_fails_ipv4);
     RUN_TEST (test_radio_bind_fails_ipv6);
diff -pruN 4.3.2-2/tests/test_rebind_ipc.cpp 4.3.3-1/tests/test_rebind_ipc.cpp
--- 4.3.2-2/tests/test_rebind_ipc.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_rebind_ipc.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -34,7 +34,7 @@ SETUP_TEARDOWN_TESTCONTEXT
 
 void test_rebind_ipc ()
 {
-    char my_endpoint[32];
+    char my_endpoint[MAX_SOCKET_STRING];
     make_random_ipc_endpoint (my_endpoint);
 
     void *sb0 = test_context_socket (ZMQ_PUSH);
diff -pruN 4.3.2-2/tests/test_reconnect_ivl.cpp 4.3.3-1/tests/test_reconnect_ivl.cpp
--- 4.3.2-2/tests/test_reconnect_ivl.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_reconnect_ivl.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -58,7 +58,7 @@ void test_reconnect_ivl_against_pair_soc
     test_context_socket_close (sc);
 }
 
-#if !defined(ZMQ_HAVE_WINDOWS) && !defined(ZMQ_HAVE_GNU)
+#if defined(ZMQ_HAVE_IPC) && !defined(ZMQ_HAVE_GNU)
 void test_reconnect_ivl_ipc (void)
 {
     char my_endpoint[256];
@@ -101,7 +101,7 @@ int main (void)
     setup_test_environment ();
 
     UNITY_BEGIN ();
-#if !defined(ZMQ_HAVE_WINDOWS) && !defined(ZMQ_HAVE_GNU)
+#if defined(ZMQ_HAVE_IPC) && !defined(ZMQ_HAVE_GNU)
     RUN_TEST (test_reconnect_ivl_ipc);
 #endif
     RUN_TEST (test_reconnect_ivl_tcp_ipv4);
diff -pruN 4.3.2-2/tests/test_reconnect_options.cpp 4.3.3-1/tests/test_reconnect_options.cpp
--- 4.3.2-2/tests/test_reconnect_options.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_reconnect_options.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,297 @@
+/*
+    Copyright (c) 2017 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+#include <assert.h>
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+#include "testutil_monitoring.hpp"
+
+#include <unity.h>
+
+// test behavior with (mostly) default values
+void reconnect_default ()
+{
+    // setup pub socket
+    void *pub = test_context_socket (ZMQ_PUB);
+    //  Bind pub socket
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (pub, ENDPOINT_0));
+
+    // setup sub socket
+    void *sub = test_context_socket (ZMQ_SUB);
+    //  Monitor all events on sub
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_socket_monitor (sub, "inproc://monitor-sub", ZMQ_EVENT_ALL));
+    //  Create socket for collecting monitor events
+    void *sub_mon = test_context_socket (ZMQ_PAIR);
+    //  Connect so they'll get events
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub_mon, "inproc://monitor-sub"));
+    // set reconnect interval so only a single reconnect is tried
+    int interval = 60 * 1000;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (sub, ZMQ_RECONNECT_IVL, &interval, sizeof (interval)));
+    // connect to pub
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub, ENDPOINT_0));
+
+    //  confirm that we get following events
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECT_DELAYED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECTED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_HANDSHAKE_SUCCEEDED);
+
+    // close the pub socket
+    test_context_socket_close_zero_linger (pub);
+
+    //  confirm that we get following events
+    expect_monitor_event (sub_mon, ZMQ_EVENT_DISCONNECTED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECT_RETRIED);
+
+    // ZMQ_EVENT_CONNECT_RETRIED should be last event, because of timeout set above
+    int event;
+    char *event_address;
+    int rc = get_monitor_event_with_timeout (sub_mon, &event, &event_address,
+                                             2 * 1000);
+    assert (rc == -1);
+
+    //  Close sub
+    //  TODO why does this use zero_linger?
+    test_context_socket_close_zero_linger (sub);
+
+    //  Close monitor
+    //  TODO why does this use zero_linger?
+    test_context_socket_close_zero_linger (sub_mon);
+}
+
+
+// test successful reconnect
+void reconnect_success ()
+{
+    // setup pub socket
+    void *pub = test_context_socket (ZMQ_PUB);
+    //  Bind pub socket
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (pub, ENDPOINT_0));
+
+    // setup sub socket
+    void *sub = test_context_socket (ZMQ_SUB);
+    //  Monitor all events on sub
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_socket_monitor (sub, "inproc://monitor-sub", ZMQ_EVENT_ALL));
+    //  Create socket for collecting monitor events
+    void *sub_mon = test_context_socket (ZMQ_PAIR);
+    //  Connect so they'll get events
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub_mon, "inproc://monitor-sub"));
+    // set reconnect interval so only a single reconnect is tried
+    int interval = 1 * 1000;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (sub, ZMQ_RECONNECT_IVL, &interval, sizeof (interval)));
+    // connect to pub
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub, ENDPOINT_0));
+
+    //  confirm that we get following events
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECT_DELAYED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECTED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_HANDSHAKE_SUCCEEDED);
+
+    // close the pub socket
+    test_context_socket_close_zero_linger (pub);
+
+    //  confirm that we get following events
+    expect_monitor_event (sub_mon, ZMQ_EVENT_DISCONNECTED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECT_RETRIED);
+
+    // ZMQ_EVENT_CONNECT_RETRIED should be last event, because of timeout set above
+    int event;
+    char *event_address;
+    int rc = get_monitor_event_with_timeout (sub_mon, &event, &event_address,
+                                             SETTLE_TIME);
+    assert (rc == -1);
+
+    //  Now re-bind pub socket and wait for re-connect
+    pub = test_context_socket (ZMQ_PUB);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (pub, ENDPOINT_0));
+    msleep (SETTLE_TIME);
+
+    //  confirm that we get following events
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECT_DELAYED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECTED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_HANDSHAKE_SUCCEEDED);
+
+    // ZMQ_EVENT_HANDSHAKE_SUCCEEDED should be last event
+    rc = get_monitor_event_with_timeout (sub_mon, &event, &event_address,
+                                         SETTLE_TIME);
+    assert (rc == -1);
+
+    //  Close sub
+    //  TODO why does this use zero_linger?
+    test_context_socket_close_zero_linger (sub);
+    test_context_socket_close_zero_linger (pub);
+
+    //  Close monitor
+    //  TODO why does this use zero_linger?
+    test_context_socket_close_zero_linger (sub_mon);
+}
+
+
+#ifdef ZMQ_BUILD_DRAFT_API
+// test stopping reconnect on connection refused
+void reconnect_stop_on_refused ()
+{
+    // setup pub socket
+    void *pub = test_context_socket (ZMQ_PUB);
+    //  Bind pub socket
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (pub, ENDPOINT_0));
+
+    // setup sub socket
+    void *sub = test_context_socket (ZMQ_SUB);
+    //  Monitor all events on sub
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_socket_monitor (sub, "inproc://monitor-sub", ZMQ_EVENT_ALL));
+    //  Create socket for collecting monitor events
+    void *sub_mon = test_context_socket (ZMQ_PAIR);
+    //  Connect so they'll get events
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub_mon, "inproc://monitor-sub"));
+    // set option to stop reconnecting on error
+    int stopReconnectOnError = ZMQ_RECONNECT_STOP_CONN_REFUSED;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (sub, ZMQ_RECONNECT_STOP,
+                                               &stopReconnectOnError,
+                                               sizeof (stopReconnectOnError)));
+    // connect to pub
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub, ENDPOINT_0));
+
+    //  confirm that we get following events
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECT_DELAYED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECTED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_HANDSHAKE_SUCCEEDED);
+
+    // close the pub socket
+    test_context_socket_close_zero_linger (pub);
+
+    //  confirm that we get following events
+    expect_monitor_event (sub_mon, ZMQ_EVENT_DISCONNECTED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECT_RETRIED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECT_DELAYED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CLOSED);
+
+    // ZMQ_EVENT_CLOSED should be last event, because of ZMQ_RECONNECT_STOP set above
+    int event = 0;
+    char *event_address;
+    int rc = get_monitor_event_with_timeout (sub_mon, &event, &event_address,
+                                             2 * 1000);
+    int limit = 0;
+    while ((rc != -1) && (++limit < 1000)) {
+        print_unexpected_event_stderr (event, rc, 0, -1);
+        rc = get_monitor_event_with_timeout (sub_mon, &event, &event_address,
+                                             2 * 1000);
+    }
+
+    //  Close sub
+    //  TODO why does this use zero_linger?
+    test_context_socket_close_zero_linger (sub);
+
+    //  Close monitor
+    //  TODO why does this use zero_linger?
+    test_context_socket_close_zero_linger (sub_mon);
+}
+#endif
+
+#ifdef ZMQ_BUILD_DRAFT_API
+// test stopping reconnect on connection refused
+void reconnect_stop_on_handshake_failed ()
+{
+    char bind_address[MAX_SOCKET_STRING];
+    size_t addr_length = sizeof (bind_address);
+    void *dummy = test_context_socket (ZMQ_STREAM);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (dummy, "tcp://127.0.0.1:0"));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_getsockopt (dummy, ZMQ_LAST_ENDPOINT, bind_address, &addr_length));
+
+    // setup sub socket
+    void *sub = test_context_socket (ZMQ_SUB);
+    //  Monitor all events on sub
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_socket_monitor (sub, "inproc://monitor-sub", ZMQ_EVENT_ALL));
+    //  Create socket for collecting monitor events
+    void *sub_mon = test_context_socket (ZMQ_PAIR);
+    //  Connect so they'll get events
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub_mon, "inproc://monitor-sub"));
+    // set handshake interval (i.e., timeout) to a more reasonable value
+    int handshakeInterval = 1000;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (
+      sub, ZMQ_HANDSHAKE_IVL, &handshakeInterval, sizeof (handshakeInterval)));
+    // set option to stop reconnecting on failed handshake
+    int stopReconnectOnError = ZMQ_RECONNECT_STOP_HANDSHAKE_FAILED;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (sub, ZMQ_RECONNECT_STOP,
+                                               &stopReconnectOnError,
+                                               sizeof (stopReconnectOnError)));
+    // connect to dummy stream socket above
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub, bind_address));
+
+#if 1
+    // ZMQ_EVENT_DISCONNECTED should be last event, because of ZMQ_RECONNECT_STOP set above
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECT_DELAYED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_CONNECTED);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_HANDSHAKE_FAILED_NO_DETAIL);
+    expect_monitor_event (sub_mon, ZMQ_EVENT_DISCONNECTED);
+#else
+    print_events (sub_mon, 2 * 1000, 1000);
+#endif
+
+    //  Close sub
+    //  TODO why does this use zero_linger?
+    test_context_socket_close_zero_linger (sub);
+    test_context_socket_close_zero_linger (dummy);
+
+    //  Close monitor
+    //  TODO why does this use zero_linger?
+    test_context_socket_close_zero_linger (sub_mon);
+}
+#endif
+
+void setUp ()
+{
+    setup_test_context ();
+}
+
+void tearDown ()
+{
+    teardown_test_context ();
+}
+
+int main (void)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+
+    RUN_TEST (reconnect_default);
+    RUN_TEST (reconnect_success);
+#ifdef ZMQ_BUILD_DRAFT_API
+    RUN_TEST (reconnect_stop_on_refused);
+    RUN_TEST (reconnect_stop_on_handshake_failed);
+#endif
+    return UNITY_END ();
+}
diff -pruN 4.3.2-2/tests/test_req_relaxed.cpp 4.3.3-1/tests/test_req_relaxed.cpp
--- 4.3.2-2/tests/test_req_relaxed.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_req_relaxed.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -28,8 +28,6 @@
 */
 
 #include "testutil.hpp"
-
-#include "testutil.hpp"
 #include "testutil_unity.hpp"
 
 #include <unity.h>
@@ -63,11 +61,12 @@ void setUp ()
           zmq_setsockopt (rep[peer], ZMQ_RCVTIMEO, &timeout, sizeof (int)));
 
         TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (rep[peer], my_endpoint));
+
+        //  These tests require strict ordering, so wait for the connections to
+        //  happen before opening the next, so that messages flow in the
+        //  expected direction
+        msleep (SETTLE_TIME);
     }
-    //  We have to give the connects time to finish otherwise the requests
-    //  will not properly round-robin. We could alternatively connect the
-    //  REQ sockets to the REP sockets.
-    msleep (SETTLE_TIME);
 }
 
 void tearDown ()
diff -pruN 4.3.2-2/tests/test_router_notify.cpp 4.3.3-1/tests/test_router_notify.cpp
--- 4.3.2-2/tests/test_router_notify.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_router_notify.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -136,7 +136,7 @@ void test_sockopt_router_notify ()
 }
 
 
-void test_router_notify_helper (int opt_notify)
+void test_router_notify_helper (int opt_notify_)
 {
     void *router = test_context_socket (ZMQ_ROUTER);
     int opt_more;
@@ -148,7 +148,7 @@ void test_router_notify_helper (int opt_
 
     // valid values
     TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (
-      router, ZMQ_ROUTER_NOTIFY, &opt_notify, sizeof (opt_notify)));
+      router, ZMQ_ROUTER_NOTIFY, &opt_notify_, sizeof (opt_notify_)));
 
     bind_loopback_ipv4 (router, connect_address, sizeof connect_address);
 
@@ -162,7 +162,7 @@ void test_router_notify_helper (int opt_
     TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (dealer, connect_address));
 
     // connection notification msg
-    if (opt_notify & ZMQ_NOTIFY_CONNECT) {
+    if (opt_notify_ & ZMQ_NOTIFY_CONNECT) {
         // routing-id only message of the connect
         recv_string_expect_success (router, dealer_routing_id,
                                     0);             // 1st part: routing-id
@@ -188,7 +188,7 @@ void test_router_notify_helper (int opt_
     zmq_getsockopt (dealer, ZMQ_EVENTS, &opt_events, &opt_events_length);
 
     // connection notification msg
-    if (opt_notify & ZMQ_NOTIFY_DISCONNECT) {
+    if (opt_notify_ & ZMQ_NOTIFY_DISCONNECT) {
         // routing-id only message of the connect
         recv_string_expect_success (router, dealer_routing_id,
                                     0);             // 1st part: routing-id
diff -pruN 4.3.2-2/tests/test_security_curve.cpp 4.3.3-1/tests/test_security_curve.cpp
--- 4.3.2-2/tests/test_security_curve.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_security_curve.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -27,19 +27,26 @@
     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
-#include "testutil.hpp"
-#include "testutil_security.hpp"
-#if defined(ZMQ_HAVE_WINDOWS)
-#include <winsock2.h>
-#include <ws2tcpip.h>
-#include <stdexcept>
-#define close closesocket
+// TODO remove this workaround for handling libsodium/tweetnacl
+
+//  To define SIZE_MAX with older compilers
+#define __STDC_LIMIT_MACROS
+
+#if defined ZMQ_CUSTOM_PLATFORM_HPP
+#include "platform.hpp"
 #else
-#include <sys/socket.h>
-#include <netinet/in.h>
-#include <arpa/inet.h>
-#include <unistd.h>
+#include "../src/platform.hpp"
 #endif
+
+#ifndef ZMQ_USE_TWEETNACL
+#define ZMQ_USE_TWEETNACL
+#endif
+#ifdef ZMQ_USE_LIBSODIUM
+#undef ZMQ_USE_LIBSODIUM
+#endif
+
+#include "testutil.hpp"
+#include "testutil_security.hpp"
 #include <unity.h>
 
 #include "../src/tweetnacl.h"
@@ -82,9 +89,9 @@ static void zap_handler_large_routing_id
     zap_handler_generic (zap_ok, large_routing_id);
 }
 
-void expect_new_client_curve_bounce_fail (char *server_public_,
-                                          char *client_public_,
-                                          char *client_secret_,
+void expect_new_client_curve_bounce_fail (const char *server_public_,
+                                          const char *client_public_,
+                                          const char *client_secret_,
                                           char *my_endpoint_,
                                           void *server_,
                                           void **client_mon_ = NULL,
@@ -205,33 +212,10 @@ void test_curve_security_with_plain_clie
     expect_zmtp_mechanism_mismatch (client, my_endpoint, server, server_mon);
 }
 
-fd_t connect_vanilla_socket (char *my_endpoint_)
-{
-    fd_t s;
-    struct sockaddr_in ip4addr;
-
-    unsigned short int port;
-    int rc = sscanf (my_endpoint_, "tcp://127.0.0.1:%hu", &port);
-    TEST_ASSERT_EQUAL_INT (1, rc);
-
-    ip4addr.sin_family = AF_INET;
-    ip4addr.sin_port = htons (port);
-#if defined(ZMQ_HAVE_WINDOWS) && (_WIN32_WINNT < 0x0600)
-    ip4addr.sin_addr.s_addr = inet_addr ("127.0.0.1");
-#else
-    inet_pton (AF_INET, "127.0.0.1", &ip4addr.sin_addr);
-#endif
-
-    s = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);
-    rc = connect (s, (struct sockaddr *) &ip4addr, sizeof (ip4addr));
-    TEST_ASSERT_GREATER_THAN_INT (-1, rc);
-    return s;
-}
-
 void test_curve_security_unauthenticated_message ()
 {
     // Unauthenticated messages from a vanilla socket shouldn't be received
-    fd_t s = connect_vanilla_socket (my_endpoint);
+    fd_t s = connect_socket (my_endpoint);
     // send anonymous ZMTP/1.0 greeting
     send (s, "\x01\x00", 2, 0);
     // send sneaky message that shouldn't be received
@@ -258,21 +242,16 @@ template <size_t N> void send (fd_t fd_,
     send_all (fd_, data_, N - 1);
 }
 
-void send_greeting (fd_t s_)
+template <size_t N> void send (fd_t fd_, const uint8_t (&data_)[N])
 {
-    send (s_, "\xff\0\0\0\0\0\0\0\0\x7f");            // signature
-    send (s_, "\x03\x00");                            // version 3.0
-    send (s_, "CURVE\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"); // mechanism CURVE
-    send (s_, "\0");                                  // as-server == false
-    send (s_, "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0");
+    send_all (fd_, reinterpret_cast<const char *> (&data_), N);
 }
 
 void test_curve_security_invalid_hello_wrong_length ()
 {
-    fd_t s = connect_vanilla_socket (my_endpoint);
+    fd_t s = connect_socket (my_endpoint);
 
-    // send GREETING
-    send_greeting (s);
+    send (s, zmtp_greeting_curve);
 
     // send CURVE HELLO of wrong size
     send (s, "\x04\x06\x05HELLO");
@@ -316,9 +295,8 @@ static uint64_t host_to_network (uint64_
           htonl (static_cast<uint32_t> (value_ & 0xFFFFFFFFLL));
 
         return (static_cast<uint64_t> (low_part) << 32) | high_part;
-    } else {
-        return value_;
     }
+    return value_;
 }
 
 template <size_t N> void send_command (fd_t s_, char (&command_)[N])
@@ -330,16 +308,16 @@ template <size_t N> void send_command (f
     } else {
         send (s_, "\x06");
         uint64_t len = host_to_network (N);
-        send_all (s_, (char *) &len, 8);
+        send_all (s_, reinterpret_cast<char *> (&len), 8);
     }
     send_all (s_, command_, N);
 }
 
 void test_curve_security_invalid_hello_command_name ()
 {
-    fd_t s = connect_vanilla_socket (my_endpoint);
+    fd_t s = connect_socket (my_endpoint);
 
-    send_greeting (s);
+    send (s, zmtp_greeting_curve);
 
     zmq::curve_client_tools_t tools = make_curve_client_tools ();
 
@@ -359,9 +337,9 @@ void test_curve_security_invalid_hello_c
 
 void test_curve_security_invalid_hello_version ()
 {
-    fd_t s = connect_vanilla_socket (my_endpoint);
+    fd_t s = connect_socket (my_endpoint);
 
-    send_greeting (s);
+    send (s, zmtp_greeting_curve);
 
     zmq::curve_client_tools_t tools = make_curve_client_tools ();
 
@@ -393,7 +371,7 @@ void recv_all (fd_t fd_, uint8_t *data_,
 {
     socket_size_t received = 0;
     while (received < len_) {
-        int res = recv (fd_, (char *) data_, len_, 0);
+        int res = recv (fd_, reinterpret_cast<char *> (data_), len_, 0);
         TEST_ASSERT_GREATER_THAN_INT (0, res);
 
         data_ += res;
@@ -411,9 +389,9 @@ void recv_greeting (fd_t fd_)
 fd_t connect_exchange_greeting_and_send_hello (
   char *my_endpoint_, zmq::curve_client_tools_t &tools_)
 {
-    fd_t s = connect_vanilla_socket (my_endpoint_);
+    fd_t s = connect_socket (my_endpoint_);
 
-    send_greeting (s);
+    send (s, zmtp_greeting_curve);
     recv_greeting (s);
 
     // send valid CURVE HELLO
diff -pruN 4.3.2-2/tests/test_security_gssapi.cpp 4.3.3-1/tests/test_security_gssapi.cpp
--- 4.3.2-2/tests/test_security_gssapi.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_security_gssapi.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -28,18 +28,8 @@
 */
 
 #include "testutil.hpp"
+#include "testutil_monitoring.hpp"
 #include "testutil_unity.hpp"
-#if defined(ZMQ_HAVE_WINDOWS)
-#include <winsock2.h>
-#include <ws2tcpip.h>
-#include <stdexcept>
-#define close closesocket
-#else
-#include <sys/socket.h>
-#include <netinet/in.h>
-#include <arpa/inet.h>
-#include <unistd.h>
-#endif
 
 #include <stdlib.h>
 #include <string.h>
@@ -178,42 +168,6 @@ void tearDown ()
         zmq_threadclose (zap_thread);
 }
 
-//  Read one event off the monitor socket; return value and address
-//  by reference, if not null, and event number by value. Returns -1
-//  in case of error.
-static int get_monitor_event (void *monitor_, int *value_, char **address_)
-{
-    //  First frame in message contains event number and value
-    zmq_msg_t msg;
-    zmq_msg_init (&msg);
-    if (zmq_msg_recv (&msg, monitor_, 0) == -1)
-        return -1; //  Interruped, presumably
-    TEST_ASSERT_TRUE (zmq_msg_more (&msg));
-
-    uint8_t *data = (uint8_t *) zmq_msg_data (&msg);
-    uint16_t event = *(uint16_t *) (data);
-    if (value_)
-        *value_ = *(uint32_t *) (data + 2);
-    zmq_msg_close (&msg);
-
-    //  Second frame in message contains event address
-    zmq_msg_init (&msg);
-    if (zmq_msg_recv (&msg, monitor_, 0) == -1)
-        return -1; //  Interruped, presumably
-    TEST_ASSERT_FALSE (zmq_msg_more (&msg));
-
-    if (address_) {
-        uint8_t *data = (uint8_t *) zmq_msg_data (&msg);
-        size_t size = zmq_msg_size (&msg);
-        *address_ = (char *) malloc (size + 1);
-        memcpy (*address_, data, size);
-        *address_[size] = 0;
-    }
-    zmq_msg_close (&msg);
-
-    return event;
-}
-
 void test_valid_creds ()
 {
     void *client = test_context_socket (ZMQ_DEALER);
@@ -288,22 +242,7 @@ void test_plain_creds ()
 // Unauthenticated messages from a vanilla socket shouldn't be received
 void test_vanilla_socket ()
 {
-    struct sockaddr_in ip4addr;
-    int s;
-    unsigned short int port;
-    int rc = sscanf (my_endpoint, "tcp://127.0.0.1:%hu", &port);
-    TEST_ASSERT_EQUAL_INT (1, rc);
-    ip4addr.sin_family = AF_INET;
-    ip4addr.sin_port = htons (port);
-#if defined(ZMQ_HAVE_WINDOWS) && (_WIN32_WINNT < 0x0600)
-    ip4addr.sin_addr.s_addr = inet_addr ("127.0.0.1");
-#else
-    inet_pton (AF_INET, "127.0.0.1", &ip4addr.sin_addr);
-#endif
-
-    s = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);
-    rc = connect (s, (struct sockaddr *) &ip4addr, sizeof (ip4addr));
-    TEST_ASSERT_GREATER_THAN (-1, rc);
+    fd_t s = connect_socket (my_endpoint);
     // send anonymous ZMTP/1.0 greeting
     send (s, "\x01\x00", 2, 0);
     // send sneaky message that shouldn't be received
@@ -332,5 +271,4 @@ int main (void)
     RUN_TEST (test_vanilla_socket);
     RUN_TEST (test_unauth_creds);
     return UNITY_END ();
-    return 0;
 }
diff -pruN 4.3.2-2/tests/test_security_null.cpp 4.3.3-1/tests/test_security_null.cpp
--- 4.3.2-2/tests/test_security_null.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_security_null.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -169,24 +169,8 @@ void test_vanilla_socket ()
     char my_endpoint[MAX_SOCKET_STRING];
     bind_loopback_ipv4 (server, my_endpoint, sizeof my_endpoint);
 
-    struct sockaddr_in ip4addr;
-    fd_t s;
+    fd_t s = connect_socket (my_endpoint);
 
-    unsigned short int port;
-    int rc = sscanf (my_endpoint, "tcp://127.0.0.1:%hu", &port);
-    TEST_ASSERT_EQUAL_INT (1, rc);
-
-    ip4addr.sin_family = AF_INET;
-    ip4addr.sin_port = htons (port);
-#if defined(ZMQ_HAVE_WINDOWS) && (_WIN32_WINNT < 0x0600)
-    ip4addr.sin_addr.s_addr = inet_addr ("127.0.0.1");
-#else
-    inet_pton (AF_INET, "127.0.0.1", &ip4addr.sin_addr);
-#endif
-
-    s = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);
-    rc = connect (s, (struct sockaddr *) &ip4addr, sizeof ip4addr);
-    TEST_ASSERT_GREATER_THAN_INT (-1, rc);
     // send anonymous ZMTP/1.0 greeting
     send (s, "\x01\x00", 2, 0);
     // send sneaky message that shouldn't be received
diff -pruN 4.3.2-2/tests/test_security_plain.cpp 4.3.3-1/tests/test_security_plain.cpp
--- 4.3.2-2/tests/test_security_plain.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_security_plain.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -30,18 +30,6 @@
 #include "testutil.hpp"
 #include "testutil_unity.hpp"
 
-#if defined(ZMQ_HAVE_WINDOWS)
-#include <winsock2.h>
-#include <ws2tcpip.h>
-#include <stdexcept>
-#define close closesocket
-#else
-#include <sys/socket.h>
-#include <netinet/in.h>
-#include <arpa/inet.h>
-#include <unistd.h>
-#endif
-
 #include <stdlib.h>
 #include <string.h>
 
@@ -195,24 +183,7 @@ void test_plain_wrong_credentials_fails
 void test_plain_vanilla_socket ()
 {
     // Unauthenticated messages from a vanilla socket shouldn't be received
-    struct sockaddr_in ip4addr;
-    fd_t s;
-
-    unsigned short int port;
-    int rc = sscanf (my_endpoint, "tcp://127.0.0.1:%hu", &port);
-    TEST_ASSERT_EQUAL_INT (1, rc);
-
-    ip4addr.sin_family = AF_INET;
-    ip4addr.sin_port = htons (port);
-#if defined(ZMQ_HAVE_WINDOWS) && (_WIN32_WINNT < 0x0600)
-    ip4addr.sin_addr.s_addr = inet_addr ("127.0.0.1");
-#else
-    inet_pton (AF_INET, "127.0.0.1", &ip4addr.sin_addr);
-#endif
-
-    s = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);
-    rc = connect (s, (struct sockaddr *) &ip4addr, sizeof (ip4addr));
-    TEST_ASSERT_GREATER_THAN_INT (-1, rc);
+    fd_t s = connect_socket (my_endpoint);
     // send anonymous ZMTP/1.0 greeting
     send (s, "\x01\x00", 2, 0);
     // send sneaky message that shouldn't be received
diff -pruN 4.3.2-2/tests/test_shutdown_stress.cpp 4.3.3-1/tests/test_shutdown_stress.cpp
--- 4.3.2-2/tests/test_shutdown_stress.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_shutdown_stress.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -48,7 +48,7 @@ struct thread_data
 extern "C" {
 static void worker (void *data_)
 {
-    struct thread_data *tdata = (struct thread_data *) data_;
+    const thread_data *const tdata = static_cast<const thread_data *> (data_);
 
     void *socket = zmq_socket (get_test_context (), ZMQ_SUB);
 
diff -pruN 4.3.2-2/tests/test_shutdown_stress_tipc.cpp 4.3.3-1/tests/test_shutdown_stress_tipc.cpp
--- 4.3.2-2/tests/test_shutdown_stress_tipc.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_shutdown_stress_tipc.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -43,12 +43,13 @@ void tearDown ()
 #define THREAD_COUNT 100
 
 extern "C" {
-static void *worker (void *s_)
+static void *worker (void *ctx)
 {
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (s_, "tipc://{5560,0}@0.0.0"));
+    void *s = zmq_socket (ctx, ZMQ_SUB);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (s, "tipc://{5560,0}@0.0.0"));
 
     //  Start closing the socket while the connecting process is underway.
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_close (s_));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_close (s));
 
     return NULL;
 }
@@ -57,7 +58,6 @@ static void *worker (void *s_)
 void test_shutdown_stress_tipc ()
 {
     void *s1;
-    void *s2;
     int i;
     int j;
     pthread_t threads[THREAD_COUNT];
@@ -72,9 +72,8 @@ void test_shutdown_stress_tipc ()
         TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (s1, "tipc://{5560,0,0}"));
 
         for (i = 0; i != THREAD_COUNT; i++) {
-            s2 = zmq_socket (get_test_context (), ZMQ_SUB);
             TEST_ASSERT_SUCCESS_RAW_ERRNO (
-              pthread_create (&threads[i], NULL, worker, s2));
+              pthread_create (&threads[i], NULL, worker, get_test_context ()));
         }
 
         for (i = 0; i != THREAD_COUNT; i++) {
diff -pruN 4.3.2-2/tests/test_socket_null.cpp 4.3.3-1/tests/test_socket_null.cpp
--- 4.3.2-2/tests/test_socket_null.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_socket_null.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -42,8 +42,7 @@ void tearDown ()
 //  tests all socket-related functions with a NULL socket argument
 void test_zmq_socket_null_context ()
 {
-    void *s = zmq_socket (NULL, ZMQ_PAIR);
-    TEST_ASSERT_NULL (s);
+    TEST_ASSERT_NULL (zmq_socket (NULL, ZMQ_PAIR));
     TEST_ASSERT_EQUAL_INT (EFAULT, errno); // TODO use EINVAL instead?
 }
 
diff -pruN 4.3.2-2/tests/test_socket_options_fuzzer.cpp 4.3.3-1/tests/test_socket_options_fuzzer.cpp
--- 4.3.2-2/tests/test_socket_options_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_socket_options_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,98 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+#ifdef ZMQ_DISCONNECT_MSG
+#define LAST_OPTION ZMQ_DISCONNECT_MSG
+#else
+#define LAST_OPTION ZMQ_BINDTODEVICE
+#endif
+
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    int option;
+    void *ctx = zmq_ctx_new ();
+    TEST_ASSERT_NOT_NULL (ctx);
+    void *server = zmq_socket (ctx, ZMQ_XPUB);
+    TEST_ASSERT_NOT_NULL (server);
+
+    if (!size)
+        return 0;
+
+    for (option = ZMQ_AFFINITY; option <= LAST_OPTION; ++option) {
+        uint8_t out[8192];
+        size_t out_size = 8192;
+
+        zmq_setsockopt (server, option, data, size);
+        zmq_getsockopt (server, option, out, &out_size);
+    }
+
+    zmq_close (server);
+    zmq_ctx_term (ctx);
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_socket_options_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_socket_options_fuzzer_seed_corpus",
+          &data, &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_socket_options_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/tests/test_socks.cpp 4.3.3-1/tests/test_socks.cpp
--- 4.3.2-2/tests/test_socks.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_socks.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -27,10 +27,15 @@
     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
+#ifdef _WIN32
+#include "../src/windows.hpp"
+#else
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <unistd.h>
+#endif
+
 #include <stdlib.h>
 #include <string.h>
 #include <stdio.h>
@@ -100,16 +105,10 @@ void *setup_socks_server (char *socks_se
                           int socks_server_address_len)
 {
     fprintf (stderr, "socks_server: setup socks server\n");
-    int server_fd = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);
-    TEST_ASSERT_NOT_EQUAL (-1, server_fd);
-    int flag = 1;
-    int res;
-    res = setsockopt (server_fd, SOL_SOCKET, SO_REUSEADDR, &flag, sizeof (int));
-    TEST_ASSERT_SUCCESS_RAW_ERRNO (res);
-    struct sockaddr_in saddr = bind_bsd_socket (server_fd);
-    int nbytes = snprintf (socks_server_address, socks_server_address_len,
-                           "127.0.0.1:%d", ntohs (saddr.sin_port));
-    TEST_ASSERT (nbytes >= 0 && nbytes < socks_server_address_len);
+    int server_fd =
+      bind_socket_resolve_port ("127.0.0.1", "0", socks_server_address);
+    memmove (socks_server_address, strchr (socks_server_address, '/') + 2,
+             strlen (strchr (socks_server_address, '/') + 1));
     fprintf (stderr, "socks_server: bound to: tcp://%s\n",
              socks_server_address);
     return (void *) (intptr_t) server_fd;
diff -pruN 4.3.2-2/tests/test_spec_pushpull.cpp 4.3.3-1/tests/test_spec_pushpull.cpp
--- 4.3.2-2/tests/test_spec_pushpull.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_spec_pushpull.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -130,7 +130,7 @@ void test_pull_fair_queue_in (const char
     for (size_t peer = 0; peer < services; ++peer) {
         TEST_ASSERT_EQUAL_INT (
           2, TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_recv (&msg, pull, 0)));
-        const char *str = (const char *) zmq_msg_data (&msg);
+        const char *str = static_cast<const char *> (zmq_msg_data (&msg));
         first_half -= str[0];
     }
     TEST_ASSERT_EQUAL_INT (0, first_half);
@@ -139,7 +139,7 @@ void test_pull_fair_queue_in (const char
     for (size_t peer = 0; peer < services; ++peer) {
         TEST_ASSERT_EQUAL_INT (
           2, TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_recv (&msg, pull, 0)));
-        const char *str = (const char *) zmq_msg_data (&msg);
+        const char *str = static_cast<const char *> (zmq_msg_data (&msg));
         second_half -= str[0];
     }
     TEST_ASSERT_EQUAL_INT (0, second_half);
@@ -237,7 +237,7 @@ void test_destroy_queue_on_disconnect (c
 
 // PUSH and PULL: SHALL either receive or drop multipart messages atomically.
 void test_push_multipart_atomic_drop (const char *bind_address_,
-                                      const bool block)
+                                      const bool block_)
 {
     int linger = 0;
     int hwm = 1;
@@ -312,7 +312,7 @@ void test_push_multipart_atomic_drop (co
     send_string_expect_success (push, "3", ZMQ_SNDMORE);
     TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_size (&msg_data, len));
     memset (zmq_msg_data (&msg_data), 'c', len);
-    if (block) {
+    if (block_) {
         TEST_ASSERT_EQUAL_INT (len,
                                zmq_msg_send (&msg_data, push, ZMQ_SNDMORE));
     } else {
diff -pruN 4.3.2-2/tests/test_spec_rep.cpp 4.3.3-1/tests/test_spec_rep.cpp
--- 4.3.2-2/tests/test_spec_rep.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_spec_rep.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -36,7 +36,7 @@ SETUP_TEARDOWN_TESTCONTEXT
 
 char connect_address[MAX_SOCKET_STRING];
 
-void test_fair_queue_in (const char *bind_address)
+void test_fair_queue_in (const char *bind_address_)
 {
     void *rep = test_context_socket (ZMQ_REP);
 
@@ -44,7 +44,7 @@ void test_fair_queue_in (const char *bin
     TEST_ASSERT_SUCCESS_ERRNO (
       zmq_setsockopt (rep, ZMQ_RCVTIMEO, &timeout, sizeof (int)));
 
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (rep, bind_address));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (rep, bind_address_));
     size_t len = MAX_SOCKET_STRING;
     TEST_ASSERT_SUCCESS_ERRNO (
       zmq_getsockopt (rep, ZMQ_LAST_ENDPOINT, connect_address, &len));
@@ -98,11 +98,11 @@ void test_fair_queue_in (const char *bin
         test_context_socket_close_zero_linger (reqs[peer]);
 }
 
-void test_envelope (const char *bind_address)
+void test_envelope (const char *bind_address_)
 {
     void *rep = test_context_socket (ZMQ_REP);
 
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (rep, bind_address));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (rep, bind_address_));
     size_t len = MAX_SOCKET_STRING;
     TEST_ASSERT_SUCCESS_ERRNO (
       zmq_getsockopt (rep, ZMQ_LAST_ENDPOINT, connect_address, &len));
diff -pruN 4.3.2-2/tests/test_spec_router.cpp 4.3.3-1/tests/test_spec_router.cpp
--- 4.3.2-2/tests/test_spec_router.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_spec_router.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -37,7 +37,7 @@ SETUP_TEARDOWN_TESTCONTEXT
 
 // SHALL receive incoming messages from its peers using a fair-queuing
 // strategy.
-void test_fair_queue_in (const char *bind_address)
+void test_fair_queue_in (const char *bind_address_)
 {
     char connect_address[MAX_SOCKET_STRING];
     void *receiver = test_context_socket (ZMQ_ROUTER);
@@ -46,7 +46,7 @@ void test_fair_queue_in (const char *bin
     TEST_ASSERT_SUCCESS_ERRNO (
       zmq_setsockopt (receiver, ZMQ_RCVTIMEO, &timeout, sizeof (int)));
 
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (receiver, bind_address));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (receiver, bind_address_));
     size_t len = MAX_SOCKET_STRING;
     TEST_ASSERT_SUCCESS_ERRNO (
       zmq_getsockopt (receiver, ZMQ_LAST_ENDPOINT, connect_address, &len));
@@ -116,7 +116,7 @@ void test_fair_queue_in (const char *bin
 // SHALL create a double queue when a peer connects to it. If this peer
 // disconnects, the ROUTER socket SHALL destroy its double queue and SHALL
 // discard any messages it contains.
-void test_destroy_queue_on_disconnect (const char *bind_address)
+void test_destroy_queue_on_disconnect (const char *bind_address_)
 {
     void *a = test_context_socket (ZMQ_ROUTER);
 
@@ -124,7 +124,7 @@ void test_destroy_queue_on_disconnect (c
     TEST_ASSERT_SUCCESS_ERRNO (
       zmq_setsockopt (a, ZMQ_ROUTER_MANDATORY, &enabled, sizeof (enabled)));
 
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (a, bind_address));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (a, bind_address_));
     size_t len = MAX_SOCKET_STRING;
     char connect_address[MAX_SOCKET_STRING];
     TEST_ASSERT_SUCCESS_ERRNO (
diff -pruN 4.3.2-2/tests/test_stream.cpp 4.3.3-1/tests/test_stream.cpp
--- 4.3.2-2/tests/test_stream.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_stream.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -40,7 +40,7 @@ typedef uint8_t byte;
 typedef struct
 {
     byte signature[10]; //  0xFF 8*0x00 0x7F
-    byte version[2];    //  0x03 0x00 for ZMTP/3.0
+    byte version[2];    //  0x03 0x01 for ZMTP/3.1
     byte mechanism[20]; //  "NULL"
     byte as_server;
     byte filler[31];
@@ -52,7 +52,7 @@ typedef struct
 //  8-byte size is set to 1 for backwards compatibility
 
 static zmtp_greeting_t greeting = {
-  {0xFF, 0, 0, 0, 0, 0, 0, 0, 1, 0x7F}, {3, 0}, {'N', 'U', 'L', 'L'}, 0, {0}};
+  {0xFF, 0, 0, 0, 0, 0, 0, 0, 1, 0x7F}, {3, 1}, {'N', 'U', 'L', 'L'}, 0, {0}};
 
 static void test_stream_to_dealer ()
 {
@@ -135,8 +135,8 @@ static void test_stream_to_dealer ()
     }
 
     //  First two bytes are major and minor version numbers.
-    TEST_ASSERT_EQUAL_INT (3, buffer[0]); //  ZMTP/3.0
-    TEST_ASSERT_EQUAL_INT (0, buffer[1]);
+    TEST_ASSERT_EQUAL_INT (3, buffer[0]); //  ZMTP/3.1
+    TEST_ASSERT_EQUAL_INT (1, buffer[1]);
 
     //  Mechanism is "NULL"
     TEST_ASSERT_EQUAL_INT8_ARRAY (buffer + 2,
diff -pruN 4.3.2-2/tests/test_stream_disconnect.cpp 4.3.3-1/tests/test_stream_disconnect.cpp
--- 4.3.2-2/tests/test_stream_disconnect.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_stream_disconnect.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -168,7 +168,8 @@ void test_stream_disconnect ()
               zmq_msg_recv (&data_frame, sockets[SERVER], 0));
 
             // Make sure payload matches what we expect.
-            const char *const data = (const char *) zmq_msg_data (&data_frame);
+            const char *const data =
+              static_cast<const char *> (zmq_msg_data (&data_frame));
             const size_t size = zmq_msg_size (&data_frame);
             // 0-length frame is a disconnection notification.  The server
             // should receive it as the last step in the dialogue.
@@ -222,7 +223,8 @@ void test_stream_disconnect ()
             TEST_ASSERT_GREATER_THAN_INT (0, zmq_msg_size (&data_frame));
 
             // Make sure payload matches what we expect.
-            const char *const data = (const char *) zmq_msg_data (&data_frame);
+            const char *const data =
+              static_cast<const char *> (zmq_msg_data (&data_frame));
             const size_t size = zmq_msg_size (&data_frame);
             TEST_ASSERT_EQUAL_INT (strlen (dialog[step].text), size);
             TEST_ASSERT_EQUAL_STRING_LEN (dialog[step].text, data, size);
diff -pruN 4.3.2-2/tests/test_stream_exceeds_buffer.cpp 4.3.3-1/tests/test_stream_exceeds_buffer.cpp
--- 4.3.2-2/tests/test_stream_exceeds_buffer.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_stream_exceeds_buffer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -32,12 +32,6 @@
 
 #include <string.h>
 
-#ifndef _WIN32
-#include <netinet/in.h>
-#include <arpa/inet.h>
-#include <unistd.h>
-#endif
-
 SETUP_TEARDOWN_TESTCONTEXT
 
 void test_stream_exceeds_buffer ()
@@ -47,16 +41,7 @@ void test_stream_exceeds_buffer ()
     unsigned char rcvbuf[msgsize];
     char my_endpoint[MAX_SOCKET_STRING];
 
-    int server_sock =
-      TEST_ASSERT_SUCCESS_RAW_ERRNO (socket (AF_INET, SOCK_STREAM, 0));
-    int enable = 1;
-    TEST_ASSERT_SUCCESS_RAW_ERRNO (setsockopt (server_sock, SOL_SOCKET,
-                                               SO_REUSEADDR, (char *) &enable,
-                                               sizeof (enable)));
-    struct sockaddr_in saddr = bind_bsd_socket (server_sock);
-    TEST_ASSERT_SUCCESS_RAW_ERRNO (listen (server_sock, 1));
-
-    sprintf (my_endpoint, "tcp://127.0.0.1:%d", ntohs (saddr.sin_port));
+    int server_sock = bind_socket_resolve_port ("127.0.0.1", "0", my_endpoint);
 
     void *zsock = test_context_socket (ZMQ_STREAM);
     TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (zsock, my_endpoint));
diff -pruN 4.3.2-2/tests/test_stream_timeout.cpp 4.3.3-1/tests/test_stream_timeout.cpp
--- 4.3.2-2/tests/test_stream_timeout.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_stream_timeout.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -28,6 +28,7 @@
 */
 
 #include "testutil.hpp"
+#include "testutil_monitoring.hpp"
 #include "testutil_unity.hpp"
 
 #include <stdlib.h>
@@ -35,40 +36,6 @@
 
 SETUP_TEARDOWN_TESTCONTEXT
 
-//  Read one event off the monitor socket; return value and address
-//  by reference, if not null, and event number by value. Returns -1
-//  in case of error.
-
-static int get_monitor_event (void *monitor_, int *value_, char **address_)
-{
-    //  First frame in message contains event number and value
-    zmq_msg_t msg;
-    zmq_msg_init (&msg);
-    if (zmq_msg_recv (&msg, monitor_, 0) == -1)
-        return -1; //  Interruped, presumably
-    TEST_ASSERT_TRUE (zmq_msg_more (&msg));
-
-    uint8_t *data = (uint8_t *) zmq_msg_data (&msg);
-    uint16_t event = *(uint16_t *) (data);
-    if (value_)
-        *value_ = *(uint32_t *) (data + 2);
-
-    //  Second frame in message contains event address
-    zmq_msg_init (&msg);
-    if (zmq_msg_recv (&msg, monitor_, 0) == -1)
-        return -1; //  Interruped, presumably
-    TEST_ASSERT_TRUE (!zmq_msg_more (&msg));
-
-    if (address_) {
-        uint8_t *data = (uint8_t *) zmq_msg_data (&msg);
-        size_t size = zmq_msg_size (&msg);
-        *address_ = (char *) malloc (size + 1);
-        memcpy (*address_, data, size);
-        *address_[size] = 0;
-    }
-    return event;
-}
-
 static void test_stream_handshake_timeout_accept ()
 {
     char my_endpoint[MAX_SOCKET_STRING];
diff -pruN 4.3.2-2/tests/test_system.cpp 4.3.3-1/tests/test_system.cpp
--- 4.3.2-2/tests/test_system.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_system.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -85,7 +85,7 @@ void test_max_sockets ()
     int count;
     for (count = 0; count < MAX_SOCKETS; count++) {
         handle[count] = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);
-        if (handle[count] == -1) {
+        if (handle[count] == retired_fd) {
             printf ("W: Only able to create %d sockets on this box\n", count);
             const char msg[] =
               "I: Tune your system to increase maximum allowed file handles\n"
diff -pruN 4.3.2-2/tests/test_tcp_accept_filter.cpp 4.3.3-1/tests/test_tcp_accept_filter.cpp
--- 4.3.2-2/tests/test_tcp_accept_filter.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_tcp_accept_filter.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,215 @@
+/*
+    Copyright (c) 2017 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+#include <cstring>
+
+SETUP_TEARDOWN_TESTCONTEXT
+
+void test_reconnect_ivl_against_pair_socket (const char *my_endpoint_,
+                                             void *sb_)
+{
+    void *sc = test_context_socket (ZMQ_PAIR);
+    int interval = -1;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (sc, ZMQ_RECONNECT_IVL, &interval, sizeof (int)));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sc, my_endpoint_));
+
+    bounce (sb_, sc);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_unbind (sb_, my_endpoint_));
+
+    expect_bounce_fail (sb_, sc);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (sb_, my_endpoint_));
+
+    expect_bounce_fail (sb_, sc);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sc, my_endpoint_));
+
+    bounce (sb_, sc);
+
+    test_context_socket_close (sc);
+}
+
+void test_reconnect_ivl_tcp (bind_function_t bind_function_)
+{
+    char my_endpoint[MAX_SOCKET_STRING];
+
+    void *sb = test_context_socket (ZMQ_PAIR);
+    bind_function_ (sb, my_endpoint, sizeof my_endpoint);
+
+    test_reconnect_ivl_against_pair_socket (my_endpoint, sb);
+    test_context_socket_close (sb);
+}
+
+void test_bad_filter_string (const char *const filter_)
+{
+    void *socket = test_context_socket (ZMQ_PAIR);
+
+    TEST_ASSERT_FAILURE_ERRNO (EINVAL,
+                               zmq_setsockopt (socket, ZMQ_TCP_ACCEPT_FILTER,
+                                               filter_, strlen (filter_)));
+
+    test_context_socket_close (socket);
+}
+
+#define TEST_BAD_FILTER_STRING(case, filter)                                   \
+    void test_bad_filter_string_##case () { test_bad_filter_string (filter); }
+
+TEST_BAD_FILTER_STRING (foo, "foo")
+TEST_BAD_FILTER_STRING (zeros_foo, "0.0.0.0foo")
+TEST_BAD_FILTER_STRING (zeros_foo_mask, "0.0.0.0/foo")
+TEST_BAD_FILTER_STRING (zeros_empty_mask, "0.0.0.0/")
+TEST_BAD_FILTER_STRING (zeros_negative_mask, "0.0.0.0/-1")
+TEST_BAD_FILTER_STRING (zeros_too_large_mask, "0.0.0.0/33")
+
+void test_clear ()
+{
+    void *bind_socket = test_context_socket (ZMQ_PAIR);
+
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (bind_socket, ZMQ_TCP_ACCEPT_FILTER, NULL, 0));
+
+#if 0
+    // XXX Shouldn't this work as well?
+    const char empty_filter[] = "";
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (
+      socket, ZMQ_TCP_ACCEPT_FILTER, empty_filter, strlen (empty_filter)));
+#endif
+
+    char endpoint[MAX_SOCKET_STRING];
+    bind_loopback_ipv4 (bind_socket, endpoint, sizeof (endpoint));
+
+    void *connect_socket = test_context_socket (ZMQ_PAIR);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (connect_socket, endpoint));
+
+    bounce (bind_socket, connect_socket);
+
+    test_context_socket_close (connect_socket);
+    test_context_socket_close (bind_socket);
+}
+
+const char non_matching_filter[] = "127.0.0.255/32";
+
+void test_set_non_matching_and_clear ()
+{
+    void *bind_socket = test_context_socket (ZMQ_PAIR);
+
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (bind_socket, ZMQ_TCP_ACCEPT_FILTER, non_matching_filter,
+                      strlen (non_matching_filter)));
+
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (bind_socket, ZMQ_TCP_ACCEPT_FILTER, NULL, 0));
+
+    char endpoint[MAX_SOCKET_STRING];
+    bind_loopback_ipv4 (bind_socket, endpoint, sizeof (endpoint));
+
+    void *connect_socket = test_context_socket (ZMQ_PAIR);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (connect_socket, endpoint));
+
+    bounce (bind_socket, connect_socket);
+
+    test_context_socket_close (connect_socket);
+    test_context_socket_close (bind_socket);
+}
+
+void test_set_matching (const char *const filter_)
+{
+    void *bind_socket = test_context_socket (ZMQ_PAIR);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (
+      bind_socket, ZMQ_TCP_ACCEPT_FILTER, filter_, strlen (filter_)));
+
+    char endpoint[MAX_SOCKET_STRING];
+    bind_loopback_ipv4 (bind_socket, endpoint, sizeof (endpoint));
+
+    void *connect_socket = test_context_socket (ZMQ_PAIR);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (connect_socket, endpoint));
+
+    bounce (bind_socket, connect_socket);
+
+    test_context_socket_close (connect_socket);
+    test_context_socket_close (bind_socket);
+}
+
+void test_set_matching_1 ()
+{
+    test_set_matching ("127.0.0.1/32");
+}
+
+void test_set_matching_2 ()
+{
+    test_set_matching ("0.0.0.0/0");
+}
+
+void test_set_non_matching ()
+{
+    void *bind_socket = test_context_socket (ZMQ_PAIR);
+
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (bind_socket, ZMQ_TCP_ACCEPT_FILTER, non_matching_filter,
+                      strlen (non_matching_filter)));
+
+    char endpoint[MAX_SOCKET_STRING];
+    bind_loopback_ipv4 (bind_socket, endpoint, sizeof (endpoint));
+
+    void *connect_socket = test_context_socket (ZMQ_PAIR);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (connect_socket, endpoint));
+
+    expect_bounce_fail (bind_socket, connect_socket);
+
+    test_context_socket_close_zero_linger (connect_socket);
+    test_context_socket_close_zero_linger (bind_socket);
+}
+
+int main ()
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_bad_filter_string_foo);
+    RUN_TEST (test_bad_filter_string_zeros_foo);
+    RUN_TEST (test_bad_filter_string_zeros_foo_mask);
+    RUN_TEST (test_bad_filter_string_zeros_empty_mask);
+    RUN_TEST (test_bad_filter_string_zeros_negative_mask);
+    RUN_TEST (test_bad_filter_string_zeros_too_large_mask);
+
+    RUN_TEST (test_clear);
+    RUN_TEST (test_set_non_matching_and_clear);
+    RUN_TEST (test_set_matching_1);
+    RUN_TEST (test_set_matching_2);
+
+    RUN_TEST (test_set_non_matching);
+
+    return UNITY_END ();
+}
diff -pruN 4.3.2-2/tests/test_timers.cpp 4.3.3-1/tests/test_timers.cpp
--- 4.3.2-2/tests/test_timers.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_timers.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -42,7 +42,7 @@ void tearDown ()
 void handler (int timer_id_, void *arg_)
 {
     (void) timer_id_; //  Stop 'unused' compiler warnings
-    *((bool *) arg_) = true;
+    *(static_cast<bool *> (arg_)) = true;
 }
 
 int sleep_and_execute (void *timers_)
diff -pruN 4.3.2-2/tests/test_use_fd.cpp 4.3.3-1/tests/test_use_fd.cpp
--- 4.3.2-2/tests/test_use_fd.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_use_fd.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -37,33 +37,12 @@
 SETUP_TEARDOWN_TESTCONTEXT
 
 #if !defined(ZMQ_HAVE_WINDOWS)
-#include <sys/socket.h>
-#include <sys/un.h>
-#include <netdb.h>
-#include <unistd.h>
-
-int setup_socket_and_set_fd (void *zmq_socket_,
-                             int af_,
-                             int protocol_,
-                             const sockaddr *addr_,
-                             size_t addr_len_)
-{
-    const int s_pre =
-      TEST_ASSERT_SUCCESS_ERRNO (socket (af_, SOCK_STREAM, protocol_));
-
-    if (af_ == AF_INET) {
-        int flag = 1;
-        TEST_ASSERT_SUCCESS_ERRNO (
-          setsockopt (s_pre, SOL_SOCKET, SO_REUSEADDR, &flag, sizeof (int)));
-    }
-
-    TEST_ASSERT_SUCCESS_ERRNO (bind (s_pre, addr_, addr_len_));
-    TEST_ASSERT_SUCCESS_ERRNO (listen (s_pre, SOMAXCONN));
 
+void pre_allocate_sock_tcp (void *socket_, char *my_endpoint_)
+{
+    fd_t s = bind_socket_resolve_port ("127.0.0.1", "0", my_endpoint_);
     TEST_ASSERT_SUCCESS_ERRNO (
-      zmq_setsockopt (zmq_socket_, ZMQ_USE_FD, &s_pre, sizeof (s_pre)));
-
-    return s_pre;
+      zmq_setsockopt (socket_, ZMQ_USE_FD, &s, sizeof (s)));
 }
 
 typedef void (*pre_allocate_sock_fun_t) (void *, char *);
@@ -119,7 +98,7 @@ void test_client_server (pre_allocate_so
     zmq_msg_t msg;
     TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_size (&msg, 1));
 
-    char *data = (char *) zmq_msg_data (&msg);
+    char *data = static_cast<char *> (zmq_msg_data (&msg));
     data[0] = 1;
 
     int rc = zmq_msg_send (&msg, sc, ZMQ_SNDMORE);
@@ -141,7 +120,7 @@ void test_client_server (pre_allocate_so
 
     TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_size (&msg, 1));
 
-    data = (char *) zmq_msg_data (&msg);
+    data = static_cast<char *> (zmq_msg_data (&msg));
     data[0] = 2;
 
     TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_set_routing_id (&msg, routing_id));
@@ -166,41 +145,6 @@ void test_client_server (pre_allocate_so
 #endif
 }
 
-uint16_t pre_allocate_sock_tcp_int (void *zmq_socket_,
-                                    const char *address_,
-                                    const char *port_)
-{
-    struct addrinfo *addr, hint;
-    hint.ai_flags = 0;
-    hint.ai_family = AF_INET;
-    hint.ai_socktype = SOCK_STREAM;
-    hint.ai_protocol = IPPROTO_TCP;
-    hint.ai_addrlen = 0;
-    hint.ai_canonname = NULL;
-    hint.ai_addr = NULL;
-    hint.ai_next = NULL;
-
-    TEST_ASSERT_SUCCESS_ERRNO (getaddrinfo (address_, port_, &hint, &addr));
-
-    const int s_pre = setup_socket_and_set_fd (
-      zmq_socket_, AF_INET, IPPROTO_TCP, addr->ai_addr, addr->ai_addrlen);
-
-    struct sockaddr_in sin;
-    socklen_t len = sizeof (sin);
-    TEST_ASSERT_SUCCESS_ERRNO (
-      getsockname (s_pre, (struct sockaddr *) &sin, &len));
-
-    freeaddrinfo (addr);
-
-    return ntohs (sin.sin_port);
-}
-
-void pre_allocate_sock_tcp (void *socket_, char *my_endpoint_)
-{
-    const uint16_t port = pre_allocate_sock_tcp_int (socket_, "127.0.0.1", "0");
-    sprintf (my_endpoint_, "tcp://127.0.0.1:%u", port);
-}
-
 void test_req_rep_tcp ()
 {
     test_req_rep (pre_allocate_sock_tcp);
@@ -218,37 +162,14 @@ void test_client_server_tcp ()
 #endif
 }
 
-void pre_allocate_sock_ipc_int (void *zmq_socket_, const char *path_)
-{
-    struct sockaddr_un addr;
-    addr.sun_family = AF_UNIX;
-    strcpy (addr.sun_path, path_);
-
-    // TODO check return value of unlink
-    unlink (path_);
-
-    setup_socket_and_set_fd (zmq_socket_, AF_UNIX, 0, (struct sockaddr *) &addr,
-                             sizeof (struct sockaddr_un));
-}
-
-char ipc_endpoint[16];
+char ipc_endpoint[MAX_SOCKET_STRING] = "";
 
 void pre_allocate_sock_ipc (void *sb_, char *my_endpoint_)
 {
-    strcpy (ipc_endpoint, "tmpXXXXXX");
-
-#ifdef HAVE_MKDTEMP
-    TEST_ASSERT_TRUE (mkdtemp (ipc_endpoint));
-    strcat (ipc_endpoint, "/ipc");
-#else
-    int fd = mkstemp (ipc_endpoint);
-    TEST_ASSERT_TRUE (fd != -1);
-    close (fd);
-#endif
-
-    pre_allocate_sock_ipc_int (sb_, ipc_endpoint);
-    strcpy (my_endpoint_, "ipc://");
-    strcat (my_endpoint_, ipc_endpoint);
+    fd_t s = bind_socket_resolve_port ("", "", my_endpoint_, AF_UNIX, 0);
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (sb_, ZMQ_USE_FD, &s, sizeof (s)));
+    strcpy (ipc_endpoint, strchr (my_endpoint_, '/') + 2);
 }
 
 void test_req_rep_ipc ()
diff -pruN 4.3.2-2/tests/testutil.cpp 4.3.3-1/tests/testutil.cpp
--- 4.3.2-2/tests/testutil.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/testutil.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -35,10 +35,14 @@
 #if defined _WIN32
 #include "../src/windows.hpp"
 #if defined _MSC_VER
+#if defined ZMQ_HAVE_IPC
+#include <direct.h>
+#include <afunix.h>
+#endif
 #include <crtdbg.h>
 #pragma warning(disable : 4996)
 // iphlpapi is needed for if_nametoindex (not on Windows XP)
-#if !defined ZMQ_HAVE_WINDOWS_TARGET_XP
+#if _WIN32_WINNT > _WIN32_WINNT_WINXP
 #pragma comment(lib, "iphlpapi")
 #endif
 #endif
@@ -55,6 +59,8 @@
 #include <arpa/inet.h>
 #include <net/if.h>
 #include <netdb.h>
+#include <sys/un.h>
+#include <dirent.h>
 #if defined(ZMQ_HAVE_AIX)
 #include <sys/types.h>
 #include <sys/socketvar.h>
@@ -215,7 +221,7 @@ void close_zero_linger (void *socket_)
     TEST_ASSERT_SUCCESS_ERRNO (zmq_close (socket_));
 }
 
-void setup_test_environment ()
+void setup_test_environment (int timeout_seconds_)
 {
 #if defined _WIN32
 #if defined _MSC_VER
@@ -229,8 +235,8 @@ void setup_test_environment ()
     alarm (121);
 #else
 #if !defined ZMQ_DISABLE_TEST_TIMEOUT
-    // abort test after 60 seconds
-    alarm (60);
+    // abort test after timeout_seconds_ seconds
+    alarm (timeout_seconds_);
 #endif
 #endif
 #endif
@@ -284,7 +290,8 @@ int is_ipv6_available ()
         if (rc != 0)
             ipv6 = 0;
         else {
-            rc = bind (fd, (struct sockaddr *) &test_addr, sizeof (test_addr));
+            rc = bind (fd, reinterpret_cast<struct sockaddr *> (&test_addr),
+                       sizeof (test_addr));
             if (rc != 0)
                 ipv6 = 0;
         }
@@ -342,7 +349,7 @@ int test_inet_pton (int af_, const char
 #endif
 }
 
-sockaddr_in bind_bsd_socket (int socket)
+sockaddr_in bind_bsd_socket (int socket_)
 {
     struct sockaddr_in saddr;
     memset (&saddr, 0, sizeof (saddr));
@@ -355,23 +362,251 @@ sockaddr_in bind_bsd_socket (int socket)
 #endif
 
     TEST_ASSERT_SUCCESS_RAW_ERRNO (
-      bind (socket, (struct sockaddr *) &saddr, sizeof (saddr)));
+      bind (socket_, (struct sockaddr *) &saddr, sizeof (saddr)));
 
 #if !defined(_WIN32_WINNT) || (_WIN32_WINNT >= 0x0600)
     socklen_t saddr_len = sizeof (saddr);
     TEST_ASSERT_SUCCESS_RAW_ERRNO (
-      getsockname (socket, (struct sockaddr *) &saddr, &saddr_len));
+      getsockname (socket_, (struct sockaddr *) &saddr, &saddr_len));
 #endif
 
     return saddr;
 }
 
-bool streq (const char *lhs, const char *rhs)
+fd_t connect_socket (const char *endpoint_, const int af_, const int protocol_)
+{
+    struct sockaddr_storage addr;
+    //  OSX is very opinionated and wants the size to match the AF family type
+    socklen_t addr_len;
+    const fd_t s_pre = socket (af_, SOCK_STREAM,
+                               protocol_ == IPPROTO_UDP
+                                 ? IPPROTO_UDP
+                                 : protocol_ == IPPROTO_TCP ? IPPROTO_TCP : 0);
+    TEST_ASSERT_NOT_EQUAL (-1, s_pre);
+
+    if (af_ == AF_INET || af_ == AF_INET6) {
+        const char *port = strrchr (endpoint_, ':') + 1;
+        char address[MAX_SOCKET_STRING];
+        // getaddrinfo does not like [x:y::z]
+        if (*strchr (endpoint_, '/') + 2 == '[') {
+            strcpy (address, strchr (endpoint_, '[') + 1);
+            address[strlen (address) - strlen (port) - 2] = '\0';
+        } else {
+            strcpy (address, strchr (endpoint_, '/') + 2);
+            address[strlen (address) - strlen (port) - 1] = '\0';
+        }
+
+        struct addrinfo *in, hint;
+        memset (&hint, 0, sizeof (struct addrinfo));
+        hint.ai_flags = AI_NUMERICSERV;
+        hint.ai_family = af_;
+        hint.ai_socktype = protocol_ == IPPROTO_UDP ? SOCK_DGRAM : SOCK_STREAM;
+        hint.ai_protocol = protocol_ == IPPROTO_UDP ? IPPROTO_UDP : IPPROTO_TCP;
+
+        TEST_ASSERT_SUCCESS_RAW_ZERO_ERRNO (
+          getaddrinfo (address, port, &hint, &in));
+        TEST_ASSERT_NOT_NULL (in);
+        memcpy (&addr, in->ai_addr, in->ai_addrlen);
+        addr_len = (socklen_t) in->ai_addrlen;
+        freeaddrinfo (in);
+    } else {
+#if defined(ZMQ_HAVE_IPC)
+        //  Cannot cast addr as gcc 4.4 will fail with strict aliasing errors
+        (*(struct sockaddr_un *) &addr).sun_family = AF_UNIX;
+        strcpy ((*(struct sockaddr_un *) &addr).sun_path, endpoint_);
+        addr_len = sizeof (struct sockaddr_un);
+#else
+        return retired_fd;
+#endif
+    }
+
+    TEST_ASSERT_SUCCESS_RAW_ERRNO (
+      connect (s_pre, (struct sockaddr *) &addr, addr_len));
+
+    return s_pre;
+}
+
+fd_t bind_socket_resolve_port (const char *address_,
+                               const char *port_,
+                               char *my_endpoint_,
+                               const int af_,
+                               const int protocol_)
+{
+    struct sockaddr_storage addr;
+    //  OSX is very opinionated and wants the size to match the AF family type
+    socklen_t addr_len;
+    const fd_t s_pre = socket (af_, SOCK_STREAM,
+                               protocol_ == IPPROTO_UDP
+                                 ? IPPROTO_UDP
+                                 : protocol_ == IPPROTO_TCP ? IPPROTO_TCP : 0);
+    TEST_ASSERT_NOT_EQUAL (-1, s_pre);
+
+    if (af_ == AF_INET || af_ == AF_INET6) {
+#ifdef ZMQ_HAVE_WINDOWS
+        const char flag = '\1';
+#elif defined ZMQ_HAVE_VXWORKS
+        char flag = '\1';
+#else
+        int flag = 1;
+#endif
+        struct addrinfo *in, hint;
+        memset (&hint, 0, sizeof (struct addrinfo));
+        hint.ai_flags = AI_NUMERICSERV;
+        hint.ai_family = af_;
+        hint.ai_socktype = protocol_ == IPPROTO_UDP ? SOCK_DGRAM : SOCK_STREAM;
+        hint.ai_protocol = protocol_ == IPPROTO_UDP ? IPPROTO_UDP : IPPROTO_TCP;
+
+        TEST_ASSERT_SUCCESS_RAW_ERRNO (
+          setsockopt (s_pre, SOL_SOCKET, SO_REUSEADDR, &flag, sizeof (int)));
+        TEST_ASSERT_SUCCESS_RAW_ZERO_ERRNO (
+          getaddrinfo (address_, port_, &hint, &in));
+        TEST_ASSERT_NOT_NULL (in);
+        memcpy (&addr, in->ai_addr, in->ai_addrlen);
+        addr_len = (socklen_t) in->ai_addrlen;
+        freeaddrinfo (in);
+    } else {
+#if defined(ZMQ_HAVE_IPC)
+        //  Cannot cast addr as gcc 4.4 will fail with strict aliasing errors
+        (*(struct sockaddr_un *) &addr).sun_family = AF_UNIX;
+        addr_len = sizeof (struct sockaddr_un);
+#if defined ZMQ_HAVE_WINDOWS
+        char buffer[MAX_PATH] = "";
+
+        TEST_ASSERT_SUCCESS_RAW_ERRNO (tmpnam_s (buffer));
+        TEST_ASSERT_SUCCESS_RAW_ERRNO (_mkdir (buffer));
+        strcat (buffer, "/ipc");
+#else
+        char buffer[PATH_MAX] = "";
+        strcpy (buffer, "tmpXXXXXX");
+#ifdef HAVE_MKDTEMP
+        TEST_ASSERT_TRUE (mkdtemp (buffer));
+        strcat (buffer, "/socket");
+#else
+        int fd = mkstemp (buffer);
+        TEST_ASSERT_TRUE (fd != -1);
+        close (fd);
+#endif
+#endif
+        strcpy ((*(struct sockaddr_un *) &addr).sun_path, buffer);
+        memcpy (my_endpoint_, "ipc://", 7);
+        strcat (my_endpoint_, buffer);
+
+        // TODO check return value of unlink
+        unlink (buffer);
+#else
+        return retired_fd;
+#endif
+    }
+
+    TEST_ASSERT_SUCCESS_RAW_ERRNO (
+      bind (s_pre, (struct sockaddr *) &addr, addr_len));
+    TEST_ASSERT_SUCCESS_RAW_ERRNO (listen (s_pre, SOMAXCONN));
+
+    if (af_ == AF_INET || af_ == AF_INET6) {
+        addr_len = sizeof (struct sockaddr_storage);
+        TEST_ASSERT_SUCCESS_RAW_ERRNO (
+          getsockname (s_pre, (struct sockaddr *) &addr, &addr_len));
+        sprintf (my_endpoint_, "%s://%s:%u",
+                 protocol_ == IPPROTO_TCP
+                   ? "tcp"
+                   : protocol_ == IPPROTO_UDP
+                       ? "udp"
+                       : protocol_ == IPPROTO_WSS ? "wss" : "ws",
+                 address_,
+                 af_ == AF_INET
+                   ? ntohs ((*(struct sockaddr_in *) &addr).sin_port)
+                   : ntohs ((*(struct sockaddr_in6 *) &addr).sin6_port));
+    }
+
+    return s_pre;
+}
+
+bool streq (const char *lhs_, const char *rhs_)
 {
-    return strcmp (lhs, rhs) == 0;
+    return strcmp (lhs_, rhs_) == 0;
 }
 
-bool strneq (const char *lhs, const char *rhs)
+bool strneq (const char *lhs_, const char *rhs_)
 {
-    return strcmp (lhs, rhs) != 0;
+    return strcmp (lhs_, rhs_) != 0;
+}
+
+#if defined _WIN32
+int fuzzer_corpus_encode (const char *dirname,
+                          uint8_t ***data,
+                          size_t **len,
+                          size_t *num_cases)
+{
+    (void) dirname;
+    (void) data;
+    (void) len;
+    (void) num_cases;
+
+    return -1;
 }
+
+#else
+
+int fuzzer_corpus_encode (const char *dirname,
+                          uint8_t ***data,
+                          size_t **len,
+                          size_t *num_cases)
+{
+    TEST_ASSERT_NOT_NULL (dirname);
+    TEST_ASSERT_NOT_NULL (data);
+    TEST_ASSERT_NOT_NULL (len);
+
+    struct dirent *ent;
+    DIR *dir = opendir (dirname);
+    if (!dir)
+        return -1;
+
+    *len = NULL;
+    *data = NULL;
+    *num_cases = 0;
+
+    while ((ent = readdir (dir)) != NULL) {
+        if (!strcmp (ent->d_name, ".") || !strcmp (ent->d_name, ".."))
+            continue;
+
+        char *filename =
+          (char *) malloc (strlen (dirname) + strlen (ent->d_name) + 2);
+        TEST_ASSERT_NOT_NULL (filename);
+        strcpy (filename, dirname);
+        strcat (filename, "/");
+        strcat (filename, ent->d_name);
+        FILE *f = fopen (filename, "r");
+        free (filename);
+        if (!f)
+            continue;
+
+        fseek (f, 0, SEEK_END);
+        size_t file_len = ftell (f);
+        fseek (f, 0, SEEK_SET);
+        if (file_len == 0) {
+            fclose (f);
+            continue;
+        }
+
+        *len = (size_t *) realloc (*len, (*num_cases + 1) * sizeof (size_t));
+        TEST_ASSERT_NOT_NULL (*len);
+        *(*len + *num_cases) = file_len;
+        *data =
+          (uint8_t **) realloc (*data, (*num_cases + 1) * sizeof (uint8_t *));
+        TEST_ASSERT_NOT_NULL (*data);
+        *(*data + *num_cases) =
+          (uint8_t *) malloc (file_len * sizeof (uint8_t));
+        TEST_ASSERT_NOT_NULL (*(*data + *num_cases));
+        size_t read_bytes = 0;
+        read_bytes = fread (*(*data + *num_cases), 1, file_len, f);
+        TEST_ASSERT_EQUAL (file_len, read_bytes);
+        (*num_cases)++;
+
+        fclose (f);
+    }
+
+    closedir (dir);
+
+    return 0;
+}
+#endif
diff -pruN 4.3.2-2/tests/testutil.hpp 4.3.3-1/tests/testutil.hpp
--- 4.3.2-2/tests/testutil.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/testutil.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -38,6 +38,15 @@
 #include "../include/zmq.h"
 #include "../src/stdint.hpp"
 
+//  For AF_INET and IPPROTO_TCP
+#if defined _WIN32
+#include "../src/windows.hpp"
+#else
+#include <arpa/inet.h>
+#include <unistd.h>
+#include <stdlib.h>
+#endif
+
 //  This defines the settle time used in tests; raise this if we
 //  get test failures on slower systems due to binds/connects not
 //  settled. Tested to work reliably at 1 msec on a fast PC.
@@ -57,10 +66,39 @@
 #define ENDPOINT_5 "udp://127.0.0.1:5560"
 #define PORT_6 5561
 
+//  For tests that mock ZMTP
+const uint8_t zmtp_greeting_null[64] = {
+  0xff, 0, 0, 0, 0, 0, 0, 0, 0, 0x7f, 3, 0, 'N', 'U', 'L', 'L',
+  0,    0, 0, 0, 0, 0, 0, 0, 0, 0,    0, 0, 0,   0,   0,   0,
+  0,    0, 0, 0, 0, 0, 0, 0, 0, 0,    0, 0, 0,   0,   0,   0};
+
+const uint8_t zmtp_greeting_curve[64] = {
+  0xff, 0, 0, 0, 0, 0, 0, 0, 0, 0x7f, 3, 0, 'C', 'U', 'R', 'V',
+  'E',  0, 0, 0, 0, 0, 0, 0, 0, 0,    0, 0, 0,   0,   0,   0,
+  0,    0, 0, 0, 0, 0, 0, 0, 0, 0,    0, 0, 0,   0,   0,   0};
+const uint8_t zmtp_ready_dealer[43] = {
+  4,   41,  5,   'R', 'E', 'A', 'D', 'Y', 11,  'S', 'o', 'c', 'k', 'e', 't',
+  '-', 'T', 'y', 'p', 'e', 0,   0,   0,   6,   'D', 'E', 'A', 'L', 'E', 'R',
+  8,   'I', 'd', 'e', 'n', 't', 'i', 't', 'y', 0,   0,   0,   0};
+const uint8_t zmtp_ready_xpub[28] = {
+  4,   26,  5,   'R', 'E', 'A', 'D', 'Y', 11, 'S', 'o', 'c', 'k', 'e',
+  't', '-', 'T', 'y', 'p', 'e', 0,   0,   0,  4,   'X', 'P', 'U', 'B'};
+const uint8_t zmtp_ready_sub[27] = {
+  4,   25,  5,   'R', 'E', 'A', 'D', 'Y', 11, 'S', 'o', 'c', 'k', 'e',
+  't', '-', 'T', 'y', 'p', 'e', 0,   0,   0,  3,   'S', 'U', 'B'};
+
 #undef NDEBUG
 
+#ifndef MSG_NOSIGNAL
+#define MSG_NOSIGNAL 0
+#endif
+
 // duplicated from fd.hpp
 #ifdef ZMQ_HAVE_WINDOWS
+#ifndef NOMINMAX
+#define NOMINMAX // Macros min(a,b) and max(a,b)
+#endif
+
 #include <winsock2.h>
 #include <ws2tcpip.h>
 #include <stdexcept>
@@ -70,26 +108,32 @@ inline const char *as_setsockopt_opt_t (
 {
     return static_cast<const char *> (opt);
 }
+#else
+typedef size_t socket_size_t;
+inline const void *as_setsockopt_opt_t (const void *opt_)
+{
+    return opt_;
+}
+#endif
+
+// duplicated from fd.hpp
+typedef zmq_fd_t fd_t;
+#ifdef ZMQ_HAVE_WINDOWS
 #if defined _MSC_VER && _MSC_VER <= 1400
-typedef UINT_PTR fd_t;
 enum
 {
-    retired_fd = (fd_t) (~0)
+    retired_fd = (zmq_fd_t) (~0)
 };
 #else
-typedef SOCKET fd_t;
 enum
+#if _MSC_VER >= 1800
+  : zmq_fd_t
+#endif
 {
-    retired_fd = (fd_t) INVALID_SOCKET
+    retired_fd = INVALID_SOCKET
 };
 #endif
 #else
-typedef size_t socket_size_t;
-inline const void *as_setsockopt_opt_t (const void *opt_)
-{
-    return opt_;
-}
-typedef int fd_t;
 enum
 {
     retired_fd = -1
@@ -140,7 +184,11 @@ void s_recv_seq (void *socket_, ...);
 //  Sets a zero linger period on a socket and closes it.
 void close_zero_linger (void *socket_);
 
-void setup_test_environment (void);
+//  Setups the test environment. Must be called at the beginning of each test
+//  executable. On POSIX systems, it sets an alarm to the specified number of
+//  seconds, after which the test will be killed. Set to 0 to disable this
+//  timeout.
+void setup_test_environment (int timeout_seconds_ = 60);
 
 //  Provide portable millisecond sleep
 //  http://www.cplusplus.com/forum/unices/60161/
@@ -164,4 +212,29 @@ int test_inet_pton (int af_, const char
 //  Binds an ipv4 BSD socket to an ephemeral port, returns the compiled sockaddr
 struct sockaddr_in bind_bsd_socket (int socket);
 
+//  Some custom definitions in addition to IPPROTO_TCP and IPPROTO_UDP
+#define IPPROTO_WS 10000
+#define IPPROTO_WSS 10001
+
+//  Connects a BSD socket to the ZMQ endpoint. Works with ipv4/ipv6/unix.
+fd_t connect_socket (const char *endpoint_,
+                     const int af_ = AF_INET,
+                     const int protocol_ = IPPROTO_TCP);
+
+//  Binds a BSD socket to an ephemeral port, returns the file descriptor.
+//  The resulting ZMQ endpoint will be stored in my_endpoint, including the protocol
+//  prefix, so ensure it is writable and of appropriate size.
+//  Works with ipv4/ipv6/unix. With unix sockets address_/port_ can be empty and
+//  my_endpoint_ will contain a random path.
+fd_t bind_socket_resolve_port (const char *address_,
+                               const char *port_,
+                               char *my_endpoint_,
+                               const int af_ = AF_INET,
+                               const int protocol_ = IPPROTO_TCP);
+
+int fuzzer_corpus_encode (const char *filename,
+                          uint8_t ***data,
+                          size_t **len,
+                          size_t *num_cases);
+
 #endif
diff -pruN 4.3.2-2/tests/testutil_monitoring.cpp 4.3.3-1/tests/testutil_monitoring.cpp
--- 4.3.2-2/tests/testutil_monitoring.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/testutil_monitoring.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -32,10 +32,32 @@
 #include <stdlib.h>
 #include <string.h>
 
+static int
+receive_monitor_address (void *monitor_, char **address_, bool expect_more_)
+{
+    zmq_msg_t msg;
+
+    zmq_msg_init (&msg);
+    if (zmq_msg_recv (&msg, monitor_, 0) == -1)
+        return -1; //  Interrupted, presumably
+    TEST_ASSERT_EQUAL (expect_more_, zmq_msg_more (&msg));
+
+    if (address_) {
+        const uint8_t *const data =
+          static_cast<const uint8_t *> (zmq_msg_data (&msg));
+        const size_t size = zmq_msg_size (&msg);
+        *address_ = static_cast<char *> (malloc (size + 1));
+        memcpy (*address_, data, size);
+        (*address_)[size] = 0;
+    }
+    zmq_msg_close (&msg);
+
+    return 0;
+}
+
 //  Read one event off the monitor socket; return value and address
 //  by reference, if not null, and event number by value. Returns -1
 //  in case of error.
-
 static int get_monitor_event_internal (void *monitor_,
                                        int *value_,
                                        char **address_,
@@ -50,23 +72,15 @@ static int get_monitor_event_internal (v
     }
     TEST_ASSERT_TRUE (zmq_msg_more (&msg));
 
-    uint8_t *data = (uint8_t *) zmq_msg_data (&msg);
-    uint16_t event = *(uint16_t *) (data);
+    uint8_t *data = static_cast<uint8_t *> (zmq_msg_data (&msg));
+    uint16_t event = *reinterpret_cast<uint16_t *> (data);
     if (value_)
         memcpy (value_, data + 2, sizeof (uint32_t));
 
     //  Second frame in message contains event address
-    zmq_msg_init (&msg);
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_recv (&msg, monitor_, recv_flag_));
-    TEST_ASSERT_FALSE (zmq_msg_more (&msg));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      receive_monitor_address (monitor_, address_, false));
 
-    if (address_) {
-        uint8_t *data = (uint8_t *) zmq_msg_data (&msg);
-        size_t size = zmq_msg_size (&msg);
-        *address_ = (char *) malloc (size + 1);
-        memcpy (*address_, data, size);
-        (*address_)[size] = 0;
-    }
     return event;
 }
 
@@ -241,32 +255,13 @@ static int64_t get_monitor_event_interna
     }
 
     //  Second-to-last frame in message contains local address
-    zmq_msg_init (&msg);
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_recv (&msg, monitor_, recv_flag_));
-    TEST_ASSERT_TRUE (zmq_msg_more (&msg));
-
-    if (local_address_) {
-        uint8_t *data = (uint8_t *) zmq_msg_data (&msg);
-        size_t size = zmq_msg_size (&msg);
-        *local_address_ = (char *) malloc (size + 1);
-        memcpy (*local_address_, data, size);
-        (*local_address_)[size] = 0;
-    }
-    zmq_msg_close (&msg);
+    TEST_ASSERT_SUCCESS_ERRNO (
+      receive_monitor_address (monitor_, local_address_, true));
 
     //  Last frame in message contains remote address
-    zmq_msg_init (&msg);
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_recv (&msg, monitor_, recv_flag_));
-    TEST_ASSERT_TRUE (!zmq_msg_more (&msg));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      receive_monitor_address (monitor_, remote_address_, false));
 
-    if (remote_address_) {
-        uint8_t *data = (uint8_t *) zmq_msg_data (&msg);
-        size_t size = zmq_msg_size (&msg);
-        *remote_address_ = (char *) malloc (size + 1);
-        memcpy (*remote_address_, data, size);
-        (*remote_address_)[size] = 0;
-    }
-    zmq_msg_close (&msg);
     return event;
 }
 
@@ -328,7 +323,8 @@ void expect_monitor_event_v2 (void *moni
     if (event != expected_event_) {
         pos += snprintf (pos, sizeof buf - (pos - buf),
                          "Expected monitor event %llx, but received %llx\n",
-                         (long long) expected_event_, (long long) event);
+                         static_cast<long long> (expected_event_),
+                         static_cast<long long> (event));
         failed = true;
     }
     if (expected_local_address_
@@ -339,11 +335,67 @@ void expect_monitor_event_v2 (void *moni
     }
     if (expected_remote_address_
         && 0 != strcmp (remote_address, expected_remote_address_)) {
-        pos += snprintf (pos, sizeof buf - (pos - buf),
-                         "Expected remote address %s, but received %s\n",
-                         expected_remote_address_, remote_address);
+        snprintf (pos, sizeof buf - (pos - buf),
+                  "Expected remote address %s, but received %s\n",
+                  expected_remote_address_, remote_address);
     }
     free (local_address);
     free (remote_address);
     TEST_ASSERT_FALSE_MESSAGE (failed, buf);
 }
+
+
+const char *get_zmqEventName (uint64_t event)
+{
+    switch (event) {
+        case ZMQ_EVENT_CONNECTED:
+            return "CONNECTED";
+        case ZMQ_EVENT_CONNECT_DELAYED:
+            return "CONNECT_DELAYED";
+        case ZMQ_EVENT_CONNECT_RETRIED:
+            return "CONNECT_RETRIED";
+        case ZMQ_EVENT_LISTENING:
+            return "LISTENING";
+        case ZMQ_EVENT_BIND_FAILED:
+            return "BIND_FAILED";
+        case ZMQ_EVENT_ACCEPTED:
+            return "ACCEPTED";
+        case ZMQ_EVENT_ACCEPT_FAILED:
+            return "ACCEPT_FAILED";
+        case ZMQ_EVENT_CLOSED:
+            return "CLOSED";
+        case ZMQ_EVENT_CLOSE_FAILED:
+            return "CLOSE_FAILED";
+        case ZMQ_EVENT_DISCONNECTED:
+            return "DISCONNECTED";
+        case ZMQ_EVENT_MONITOR_STOPPED:
+            return "MONITOR_STOPPED";
+        case ZMQ_EVENT_HANDSHAKE_FAILED_NO_DETAIL:
+            return "HANDSHAKE_FAILED_NO_DETAIL";
+        case ZMQ_EVENT_HANDSHAKE_SUCCEEDED:
+            return "HANDSHAKE_SUCCEEDED";
+        case ZMQ_EVENT_HANDSHAKE_FAILED_PROTOCOL:
+            return "HANDSHAKE_FAILED_PROTOCOL";
+        case ZMQ_EVENT_HANDSHAKE_FAILED_AUTH:
+            return "HANDSHAKE_FAILED_AUTH";
+        default:
+            return "UNKNOWN";
+    }
+}
+
+void print_events (void *socket, int timeout, int limit)
+{
+    // print events received
+    int value;
+    char *event_address;
+    int event =
+      get_monitor_event_with_timeout (socket, &value, &event_address, timeout);
+    int i = 0;
+    ;
+    while ((event != -1) && (++i < limit)) {
+        const char *eventName = get_zmqEventName (event);
+        printf ("Got event: %s\n", eventName);
+        event = get_monitor_event_with_timeout (socket, &value, &event_address,
+                                                timeout);
+    }
+}
diff -pruN 4.3.2-2/tests/testutil_monitoring.hpp 4.3.3-1/tests/testutil_monitoring.hpp
--- 4.3.2-2/tests/testutil_monitoring.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/testutil_monitoring.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -1,75 +1,83 @@
-/*
-    Copyright (c) 2007-2017 Contributors as noted in the AUTHORS file
-
-    This file is part of libzmq, the ZeroMQ core engine in C++.
-
-    libzmq is free software; you can redistribute it and/or modify it under
-    the terms of the GNU Lesser General Public License (LGPL) as published
-    by the Free Software Foundation; either version 3 of the License, or
-    (at your option) any later version.
-
-    As a special exception, the Contributors give you permission to link
-    this library with independent modules to produce an executable,
-    regardless of the license terms of these independent modules, and to
-    copy and distribute the resulting executable under terms of your choice,
-    provided that you also meet, for each linked independent module, the
-    terms and conditions of the license of that module. An independent
-    module is a module which is not derived from or based on this library.
-    If you modify this library, you must extend this exception to your
-    version of the library.
-
-    libzmq is distributed in the hope that it will be useful, but WITHOUT
-    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
-    License for more details.
-
-    You should have received a copy of the GNU Lesser General Public License
-    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-*/
-
-#ifndef __TESTUTIL_MONITORING_HPP_INCLUDED__
-#define __TESTUTIL_MONITORING_HPP_INCLUDED__
-
-#include "../include/zmq.h"
-#include "../src/stdint.hpp"
-
-#include <stddef.h>
-
-//  General, i.e. non-security specific, monitor utilities
-
-int get_monitor_event_with_timeout (void *monitor_,
-                                    int *value_,
-                                    char **address_,
-                                    int timeout_);
-
-int get_monitor_event (void *monitor_, int *value_, char **address_);
-
-void expect_monitor_event (void *monitor_, int expected_event_);
-
-void print_unexpected_event_stderr (int event_,
-                                    int err_,
-                                    int expected_event_,
-                                    int expected_err_);
-
-//  expects that one or more occurrences of the expected event are received
-//  via the specified socket monitor
-//  returns the number of occurrences of the expected event
-//  interrupts, if a ZMQ_EVENT_HANDSHAKE_FAILED_NO_DETAIL with EPIPE, ECONNRESET
-//  or ECONNABORTED occurs; in this case, 0 is returned
-//  this should be investigated further, see
-//  https://github.com/zeromq/libzmq/issues/2644
-int expect_monitor_event_multiple (void *server_mon_,
-                                   int expected_event_,
-                                   int expected_err_ = -1,
-                                   bool optional_ = false);
-
-int64_t get_monitor_event_v2 (void *monitor_,
-                              uint64_t *value_,
-                              char **local_address_,
-                              char **remote_address_);
-
-void expect_monitor_event_v2 (void *monitor_,
-                              int64_t expected_event_,
-                              const char *expected_local_address_ = NULL,
-                              const char *expected_remote_address_ = NULL);
-#endif
+/*
+    Copyright (c) 2007-2017 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __TESTUTIL_MONITORING_HPP_INCLUDED__
+#define __TESTUTIL_MONITORING_HPP_INCLUDED__
+
+#include "../include/zmq.h"
+#include "../src/stdint.hpp"
+
+#include <stddef.h>
+
+//  General, i.e. non-security specific, monitor utilities
+
+int get_monitor_event_with_timeout (void *monitor_,
+                                    int *value_,
+                                    char **address_,
+                                    int timeout_);
+
+//  Read one event off the monitor socket; return value and address
+//  by reference, if not null, and event number by value. Returns -1
+//  in case of error.
+int get_monitor_event (void *monitor_, int *value_, char **address_);
+
+void expect_monitor_event (void *monitor_, int expected_event_);
+
+void print_unexpected_event_stderr (int event_,
+                                    int err_,
+                                    int expected_event_,
+                                    int expected_err_);
+
+//  expects that one or more occurrences of the expected event are received
+//  via the specified socket monitor
+//  returns the number of occurrences of the expected event
+//  interrupts, if a ZMQ_EVENT_HANDSHAKE_FAILED_NO_DETAIL with EPIPE, ECONNRESET
+//  or ECONNABORTED occurs; in this case, 0 is returned
+//  this should be investigated further, see
+//  https://github.com/zeromq/libzmq/issues/2644
+int expect_monitor_event_multiple (void *server_mon_,
+                                   int expected_event_,
+                                   int expected_err_ = -1,
+                                   bool optional_ = false);
+
+int64_t get_monitor_event_v2 (void *monitor_,
+                              uint64_t *value_,
+                              char **local_address_,
+                              char **remote_address_);
+
+void expect_monitor_event_v2 (void *monitor_,
+                              int64_t expected_event_,
+                              const char *expected_local_address_ = NULL,
+                              const char *expected_remote_address_ = NULL);
+
+
+const char *get_zmqEventName (uint64_t event);
+void print_events (void *socket, int timeout, int limit);
+
+#endif
diff -pruN 4.3.2-2/tests/testutil_security.cpp 4.3.3-1/tests/testutil_security.cpp
--- 4.3.2-2/tests/testutil_security.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/testutil_security.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -44,7 +44,7 @@ void socket_config_null_server (void *se
     TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (
       server_, ZMQ_ZAP_DOMAIN, test_zap_domain, strlen (test_zap_domain)));
 #ifdef ZMQ_ZAP_ENFORCE_DOMAIN
-    int required = server_secret_ ? *(int *) server_secret_ : 0;
+    int required = server_secret_ ? *static_cast<int *> (server_secret_) : 0;
     TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (server_, ZMQ_ZAP_ENFORCE_DOMAIN,
                                                &required, sizeof (int)));
 #else
@@ -109,8 +109,8 @@ void socket_config_curve_server (void *s
 
 void socket_config_curve_client (void *client_, void *data_)
 {
-    curve_client_data_t *curve_client_data =
-      static_cast<curve_client_data_t *> (data_);
+    const curve_client_data_t *const curve_client_data =
+      static_cast<const curve_client_data_t *> (data_);
 
     TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (
       client_, ZMQ_CURVE_SERVERKEY, curve_client_data->server_public, 41));
@@ -320,6 +320,11 @@ void setup_context_and_server_side (void
     *server_ = test_context_socket (ZMQ_DEALER);
     TEST_ASSERT_SUCCESS_ERRNO (
       zmq_setsockopt (*server_, ZMQ_LINGER, &linger, sizeof (linger)));
+    //  As per API by default there's no limit to the size of a message,
+    //  but the sanitizer allocator will barf over a gig or so
+    int64_t max_msg_size = 64 * 1024 * 1024;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (
+      *server_, ZMQ_MAXMSGSIZE, &max_msg_size, sizeof (int64_t)));
 
     socket_config_ (*server_, socket_config_data_);
 
@@ -346,6 +351,7 @@ void shutdown_context_and_server_side (v
           zmq_unbind (zap_control_, "inproc://handler-control"));
     }
     test_context_socket_close (zap_control_);
+    zmq_socket_monitor (server_, NULL, 0);
     test_context_socket_close (server_mon_);
     test_context_socket_close (server_);
 
@@ -362,6 +368,11 @@ void *create_and_connect_client (char *m
                                  void **client_mon_)
 {
     void *client = test_context_socket (ZMQ_DEALER);
+    //  As per API by default there's no limit to the size of a message,
+    //  but the sanitizer allocator will barf over a gig or so
+    int64_t max_msg_size = 64 * 1024 * 1024;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (client, ZMQ_MAXMSGSIZE, &max_msg_size, sizeof (int64_t)));
 
     socket_config_ (client, socket_config_data_);
 
@@ -383,7 +394,7 @@ void expect_new_client_bounce_fail (char
                                     int expected_client_event_,
                                     int expected_client_value_)
 {
-    void *my_client_mon;
+    void *my_client_mon = NULL;
     TEST_ASSERT_TRUE (client_mon_ == NULL || expected_client_event_ == 0);
     if (expected_client_event_ != 0)
         client_mon_ = &my_client_mon;
diff -pruN 4.3.2-2/tests/testutil_unity.cpp 4.3.3-1/tests/testutil_unity.cpp
--- 4.3.2-2/tests/testutil_unity.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/testutil_unity.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -31,14 +31,16 @@
 #include <stdlib.h>
 #include <string.h>
 
-#ifndef _WIN32
+#ifdef _WIN32
+#include <direct.h>
+#else
 #include <unistd.h>
 #endif
 
 int test_assert_success_message_errno_helper (int rc_,
                                               const char *msg_,
                                               const char *expr_,
-                                              int line)
+                                              int line_)
 {
     if (rc_ == -1) {
         char buffer[512];
@@ -48,17 +50,15 @@ int test_assert_success_message_errno_he
                   "%s failed%s%s%s, errno = %i (%s)", expr_,
                   msg_ ? " (additional info: " : "", msg_ ? msg_ : "",
                   msg_ ? ")" : "", zmq_errno (), zmq_strerror (zmq_errno ()));
-        UNITY_TEST_FAIL (line, buffer);
+        UNITY_TEST_FAIL (line_, buffer);
     }
     return rc_;
 }
 
-int test_assert_success_message_raw_errno_helper (int rc_,
-                                                  const char *msg_,
-                                                  const char *expr_,
-                                                  int line)
+int test_assert_success_message_raw_errno_helper (
+  int rc_, const char *msg_, const char *expr_, int line_, bool zero)
 {
-    if (rc_ == -1) {
+    if (rc_ == -1 || (zero && rc_ != 0)) {
 #if defined ZMQ_HAVE_WINDOWS
         int current_errno = WSAGetLastError ();
 #else
@@ -68,16 +68,26 @@ int test_assert_success_message_raw_errn
         char buffer[512];
         buffer[sizeof (buffer) - 1] =
           0; // to ensure defined behavior with VC++ <= 2013
-        snprintf (buffer, sizeof (buffer) - 1, "%s failed%s%s%s, errno = %i",
-                  expr_, msg_ ? " (additional info: " : "", msg_ ? msg_ : "",
-                  msg_ ? ")" : "", current_errno);
-        UNITY_TEST_FAIL (line, buffer);
+        snprintf (
+          buffer, sizeof (buffer) - 1, "%s failed%s%s%s with %d, errno = %i/%s",
+          expr_, msg_ ? " (additional info: " : "", msg_ ? msg_ : "",
+          msg_ ? ")" : "", rc_, current_errno, strerror (current_errno));
+        UNITY_TEST_FAIL (line_, buffer);
     }
     return rc_;
 }
 
+int test_assert_success_message_raw_zero_errno_helper (int rc_,
+                                                       const char *msg_,
+                                                       const char *expr_,
+                                                       int line_)
+{
+    return test_assert_success_message_raw_errno_helper (rc_, msg_, expr_,
+                                                         line_, true);
+}
+
 int test_assert_failure_message_raw_errno_helper (
-  int rc_, int expected_errno_, const char *msg_, const char *expr_, int line)
+  int rc_, int expected_errno_, const char *msg_, const char *expr_, int line_)
 {
     char buffer[512];
     buffer[sizeof (buffer) - 1] =
@@ -88,7 +98,7 @@ int test_assert_failure_message_raw_errn
                   "errno = %i, actual return value = %i",
                   expr_, msg_ ? " (additional info: " : "", msg_ ? msg_ : "",
                   msg_ ? ")" : "", expected_errno_, rc_);
-        UNITY_TEST_FAIL (line, buffer);
+        UNITY_TEST_FAIL (line_, buffer);
     } else {
 #if defined ZMQ_HAVE_WINDOWS
         int current_errno = WSAGetLastError ();
@@ -102,7 +112,7 @@ int test_assert_failure_message_raw_errn
                       expr_, msg_ ? " (additional info: " : "",
                       msg_ ? msg_ : "", msg_ ? ")" : "", expected_errno_,
                       current_errno);
-            UNITY_TEST_FAIL (line, buffer);
+            UNITY_TEST_FAIL (line_, buffer);
         }
     }
     return rc_;
@@ -163,7 +173,7 @@ static void internal_manage_test_sockets
             fprintf (stderr,
                      "WARNING: Forced closure of %i sockets, this is an "
                      "implementation error unless the test case failed\n",
-                     (int) test_socket_count);
+                     static_cast<int> (test_socket_count));
             test_socket_count = 0;
         }
     } else {
@@ -288,9 +298,24 @@ void bind_loopback_tipc (void *socket_,
     test_bind (socket_, "tipc://<*>", my_endpoint_, len_);
 }
 
-#if !defined(ZMQ_HAVE_WINDOWS) && !defined(ZMQ_HAVE_GNU)
+#if defined(ZMQ_HAVE_IPC) && !defined(ZMQ_HAVE_GNU)
 void make_random_ipc_endpoint (char *out_endpoint_)
 {
+#ifdef ZMQ_HAVE_WINDOWS
+    char random_file[MAX_PATH];
+
+    {
+        const errno_t rc = tmpnam_s (random_file);
+        TEST_ASSERT_EQUAL (0, rc);
+    }
+
+    // TODO or use CreateDirectoryA and specify permissions?
+    const int rc = _mkdir (random_file);
+    TEST_ASSERT_EQUAL (0, rc);
+
+    strcat (random_file, "/ipc");
+
+#else
     char random_file[16];
     strcpy (random_file, "tmpXXXXXX");
 
@@ -302,6 +327,7 @@ void make_random_ipc_endpoint (char *out
     TEST_ASSERT_TRUE (fd != -1);
     close (fd);
 #endif
+#endif
 
     strcpy (out_endpoint_, "ipc://");
     strcat (out_endpoint_, random_file);
diff -pruN 4.3.2-2/tests/testutil_unity.hpp 4.3.3-1/tests/testutil_unity.hpp
--- 4.3.2-2/tests/testutil_unity.hpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/testutil_unity.hpp	2020-09-07 10:12:14.000000000 +0000
@@ -43,10 +43,13 @@ int test_assert_success_message_errno_he
                                               const char *expr_,
                                               int line);
 
-int test_assert_success_message_raw_errno_helper (int rc_,
-                                                  const char *msg_,
-                                                  const char *expr_,
-                                                  int line);
+int test_assert_success_message_raw_errno_helper (
+  int rc_, const char *msg_, const char *expr_, int line, bool zero_ = false);
+
+int test_assert_success_message_raw_zero_errno_helper (int rc_,
+                                                       const char *msg_,
+                                                       const char *expr_,
+                                                       int line);
 
 int test_assert_failure_message_raw_errno_helper (
   int rc_, int expected_errno_, const char *msg_, const char *expr_, int line);
@@ -88,9 +91,22 @@ int test_assert_failure_message_raw_errn
 // A typical use would be:
 //   TEST_ASSERT_SUCCESS_RAW_ERRNO (send (fd, buffer, 64, 0));
 // In case of success, the result of the macro is the result of 'expr'.
+// Success is strictly defined by a return value different from -1, as opposed
+// to checking that it is 0, like TEST_ASSERT_FAILURE_RAW_ZERO_ERRNO does.
 #define TEST_ASSERT_SUCCESS_RAW_ERRNO(expr)                                    \
     test_assert_success_message_raw_errno_helper (expr, NULL, #expr, __LINE__)
 
+// Asserts that the socket API 'expr' is successful. In case of a failure, the
+// assertion message includes the literal 'expr' and the error code.
+// A typical use would be:
+//   TEST_ASSERT_SUCCESS_RAW_ZERO_ERRNO (send (fd, buffer, 64, 0));
+// In case of success, the result of the macro is the result of 'expr'.
+// Success is strictly defined by a return value of 0, as opposed to checking
+// that it is not -1, like TEST_ASSERT_FAILURE_RAW_ERRNO does.
+#define TEST_ASSERT_SUCCESS_RAW_ZERO_ERRNO(expr)                               \
+    test_assert_success_message_raw_zero_errno_helper (expr, NULL, #expr,      \
+                                                       __LINE__)
+
 // Asserts that the socket API 'expr' is not successful, and the error code is
 // 'error_code'. In case of an unexpected succces, or a failure with an
 // unexpected error code, the assertion message includes the literal 'expr'
@@ -256,7 +272,7 @@ void bind_loopback_ipc (void *socket_, c
 // Binds to an ipc endpoint using the tipc wildcard address.
 void bind_loopback_tipc (void *socket_, char *my_endpoint_, size_t len_);
 
-#if !defined(ZMQ_HAVE_WINDOWS) && !defined(ZMQ_HAVE_GNU)
+#if defined(ZMQ_HAVE_IPC) && !defined(ZMQ_HAVE_GNU)
 // utility function to create a random IPC endpoint, similar to what a ipc://*
 // wildcard binding does, but in a way it can be reused for multiple binds
 // TODO also add a len parameter here
diff -pruN 4.3.2-2/tests/test_wss_transport.cpp 4.3.3-1/tests/test_wss_transport.cpp
--- 4.3.2-2/tests/test_wss_transport.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_wss_transport.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,162 @@
+/*
+    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <string.h>
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+SETUP_TEARDOWN_TESTCONTEXT
+
+#ifdef ZMQ_WSS_CERT_PEM
+const char *key =
+  "-----BEGIN PRIVATE KEY-----\n"
+  "MIIJQwIBADANBgkqhkiG9w0BAQEFAASCCS0wggkpAgEAAoICAQDnzizmqK1e0iRR\n"
+  "lY75z9q3TWVBzFYX00Rl18GT2liW6AYzOB/qa55EhjTf4snhC2FaUoosu4MYRdvo\n"
+  "8qBOpFvnQDScJ6o06LyrWyL15kkBYEsTkjmDEXe/TxUVE2IBb991m1F91SIEjK5m\n"
+  "NRH2aRjrN5mL9f8+Crrv96Y4sxGCDkqwOarViFbDYFxdYa7WrvZImpknrmM5KPyg\n"
+  "PtU9gqnlIgAU9bPTGUJGdQeQ+AWKOgw6unV8IiKEX8jyHBoKiAqTspRCCV9yDOKx\n"
+  "eVUGgkcAMpeSv8HVboNbfof8DI+eT8EtYNsWW4dINgiYYEGZIhy74X2dKria6hCc\n"
+  "AYdS+/90nf0RAyymniDtgTGrMIXFmjlYpLngqfAo+zzl21dGh3VnRUFbTak8CH4g\n"
+  "wYIefJFerwJP1im5jAiULWHaiOOk2r5fHdxbBLebqcaWBRSGGNE9cj4bj/qYuHAf\n"
+  "VrNW5+CN3j0h5ss/f8lOoDbbrb6GtSJfI16fuQZd2hW84u38EuVd1/mzbVMv7Bip\n"
+  "yzjbEAcOgn0Mk89zZewooz8Sxr2e1R47/5CCHJodUFqc5hmcnOqRd7YmpM68bS7V\n"
+  "KbnOY3w9Llw6tkXMitmtUs7IiKZ1ViXA3UzMSumvEJKMqOnfNEUH9pkqYe2lVbay\n"
+  "1HSk/hz7AkprVPMlqlF12x/794fg9wIDAQABAoICAHI10UWsYg9P9nkD+Tf4Q0kB\n"
+  "JxyuMtT2UMLk9QmGERP5KeTeiEsVzxrwDOkqclEhLEw2UsILeWHiOaGiuX1F2cos\n"
+  "hj9SA7ih2yOKecUyO1IkQZlY+GEtoBRwQHDr5ePTXQQzDIm1E1eugNb22uzPh2mN\n"
+  "MWgWQjYtT0GggRN6luu/YulE4Hjo/eaxeZDA6kX4WnwXP9KfR2AIY8AIdUQjNtYg\n"
+  "VG3/SSR/U3onexzgNsqOIyxkZjJNFzilgPpZAjOiJ6Px3r5So+Yrlx3eLBhS4+yj\n"
+  "AK9bL4ObOblAtHtpLPHRVdqn2ApB+nuHs+BvvKJYflPLm/pt7BrXrGtRDX3Dj27T\n"
+  "sXPZTBsPmFr8vqlbgIYNCiY3uQonsAO95o0Y0Dx6oVFlzL1ajP49KmUye+p/wEHc\n"
+  "1XfYD8DxfU+ECEZk1/DvmKIPc4cZr2U1i9RBVRiKFd4NFIGYylLihuYhB9FZEyWQ\n"
+  "p0TwM3DFs7PwIQNPE6mGKtjgdgBGkY4AGfCxQzdp1mM+I2700OIx0EHAbxm5JMQm\n"
+  "NQKtBWliiz7+DLK/NWrDVS8N8tdkZVpHUK6ahvJbYG8oDqX0me6Bmk+0SaQJujis\n"
+  "fOPFRNGanr0X97+fqMJnDeOfXAcYurXBm81IkGilUF+2a0wWhS7PGhOT4dcLKRU8\n"
+  "tcmIZRJDWWyv2uQGg2yhAoIBAQD5sM7SX/ZuQ44HHmjQP59//vxCoZYqcPtf+52z\n"
+  "kCpRnbbzFh/uTLRBvQ5NjZp7XOpZ/3y05JnarYChjCuVjG5+SJO7UQ0pl5N7LL0r\n"
+  "3YGSRkfBGE05AiccyitonQssnJ4GVGfkt+1l9kVn4aMN9YkgoWc68vFzHY9CfIjS\n"
+  "3d7QM89vGJBmBCpLG9WC0R24VNH6mfnM0MANwFlYFk9a2cKWueNjMidtHaNgry7A\n"
+  "lWKn7jEUizkb5kNiVoFC+9qYx16unR1U2K4eRJoOhOLNWPaPuGX219iMvQ+CHs2T\n"
+  "ZA72qj0d29t2wS8RmFXAIRNDuc7MkPh3iTF4jdRt57/pU1WPAoIBAQDtqavyOx/h\n"
+  "kilyGjALfca68iQscWuVmWCVzFFfeGvFN4IXSxgM38xmtSEhAILVf7ozv/QNJsxv\n"
+  "9l1xGkY+FaoFTSxglMw0iO4fZwNp2GuEy57jFzJuJyzE4FiueNb5dzoZnGnXxJIS\n"
+  "bnprZgR42aaYAU0PzPwrqyc3PXv2J4tn6O8Mt53JO4bN+/XomD4oQBOhM0iLuS7t\n"
+  "xTUQnsaHr1QglSIGQf4XOmXTO0+dE5uhFXkKP0Frq4MtoJUdEiWNzOdzwzxAZJTL\n"
+  "v8dPOQud9yxKxwRg2rroasKgyRgE6GHqKSRhggiMwVOFzeMxPLJ2oeWmpRZXiMoH\n"
+  "dkiCnPh7DBoZAoIBAGSuUJcvrrSDdO+V6XmfTfdUn+9WLLDsYdAwK0TOauICEFUw\n"
+  "pKt4Lm8bhnrrEFGSA8VKacSfMRKmR2nclW5188/j//3WDtKolgVi4tyfMrICuMg5\n"
+  "vlmwbokDVEGYoXrZpDa1Ljdhms40YYQjzZXBXgvUSUXR1F4wmyWaBanRYRje61PG\n"
+  "ueMI5uzmSk+3dp5vRUQhdkKKIgbpep00Ucc2a2pPhkrnXFJ5UvmXaeip0+AXAZ9h\n"
+  "DCQd0yoB65lQ6LIWIi2SmNMvk/YMf3o/Rxy6NKF7H1JLcrw9N9WmCgrWm9oGhyJV\n"
+  "Fsdp2krj/B++tn/mmmaORkIdBd+wgOnYOuAghC0CggEBAK6KtLgyieh9Eqk06GIY\n"
+  "HlJ/sOde6Pc2bIO3SW/HHcb6TDVVNjWGSzSHA+yb1np70sFc0RyziOMVWWzOMhY4\n"
+  "jORV2CiaPxq6Eb/IRO6APf6KGIeJKsVRSgTRCvAf2SnfUTEr+WO4ftrAfnHPu6sR\n"
+  "ldL+6ZyYG/7qNOPR6O9P/YbzwFRjqaL3b7ppuCD5ZnTjEkeKRVYwS3HeKmmpYf6W\n"
+  "Wj+PpyxXXQesIMowPfkLRHnaLknDSQWNMcrZq4ltIV1xxe3zzZUxCUJV90eMiqaZ\n"
+  "t9K3NNT47tnwRj4VUemQzRBO5OQjvqm49eFH4vnvLNYJcoKfrbfdwxoV2YzrQWYE\n"
+  "7kkCggEBAKzLviuI6eoaPwgKeR2wrFBbrucnY4yqkVIFzFRpjM6azzMArYVpslZW\n"
+  "DTdmi/2QCd9altVAT20Yvml8YqrFszpINV1DqBIfHtQPEy9oKrhFW92rhuJQo/aX\n"
+  "1yILvzmyzLdpQG6zLm7TD7mEkumiT9F3ObeoVnAOllEwUrNAfDPPclRHGowJs6Ya\n"
+  "wv50Idk62v7gnXny9OyFN3kUq6dtwItYqmalfKKGXhTi49mEWX39SSZSt+a15oKM\n"
+  "21fKHdqiG/AXST7n8IlBGRzyW9TqTnmVC5zj7esmqfRT0eno399hl0LOZgJoa4dx\n"
+  "lMwbKi/uEdrUT3ei3nAxnuQolXgClZk=\n"
+  "-----END PRIVATE KEY-----";
+
+const char *cert =
+  "-----BEGIN CERTIFICATE-----\n"
+  "MIIFkTCCA3mgAwIBAgIUWazS3jRxgV/9TgdybZ9ch7nYsQIwDQYJKoZIhvcNAQEL\n"
+  "BQAwVzELMAkGA1UEBhMCWFgxFTATBgNVBAcMDERlZmF1bHQgQ2l0eTEcMBoGA1UE\n"
+  "CgwTRGVmYXVsdCBDb21wYW55IEx0ZDETMBEGA1UEAwwKemVyb21xLm9yZzAgFw0x\n"
+  "OTExMTAwODMzMThaGA8yMTE5MTAxNzA4MzMxOFowVzELMAkGA1UEBhMCWFgxFTAT\n"
+  "BgNVBAcMDERlZmF1bHQgQ2l0eTEcMBoGA1UECgwTRGVmYXVsdCBDb21wYW55IEx0\n"
+  "ZDETMBEGA1UEAwwKemVyb21xLm9yZzCCAiIwDQYJKoZIhvcNAQEBBQADggIPADCC\n"
+  "AgoCggIBAOfOLOaorV7SJFGVjvnP2rdNZUHMVhfTRGXXwZPaWJboBjM4H+prnkSG\n"
+  "NN/iyeELYVpSiiy7gxhF2+jyoE6kW+dANJwnqjTovKtbIvXmSQFgSxOSOYMRd79P\n"
+  "FRUTYgFv33WbUX3VIgSMrmY1EfZpGOs3mYv1/z4Kuu/3pjizEYIOSrA5qtWIVsNg\n"
+  "XF1hrtau9kiamSeuYzko/KA+1T2CqeUiABT1s9MZQkZ1B5D4BYo6DDq6dXwiIoRf\n"
+  "yPIcGgqICpOylEIJX3IM4rF5VQaCRwAyl5K/wdVug1t+h/wMj55PwS1g2xZbh0g2\n"
+  "CJhgQZkiHLvhfZ0quJrqEJwBh1L7/3Sd/REDLKaeIO2BMaswhcWaOVikueCp8Cj7\n"
+  "POXbV0aHdWdFQVtNqTwIfiDBgh58kV6vAk/WKbmMCJQtYdqI46Tavl8d3FsEt5up\n"
+  "xpYFFIYY0T1yPhuP+pi4cB9Ws1bn4I3ePSHmyz9/yU6gNtutvoa1Il8jXp+5Bl3a\n"
+  "Fbzi7fwS5V3X+bNtUy/sGKnLONsQBw6CfQyTz3Nl7CijPxLGvZ7VHjv/kIIcmh1Q\n"
+  "WpzmGZyc6pF3tiakzrxtLtUpuc5jfD0uXDq2RcyK2a1SzsiIpnVWJcDdTMxK6a8Q\n"
+  "koyo6d80RQf2mSph7aVVtrLUdKT+HPsCSmtU8yWqUXXbH/v3h+D3AgMBAAGjUzBR\n"
+  "MB0GA1UdDgQWBBTVHR+4lBIBcr2rEEMdideTAkwDZDAfBgNVHSMEGDAWgBTVHR+4\n"
+  "lBIBcr2rEEMdideTAkwDZDAPBgNVHRMBAf8EBTADAQH/MA0GCSqGSIb3DQEBCwUA\n"
+  "A4ICAQB9M5p9z92UhVXg2baUj9QBN2YFGAeveFRpZ9Y/wktEssTqMKkc+39UtfJS\n"
+  "UclZnzMEhLyTieNqf+8GCgLLI0YSTIJpWwzvQBcXPoo+8IcexANvxR22KZrE51y4\n"
+  "/YfCKh8Q0ZbG8oc5Br8YHwipzGcmWjWtznfMpuaELezv/r381QV1Sbmpw2a0jvwp\n"
+  "uA/bc+4IZ9yvrhC9KkOUnivnCV71U2Wy8zOvrBEJicuGOc+lbWJRKyjbMDi1IybG\n"
+  "VnemtkQEyXFh6f1h8AdaN+Xj7qXX/YKmNk20Siu4qDNo8nozVpOL2DHjoKLa4N2c\n"
+  "ULG3kXScxVxWqCuPVNeypV2TZ9uSVFeKK/VJ5iGvFeifDsqVVo6WC4Pdz0WYes8H\n"
+  "3VqEPSwmNJ1FswLpYpGgCEFnkGRPFFB5dmwr0fuubkgaJPatxrImFac+nukfqZ8N\n"
+  "x/d4t72u1yIs0HnrkAj96ZIUXH5jFGPXbD8eGO0hzw+wbY9KRLXGBBl2B4EAaBdt\n"
+  "Cmp8R8xus3FGDZ5RVftZvTQO2CiTC4yn9Wab/ADDwcXDs6ntHctx4xQpm0tLqMoz\n"
+  "BTH8+ftqyzklar35gJluD84oh1kynEojrPkUvb75NlzxikBSF3pRrOx30Myy7DBx\n"
+  "rhUIqDFxqlYFx9InEzHlvI7cWWdMNqAmSxpz4SXMrd/7PJG+Ag==\n"
+  "-----END CERTIFICATE-----";
+
+void test_roundtrip ()
+{
+    char connect_address[MAX_SOCKET_STRING + strlen ("/roundtrip")];
+    size_t addr_length = sizeof (connect_address);
+    void *sb = test_context_socket (ZMQ_REP);
+    zmq_setsockopt (sb, ZMQ_WSS_CERT_PEM, cert, strlen (cert));
+    zmq_setsockopt (sb, ZMQ_WSS_KEY_PEM, key, strlen (key));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (sb, "wss://*:*/roundtrip"));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_getsockopt (sb, ZMQ_LAST_ENDPOINT, connect_address, &addr_length));
+    strcat (connect_address, "/roundtrip");
+
+    void *sc = test_context_socket (ZMQ_REQ);
+    zmq_setsockopt (sc, ZMQ_WSS_TRUST_PEM, cert, strlen (cert));
+    zmq_setsockopt (sc, ZMQ_WSS_HOSTNAME, "zeromq.org", strlen ("zeromq.org"));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sc, connect_address));
+
+    bounce (sb, sc);
+
+    test_context_socket_close (sc);
+    test_context_socket_close (sb);
+}
+
+int main ()
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_roundtrip);
+    return UNITY_END ();
+}
+#else
+int main ()
+{
+    printf ("WSS unavailable, skipping test\n");
+    return 77;
+}
+#endif
diff -pruN 4.3.2-2/tests/test_ws_transport.cpp 4.3.3-1/tests/test_ws_transport.cpp
--- 4.3.2-2/tests/test_ws_transport.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_ws_transport.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,291 @@
+/*
+    Copyright (c) 2007-2016 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <string.h>
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+SETUP_TEARDOWN_TESTCONTEXT
+
+void test_roundtrip ()
+{
+    char bind_address[MAX_SOCKET_STRING];
+    char connect_address[MAX_SOCKET_STRING];
+    size_t addr_length = sizeof (connect_address);
+
+    void *sb = test_context_socket (ZMQ_REP);
+    void *sc = test_context_socket (ZMQ_REQ);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (sb, "ws://*:*/roundtrip"));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_getsockopt (sb, ZMQ_LAST_ENDPOINT, bind_address, &addr_length));
+
+    // Windows can't connect to 0.0.0.0
+    sprintf (connect_address, "ws://127.0.0.1%s", strrchr (bind_address, ':'));
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sc, connect_address));
+
+    bounce (sb, sc);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_disconnect (sc, connect_address));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_unbind (sb, bind_address));
+
+    test_context_socket_close (sc);
+    test_context_socket_close (sb);
+}
+
+void test_roundtrip_without_path ()
+{
+    char connect_address[MAX_SOCKET_STRING];
+    size_t addr_length = sizeof (connect_address);
+    void *sb = test_context_socket (ZMQ_REP);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (sb, "ws://127.0.0.1:*"));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_getsockopt (sb, ZMQ_LAST_ENDPOINT, connect_address, &addr_length));
+
+    void *sc = test_context_socket (ZMQ_REQ);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sc, connect_address));
+
+    bounce (sb, sc);
+
+    test_context_socket_close (sc);
+    test_context_socket_close (sb);
+}
+
+
+void test_heartbeat ()
+{
+    char connect_address[MAX_SOCKET_STRING];
+    size_t addr_length = sizeof (connect_address);
+    void *sb = test_context_socket (ZMQ_REP);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (sb, "ws://127.0.0.1:*/heartbeat"));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_getsockopt (sb, ZMQ_LAST_ENDPOINT, connect_address, &addr_length));
+
+    void *sc = test_context_socket (ZMQ_REQ);
+
+    // Setting heartbeat settings
+    int ivl = 10;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (sc, ZMQ_HEARTBEAT_IVL, &ivl, sizeof (ivl)));
+
+    // Disable reconnect, to make sure the ping-pong actually work
+    ivl = -1;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (sc, ZMQ_RECONNECT_IVL, &ivl, sizeof (ivl)));
+
+    // Connect to server
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sc, connect_address));
+
+    // Make sure some ping and pong going through
+    msleep (100);
+
+    bounce (sb, sc);
+
+    test_context_socket_close (sc);
+    test_context_socket_close (sb);
+}
+
+void test_short_message ()
+{
+    char connect_address[MAX_SOCKET_STRING];
+    size_t addr_length = sizeof (connect_address);
+    void *sb = test_context_socket (ZMQ_REP);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (sb, "ws://127.0.0.1:*/short"));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_getsockopt (sb, ZMQ_LAST_ENDPOINT, connect_address, &addr_length));
+
+    void *sc = test_context_socket (ZMQ_REQ);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sc, connect_address));
+
+    zmq_msg_t msg;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_size (&msg, 255));
+
+    for (unsigned char i = 0; i < 255; ++i)
+        ((unsigned char *) zmq_msg_data (&msg))[i] = i;
+
+    int rc = zmq_msg_send (&msg, sc, 0);
+    TEST_ASSERT_EQUAL_INT (255, rc);
+
+    rc = zmq_msg_recv (&msg, sb, 0);
+    TEST_ASSERT_EQUAL_INT (255, rc);
+
+    for (unsigned char i = 0; i < 255; ++i)
+        TEST_ASSERT_EQUAL_INT (i, ((unsigned char *) zmq_msg_data (&msg))[i]);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_close (&msg));
+
+    test_context_socket_close (sc);
+    test_context_socket_close (sb);
+}
+
+void test_large_message ()
+{
+    char connect_address[MAX_SOCKET_STRING];
+    size_t addr_length = sizeof (connect_address);
+    void *sb = test_context_socket (ZMQ_REP);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (sb, "ws://127.0.0.1:*/large"));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_getsockopt (sb, ZMQ_LAST_ENDPOINT, connect_address, &addr_length));
+
+    void *sc = test_context_socket (ZMQ_REQ);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sc, connect_address));
+
+    zmq_msg_t msg;
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_init_size (&msg, 65536));
+
+    for (int i = 0; i < 65536; ++i)
+        ((unsigned char *) zmq_msg_data (&msg))[i] = i % 255;
+
+    int rc = zmq_msg_send (&msg, sc, 0);
+    TEST_ASSERT_EQUAL_INT (65536, rc);
+
+    rc = zmq_msg_recv (&msg, sb, 0);
+    TEST_ASSERT_EQUAL_INT (65536, rc);
+
+    for (int i = 0; i < 65536; ++i)
+        TEST_ASSERT_EQUAL_INT (i % 255,
+                               ((unsigned char *) zmq_msg_data (&msg))[i]);
+
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_msg_close (&msg));
+
+    test_context_socket_close (sc);
+    test_context_socket_close (sb);
+}
+
+void test_curve ()
+{
+    char connect_address[MAX_SOCKET_STRING];
+    size_t addr_length = sizeof (connect_address);
+    char client_public[41];
+    char client_secret[41];
+    char server_public[41];
+    char server_secret[41];
+
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_curve_keypair (server_public, server_secret));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_curve_keypair (client_public, client_secret));
+
+    void *server = test_context_socket (ZMQ_REP);
+    int as_server = 1;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (server, ZMQ_CURVE_SERVER, &as_server, sizeof (int)));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (server, ZMQ_CURVE_SECRETKEY, server_secret, 41));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (server, "ws://127.0.0.1:*/roundtrip"));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_getsockopt (server, ZMQ_LAST_ENDPOINT,
+                                               connect_address, &addr_length));
+
+    void *client = test_context_socket (ZMQ_REQ);
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (client, ZMQ_CURVE_SERVERKEY, server_public, 41));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (client, ZMQ_CURVE_PUBLICKEY, client_public, 41));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_setsockopt (client, ZMQ_CURVE_SECRETKEY, client_secret, 41));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (client, connect_address));
+
+    bounce (server, client);
+
+    test_context_socket_close (client);
+    test_context_socket_close (server);
+}
+
+
+void test_mask_shared_msg ()
+{
+    char connect_address[MAX_SOCKET_STRING];
+    size_t addr_length = sizeof (connect_address);
+    void *sb = test_context_socket (ZMQ_DEALER);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (sb, "ws://127.0.0.1:*/mask-shared"));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      zmq_getsockopt (sb, ZMQ_LAST_ENDPOINT, connect_address, &addr_length));
+
+    void *sc = test_context_socket (ZMQ_DEALER);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sc, connect_address));
+
+    zmq_msg_t msg;
+    zmq_msg_init_size (
+      &msg, 255); // Message have to be long enough so it won't fit inside msg
+    unsigned char *data = (unsigned char *) zmq_msg_data (&msg);
+    for (int i = 0; i < 255; i++)
+        data[i] = i;
+
+    //  Taking a copy to make the msg shared
+    zmq_msg_t copy;
+    zmq_msg_init (&copy);
+    zmq_msg_copy (&copy, &msg);
+
+    //  Sending the shared msg
+    int rc = zmq_msg_send (&msg, sc, 0);
+    TEST_ASSERT_EQUAL_INT (255, rc);
+
+    //  Recv the msg and check that it was masked correctly
+    rc = zmq_msg_recv (&msg, sb, 0);
+    TEST_ASSERT_EQUAL_INT (255, rc);
+    data = (unsigned char *) zmq_msg_data (&msg);
+    for (int i = 0; i < 255; i++)
+        TEST_ASSERT_EQUAL_INT (i, data[i]);
+
+    //  Testing that copy was not masked
+    data = (unsigned char *) zmq_msg_data (&copy);
+    for (int i = 0; i < 255; i++)
+        TEST_ASSERT_EQUAL_INT (i, data[i]);
+
+    //  Constant msg cannot be masked as well, as it is constant
+    rc = zmq_send_const (sc, "HELLO", 5, 0);
+    TEST_ASSERT_EQUAL_INT (5, rc);
+    recv_string_expect_success (sb, "HELLO", 0);
+
+    zmq_msg_close (&copy);
+    zmq_msg_close (&msg);
+
+    test_context_socket_close (sc);
+    test_context_socket_close (sb);
+}
+
+
+int main ()
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_roundtrip_without_path);
+    RUN_TEST (test_roundtrip);
+    RUN_TEST (test_short_message);
+    RUN_TEST (test_large_message);
+    RUN_TEST (test_heartbeat);
+    RUN_TEST (test_mask_shared_msg);
+
+    if (zmq_has ("curve"))
+        RUN_TEST (test_curve);
+
+    return UNITY_END ();
+}
diff -pruN 4.3.2-2/tests/test_xpub_manual.cpp 4.3.3-1/tests/test_xpub_manual.cpp
--- 4.3.2-2/tests/test_xpub_manual.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_xpub_manual.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -297,11 +297,6 @@ void test_missing_subscriptions ()
     TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub1, my_endpoint_backend));
     TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (sub1, ZMQ_SUBSCRIBE, topic1, 1));
 
-    // second subscriber
-    void *sub2 = test_context_socket (ZMQ_SUB);
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub2, my_endpoint_backend));
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (sub2, ZMQ_SUBSCRIBE, topic2, 1));
-
     // wait
     msleep (SETTLE_TIME);
 
@@ -312,6 +307,14 @@ void test_missing_subscriptions ()
       zmq_setsockopt (xpub_proxy, ZMQ_SUBSCRIBE, topic1, 1));
     send_array_expect_success (xsub_proxy, subscription1, 0);
 
+    // second subscriber
+    void *sub2 = test_context_socket (ZMQ_SUB);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub2, my_endpoint_backend));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (sub2, ZMQ_SUBSCRIBE, topic2, 1));
+
+    // wait
+    msleep (SETTLE_TIME);
+
     const uint8_t subscription2[] = {1, static_cast<uint8_t> (topic2[0])};
     recv_array_expect_success (xpub_proxy, subscription2, ZMQ_DONTWAIT);
     TEST_ASSERT_SUCCESS_ERRNO (
@@ -434,6 +437,89 @@ void test_unsubscribe_cleanup ()
     test_context_socket_close (sub);
 }
 
+void test_user_message ()
+{
+    //  Create a publisher
+    void *pub = test_context_socket (ZMQ_XPUB);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (pub, "inproc://soname"));
+
+    //  Create a subscriber
+    void *sub = test_context_socket (ZMQ_XSUB);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub, "inproc://soname"));
+
+    //  Send some data that is neither sub nor unsub
+    const char subscription[] = {2, 'A', 0};
+    send_string_expect_success (sub, subscription, 0);
+
+    // Receive subscriptions from subscriber
+    recv_string_expect_success (pub, subscription, 0);
+
+    //  Clean up.
+    test_context_socket_close (pub);
+    test_context_socket_close (sub);
+}
+
+#ifdef ZMQ_ONLY_FIRST_SUBSCRIBE
+void test_user_message_multi ()
+{
+    const int only_first_subscribe = 1;
+
+    //  Create a publisher
+    void *pub = test_context_socket (ZMQ_XPUB);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_bind (pub, "inproc://soname"));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (pub, ZMQ_ONLY_FIRST_SUBSCRIBE,
+                                               &only_first_subscribe,
+                                               sizeof (only_first_subscribe)));
+
+    //  Create a subscriber
+    void *sub = test_context_socket (ZMQ_XSUB);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub, "inproc://soname"));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (sub, ZMQ_ONLY_FIRST_SUBSCRIBE,
+                                               &only_first_subscribe,
+                                               sizeof (only_first_subscribe)));
+
+    //  Send some data that is neither sub nor unsub
+    const uint8_t msg_common[] = {'A', 'B', 'C'};
+    //  Message starts with 0 but should still treated as user
+    const uint8_t msg_0a[] = {0, 'B', 'C'};
+    const uint8_t msg_0b[] = {0, 'C', 'D'};
+    //  Message starts with 1 but should still treated as user
+    const uint8_t msg_1a[] = {1, 'B', 'C'};
+    const uint8_t msg_1b[] = {1, 'C', 'D'};
+
+    // Test second message starting with 0
+    send_array_expect_success (sub, msg_common, ZMQ_SNDMORE);
+    send_array_expect_success (sub, msg_0a, 0);
+
+    // Receive messages from subscriber
+    recv_array_expect_success (pub, msg_common, 0);
+    recv_array_expect_success (pub, msg_0a, 0);
+
+    // Test second message starting with 1
+    send_array_expect_success (sub, msg_common, ZMQ_SNDMORE);
+    send_array_expect_success (sub, msg_1a, 0);
+
+    // Receive messages from subscriber
+    recv_array_expect_success (pub, msg_common, 0);
+    recv_array_expect_success (pub, msg_1a, 0);
+
+    // Test first message starting with 1
+    send_array_expect_success (sub, msg_1a, ZMQ_SNDMORE);
+    send_array_expect_success (sub, msg_1b, 0);
+    recv_array_expect_success (pub, msg_1a, 0);
+    recv_array_expect_success (pub, msg_1b, 0);
+
+    send_array_expect_success (sub, msg_0a, ZMQ_SNDMORE);
+    send_array_expect_success (sub, msg_0b, 0);
+    recv_array_expect_success (pub, msg_0a, 0);
+    recv_array_expect_success (pub, msg_0b, 0);
+
+    //  Clean up.
+    test_context_socket_close (pub);
+    test_context_socket_close (sub);
+}
+#endif
+
 int main ()
 {
     setup_test_environment ();
@@ -444,6 +530,10 @@ int main ()
     RUN_TEST (test_xpub_proxy_unsubscribe_on_disconnect);
     RUN_TEST (test_missing_subscriptions);
     RUN_TEST (test_unsubscribe_cleanup);
+    RUN_TEST (test_user_message);
+#ifdef ZMQ_ONLY_FIRST_SUBSCRIBE
+    RUN_TEST (test_user_message_multi);
+#endif
 
     return UNITY_END ();
 }
diff -pruN 4.3.2-2/tests/test_xpub_manual_last_value.cpp 4.3.3-1/tests/test_xpub_manual_last_value.cpp
--- 4.3.2-2/tests/test_xpub_manual_last_value.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_xpub_manual_last_value.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -303,11 +303,6 @@ void test_missing_subscriptions ()
     TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub1, my_endpoint_backend));
     TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (sub1, ZMQ_SUBSCRIBE, topic1, 1));
 
-    // second subscriber
-    void *sub2 = test_context_socket (ZMQ_SUB);
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub2, my_endpoint_backend));
-    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (sub2, ZMQ_SUBSCRIBE, topic2, 1));
-
     // wait
     msleep (SETTLE_TIME);
 
@@ -318,6 +313,15 @@ void test_missing_subscriptions ()
       zmq_setsockopt (xpub_proxy, ZMQ_SUBSCRIBE, topic1, 1));
     send_array_expect_success (xsub_proxy, subscription1, 0);
 
+    // second subscriber
+    void *sub2 = test_context_socket (ZMQ_SUB);
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_connect (sub2, my_endpoint_backend));
+    TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (sub2, ZMQ_SUBSCRIBE, topic2, 1));
+
+    // wait
+    msleep (SETTLE_TIME);
+
+    // proxy now reroutes and confirms subscriptions
     const uint8_t subscription2[] = {1, static_cast<uint8_t> (topic2[0])};
     recv_array_expect_success (xpub_proxy, subscription2, ZMQ_DONTWAIT);
     TEST_ASSERT_SUCCESS_ERRNO (
diff -pruN 4.3.2-2/tests/test_xpub_nodrop.cpp 4.3.3-1/tests/test_xpub_nodrop.cpp
--- 4.3.2-2/tests/test_xpub_nodrop.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/tests/test_xpub_nodrop.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -73,16 +73,16 @@ void test ()
         if (rc == -1) {
             TEST_ASSERT_EQUAL_INT (EAGAIN, errno);
             break;
-        } else {
-            TEST_ASSERT_EQUAL_INT (0, rc);
-            recv_count++;
+        }
+        TEST_ASSERT_EQUAL_INT (0, rc);
+        recv_count++;
 
-            if (recv_count == 1) {
-                const int sub_rcvtimeo = 250;
-                TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (
-                  sub, ZMQ_RCVTIMEO, &sub_rcvtimeo, sizeof (sub_rcvtimeo)));
-            }
+        if (recv_count == 1) {
+            const int sub_rcvtimeo = 250;
+            TEST_ASSERT_SUCCESS_ERRNO (zmq_setsockopt (
+              sub, ZMQ_RCVTIMEO, &sub_rcvtimeo, sizeof (sub_rcvtimeo)));
         }
+
     } while (true);
 
     TEST_ASSERT_EQUAL_INT (send_count, recv_count);
@@ -101,8 +101,15 @@ void test ()
         send_count++;
     TEST_ASSERT_EQUAL_INT (EAGAIN, errno);
 
-    while (zmq_recv (sub, NULL, 0, ZMQ_DONTWAIT) == 0)
+    if (send_count > 0) {
+        //  Receive first message with blocking
+        TEST_ASSERT_SUCCESS_ERRNO (zmq_recv (sub, NULL, 0, 0));
         recv_count++;
+
+        while (zmq_recv (sub, NULL, 0, ZMQ_DONTWAIT) == 0)
+            recv_count++;
+    }
+
     TEST_ASSERT_EQUAL_INT (send_count, recv_count);
 
     //  Clean up.
diff -pruN 4.3.2-2/tests/test_z85_decode_fuzzer.cpp 4.3.3-1/tests/test_z85_decode_fuzzer.cpp
--- 4.3.2-2/tests/test_z85_decode_fuzzer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/tests/test_z85_decode_fuzzer.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,90 @@
+/*
+    Copyright (c) 2020 Contributors as noted in the AUTHORS file
+
+    This file is part of libzmq, the ZeroMQ core engine in C++.
+
+    libzmq is free software; you can redistribute it and/or modify it under
+    the terms of the GNU Lesser General Public License (LGPL) as published
+    by the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    As a special exception, the Contributors give you permission to link
+    this library with independent modules to produce an executable,
+    regardless of the license terms of these independent modules, and to
+    copy and distribute the resulting executable under terms of your choice,
+    provided that you also meet, for each linked independent module, the
+    terms and conditions of the license of that module. An independent
+    module is a module which is not derived from or based on this library.
+    If you modify this library, you must extend this exception to your
+    version of the library.
+
+    libzmq is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
+    License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef ZMQ_USE_FUZZING_ENGINE
+#include <fuzzer/FuzzedDataProvider.h>
+#endif
+
+#include <string>
+#include <stdlib.h>
+
+#include "testutil.hpp"
+#include "testutil_unity.hpp"
+
+extern "C" int LLVMFuzzerTestOneInput (const uint8_t *data, size_t size)
+{
+    uint8_t *secret_key;
+
+    if (size < 5)
+        return 0;
+
+    // As per API definition, input must be divisible by 5, so truncate it if it's not
+    size -= size % 5;
+    // As per API definition, the destination must be at least 0.8 times the input data
+    TEST_ASSERT_NOT_NULL (secret_key = (uint8_t *) malloc (size * 4 / 5));
+
+    std::string z85_secret_key (reinterpret_cast<const char *> (data), size);
+    zmq_z85_decode (secret_key, z85_secret_key.c_str ());
+
+    free (secret_key);
+
+    return 0;
+}
+
+#ifndef ZMQ_USE_FUZZING_ENGINE
+void test_z85_decode_fuzzer ()
+{
+    uint8_t **data;
+    size_t *len, num_cases = 0;
+    if (fuzzer_corpus_encode (
+          "tests/libzmq-fuzz-corpora/test_z85_decode_fuzzer_seed_corpus", &data,
+          &len, &num_cases)
+        != 0)
+        exit (77);
+
+    while (num_cases-- > 0) {
+        TEST_ASSERT_SUCCESS_ERRNO (
+          LLVMFuzzerTestOneInput (data[num_cases], len[num_cases]));
+        free (data[num_cases]);
+    }
+
+    free (data);
+    free (len);
+}
+
+int main (int argc, char **argv)
+{
+    setup_test_environment ();
+
+    UNITY_BEGIN ();
+    RUN_TEST (test_z85_decode_fuzzer);
+
+    return UNITY_END ();
+}
+#endif
diff -pruN 4.3.2-2/.travis.yml 4.3.3-1/.travis.yml
--- 4.3.2-2/.travis.yml	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/.travis.yml	2020-09-07 10:12:14.000000000 +0000
@@ -6,7 +6,7 @@ os:
 - linux
 - osx
 
-dist: trusty
+dist: bionic
 
 cache: ccache
 
@@ -29,34 +29,42 @@ env:
 matrix:
   include:
   - if: type = cron OR (branch =~ analyze$ AND type = push)
-    env: BUILD_TYPE=cmake CLANG_TIDY=/usr/bin/clang-tidy-6.0 CC=clang-6.0 CXX=clang++-6.0
+    env: BUILD_TYPE=cmake CLANG_TIDY=/usr/bin/clang-tidy-10 CC=clang-10 CXX=clang++-10
     os: linux
     compiler: clang
     addons:
       apt:
         sources:
           - ubuntu-toolchain-r-test
-          - llvm-toolchain-trusty-6.0
+          - llvm-toolchain-10
         packages:
-          - clang-6.0
-          - clang-tools-6.0
-          - clang-tidy-6.0
+          - clang-10
+          - clang-tools-10
+          - clang-tidy-10
   - env: BUILD_TYPE=default CURVE=tweetnacl IPv6=ON
     os: linux
     dist: precise
-    sudo: false
-  - env: BUILD_TYPE=coverage CURVE=tweetnacl DRAFT=enabled
+  - env: BUILD_TYPE=coverage CURVE=tweetnacl GSSAPI=enabled PGM=enabled NORM=enabled TIPC=enabled IPv6=ON TLS=enabled DRAFT=enabled
     os: linux
     addons:
       apt:
+        sources:
+        - sourceline: 'deb http://download.opensuse.org/repositories/network:/messaging:/zeromq:/git-stable/xUbuntu_18.04/ ./'
+          key_url: 'http://download.opensuse.org/repositories/network:/messaging:/zeromq:/git-stable/xUbuntu_18.04/Release.key'
         packages:
+        - libkrb5-dev
+        - libnorm-dev
+        - libpgm-dev
+        - libgnutls28-dev
         - lcov
-  - env: BUILD_TYPE=valgrind CURVE=tweetnacl DRAFT=enabled
+  - env: BUILD_TYPE=valgrind CURVE=tweetnacl DRAFT=enabled TLS=enabled
     os: linux
+    dist: xenial
     addons:
       apt:
         packages:
         - valgrind
+        - libgnutls-dev
   - env: BUILD_TYPE=default CURVE=libsodium GSSAPI=enabled PGM=enabled NORM=enabled
     os: linux
     addons:
@@ -71,9 +79,15 @@ matrix:
         - libsodium-dev
         - asciidoc
         - xmlto
-  - env: BUILD_TYPE=default CURVE=libsodium DRAFT=enabled GSSAPI=enabled PGM=enabled NORM=enabled TIPC=enabled
+  - env: BUILD_TYPE=default DRAFT=enabled TLS=enabled
+    os: linux
+    dist: xenial
+    addons:
+      apt:
+        packages:
+          - libgnutls-dev
+  - env: BUILD_TYPE=default CURVE=libsodium DRAFT=enabled GSSAPI=enabled PGM=enabled NORM=enabled TIPC=enabled USE_NSS=yes
     os: linux
-    sudo: required
     addons:
       apt:
         sources:
@@ -84,30 +98,25 @@ matrix:
         - libnorm-dev
         - libpgm-dev
         - libsodium-dev
+        - libnss3-dev
+        - libbsd-dev
   - env: BUILD_TYPE=default CURVE=libsodium DRAFT=enabled
     os: osx
-  - env: BUILD_TYPE=default CURVE=tweetnacl DRAFT=enabled ADDRESS_SANITIZER=enabled
+  - env: BUILD_TYPE=default CURVE=libsodium DRAFT=enabled ADDRESS_SANITIZER=enabled
     os: linux
-    dist: trusty
     addons:
       apt:
-        sources:
-        - sourceline: 'ppa:ubuntu-toolchain-r/test'
         packages:
-        - g++-6
-        - gcc-6
+        - libsodium-dev
   - env: BUILD_TYPE=android CURVE=tweetnacl
     os: linux
     dist: trusty
-  - env: BUILD_TYPE=cmake DO_CLANG_FORMAT_CHECK=1 CLANG_FORMAT=/usr/lib/llvm-7/bin/clang-format
+  - env: BUILD_TYPE=cmake DO_CLANG_FORMAT_CHECK=1 CLANG_FORMAT=/usr/lib/llvm-8/bin/clang-format
     os: linux
     addons:
       apt:
-        sources:
-        - llvm-toolchain-trusty-7
-        - ubuntu-toolchain-r-test
         packages:
-        - clang-format-7
+        - clang-format-8
   - env: BUILD_TYPE=default POLLER=poll
     os: linux
   - env: BUILD_TYPE=default POLLER=select
@@ -134,18 +143,19 @@ matrix:
         - abi-dumper
         - abi-compliance-checker
     
-sudo: false
 
 before_install:
 - if [ $TRAVIS_OS_NAME == "osx" -a $BUILD_TYPE == "android" ] ; then brew update; brew install binutils ; fi
 - if [ $TRAVIS_OS_NAME == "osx" -a $CURVE == "libsodium" ] ; then brew update; brew install libsodium ; fi
+# To allow sonar to process history information, unshallow clone first.
 - if [ -n "$CLANG_TIDY" ] ; then
+    git fetch --unshallow ;
     curl -L https://sonarcloud.io/static/cpp/build-wrapper-linux-x86.zip -o build-wrapper-linux-x86.zip ;
     unzip build-wrapper-linux-x86.zip ;
     export SONARCLOUD_BUILD_WRAPPER_PATH="$(pwd)/build-wrapper-linux-x86/" ;
-    curl -L https://sonarsource.bintray.com/Distribution/sonar-scanner-cli/sonar-scanner-cli-3.1.0.1141-linux.zip -o sonar-scanner-cli.zip ;
+    curl -L https://binaries.sonarsource.com/Distribution/sonar-scanner-cli/sonar-scanner-cli-4.2.0.1873-linux.zip -o sonar-scanner-cli.zip ;
     unzip sonar-scanner-cli.zip ;
-    export SONAR_SCANNER_CLI_PATH="$(pwd)/sonar-scanner-3.1.0.1141-linux/bin/" ;
+    export SONAR_SCANNER_CLI_PATH="$(pwd)/sonar-scanner-4.2.0.1873-linux/bin/" ;
   fi
 
 before_script:
diff -pruN 4.3.2-2/unittests/CMakeLists.txt 4.3.3-1/unittests/CMakeLists.txt
--- 4.3.2-2/unittests/CMakeLists.txt	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/unittests/CMakeLists.txt	2020-09-07 10:12:14.000000000 +0000
@@ -2,18 +2,15 @@
 cmake_minimum_required(VERSION "2.8.1")
 
 set(unittests
-  unittest_ypipe
-  unittest_poller
-  unittest_mtrie
-  unittest_ip_resolver
-  unittest_udp_address
-  unittest_radix_tree
-)
-
-#if(ENABLE_DRAFTS)
-#  list(APPEND tests
-#  )
-#endif(ENABLE_DRAFTS)
+    unittest_ypipe
+    unittest_poller
+    unittest_mtrie
+    unittest_ip_resolver
+    unittest_udp_address
+    unittest_radix_tree
+    unittest_curve_encoding)
+
+# if(ENABLE_DRAFTS) list(APPEND tests ) endif(ENABLE_DRAFTS)
 
 # add location of platform.hpp for Windows builds
 if(WIN32)
@@ -47,7 +44,10 @@ foreach(test ${unittests})
   endif()
 
   if(WIN32)
-    add_test(NAME ${test} WORKING_DIRECTORY ${LIBRARY_OUTPUT_PATH} COMMAND ${test})
+    add_test(
+      NAME ${test}
+      WORKING_DIRECTORY ${LIBRARY_OUTPUT_PATH}
+      COMMAND ${test})
   else()
     add_test(NAME ${test} COMMAND ${test})
   endif()
@@ -60,8 +60,8 @@ foreach(test ${unittests})
   set_target_properties(${test} PROPERTIES LINK_LIBRARIES "${LIBS}")
 endforeach()
 
-#Check whether all tests in the current folder are present
-#TODO duplicated with tests/CMakeLists.txt, define as a function?
+# Check whether all tests in the current folder are present TODO duplicated with tests/CMakeLists.txt, define as a
+# function?
 file(READ "${CMAKE_CURRENT_LIST_FILE}" CURRENT_LIST_FILE_CONTENT)
 file(GLOB ALL_TEST_SOURCES "test_*.cpp")
 foreach(TEST_SOURCE ${ALL_TEST_SOURCES})
diff -pruN 4.3.2-2/unittests/unittest_curve_encoding.cpp 4.3.3-1/unittests/unittest_curve_encoding.cpp
--- 4.3.2-2/unittests/unittest_curve_encoding.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.3-1/unittests/unittest_curve_encoding.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -0,0 +1,155 @@
+/*
+Copyright (c) 2018 Contributors as noted in the AUTHORS file
+
+This file is part of 0MQ.
+
+0MQ is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by
+the Free Software Foundation; either version 3 of the License, or
+(at your option) any later version.
+
+0MQ is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "../tests/testutil_unity.hpp"
+
+// TODO: remove this ugly hack
+#ifdef close
+#undef close
+#endif
+
+#include <curve_mechanism_base.hpp>
+#include <msg.hpp>
+#include <random.hpp>
+
+#include <unity.h>
+
+#include <vector>
+
+void setUp ()
+{
+}
+
+void tearDown ()
+{
+}
+
+void test_roundtrip (zmq::msg_t *msg_)
+{
+#ifdef ZMQ_HAVE_CURVE
+    const std::vector<uint8_t> original (static_cast<uint8_t *> (msg_->data ()),
+                                         static_cast<uint8_t *> (msg_->data ())
+                                           + msg_->size ());
+
+    zmq::curve_encoding_t encoding_client ("CurveZMQMESSAGEC",
+                                           "CurveZMQMESSAGES",
+                                           false);
+    zmq::curve_encoding_t encoding_server ("CurveZMQMESSAGES",
+                                           "CurveZMQMESSAGEC",
+                                           false);
+
+    uint8_t client_public[32];
+    uint8_t client_secret[32];
+    TEST_ASSERT_SUCCESS_ERRNO (
+      crypto_box_keypair (client_public, client_secret));
+
+    uint8_t server_public[32];
+    uint8_t server_secret[32];
+    TEST_ASSERT_SUCCESS_ERRNO (
+      crypto_box_keypair (server_public, server_secret));
+
+    TEST_ASSERT_SUCCESS_ERRNO (
+      crypto_box_beforenm (encoding_client.get_writable_precom_buffer (),
+                           server_public, client_secret));
+    TEST_ASSERT_SUCCESS_ERRNO (
+      crypto_box_beforenm (encoding_server.get_writable_precom_buffer (),
+                           client_public, server_secret));
+
+    TEST_ASSERT_SUCCESS_ERRNO (encoding_client.encode (msg_));
+
+    // TODO: This is hacky...
+    encoding_server.set_peer_nonce (0);
+    int error_event_code;
+    TEST_ASSERT_SUCCESS_ERRNO (
+      encoding_server.decode (msg_, &error_event_code));
+
+    TEST_ASSERT_EQUAL_INT (original.size (), msg_->size ());
+    if (!original.empty ()) {
+        TEST_ASSERT_EQUAL_UINT8_ARRAY (&original[0], msg_->data (),
+                                       original.size ());
+    }
+#else
+    TEST_IGNORE_MESSAGE ("CURVE support is disabled");
+#endif
+}
+
+void test_roundtrip_empty ()
+{
+    zmq::msg_t msg;
+    msg.init ();
+
+    test_roundtrip (&msg);
+
+    msg.close ();
+}
+
+void test_roundtrip_small ()
+{
+    zmq::msg_t msg;
+    msg.init_size (32);
+    memcpy (msg.data (), "0123456789ABCDEF0123456789ABCDEF", 32);
+
+    test_roundtrip (&msg);
+
+    msg.close ();
+}
+
+void test_roundtrip_large ()
+{
+    zmq::msg_t msg;
+    msg.init_size (2048);
+    for (size_t pos = 0; pos < 2048; pos += 32) {
+        memcpy (static_cast<char *> (msg.data ()) + pos,
+                "0123456789ABCDEF0123456789ABCDEF", 32);
+    }
+
+    test_roundtrip (&msg);
+
+    msg.close ();
+}
+
+void test_roundtrip_empty_more ()
+{
+    zmq::msg_t msg;
+    msg.init ();
+    msg.set_flags (zmq::msg_t::more);
+
+    test_roundtrip (&msg);
+    TEST_ASSERT_TRUE (msg.flags () & zmq::msg_t::more);
+
+    msg.close ();
+}
+
+int main ()
+{
+    setup_test_environment ();
+    zmq::random_open ();
+
+    UNITY_BEGIN ();
+
+    RUN_TEST (test_roundtrip_empty);
+    RUN_TEST (test_roundtrip_small);
+    RUN_TEST (test_roundtrip_large);
+
+    RUN_TEST (test_roundtrip_empty_more);
+
+    zmq::random_close ();
+
+    return UNITY_END ();
+}
diff -pruN 4.3.2-2/unittests/unittest_ip_resolver.cpp 4.3.3-1/unittests/unittest_ip_resolver.cpp
--- 4.3.2-2/unittests/unittest_ip_resolver.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/unittests/unittest_ip_resolver.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -18,6 +18,7 @@ along with this program.  If not, see <h
 */
 
 #include <unity.h>
+#include "../src/macros.hpp"
 #include "../tests/testutil.hpp"
 #include "../tests/testutil_unity.hpp"
 #include "../unittests/unittest_resolver_common.hpp"
@@ -39,7 +40,7 @@ void tearDown ()
 {
 }
 
-class test_ip_resolver_t : public zmq::ip_resolver_t
+class test_ip_resolver_t ZMQ_FINAL : public zmq::ip_resolver_t
 {
   public:
     test_ip_resolver_t (zmq::ip_resolver_options_t opts_) :
@@ -55,10 +56,10 @@ class test_ip_resolver_t : public zmq::i
         const char *ipv6;
     };
 
-    virtual int do_getaddrinfo (const char *node_,
-                                const char *service_,
-                                const struct addrinfo *hints_,
-                                struct addrinfo **res_)
+    int do_getaddrinfo (const char *node_,
+                        const char *service_,
+                        const struct addrinfo *hints_,
+                        struct addrinfo **res_) ZMQ_FINAL
     {
         static const struct dns_lut_t dns_lut[] = {
           {"ip.zeromq.org", "10.100.0.1", "fdf5:d058:d656::1"},
@@ -105,7 +106,7 @@ class test_ip_resolver_t : public zmq::i
         return zmq::ip_resolver_t::do_getaddrinfo (ip, NULL, &ai, res_);
     }
 
-    virtual unsigned int do_if_nametoindex (const char *ifname_)
+    unsigned int do_if_nametoindex (const char *ifname_) ZMQ_FINAL
     {
         static const char *dummy_interfaces[] = {
           "lo0",
@@ -160,9 +161,9 @@ static void test_resolve (zmq::ip_resolv
         // TODO also check the expected errno
         TEST_ASSERT_EQUAL (-1, rc);
         return;
-    } else {
-        TEST_ASSERT_SUCCESS_ERRNO (rc);
     }
+    TEST_ASSERT_SUCCESS_ERRNO (rc);
+
 
     validate_address (family, &addr, expected_addr_, expected_port_,
                       expected_zone_, expected_addr_v4_failover_);
diff -pruN 4.3.2-2/unittests/unittest_mtrie.cpp 4.3.3-1/unittests/unittest_mtrie.cpp
--- 4.3.2-2/unittests/unittest_mtrie.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/unittests/unittest_mtrie.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -34,9 +34,9 @@ void tearDown ()
 {
 }
 
-int getlen (const zmq::generic_mtrie_t<int>::prefix_t &data)
+int getlen (const zmq::generic_mtrie_t<int>::prefix_t &data_)
 {
-    return (int) strlen (reinterpret_cast<const char *> (data));
+    return static_cast<int> (strlen (reinterpret_cast<const char *> (data_)));
 }
 
 void test_create ()
@@ -44,10 +44,10 @@ void test_create ()
     zmq::generic_mtrie_t<int> mtrie;
 }
 
-void mtrie_count (int *pipe, int *count)
+void mtrie_count (int *pipe_, int *count_)
 {
-    LIBZMQ_UNUSED (pipe);
-    ++*count;
+    LIBZMQ_UNUSED (pipe_);
+    ++*count_;
 }
 
 void test_check_empty_match_nonempty_data ()
@@ -187,14 +187,14 @@ void test_rm_nonexistent_empty ()
     TEST_ASSERT_EQUAL_INT (0, count);
 }
 
-void test_add_and_rm_other (const char *add_name, const char *rm_name)
+void test_add_and_rm_other (const char *add_name_, const char *rm_name_)
 {
     int addpipe, rmpipe;
     zmq::generic_mtrie_t<int> mtrie;
     const zmq::generic_mtrie_t<int>::prefix_t add_name_data =
-      reinterpret_cast<zmq::generic_mtrie_t<int>::prefix_t> (add_name);
+      reinterpret_cast<zmq::generic_mtrie_t<int>::prefix_t> (add_name_);
     const zmq::generic_mtrie_t<int>::prefix_t rm_name_data =
-      reinterpret_cast<zmq::generic_mtrie_t<int>::prefix_t> (rm_name);
+      reinterpret_cast<zmq::generic_mtrie_t<int>::prefix_t> (rm_name_);
 
     mtrie.add (add_name_data, getlen (add_name_data), &addpipe);
 
@@ -209,8 +209,8 @@ void test_add_and_rm_other (const char *
         TEST_ASSERT_EQUAL_INT (1, count);
     }
 
-    if (strncmp (add_name, rm_name,
-                 std::min (strlen (add_name), strlen (rm_name) + 1))
+    if (strncmp (add_name_, rm_name_,
+                 std::min (strlen (add_name_), strlen (rm_name_) + 1))
         != 0) {
         int count = 0;
         mtrie.match (rm_name_data, getlen (rm_name_data), mtrie_count, &count);
@@ -240,15 +240,15 @@ void test_rm_nonexistent_nonempty_prefix
     test_add_and_rm_other ("foo", "foobar");
 }
 
-void add_indexed_expect_unique (zmq::generic_mtrie_t<int> &mtrie,
-                                int *pipes,
-                                const char **names,
-                                size_t i)
+void add_indexed_expect_unique (zmq::generic_mtrie_t<int> &mtrie_,
+                                int *pipes_,
+                                const char **names_,
+                                size_t i_)
 {
     const zmq::generic_mtrie_t<int>::prefix_t name_data =
-      reinterpret_cast<zmq::generic_mtrie_t<int>::prefix_t> (names[i]);
+      reinterpret_cast<zmq::generic_mtrie_t<int>::prefix_t> (names_[i_]);
 
-    bool res = mtrie.add (name_data, getlen (name_data), &pipes[i]);
+    bool res = mtrie_.add (name_data, getlen (name_data), &pipes_[i_]);
     TEST_ASSERT_EQUAL (zmq::generic_mtrie_t<int>::last_value_removed, res);
 }
 
@@ -270,12 +270,12 @@ void test_rm_nonexistent_between ()
 }
 
 template <size_t N>
-void add_entries (zmq::generic_mtrie_t<int> &mtrie,
-                  int (&pipes)[N],
-                  const char *(&names)[N])
+void add_entries (zmq::generic_mtrie_t<int> &mtrie_,
+                  int (&pipes_)[N],
+                  const char *(&names_)[N])
 {
     for (size_t i = 0; i < N; ++i) {
-        add_indexed_expect_unique (mtrie, pipes, names, i);
+        add_indexed_expect_unique (mtrie_, pipes_, names_, i);
     }
 }
 
@@ -303,7 +303,8 @@ void test_add_multiple_reverse ()
 
     zmq::generic_mtrie_t<int> mtrie;
     for (int i = 2; i >= 0; --i) {
-        add_indexed_expect_unique (mtrie, pipes, names, (size_t) i);
+        add_indexed_expect_unique (mtrie, pipes, names,
+                                   static_cast<size_t> (i));
     }
 
     for (size_t i = 0; i < 3; ++i) {
@@ -315,15 +316,15 @@ void test_add_multiple_reverse ()
     }
 }
 
-template <size_t N> void add_and_rm_entries (const char *(&names)[N])
+template <size_t N> void add_and_rm_entries (const char *(&names_)[N])
 {
     int pipes[N];
     zmq::generic_mtrie_t<int> mtrie;
-    add_entries (mtrie, pipes, names);
+    add_entries (mtrie, pipes, names_);
 
     for (size_t i = 0; i < N; ++i) {
         const zmq::generic_mtrie_t<int>::prefix_t name_data =
-          reinterpret_cast<zmq::generic_mtrie_t<int>::prefix_t> (names[i]);
+          reinterpret_cast<zmq::generic_mtrie_t<int>::prefix_t> (names_[i]);
 
         zmq::generic_mtrie_t<int>::rm_result res =
           mtrie.rm (name_data, getlen (name_data), &pipes[i]);
@@ -351,14 +352,14 @@ void check_name (zmq::generic_mtrie_t<in
     TEST_ASSERT_EQUAL_STRING_LEN (name_, data_, len_);
 }
 
-template <size_t N> void add_entries_rm_pipes_unique (const char *(&names)[N])
+template <size_t N> void add_entries_rm_pipes_unique (const char *(&names_)[N])
 {
     int pipes[N];
     zmq::generic_mtrie_t<int> mtrie;
-    add_entries (mtrie, pipes, names);
+    add_entries (mtrie, pipes, names_);
 
     for (size_t i = 0; i < N; ++i) {
-        mtrie.rm (&pipes[i], check_name, names[i], false);
+        mtrie.rm (&pipes[i], check_name, names_[i], false);
     }
 }
 
@@ -384,16 +385,16 @@ void check_count (zmq::generic_mtrie_t<i
     TEST_ASSERT_GREATER_OR_EQUAL (0, *count_);
 }
 
-void add_duplicate_entry (zmq::generic_mtrie_t<int> &mtrie, int (&pipes)[2])
+void add_duplicate_entry (zmq::generic_mtrie_t<int> &mtrie_, int (&pipes_)[2])
 {
     const char *name = "foo";
 
     const zmq::generic_mtrie_t<int>::prefix_t name_data =
       reinterpret_cast<zmq::generic_mtrie_t<int>::prefix_t> (name);
 
-    bool res = mtrie.add (name_data, getlen (name_data), &pipes[0]);
+    bool res = mtrie_.add (name_data, getlen (name_data), &pipes_[0]);
     TEST_ASSERT_TRUE (res);
-    res = mtrie.add (name_data, getlen (name_data), &pipes[1]);
+    res = mtrie_.add (name_data, getlen (name_data), &pipes_[1]);
     TEST_ASSERT_FALSE (res);
 }
 
diff -pruN 4.3.2-2/unittests/unittest_poller.cpp 4.3.3-1/unittests/unittest_poller.cpp
--- 4.3.2-2/unittests/unittest_poller.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/unittests/unittest_poller.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -57,52 +57,53 @@ void test_start_empty ()
 struct test_events_t : zmq::i_poll_events
 {
     test_events_t (zmq::fd_t fd_, zmq::poller_t &poller_) :
-        fd (fd_),
-        poller (poller_)
+        _fd (fd_),
+        _poller (poller_)
     {
-        (void)fd;
+        (void) _fd;
     }
 
-    virtual void in_event ()
+    void in_event () ZMQ_OVERRIDE
     {
-        poller.rm_fd (handle);
-        handle = (zmq::poller_t::handle_t) NULL;
+        _poller.rm_fd (_handle);
+        _handle = (zmq::poller_t::handle_t) NULL;
 
         // this must only be incremented after rm_fd
         in_events.add (1);
     }
 
 
-    virtual void out_event ()
+    void out_event () ZMQ_OVERRIDE
     {
         // TODO
     }
 
 
-    virtual void timer_event (int id_)
+    void timer_event (int id_) ZMQ_OVERRIDE
     {
         LIBZMQ_UNUSED (id_);
-        poller.rm_fd (handle);
-        handle = (zmq::poller_t::handle_t) NULL;
+        _poller.rm_fd (_handle);
+        _handle = (zmq::poller_t::handle_t) NULL;
 
         // this must only be incremented after rm_fd
         timer_events.add (1);
     }
 
-    void set_handle (zmq::poller_t::handle_t handle_) { handle = handle_; }
+    void set_handle (zmq::poller_t::handle_t handle_) { _handle = handle_; }
 
     zmq::atomic_counter_t in_events, timer_events;
 
   private:
-    zmq::fd_t fd;
-    zmq::poller_t &poller;
-    zmq::poller_t::handle_t handle;
+    zmq::fd_t _fd;
+    zmq::poller_t &_poller;
+    zmq::poller_t::handle_t _handle;
 };
 
-void wait_in_events (test_events_t &events)
+void wait_in_events (test_events_t &events_)
 {
     void *watch = zmq_stopwatch_start ();
-    while (events.in_events.get () < 1) {
+    while (events_.in_events.get () < 1) {
+        msleep (1);
 #ifdef ZMQ_BUILD_DRAFT
         TEST_ASSERT_LESS_OR_EQUAL_MESSAGE (SETTLE_TIME,
                                            zmq_stopwatch_intermediate (watch),
@@ -112,10 +113,11 @@ void wait_in_events (test_events_t &even
     zmq_stopwatch_stop (watch);
 }
 
-void wait_timer_events (test_events_t &events)
+void wait_timer_events (test_events_t &events_)
 {
     void *watch = zmq_stopwatch_start ();
-    while (events.timer_events.get () < 1) {
+    while (events_.timer_events.get () < 1) {
+        msleep (1);
 #ifdef ZMQ_BUILD_DRAFT
         TEST_ASSERT_LESS_OR_EQUAL_MESSAGE (SETTLE_TIME,
                                            zmq_stopwatch_intermediate (watch),
@@ -125,40 +127,40 @@ void wait_timer_events (test_events_t &e
     zmq_stopwatch_stop (watch);
 }
 
-void create_nonblocking_fdpair (zmq::fd_t *r, zmq::fd_t *w)
+void create_nonblocking_fdpair (zmq::fd_t *r_, zmq::fd_t *w_)
 {
-    int rc = zmq::make_fdpair (r, w);
+    int rc = zmq::make_fdpair (r_, w_);
     TEST_ASSERT_EQUAL_INT (0, rc);
-    TEST_ASSERT_NOT_EQUAL (zmq::retired_fd, *r);
-    TEST_ASSERT_NOT_EQUAL (zmq::retired_fd, *w);
-    zmq::unblock_socket (*r);
-    zmq::unblock_socket (*w);
+    TEST_ASSERT_NOT_EQUAL (zmq::retired_fd, *r_);
+    TEST_ASSERT_NOT_EQUAL (zmq::retired_fd, *w_);
+    zmq::unblock_socket (*r_);
+    zmq::unblock_socket (*w_);
 }
 
-void send_signal (zmq::fd_t w)
+void send_signal (zmq::fd_t w_)
 {
 #if defined ZMQ_HAVE_EVENTFD
     const uint64_t inc = 1;
-    ssize_t sz = write (w, &inc, sizeof (inc));
+    ssize_t sz = write (w_, &inc, sizeof (inc));
     assert (sz == sizeof (inc));
 #else
     {
         char msg[] = "test";
-        int rc = send (w, msg, sizeof (msg), 0);
+        int rc = send (w_, msg, sizeof (msg), 0);
         assert (rc == sizeof (msg));
     }
 #endif
 }
 
-void close_fdpair (zmq::fd_t w, zmq::fd_t r)
+void close_fdpair (zmq::fd_t w_, zmq::fd_t r_)
 {
-    int rc = closesocket (w);
+    int rc = closesocket (w_);
     TEST_ASSERT_EQUAL_INT (0, rc);
 #if !defined ZMQ_HAVE_EVENTFD
-    rc = closesocket (r);
+    rc = closesocket (r_);
     TEST_ASSERT_EQUAL_INT (0, rc);
 #else
-    LIBZMQ_UNUSED (r);
+    LIBZMQ_UNUSED (r_);
 #endif
 }
 
diff -pruN 4.3.2-2/unittests/unittest_radix_tree.cpp 4.3.3-1/unittests/unittest_radix_tree.cpp
--- 4.3.2-2/unittests/unittest_radix_tree.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/unittests/unittest_radix_tree.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -222,13 +222,13 @@ void test_size ()
     TEST_ASSERT_TRUE (tree.size () == 0);
 }
 
-void return_key (unsigned char *data, size_t size, void *arg)
+void return_key (unsigned char *data_, size_t size_, void *arg_)
 {
     std::vector<std::string> *vec =
-      reinterpret_cast<std::vector<std::string> *> (arg);
+      reinterpret_cast<std::vector<std::string> *> (arg_);
     std::string key;
-    for (size_t i = 0; i < size; ++i)
-        key.push_back (static_cast<char> (data[i]));
+    for (size_t i = 0; i < size_; ++i)
+        key.push_back (static_cast<char> (data_[i]));
     vec->push_back (key);
 }
 
diff -pruN 4.3.2-2/unittests/unittest_udp_address.cpp 4.3.3-1/unittests/unittest_udp_address.cpp
--- 4.3.2-2/unittests/unittest_udp_address.cpp	2019-07-08 16:06:38.000000000 +0000
+++ 4.3.3-1/unittests/unittest_udp_address.cpp	2020-09-07 10:12:14.000000000 +0000
@@ -54,9 +54,9 @@ static void test_resolve (bool bind_,
         TEST_ASSERT_EQUAL (-1, rc);
         TEST_ASSERT_EQUAL (EINVAL, errno);
         return;
-    } else {
-        TEST_ASSERT_EQUAL (0, rc);
     }
+    TEST_ASSERT_EQUAL (0, rc);
+
 
     TEST_ASSERT_EQUAL (multicast_, addr.is_mcast ());
 
@@ -69,32 +69,36 @@ static void test_resolve (bool bind_,
         }
     }
 
-    validate_address (family_, addr.target_addr(), target_addr_, expected_port_);
-    validate_address (family_, addr.bind_addr(), bind_addr_, expected_port_);
+    validate_address (family_, addr.target_addr (), target_addr_,
+                      expected_port_);
+    validate_address (family_, addr.bind_addr (), bind_addr_, expected_port_);
 }
 
 static void test_resolve_bind (int family_,
-                               const char *name_, const char *dest_addr_,
-                                uint16_t expected_port_ = 0,
+                               const char *name_,
+                               const char *dest_addr_,
+                               uint16_t expected_port_ = 0,
                                const char *bind_addr_ = NULL,
                                bool multicast_ = false)
 {
-test_resolve (true, family_, name_, dest_addr_, expected_port_, bind_addr_,
+    test_resolve (true, family_, name_, dest_addr_, expected_port_, bind_addr_,
                   multicast_);
 }
 
-static void test_resolve_connect (int family_, const char *name_, const char *dest_addr_,
+static void test_resolve_connect (int family_,
+                                  const char *name_,
+                                  const char *dest_addr_,
                                   uint16_t expected_port_ = 0,
                                   const char *bind_addr_ = NULL,
                                   bool multicast_ = false)
 {
-test_resolve (false, family_, name_, dest_addr_, expected_port_, bind_addr_,
+    test_resolve (false, family_, name_, dest_addr_, expected_port_, bind_addr_,
                   multicast_);
 }
 
 static void test_resolve_ipv4_simple ()
 {
-test_resolve_connect (AF_INET, "127.0.0.1:5555", "127.0.0.1", 5555);
+    test_resolve_connect (AF_INET, "127.0.0.1:5555", "127.0.0.1", 5555);
 }
 
 static void test_resolve_ipv6_simple ()
@@ -104,12 +108,14 @@ static void test_resolve_ipv6_simple ()
 
 static void test_resolve_ipv4_bind ()
 {
-    test_resolve_bind (AF_INET, "127.0.0.1:5555", "127.0.0.1", 5555, "127.0.0.1");
+    test_resolve_bind (AF_INET, "127.0.0.1:5555", "127.0.0.1", 5555,
+                       "127.0.0.1");
 }
 
 static void test_resolve_ipv6_bind ()
 {
-    test_resolve_bind (AF_INET6, "[abcd::1234:1]:5555", "abcd::1234:1", 5555, "abcd::1234:1");
+    test_resolve_bind (AF_INET6, "[abcd::1234:1]:5555", "abcd::1234:1", 5555,
+                       "abcd::1234:1");
 }
 
 static void test_resolve_ipv4_bind_any ()
@@ -129,7 +135,8 @@ static void test_resolve_ipv4_bind_anypo
 
 static void test_resolve_ipv6_bind_anyport ()
 {
-    test_resolve_bind (AF_INET6, "[1:2:3:4::5]:*", "1:2:3:4::5", 0, "1:2:3:4::5");
+    test_resolve_bind (AF_INET6, "[1:2:3:4::5]:*", "1:2:3:4::5", 0,
+                       "1:2:3:4::5");
 }
 
 static void test_resolve_ipv4_bind_any_port ()
@@ -176,7 +183,8 @@ static void test_resolve_ipv6_connect_po
 
 static void test_resolve_ipv4_bind_mcast ()
 {
-    test_resolve_bind (AF_INET, "239.0.0.1:1234", "239.0.0.1", 1234, "0.0.0.0", true);
+    test_resolve_bind (AF_INET, "239.0.0.1:1234", "239.0.0.1", 1234, "0.0.0.0",
+                       true);
 }
 
 static void test_resolve_ipv6_bind_mcast ()
@@ -186,12 +194,14 @@ static void test_resolve_ipv6_bind_mcast
 
 static void test_resolve_ipv4_connect_mcast ()
 {
-    test_resolve_connect (AF_INET, "239.0.0.1:2222", "239.0.0.1", 2222, NULL, true);
+    test_resolve_connect (AF_INET, "239.0.0.1:2222", "239.0.0.1", 2222, NULL,
+                          true);
 }
 
 static void test_resolve_ipv6_connect_mcast ()
 {
-    test_resolve_connect (AF_INET6, "[ff00::1]:2222", "ff00::1", 2222, NULL, true);
+    test_resolve_connect (AF_INET6, "[ff00::1]:2222", "ff00::1", 2222, NULL,
+                          true);
 }
 
 static void test_resolve_ipv4_mcast_src_bind ()
@@ -223,14 +233,13 @@ static void test_resolve_ipv4_mcast_src_
 
 static void test_resolve_ipv6_mcast_src_bind_any ()
 {
-    test_resolve_bind (AF_INET6, "*;[ffff::]:5555", "ffff::", 5555,
-                       "::", true);
+    test_resolve_bind (AF_INET6, "*;[ffff::]:5555", "ffff::", 5555, "::", true);
 }
 
 static void test_resolve_ipv4_mcast_src_connect ()
 {
-    test_resolve_connect (AF_INET, "8.9.10.11;230.2.8.12:5555", "230.2.8.12", 5555,
-                          "8.9.10.11", true);
+    test_resolve_connect (AF_INET, "8.9.10.11;230.2.8.12:5555", "230.2.8.12",
+                          5555, "8.9.10.11", true);
 }
 
 static void test_resolve_ipv6_mcast_src_connect ()
